# MatrixEquations.jl

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.3556867.svg)](https://doi.org/10.5281/zenodo.3556867)
[![DocBuild](https://github.com/andreasvarga/MatrixEquations.jl/workflows/CI/badge.svg)](https://github.com/andreasvarga/MatrixEquations.jl/actions)
[![codecov.io](https://codecov.io/gh/andreasvarga/MatrixEquations.jl/coverage.svg?branch=master)](https://codecov.io/gh/andreasvarga/MatrixEquations.jl?branch=master)
[![stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://andreasvarga.github.io/MatrixEquations.jl/stable/)
[![dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://andreasvarga.github.io/MatrixEquations.jl/dev/)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl) 
[![Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FMatrixEquations&query=total_requests&suffix=%2Fmonth&label=Downloads)](http://juliapkgstats.com/pkg/MatrixEquations)
[![LinkedIn Badge](https://img.shields.io/badge/LinkedIn-Article-informational?style=flat&logo=linkedin&logoColor=white&color=0D76A8)](https://www.linkedin.com/pulse/matrixequations-solving-matrix-equations-julia-andreas-varga-wauue/?trackingId=bSzyqKO0Rl2faMhNEX%2BMeQ%3D%3D)
[![The MIT License](https://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat-square)](https://github.com/andreasvarga/DescriptorSystems.jl/blob/main/LICENSE.md)


**Solution of Lyapunov, Sylvester and Riccati matrix equations using Julia**

## Compatibility

Julia 1.10 and higher.

## How to Install

````Julia
pkg> add MatrixEquations
pkg> test MatrixEquations
````

## About

This collection of Julia functions is an attemp to implement high performance
numerical software to solve several classes of Lyapunov, Sylvester and Riccati matrix equations
at a performance level comparable with efficient structure exploiting Fortran implementations, as those available in the Systems and Control Library [SLICOT](https://github.com/SLICOT).
This goal has been fully achieved for Lyapunov and Sylvester equation solvers, for which the
codes for both real and complex data perform at practically same performance level as similar functions available in
the MATLAB Control System Toolbox (which rely on SLICOT).

The available functions in the `MatrixEquation.jl` package cover both standard
and generalized continuous and discrete Lyapunov, Sylvester and Riccati equations for both real and complex data. The functions for the solution of Lyapunov and Sylvester equations rely on efficient structure
exploiting solvers for which the input data are in Schur or generalized Schur forms. A comprehensive set of Lyapunov and Sylvester operators has been implemented, which allow the estimation of condition numbers of these operators. The implementation of Riccati equation solvers employ orthogonal Schur vectors
based methods and their extensions to linear matrix pencil based reduction approaches. The calls of all functions with adjoint (in complex case) or transposed (in real case) arguments are fully supported by appropriate computational algorithms, thus the matrix copying operations are mostly avoided.

The current version of the package includes the following functions:

**Solution of Lyapunov equations**

* **lyapc**   Solution of the continuous Lyapunov equations `AX+XA'+C = 0` and `AXE'+EXA'+C = 0`.
* **lyapd**  Solution of discrete Lyapunov equations `AXA'-X +C = 0` and `AXA'-EXE'+C = 0`.
* **tlyapc** Solution of the continuous T-Lyapunov equations `A*X±X^⊤*A^⊤+C = 0`.
* **hlyapc** Solution of the continuous H-Lyapunov equations `A*X±X'*A'+C = 0`.
* **tulyapc!** Solution of the continuous T-Lyapunov equations `U*X^⊤+X*U^⊤ = C` and `U^⊤*X+X^⊤*U = C` for `U` and `X` upper triangular.
* **hulyapc!** Solution of the continuous H-Lyapunov equations `U*X'+X*U' = C` and `U'*X+X'*U = C` for `U` and `X` upper triangular.
* **plyapc**  Solution of the positive continuous Lyapunov equations `AX+XA'+BB' = 0` and `AXE'+EXA'+BB' = 0`.
* **plyapd**  Solution of the positive discrete Lyapunov equations `AXA'-X +C = 0` and `AXA'-EXE'+C = 0`.

 **Solution of algebraic  Riccati equations**

* **arec**  Solution of the continuous Riccati equations `A'X+XA-XRX+Q = 0` and
 `A'X+XA-(XB+S)R^(-1)(B'X+S')+Q = 0`.
* **garec** Solution of the generalized continuous Riccati equation
 `A'XE+E'XA-(E'XB+S)R^(-1)(B'XE+S')+Q = 0`.
* **ared** Solution of the discrete Riccati equation
 `A'XA - X - (A'XB+S)(R+B'XB)^(-1)(B'XA+S') + Q = 0`.
* **gared**  Solution of the generalized discrete Riccati equation
 `A'XA - E'XE - (A'XB+S)(R+B'XB)^(-1)(B'XA+S') + Q = 0`.

 **Solution of Sylvester equations and systems**

* **sylvc** Solution of the (continuous) Sylvester equation `AX+XB = C`.
* **sylvd** Solution of the (discrete) Sylvester equation `AXB+X = C`.
* **gsylv** Solution of the generalized Sylvester equation `AXB+CXD = E`.
* **sylvsys** Solution of the Sylvester system of matrix equations `AX+YB = C, DX+YE = F`.
* **dsylvsys** Solution of the dual Sylvester system of matrix equations `AX+DY = C, XB+YE = F`.

**Iterative solution of linear matrix equations**

* **lyapci** Iterative solution of the continuous Lyapunov equations `AX+XA'+C = 0` and `AXE'+EXA'+C = 0`.
* **plyapci** Iterative solution of the low-rank positive continuous Lyapunov equations `AX+XA'+BB' = 0` and `AXE'+EXA'+BB' = 0`.
* **lyapdi**  Iterative solution of the discrete Lyapunov equations `AXA'-X+C = 0` and `AXA'-EXE'+C = 0`.
* **plyapdi** Iterative solution of the low-rank positive discrete Lyapunov equations `AXA'-X+BB' = 0` and `AXA'-EXE'+BB' = 0`.
* **tlyapci** Iterative solution of the continuous T-Lyapunov equations `A*X+X^⊤*A^⊤ = C` and `A*X^⊤+X*A^⊤ = C`.
* **hlyapci** Iterative solution of the continuous H-Lyapunov equations `A*X+X'*A' = C` and `A*X'+X*A' = C`.
* **tulyapci** Iterative solution of the continuous T-Lyapunov equations `U*X^⊤+X*U^⊤ = C` and `U^⊤*X+X^⊤*U = C` for `U` and `X` upper triangular.
* **hulyapci** Iterative solution of the continuous H-Lyapunov equations `U*X'+X*U' = C` and `U'*X+X'*U = C` for `U` and `X` upper triangular.
* **sylvci** Iterative solution of the (continuous) Sylvester equation `AX+XB = C`.
* **sylvdi** Iterative solution of the (discrete) Sylvester equation `AXB+X = C`.
* **gsylvi** Iterative solution of the generalized Sylvester equation `AXB+CXD = E`.
* **gtsylvi** Iterative solution of the generalized T-Sylvester equations `∑ A_i*X*B_i + ∑ C_j*X^⊤*D_j = E`.
* **ghsylvi** Iterative solution of the generalized H-Sylvester equations `∑ A_i*X*B_i + ∑ C_j*X'*D_j = E`.
* **cgls** The conjugate gradient method for nonsymmetric linear equations and least squares problems.

**Norm, condition and separation estimation**

* **opnorm1**  Computation of the 1-norm of a linear operator.
* **opnorm1est** Estimation of 1-norm of a linear operator.
* **oprcondest** Estimation of the reciprocal 1-norm condition number of a linear operator.
* **opsepest** Estimation of the 1-norm separation a linear operator.

The general solvers of Lyapunov and Sylvester equations rely on a set of specialized solvers for real or complex matrices in appropriate Schur forms. For testing purposes, a set of solvers for various linear matrix equations has been implemented, which employ the Kronecker-product expansion of the equations. These solvers are not recommended for large order matrices. Based on the conjugate gradient method to solve linear systems or least-squares problems, several iterative solvers have been implemented, which potentially are applicable to solve linear matrix equations with large order dense and sparse matrices. The norms, reciprocal condition numbers and separations can be estimated for a comprehensive set of predefined Lyapunov and Sylvester operators.  
A complete list of implemented functions is available [here](https://sites.google.com/view/andreasvarga/home/software/matrix-equations-in-julia).

## Future plans

The collection of tools can be extended by adding new functionality, such as expert solvers, which additionally compute error bounds and condition estimates, or solvers for new classes of Riccati equations, as those arising in game-theoretic optimization problems. Further performance improvements are still possible (e.g., in some positive Lyapunov solvers by employing specially taylored solvers for the underlying particular Sylvester equations) or by employing blocking based variants of solvers for Sylvester equations.

module Runtests

using Test, MatrixEquations

@testset "Test MatrixEquations.jl" begin
    include("test_clyap.jl")
    include("test_dlyap.jl")
    include("test_meutil.jl")
    include("test_riccati.jl")
    include("test_sylvester.jl")
    include("test_sylvkr.jl")
    include("test_cplyap.jl")
    include("test_dplyap.jl")
    include("test_mecondest.jl")
    include("test_iterative.jl")
end

end

module Test_clyap

using LinearAlgebra
using MatrixEquations
using GenericSchur
using GenericLinearAlgebra
using Test


println("Test_clyap")
@testset "Testing continuous Lyapunov equation solvers" begin

n = 10; m = 7
Ty = Float64

@testset "Continuous Lyapunov equations" begin

reltol = eps(float(100))
a = -1; b = 2im; @time x = lyapc(a,b)
@test abs(a*x+x*a'+b) < reltol

reltol = eps(float(100f0))
a = 1f0-2f0im; b = 2f0; @time x = lyapc(a,b)
@test abs(a*x+x*a'+b) < reltol

try
  x = lyapc(zeros(1,1),ones(1,1))
  if norm(x,Inf) > 1.e10
    @test true
  else
    @test false
  end
catch
  @test true
end  

try
  x = lyapc([0 1;  -1 0 ],ones(2,2))
  if norm(x,Inf) > 1.e10
     @test true
  else
     @test false
  end
catch
  @test true
end  

try
  x = lyapc([1 1;  0 -1],ones(2,2))
  if norm(x,Inf) > 1.e10
     @test true
  else
     @test false
  end
catch
  @test true
end  

try
  x = lyapc([1 1 1 1;  -1 1 0 1; 0 0 -1 1; 0 0 -1 -1],ones(4,4))
  if norm(x,Inf) > 1.e10
     @test true
  else
     @test false
  end
catch
  @test true
end  

for Ty in (Float64, Float32, BigFloat)

ar = rand(Ty,n,n); ars = Symmetric(ar);
ac = rand(Ty,n,n)+im*rand(Ty,n,n); ach = Hermitian(ac); acd = Diagonal(ac);
c = rand(Ty,n,n)+im*rand(Ty,n,n);
qnh = rand(Ty,n,n)+im*rand(Ty,n,n);
#qc = c'*c;
qc = Matrix(Hermitian(c'*c));
Qr = real(qc);
Qnh = real(qnh);
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))

@time x = lyapc(ac,qc);
@test norm(ac*x+x*ac'+qc)/norm(x)/norm(ac) < reltol

@time x = lyapc(ac,qc,blocksize=5);
@test norm(ac*x+x*ac'+qc)/norm(x)/norm(ac) < reltol

@time x = lyapc(ach,qc);
@test norm(ach*x+x*ach+qc)/norm(x)/norm(ach) < reltol

@time x = lyapc(ach,qc,blocksize=5);
@test norm(ach*x+x*ach+qc)/norm(x)/norm(ach) < reltol

@time x = lyapc(acd,qc);
@test norm(acd*x+x*acd'+qc)/norm(x)/norm(acd) < reltol

@time x = lyapc(acd',qc);
@test norm(acd'*x+x*acd+qc)/norm(x)/norm(acd) < reltol


α = 3+im; # α = im  # SingularException
@time x = lyapc(α*I,qc);
@test norm(α*x+x*α'+qc)/norm(x) < reltol

α = 3+im; # α = im  # SingularException
@time x = lyapc(α,Qr);
@test norm(α*x+x*α'+Qr)/norm(x) < reltol

@time x = lyapc(ac',qc);
@test norm(ac'*x+x*ac+qc)/norm(x)/norm(ac) < reltol

@time x = lyapc(ac',qc,blocksize=5);
@test norm(ac'*x+x*ac+qc)/norm(x)/norm(ac) < reltol

@time x = lyapc(ar,Qr)
@test norm(ar*x+x*ar'+Qr)/norm(x)/norm(ar)  < reltol

@time x = lyapc(ar,Qr,blocksize=5)
@test norm(ar*x+x*ar'+Qr)/norm(x)/norm(ar)  < reltol

@time x = lyapc(ars,Qr)
@test norm(ars*x+x*ars'+Qr)/norm(x)/norm(ars)  < reltol

@time x = lyapc(ars,Qr,blocksize=5)
@test norm(ars*x+x*ars'+Qr)/norm(x)/norm(ars)  < reltol

@time x = lyapc(ar',Qr)
@test norm(ar'*x+x*ar+Qr)/norm(x)/norm(ar) < reltol

@time x = lyapc(ar',Qr,blocksize=5)
@test norm(ar'*x+x*ar+Qr)/norm(x)/norm(ar) < reltol

@time x = lyapc(ac,Qr);
@test norm(ac*x+x*ac'+Qr)/norm(x)/norm(ac) < reltol

@time x = lyapc(ac',Qr);
@test norm(ac'*x+x*ac+Qr)/norm(x)/norm(ac) < reltol

@time x = lyapc(ar,qc);
@test norm(ar*x+x*ar'+qc)/norm(x)/norm(ar) < reltol

@time x = lyapc(ar,Qnh);
@test norm(ar*x+x*ar'+Qnh)/norm(x)/norm(ar)  < reltol

@time x = lyapc(ar,Qnh,blocksize=5);
@test norm(ar*x+x*ar'+Qnh)/norm(x)/norm(ar)  < reltol

@time x = lyapc(ar',Qnh);
@test norm(ar'*x+x*ar+Qnh)/norm(x)/norm(ar)  < reltol

@time x = lyapc(ar',Qnh,blocksize=5);
@test norm(ar'*x+x*ar+Qnh)/norm(x)/norm(ar)  < reltol

@time x = lyapc(ars,Qnh);
@test norm(ars*x+x*ars+Qnh)/norm(x)/norm(ars)  < reltol

#end

@time x = lyapc(ac,qnh);
@test norm(ac*x+x*ac'+qnh)/norm(x)/norm(ac)  < reltol

@time x = lyapc(ac,qnh,blocksize=5);
@test norm(ac*x+x*ac'+qnh)/norm(x)/norm(ac)  < reltol

@time x = lyapc(ac',qnh);
@test norm(ac'*x+x*ac+qnh)/norm(x)/norm(ac)  < reltol

@time x = lyapc(ac',qnh,blocksize=5);
@test norm(ac'*x+x*ac+qnh)/norm(x)/norm(ac)  < reltol


end
end


@testset "Continuous generalized Lyapunov equations" begin

reltol = eps(float(100))
a = -1+im; ee = 3im; b = 2; @time x = lyapc(a,ee,b)
@test abs(a*x*ee'+ee*x*a'+b) < reltol

reltol = eps(float(100f0))
a = 1f0-2f0im; ee = 3f0im; b = 2f0; @time x = lyapc(a,ee,b)
@test abs(a*x*ee'+ee*x*a'+b) < reltol

try
  x = lyapc(zeros(1,1),ones(1,1),ones(1,1))
  @test false
catch
  @test true
end  

try
  x = lyapc([0 2;  -2 0 ],[2 0; 0 2],ones(2,2))
  @test false
catch
  @test true
end  

try
  x = lyapc([2 2;  0 -2],[2 0; 0 2],ones(2,2))
  @test false
catch
  @test true
end  

try
  x = lyapc(2*[1 1 1 1;  -1 1 0 1; 0 0 -1 1; 0 0 -1 -1],2*Matrix{Float64}(I,4,4), ones(4,4))
  @test false
catch
  @test true
end  

for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n)
ac = rand(Ty,n,n)+im*rand(Ty,n,n)
er = rand(Ty,n,n)
ec = er+im*rand(Ty,n,n)

c = rand(Ty,n,n)+im*rand(Ty,n,n)
#qc = c'*c
qc = Matrix(Hermitian(c'*c));
Qr = real(qc)
qnh = c;
Qnh = real(qnh);
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))


@time x = lyapc(ac,ec,qc);
@test norm(ac*x*ec'+ec*x*ac'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

@time x = lyapc(ac,ec,qc,blocksize=5);
@test norm(ac*x*ec'+ec*x*ac'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

@time x = lyapc(ac,ec,qnh);
@test norm(ac*x*ec'+ec*x*ac'+qnh)/norm(x)/norm(ac)/norm(ec) < reltol

@time x = lyapc(ac,ec,qnh,blocksize=5);
@test norm(ac*x*ec'+ec*x*ac'+qnh)/norm(x)/norm(ac)/norm(ec) < reltol

β = 3
@time x = lyapc(ac,β*I,qc);
@test norm(ac*x*β'+β*x*ac'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

β = (1+im);
@time x = lyapc(ac,β,qc);
@test norm(ac*x*β'+β*x*ac'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

α = 2+3im
@time x = lyapc(α*I,ec,qc);
@test norm(α*x*ec'+ec*x*α'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

α = 2+3im; β = (1+im); # α = im; β = 1  # SingularException
@time x = lyapc(α,β,qc);
@test norm(α*x*β'+β*x*α'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

α = 2+3im; β = (1+im); # α = im; β = 1  # SingularException
@time x = lyapc(α*I,β*I,qc);
@test norm(α*x*β'+β*x*α'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

@time x = lyapc(ac',ec',qc);
@test norm(ac'*x*ec+ec'*x*ac+qc)/norm(x)/norm(ac)/norm(ec)  < reltol

@time x = lyapc(ac',ec',qc,blocksize=5);
@test norm(ac'*x*ec+ec'*x*ac+qc)/norm(x)/norm(ac)/norm(ec)  < reltol

@time x = lyapc(ac',ec',qnh);
@test norm(ac'*x*ec+ec'*x*ac+qnh)/norm(x)/norm(ac)/norm(ec)  < reltol

@time x = lyapc(ac',ec',qnh,blocksize=5);
@test norm(ac'*x*ec+ec'*x*ac+qnh)/norm(x)/norm(ac)/norm(ec)  < reltol


β = (1+im);
@time x = lyapc(ac',β*I,qc);
@test norm(ac'*x*β+β'*x*ac+qc)/norm(x)/norm(ac)/norm(ec)  < reltol

α = 2+3im
@time x = lyapc(α*I,ec',qc);
@test norm(α'*x*ec+ec'*x*α+qc)/norm(x)/norm(ac)/norm(ec) < reltol

@time x = lyapc(ac',ec,qc);
@test norm(ac'*x*ec'+ec*x*ac+qc)/norm(x)/norm(ac)/norm(ec)  < reltol

@time x = lyapc(ac,ec',qc);
@test norm(ac*x*ec+ec'*x*ac'+qc)/norm(x)/norm(ac)/norm(ec)  < reltol

@time x = lyapc(ar,er,Qr);
@test norm(ar*x*er'+er*x*ar'+Qr)/norm(x)/norm(ar)/norm(er)  < reltol

@time x = lyapc(ar,er,Qr,blocksize=5);
@test norm(ar*x*er'+er*x*ar'+Qr)/norm(x)/norm(ar)/norm(er)  < reltol

@time x = lyapc(ar,er,Qnh);
@test norm(ar*x*er'+er*x*ar'+Qnh)/norm(x)/norm(ar)/norm(er)  < reltol

@time x = lyapc(ar,er,Qnh,blocksize=5);
@test norm(ar*x*er'+er*x*ar'+Qnh)/norm(x)/norm(ar)/norm(er)  < reltol

@time x = lyapc(ar,er,qc);
@test norm(ar*x*er'+er*x*ar'+qc)/norm(x)/norm(ar)/norm(er)  < reltol

@time x = lyapc(ar',er',Qr);
@test norm(ar'*x*er+er'*x*ar+Qr)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar',er',Qr,blocksize=5);
@test norm(ar'*x*er+er'*x*ar+Qr)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar',er',Qnh);
@test norm(ar'*x*er+er'*x*ar+Qnh)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar',er',Qnh,blocksize=5);
@test norm(ar'*x*er+er'*x*ar+Qnh)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar',er,Qr);
@test norm(ar'*x*er'+er*x*ar+Qr)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar,er',Qr);
@test norm(ar*x*er+er'*x*ar'+Qr)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ac,ec,Qr);
@test norm(ac*x*ec'+ec*x*ac'+Qr)/norm(x)/norm(ac)/norm(ec)   < reltol

@time x = lyapc(ac',ec',Qr);
@test norm(ac'*x*ec+ec'*x*ac+Qr)/norm(x)/norm(ac)/norm(ec)   < reltol

@time x = lyapc(ac',ec,Qr);
@test norm(ac'*x*ec'+ec*x*ac+Qr)/norm(x)/norm(ac)/norm(ec)   < reltol

@time x = lyapc(ac,ec',Qr);
@test norm(ac*x*ec+ec'*x*ac'+Qr)/norm(x)/norm(ac)/norm(ec)   < reltol

@time x = lyapc(ar,er,qc);
@test norm(ar*x*er'+er*x*ar'+qc)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar',er',qc);
@test norm(ar'*x*er+er'*x*ar+qc)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar',er,qc);
@test norm(ar'*x*er'+er*x*ar+qc)/norm(x)/norm(ar)/norm(er) < reltol

@time x = lyapc(ar,er',qc);
@test norm(ar*x*er+er'*x*ar'+qc)/norm(x)/norm(ar)/norm(er) < reltol
end
end

@testset "Continuous Lyapunov equations - Schur form" begin

for Ty in (Float64, Float32, BigFloat)
# for Ty in (Float64, Float32)

ar = rand(Ty,n,n); ard = Diagonal(ar); 
ac = rand(Ty,n,n)+im*rand(Ty,n,n); acd = Diagonal(ac);
er = rand(Ty,n,n);
ec = er+im*rand(Ty,n,n);
es = triu(er);
as = es*schur(ar).T;
#as, es = schur(ar,er);
acs, ecs = schur(ac,ec);

c = rand(Ty,n,n)+im*rand(Ty,n,n);
#qc = c'*c;
qc = Matrix(Hermitian(c'*c));
Qr = real(qc);
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))


x = copy(qc)
@time lyapcs!(acs,ecs,x);
@test norm(acs*x*ecs'+ecs*x*acs'+qc)/norm(x)/norm(acs)/norm(ecs) < reltol


x = copy(qc)
@time lyapcs!(acs,I,x);
@test norm(acs*x+x*acs'+qc)/norm(x)/norm(acs)/norm(ecs) < reltol

x = copy(qc)
@time lyapcs!(acs,ecs,x,adj=true);
@test norm(acs'*x*ecs+ecs'*x*acs+qc)/norm(x)/norm(acs)/norm(ecs) < reltol

# test
x = copy(Qr);
@time lyapcs!(as,es,x);
@test norm(as*x*es'+es*x*as'+Qr)/norm(x)/norm(as)/norm(es) < reltol

x = copy(Qr);
@time lyapcs!(as,es,x,adj=true);
@test norm(as'*x*es+es'*x*as+Qr)/norm(x)/norm(as)/norm(es) < reltol

x = copy(Qr)
@time lyapcs!(as,I,x);
@test norm(as*x+x*as'+Qr)/norm(x)/norm(as) < reltol

x = copy(Qr)
@time lyapcs!(as,x);
@test norm(as*x+x*as'+Qr)/norm(x)/norm(as) < reltol

x = copy(Qr)
@time lyapcs!(ard,x);
@test norm(ard*x+x*ard+Qr)/norm(x)/norm(ard) < reltol


if Ty == Float64
try
  x = convert(Matrix{Complex{Float32}},copy(qc))
  @time lyapcs!(as,x);
  @test false
catch
  @test true
end
end

x = copy(Qr)
@time lyapcs!(as,es,x,adj=true);
@test norm(as'*x*es+es'*x*as+Qr)/norm(x)/norm(as)/norm(es) < reltol

x = copy(qc)
@time lyapcs!(acs,x);
@test norm(acs*x+x*acs'+qc)/norm(x)/norm(acs) < reltol

x = copy(qc)
@time lyapcs!(acd,x);
@test norm(acd*x+x*acd'+qc)/norm(x)/norm(acd) < reltol

x = copy(qc)
@time lyapcs!(acs,x,adj=true);
@test norm(acs'*x+x*acs+qc)/norm(x)/norm(acs) < reltol

x = copy(qc); @time lyapcs!(acd,x,adj=true);
@test norm(acd'*x+x*acd+qc)/norm(x)/norm(acd) < reltol

x = copy(Qr)
@time lyapcs!(as,x);
@test norm(as*x+x*as'+Qr)/norm(x)/norm(as) < reltol

x = copy(Qr)
@time lyapcs!(as,x,adj=true);
@test norm(as'*x+x*as+Qr)/norm(x)/norm(as) < reltol
end
end

@testset "Continuous Lyapunov-like equations" begin
for Ty in (Float64, Float32, BigFloat)

  ar = rand(Ty,n,n);
  er = rand(Ty,m,m)
  cr = rand(Ty,n,m)
  art = rand(Ty,m,n)
  crt = rand(Ty,m,m)
  ac = rand(Ty,n,n)+im*rand(Ty,n,n);
  cc = cr+im*rand(Ty,n,m)
  crt1 = rand(Ty,m,n)
  act = art+im*rand(Ty,m,n)
  cct = crt+im*rand(Ty,m,m)
  cct1 = crt1+im*rand(Ty,m,n)
  qnh = rand(Ty,n,n)+im*rand(Ty,n,n);
  Qc = Matrix(Hermitian(cc*cc'));
  Qr = real(Qc);
  Qcs = (Qc+transpose(Qc))/2
  Qcss = (Qc-transpose(Qc))/2
  Qrt1 = Matrix(Symmetric(crt1*crt1'))
  Qct1 = Matrix(Hermitian(cct1*cct1'))
  Ty == Float64 ? reltol = eps(float(100*n)) : reltol = eps(100*n*one(Ty))

  for fast in (true, false)

  @time x2 = tlyapc(ar,-Qr; fast)
  @test norm(ar*x2+transpose(x2)*ar'+Qr)/norm(x2) < reltol && x2 ≈ (-2ar)\Qr

  @time x2 = tlyapc(art,-Qrt1; fast)
  @test norm(art*x2+transpose(x2)*art'+Qrt1)/norm(x2) < reltol 

  @time x2 = tlyapc(art,-Qrt1; fast)
  @test norm(art*x2+transpose(x2)*art'+Qrt1)/norm(x2) < reltol 

  @time x2 = tlyapc(ac,-Qcs; fast)
  @test norm(ac*x2+transpose(x2)*transpose(ac)+Qcs)/norm(x2) < reltol 

  @time x2 = tlyapc(ac,-Qcss,-1; fast)
  @test norm(ac*x2-transpose(x2)*transpose(ac)+Qcss)/norm(x2) < reltol 

  @time x2 = tlyapc(ar,-ar+ar',-1; fast)
  @test norm(ar*x2-transpose(x2)*ar'+ar-ar')/norm(x2) < reltol && x2 ≈ (-2ar)\(ar-ar')

  @time x2 = tlyapc(art,-er+er',-1; fast)
  @test norm(art*x2-transpose(x2)*art'+er-er')/norm(x2) < reltol 
  
  @time x2 = tlyapc(transpose(ac),-ac+transpose(ac),-1; fast)
  @test norm(transpose(ac)*x2-transpose(x2)*ac+ac-transpose(ac))/norm(x2) < reltol && x2 ≈ (-2transpose(ac))\(ac-transpose(ac))

  @time x2 = hlyapc(ac',-Qc; fast)  
  @test norm(ac'*x2+adjoint(x2)*ac+Qc)/norm(x2) < reltol 

  @time x2 = hlyapc(act,-Qct1; fast)  
  @test norm(act*x2+adjoint(x2)*adjoint(act)+Qct1)/norm(x2) < reltol 

  @time x2 = hlyapc(ac',-ac+ac',-1; fast)  
  @test norm(ac'*x2-adjoint(x2)*ac+ac-ac')/norm(x2) < reltol 

end
end  

@testset "Continuous positive Lyapunov-like equations" begin
  n = 5
  Ty = Float64
  # nonsingular U
  for Ty in (Float64, Float32, BigFloat)
      Ty == Float64 ? reltol = eps(float(100*n)) : reltol = eps(100*n*one(Ty))
      U = triu(rand(Ty,n,n));
      X0 = triu(rand(Ty,n,n));
      Q = Matrix(Symmetric(transpose(U)*X0 + transpose(X0)*U))
      @time X = tulyapc!(U, copy(Q); adj = false)  
      @test norm(transpose(U)*X + transpose(X)*U - Q)/norm(X) < reltol 
    
      Q = Matrix(Symmetric(U*transpose(X0) + X0*transpose(U)))
      @time X = tulyapc!(U, copy(Q); adj = true); 
      @test norm(U*transpose(X) + X*transpose(U)- Q)/norm(X) < reltol 

      U = triu(rand(Ty,n,n)+im*rand(Ty,n,n));
      X0 = triu(rand(Ty,n,n)+im*rand(Ty,n,n));
      Q = Matrix(Symmetric(transpose(U)*X0 + transpose(X0)*U))
      @time X = tulyapc!(U, copy(Q); adj = false)  
      @test norm(transpose(U)*X + transpose(X)*U - Q)/norm(X) < reltol 

      Q = Matrix(Symmetric(U*transpose(X0) + X0*transpose(U)))
      @time X = tulyapc!(U, copy(Q); adj = true); 
      @test norm(U*transpose(X) + X*transpose(U)- Q)/norm(X) < reltol 

      Q = Matrix(Hermitian(U'*X0 + X0'*U))
      @time X = hulyapc!(U, copy(Q); adj = false)  
      @test norm(U'*X + X'*U - Q)/norm(X) < reltol 

      Q = Matrix(Hermitian(U*X0' + X0*U'))
      @time X = hulyapc!(U, copy(Q); adj = true); 
      @test norm(U*X' + X*U'- Q)/norm(X) < reltol 
 
  end

  # singular U
  n = 5
  Ty = Float64
  reltol = 1.e-6
  # real case
  #U = triu(rand(Ty,n,n)); U[1,1] = 0; U[n,n] = 0; #U[7,7] = 0
  U = [ 0.0  0.446398  0.117541  0.108452   0.713935
  0.0  0.101524  0.167705  0.0307678  0.96426
  0.0  0.0       0.743782  0.75158    0.836415
  0.0  0.0       0.0       0.95128    0.0910885
  0.0  0.0       0.0       0.0        0.0];
  #X0 = triu(rand(Ty,n,n)); X0[1,1] = 0; X0[n,n] = 0
  X0 = [0.0  0.516821  0.00618001  0.119169  0.85199
  0.0  0.344247  0.516058    0.271105  0.871912
  0.0  0.0       0.38342     0.154878  0.128648
  0.0  0.0       0.0         0.984649  0.459241
  0.0  0.0       0.0         0.0       0.0];
  Q = Matrix(Symmetric(transpose(U)*X0 + transpose(X0)*U))
  @time X = tulyapc!(U, copy(Q); adj = false) 
  @test norm(transpose(U)*X + transpose(X)*U - Q)/norm(X) < reltol 

  LT = tulyaplikeop(U; adj = false)
  x2,info=MatrixEquations.cgls(LT,triu2vec(Q),reltol=1.e-14,maxiter=1000); X2 = vec2triu(x2);
  @test norm(transpose(U)*X2 + transpose(X2)*U - Q)/norm(X2) < reltol 

  Q = Matrix(Symmetric(U*transpose(X0) + X0*transpose(U)))
  @time X = tulyapc!(U, copy(Q); adj = true) 
  @test norm(U*transpose(X) + X*transpose(U)- Q)/norm(X) < reltol 

  LT = tulyaplikeop(U; adj = true)
  x2,info=MatrixEquations.cgls(LT,triu2vec(Q),reltol=1.e-14,maxiter=1000); X2 = vec2triu(x2);
  @test norm(U*transpose(X2) + X2*transpose(U)- Q)/norm(X2) < reltol 

  # complex case
  U = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); U[1,1] = 0; U[n,n] = 0; 
  X0 = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); X0[1,1] = 0; X0[n,n] = 0
  Q = Matrix(Symmetric(transpose(U)*X0 + transpose(X0)*U))
  @time X = tulyapc!(U, copy(Q); adj = false)  
  @test norm(transpose(U)*X + transpose(X)*U - Q)/norm(X) < reltol 

  LT = tulyaplikeop(U; adj = false)
  x2,info=MatrixEquations.cgls(LT,triu2vec(Q),reltol=1.e-14,maxiter=1000); X2 = vec2triu(x2);
  @test norm(transpose(U)*X2 + transpose(X2)*U - Q)/norm(X2) < reltol 


  Q = Matrix(Symmetric(U*transpose(X0) + X0*transpose(U)))
  @time X = tulyapc!(U, copy(Q); adj = true); 
  @test norm(U*transpose(X) + X*transpose(U)- Q)/norm(X) < reltol 

  LT = tulyaplikeop(U; adj = true)
  x2,info=MatrixEquations.cgls(LT,triu2vec(Q),reltol=1.e-14,maxiter=1000); X2 = vec2triu(x2);
  @test norm(U*transpose(X2) + X2*transpose(U)- Q)/norm(X) < reltol 

  # complex hermitian case
  U = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); U[1,1] = 0; U[n,n] = 0; 
  X0 = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); X0[1,1] = 0; X0[n,n] = 0
  Q = Matrix(Hermitian(U'*X0 + X0'*U))
  @time X = hulyapc!(U, copy(Q); adj = false)  
  @test norm(U'*X + X'*U - Q)/norm(X) < reltol 

  LT = hulyaplikeop(U; adj = false)
  x2,info=MatrixEquations.cgls(LT,triu2vec(Q),reltol=1.e-14,maxiter=1000); X2 = vec2triu(x2);
  @test norm(U'*X2 + X2'*U - Q)/norm(X2) < reltol 

  Q = Matrix(Hermitian(U*X0' + X0*U'))
  @time X = hulyapc!(U, copy(Q); adj = true); 
  @test norm(U*X' + X*U'- Q)/norm(X) < 10*reltol 

  LT = hulyaplikeop(U; adj = true)
  x2,info=MatrixEquations.cgls(LT,triu2vec(Q),reltol=1.e-14,maxiter=1000); X2 = vec2triu(x2);
  @test norm(U*X2' + X2*U'- Q)/norm(X) < reltol 

    
end

end

end
end

rev!(t) = reverse!(reverse!(t,dims=1),dims=2)
"""
    U = plyapc(A, B)

Compute `U`, the upper triangular factor of the solution `X = UU'` of the
continuous Lyapunov equation

      AX + XA' + BB' = 0,

where `A` is a square real or complex matrix and `B` is a matrix with the same
number of rows as `A`. `A` must have only eigenvalues with negative real parts.

    U = plyapc(A', B')

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the continuous Lyapunov equation

      A'X + XA + B'B = 0,

where `A` is a square real or complex matrix and `B` is a matrix with the same
number of columns as `A`. `A` must have only eigenvalues with negative real parts.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-2. 1.;-1. -2.]
2×2 Array{Float64,2}:
 -2.0   1.0
 -1.0  -2.0

julia> B = [1. 1. ;1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> U = plyapc(A,B)
2×2 UpperTriangular{Float64,Array{Float64,2}}:
 0.481812  0.801784
  ⋅        0.935414

julia> A*U*U'+U*U'*A'+B*B'
2×2 Array{Float64,2}:
 0.0          8.88178e-16
 8.88178e-16  3.55271e-15
```
"""
function plyapc(A::AbstractMatrix, B::AbstractMatrix)
   # Method

   # The Bartels-Steward Schur form based method is employed [1], with the
   # modifications proposed by Hammarling [2].

   # Reference:

   # [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix
   #     equation AX+XB=C. Comm. ACM, 15:820–826, 1972.
   # [2] Hammarling, S.J. Numerical solution of the stable, non-negative definite
   #     Lyapunov equation. IMA J. Num. Anal., 2, pp. 303-325, 1982.

   adj = isa(A,Adjoint)
   xor(adj,isa(B,Adjoint)) && error("Only calls with A and B or with A' and B' allowed")

   n = LinearAlgebra.checksquare(A)
   if adj
      nb, mb = size(B)
      nb == n || throw(DimensionMismatch("B must be a matrix of column dimension $n"))
   else
      mb, nb = size(B)
      mb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))
   end

   T2 = promote_type(eltype(A), eltype(B))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(B) == T2 || (adj ? B = convert(Matrix{T2},B.parent)' : B = convert(Matrix{T2},B))

   ZERO = zero(T2)

  
   # Reduce A to Schur form and transform B
   if adj
      AS, Q, EV = schur(A.parent)
   else
      AS, Q, EV = schur(A)
   end
   maximum(real(EV)) >= 0 && error("A must have only eigenvalues with negative real part")
   
   if adj
      #U'U = Q'*B'*B*Q
      T2 <: BlasFloat  && (tau = similar(Q,min(n,mb)))
      if mb < n
         U = similar(Q,T2,n,n)
         U1 = view(U,1:mb,:)
         if T2 <: BlasFloat
            mul!(U1,B.parent,Q)
            LinearAlgebra.LAPACK.geqrf!(U1,tau)
         else
            copyto!(U1,qr!(B.parent*Q).R)
         end
         fill!(view(U,mb+1:n,:),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.geqrf!(B.parent*Q,tau)[1][1:n,:]
         else
            U = qr!(B.parent*Q).R[1:n,:]
         end
      end
   else
      #UU' = Q'*B*B'*Q
      T2 <: BlasFloat  && (tau = similar(Q,min(n,nb)))
      if nb <= n
         U = similar(Q,T2,n,n)
         U2 = view(U,:,n-nb+1:n)
         if T2 <: BlasFloat
            mul!(U2,Q',B)
            LinearAlgebra.LAPACK.gerqf!(U2,tau)
         else
            copyto!(U2,rev!(qr!(rev!(B'*Q)).R)')
         end
         fill!(view(U,:,1:n-nb),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.gerqf!(Q'*B,tau)[1][:,nb-n+1:nb]
         else
            U = rev!(qr!(rev!(B'*Q)).R)'
         end
      end
   end
   U = UpperTriangular(U)
   plyapcs!(AS, U, adj = adj)
   T2 <: BlasFloat  && (tau = similar(U,n))
   if adj
      #X = Q*U'*U*Q'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.geqrf!(lmul!(U,copy(Q')),tau)[1])
      else
         U = UpperTriangular(qr!(lmul!(U,copy(Q'))).R)
      end
   else
      #X <- Q*U*U'*Q'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.gerqf!(rmul!(Q, U), tau)[1])
      else
         U = UpperTriangular(rev!(qr!(rev!(copy(rmul!(Q, U)'))).R)')
      end
   end  
   return utnormalize!(U,adj)
end
plyapc(A::Union{Real,Complex}, B::Union{Real,Complex}) =
      real(A) < 0 ? abs(B)/sqrt( -2 * real(A) ) :
      error("A must be a negative number or must have negative real part")
"""
    U = plyapc(A, E, B)

Compute `U`, the upper triangular factor of the solution `X = UU'` of the
generalized continuous Lyapunov equation

      AXE' + EXA' + BB' = 0,

where `A` and `E` are square real or complex matrices and `B` is a matrix
with the same number of rows as `A`. The pencil `A - λE` must have only
eigenvalues with negative real parts.

    U = plyapc(A', E', B')

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the generalized continuous Lyapunov equation

      A'XE + E'XA + B'B = 0,

where `A` and `E` are square real or complex matrices and `B` is a matrix
with the same number of columns as `A`. The pencil `A - λE` must have only
eigenvalues with negative real parts.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-2. 1.;-1. -2.]
2×2 Array{Float64,2}:
 -2.0   1.0
 -1.0  -2.0

julia> E = [1. 0.; 1. 1.]
2×2 Array{Float64,2}:
 1.0  0.0
 1.0  1.0

julia> B = [1. 1. ;1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> U = plyapc(A,E,B)
2×2 UpperTriangular{Float64,Array{Float64,2}}:
 0.408248  0.730297
  ⋅        0.547723

julia> A*U*U'*E'+E*U*U'*A'+B*B'
2×2 Array{Float64,2}:
  0.0          -8.88178e-16
 -1.33227e-15  -2.66454e-15
```
"""
function plyapc(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling{Bool}}, B::AbstractMatrix)
   # Method

   # A generalization of Bartels-Steward Schur form based method is employed [1],
   # with the modifications proposed by Hammarling [2] and Penzl [3].

   # Reference:

   # [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix
   #     equation AX+XB=C. Comm. ACM, 15:820–826, 1972.
   # [2] Hammarling, S.J. Numerical solution of the stable, non-negative definite
   #     Lyapunov equation. IMA J. Num. Anal., 2, pp. 303-325, 1982.
   # [3] Penzl, T.
   #     Numerical solution of generalized Lyapunov equations.
   #     Advances in Comp. Math., vol. 8, pp. 33-48, 1998.

   n = LinearAlgebra.checksquare(A)
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) &&  size(E,1) == n)) && (return plyapc(A, B))
   
   T2 = promote_type(eltype(A), eltype(E), eltype(B))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))

   adj = isa(A,Adjoint)
   (xor(adj,isa(E,Adjoint)) || xor(adj,isa(B,Adjoint))) &&
      error("Only calls with A, E and B or with A', E' and B' allowed")

   # # generalized Schur form decomposition available only for complex data 
   # T2 <: BlasFloat || T2 <: Complex || 
   # (return adj ? real(plyapc(complex(A.parent)',complex(E.parent)',complex(B.parent)')) : real(plyapc(complex(A),complex(E),complex(B))))

   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))

   if adj
      nb, mb = size(B)
      nb == n || throw(DimensionMismatch("B must be a matrix of column dimension $n"))
   else
      mb, nb = size(B)
      mb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))
   end

   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(E) == T2 || (adj ? E = convert(Matrix{T2},E.parent)' : E = convert(Matrix{T2},E))
   eltype(B) == T2 || (adj ? B = convert(Matrix{T2},B.parent)' : B = convert(Matrix{T2},B))

   ZERO = zero(real(T2))

   # Reduce (A,E) to generalized Schur form and transform C
   # (AS,ES) = (Q'*A*Z, Q'*E*Z)
   if adj
      AS, ES, Q, Z, α, β = schur(A.parent,E.parent)
   else
      AS, ES, Q, Z, α, β = schur(A,E)
   end

   maximum(real(α./β)) >= ZERO && error("A-λE must have only eigenvalues with negative real parts")

   if adj
      #U'*U = Z'*B'*B*Z
      T2 <: BlasFloat  && (tau = similar(Z,min(n,mb)))
      if mb <= n
         U = similar(Z,T2,n,n)
         U1 = view(U,1:mb,:)
         if T2 <: BlasFloat
            mul!(U1,B.parent,Z)
            LinearAlgebra.LAPACK.geqrf!(U1,tau)
         else
            copyto!(U1,qr!(B.parent*Z).R)
         end
         fill!(view(U,mb+1:n,:),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.geqrf!(B.parent*Z,tau)[1][1:n,:]
         else
            U = qr!(B.parent*Z).R[1:n,:]
         end
      end
   else
      #UU' = Q'*B*B'*Q
      T2 <: BlasFloat  && (tau = similar(Q,min(n,nb)))
      if nb <= n
         U = similar(Q,T2,n,n)
         U2 = view(U,:,n-nb+1:n)
         if T2 <: BlasFloat
            mul!(U2,Q',B)
            LinearAlgebra.LAPACK.gerqf!(U2,tau)
         else
            copyto!(U2,rev!(qr!(rev!(B'*Q)).R)')
         end
         fill!(view(U,:,1:n-nb),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.gerqf!(Q'*B,tau)[1][:,nb-n+1:nb]
         else
            U = rev!(qr!(rev!(B'*Q)).R)'
         end
      end
   end
   U = UpperTriangular(U)
   plyapcs!(AS, ES, U, adj = adj)
   T2 <: BlasFloat  && (tau = similar(U,n))
   if adj
      #X = Q*U'*U*Q'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.geqrf!(lmul!(U,copy(Q')),tau)[1])
      else
         U = UpperTriangular(qr!(lmul!(U,copy(Q'))).R)
      end
   else
      #X <- Z*U*U'*Z'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.gerqf!(rmul!(Z, U), tau)[1])
      else
         U = UpperTriangular(rev!(qr!(rev!(copy(rmul!(Z, U)'))).R)')
      end
   end  
   return utnormalize!(U,adj)
end
plyapc(A::Union{Real,Complex}, E::Union{Real,Complex}, B::Union{Real,Complex}) =
      real(A*E') < 0 ? abs(B)/sqrt( -2 * real(A*E') ) :
      error("A*E' must be a negative number or must have negative real part")
"""
    U = plyapd(A, B)

Compute `U`, the upper triangular factor of the solution `X = UU'` of
the discrete Lyapunov equation

      AXA' - X + BB' = 0,

where `A` is a square real or complex matrix and `B` is a matrix with the same
number of rows as `A`. `A` must have only eigenvalues with moduli less than one.

    U = plyapd(A', B')

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the discrete Lyapunov equation

      A'XA - X + B'B = 0,

where `A` is a square real or complex matrix and `B` is a matrix with the same
number of columns as `A`. `A` must have only eigenvalues with moduli less than one.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-0.5 .1;-0.1 -0.5]
2×2 Array{Float64,2}:
 -0.5   0.1
 -0.1  -0.5

julia> B = [1. 1. ;1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> U = plyapd(A,B)
2×2 UpperTriangular{Float64,Array{Float64,2}}:
 0.670145  1.35277
  ⋅        2.67962

julia> A*U*U'*A'-U*U'+B*B'
2×2 Array{Float64,2}:
 -4.44089e-16  4.44089e-16
  4.44089e-16  1.77636e-15
```
"""
function plyapd(A::AbstractMatrix, B::AbstractMatrix)
   # Method

   # The Bartels-Steward Schur form based method is employed [1], with the
   # modifications proposed by Hammarling in [2] and [3].

   # Reference:

   # [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix
   #     equation AX+XB=C. Comm. ACM, 15:820–826, 1972.
   # [2] Hammarling, S.J. Numerical solution of the stable, non-negative definite
   #     Lyapunov equation. IMA J. Num. Anal., 2, pp. 303-325, 1982.
   # [3] Hammarling, S.J. Numerical solution of the discrete-time, convergent,
   #     non-negative definite Lyapunov equation.
   #     Systems & Control Letters 17 (1991) 137-139.

   adj = isa(A,Adjoint)
   xor(adj,isa(B,Adjoint)) && error("Only calls with A and B or with A' and B' allowed")

   n = LinearAlgebra.checksquare(A)
   if adj
      nb, mb = size(B)
      nb == n || throw(DimensionMismatch("B must be a matrix of column dimension $n"))
   else
      mb, nb = size(B)
      mb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))
   end

   T2 = promote_type(eltype(A), eltype(B))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(B) == T2 || (adj ? B = convert(Matrix{T2},B.parent)' : B = convert(Matrix{T2},B))

   ONE = one(real(T2))
   ZERO = zero(T2)

   # Reduce A to Schur form and transform B
   if adj
      AS, Q, EV = schur(A.parent)
   else
      AS, Q, EV = schur(A)
   end
   maximum(abs.(EV)) >= ONE && error("A must have only eigenvalues with moduli less than one")

   if adj
      #U'U = Q'*B'*B*Q
      T2 <: BlasFloat  && (tau = similar(Q,min(n,mb)))
      if mb <= n
         U = similar(Q,T2,n,n)
         U1 = view(U,1:mb,:)
         if T2 <: BlasFloat
            mul!(U1,B.parent,Q)
            LinearAlgebra.LAPACK.geqrf!(U1,tau)
         else
            copyto!(U1,qr!(B.parent*Q).R)
         end
         fill!(view(U,mb+1:n,:),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.geqrf!(B.parent*Q,tau)[1][1:n,:]
         else
            U = qr!(B.parent*Q).R[1:n,:]
         end
      end
   else
      #UU' = Q'*B*B'*Q
      T2 <: BlasFloat  && (tau = similar(Q,min(n,nb)))
      if nb <= n
         U = similar(Q,T2,n,n)
         U2 = view(U,:,n-nb+1:n)
         if T2 <: BlasFloat
            mul!(U2,Q',B)
            LinearAlgebra.LAPACK.gerqf!(U2,tau)
         else
            copyto!(U2,rev!(qr!(rev!(B'*Q)).R)')
         end
         fill!(view(U,:,1:n-nb),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.gerqf!(Q'*B,tau)[1][:,nb-n+1:nb]
         else
            U = rev!(qr!(rev!(B'*Q)).R)'
         end
       end
   end
   U = UpperTriangular(U)
   plyapds!(AS, U, adj = adj)
   tau = similar(U,n)
   if adj
      #X = Q*U'*U*Q'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.geqrf!(lmul!(U,copy(Q')),tau)[1])
      else
         U = UpperTriangular(qr!(lmul!(U,copy(Q'))).R)
      end
   else
      #X <- Q*U*U'*Q'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.gerqf!(rmul!(Q, U), tau)[1])
      else
         U = UpperTriangular(rev!(qr!(rev!(copy(rmul!(Q, U)'))).R)')
      end
   end  
   return utnormalize!(U,adj)
end
plyapd(A::Union{Real,Complex}, B::Union{Real,Complex}) =
      abs(A) < real(one(A)) ? real(abs(B)/sqrt( (one(A)-abs(A))*(one(A)+abs(A)) )) :
      error("A must be a subunitary number")
"""
    U = plyapd(A, E, B)

Compute `U`, the upper triangular factor of the solution `X = UU'` of the
generalized discrete Lyapunov equation

      AXA' - EXE' + BB' = 0,

where `A` and `E` are square real or complex matrices and `B` is a matrix
with the same number of rows as `A`. The pencil `A - λE` must have only
eigenvalues with moduli less than one.

    U = plyapd(A', E', B')

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the generalized discrete Lyapunov equation

      A'XA - E'XE + B'B = 0,

where `A` and `E` are square real or complex matrices and `B` is a matrix
with the same number of columns as `A`. The pencil `A - λE` must have only
eigenvalues with moduli less than one.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-0.5 .1;-0.1 -0.5]
2×2 Array{Float64,2}:
 -0.5   0.1
 -0.1  -0.5

julia> E = [1. 0.; 1. 1.]
2×2 Array{Float64,2}:
 1.0  0.0
 1.0  1.0

julia> B = [1. 1. ;1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> U = plyapd(A,E,B)
2×2 UpperTriangular{Float64,Array{Float64,2}}:
 1.56276  0.416976
  ⋅       1.34062

julia> A*U*U'*A'-E*U*U'*E'+B*B'
2×2 Array{Float64,2}:
 1.77636e-15  2.22045e-15
 2.22045e-15  2.66454e-15
```
"""
function plyapd(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling{Bool}}, B::AbstractMatrix)
   # Method

   # The Bartels-Steward Schur form based method is employed [1], with the
   # modifications proposed by Hammarling in [2] and Penzl in [3].

   # Reference:

   # [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix
   #     equation AX+XB=C. Comm. ACM, 15:820–826, 1972.
   # [2] Hammarling, S.J. Numerical solution of the stable, non-negative definite
   #     Lyapunov equation. IMA J. Num. Anal., 2, pp. 303-325, 1982.
   # [3] Penzl, T.
   #     Numerical solution of generalized Lyapunov equations.
   #     Advances in Comp. Math., vol. 8, pp. 33-48, 1998.

   n = LinearAlgebra.checksquare(A)
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) &&  size(E,1) == n)) && (return plyapd(A, B))
   
   T2 = promote_type(eltype(A), eltype(E), eltype(B))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))

   adj = isa(A,Adjoint)
   (xor(adj,isa(E,Adjoint)) || xor(adj,isa(B,Adjoint))) &&
      error("Only calls with A, E and B or with A', E' and B' allowed")

   # # generalized Schur form decomposition available only for complex data 
   # T2 <: BlasFloat || T2 <: Complex || 
   # (return adj ? real(plyapd(complex(A.parent)',complex(E.parent)',complex(B.parent)')) : real(plyapd(complex(A),complex(E),complex(B))))

   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
   
   if adj
      nb, mb = size(B)
      nb == n || throw(DimensionMismatch("B must be a matrix of column dimension $n"))
   else
      mb, nb = size(B)
      mb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))
   end

   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(E) == T2 || (adj ? E = convert(Matrix{T2},E.parent)' : E = convert(Matrix{T2},E))
   eltype(B) == T2 || (adj ? B = convert(Matrix{T2},B.parent)' : B = convert(Matrix{T2},B))

   ONE = one(real(T2))
   ZERO = zero(real(T2))

   # Reduce (A,E) to generalized Schur form and transform C
   # (AS,ES) = (Q'*A*Z, Q'*E*Z)
   if adj
      AS, ES, Q, Z, α, β = schur(A.parent,E.parent)
   else
      AS, ES, Q, Z, α, β = schur(A,E)
   end

   maximum(abs.(α./β)) >= ONE && error("A-λE must have only eigenvalues with moduli less than one")

   if adj
      #U'*U = Z'*B'*B*Z
      T2 <: BlasFloat  && (tau = similar(Z,min(n,mb)))
      if mb <= n
         U = similar(Z,T2,n,n)
         U1 = view(U,1:mb,:)
         if T2 <: BlasFloat
            mul!(U1,B.parent,Z)
            LinearAlgebra.LAPACK.geqrf!(U1,tau)
         else
            copyto!(U1,qr!(B.parent*Z).R)
         end
         fill!(view(U,mb+1:n,:),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.geqrf!(B.parent*Z,tau)[1][1:n,:]
         else
            U = qr!(B.parent*Z).R[1:n,:]
         end
      end
   else
      #UU' = Q'*B*B'*Q
      T2 <: BlasFloat  && (tau = similar(Q,min(n,nb)))
      if nb <= n
         U = similar(Q,T2,n,n)
         U2 = view(U,:,n-nb+1:n)
         if T2 <: BlasFloat
            mul!(U2,Q',B)
            LinearAlgebra.LAPACK.gerqf!(U2,tau)
         else
            copyto!(U2,rev!(qr!(rev!(B'*Q)).R)')
         end
         fill!(view(U,:,1:n-nb),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.gerqf!(Q'*B,tau)[1][:,nb-n+1:nb]
         else
            U = rev!(qr!(rev!(B'*Q)).R)'
         end
       end
   end
   U = UpperTriangular(U)
   plyapds!(AS, ES, U, adj = adj)
   T2 <: BlasFloat  && (tau = similar(U,n))
   if adj
      #X = Q*U'*U*Q'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.geqrf!(lmul!(U,copy(Q')),tau)[1])
      else
         U = UpperTriangular(qr!(lmul!(U,copy(Q'))).R)
      end
   else
      #X <- Z*U*U'*Z'
      if T2 <: BlasFloat
         U = UpperTriangular(LinearAlgebra.LAPACK.gerqf!(rmul!(Z, U), tau)[1])
      else
         U = UpperTriangular(rev!(qr!(rev!(copy(rmul!(Z, U)'))).R)')
      end
   end  
   return utnormalize!(U,adj)
end
plyapd(A::Union{Real,Complex}, E::Union{Real,Complex}, B::Union{Real,Complex}) =
     abs(A) < abs(E) ? real(abs(B)/sqrt( (abs(E)-abs(A))*(abs(E)+abs(A)) )) :
      error("A/E must be a subunitary number")

"""
    U = plyaps(A, B; disc = false)

Compute `U`, the upper triangular factor of the solution `X = UU'` of the
continuous Lyapunov equation

      AX + XA' + BB' = 0,

where `A` is a square real or complex matrix in a real or complex Schur form,
respectively, and `B` is a matrix with the same number of rows as `A`.
`A` must have only eigenvalues with negative real parts. Only the upper
Hessenberg part of `A` is referenced.

    U = plyaps(A', B', disc = false)

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the continuous Lyapunov equation

      A'X + XA + B'B = 0,

where `A` is a square real or complex matrix in a real or complex Schur form,
respectively, and `B` is a matrix with the same number of columns as `A`.
`A` must have only eigenvalues with negative real parts. Only the upper
Hessenberg part of `A` is referenced.

    U = plyaps(A, B, disc = true)

Compute `U`, the upper triangular factor of the solution `X = UU'` of the
discrete Lyapunov equation

      AXA' - X + BB' = 0,

where `A` is a square real or complex matrix in a real or complex Schur form,
respectively, and `B` is a matrix with the same number of rows as `A`.
`A` must have only eigenvalues with moduli less than one. Only the upper
Hessenberg part of `A` is referenced.

    U = plyaps(A', B', disc = true)

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the discrete Lyapunov equation

      A'XA - X + B'B = 0,

where `A` is a square real or complex matrix in a real or complex Schur form,
respectively, and `B` is a matrix with the same number of columns as `A`.
`A` must have only eigenvalues with moduli less than one. Only the upper
Hessenberg part of `A` is referenced.
"""
function plyaps(A::AbstractMatrix, B::AbstractMatrix; disc = false)
   # Method

   # The Bartels-Steward Schur form based method is employed [1], with the
   # modifications proposed by Hammarling in [2] and [3].

   # Reference:

   # [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix
   #     equation AX+XB=C. Comm. ACM, 15:820–826, 1972.
   # [2] Hammarling, S.J. Numerical solution of the stable, non-negative definite
   #     Lyapunov equation. IMA J. Num. Anal., 2, pp. 303-325, 1982.
   # [3] Hammarling, S.J. Numerical solution of the discrete-time, convergent,
   #     non-negative definite Lyapunov equation.
   #     Systems & Control Letters 17 (1991) 137-139.

   adj = isa(A,Adjoint)
   xor(adj,isa(B,Adjoint)) && error("Only calls with A and B or with A' and B' allowed")

   n = LinearAlgebra.checksquare(A)
   if adj
      nb, mb = size(B)
      nb == n || throw(DimensionMismatch("B must be a matrix of column dimension $n"))
   else
      mb, nb = size(B)
      mb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))
   end

   T2 = promote_type(eltype(A), eltype(B))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(B) == T2 || (adj ? B = convert(Matrix{T2},B.parent)' : B = convert(Matrix{T2},B))
   ZERO = zero(T2)

   if adj
      #U'U = B'*B
      T2 <: BlasFloat  && (tau = similar(B,min(n,mb)))
      if mb <= n
         U = similar(B,T2,n,n)
         U1 = view(U,1:mb,:)
         if T2 <: BlasFloat
            copyto!(U1,B.parent)
            LinearAlgebra.LAPACK.geqrf!(U1,tau)
         else
            copyto!(U1,qr(B.parent).R)
         end
         fill!(view(U,mb+1:n,:),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.geqrf!(copy(B.parent),tau)[1][1:n,:]
         else
            U = qr(B.parent).R[1:n,:]
         end
      end
      U = UpperTriangular(U)
      if disc
         plyapds!(A.parent, U; adj)
      else
         plyapcs!(A.parent, U; adj)
      end
   else
      #UU' = B*B'
      T2 <: BlasFloat  && (tau = similar(B,min(n,nb)))
      if nb <= n
         U = similar(B,T2,n,n)
         U2 = view(U,:,n-nb+1:n)
         if T2 <: BlasFloat
            copyto!(U2,B)
            LinearAlgebra.LAPACK.gerqf!(U2,tau)
         else
            copyto!(U2,rev!(qr!(rev!(copy(B'))).R)')
         end
         fill!(view(U,:,1:n-nb),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.gerqf!(copy(B),tau)[1][:,nb-n+1:nb]
         else
            U = rev!(qr!(rev!(copy(B'))).R)'
         end
      end
      U = UpperTriangular(U)
      if disc
         plyapds!(A, U; adj)
      else
         plyapcs!(A, U; adj)
      end
   end
   return utnormalize!(U,adj)
end
"""
    U = plyaps(A, E, B; disc = false)

Compute `U`, the upper triangular factor of the solution `X = UU'` of the
generalized continuous Lyapunov equation

      AXE' + EXA' + BB' = 0,

where `A` and `E` are square real or complex matrices with the pair `(A,E)` in
a generalied real or complex Schur form, respectively,  and `B` is a matrix
with the same number of rows as `A`. The pencil `A - λE` must have only
eigenvalues with negative real parts.

    U = plyaps(A', E', B', disc = false)

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the generalized continuous Lyapunov equation

      A'XE + E'XA + B'B = 0,

where `A` and `E` are square real or complex matrices with the pair `(A,E)` in
a generalied real or complex Schur form, respectively,  and `B` is a matrix
with the same number of columns as `A`. The pencil `A - λE` must have only
eigenvalues with negative real parts.

    U = plyaps(A, E, B, disc = true)

Compute `U`, the upper triangular factor of the solution `X = UU'` of the
generalized discrete Lyapunov equation

      AXA' - EXE' + BB' = 0,

where `A` and `E` are square real or complex matrices with the pair `(A,E)` in
a generalied real or complex Schur form, respectively,  and `B` is a matrix
with the same number of rows as `A`. The pencil `A - λE` must have only
eigenvalues with moduli less than one.

    U = plyaps(A', E', B', disc = true)

Compute `U`, the upper triangular factor of the solution `X = U'U` of
the generalized discrete Lyapunov equation

      A'XA - E'XE + B'B = 0,

where `A` and `E` are square real or complex matrices with the pair `(A,E)` in
a generalied real or complex Schur form, respectively,  and `B` is a matrix
with the same number of columns as `A`. The pencil `A - λE` must have only
eigenvalues with moduli less than one.
"""
function plyaps(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling{Bool}}, B::AbstractMatrix; disc = false)
   # Method

   # Generalizations of Bartels-Steward Schur form based method is employed [1],
   # with the modifications proposed by Hammarling [2] and Penzl [3].

   # Reference:

   # [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix
   #     equation AX+XB=C. Comm. ACM, 15:820–826, 1972.
   # [2] Hammarling, S.J. Numerical solution of the stable, non-negative definite
   #     Lyapunov equation. IMA J. Num. Anal., 2, pp. 303-325, 1982.
   # [3] Penzl, T.
   #     Numerical solution of generalized Lyapunov equations.
   #     Advances in Comp. Math., vol. 8, pp. 33-48, 1998.

   n = LinearAlgebra.checksquare(A)
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) &&  size(E,1) == n)) && (return plyaps(A, B))
   
   T2 = promote_type(eltype(A), eltype(E), eltype(B))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))

   adj = isa(A,Adjoint)
   (xor(adj,isa(E,Adjoint)) || xor(adj,isa(B,Adjoint))) &&
      error("Only calls with A, E and B or with A', E' and B' allowed")


   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
   

   if adj
      nb, mb = size(B)
      nb == n || throw(DimensionMismatch("B must be a matrix of column dimension $n"))
   else
      mb, nb = size(B)
      mb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))
   end


   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(E) == T2 || (adj ? E = convert(Matrix{T2},E.parent)' : E = convert(Matrix{T2},E))
   eltype(B) == T2 || (adj ? B = convert(Matrix{T2},B.parent)' : B = convert(Matrix{T2},B))
   ZERO = zero(T2)

   if adj
      #U'*U = B'*B
      T2 <: BlasFloat  && (tau = similar(B,min(n,mb)))
      if mb <= n
         U = similar(B,T2,n,n)
         U1 = view(U,1:mb,:)
         if T2 <: BlasFloat
            copyto!(U1,B.parent)
            LinearAlgebra.LAPACK.geqrf!(U1,tau)
         else
            copyto!(U1,qr(B.parent).R)
         end
         fill!(view(U,mb+1:n,:),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.geqrf!(copy(B.parent),tau)[1][1:n,:]
         else
            U = qr(B.parent).R[1:n,:]
         end
      end
      U = UpperTriangular(U)
      if disc
         plyapds!(A.parent, E.parent, U; adj)
      else
         plyapcs!(A.parent, E.parent, U; adj)
      end
   else
      #U*U' = B*B'
      T2 <: BlasFloat  && (tau = similar(B,min(n,nb)))
      if nb <= n
         U = similar(B,T2,n,n)
         U2 = view(U,:,n-nb+1:n)
         if T2 <: BlasFloat
            copyto!(U2,B)
            LinearAlgebra.LAPACK.gerqf!(U2,tau)
         else
            copyto!(U2,rev!(qr!(rev!(copy(B'))).R)')
         end
         fill!(view(U,:,1:n-nb),ZERO)
      else
         if T2 <: BlasFloat
            U = LinearAlgebra.LAPACK.gerqf!(copy(B),tau)[1][:,nb-n+1:nb]
         else
            U = rev!(qr!(rev!(copy(B'))).R)'
         end
      end
      U = UpperTriangular(U)
      if disc
         plyapds!(A, E, U; adj)
      else
         plyapcs!(A, E, U; adj)
      end
   end
   return utnormalize!(U,adj)
end
"""
    plyapcs!(A,R;adj = false)

Solve the positive continuous Lyapunov matrix equation

                op(A)X + Xop(A)' + op(R)*op(R)' = 0

for `X = op(U)*op(U)'`, where `op(K) = K` if `adj = false` and `op(K) = K'` if `adj = true`.
`A` is a square real matrix in a real Schur form  or a square complex matrix in a
complex Schur form and `R` is an upper triangular matrix.
`A` must have only eigenvalues with negative real parts.
`R` contains on output the solution `U`.
"""
function plyapcs!(A::AbstractMatrix{T1}, R::UpperTriangular{T1}; adj = false)  where T1 <: Real
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))

   ONE = one(T1)
   ZERO = zero(T1)
   TWO = 2*ONE
   EPS = eps(T1)
   SMLNUM = sqrt(_safemin(T1))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))

   # small = safemin(T1)*n*n
   # BIGNUM = ONE / small
   # SMIN = eps(maximum(abs.(A)))


   # determine the structure of the real Schur form
   ba, p = sfstruct(A)

   Wr = Matrix{T1}(undef,n,2)
   Wz = Matrix{T1}(undef,n,2)
   Mα = Matrix{T1}(undef,2,2)
   Mβ = Matrix{T1}(undef,2,2)
   if adj
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #       A(L,L)'*X(L,L) + X(L,L)*A(L,L) = -R(L,L)'*R(L,L),
      j = 1
      for ll = 1:p
          dl = ba[ll]
          l = j:j+dl-1
          if dl == 1
             λ = A[j,j]
             λ >= ZERO && error("A is not stable")
             TEMP = sqrt( abs( TWO*λ ) )
             TEMP < SMIN && (TEMP = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular Lyapunov equation")
             tα = copysign( TEMP, R[j,j])
             R[j,j] = R[j,j]/tα
             Mα[1,1] = tα
             Mβ[1,1] = A[j,j]
          else
             Mβ, Mα = plyap2!(view(A,l,l), view(R,l,l), adj = true)
          end
          if ll < p
             dll = 1:dl
             js = j
             j += dl
             j1 = j:n
             ir1 = 1:n-j+1
             rbar = view(Wr,ir1,dll)
             z = view(Wz,ir1,dll)
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             # Form the right-hand side of (6.2)
             # z = rbar'*α + s'*u11'
             # rbar = R[l,j1]'
             transpose!(rbar,view(R,l,j1))
             # z = rbar*α + A[l,j1]'*R[l,l]'
             mul!(z,rbar,α)
             # mul!(z,transpose(view(A,l,j1)),transpose(R[l,l]),ONE,ONE)
             # alternative code exploiting lower triangular form of R'
             k = js+dl-1
             axpy!(R[k,k],view(A,k,j1),view(z,:,dl))
             dl == 1 || (axpy!(R[js,js],view(A,js,j1),view(z,:,1)); axpy!(R[js,js+1],view(A,js+1,j1),view(z,:,1)))

             # Solve S1'*ubar+ubar*β + z = 0
             if T1 <: BlasReal
                _, scale = LAPACK.trsyl!('T','N', view(A,j1,j1), β, z)
                scale == ONE || error("Singular Lyapunov equation")
                transpose!(view(R,l,j1),rmul!(z,-1))
             else
                sylvcs2!(view(A,j1,j1), β, z; adj)
                transpose!(view(R,l,j1),z)
             end
             # update the Cholesky factor R1'*R1 <- R1'*R1 + y'*y
             # y = rbar - ubar * α'
             mul!(rbar, z, transpose(α), -ONE, ONE)
             #rbar += ubar * α'
             qrupdate!(view(R,j1,j1), rbar)
         end
      end
   else
      # The (L,L)th block of X is determined starting from
      # bottom-right corner column by column by
      #        A(L,L)*X(L,L) + X(L,L)*A(L,L)' = -R(L,L)*R(L,L)',
      j = n
      for ll = p:-1:1
          dl = ba[ll]
          l = j-dl+1:j
          if dl == 1
             λ = A[j,j]
             λ >= ZERO && error("A is not stable")
             TEMP = sqrt( abs( TWO*λ ) )
             TEMP < SMIN && (TEMP  = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular Lyapunov equation")
             tα = copysign( TEMP, R[j,j])
             R[j,j] = R[j,j]/tα
             Mα[1,1] = tα
             Mβ[1,1] = A[j,j]
          else
             Mβ, Mα = plyap2!(view(A,l,l), view(R,l,l), adj = false)
          end
          if ll > 1
             dll = 1:dl
             js = j
             j -= dl
             j1 = 1:j
             # Form the right-hand side corresponding to the dual of (6.2)
             # S = [ S1  s  ]
             #     [ 0  s11 ]
             # z = rbar*α' + s*u11
             rbar = view(Wr,j1,dll)
             z = view(Wz,j1,dll)
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             # rbar = R[j1,l]
             copyto!(rbar,view(R,j1,l))
             # z = rbar*α' + A[j1,l]*R[l,l]
             #z = rbar*α'
             mul!(z,rbar,transpose(α))
             #mul!(z,view(A,j1,l),view(R,l,l),ONE,ONE)
             #mul!(z,view(A,j1,l),R[l,l],ONE,ONE)
             # alternative code exploiting upper triangular shape of R
             k = js-dl+1
             axpy!(R[k,k],view(A,j1,k),view(z,:,1))
             dl == 1 || (axpy!(R[js-1,js],view(A,j1,js-1),view(z,:,2)); axpy!(R[js,js],view(A,j1,js),view(z,:,2)))
             # Solve S1*ubar+ubar*β' + z = 0
             if T1 <: BlasReal
                _, scale = LAPACK.trsyl!('N','T', view(A,j1,j1), β, z)
                scale == ONE || error("Singular Lyapunov equation")
                copyto!(view(R,j1,l), rmul!(z,-1))
             else
               sylvcs2!(view(A,j1,j1), β, z; adj)
               copyto!(view(R,j1,l), z)
             end  
             # update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             # y = rbar - ubar*α
             mul!(rbar, z, α, -ONE, ONE)
             rqupdate!(view(R,j1,j1), rbar)
         end
       end
   end
   return R
end
function plyapcs!(A::AbstractMatrix{T1}, R::UpperTriangular{T1}; adj = false)  where T1 <: Complex
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))

   T = real(T1)
   ONE = one(T)
   ZERO = zero(T)
   TWO = 2*ONE
   EPS = eps(T)
   SMLNUM = sqrt(_safemin(T))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))


   Wr = Vector{T1}(undef,n)
   Wz = similar(Wr,n,1)
   if adj
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #       A(L,L)'*X(L,L) + X(L,L)*A(L,L) = -R(L,L)'*R(L,L),
      for j = 1:n
          λ = real(A[j,j])
          λ >= ZERO && error("A is not stable")
          TEMP = sqrt( -TWO*λ )
          TEMP < SMIN && (TEMP  = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular Lyapunov equation")
          iszero(DR) ? α = TEMP : α = sign(R[j,j])*TEMP
          R[j,j] = R[j,j]/α
          l = j:j
          β = A[l,l]
          if j < n
            j += 1
            j1 = j:n
            ir1 = 1:n-j+1
            # Form the right-hand side of (6.2)
            # z = rbar'*α + s'*u11'
            rbar = view(Wr,ir1,1:1)
            z = view(Wz,ir1,1:1)
            k = j
            for ii = 1:n-j+1
               rbar[ii] = R[j-1,k]'
               z[ii] = rbar[ii]*α + R[j-1,j-1]*A[j-1,k]'
               k += 1
            end  
            # Solve S1'*ubar+ubar*β + z = 0
            if T <: BlasReal
               _, scale = LAPACK.trsyl!('C','N', view(A,j1,j1), β, z)
               scale == ONE || error("Singular Lyapunov equation")
            else
               sylvcs1!(view(A,j1,j1), β, z; adj)
               rmul!(z,-1)
            end
            k = j
            for ii = 1:n-j+1
               R[j-1,k] = -z[ii]'
               rbar[ii] = conj(rbar[ii] + z[ii] * α')
               k += 1
            end
            # update the Cholesky factor R1'*R1 <- R1'*R1 + y'*y
            #y = conj(rbar + ubar * α')
            qrupdate!(view(R,j1,j1), rbar)
          end
      end
   else
      # The (L,L)th block of X is determined starting from
      # bottom-right corner column by column by
      #       A(L,L)*X(L,L) + X(L,L)*A(L,L)' = -R(L,L)*R(L,L)',
      for j = n:-1:1
          λ = real(A[j,j])
          λ >= ZERO && error("A is not stable")
          TEMP = sqrt( -TWO*λ  )
          TEMP < SMIN && (TEMP  = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular Lyapunov equation")
          iszero(DR) ? α = TEMP : α = sign(R[j,j])*TEMP
          R[j,j] = R[j,j]/α
          l = j:j
          β = A[l,l]
          if j > 1
             j -= 1
             j1 = 1:j
             # Form the right-hand side corresponding to the dual of (6.2)
             # S = [ S1  s  ]
             #     [ 0  s11 ]
             # z = rbar*α' + s*u11
             rbar = view(Wr,j1,1:1)
             z = view(Wz,j1,1:1)
             for ii = 1:j
               rbar[ii] = R[ii,j+1]
               z[ii]= rbar[ii]*α' + A[ii,j+1]*R[j+1,j+1]
             end
             #z = rbar*α' + A[j1,l]*R[l,l]
             # Solve S1*ubar+ubar*β' + z = 0
             if T <: BlasReal
                _, scale = LAPACK.trsyl!('N','C', view(A,j1,j1), β, z)
                scale == ONE || error("Singular Lyapunov equation")
             else
                sylvcs1!(view(A,j1,j1), β, z; adj)
                rmul!(z,-1)
             end
             # update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             # y = rbar + z*α
             for ii = 1:j
                 R[ii,j+1] = -z[ii]
                 rbar[ii] += z[ii]*α
             end
             rqupdate!(view(R,j1,j1), rbar)
          end
       end
   end
   return R
end
"""
    plyapcs!(A,E,R;adj = false)

Solve the generalized positive continuous Lyapunov matrix equation

                op(A)Xop(E)' + op(E)*Xop(A)' + op(R)*op(R)' = 0

for `X = op(U)*op(U)'`, where `op(K) = K` if `adj = false` and `op(K) = K'` if `adj = true`.
The pair `(A,E)` is in a generalized real/complex Schur form and `R` is an upper
triangular matrix. The pencil `A-λE` must have only eigenvalues with negative
real parts. `R` contains on output the solution `U`.
"""
function plyapcs!(A::AbstractMatrix{T1}, E::Union{AbstractMatrix{T1},UniformScaling{Bool}},R::UpperTriangular{T1}; adj::Bool = false)  where T1 <: Real
   n = LinearAlgebra.checksquare(A)
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) && size(E,1) == n)) && (plyapcs!(A, R, adj = adj); return)
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))

   ONE = one(T1)
   ZERO = zero(T1)
   TWO = 2*ONE
   EPS = eps(T1)
   SMLNUM = sqrt(_safemin(T1))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))
   
   # determine the structure of the generalized real Schur form
   ba, p = sfstruct(A)

   WB = Matrix{T1}(undef,n,2)
   WD = Matrix{T1}(undef,n,2)
   Wr = Matrix{T1}(undef,n,2)
   Wv = similar(Wr)
   Wz = similar(Wr)
   Mα = Matrix{T1}(undef,2,2)
   Mβ = Matrix{T1}(undef,2,2)
   η = [ ONE ZERO; SMLNUM ONE]
   if adj
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #       A(L,L)'*X(L,L)*E(L,L) + E(L,L)'*X(L,L)*A(L,L) = -R(L,L)'*R(L,L),
      j = 1
      for ll = 1:p
          dl = ba[ll]
          l = j:j+dl-1
          if dl == 1
             λ = A[j,j]*E[j,j]
             λ >= ZERO && error("A-λE has eigenvalues with non-negative real parts")
             TEMP = sqrt( -TWO*λ )
             TEMP < SMIN && (TEMP = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular generalized Lyapunov equation")
             iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
             R[j,j] = R[j,j]/TEMP
             Mα[1,1] = TEMP/E[j,j]
             Mβ[1,1] = A[j,j]/E[j,j]
          else
             Mβ, Mα = pglyap2!(view(A,l,l), view(E,l,l), view(R,l,l), adj = true)
          end
          if ll < p
             dll = 1:dl
             js = j
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             j += dl
             j1 = j:n
             ir1 = 1:n-j+1
             # Form the right-hand side of (6.2)
             # z = rbar'*α + s'*u11'
             rbar = view(Wr,ir1,dll)
             v = view(Wv,ir1,dll)
             z = view(Wz,ir1,dll)
             #rbar = R[l,j1]'
             transpose!(rbar,view(R,l,j1))
             #z = rbar*α + A[l,j1]'*R[l,l]' + E[l,j1]'*R[l,l]'*β
             mul!(z, rbar, α)
             k = js+dl-1
             # z <- z + A[l,j1]'*R[l,l]' exploiting upper triangular shape of R
             axpy!(R[k,k],view(A,k,j1),view(z,:,dl))
             dl == 1 || (axpy!(R[js,js],view(A,js,j1),view(z,:,1)); axpy!(R[js,js+1],view(A,js+1,j1),view(z,:,1)))
             # v = (R[l,l]*E[l,j1])'  exploiting upper triangular shape of R
             jj = j
             for ii = 1:n-j+1
                 v[ii,dl] = R[k,k]*E[k,jj]
                 jj += 1
             end               
             if dl == 2
               jj = j
               for ii = 1:n-j+1
                   v[ii,1] = R[js,js]*E[js,jj] + R[js,js+1]*E[js+1,jj]
                   jj += 1
               end
             end
             mul!(z, v, β, 1, 1)
             rmul!(z,-1)
             # Solve A[j1,j1]'*ubar+E[j1,j1]'*ubar*β + z = 0
             E1 = view(E,j1,j1)
             gsylvs!(view(A,j1,j1), view(η,dll,dll), E1, β, z, view(WB,j1,1:2), view(WD,j1,1:2); adjAC = true, adjBD = false)
             #R[l,j1] = z'
             transpose!(view(R,l,j1),z)
             # update the Cholesky factor R2'*R2 <- R2'*R2 + y'*y
             #y = rbar - (E[j1,j1]'*ubar+E[l,j1]'*R[l,l]') * α'
             #y = rbar - (E[j1,j1]'*ubar+v) * α'
             mul!(v, transpose(UpperTriangular(E1)), z, ONE, ONE)
             #rbar -= v * α'
             mul!(rbar, v, transpose(α), -ONE, ONE)
             qrupdate!(view(R,j1,j1), rbar)
         end
      end
   else
      # The (L,L)th block of X is determined starting from
      # bottom-right corner column by column by
      #      A(L,L)*X(L,L)*E(L,L)' + E(L,L)*X(L,L)*A(L,L)' = -R(L,L)*R(L,L)',
      j = n
      for ll = p:-1:1
          dl = ba[ll]
          l = j-dl+1:j
          if dl == 1
             λ = A[j,j]*E[j,j]
             λ >= ZERO && error("A-λE has eigenvalues with non-negative real parts")
             TEMP = sqrt( -TWO*λ )
             TEMP < SMIN && (TEMP = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular generalized Lyapunov equation")
             iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
             R[j,j] = R[j,j]/TEMP
             Mα[1,1] = TEMP/E[j,j]
             Mβ[1,1] = A[j,j]/E[j,j]
          else
             Mβ, Mα = pglyap2!(view(A,l,l), view(E,l,l), view(R,l,l), adj = false)
          end
          if ll > 1
             dll = 1:dl
             js = j
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             j -= dl
             j1 = 1:j
             # Form the right-hand side corresponding to the dual of (6.2)
             # S = [ S1  s  ]
             #     [ 0  s11 ]
             # z = rbar*α' + s*u11
             rbar = view(Wr,j1,dll)
             v = view(Wv,j1,dll)
             z = view(Wz,j1,dll)
             #rbar = R[j1,l]
             copyto!(rbar,view(R,j1,l))
             #v = E[j1,l]*R[l,l]  - null allocation code exploiting upper triangular shape of R
             #mul!(v,view(E,j1,l),view(R,l,l))
             k = js-dl+1
             for ii = 1:j
                 v[ii,1] = R[k,k]*E[ii,k]
             end               
             if dl == 2
               for ii = 1:j
                   v[ii,2] = R[js-1,js]*E[ii,js-1] + R[js,js]*E[ii,js]
               end
             end
             # z = rbar*α' + A[j1,l]*R[l,l] + v*β'
             mul!(z, rbar, transpose(α))
             # null allocation code exploiting upper triangular shape of R
             axpy!(R[k,k],view(A,j1,k),view(z,:,1))
             dl == 1 || (axpy!(R[js-1,js],view(A,j1,js-1),view(z,:,2)); axpy!(R[js,js],view(A,j1,js),view(z,:,2)))
             mul!(z, v, transpose(β), 1, 1)
             rmul!(z,-1)
             # Solve S1*ubar+ubar*β' + z = 0
             E1 = view(E,j1,j1)
             gsylvs!(view(A,j1,j1), view(η,dll,dll), E1, β, z, view(WB,j1,1:2), view(WD,j1,1:2); adjAC = false, adjBD = true)
             #R[j1,l] = z
             copyto!(view(R,j1,l), z)
             # update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             #y = rbar - (E[j1,j1]*z+v) * α
             #v <-v + E[j1,j1]*z
             #mul!(v,UpperTriangular(E1),z,ONE,ONE)
             mul!(v, E1, z, ONE, ONE)  # null allocation
             #y = rbar - v * α
             mul!(rbar, v, α, -ONE, ONE)
             rqupdate!(view(R,j1,j1), rbar)
          end
       end
   end
   return R
end
function plyapcs!(A::AbstractMatrix{T1}, E::Union{AbstractMatrix{T1},UniformScaling{Bool}},R::UpperTriangular{T1}; adj = false)  where T1 <: Complex
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))
   (typeof(E) == UniformScaling{Bool} || isempty(E) || (isequal(E,I) && size(E,1) == n)) &&
         (plyapcs!(A, R, adj = adj); return)

   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))

   T = real(T1)
   ONE = one(T)
   ZERO = zero(T)
   TWO = 2*ONE
   EPS = eps(T)
   SMLNUM = sqrt(_safemin(T))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))

   WB = Vector{T1}(undef,n)
   WD = Vector{T1}(undef,n)
   Wr = Matrix{T1}(undef,n,1)
   Wv = similar(Wr)
   Wz = similar(Wr)
   η  = complex(fill(ONE,(1,1)))
   if adj
      # The (L,L)th block of X is determined starting from
      # upper-left corner row by row by
      #       A(L,L)'*X(L,L)*E(L,L) + E(L,L)'*X(L,L)*A(L,L) = -R(L,L)'*R(L,L),
      for j = 1:n
          δ = -TWO*real(A[j,j]'*E[j,j])
          δ <= ZERO && error("A-λE has unstable eigenvalues")
          TEMP = sqrt( δ )
          TEMP < SMIN && (TEMP = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular generalized Lyapunov equation")
          iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
          R[j,j] = R[j,j]/TEMP
          l = j:j
          β = A[l,l]/E[j,j]
          α = TEMP/E[j,j]
          # Form the right-hand side corresponding to (11.6)
          # A = [ A[l,l]   A[l,j1]  ]     E = [ E[l,l]   E[l,j1]  ]
          #     [ 0        A[j1,j1] ]         [ 0        E[j1,j1] ]
          if j < n
             j += 1
             j1 = j:n
             ir1 = 1:n-j+1
             # Form the right-hand side of (11.12)
             # z = rbar'*α + s'*u11'
             rbar = view(Wr,ir1,1:1)
             v = view(Wv,ir1,1:1)
             z = view(Wz,ir1,1:1)
             k = j
             for ii = 1:n-j+1
                rbar[ii] = R[j-1,k]'
                v[ii] = R[j-1,j-1]*E[j-1,k]'
                z[ii] = -(rbar[ii]*α + R[j-1,j-1]*A[j-1,k]' + v[ii]*β[1,1])
                k += 1
             end  
             #  rbar = R[l,j1]'
             #  v = (R[l,l]*E[l,j1])'
             #  #z = rbar*α + A[l,j1]'*R[l,l]' + E[l,j1]'*R[l,l]'*β
             # Solve A[j1,j1]'*ubar+E[j1,j1]'*ubar*β + z = 0
             E1 = view(E,j1,j1)
             gsylvs!(view(A,j1,j1), η, E1, β, z, view(WB,j1), view(WD,j1); adjAC=true, adjBD=false)
             # v <- v + E1'*z
             mul!(v, UpperTriangular(E1)', z, 1, 1)
             #R[l,j1] = z'
             # update the Cholesky factor R2'*R2 <- R2'*R2 + y'*y
             #y = conj(rbar - (E[j1,j1]'*ubar+E[l,j1]'*R[l,l]') * α')
             k = j
             for ii = 1:n-j+1
                R[j-1,k] = z[ii]'
                rbar[ii] = conj(rbar[ii] - v[ii] * α')
                k += 1
             end
             qrupdate!(view(R,j1,j1), rbar)
          end
      end
      return R
   else
      # The (L,L)th block of X is determined starting from
      # bottom-right corner column by column by
      #      A(L,L)*X(L,L)*E(L,L)' + E(L,L)*X(L,L)*A(L,L)' = -R(L,L)*R(L,L)',
      for j = n:-1:1
          δ = -TWO*real(A[j,j]'*E[j,j])
          δ <= ZERO && error("A-λE has unstable eigenvalues")
          TEMP = sqrt( δ )
          TEMP < SMIN && (TEMP = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP && error("Singular generalized Lyapunov equation")
          iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
          R[j,j] = R[j,j]/TEMP
          l = j:j
          β = A[l,l]/E[j,j]
          α = TEMP/E[j,j]
          # Form the right-hand side corresponding to the dual of (11.6)
          # A = [ A[j1,j1]  A[j1,l]  ]     E = [ E[j1,j1]  E[j1,l]  ]
          #     [ 0         A[l,l]   ]         [ 0         E[l,l]   ]
          if j > 1
             j -= 1
             j1 = 1:j
             # z = rbar*α' + s*u11
             rbar = view(Wr,j1,1:1)
             v = view(Wv,j1,1:1)
             z = view(Wz,j1,1:1)
             #rbar = R[j1,l]
             #v = E[j1,l]*R[l,l]
             #z = rbar*α + A[l,j1]'*R[l,l]' + E[l,j1]'*R[l,l]'*β
             #z = rbar*α' + A[j1,l]*R[l,l] + v*β'
             for ii = 1:j
                 rbar[ii] = R[ii,j+1]
                 v[ii] = E[ii,j+1]*R[j+1,j+1]
                 z[ii] = -(rbar[ii]*α' + A[ii,j+1]*R[j+1,j+1] + v[ii]*β[1,1]')
             end
             # Solve S1*ubar+ubar*β' + z = 0
             E1 = view(E,j1,j1)
             gsylvs!(view(A,j1,j1), η, E1, β, z, view(WB,j1), view(WD,j1); adjAC=false, adjBD=true)
             # v <- v + E1*z
             mul!(v, UpperTriangular(E1), z, 1, 1)
             #R[j1,l] = z
             # update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             # y = rbar - (E[j1,j1]*ubar+v) * α
             #y = rbar - (E1*z+v) * α
             for ii = 1:j
               R[ii,j+1] = z[ii]
               rbar[ii] -= v[ii]*α
             end
             rqupdate!(view(R,j1,j1), rbar)
          end
       end
   end
   return R
end
"""
    plyapds!(A, R; adj = false)

Solve the positive discrete Lyapunov matrix equation

                op(A)Xop(A)' - X + op(R)*op(R)' = 0

for `X = op(U)*op(U)'`, where `op(K) = K` if `adj = false` and `op(K) = K'` if `adj = true`.
`A` is a square real matrix in a real Schur form or a square complex matrix in a
complex Schur form and `R` is an upper triangular matrix.
`A` must have only eigenvalues with moduli less than one.
`R` contains on output the upper triangular solution `U`.
"""
function plyapds!(A::AbstractMatrix{T1}, R::UpperTriangular{T1}; adj = false)  where T1 <: Real
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))

   ONE = one(T1)
   ZERO = zero(T1)
   TWO = 2*ONE
   EPS = eps(T1)
   SMLNUM = sqrt(_safemin(T1))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))

   # determine the structure of the real Schur form
   ba, p = sfstruct(A)

   W = Matrix{T1}(undef,n,2)
   Wr = Matrix{T1}(undef,n,2)
   Wv = similar(Wr)
   Wz = similar(Wr)
   Mα = Matrix{T1}(undef,2,2)
   Mβ = Matrix{T1}(undef,2,2)
   if adj
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #    A(L,L)'*X(L,L)*A(L,L) - X(L,L) = -R(L,L)'*R(L,L),
      j = 1
      for ll = 1:p
          dl = ba[ll]
          l = j:j+dl-1
          if dl == 1
             λ = abs(A[j,j])
             λ >= 1 && error("A is not convergent")
             TEMP = sqrt( (ONE - λ)*(ONE + λ) )
             TEMP < SMIN && (TEMP  = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
                error("Singular Lyapunov equation")
             tα = copysign( TEMP, R[j,j])
             R[j,j] = R[j,j]/tα
             Mα[1,1] = tα
             Mβ[1,1] = A[j,j]
          else
             Mβ, Mα = plyap2!(view(A,l,l), view(R,l,l), adj = true, disc = true)
          end
          if ll < p
             dll = 1:dl
             js = j
             j += dl
             j1 = j:n
             ir1 = 1:n-j+1
             rbar = view(Wr,ir1,dll)
             #v = view(Wv,j1,dll)
             v = view(Wv,ir1,dll)
             z = view(Wz,ir1,dll)
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             # Form the right-hand side of (10.16)
             # z = rbar*α + s'*u11*β
             # rbar = R[l,j1]'
             transpose!(rbar,view(R,l,j1))
             # v = (R[l,l]*A[l,j1])'
             #mul!(v,transpose(view(A,l,j1)),transpose(R[l,l]))
             k = js+dl-1
             jj = j
             for ii = 1:n-j+1
                 v[ii,dl] = R[k,k]*A[k,jj]
                 jj += 1
             end               
             if dl == 2
               jj = j
               for ii = 1:n-j+1
                   v[ii,1] = R[js,js]*A[js,jj] + R[js,js+1]*A[js+1,jj]
                   jj += 1
               end
             end
             #z = rbar*α + A[l,j1]'*R[l,l]*β
             #z = rbar*α + v*β
             mul!(z, rbar, α)
             mul!(z, v, β, ONE, ONE)
             # Solve S1'*ubar*β+ubar + z = 0
             S1 = view(A,j1,j1)
             sylvds!(S1, -β, z, view(W,j1,1:2), adjA = true, adjB = false)
             #R[l,j1] = ubar'
             transpose!(view(R,l,j1), z)
             # update the Cholesky factor R1'*R1 <- R1'*R1 + y'*y
             # v += S1'*z
             mul!(v, transpose(S1), z, ONE, ONE)
             if dl == 1
                #y = rbar*β - v*α
               #  mul!(y, v, α)
               #  mul!(y,rbar,β,ONE,-ONE)
                rmul!(v, -α[1,1])
                #mul!(v, rbar, β, ONE, ONE)
                #LinearAlgebra.axpy!(β[1,1], rbar, v)
                axpy!(β[1,1], view(Wr,ir1,1), view(Wv,ir1,1))
             else
               #  F = qr([α; β])
               #  vy = [rbar v]*F.Q
               #  y = vy[:,dl+1:end]
                v =  ([rbar v]*qr([α; β]).Q)[:,dl+1:end]
                # alternative formula of Varga
                #y = rbar - (A[l,j1]'*R[l,l]'+S1'*ubar+ubar)*inv(I+β')*α'
             end
             #RR = view(R,j1,j1)
             qrupdate!(view(R,j1,j1), v)
          end
      end
   else
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #      A(L,L)*X(L,L)*A(L,L)' - X(L,L) = -R(L,L)*R(L,L)',
      j = n
      for ll = p:-1:1
          dl = ba[ll]
          l = j-dl+1:j
          if dl == 1
             λ = abs(A[j,j])
             λ >= 1 && error("A is not convergent")
             TEMP = sqrt( (ONE - λ)*(ONE + λ) )
             TEMP < SMIN && (TEMP  = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
                error("Singular Lyapunov equation")
             tα = copysign( TEMP, R[j,j])
             R[j,j] = R[j,j]/tα
             Mα[1,1] = tα
             Mβ[1,1] = A[j,j]
          else
             Mβ, Mα = plyap2!(view(A,l,l), view(R,l,l), adj = false, disc = true)
          end
          if ll > 1
             dll = 1:dl
             js = j
             j -= dl
             j1 = 1:j
             # Form the right-hand side corresponding to the dual of (6.2)
             # S = [ S1  s  ]
             #     [ 0  s11 ]
             # z = rbar*α' + s*u11
             rbar = view(Wr,j1,dll)
             z = view(Wz,j1,dll)
             v = view(Wv,j1,dll)
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             #rbar = R[j1,l]
             copyto!(rbar,view(R,j1,l))
             # v = A[j1,l]*R[l,l]
             # v = view(A,j1,l)*R[l,l]
             #mul!(v,view(A,j1,l),view(R,l,l))
             k = js-dl+1
             for ii = 1:j
                 v[ii,1] = R[k,k]*A[ii,k]
             end               
             if dl == 2
               for ii = 1:j
                   v[ii,2] = R[js-1,js]*A[ii,js-1] + R[js,js]*A[ii,js]
               end
             end
             #z = rbar*α' + v*β'
             mul!(z,rbar,transpose(α))
             mul!(z,v,transpose(β),ONE,ONE)
             # Solve S1*ubar*β'+ubar + z = 0
             S1 = view(A,j1,j1)
             sylvds!(S1, -β, z, view(W,j1,1:2), adjA = false, adjB = true)
             copyto!(view(R,j1,l), z )
             # update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             #v += S1*ubar
             mul!(v, S1, z, ONE, ONE)
             if dl == 1
                #y = rbar*β - v*α
                rmul!(v,-α[1,1])
                mul!(v, rbar, β, ONE, ONE)
               #  mul!(y, v, α)
               #  mul!(y,rbar,β,ONE,-ONE)
             else
               #  F = qr([α'; β'])
               #  vy = [rbar v]*F.Q
               #  y = vy[:,dl+1:end]
                v =  ([rbar v]*qr([α'; β']).Q)[:,dl+1:end]
             end
             #RR = view(R,j1,j1)
             rqupdate!(view(R,j1,j1), v)
          end
       end
   end
   return R
end
function plyapds!(A::AbstractMatrix{T1}, R::UpperTriangular{T1}; adj = false)  where T1 <: Complex
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))

   T = real(T1)

   ONE = one(T)
   EPS = eps(T)
   SMLNUM = sqrt(_safemin(T))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))

   W = Vector{T1}(undef,n)
   Wr = Matrix{T1}(undef,n,1)
   Wv = similar(Wr)
   Wz = similar(Wr)
   if adj
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #     A(L,L)'*X(L,L)*A(L,L) - X(L,L) = -R(L,L)'*R(L,L),
      for j = 1:n
          λ = abs(A[j,j])
          λ >= ONE && error("A is not convergent")
          TEMP = sqrt( (ONE - λ)*(ONE + λ) )
          TEMP < SMIN && (TEMP  = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
             error("Singular Lyapunov equation")
          iszero(DR) ? α = TEMP : α = sign(R[j,j])*TEMP
          R[j,j] = R[j,j]/α
          l = j:j
          β = A[l,l]
          if j < n
             js = j
             j += 1
             j1 = j:n
             ir1 = 1:n-j+1
             rbar = view(Wr,ir1,1:1)
             v = view(Wv,ir1,1:1)
             z = view(Wz,ir1,1:1)
             # Form the right-hand side of (10.16)
             # z = rbar*α + s'*u11*β
             k = j
             for ii = 1:n-j+1
                rbar[ii] = R[js,k]'
                v[ii] = R[js,js]*A[js,k]'
                z[ii] = rbar[ii]*α + v[ii]*β[1,1]
                k += 1
             end  
             # Solve S1'*ubar*β + ubar + z = 0
             S1 = view(A,j1,j1)
             sylvds!(S1, -β, z, W; adjA = true, adjB = false)
             # v <- v + S1'*z
             #mul!(v, UpperTriangular(S1)', z, 1, 1) # faster but involves allocations
             mul!(v, S1', z, 1, 1)  # null allocation
             # R[l,j1] = z'
             # update the Cholesky factor R1'*R1 <- R1'*R1 + y'*y
             # y = conj(rbar*β' - v * α')
             k = j
             t = β[1,1]'
             for ii = 1:n-j+1
                R[j-1,k] = z[ii]'
                rbar[ii] = conj(rbar[ii] * t - v[ii] * α')
                k += 1
             end
             qrupdate!(view(R,j1,j1), rbar)
         end
      end
   else
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #     A(L,L)*X(L,L)*A(L,L)' - X(L,L) = -R(L,L)*R(L,L)',
      for j = n:-1:1
          λ = abs(A[j,j])
          λ >= ONE && error("A is not convergent")
          TEMP = sqrt( (ONE - λ)*(ONE + λ) )
          TEMP < SMIN && (TEMP  = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
             error("Singular Lyapunov equation")
          iszero(DR) ? α = TEMP : α = sign(R[j,j])*TEMP
          R[j,j] = R[j,j]/α
          l = j:j
          β = A[l,l]
          if j > 1
             js = j
             j -= 1
             j1 = 1:j
             # Form the right-hand side corresponding to the dual of (6.2)
             # S = [ S1  s  ]
             #     [ 0  s11 ]
             rbar = view(Wr,j1,1:1)
             v = view(Wv,j1,1:1)
             z = view(Wz,j1,1:1)
             #  rbar = R[j1,l]
             #  v = A[j1,l]*R[l,l]
             #  z = rbar*α' + v*β'
             for ii = 1:j
                 rbar[ii] = R[ii,js]
                 v[ii] = A[ii,js]*R[js,js]
                 z[ii] = rbar[ii]*α' + v[ii]*β[1,1]'
             end
             # Solve S1*ubar*β'+ubar + z = 0
             S1 = view(A,j1,j1)
             sylvds!(S1, -β, z, W; adjA = false, adjB = true)
             # v <- v + S1*z
             #mul!(v, UpperTriangular(S1), z, 1, 1) # involves allocations
             mul!(v, S1, z, 1, 1)
             #  R[j1,l] = ubar
             #  update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             #  y = rbar*β - v * α
             for ii = 1:j
                 R[ii,j+1] = z[ii]
                 rbar[ii] = rbar[ii]*β[1,1] - v[ii]*α
             end
             rqupdate!(view(R,j1,j1), rbar)
          end
       end
   end
   return R
end
"""
    plyapds!(A,E,R;adj = false)

Solve the generalized positive discrete Lyapunov matrix equation

                op(A)Xop(A)' - op(E)Xop(E)' + op(R)*op(R)' = 0

for `X = op(U)*op(U)'`, where `op(K) = K` if `adj = false` and `op(K) = K'` if `adj = true`.
The pair `(A,E)` of square real or complex matrices is in a generalized Schur form
and `R` is an upper triangular matrix. `A-λE` must have only eigenvalues with
moduli less than one. `R` contains on output the upper triangular solution `U`.
"""
function plyapds!(A::AbstractMatrix{T1}, E::Union{AbstractMatrix{T1},UniformScaling{Bool}}, R::UpperTriangular{T1}; adj::Bool = false)  where T1 <: Real
   # The method of [1] for the discrete case is implemented.

   # [1] Penzl, T.
   #     Numerical solution of generalized Lyapunov equations.
   #     Advances in Comp. Math., vol. 8, pp. 33-48, 1998.

   n = LinearAlgebra.checksquare(A)
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) && size(E,1) == n)) && (plyapds!(A, R, adj = adj); return)
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))

   # ONE = one(T1)
   # ZERO = zero(T1)
   # small = safemin(T1)*n*n
   # BIGNUM = ONE / small
   # SMIN = eps(max(maximum(abs.(A)),maximum(abs.(E))))

   ONE = one(T1)
   ZERO = zero(T1)
   TWO = 2*ONE
   EPS = eps(T1)
   SMLNUM = sqrt(_safemin(T1))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))


   # determine the structure of the real Schur form
   ba, p = sfstruct(A)

   WB = Matrix{T1}(undef,n,2)
   WD = Matrix{T1}(undef,n,2)
   Wr = Matrix{T1}(undef,n,2)
   Wv = similar(Wr)
   Wz = similar(Wr)
   Mα = Matrix{T1}(undef,2,2)
   Mβ = Matrix{T1}(undef,2,2)
   η = [ -ONE ZERO; ZERO -ONE]
   if adj
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #     A(L,L)'*X(L,L)*A(L,L) - E(L,L)'*X(L,L)*E(L,L) = -R(L,L)'*R(L,L),
      j = 1
      for ll = 1:p
          dl = ba[ll]
          l = j:j+dl-1
          if dl == 1
             abs(A[j,j]) >= abs(E[j,j]) && error("A-λE must have only eigenvalues with moduli less than one")
             TEMP = sqrt( real((E[j,j] - A[j,j])*(E[j,j] + A[j,j])) )
             TEMP < SMIN && (TEMP = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
                error("Singular generalized discrete Lyapunov equation")
             iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
             R[j,j] = R[j,j]/TEMP
             Mα[1,1] = TEMP/E[j,j]
             Mβ[1,1] = A[j,j]/E[j,j]
          else
            Mβ, Mα = pglyap2!(view(A,l,l), view(E,l,l), view(R,l,l), adj = true, disc = true)
          end
          if ll < p
             dll = 1:dl
             js = j
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             j += dl
             j1 = j:n
             ir1 = 1:n-j+1
             rbar = view(Wr,ir1,dll)
             v = view(Wv,ir1,dll)
             z = view(Wz,ir1,dll)
             # rbar = R[l,j1]'
             transpose!(rbar,view(R,l,j1))
             # Form the right-hand side of (22) in [1]
             # z = -rbar*α - v*β + (R[l,l]*E[l,j1])' 
             # where v = (R[l,l]*A[l,j1])'
             mul!(z, rbar, α)
             rmul!(z,-1)
             k = js+dl-1
             # z <- z + E[l,j1]'*R[l,l]' exploiting upper triangular shape of R
             axpy!(R[k,k],view(E,k,j1),view(z,:,dl))
             dl == 1 || (axpy!(R[js,js],view(E,js,j1),view(z,:,1)); axpy!(R[js,js+1],view(E,js+1,j1),view(z,:,1)))
             # v = (R[l,l]*A[l,j1])'  exploiting upper triangular shape of R
             jj = j
             for ii = 1:n-j+1
                 v[ii,dl] = R[k,k]*A[k,jj]
                 jj += 1
             end               
             if dl == 2
               jj = j
               for ii = 1:n-j+1
                   v[ii,1] = R[js,js]*A[js,jj] + R[js,js+1]*A[js+1,jj]
                   jj += 1
               end
             end
             mul!(z, v, β, -1, 1)

             # Solve S1'*ubar*β+ubar + z = 0
             S1 = view(A,j1,j1)
             gsylvs!(S1, β, view(E,j1,j1), view(η,dll,dll), z, view(WB,j1,1:2), view(WD,j1,1:2); adjAC = true, adjBD = false)
             # R[l,j1] = z'
             transpose!(view(R,l,j1),z)
             #v += S1'*z
             mul!(v, transpose(S1), z, ONE, ONE)
             # update the Cholesky factor R1'*R1 <- R1'*R1 + y'*y
             if dl == 1
                #y = rbar*β - v*α
                rmul!(rbar, β[1,1])
                #LinearAlgebra.axpy!(-α[1,1], v, rbar)
                axpy!(-α[1,1], view(Wv,ir1,1), view(Wr,ir1,1))
             else
                rbar =  ([rbar v]*qr([α; β]).Q)[:,dl+1:end]
             end
             qrupdate!(view(R,j1,j1), rbar)
         end
      end
   else
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #     A(L,L)*X(L,L)*A(L,L)' - E(L,L)*X(L,L)*E(L,L)' = -R(L,L)*R(L,L)',
      j = n
      for ll = p:-1:1
          dl = ba[ll]
          l = j-dl+1:j
          if dl == 1
             abs(A[j,j]) >= abs(E[j,j]) && error("A-λE must have only eigenvalues with moduli less than one")
             TEMP = sqrt( real((E[j,j] - A[j,j])*(E[j,j] + A[j,j])) )
             TEMP < SMIN && (TEMP = SMIN)
             DR = abs( R[j,j] )
             TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
                error("Singular generalized discrete Lyapunov equation")
             iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
             R[j,j] = R[j,j]/TEMP
             Mα[1,1] = TEMP/E[j,j]
             Mβ[1,1] = A[j,j]/E[j,j]
          else
             Mβ, Mα = pglyap2!(view(A,l,l), view(E,l,l), view(R,l,l), adj = false, disc = true)
          end
          if ll > 1
             dll = 1:dl
             js = j
             α = view(Mα,dll,dll)
             β = view(Mβ,dll,dll)
             j -= dl
             j1 = 1:j
             # Form the right-hand side corresponding to the dual of (6.2)
             # S = [ S1  s  ]
             #     [ 0  s11 ]
             # z = rbar*α' + s*u11
             rbar = view(Wr,j1,dll)
             v = view(Wv,j1,dll)
             z = view(Wz,j1,dll)
             #rbar = R[j1,l]
             copyto!(rbar,view(R,j1,l))
             #v = A[j1,l]*R[l,l]
             k = js-dl+1
             for ii = 1:j
                 v[ii,1] = R[k,k]*A[ii,k]
             end               
             if dl == 2
               for ii = 1:j
                   v[ii,2] = R[js-1,js]*A[ii,js-1] + R[js,js]*A[ii,js]
               end
             end
             #z = -rbar*α' - v*β' + E[j1,l]*R[l,l]
             mul!(z, rbar, transpose(α))
             mul!(z, v, transpose(β), -1, -1)
             axpy!(R[k,k],view(E,j1,k),view(z,:,1))
             dl == 1 || (axpy!(R[js-1,js],view(E,j1,js-1),view(z,:,2)); axpy!(R[js,js],view(E,j1,js),view(z,:,2)))

             # Solve S1*ubar*β'+ubar + z = 0
             S1 = view(A,j1,j1)
             gsylvs!(S1, β, view(E,j1,j1), view(η,dll,dll), z, view(WB,j1,1:2), view(WD,j1,1:2); adjAC = false, adjBD = true)
             #R[j1,l] = z
             copyto!(view(R,j1,l),z)
             # update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             #v += S1*ubar
             mul!(v, S1, z, ONE, ONE)
             if dl == 1
                # y = rbar*β - v*α
                rmul!(rbar, β[1,1])
                axpy!(-α[1,1], view(Wv,j1,1), view(Wr,j1,1))
             else
                rbar =  ([rbar v]*qr([α'; β']).Q)[:,dl+1:end]
             end
             rqupdate!(view(R,j1,j1), rbar)
          end
       end
   end
   return R
end
function plyapds!(A::AbstractMatrix{T1}, E::Union{AbstractMatrix{T1},UniformScaling{Bool}}, R::UpperTriangular{T1}; adj = false)  where T1 <: Complex
   n = LinearAlgebra.checksquare(A)
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) && size(E,1) == n)) && (plyapds!(A, R, adj = adj); return)
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
   LinearAlgebra.checksquare(R) == n || throw(DimensionMismatch("R must be a $n x $n upper triangular matrix"))

   # T = real(T1)
   # ONE = one(T)
   # small = safemin(T)*n*n
   # BIGNUM = ONE / small
   # SMIN = eps(max(maximum(abs.(A)),maximum(abs.(E))))

   T = real(T1)
   ONE = one(T)
   ZERO = zero(T)
   TWO = 2*ONE
   EPS = eps(T)
   SMLNUM = sqrt(_safemin(T))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))

   WB = Vector{T1}(undef,n)
   WD = Vector{T1}(undef,n)
   Wr = Matrix{T1}(undef,n,1)
   Wv = similar(Wr)
   Wz = similar(Wr)
   η  = complex(fill(-ONE,(1,1)))
   if adj
     # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #      A(L,L)'*X(L,L)*A(L,L) - E(L,L)'*X(L,L)*E(L,L) = -R(L,L)'*R(L,L),
      for j = 1:n
          abs(A[j,j]) >= abs(E[j,j]) && error("A-λE must have only eigenvalues with moduli less than one")
          TEMP = sqrt( real((E[j,j]' - A[j,j]')*(E[j,j] + A[j,j])) )
          TEMP < SMIN && (TEMP = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
             error("Singular generalized discrete Lyapunov equation")
          iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
          R[j,j] = R[j,j]/TEMP
          l = j:j
          β = A[l,l]/E[j,j]
          α = TEMP/E[j,j]
          if j < n
             js = j
             j += 1
             j1 = j:n
             ir1 = 1:n-j+1
             rbar = view(Wr,ir1,1:1)
             v = view(Wv,ir1,1:1)
             z = view(Wz,ir1,1:1)
             # Form the right-hand side of (10.16)
             # rbar = R[l,j1]'
             # v = R[l,l]*A[l,j1]'
             # z = rbar*α + A[l,j1]'*R[l,l]*β - E[l,j1]'*R[l,l]
             k = j
             for ii = 1:n-j+1
                 rbar[ii] = R[js,k]'
                 v[ii] = R[js,js]*A[js,k]'
                 z[ii] = -(rbar[ii]*α - R[js,js]*E[js,k]' + v[ii]*β[1,1])
                 k += 1
             end  
             # Solve S1'*ubar*β+ubar + z = 0
             S1 = view(A,j1,j1)
             gsylvs!(S1, β, view(E,j1,j1), η, z, view(WB,j1), view(WD,j1); adjAC = true, adjBD = false)
             # v <- v + S1'*z
             #mul!(v, UpperTriangular(S1)', z, 1, 1)
             mul!(v, S1', z, 1, 1)  # no allocations
             #  R[l,j1] = z'
             #  update the Cholesky factor R1'*R1 <- R1'*R1 + y'*y
             #  y = conj(rbar*β' - v * α')
             k = j
             t = β[1,1]'
             for ii = 1:n-j+1
                R[js,k] = z[ii]'
                rbar[ii] = conj(rbar[ii] * t - v[ii] * α')
                k += 1
             end
             qrupdate!(view(R,j1,j1), rbar)
          end
      end
   else
      # The (L,L)th block of X is determined starting from
      # upper-left corner column by column by
      #     A(L,L)*X(L,L)*A(L,L)' - E(L,L)*X(L,L)*E(L,L)' = -R(L,L)*R(L,L)',
      for j = n:-1:1
          abs(A[j,j]) >= abs(E[j,j]) && error("A-λE must have only eigenvalues with moduli less than one")
          TEMP = sqrt( real((E[j,j]' - A[j,j]')*(E[j,j] + A[j,j])) )
          TEMP < SMIN && (TEMP = SMIN)
          DR = abs( R[j,j] )
          TEMP < ONE && DR > ONE && DR > BIGNUM*TEMP &&
            error("Singular generalized discrete Lyapunov equation")
          iszero(DR) || (TEMP = sign(R[j,j])*TEMP)
          R[j,j] = R[j,j]/TEMP
          l = j:j
          β = A[l,l]/E[j,j]
          α = TEMP/E[j,j]
          if j > 1
             js = j
             j -= 1
             j1 = 1:j
             # Form the right-hand side corresponding to the dual of (6.2)
             # S = [ S1  s  ]
             #     [ 0  s11 ]
             rbar = view(Wr,j1,1:1)
             v = view(Wv,j1,1:1)
             z = view(Wz,j1,1:1)
             #  rbar = R[j1,l]
             #  v = A[j1,l]*R[l,l]
             #  z = rbar*α + A[j1,l]*R[l,l]*β' - E[j1,l]*R[l,l]
             for ii = 1:j
                 rbar[ii] = R[ii,j+1]
                 v[ii] = A[ii,js]*R[js,js]
                 z[ii] = -rbar[ii]*α' + E[ii,js]*R[js,js] - v[ii]*β[1,1]'
             end
             # Solve S1*ubar*β'+ubar + z = 0
             S1 = view(A,j1,j1)
             gsylvs!(S1, β, view(E,j1,j1), η, z, view(WB,j1), view(WD,j1); adjAC = false, adjBD = true)
             # v <- v + S1*z
             #mul!(v, UpperTriangular(S1), z, 1, 1)
             mul!(v, S1, z, 1, 1)  # no allocations
             #  R[j1,l] = z
             #  update the Cholesky factor R1*R1' <- R1*R1' + y*y'
             #  y = rbar*β - v * α
             for ii = 1:j
                 R[ii,j+1] = z[ii]
                 rbar[ii] = rbar[ii] * β[1,1] - v[ii]*α
             end
             rqupdate!(view(R,j1,j1), rbar)
          end
       end
   end
   return R
end
"""
    plyap2!(A, R; adj = false, disc = false) -> (β, α)

Solve for the Cholesky factor  `U`  of  `X`,

     op(U)*op(U)' = X,

where  `U`  is a two-by-two upper triangular matrix, either the
continuous-time two-by-two Lyapunov equation

      op(A)*X + X*op(A)' = -op(R)*op(R)',

when disc = false, or the discrete-time two-by-two Lyapunov equation

      op(A)*X*op(A)' - X = -op(R)*op(R)',

when `disc = true`, where `op(K) = K` if `adj = false` or `op(K) = K'`
if `adj = true`,  `A`  is a two-by-two matrix with complex conjugate eigenvalues,
`R`  is a two-by-two upper triangular matrix.
The routine also computes two matrices, `β` and `α`, so that

      U*A = β*U  and  U*α = R,  if  adj = false, or

      β*U = U*A  and  α*U = R,  if  adj = true,

which are used by the general Lyapunov solver. The computed `U` is returned in `R`.

In the continuous-time case  `A`  must be stable, so that its
eigenvalues must have strictly negative real parts.
In the discrete-time case  `A`  must be convergent, that is, its eigenvalues
must have moduli less than one. These conditions are checked and
an error message is issued if not fulfilled.

If the Lyapunov equation is numerically singular, then small perturbations in `A` can make
one or more of the eigenvalues have a non-negative real part, if `disc = false`, or
can make one or more of the eigenvalues lie outside the unit circle, if `disc = true`.
If this situation is detected, an error message is issued.
"""
function plyap2!(A::AbstractMatrix{T}, R::AbstractMatrix{T}; adj = false, disc = false) where T<:Real
   # This function is based on the SLICOT routine SB03OY, which implements the
   # the LAPACK scheme for solving 2-by-2 Sylvester equations, adapted in [1]
   # for 2-by-2 Lyapunov equations, but directly computing the Cholesky factor
   # of the solution.

   # [1] Hammarling S. J.
   #     Numerical solution of the stable, non-negative definite Lyapunov equation.
   #     IMA J. Num. Anal., 2, pp. 303-325, 1982.

   errtext = "Singular Lyapunov equation"
   ZERO = zero(T)
   ONE = one(T)
   TWO = 2*ONE
   small = 2*sqrt(_safemin(T))
   BIGNUM = ONE / small
   SMIN = eps(maximum(abs.(A)))
   noadj = !adj
   β = similar(A)
   α = similar(A)
   S11 = A[1,1]
   S12 = A[1,2]
   S21 = A[2,1]
   S22 = A[2,2]
   #TEMPR, TEMPI, E1, E2, CSP, CSQ = LapackUtil.lanv2( S11, S12, S21, S22)
   TEMPR, TEMPI, E1, E2 = _lanv2( S11, S12, S21, S22)
   TEMPI == ZERO && error("A has real eigenvalues")
   ABSB = hypot(E1,E2)
   if disc
      ABSB >= ONE && error("A is not convergent")
   else
      E1 >= ZERO && error("A is not stable")
   end
   #     Compute the cos and sine that define  Qhat.  The sine is real.
   TEMP1 = S11 - E1
   noadj ? TEMP2 = -E2 : TEMP2 =  E2
   CSQR, CSQI, SNQ = cgivens2( TEMP1, TEMP2, S21, small )
   #     beta in (6.9) is given by  beta = E1 + i*E2,  compute  t.
   TEMP1 = CSQR*S12 - SNQ*S11
   TEMP2 = CSQI*S12
   TEMPR   = CSQR*S22 - SNQ*S21
   TEMPI   = CSQI*S22
   T1      = CSQR*TEMP1 - CSQI*TEMP2 + SNQ*TEMPR
   T2      = CSQR*TEMP2 + CSQI*TEMP1 + SNQ*TEMPI
   if noadj
      #                                                        (     -- )
      #        Case op(M) = M.  Note that the modified  R  is  ( p3  p2 ).
      #                                                        ( 0   p1 )
      #
      #        Compute the cos and sine that define  Phat.
      #
      TEMP1 =  CSQR*R[2,2] - SNQ*R[1,2]
      TEMP2 = -CSQI*R[2,2]
      CSPR, CSPI, SNP, P1 = cgivens2( TEMP1, TEMP2, -SNQ*R[1,1], small )
      #    Compute p1, p2 and p3 of the relation corresponding to (6.11).
      TEMP1 =  CSQR*R[1,2] + SNQ*R[2,2]
      TEMP2 = -CSQI*R[1,2]
      TEMPR   =  CSQR*R[1,1]
      TEMPI   = -CSQI*R[1,1]
      P2R     =  CSPR*TEMP1 - CSPI*TEMP2 + SNP*TEMPR
      P2I     = -CSPR*TEMP2 - CSPI*TEMP1 - SNP*TEMPI
      P3R     =  CSPR*TEMPR   + CSPI*TEMPI   - SNP*TEMP1
      P3I     =  CSPR*TEMPI   - CSPI*TEMPR   - SNP*TEMP2
   else
      #     Case op(M) = M'.
      #     Compute the cos and sine that define  Phat.
      TEMP1 = CSQR*R[1,1] + SNQ*R[1,2]
      TEMP2 = CSQI*R[1,1]
      CSPR, CSPI, SNP, P1 = cgivens2( TEMP1, TEMP2, SNQ*R[2,2], small  )
      #     Compute p1, p2 and p3 of (6.11).
      TEMP1 = CSQR*R[1,2] - SNQ*R[1,1]
      TEMP2 = CSQI*R[1,2]
      TEMPR   = CSQR*R[2,2]
      TEMPI   = CSQI*R[2,2]
      P2R     = CSPR*TEMP1 - CSPI*TEMP2 + SNP*TEMPR
      P2I     = CSPR*TEMP2 + CSPI*TEMP1 + SNP*TEMPI
      P3R     = CSPR*TEMPR   + CSPI*TEMPI   - SNP*TEMP1
      P3I     = CSPI*TEMPR   - CSPR*TEMPI   + SNP*TEMP2
   end
   #  Make  p3  real by multiplying by  conjg ( p3 )/abs( p3 )  to give
   #  p3 := abs( p3 ).
   if P3I == ZERO
      P3  = abs( P3R )
      DP1 = copysign( ONE, P3R )
      DP2 = ZERO
   else
      P3  =  hypot(P3R,P3I)
      DP1 =  P3R/P3
      DP2 = -P3I/P3
   end
   #  Now compute the quantities v1, v2, v3 and y in (6.13) - (6.15),
   #  or (10.23) - (10.25). Care is taken to avoid overflows.
   if disc
      ALPHA = sqrt( abs( ONE - ABSB )*( ONE + ABSB ) )
   else
      ALPHA = sqrt( abs( TWO*E1 ) )
   end

   ALPHA < SMIN && (ALPHA = SMIN)
   ABST = abs( P1 )
   ALPHA < ONE && ABST > ONE && ABST > BIGNUM*ALPHA && error("$errtext")
   V1 = P1/ALPHA

   if disc
      G1 = (ONE - E1 )*( ONE + E1 ) + E2*E2
      G2 = -TWO*E1*E2
      ABSG =  hypot(G1,G2)
      ABSG < SMIN && (ABSG = SMIN)
      TEMP1 = ALPHA*P2R + V1*( E1*T1 - E2*T2 )
      TEMP2 = ALPHA*P2I + V1*( E1*T2 + E2*T1 )
      ABST    = max( abs( TEMP1 ), abs( TEMP2 ) )
      ABSG < ONE  &&  ABST > ONE && ABST > BIGNUM*ABSG && error("$errtext")
      TEMP1 = TEMP1/ABSG
      TEMP2 = TEMP2/ABSG

      V2R    = G1*TEMP1 + G2*TEMP2
      V2I    = G1*TEMP2 - G2*TEMP1
      ABST   = max( abs( V2R ), abs( V2I ) )
      ABSG < ONE  &&  ABST > ONE && ABST > BIGNUM*ABSG && error("$errtext")
      V2R = V2R/ABSG
      V2I = V2I/ABSG

      TEMP1 = P1*T1 - TWO*E2*P2I
      TEMP2 = P1*T2 + TWO*E2*P2R
      ABST    = max( abs( TEMP1 ), abs( TEMP2 ) )
      ABSG < ONE  &&  ABST > ONE && ABST > BIGNUM*ABSG && error("$errtext")
      TEMP1 = TEMP1/ABSG
      TEMP2 = TEMP2/ABSG

      YR  = -( G1*TEMP1 + G2*TEMP2 )
      YI  = -( G1*TEMP2 - G2*TEMP1 )
      ABST    = max( abs( YR ), abs( YI ) )
      ABSG < ONE  &&  ABST > ONE && ABST > BIGNUM*ABSG && error("$errtext")
      YR = YR/ABSG
      YI = YI/ABSG
   else
      ABSB < SMIN && (ABSB = SMIN)
      TEMP1 = ALPHA*P2R + V1*T1
      TEMP2 = ALPHA*P2I + V1*T2
      ABST    = max( abs( TEMP1 ), abs( TEMP2 ) )
      ABSB < ONE  &&  ABST > ONE && ABST > BIGNUM*ABSB && error("$errtext")
      TEMP1 = TEMP1/( TWO*ABSB )
      TEMP2 = TEMP2/( TWO*ABSB )
      V2R     =  -(E1*TEMP1 + E2*TEMP2)
      V2I     =  -(E1*TEMP2 - E2*TEMP1)
      ABST = max( abs( V2R ), abs( V2I ) )
      ABSB < ONE  &&  ABST > ONE &&  ABST > BIGNUM*ABSB && error("$errtext")
      V2R = V2R/ABSB
      V2I = V2I/ABSB
      YR  = P2R - ALPHA*V2R
      YI  = P2I - ALPHA*V2I
   end

   V3     = hypot3(P3,YR,YI)
   ALPHA < ONE  &&  V3 > ONE && V3 > BIGNUM*ALPHA && error("$errtext")
   V3 = V3/ALPHA

   if noadj
      #     Case op(M) = M.
      #     Form  X = conjg( Qhat' )*v11.
      X11R   =  CSQR*V3
      X11I   =  CSQI*V3
      X21R   =  SNQ*V3
      X21I   =  ZERO
      X12R   =  CSQR*V2R+CSQI*V2I-SNQ*V1
      X12I   = -CSQR*V2I+CSQI*V2R
      X22R   =  CSQR*V1 + SNQ*V2R
      X22I   = -CSQI*V1 - SNQ*V2I
      #     Obtain u11 from the RQ-factorization of X. The conjugate of
      #     X22 should be taken.
      X22I = -X22I
      CSTR, CSTI, SNT, TMP = cgivens2( X22R, X22I, X21R, small )
      U22 = TMP
      U12 = CSTR*X12R - CSTI*X12I + SNT*X11R
      TEMPR  = CSTR*X11R + CSTI*X11I - SNT*X12R
      TEMPI  = CSTR*X11I - CSTI*X11R - SNT*X12I
      if TEMPI == ZERO
         U11 = abs( TEMPR )
         DT1    = copysign( ONE, TEMPR )
         DT2    = ZERO
      else
         U11 =  hypot(TEMPR,TEMPI)
         DT1    =  TEMPR/U11
         DT2    = -TEMPI/U11
      end
   else
      #     Case op(M) = M'.
      #     Now form  X = v11*conjg( Qhat' ).
      X11R   =  CSQR*V1 - SNQ*V2R
      X11I   = -CSQI*V1 + SNQ*V2I
      X21R   = -SNQ*V3
      X21I   =  ZERO
      X12R   =  CSQR*V2R + CSQI*V2I + SNQ*V1
      X12I   = -CSQR*V2I + CSQI*V2R
      X22R   =  CSQR*V3
      X22I   =  CSQI*V3
      #     Obtain u11 from the QR-factorization of X.
      CSTR, CSTI, SNT, TMP = cgivens2( X11R, X11I, X21R, small  )
      U11 = TMP
      U12 = CSTR*X12R + CSTI*X12I + SNT*X22R
      TEMPR  = CSTR*X22R - CSTI*X22I - SNT*X12R
      TEMPI  = CSTR*X22I + CSTI*X22R - SNT*X12I
      if TEMPI == ZERO
         U22 = abs( TEMPR )
         DT1    = copysign( ONE, TEMPR )
         DT2    = ZERO
      else
         U22 =  hypot(TEMPR,TEMPI)
         DT1    =  TEMPR/U22
         DT2    = -TEMPI/U22
      end
   end
   #  The computations below are not needed when β and α are not
   #  useful. Compute delta, eta and gamma as in (6.21) or (10.26).
   if abs( YR ) < small  && abs( YI ) <= small
      DELTA1 = ZERO
      DELTA2 = ZERO
      GAMMA1 = ZERO
      GAMMA2 = ZERO
      ETA = ALPHA
   else
      DELTA1 =  YR/V3
      DELTA2 =  YI/V3
      GAMMA1 =  -ALPHA*DELTA1
      GAMMA2 =  -ALPHA*DELTA2
      ETA = P3/V3
      if disc
         TEMPR  = E1*DELTA1 - E2*DELTA2
         DELTA2 = E1*DELTA2 + E2*DELTA1
         DELTA1 = TEMPR
      end
   end
   if noadj
      #     Case op(M) = M.
      #     Find  X = conjg( That' )*( inv( v11 )*s11hat*v11 ).
      #     ( Defer the scaling.)
      X11R =  CSTR*E1 + CSTI*E2
      X11I = -CSTR*E2 + CSTI*E1
      X21R =  SNT*E1
      X21I = -SNT*E2
      X12R =  CSTR*GAMMA1 + CSTI*GAMMA2 - SNT*E1
      X12I = -CSTR*GAMMA2 + CSTI*GAMMA1 - SNT*E2
      X22R =  CSTR*E1 + CSTI*E2 + SNT*GAMMA1
      X22I =  CSTR*E2 - CSTI*E1 - SNT*GAMMA2
      #     Now find  B = X*That. ( Include the scaling here.)
      β[1,1] = CSTR*X11R + CSTI*X11I - SNT*X12R
      TEMPR  = CSTR*X21R + CSTI*X21I - SNT*X22R
      TEMPI  = CSTR*X21I - CSTI*X21R - SNT*X22I
      β[2,1] = DT1*TEMPR   - DT2*TEMPI
      TEMPR  = CSTR*X12R - CSTI*X12I + SNT*X11R
      TEMPI  = CSTR*X12I + CSTI*X12R + SNT*X11I
      β[1,2] = DT1*TEMPR   + DT2*TEMPI
      β[2,2] = CSTR*X22R - CSTI*X22I + SNT*X21R
      #     Form  X = ( inv( v11 )*p11 )*conjg( Phat' ).
      TEMPR  =  DP1*ETA
      TEMPI  = -DP2*ETA
      X11R =  CSPR*TEMPR - CSPI*TEMPI + SNP*DELTA1
      X11I =  CSPR*TEMPI + CSPI*TEMPR - SNP*DELTA2
      X21R =  SNP*ALPHA
      X12R = -SNP*TEMPR + CSPR*DELTA1 - CSPI*DELTA2
      X12I = -SNP*TEMPI - CSPR*DELTA2 - CSPI*DELTA1
      X22R =  CSPR*ALPHA
      X22I = -CSPI*ALPHA
      #     Finally form  A = conjg( That' )*X.
      TEMPR  = CSTR*X11R - CSTI*X11I - SNT*X21R
      TEMPI  = CSTR*X22I + CSTI*X22R
      α[1,1] = DT1*TEMPR   + DT2*TEMPI
      TEMPR  = CSTR*X12R - CSTI*X12I - SNT*X22R
      TEMPI  = CSTR*X12I + CSTI*X12R - SNT*X22R
      α[1,2] = DT1*TEMPR   + DT2*TEMPI
      α[2,1] = ZERO
      α[2,2] = CSTR*X22R + CSTI*X22I + SNT*X12R
   else
      #     Case op(M) = M'.
      #     Find  X = That*( v11*s11hat*inv( v11 ) ). ( Defer the scaling.)
      X11R =  CSTR*E1 + CSTI*E2
      X11I =  CSTR*E2 - CSTI*E1
      X21R = -SNT*E1
      X21I = -SNT*E2
      X12R =  CSTR*GAMMA1 - CSTI*GAMMA2 + SNT*E1
      X12I = -CSTR*GAMMA2 - CSTI*GAMMA1 - SNT*E2
      X22R =  CSTR*E1 + CSTI*E2 - SNT*GAMMA1
      X22I = -CSTR*E2 + CSTI*E1 + SNT*GAMMA2
      #     Now find  B = X*conjg( That' ). ( Include the scaling here.)
      β[1,1] = CSTR*X11R - CSTI*X11I + SNT*X12R
      TEMPR  = CSTR*X21R - CSTI*X21I + SNT*X22R
      TEMPI  = CSTR*X21I + CSTI*X21R + SNT*X22I
      β[2,1] = DT1*TEMPR   - DT2*TEMPI
      TEMPR  = CSTR*X12R + CSTI*X12I - SNT*X11R
      TEMPI  = CSTR*X12I - CSTI*X12R - SNT*X11I
      β[1,2] = DT1*TEMPR   + DT2*TEMPI
      β[2,2] = CSTR*X22R + CSTI*X22I - SNT*X21R
      #     Form  X = Phat*( p11*inv( v11 ) ).
      TEMPR  =  DP1*ETA
      TEMPI  = -DP2*ETA
      X11R =  CSPR*ALPHA
      X11I =  CSPI*ALPHA
      X21R =  SNP*ALPHA
      X12R =  CSPR*DELTA1 + CSPI*DELTA2 - SNP*TEMPR
      X12I = -CSPR*DELTA2 + CSPI*DELTA1 - SNP*TEMPI
      X22R =  CSPR*TEMPR + CSPI*TEMPI + SNP*DELTA1
      X22I =  CSPR*TEMPI - CSPI*TEMPR - SNP*DELTA2
      #     Finally form  A = X*conjg( That' ).
      α[1,1] = CSTR*X11R - CSTI*X11I + SNT*X12R
      α[2,1] = ZERO
      α[1,2] = CSTR*X12R + CSTI*X12I - SNT*X11R
      TEMPR  = CSTR*X22R + CSTI*X22I - SNT*X21R
      TEMPI  = CSTR*X22I - CSTI*X22R
      α[2,2] = DT1*TEMPR   + DT2*TEMPI
   end

   R[1,1] = U11
   R[1,2] = U12
   R[2,2] = U22
   return β, α
end
"""
    pglyap2!(A, E, R; adj = false, disc = false) -> (β, α)

Solve for the Cholesky factor  `U`  of  `X`,

     op(U)*op(U)' = X,

where  `U`  is a two-by-two upper triangular matrix, either the
continuous-time two-by-two generalized Lyapunov equation

      op(A)*X*op(E)' + op(E)*X*op(A)' = -op(R)*op(R)',

when disc = false, or the discrete-time two-by-two Lyapunov equation

      op(A)*X*op(A)' - op(E)*X*op(E)' = -op(R)*op(R)',

when `disc = true`, where `op(K) = K` if `adj = false` or `op(K) = K'`
if `adj = true`,  `A` and `E` are two-by-two matrices such that the pencil `A-λE`
has complex conjugate eigenvalues and `R`  is a two-by-two upper triangular matrix.
The routine also computes two matrices, `β` and `α`, so that,
for `adj = true`:

      β*U*E = U*A
      α*U*E = R

for `adj = false`:

      E*U*β = A*U
      E*U*α = R
      α = R'*inv(E')*inv(U')

which are used by the general Lyapunov solver.

The pencil `A-λE` must have a pair of complex conjugate eigenvalues.
In the continuous-time case the eigenvalues must have strictly negative
real parts, while, in the discrete-time case, the eigenvalues must have
moduli less than unity. These conditions are checked and
an error message is issued if not fulfilled.

If the Lyapunov equation is numerically singular, then small perturbations in `A` or `E`
can make one or more of the eigenvalues have a non-negative real part, if `disc = false`, or
can make one or more of the eigenvalues lie outside the unit circle, if `disc = true`.
If this situation is detected, an error message is issued.
"""
function pglyap2!(A::AbstractMatrix{T1}, E::AbstractMatrix{T1}, R::AbstractMatrix{T1}; adj = false, disc = false) where T1 <: Real
   # This function is based on the SLICOT routine SG03BX, which implements the
   # generalization of the method due to Hammarling ([1], section 6) for Lyapunov
   # equations of order 2. A more detailed description is given in [2].
   # The 2x2 matrix is allowed to be a full matrix.

   # [1] Hammarling S. J.
   #     Numerical solution of the stable, non-negative definite Lyapunov equation.
   #     IMA J. Num. Anal., 2, pp. 303-325, 1982.
   # [2] Penzl, T.
   #     Numerical solution of generalized Lyapunov equations.
   #     Advances in Comp. Math., vol. 8, pp. 33-48, 1998.

   errtext = "Singular Lyapunov equation"

   # ZERO = zero(T1)
   # ONE = one(T1)
   # TWO = 2*ONE
   # SMLNUM = smlnum(T1)
   # EPS = eps(T1)
   # small = 2*SMLNUM/EPS
   # BIGNUM = ONE / small
   # SMIN = EPS*maximum(abs.(A))

   ONE = one(T1)
   ZERO = zero(T1)
   TWO = 2*ONE
   EPS = eps(T1)
   SMLNUM = sqrt(_safemin(T1))/EPS
   BIGNUM = ONE / SMLNUM
   SMIN = EPS*maximum(abs.(A))
   small = SMLNUM

   #scale = ONE
   noadj = !adj
   ISCONT = !disc
   #U = similar(R)
   #U[2,1] = ZERO
   β = similar(A)
   AA  = similar(A)
   EE  = similar(E)
   RR  = similar(R)
   QBR = similar(A)
   QBI = similar(A)
   QUR = similar(A)
   QUI = similar(A)
   UR = similar(A)
   UI = similar(A)
   M1R = similar(A)
   M1I = similar(A)
   M2R = similar(A)
   M2I = similar(A)
   β = similar(A)
   α = similar(R)
   # Make copies of A, E, and B.
   AA = copy(A)
   EE = copy(E)
   RR = copy(R)
   if noadj
      V = AA[1,1]
      AA[1,1] = AA[2,2]
      AA[2,2] = V
      V = EE[1,1]
      EE[1,1] = EE[2,2]
      EE[2,2] = V
      V = RR[1,1]
      RR[1,1] = RR[2,2]
      RR[2,2] = V
   end
   if iszero(EE[2,1])
      # handle the case when EE is upper triangular (required by lag2)
      scale1, scale2, LAMR, W, LAMI = _lag2(AA,EE,small)
   else
      # handle the case when EE is full
      E1 = copy(EE)
      G, E1[1,1] = givens(E1[1,1],E1[2,1],1,2)
      lmul!(G,view(E1,:,2)); E1[2,1] = ZERO
      scale1, scale2, LAMR, W, LAMI = _lag2(lmul!(G,copy(AA)),E1,small)
   end
   LAMI == ZERO && error("The pair (A,E) has real generalized eigenvalues")
   # Compute right orthogonal transformation matrix Q (modified to cope with nonzero E[2,1])
   @inbounds CR, CI, SR, SI, L =  cgivensc2( scale1*AA[1,1] - EE[1,1]*LAMR,
                                   -EE[1,1]*LAMI, scale1*AA[2,1] - EE[2,1]*LAMR, -EE[2,1]*LAMI, small )
   QR = [ CR SR; -SR CR ]
   QI = [ -CI  -SI; -SI CI ]
   #  A := Q * A
   AR = QR*AA
   AI = QI*AA
   #  E := Q * E
   ER = QR*EE
   EI = QI*EE
   # Compute left orthogonal transformation matrix Z.
   @inbounds CR, CI, SR, SI, L =  cgivensc2( ER[2,2], EI[2,2], ER[2,1], EI[2,1], small )
   ZR =  [ CR SR; -SR CR ]
   ZI =  [ CI -SI; -SI -CI ]
   # E := E * Z
   @inbounds TR = ER[1:1,:]*ZR - EI[1:1,:]*ZI
   @inbounds TI = ER[1:1,:]*ZI + EI[1:1,:]*ZR
   @inbounds ER[1:1,:] = TR
   @inbounds EI[1:1,:] = TI
   ER[2,1] = ZERO
   ER[2,2] = L
   EI[2,1] = ZERO
   EI[2,2] = ZERO

   # Make main diagonal entries of E real and positive.
   @inbounds V = hypot( ER[1,1], EI[1,1] )
   @inbounds XR, XI = _ladiv(V, ZERO, ER[1,1], EI[1,1])
   ER[1,1] = V
   EI[1,1] = ZERO
   YR = ZR[1,1]
   YI = ZI[1,1]
   ZR[1,1] = XR*YR - XI*YI
   ZI[1,1] = XR*YI + XI*YR
   YR = ZR[2,1]
   YI = ZI[2,1]
   ZR[2,1] = XR*YR - XI*YI
   ZI[2,1] = XR*YI + XI*YR
   # A := A * Z
   @inbounds TR = AR*ZR - AI*ZI
   @inbounds AI = AI*ZR + AR*ZI
   @inbounds AR = TR
   # End of QZ-step.
   @inbounds BR = RR*ZR
   @inbounds BI = RR*ZI
   # Overwrite B with the upper triangular matrix of its
   # QR-factorization. The elements on the main diagonal are real
   # and non-negative.
   @inbounds CR, CI, SR, SI, L = cgivensc2( BR[1,1], BI[1,1], BR[2,1], BI[2,1], small )
   QBR[1,1] =  CR
   QBR[1,2] =  SR
   QBR[2,1] = -SR
   QBR[2,2] =  CR
   QBI[1,1] = -CI
   QBI[1,2] = -SI
   QBI[2,1] = -SI
   QBI[2,2] =  CI
   @inbounds TR = QBR*BR[:,2] - QBI*BI[:,2]
   @inbounds TI = QBI*BR[:,2] + QBR*BI[:,2]
   @inbounds BR[:,2] = TR
   @inbounds BI[:,2] = TI
   BR[1,1] = L
   BR[2,1] = ZERO
   BI[1,1] = ZERO
   BI[2,1] = ZERO
   V = hypot( BR[2,2], BI[2,2] )
   if V >= max( EPS*max( BR[1,1], hypot( BR[1,2], BI[1,2] ) ), SMLNUM )
      XR, XI = _ladiv( V, ZERO, BR[2,2], BI[2,2] )
      BR[2,2] = V
      YR = QBR[2,1]
      YI = QBI[2,1]
      QBR[2,1] = XR*YR - XI*YI
      QBI[2,1] = XR*YI + XI*YR
      YR = QBR[2,2]
      YI = QBI[2,2]
      QBR[2,2] = XR*YR - XI*YI
      QBI[2,2] = XR*YI + XI*YR
   else
      BR[2,2] = ZERO
   end
   BI[2,2] = ZERO

   # Compute the Cholesky factor of the solution of the reduced
   # equation. The solution may be scaled to avoid overflow.

   if ISCONT

      # Continuous-time equation.

      # Step I:  Compute U[1,1]. Set U[2,1] = 0.
      V = -TWO*( AR[1,1]*ER[1,1] + AI[1,1]*EI[1,1] )
      V <= ZERO && error("The eigenvalues of the pencil A - λE  are not in the open right half plane")
      V = sqrt( V )
      T = TWO*abs( BR[1,1] )*SMLNUM
      T > V && error("$errtext")
      UR[1,1] = BR[1,1]/V
      UI[1,1] = ZERO
      UR[2,1] = ZERO
      UI[2,1] = ZERO

      # Step II:  Compute U[1,2].

      T = max( EPS*max( BR[2,2], hypot( BR[1,2], BI[1,2] ) ), SMLNUM )
      if abs( BR[1,1] ) < T
         UR[1,2] = ZERO
         UI[1,2] = ZERO
      else
         XR = AR[1,1]*ER[1,2] + AI[1,1]*EI[1,2]
         XI = AI[1,1]*ER[1,2] - AR[1,1]*EI[1,2]
         XR = XR + AR[1,2]*ER[1,1] + AI[1,2]*EI[1,1]
         XI = XI - AI[1,2]*ER[1,1] + AR[1,2]*EI[1,1]
         XR = -BR[1,2]*V - XR*UR[1,1]
         XI =  BI[1,2]*V - XI*UR[1,1]
         YR =  AR[2,2]*ER[1,1] + AI[2,2]*EI[1,1]
         YI = -AI[2,2]*ER[1,1] + AR[2,2]*EI[1,1]
         YR = YR + ER[2,2]*AR[1,1] + EI[2,2]*AI[1,1]
         YI = YI - EI[2,2]*AR[1,1] + ER[2,2]*AI[1,1]
         T  = TWO*hypot( XR, XI )*SMLNUM
         T > hypot( YR, YI ) && error("$errtext")
         UR[1,2], UI[1,2] = _ladiv( XR, XI, YR, YI )
         UI[1,2] = -UI[1,2]
      end

      # Step III:  Compute U[2,2].

      XR = ( ER[1,2]*UR[1,1] + ER[2,2]*UR[1,2] - EI[2,2]*UI[1,2] )*V
      XI = (-EI[1,2]*UR[1,1] - ER[2,2]*UI[1,2] - EI[2,2]*UR[1,2] )*V
      T  = TWO*hypot( XR, XI )*SMLNUM
      T > hypot( ER[1,1], EI[1,1] ) && error("$errtext")
      YR, YI = _ladiv( XR, XI, ER[1,1], -EI[1,1] )
      YR =  BR[1,2] - YR
      YI = -BI[1,2] - YI
      V  = -TWO*( AR[2,2]*ER[2,2] + AI[2,2]*EI[2,2] )
      V <= ZERO && error("The eigenvalues of the pencil A - λE have no negative real parts")
      V = sqrt( V )
      W = hypot4( BR[2,2], BI[2,2], YR, YI )
      T = TWO*W*SMLNUM
      T > V && error("$errtext")
      UR[2,2] = W/V
      UI[2,2] = ZERO

      # Compute matrices M1 and M2 for the reduced equation.

      M1R[2,1] = ZERO
      M1I[2,1] = ZERO
      M2R[2,1] = ZERO
      M2I[2,1] = ZERO
      BETAR, BETAI = _ladiv( AR[1,1], AI[1,1], ER[1,1], EI[1,1] )
      M1R[1,1] =  BETAR
      M1I[1,1] =  BETAI
      M1R[2,2] =  BETAR
      M1I[2,2] = -BETAI
      ALPHA = sqrt( -TWO*BETAR )
      M2R[1,1] = ALPHA
      M2I[1,1] = ZERO
      V  = ER[1,1]*ER[2,2]
      XR = ( -BR[1,1]*ER[1,2] + ER[1,1]*BR[1,2] )/V
      XI = ( -BR[1,1]*EI[1,2] + ER[1,1]*BI[1,2] )/V
      YR =  XR - ALPHA*UR[1,2]
      YI = -XI + ALPHA*UI[1,2]
      if ( YR != ZERO ) || ( YI != ZERO )
         M2R[1,2] =  YR/UR[2,2]
         M2I[1,2] = -YI/UR[2,2]
         M2R[2,2] =  BR[2,2]/( ER[2,2]*UR[2,2] )
         M2I[2,2] =  ZERO
         M1R[1,2] = -ALPHA*M2R[1,2]
         M1I[1,2] = -ALPHA*M2I[1,2]
      else
         M2R[1,2] = ZERO
         M2I[1,2] = ZERO
         M2R[2,2] = ALPHA
         M2I[2,2] = ZERO
         M1R[1,2] = ZERO
         M1I[1,2] = ZERO
      end
   else

      # Discrete-time equation.

      # Step I:  Compute U[1,1]. Set U[2,1] = 0.
      T = max(abs(AR[1,1]),abs(AI[1,1]),abs(ER[1,1]),abs(EI[1,1]))
      #V = ER[1,1]^2 + EI[1,1]^2 - AR[1,1]^2 - AI[1,1]^2
      V = (ER[1,1]/T)^2 + (EI[1,1]/T)^2 - (AR[1,1]/T)^2 - (AI[1,1]/T)^2
      V <= ZERO && error("The eigenvalues of the pencil A - λE  are not inside the unit circle")
      V = T*sqrt( V )
      T = TWO*abs( BR[1,1] )*SMLNUM
      T > V && error("$errtext")
      UR[1,1] = BR[1,1]/V
      UI[1,1] = ZERO
      UR[2,1] = ZERO
      UI[2,1] = ZERO
      # Step II:  Compute U[1,2].

      T = max( EPS*max( BR[2,2], hypot( BR[1,2], BI[1,2] ) ), SMLNUM )
      if abs( BR[1,1] ) < T
         UR[1,2] = ZERO
         UI[1,2] = ZERO
      else
         XR =  AR[1,1]*AR[1,2] + AI[1,1]*AI[1,2]
         XI =  AI[1,1]*AR[1,2] - AR[1,1]*AI[1,2]
         XR =  XR - ER[1,2]*ER[1,1] - EI[1,2]*EI[1,1]
         XI =  XI + EI[1,2]*ER[1,1] - ER[1,2]*EI[1,1]
         XR = -BR[1,2]*V - XR*UR[1,1]
         XI =  BI[1,2]*V - XI*UR[1,1]
         YR =  AR[2,2]*AR[1,1] + AI[2,2]*AI[1,1]
         YI = -AI[2,2]*AR[1,1] + AR[2,2]*AI[1,1]
         YR = YR - ER[2,2]*ER[1,1] - EI[2,2]*EI[1,1]
         YI = YI + EI[2,2]*ER[1,1] - ER[2,2]*EI[1,1]
         T  = TWO*hypot( XR, XI )*SMLNUM
         T > hypot( YR, YI ) && error("$errtext")
         t1, t2 = _ladiv( XR, XI, YR, YI )
         UR[1,2] = t1
         UI[1,2] = -t2
      end
      # Step III:  Compute U[2,2].

      XR =  ER[1,2]*UR[1,1] + ER[2,2]*UR[1,2] - EI[2,2]*UI[1,2]
      XI = -EI[1,2]*UR[1,1] - ER[2,2]*UI[1,2] - EI[2,2]*UR[1,2]
      YR =  AR[1,2]*UR[1,1] + AR[2,2]*UR[1,2] - AI[2,2]*UI[1,2]
      YI = -AI[1,2]*UR[1,1] - AR[2,2]*UI[1,2] - AI[2,2]*UR[1,2]
      V  = ER[2,2]^2 + EI[2,2]^2 - AR[2,2]^2 - AI[2,2]^2
      V <= ZERO && error("The eigenvalues of the pencil A - λE  are not inside the unit circle")
      V = sqrt( V )
      T = max( abs( BR[2,2] ), abs( BR[1,2] ), abs( BI[1,2] ),
               abs( XR ), abs( XI ), abs( YR ), abs( YI) )
      if T <= SMLNUM
         W = ZERO
      else
         W = ( BR[2,2]/T )^2 + ( BR[1,2]/T )^2 + ( BI[1,2]/T )^2 -
             ( XR/T )^2 - ( XI/T )^2 + ( YR/T )^2 + ( YI/T )^2
         #  the condition below usually does not occur -> we simply set W = 0
         #  and thus U22 = 0
         W < ZERO ? W = ZERO : W = T*sqrt( W )
      end
      T = TWO*W*SMLNUM
      T > V && error("$errtext")
      UR[2,2] = W/V
      UI[2,2] = ZERO

      #Compute matrices M1 and M2 for the reduced equation.

      B11  = BR[1,1]/ER[1,1]
      T    = ER[1,1]*ER[2,2]
      B12R = ( ER[1,1]*BR[1,2] - BR[1,1]*ER[1,2] )/T
      B12I = ( ER[1,1]*BI[1,2] - BR[1,1]*EI[1,2] )/T
      B22  = BR[2,2]/ER[2,2]
      M1R[2,1] = ZERO
      M1I[2,1] = ZERO
      M2R[2,1] = ZERO
      M2I[2,1] = ZERO
      BETAR, BETAI = _ladiv( AR[1,1], AI[1,1], ER[1,1], EI[1,1] )
      M1R[1,1] =  BETAR
      M1I[1,1] =  BETAI
      M1R[2,2] =  BETAR
      M1I[2,2] = -BETAI
      V = hypot( BETAR, BETAI )
      ALPHA = sqrt( ( ONE - V )*( ONE + V ) )
      M2R[1,1] = ALPHA
      M2I[1,1] = ZERO
      XR = ( AI[1,1]*EI[1,2] - AR[1,1]*ER[1,2] )/T + AR[1,2]/ER[2,2]
      XI = ( AR[1,1]*EI[1,2] + AI[1,1]*ER[1,2] )/T - AI[1,2]/ER[2,2]
      XR = -TWO*BETAI*B12I - B11*XR
      XI = -TWO*BETAI*B12R - B11*XI
      V  =  ONE + ( BETAI - BETAR )*( BETAI + BETAR )
      W  = -TWO*BETAI*BETAR
      YR, YI = _ladiv( XR, XI, V, W )
     #if ( YR != ZERO ) || ( YI != ZERO )
      # - to avoid NaNs, the above has been changed to:
      if ( abs(YR) > SMLNUM ) || ( abs(YI) > SMLNUM )
         M2R[1,2] =  ( YR*BETAR - YI*BETAI )/UR[2,2]
         M2I[1,2] = -( YI*BETAR + YR*BETAI )/UR[2,2]
         M2R[2,2] =  B22/UR[2,2]
         M2I[2,2] =  ZERO
         M1R[1,2] = -ALPHA*YR/UR[2,2]
         M1I[1,2] =  ALPHA*YI/UR[2,2]
      else
         M2R[1,2] = ZERO
         M2I[1,2] = ZERO
         M2R[2,2] = ALPHA
         M2I[2,2] = ZERO
         M1R[1,2] = ZERO
         M1I[1,2] = ZERO
      end
   end

   # Transform U back:  U := U * Q.
   # (Note:  Z is used as workspace.)
   @inbounds ZR = UR*QR - UI*QI
   @inbounds ZI = UR*QI + UI*QR

   # Overwrite U with the upper triangular matrix of its
   # QR-factorization. The elements on the main diagonal are real
   # and non-negative.

   CR, CI, SR, SI, L = cgivensc2( ZR[1,1], ZI[1,1], ZR[2,1], ZI[2,1], small )
   QUR[1,1] =  CR
   QUR[1,2] =  SR
   QUR[2,1] = -SR
   QUR[2,2] =  CR
   QUI[1,1] = -CI
   QUI[1,2] = -SI
   QUI[2,1] = -SI
   QUI[2,2] =  CI
   UR[:,2] = QUR*ZR[:,2] - QUI*ZI[:,2]
   #U[:,2] = QUR*ZR[:,2] - QUI*ZI[:,2]
   UI[:,2] = QUI*ZR[:,2] + QUR*ZI[:,2]
   U11 = L
   #U[2,1] = ZERO
   U12 = UR[1,2]
   U22 = UR[2,2]
   V = hypot( U22, UI[2,2] )
   if V  !=  ZERO
      XR, XI = _ladiv( V, ZERO, U22, UI[2,2] )
      YR = QUR[2,1]
      YI = QUI[2,1]
      QUR[2,1] = XR*YR - XI*YI
      QUI[2,1] = XR*YI + XI*YR
      YR = QUR[2,2]
      YI = QUI[2,2]
      QUR[2,2] = XR*YR - XI*YI
      QUI[2,2] = XR*YI + XI*YR
   end
   U22 = V

   # Transform the matrices M1 and M2 back.

   # M1 := QU * M1 * QU^H
   @inbounds TR = M1R*QUR' + M1I*QUI'
   @inbounds TI = -M1R*QUI' + M1I*QUR'
   @inbounds β = QUR*TR - QUI*TI
   # M2 := QB^H * M2 * QU^H
   @inbounds TR = M2R*QUR' + M2I*QUI'
   @inbounds TI = -M2R*QUI' + M2I*QUR'
   @inbounds α = QBR'*TR + QBI'*TI

   # If the transposed equation (op(K)=K^T, K=A,B,E,U) is to be
   # solved, transpose the matrix U with respect to the
   # anti-diagonal and the matrices M1, M2 with respect to the diagonal
   # and the anti-diagonal.

   if noadj
      V = U11
      U11 = U22
      U22 = V
      V = β[1,1]
      β[1,1] = β[2,2]
      β[2,2] = V
      V = α[1,1]
      α[1,1] = α[2,2]
      α[2,2] = V
   end
   R[1,1] = U11
   R[1,2] = U12
   R[2,2] = U22
   return β, α
end
"""
    cgivens2(ar, ai, b, small) -> (cr, ci, s, d)

Construct a complex Givens plane rotation such that, for a complex number  `a`
and a real number  `b`,

        ( conj( c )  s )*( a ) = ( d ),
        (      -s    c ) ( b )   ( 0 )

where  `d`  is always real. `a` and `b` are unaltered.
On entry, `ar` and `ai` must contain the real and imaginary part,
respectively, of the complex number `a` and `b` contains a real number.
On exit, `cr` and `ci` contain the real and imaginary part, respectively,
of the complex number c, the cosines of the plane rotation and
`s` contains the real number `s`, the sines of the plane rotation.
`small` is a small real number. If the norm `d` of `[ a; b ]` is smaller
than `small`, then the rotation is taken as a unit matrix.

This function is based on the SLICOT routine SB03OV.
"""
@inline function cgivens2(ar, ai, b, small)
   d = max(abs(ar), abs(ai), abs(b))
   ZERO = zero(d)
   ONE = one(d)
   if d < small
      cr = ONE
      ci = ZERO
      s = ZERO
   else
      d = d*hypot3(ar/d, ai/d, b/d)
      cr = ar/d
      ci = ai/d
      s = b/d
   end
   return cr, ci, s, d
end
"""
    hypot3(X, Y, Z)

Compute the hypotenuse `sqrt(X^2+Y^2+Z^2)` avoiding overflow and underflow.
Based on the LAPACK function DLAPY3.
`Note:` The Julia function `hypot` is not reliable for more than two arguments.
"""
@inline function hypot3(X, Y, Z)
   XABS = abs( X )
   YABS = abs( Y )
   ZABS = abs( Z )
   W = max( XABS, YABS, ZABS )
   iszero(W) ? (return zero(W)) : (return W*sqrt( ( XABS / W )^2+( YABS / W )^2+ ( ZABS / W )^2 ))
end
"""
    cgivensc2(xr, xi, yr, yi, small) -> (cr, ci, sr, si, d)

Construct a complex Givens plane rotation such that, for the complex numbers
`x`  and  `y`,

        ( conj( c )  conj( s) )*( x ) = ( d ),
        (      -s          c  ) ( y )   ( 0 )

where  `d`  is always real. `x` and `y` are unaltered.
On entry, `xr` and `xi` must contain the real and imaginary part,
respectively, of the complex number `x` and `yr` and `yi` must contain
the real and imaginary part, respectively, of the complex number `y`.
On exit, `cr` and `ci` contain the real and imaginary part, respectively,
of the complex number c, the cosines of the plane rotation and
`sr` and `si` contain the real and imaginary part, respectively,
of the complex number s, the sines of the plane rotation.
s contains the real number s, the sines of the plane rotation.
`small` is a small real number. If the norm `d` of `[ x; y ]` is smaller
than `small`, then the rotation is taken as a unit matrix.

This function is based on the SLICOT routine SG03BY.
"""
@inline function cgivensc2(xr, xi, yr, yi, small)
   d = max(abs(xr), abs(xi), abs(yr), abs(yi))
   ZERO = zero(d)
   ONE = one(d)
   if d < small
      cr = ONE
      ci = ZERO
      sr = ZERO
      si = ZERO
   else
      d = d*hypot4(xr/d, xi/d, yr/d, yi/d)
      cr = xr/d
      ci = xi/d
      sr = yr/d
      si = yi/d
   end
   return cr, ci, sr, si, d
end
"""
    hypot4(X, Y, Z, T)

Compute the hypotenuse `sqrt(X^2+Y^2+Z^2+T^2)` avoiding overflow and underflow.
Based on the LAPACK function DLAPY3.
`Note:` The Julia function `hypot` is not reliable for more than two arguments.
"""
@inline function hypot4(X, Y, Z, T)
   XABS = abs( X )
   YABS = abs( Y )
   ZABS = abs( Z )
   TABS = abs( T )
   W = max( XABS, YABS, ZABS, TABS )
   iszero(W) ? (return zero(W)) : (return W*sqrt( ( XABS / W )^2+( YABS / W )^2+ ( ZABS / W )^2+ ( TABS / W )^2  ))
end

module Test_meutil

using LinearAlgebra
using MatrixEquations
using Test

n = 500
ar, ur, = schur(rand(n,n))
cr = rand(n,n)
Qr = cr'*cr

println("Test_meutil")

@testset "Matrix Equations Utilities" begin
x = copy(Qr); @time utqu!(x,ur);
@time y = ur'*Qr*ur;
@test norm(x-y) < sqrt(eps(1.))

x = copy(Qr); @time utqu!(x,ur');
@time y = ur*Qr*ur';
@test norm(x-y) < sqrt(eps(1.))

@time x = utqu(Qr,ur);
@time y = ur'*Qr*ur;
@test norm(x-y) < sqrt(eps(1.))

@time x = utqu(Qr,ur');
@time y = ur*Qr*ur';
@test norm(x-y) < sqrt(eps(1.))

@time x = vec2triu(triu2vec(Qr, rowwise = false, her = false),rowwise = false, her = false)
@test x == triu(Qr)

@time x = vec2triu(triu2vec(Qr, rowwise = false, her = true),rowwise = false, her = true)
@test x == Qr

@time x = vec2triu(triu2vec(Qr, rowwise = true, her = false),rowwise = true, her = false)
@test x == triu(Qr)

@time x = vec2triu(triu2vec(Qr, rowwise = true, her = true),rowwise = true, her = true)
@test x == Qr

@test isschur(rand(2,3)) == false &&
      isschur(rand(1,1)) == true &&
      isschur(rand(3,3)) == false &&
      isschur(rand(3,3),rand(2,2)) == false

 u = [1 2;3 4]
 q = [1 3; 3 1]

try
    utqu(q,u) 
    utqu(q//2,u) 
    utqu(q//2,u//2) 
    utqu!(q,u) 
    utqu!(q//2,u) 
    utqu(q//2,u//2) 
   @test true   
catch
    @test false   
end     

try
    utqu!(q,u//2) 
    @test false   
catch
    @test true   
end     
     
try
    utqu!(rand(3,3),rand(3,3)) 
    @test false   
catch
    @test true   
end     

try
    utqu!(Symmetric(rand(3,3)),rand(2,2))
    @test false   
catch
    @test true   
end     

try
    utqu(rand(3,3),rand(3,3)) 
    @test false   
catch
    @test true   
end     

try
    utqu(Symmetric(rand(3,3)),rand(2,2))
    @test false   
catch
    @test true   
end     

try
    utqu(Symmetric(rand(3,3)),rand(2,2)')
    @test false   
catch
    @test true   
end     

try
    qrupdate!(triu(rand(4,4)), rand(2,3))
    @test false   
catch
    @test true   
end     

try
    rqupdate!(triu(rand(4,4)), rand(2,3))
    @test false   
catch
    @test true   
end     

try
    triu2vec(rand(2,2), her = true)
    @test false   
catch
    @test true   
end     

end

end

module Test_riccati

using Random
using LinearAlgebra
using MatrixEquations
using Test
using GenericSchur
using GenericLinearAlgebra

println("Test_riccati")

@testset "Testing algebraic Riccati equation solvers" begin


# only double precision tests are performed

#for (Ty,n,p,m) in ((Float64, 30, 10, 10), (Float32, 5, 3, 3))
for (Ty,n,p,m) in ((Float64, 20, 10, 10),  (Float64, 5, 3, 1))

Random.seed!(21235)

#(Ty,n,p,m) = (Float64, 20, 10, 10)
#(Ty,n,p,m) = (Float64, 2, 1, 1)

ar = randn(Ty,n,n)
er = rand(Ty,n,n)
if m == 1
    br = rand(Ty,n)
    bc = rand(Ty,n)+im*rand(Ty,n)
    sc = rand(Complex{Ty},n)/100
    sr = rand(Ty,n)/100
else
    br = rand(Ty,n,m)
    bc = rand(Ty,n,m)+im*rand(Ty,n,m)
    sc = rand(Complex{Ty},n,m)/100
    sr = rand(Ty,n,m)/100
end
cr = rand(Ty,p,n)
ac = randn(Ty,n,n) + im*randn(Ty,n,n)
ec = er+im*rand(Ty,n,n)
cc = rand(Ty,p,n)+im*rand(Ty,p,n)
bc = rand(Ty,n,m)+im*rand(Ty,n,m)
rr1 = rand(Ty,m,m)
rc1 = rand(Ty,m,m)+im*rand(Ty,m,m)
#Ty == Float64 ? rtol = n*n*sqrt(eps(1.)) : rtol = n*sqrt(eps(1.f0))
rtol = n*n*sqrt(eps(1.)) 

qc = cc'*cc
Qr = cr'*cr
gc = bc*bc'
gr = br*br'
rr = rr1*rr1'
rc = rc1*rc1'




@testset "Continuous Riccati equation ($Ty, n = $n, m = $m)" begin

@time x, clseig = arec(ar,gr,Qr)
@test norm(ar'*x+x*ar-x*gr*x+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,gr,Qr,as = true)
@test norm(ar'*x+x*ar-x*gr*x+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,gr)
@test norm(ar'*x+x*ar-x*gr*x)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,2I,I)
@test norm(ar'*x+x*ar-x*2*x+I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-2*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-2*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,2,I)
@test norm(ar'*x+x*ar-x*2*x+I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-2*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-2*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,gr,2I)
@test norm(ar'*x+x*ar-x*gr*x+2I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,gr,2)
@test norm(ar'*x+x*ar-x*gr*x+2I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,2I,Qr)
@test norm(ar'*x+x*ar-x*2*x+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-2*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-2*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar',gr,Qr)
@test norm(ar*x+x*ar'-x*gr*x+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar'-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar'-gr*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ac,gc,qc)
@test norm(ac'*x+x*ac-x*gc*x+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-gc*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-gc*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ac',gc,qc)
@test norm(ac*x+x*ac'-x*gc*x+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac'-gc*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac'-gc*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ar,gc,qc)
@test norm(ar'*x+x*ar-x*gc*x+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gc*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gc*x))))/norm(clseig)  < rtol

@time x, clseig = arec(ac,gr,Qr)
@test norm(ac'*x+x*ac-x*gr*x+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-gr*x))))/norm(clseig)  < rtol

try
    arec(zeros(2,2),[1 1;1 1],[1 0;0 0])  # Hamiltonian not dichotomic
    @test false
catch
    @test true
end

try
    arec(rand(2,2),0I,0I)  # no finite solution 
    @test false
catch
    @test true
end


end



@testset "Generalized continuous Riccati equation ($Ty, n = $n, m = $m)" begin

@time x, clseig = garec(ar,er,gr,Qr)
@test norm(ar'*x*er+er'*x*ar-er'*x*gr*x*er+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol

@time x, clseig = garec(ar,er,gr,Qr,as = true)
@test norm(ar'*x*er+er'*x*ar-er'*x*gr*x*er+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol

@time x, clseig = garec(ar,er,gr)
@test norm(ar'*x*er+er'*x*ar-er'*x*gr*x*er)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol


@time x, clseig = garec(ar,er,gr,2I)
@test norm(ar'*x*er+er'*x*ar-er'*x*gr*x*er+2I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-gr*x*er,er))))/norm(clseig)  < rtol


@time x, clseig = garec(ar,er,I,2I)
@test norm(ar'*x*er+er'*x*ar-er'*x*x*er+2I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-x*er,er))))/norm(clseig)  < rtol


@time x, clseig = garec(ar,I,1,2)
@test norm(ar'*x+x*ar-x*x+2I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-x))))/norm(clseig)  < rtol

end


@testset "Continuous control Riccati equation ($Ty, n = $n, m = $m)" begin


@time x, clseig, f, z = arec(ar,br,rr,Qr,sr)
@test norm(ar'*x+x*ar-(x*br+sr)*inv(rr)*(br'*x+sr')+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol

@time x, clseig, f, z = arec(ar,br,rr,Qr,sr;orth=true)
@test norm(ar'*x+x*ar-(x*br+sr)*inv(rr)*(br'*x+sr')+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol
norm(z'*z - I) < rtol

@time x, clseig, f = arec(ar,br,rr,Qr,sr,as=true)
@test norm(ar'*x+x*ar-(x*br+sr)*inv(rr)*(br'*x+sr')+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ar,br,rr,Qr)
@test norm(ar'*x+x*ar-x*br*inv(rr)*br'*x+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ar,br,I,Qr)
@test norm(ar'*x+x*ar-x*br*br'*x+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ar,br,1,Qr)
@test norm(ar'*x+x*ar-x*br*br'*x+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ar,br,rr,0I)
@test norm(ar'*x+x*ar-x*br*inv(rr)*br'*x)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ar,br,rr,0)
@test norm(ar'*x+x*ar-x*br*inv(rr)*br'*x)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ac,bc,rc,qc)
@test norm(ac'*x+x*ac-x*bc*inv(rc)*bc'*x+qc)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ac,bc,rc,qc,sc)
@test norm(ac'*x+x*ac-(x*bc+sc)*inv(rc)*(bc'*x+sc')+qc)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ac,bc,rr,Qr,sr)
@test norm(ac'*x+x*ac-(x*bc+sr)*inv(rr)*(bc'*x+sr')+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ar,br,gr,rr,Qr,sr)
@test norm(ar'*x+x*ar-x*gr*x-(x*br+sr)*inv(rr)*(br'*x+sr')+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-gr*x))))/norm(clseig)  < rtol

@time x, clseig, f = arec(ar,br,gr,rr,Qr,sr,as=true)
@test norm(ar'*x+x*ar-x*gr*x-(x*br+sr)*inv(rr)*(br'*x+sr')+Qr)/max(1,norm(x))  < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-gr*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-gr*x))))/norm(clseig)  < rtol

g = 2
@time x, clseig, f, z = arec(ar,br,g*I,rr,Qr,sr)
@test norm(ar'*x+x*ar-x*g*x-(x*br+sr)*inv(rr)*(br'*x+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-g*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-g*x))))/norm(clseig)  < rtol

g = 2
@time x, clseig, f, z = arec(ar,br,g*I,rr,Qr,sr,as=true)
@test norm(ar'*x+x*ar-x*g*x-(x*br+sr)*inv(rr)*(br'*x+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-g*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-g*x))))/norm(clseig)  < rtol

g = 2; q = 3. *I; r = 1;
@time x, clseig, f, z = arec(ar,br,g*I,r,q,sr,as=true)
@test norm(ar'*x+x*ar-x*g*x-(x*br+sr)*inv(r)*(br'*x+sr')+q)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-g*x))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-g*x))))/norm(clseig)  < rtol

ar1 = rand(Ty,2,2); br1 = rand(Ty,2,2); gr1 = 0*I; r1 = [1.e5 0; 0 1.e-5]; q1 = 0*I; sr1 = zeros(Ty,2,2);
@time x, clseig, f, z = arec(ar1,br1,gr1,r1,q1,sr1)
@test norm(ar1'*x+x*ar1-x*gr1*x-(x*br1+sr1)*inv(r1)*(br1'*x+sr1')+q1)/max(1,norm(x)) < rtol

end

@testset "Generalized continuous control Riccati equation ($Ty, n = $n, m = $m)" begin

@time x, clseig, f = garec(ar,er,br,rr,Qr,sr)
@test norm(ar'*x*er+er'*x*ar-(er'x*br+sr)*inv(rr)*(br'*x*er+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/norm(clseig)  < rtol

@time x, clseig, f = garec(ar,er,br,rr,Qr,sr,as = true)
@test norm(ar'*x*er+er'*x*ar-(er'x*br+sr)*inv(rr)*(br'*x*er+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/norm(clseig)  < rtol

@time x, clseig, f = garec(ar,er,br,gr,rr,Qr,sr)
@test norm(ar'*x*er+er'*x*ar-er'*x*gr*x*er - (er'x*br+sr)*inv(rr)*(br'*x*er+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-gr*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-gr*x*er,er))))/norm(clseig)  < rtol

@time x, clseig, f = garec(ar,er,br,gr,rr,Qr,sr,as = true)
@test norm(ar'*x*er+er'*x*ar-er'*x*gr*x*er - (er'x*br+sr)*inv(rr)*(br'*x*er+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-gr*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-gr*x*er,er))))/norm(clseig)  < rtol

@time x, clseig, f = garec(ar,er,br,rr,2I,sr)
@test norm(ar'*x*er+er'*x*ar-(er'x*br+sr)*inv(rr)*(br'*x*er+sr')+2I)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/norm(clseig)  < rtol

@time x, clseig, f = garec(ac,ec,bc,rc,qc,sc)
@test norm(ac'*x*ec+ec'*x*ac-(ec'x*bc+sc)*inv(rc)*(bc'*x*ec+sc')+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f,ec))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f,ec))))/norm(clseig)  < rtol

@time x, clseig, f = garec(ac,ec,bc,rr,Qr,sr)
@test norm(ac'*x*ec+ec'*x*ac-(ec'x*bc+sr)*inv(rr)*(bc'*x*ec+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f,ec))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f,ec))))/norm(clseig)  < rtol

@time x, clseig, f = garec(ar,er,br,1,rr,Qr,sr)
@test norm(ar'*x*er+er'*x*ar-er'*x*x*er-(er'x*br+sr)*inv(rr)*(br'*x*er+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-x*er,er))))/norm(clseig)  < rtol

g = 2
@time x, clseig, f, z = garec(ar,er,br,g*I,rr,Qr,sr)
@test norm(ar'*x*er+er'*x*ar-er'*x*g*x*er-(er'x*br+sr)*inv(rr)*(br'*x*er+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-g*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-g*x*er,er))))/norm(clseig)  < rtol

g = 2
@time x, clseig, f = garec(ar,er,br,g,rr,Qr,sr,as=true)
@test norm(ar'*x*er+er'*x*ar-er'*x*g*x*er-(er'x*br+sr)*inv(rr)*(br'*x*er+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-g*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-g*x*er,er))))/norm(clseig)  < rtol

g = 2; q = 3. *I; r = 1;
@time x, clseig, f = garec(ar,er,br,g,r,q,sr,as=true)
@test norm(ar'*x*er+er'*x*ar-er'*x*g*x*er-(er'x*br+sr)*inv(r)*(br'*x*er+sr')+q)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f-g*x*er,er))))/norm(clseig)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f-g*x*er,er))))/norm(clseig)  < rtol


end


@testset "Discrete control Riccati equation ($Ty, n = $n, m = $m)" begin
@time x, clseig, f = ared(ar,br,rr,Qr)
@test norm(ar'*x*ar-x-ar'*x*br*inv(rr+br'*x*br*I)*br'*x*ar+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(ar)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(ar)  < rtol

@time x, clseig, f = ared(ar,br,rr,0I)
@test norm(ar'*x*ar-x-ar'*x*br*inv(rr+br'*x*br*I)*br'*x*ar)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(ar)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(ar)  < rtol

@time x, clseig, f = ared(ar,br,rr,0I; as = true)
@test norm(ar'*x*ar-x-ar'*x*br*inv(rr+br'*x*br*I)*br'*x*ar)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(ar)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(ar)  < rtol

@time x, clseig, f = ared(ar,br,rr,Qr,sr)
@test norm(ar'*x*ar-x-(ar'*x*br+sr)*inv(rr+br'*x*br*I)*(br'*x*ar+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(ar)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(ar)  < rtol

@time x, clseig, f = ared(ar,br,rr,Qr,sr,as = true)  #fails
@test norm(ar'*x*ar-x-(ar'*x*br+sr)*inv(rr+br'*x*br*I)*(br'*x*ar+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/norm(ar)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/norm(ar)  < rtol

@time x, clseig, f = ared(ac,bc,rc,qc)
@test norm(ac'*x*ac-x-ac'*x*bc*inv(rc+bc'*x*bc*I)*bc'*x*ac+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f))))/norm(ac)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f))))/norm(ac)  < rtol

@time x, clseig, f = ared(ac,bc,rc,qc,sc)
@test norm(ac'*x*ac-x-(ac'*x*bc+sc)*inv(rc+bc'*x*bc*I)*(bc'*x*ac+sc')+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f))))/norm(ac)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f))))/norm(ac)  < rtol

q = 3.f0 *I; r = 1;
@time x, clseig, f = ared(ar,br,r,q,sr,as=true)
@test norm(ar'*x*ar-x-(ar'*x*br+sr)*inv(r*I+br'*x*br)*(br'*x*ar+sr')+q)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f))))/max(opnorm(ar,1),1)  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f))))/max(opnorm(ar,1),1)  < rtol

end


@testset "Generalized discrete control Riccati equation ($Ty, n = $n, m = $m)" begin
@time x, clseig, f = gared(ar,er,br,rr,Qr,sr)
@test norm(ar'*x*ar-er'*x*er-(ar'*x*br+sr)*inv(rr+br'*x*br*I)*(br'*x*ar+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol

@time x, clseig, f = gared(ar,er,br,rr,Qr,sr,as = true)
@test norm(ar'*x*ar-er'*x*er-(ar'*x*br+sr)*inv(rr+br'*x*br*I)*(br'*x*ar+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol

@time x, clseig, f = gared(ar,er,br,rr,0I)
@test norm(ar'*x*ar-er'*x*er-(ar'*x*br)*inv(rr+br'*x*br*I)*(br'*x*ar))/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol

@time x, clseig, f, z = gared(ar,er,br,rr,0I;as = true)
@test norm(ar'*x*ar-er'*x*er-(ar'*x*br)*inv(rr+br'*x*br*I)*(br'*x*ar))/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol

@time x, clseig, f = gared(ac,ec,bc,rc,qc,sc)
@test norm(ac'*x*ac-ec'*x*ec-(ac'*x*bc+sc)*inv(rc+bc'*x*bc*I)*(bc'*x*ac+sc')+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f,ec))))/max(opnorm(ac,1),opnorm(ec,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f,ec))))/max(opnorm(ac,1),opnorm(ec,1))  < rtol

@time x, clseig, f = gared(ac,ec,bc,rc,qc,sc; as = true) #fails
@test norm(ac'*x*ac-ec'*x*ec-(ac'*x*bc+sc)*inv(rc+bc'*x*bc*I)*(bc'*x*ac+sc')+qc)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f,ec))))/max(opnorm(ac,1),opnorm(ec,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f,ec))))/max(opnorm(ac,1),opnorm(ec,1))  < rtol

@time x, clseig, f = gared(ac,ec,bc,rr,Qr,sr)
@test norm(ac'*x*ac-ec'*x*ec-(ac'*x*bc+sr)*inv(rr+bc'*x*bc*I)*(bc'*x*ac+sr')+Qr)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ac-bc*f,ec))))/max(opnorm(ac,1),opnorm(ec,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ac-bc*f,ec))))/max(opnorm(ac,1),opnorm(ec,1))  < rtol

q = 3.f0 *I; r = 1;
@time x, clseig, f = gared(ar,er,br,r,q,sr,as=true)
@test norm(ar'*x*ar-er'*x*er-(ar'*x*br+sr)*inv(r*I+br'*x*br)*(br'*x*ar+sr')+q)/max(1,norm(x)) < rtol &&
norm(sort(real(clseig))-sort(real(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol &&
norm(sort(imag(clseig))-sort(imag(eigvals(ar-br*f,er))))/max(opnorm(ar,1),opnorm(er,1))  < rtol

end

end

@testset "Scaling continuous-time Riccati equation" begin
    
# some continuous-time problems which need scaling
A = [ 0.0        0.0        -0.00135213   0.0
      0.0        0.0         0.0         -0.000755718
      0.0531806  0.0         0.0          0.0378156
      0.0        0.0531806  -0.0709927    0.0];
B = [ 1.0  0.0
 0.0  1.0
 0.0  0.0
 0.0  0.0]; 
Q = [ 0.0  0.0  0.0        0.0
 0.0  0.0  0.0        0.0
 0.0  0.0  1.17474e9  0.0
 0.0  0.0  0.0        4.14026e9]; 
R = [100.0    0.0
   0.0  100.0];
G = B*inv(R)*B'; G = (G+G)/2   
E = [0.3145695364503345 0.28299421375349765 0.7751430938038222 0.3817600131380937; 
0.6175205621578082 0.9791019859058574 0.6388662440424374 0.36327849747268603; 
0.13292183504367217 0.9319918486921431 0.15347895705946646 0.1378470943397626; 
0.1411783703336893 0.6496471027507487 0.7764461576953698 0.2687776918944005];
reltol = sqrt(eps(1000.))

# without scaling
@time X, clseig = arec(A,G,Q; scaling = 'N')
rezn = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test !(rezn < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol)

# with block scaling
@time X, clseig = arec(A,G,Q; scaling = 'B')
rezb = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test  rezb < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

# extended precision with block scaling
@time X, clseig = arec(BigFloat.(A),G,Q; scaling = 'B')
rezb = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test  rezb < 1.e-60*reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

# with special scaling
@time X, clseig = arec(A,G,Q; scaling = 'S')
rezs = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test rezs < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

# with special scaling
@time X, clseig, Z, scalinfo = arec(A,G,Q; scaling = 'K', nrm = Inf)
rezk = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test rezk < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

# with general scaling
@time X, clseig = arec(A,G,Q; scaling = 'G')
rezg = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test rezg < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

# without scaling
@time X, clseig = garec(A,E,G,Q; scaling = 'N')
rezn = norm(A'*X*E+E'*X*A-E'*X*G*X*E+Q)/max(1,norm(X))
@test !(rezn < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X*E,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X*E,E))))/norm(clseig)  < reltol)

# with block scaling
@time X, clseig = garec(A,E,G,Q; scaling = 'B')
rezb = norm(A'*X*E+E'*X*A-E'*X*G*X*E+Q)/max(1,norm(X))
ev = eigvals(A-G*X*E,E)
@test rezb < reltol &&
norm(sort(real(clseig))-sort(real(ev)))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(ev)))/norm(clseig)  < reltol

@time X, clseig, Z, scalinfo = garec(BigFloat.(A),E,G,Q; scaling = 'B')
rezb = norm(A'*X*E+E'*X*A-E'*X*G*X*E+Q)/max(1,norm(X))
ev = schur(complex(A-G*X*E),complex(E)).values
@test rezb < 1.e-60*reltol &&
norm(sort(real(clseig))-sort(real(ev)))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(ev)))/norm(clseig)  < reltol &&
norm((scalinfo.Sx*(Z[5:8,:]/Z[1:4,:])*scalinfo.Sxi)/BigFloat.(E)-X)/norm(X) < reltol 

# with special scaling
@time X, clseig = garec(A,E,G,Q; scaling = 'S');
rezs = norm(A'*X*E+E'*X*A-E'*X*G*X*E+Q)/max(1,norm(X)) 
ev = eigvals(A-G*X*E,E)
@test rezs < reltol &&  
norm(sort(real(clseig))-sort(real(ev)))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(ev)))/norm(clseig)  < reltol

@time X, clseig = garec(A,E,G,Q; scaling = 'K');
rezk = norm(A'*X*E+E'*X*A-E'*X*G*X*E+Q)/max(1,norm(X)) 
ev = eigvals(A-G*X*E,E)
@test rezk < reltol &&  
norm(sort(real(clseig))-sort(real(ev)))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(ev)))/norm(clseig)  < reltol

# with special scaling
@time X, clseig = garec(A,E,G,Q; scaling = 'G')
rezg = norm(A'*X*E+E'*X*A-E'*X*G*X*E+Q)/max(1,norm(X)) 
ev = eigvals(A-G*X*E,E)
@test rezg < reltol && 
norm(sort(real(clseig))-sort(real(ev)))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(ev)))/norm(clseig)  < reltol

# without scaling
@time X, clseig, F = arec(A, B, R, Q; scaling = 'N')
rezn = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test !( rezn < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol)

# with scaling
@time X, clseig, F = arec(A,B,R,Q; scaling = 'B')
rezb1 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezb1 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(BigFloat.(A),B,R,Q; scaling = 'B')
rezb1 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezb1 < 1.e-60*reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(A,B,R,Q; scaling = 'B', orth = true)
rezb2 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezb2 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(BigFloat.(A),complex(B),R,Q; scaling = 'B', orth = true)
rezb2 = norm(A'*X+X*A-X*B*inv(BigFloat.(R))*B'*X+Q)/max(1,norm(X))
@test  rezb2 < 1.e-60*reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F, Z, scalinfo = arec(BigFloat.(A),B,R,Q; scaling = 'B', orth = true)
rezb2 = norm(A'*X+X*A-X*B*inv(BigFloat.(R))*B'*X+Q)/max(1,norm(X))
@test  rezb2 < 1.e-60*reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm((scalinfo.Sx*(Z[5:8,:]/Z[1:4,:])*scalinfo.Sxi)-X)/norm(X) < reltol &&
norm(-(scalinfo.Sr*(Z[9:10,:]/Z[1:4,:])*scalinfo.Sxi)-F)/norm(F) < reltol 
 
@time X, clseig, F = arec(A,B,R,Q; scaling = 'S')
rezs1 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezs1 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(A,B,R,Q; scaling = 'S', orth = true)
rezs2 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezs2 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(A,B,R,Q; scaling = 'K', nrm = 1)
rezk1 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezk1 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(A,B,R,Q; scaling = 'K', orth = true, nrm = 1)
rezk2 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezs2 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol


@time X, clseig, F = arec(A,B,R,Q; scaling = 'G')
rezg1 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezg1 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(A,B,R,Q; scaling = 'G', orth = true)
rezg2 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezg2 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

# without scaling
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'N')
rezn = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X))
@test !( rezn < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol)

# with scaling  
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'B')
rezb  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@test rezb < 10*reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# with scaling
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'S')
rezs  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@test rezs < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# with scaling
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'K', nrm = 1)
rezk  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@test rezs < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# with scaling
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'K', pow2 = true)
rezk  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@test rezk < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# with scaling
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'G')
rezg  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@test rezg < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# with scaling
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'D')
rezd  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@test rezd < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# with scaling
@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'T')
rezt  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@test rezt < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# Example 2 from Petkov et al. 1998 (MATLAB scaling in icare fails to produce accurate result)
# k = 6
# A = BigFloat.(diagm([10^k; 2*10^k; 3*10^k])); Q = diagm([BigFloat(10.) ^(-k);1; 10^k])
# G = diagm([BigFloat(10.) ^(-k);BigFloat(10.) ^(-k); BigFloat(10.) ^(-k)]); B = BigFloat.(I(3)); R = BigFloat.(diagm([10^k; 10^k; 10^k]))

# x = [(A[i,i]+sqrt(A[i,i]^2+Q[i,i]*G[i,i]))/G[i,i] for i in 1:3]
# Xr = diagm(x)
# rez = norm(A'*Xr+Xr*A-Xr*G*Xr+Q)/max(1,norm(Xr))

reltol = sqrt(eps(1000.))
k = 6
A = diagm([10^k; 2*10^k; 3*10^k]); Q = diagm([10. ^(-k);1; 10^k])
G = diagm([10. ^(-k);10. ^(-k); 10. ^(-k)]); B = I(3); R = diagm([10^k; 10^k; 10^k])
E = [0.229087  0.569477  0.4308
0.187523  0.569036  0.342814
0.792381  0.690077  0.202204];

x = [(A[i,i]+sqrt(A[i,i]^2+Q[i,i]*G[i,i]))/G[i,i] for i in 1:3]
Xr = diagm(x)
rez = norm(A'*Xr+Xr*A-Xr*G*Xr+Q)/max(1,norm(Xr))

# without scaling
@time X, clseig = arec(A,G,Q; scaling = 'N')
rezn = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test !(rezn < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol)

# with scaling
@time X, clseig = arec(A,G,Q; scaling = 'B')
rezb = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test rezb < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

@time X, clseig = arec(BigFloat.(A),G,Q; scaling = 'B')
rezb = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test  rezb < 1.e-60*reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

@time X, clseig = arec(A,G,Q; scaling = 'S')
rezs = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test rezs < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

@time X, clseig = arec(A,G,Q; scaling = 'K', nrm = 1)
rezk1 = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test rezk < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

@time X, clseig = arec(A,G,Q; scaling = 'G', pow2 = true)
rezg = norm(A'*X+X*A-X*G*X+Q)/max(1,norm(X))
@test rezg < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-G*X))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-G*X))))/norm(clseig)  < reltol

@time X, clseig, Z, scalinfo = garec(A,E,G,Q; scaling = 'B')
rezb = norm(A'*X*E+E'*X*A-E'*X*G*X*E+Q)/max(1,norm(X)) 
ev = eigvals(A-G*X*E,E)
@test rezb < 100*reltol &&
norm(sort(real(clseig))-sort(real(ev)))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(ev)))/norm(clseig)  < reltol

@time X, clseig, F = arec(A,B,R,Q; scaling = 'S')
rezb1 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezb1 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = arec(A,B,R,Q; scaling = 'K', nrm = 1)
rezb1 = norm(A'*X+X*A-X*B*inv(R)*B'*X+Q)/max(1,norm(X))
@test  rezb1 < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))/norm(clseig)  < reltol

@time X, clseig, F = garec(A, E, B, R, Q; scaling = 'N')
rezn  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X))

@time X, clseig, F, Z, scalinfo = garec(A, E, B, R, Q; scaling = 'K')
rezk  = norm(A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+Q)/max(1,norm(X)) 
@show rezk, rezn, norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig), norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)
@test rezk < 1.e-3*rezn 
@test norm(sort(real(clseig))-sort(real(eigvals(A-B*F,E))))/norm(clseig)  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F,E))))/norm(clseig)  < reltol

# E1 = diagm(diag(E)); A1 = E1*A; B1 = E1*B;
# @time X, clseig, F = garec(A1, E1, B1, R, Q; scaling = 'N')
# rezn  = norm(A1'*X*E1+E1'*X*A1-E1'*X*B1*inv(R)*B1'*X*E1+Q)/max(1,norm(X)) 
# @time X, clseig, F = garec(A1, E1, B1, R, Q; scaling = 'S')
# rezb  = norm(A1'*X*E1+E1'*X*A1-E1'*X*B1*inv(R)*B1'*X*E1+Q)/max(1,norm(X)) 
# @test rezb < 1.e-4*rezn &&
# norm(sort(real(clseig))-sort(real(eigvals(A1-B1*F,E1))))/norm(clseig)  < reltol &&
# norm(sort(imag(clseig))-sort(imag(eigvals(A1-B1*F,E1))))/norm(clseig)  < reltol

end
@testset "Scaling discrete-time Riccati equation" begin

# discrete-time
# 
n = 4
A = [ 0.0        0.0        -0.00135213   0.0
      0.0        0.0         0.0         -0.000755718
      0.0531806  0.0         0.0          0.0378156
      0.0        0.0531806  -0.0709927    0.0];
B = [ 1.0  0.0
 0.0  1.0
 0.0  0.0
 0.0  0.0]; 
Q = [ 0.0  0.0  0.0        0.0
 0.0  0.0  0.0        0.0
 0.0  0.0  1.17474e9  0.0
 0.0  0.0  0.0        4.14026e9]; 
R = [100.0    0.0
   0.0  100.0];
G = B*inv(R)*B'; G = (G+G)/2   
E = [0.3145695364503345 0.28299421375349765 0.7751430938038222 0.3817600131380937; 
0.6175205621578082 0.9791019859058574 0.6388662440424374 0.36327849747268603; 
0.13292183504367217 0.9319918486921431 0.15347895705946646 0.1378470943397626; 
0.1411783703336893 0.6496471027507487 0.7764461576953698 0.2687776918944005];
S = zeros(4,2); 
reltol = sqrt(eps(1000.))

M = abs.([zeros(4,4) A B; -A' -Q -S; B' S' R]) + 
    abs.([zeros(4,4)  E zeros(4,2) ; E' zeros(4,6); zeros(2,10) ])


@time X, clseig, F = ared(A,B,R,Q; scaling = 'N')
rezn = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test !(rezn < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol)

@time X, clseig, F = ared(A,B,R,Q; scaling = 'B')
rezb = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezb < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'S')
rezs = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezs < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'K', nrm = 1)
rezk = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezk < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'D')
rezd = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezd < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'T')
rezt = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezt < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'G')
rezg = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezg < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

# Example 1  Gudmundsson et al. 1992
k = 6; 
V = I-2*ones(3)*ones(3)'/3; A0 = diagm([0; 1; 3])
A = V*A0*V
B = I(3); R = 10. ^k*I(3)
Q = 10. ^6*I(3); Xr = V*(10. ^k*diagm([1;(1+sqrt(5))/2; (9+sqrt(85))/2]))*V
@time X, clseig, F = ared(A,B,R,Q; scaling = 'N')
rezn = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test !(rezn < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol && 
norm(X-Xr) < reltol)

@time X, clseig, F = ared(A,B,R,Q; scaling = 'B')
rezb = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezb < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'S')
rezs = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezs < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'K', nrm = 1)
rezk = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezk < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'D')
rezd = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezd < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'R')
rezd = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezd < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol

@time X, clseig, F = ared(A,B,R,Q; scaling = 'T')
rezt = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezt < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol


@time X, clseig, F = ared(A,B,R,Q; scaling = 'G')
rezg = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
@test rezb < reltol && norm(X-Xr)/norm(X) < reltol &&
norm(sort(real(clseig))-sort(real(eigvals(A-B*F))))  < reltol &&
norm(sort(imag(clseig))-sort(imag(eigvals(A-B*F))))  < reltol


# Example 2  Gudmundsson et al. 1992 (modified)
A = [0 100; 0 0]; B = [0;1;;]; R = [1;;]; Q = 100*I(2); Xr = 100*[1 0; 0 10001]
@time X, clseig, F = ared(A,B,R,Q; scaling = 'N')
rezn = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xn = norm(X-Xr)/norm(X)

@time X, clseig, F = ared(A,B,R,Q; scaling = 'B')
rezb = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xb = norm(X-Xr)/norm(X)
@test rezb < rezn && xb < xn

@time X, clseig, F = ared(BigFloat.(A),B,R,Q; scaling = 'B')
rezb = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xb = norm(X-Xr)/norm(X)
@test rezb < rezn && xb < xn


@time X, clseig, F = ared(A,B,R,Q; scaling = 'S')
rezs = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xs = norm(X-Xr)/norm(X)
@test rezs < rezn && xs < xn

@time X, clseig, F = ared(A,B,R,Q; scaling = 'K')
rezk = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xk = norm(X-Xr)/norm(X)
@test rezk < rezn && xk < xn

@time X, clseig, F = ared(A,B,R,Q; scaling = 'D')
rezd = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xd = norm(X-Xr)/norm(X)
@test rezd < rezn && xd < xn

@time X, clseig, F = ared(A,B,R,Q; scaling = 'R')
rezd = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xd = norm(X-Xr)/norm(X)
@test rezd < rezn && xd < xn

@time X, clseig, F = ared(A,B,R,Q; scaling = 'T')
rezt = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xt = norm(X-Xr)/norm(X)
@test rezt < rezn && xt < xn

@time X, clseig, F = ared(A,B,R,Q; scaling = 'G')
rezg = norm(A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q)/max(1,norm(X))
xg = norm(X-Xr)/norm(X)
@test rezg < rezn && xg < xn

end


end 

end

module Test_sylvester

#using MKL
using LinearAlgebra
using MatrixEquations
using GenericSchur
using Test
using Random
using LinearAlgebra: BlasFloat


println("Test_sylvester")

@testset "Testing Sylvester equation solvers" begin

Random.seed!(21235)
n = 15; m = 15; ns = 10; ms = 10;
Ty = Float64
reltol = sqrt(eps(1.))

#  continuous Sylvester equations
@testset "Continuous Sylvester equations" begin

@time x = sylvc(1,2im,3.)
@test abs(x+x*2*im-3.) < reltol

try 
   @time x = sylvc(ones(1,1),-ones(1,1),ones(1,1)) 
   @test false
catch
   @test true
end

for Ty in (Float64, Float32, BigFloat)


ar = rand(Ty,n,n); ars = Symmetric(ar); ard = Diagonal(ar);
ac = ar+im*rand(Ty,n,n); ach = Hermitian(ac); acd = Diagonal(ac);
br = rand(Ty,m,m); brs = Symmetric(br); brd = Diagonal(br);
bc = br+im*rand(Ty,m,m);  bch = Hermitian(bc); bcd = Diagonal(bc);
cr = rand(Ty,n,m);
cc = cr+im*rand(Ty,n,m);
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))

arm = rand(Ty,ns,ns); acm = arm+im*rand(Ty,ns,ns); 
brm = rand(Ty,ms,ms); bcm = brm+im*rand(Ty,ms,ms);
crm1 = rand(Ty,ns,m); crm2 = rand(Ty,n,ms); ccm1 = crm1+im*rand(Ty,ns,m); ccm2 = crm2+im*rand(Ty,n,ms);


@time x = sylvc(ar,2I,cr)
@test norm(ar*x+x*2-cr)/norm(x) < reltol

@time x = sylvc(-3. *I,br,cr)
@test norm(-3. *x+x*br-cr)/norm(x) < reltol

@time x = sylvc(-3.,br,cr)
@test norm(-3. *x+x*br-cr)/norm(x) < reltol

@time x = sylvc(2I,3I,cr)
@test norm(2*x+x*3-cr)/norm(x) < reltol

@time x = sylvc(2,3,cr)
@test norm(2*x+x*3-cr)/norm(x) < reltol

@time x = sylvc(ar,br,cr)
@test norm(ar*x+x*br-cr)/norm(x) < reltol

@time x = sylvc(ar,br,cr,blocksize = 5)
@test norm(ar*x+x*br-cr)/norm(x) < reltol

@time x = sylvc(ars,brs,cr)
@test norm(ars*x+x*brs-cr)/norm(x) < reltol

@time x = sylvc(ard,brd,cr)
@test norm(ard*x+x*brd-cr)/norm(x) < reltol

@time x = sylvckr(ar,br,cr)
@test norm(ar*x+x*br-cr)/norm(x) < reltol

@time x = sylvc(ac,bc,cc)
@test norm(ac*x+x*bc-cc)/norm(x) < reltol

@time x = sylvc(ac,bc,cc,blocksize = 5)
@test norm(ac*x+x*bc-cc)/norm(x) < reltol

@time x = sylvc(ach,bch,cc)
@test norm(ach*x+x*bch-cc)/norm(x) < reltol

@time x = sylvc(acd,bcd,cc)
@test norm(acd*x+x*bcd-cc)/norm(x) < reltol


if Ty <: LinearAlgebra.BlasFloat
      @time x = sylvester(ar,br,cr)
      @test norm(ar*x+x*br+cr)/norm(x) < reltol

      @time x = sylvester(ac,bc,cc)
      @test norm(ac*x+x*bc+cc)/norm(x) < reltol
end

@time x = sylvckr(ac,bc,cc)
@test norm(ac*x+x*bc-cc)/norm(x) < reltol


@time x = sylvc(ar,bc,cr)
@test norm(ar*x+x*bc-cr)/norm(x) < reltol

@time x = sylvc(ar',br,cr)
@test norm(ar'*x+x*br-cr)/norm(x) < reltol

@time x = sylvc(ar,br',cr)
@test norm(ar*x+x*br'-cr)/norm(x) < reltol

@time x = sylvc(ar',br',cr)
@test norm(ar'*x+x*br'-cr)/norm(x) < reltol

@time x = sylvckr(ac,bc,cc)
@test norm(ac*x+x*bc-cc)/norm(x) < reltol

@time x = sylvc(ar,br,cr,blocksize = 5)
@test norm(ar*x+x*br-cr)/norm(x) < reltol

@time x = sylvc(arm,br,crm1,blocksize = 5)
@test norm(arm*x+x*br-crm1)/norm(x) < reltol

@time x = sylvc(ar,brm,crm2,blocksize = 5)
@test norm(ar*x+x*brm-crm2)/norm(x) < reltol

@time x = sylvc(arm,br,crm1,blocksize = 5)
@test norm(arm*x+x*br-crm1)/norm(x) < reltol

@time x = sylvc(ar',br,cr,blocksize = 5)
@test norm(ar'*x+x*br-cr)/norm(x) < reltol

@time x = sylvc(arm',br,crm1,blocksize = 5)
@test norm(arm'*x+x*br-crm1)/norm(x) < reltol

@time x = sylvc(ar',brm,crm2,blocksize = 5)
@test norm(ar'*x+x*brm-crm2)/norm(x) < reltol

@time x = sylvc(ar,br',cr,blocksize = 5)
@test norm(ar*x+x*br'-cr)/norm(x) < reltol

@time x = sylvc(ar,brm',crm2,blocksize = 5)
@test norm(ar*x+x*brm'-crm2)/norm(x) < reltol

@time x = sylvc(ar',brm,crm2,blocksize = 5)
@test norm(ar'*x+x*brm-crm2)/norm(x) < reltol

@time x = sylvc(ar',br',cr,blocksize = 5)
@test norm(ar'*x+x*br'-cr)/norm(x) < reltol

@time x = sylvc(arm',br',crm1,blocksize = 5)
@test norm(arm'*x+x*br'-crm1)/norm(x) < reltol

@time x = sylvc(ac,bc',cc,blocksize = 5)
@test norm(ac*x+x*bc'-cc)/norm(x) < reltol

@time x = sylvc(acd,bcd',cc)
@test norm(acd*x+x*bcd'-cc)/norm(x) < reltol

@time x = sylvc(ac',bc,cc)
@test norm(ac'*x+x*bc-cc)/norm(x) < reltol

@time x = sylvc(ac',bc,cc,blocksize = 5)
@test norm(ac'*x+x*bc-cc)/norm(x) < reltol

@time x = sylvc(ac',br,cc)
@test norm(ac'*x+x*br-cc)/norm(x) < reltol

@time x = sylvc(ac',bc',cc)
@test norm(ac'*x+x*bc'-cc)/norm(x) < reltol

@time x = sylvc(ac',bc',cc,blocksize = 5)
@test norm(ac'*x+x*bc'-cc)/norm(x) < reltol

@time x = sylvc(ac',br',cc)
@test norm(ac'*x+x*br'-cc)/norm(x) < reltol
end
end

@testset "Continuous Sylvester equations - Schur form" begin

try 
   sylvcs!(ones(1,1),-ones(1,1),ones(1,1)) 
   @test false
catch
   @test true
end

try 
   sylvcs!([1. -1; 1 1],-[1. -1; 1 1],ones(2,2)) 
   @test false
catch
   @test true
end

for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n); ard = Diagonal(ar);
ac = ar+im*rand(Ty,n,n); acd = Diagonal(ac);
br = rand(Ty,m,m); brd = Diagonal(br);
bc = br+im*rand(Ty,m,m); bcd = Diagonal(bc);
cr = rand(Ty,n,m);
cc = cr+im*rand(Ty,n,m);
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))
as, = schur(ar);
bs,  = schur(br);
acs, = schur(ac);
bcs, = schur(bc);
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))

for isgn in (1,-1)

y = copy(cr); @time sylvcs!(as,bs,y;isgn)
@test norm(as*y+isgn*y*bs-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(ard,brd,y;isgn)
@test norm(ard*y+isgn*y*brd-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(as,bs,y;isgn,adjA=true)
@test norm(as'*y+isgn*y*bs-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(as,bs,y;isgn,adjB=true)
@test norm(as*y+isgn*y*bs'-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(as,bs,y;isgn,adjA=true,adjB=true)
@test norm(as'*y+isgn*y*bs'-cr)/norm(y) < reltol

if Ty <: BlasFloat
y = copy(cr); @time sylvcs!(as,bs,y;isgn,blocked = true)
@test norm(as*y+isgn*y*bs-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(ard,brd,y;isgn,blocked = true)
@test norm(ard*y+isgn*y*brd-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(as,bs,y;isgn,adjA=true,blocked = true)
@test norm(as'*y+isgn*y*bs-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(as,bs,y;isgn,adjB=true,blocked = true)
@test norm(as*y+isgn*y*bs'-cr)/norm(y) < reltol

y = copy(cr); @time sylvcs!(as,bs,y;isgn,adjA=true,adjB=true,blocked = true)
@test norm(as'*y+isgn*y*bs'-cr)/norm(y) < reltol
end

y = copy(cc); @time sylvcs!(acs,bcs,y;isgn)
@test norm(acs*y+isgn*y*bcs-cc)/norm(y) < reltol

y = copy(cc); @time sylvcs!(acd,bcd,y;isgn)
@test norm(acd*y+isgn*y*bcd-cc)/norm(y) < reltol

y = copy(cc); @time sylvcs!(acs,bcs,y;isgn,adjA=true)
@test norm(acs'*y+isgn*y*bcs-cc)/norm(y) < reltol

y = copy(cc); @time sylvcs!(acd,bcd,y;isgn,adjA=true)
@test norm(acd'*y+isgn*y*bcd-cc)/norm(y) < reltol

y = copy(cc); @time sylvcs!(acs,bcs,y;isgn,adjB=true)
@test norm(acs*y+isgn*y*bcs'-cc)/norm(y) < reltol

y = copy(cc); @time sylvcs!(acd,bcd,y;isgn,adjB=true)
@test norm(acd*y+isgn*y*bcd'-cc)/norm(y) < reltol

y = copy(cc); @time sylvcs!(acs,bcs,y;isgn,adjA=true,adjB=true)
@test norm(acs'*y+isgn*y*bcs'-cc)/norm(y) < reltol

y = copy(cc); @time sylvcs!(acd,bcd,y;isgn,adjA=true,adjB=true)
@test norm(acd'*y+isgn*y*bcd'-cc)/norm(y) < reltol

end
end
end


# discrete Sylvester equations
@testset "Discrete Sylvester equations" begin

try 
   @time x = sylvd(ones(1,1),-ones(1,1),ones(1,1)) 
   @test false
catch
   @test true
end

try 
   @time x = sylvd([1 -1;1 1],-0.5*[1 -1;1 1],ones(2,2)) 
   @test false
catch
   @test true
end


for Ty in (Float64, Float32, BigFloat)
#  for Ty in (Float64, Float32)

ar = rand(Ty,n,n); ars = Symmetric(ar); ard = Diagonal(ar);
ac = ar+im*rand(Ty,n,n); ach = Hermitian(ac); acd = Diagonal(ac);
br = rand(Ty,m,m); brs = Symmetric(br); brd = Diagonal(br);
bc = br+im*rand(Ty,m,m);  bch = Hermitian(bc); bcd = Diagonal(bc);
cr = rand(Ty,n,m)
cc = cr+im*rand(Ty,n,m)
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))

arm = rand(Ty,ns,ns); acm = arm+im*rand(Ty,ns,ns); 
brm = rand(Ty,ms,ms); bcm = brm+im*rand(Ty,ms,ms);
crm1 = rand(Ty,ns,m); crm2 = rand(Ty,n,ms); ccm1 = crm1+im*rand(Ty,ns,m); ccm2 = crm2+im*rand(Ty,n,ms);



@time x = sylvd(Ty(1),Ty(2)*im,Ty(3))
@test abs(x*2*im+x-3.) < reltol

@time x = sylvd(ar,2I,cr)
@test norm(2*ar*x+x-cr)/norm(x) < reltol

@time x = sylvd(-3. *I,br,cr)
@test norm(-3*x*br+x-cr)/norm(x) < reltol

@time x = sylvd(-3.,br,cr)
@test norm(-3*x*br+x-cr)/norm(x) < reltol

@time x = sylvd(2I,3I,cr)
@test norm(2*x*3+x-cr)/norm(x) < reltol

@time x = sylvd(2,3,cr)
@test norm(2*x*3+x-cr)/norm(x) < reltol

@time x = sylvd(ar,br,cr)
@test norm(ar*x*br+x-cr)/norm(x) < reltol

@time x = sylvd(ar,br,cr)
@test norm(ar*x*br+x-cr)/norm(x) < reltol

@time x = sylvd(ars,brs,cr,blocksize = 5)
@test norm(ars*x*brs+x-cr)/norm(x) < reltol

@time x = sylvd(ard,brd,cr)
@test norm(ard*x*brd+x-cr)/norm(x) < reltol

@time x = sylvd(ar',br,cr)
@test norm(ar'*x*br+x-cr)/norm(x) < reltol

@time x = sylvd(ar,br',cr)
@test norm(ar*x*br'+x-cr)/norm(x) < reltol

@time x = sylvd(ar',br',cr)
@test norm(ar'*x*br'+x-cr)/norm(x) < reltol

@time x = sylvd(ar',br,cr,blocksize = 5)
@test norm(ar'*x*br+x-cr)/norm(x) < reltol

@time x = sylvd(ar,br',cr,blocksize = 5)
@test norm(ar*x*br'+x-cr)/norm(x) < reltol

@time x = sylvd(ar',br',cr,blocksize = 5)
@test norm(ar'*x*br'+x-cr)/norm(x) < reltol

@time x = sylvd(ac,bc,cc)
@test norm(ac*x*bc+x-cc)/norm(x) < reltol

@time x = sylvd(ac,bc,cc,blocksize = 5)
@test norm(ac*x*bc+x-cc)/norm(x) < reltol

@time x = sylvd(ach,bch,cc)
@test norm(ach*x*bch+x-cc)/norm(x) < reltol

@time x = sylvd(acd,bcd,cc)
@test norm(acd*x*bcd+x-cc)/norm(x) < reltol

@time x = sylvd(ac,bc',cc)
@test norm(ac*x*bc'+x-cc)/norm(x) < reltol

@time x = sylvd(ac',bc,cc)
@test norm(ac'*x*bc+x-cc)/norm(x) < reltol

@time x = sylvd(ac',bc',cc)
@test norm(ac'*x*bc'+x-cc)/norm(x) < reltol

@time x = sylvd(ac,bc',cc,blocksize = 5)
@test norm(ac*x*bc'+x-cc)/norm(x) < reltol

@time x = sylvd(ac',bc,cc,blocksize = 5)
@test norm(ac'*x*bc+x-cc)/norm(x) < reltol

@time x = sylvd(ac',bc',cc,blocksize = 5)
@test norm(ac'*x*bc'+x-cc)/norm(x) < reltol

@time x = sylvdkr(ac,bc,cc)
@test norm(ac*x*bc+x-cc)/norm(x) < reltol

@time x = sylvd(arm,br,crm1,blocksize = 5)
@test norm(arm*x*br+x-crm1)/norm(x) < reltol

@time x = sylvd(arm',br,crm1,blocksize = 5)
@test norm(arm'*x*br+x-crm1)/norm(x) < reltol

@time x = sylvd(arm,br',crm1,blocksize = 5)
@test norm(arm*x*br'+x-crm1)/norm(x) < reltol

@time x = sylvd(arm',br',crm1,blocksize = 5)
@test norm(arm'*x*br'+x-crm1)/norm(x) < reltol

@time x = sylvd(ar,brm,crm2,blocksize = 5)
@test norm(ar*x*brm+x-crm2)/norm(x) < reltol

@time x = sylvd(ar',brm,crm2,blocksize = 5)
@test norm(ar'*x*brm+x-crm2)/norm(x) < reltol

@time x = sylvd(ar,brm',crm2,blocksize = 5)
@test norm(ar*x*brm'+x-crm2)/norm(x) < reltol

@time x = sylvd(ar',brm',crm2,blocksize = 5)
@test norm(ar'*x*brm'+x-crm2)/norm(x) < reltol

end
end

@testset "Discrete Sylvester equations - Schur form" begin

for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n); ard = Diagonal(ar);
ac = ar+im*rand(Ty,n,n); acd = Diagonal(ac);
br = rand(Ty,m,m); brd = Diagonal(br);
bc = br-im*rand(Ty,m,m); bcd = Diagonal(bc);
cr = rand(Ty,n,m);
cc = cr+im*rand(Ty,n,m);
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))
as, = schur(ar);
bs,  = schur(br);
acs, = schur(ac);
bcs, = schur(bc);
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))

for isgn in (1,-1)

y = copy(cr); @time sylvds!(as,bs,y;isgn)
@test norm(as*y*bs+isgn*y-cr)/norm(y) < reltol

y = copy(cr); @time sylvds!(ard,brd,y;isgn)
@test norm(ard*y*brd+isgn*y-cr)/norm(y) < reltol

y = copy(cr); @time sylvds!(as,bs,y;isgn,adjA=true)
@test norm(as'*y*bs+isgn*y-cr)/norm(y) < reltol

y = copy(cr); @time sylvds!(as,bs,y;isgn,adjB=true)
@test norm(as*y*bs'+isgn*y-cr)/norm(y) < reltol

y = copy(cr); @time sylvds!(as,bs,y;isgn,adjA=true,adjB=true)
@test norm(as'*y*bs'+isgn*y-cr)/norm(y) < reltol

y = copy(cc); @time sylvds!(acs,bcs,y;isgn)
@test norm(acs*y*bcs+isgn*y-cc)/norm(y) < reltol

y = copy(cc); @time sylvds!(acd,bcd,y;isgn)
@test norm(acd*y*bcd+isgn*y-cc)/norm(y) < reltol

y = copy(cc); @time sylvds!(acs,bcs,y;isgn,adjA=true)
@test norm(acs'*y*bcs+isgn*y-cc)/norm(y) < reltol

y = copy(cc); @time sylvds!(acd,bcd,y;isgn,adjA=true)
@test norm(acd'*y*bcd+isgn*y-cc)/norm(y) < reltol

y = copy(cc); @time sylvds!(acs,bcs,y;isgn,adjB=true)
@test norm(acs*y*bcs'+isgn*y-cc)/norm(y) < reltol

y = copy(cc); @time sylvds!(acd,bcd,y;isgn,adjB=true)
@test norm(acd*y*bcd'+isgn*y-cc)/norm(y) < reltol

y = copy(cc); @time sylvds!(acs,bcs,y;isgn,adjA=true,adjB=true)
@test norm(acs'*y*bcs'+isgn*y-cc)/norm(y) < reltol

y = copy(cc); @time sylvds!(acd,bcd,y;isgn,adjA=true,adjB=true)
@test norm(acd'*y*bcd'+isgn*y-cc)/norm(y) < reltol
end

end
end

# generalized Sylvester equations
@testset "Generalized Sylvester equations" begin
try 
   gsylv(ones(1,1),-ones(1,1),ones(1,1),ones(1,1),ones(1,1)) 
   @test false
catch
   @test true
end

try 
   gsylv([1. -1; 1 1],-[1. -1; 1 1],[1. -1; 1 1],[1. -1; 1 1],ones(2,2)) 
   @test false
catch
   @test true
end

try 
   gsylv([0 -1; 1 0],[1. 0;0 1]',[1 0; 0 1],-[0 -1; 1 0]',ones(2,2))
   @test false
catch
   @test true
end


for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n);
ac = ar+im*rand(Ty,n,n);
br = rand(Ty,m,m);
bc = br+im*rand(Ty,m,m);
cr = rand(Ty,n,m);
cc = cr+im*rand(Ty,n,m);
dr = rand(Ty,n,n);
er = rand(Ty,m,m);
dc = dr+im*rand(Ty,n,n);
ec = er+im*rand(Ty,m,m);
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))

@time x = gsylv(ar,br,cr)
@test norm(ar*x*br-cr)/norm(x) < reltol

@time x = gsylv(2I,br,cr)
@test norm(2*x*br-cr)/norm(x) < reltol

@time x = gsylv(ar,2I,cr)
@test norm(ar*x*2-cr)/norm(x) < reltol

@time x = gsylv(2,br,cr)
@test norm(2*x*br-cr)/norm(x) < reltol

@time x = gsylv(2,1//2,cr)
@test norm(2*x/2-cr)/norm(x) < reltol

@time x = gsylv(ar,br,dr,er,cr)
@test norm(ar*x*br+dr*x*er-cr)/norm(x) < reltol

@time x = gsylv(ar,br,2I,cr)
@test norm(ar*x*br+2*x-cr)/norm(x) < reltol

@time x = gsylv(ar,br,2im,cr)
@test norm(ar*x*br+2*im*x-cr)/norm(x) < reltol

@time x = gsylv(ar,br,2*im*I,im,cr)
@test norm(ar*x*br-2*x-cr)/norm(x) < reltol

@time x = gsylv(ar,br,2*im*I,er,cr)
@test norm(ar*x*br+2*im*x*er-cr)/norm(x) < reltol

@time x = gsylv(ar,br,dr,2*im*I,cr)
@test norm(ar*x*br+2*im*dr*x-cr)/norm(x) < reltol

@time x = gsylv(ar,br,dr,er,cr)
@test norm(ar*x*br+dr*x*er-cr)/norm(x) < reltol

@time x = gsylv(ac,bc,dc,ec,cc)
@test norm(ac*x*bc+dc*x*ec-cc)/norm(x) < reltol

@time x = gsylv(ar',br,dr',er,cr)
@test norm(ar'*x*br+dr'*x*er-cr)/norm(x) < reltol

@time x = gsylv(ar,br',dr,er',cr)
@test norm(ar*x*br'+dr*x*er'-cr)/norm(x) < reltol

@time x = gsylv(ar',br',dr',er',cr)
@test norm(ar'*x*br'+dr'*x*er'-cr)/norm(x) < reltol

@time x = gsylv(ar,br',dr,er',cr)
@test norm(ar*x*br'+dr*x*er'-cr)/norm(x) < reltol

@time x = gsylv(ar',br',dr',er',cr)
@test norm(ar'*x*br'+dr'*x*er'-cr)/norm(x) < reltol

@time x = gsylv(ar',br,dr',er,cr)
@test norm(ar'*x*br+dr'*x*er-cr)/norm(x) < reltol

@time x = gsylv(ac',bc,-dc,ec',cc)
@test norm(ac'*x*bc-dc*x*ec'-cc)/norm(x) < reltol

@time x = gsylvkr(ar,br,dr,er,cr)
@test norm(ar*x*br+dr*x*er-cr)/norm(x) < reltol

@time x = gsylvkr(ac,bc,dc,ec,cc)
@test norm(ac*x*bc+dc*x*ec-cc)/norm(x) < reltol

@time x = gsylvkr(ar,br',-dr,er',cr)
@test norm(ar*x*br'-dr*x*er'-cr)/norm(x) < reltol

@time x = gsylvkr(ac',bc,-dc,ec',cc)
@test norm(ac'*x*bc-dc*x*ec'-cc)/norm(x) < reltol
end
end

@testset "Generalized Sylvester equations - Schur form" begin

for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n);
ac = ar+im*rand(Ty,n,n);
br = rand(Ty,m,m);
bc = br+im*rand(Ty,m,m);
cr = rand(Ty,n,m);
cc = cr+im*rand(Ty,n,m);
dr = rand(Ty,n,n);
er = rand(Ty,m,m);
dc = dr+im*rand(Ty,n,n);
ec = er+im*rand(Ty,m,m);
as = schur(ar).T
ds = triu(dr)
as = ds*as
bs = schur(br).T
es = triu(er)
bs = es*bs
acs, dcs = schur(ac,dc);
bcs, ecs = schur(bc,ec);
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))

for isgn in (1,-1)

y = copy(cr); @time gsylvs!(as,bs,ds,es,y)
@test norm(as*y*bs+ds*y*es-cr)/norm(y) < reltol

y = copy(cr); @time gsylvs!(as,bs,ds,es,y,adjAC=true)
@test norm(as'*y*bs+ds'*y*es-cr)/norm(y) < reltol

y = copy(cr); @time gsylvs!(as,bs,ds,es,y,adjBD=true)
@test norm(as*y*bs'+ds*y*es'-cr)/norm(y) < reltol

y = copy(cr); @time gsylvs!(as,bs,ds,es,y,adjAC=true,adjBD=true)
@test norm(as'*y*bs'+ds'*y*es'-cr)/norm(y) < reltol

y = copy(cc); @time gsylvs!(acs,bcs,dcs,ecs,y)
@test norm(acs*y*bcs+dcs*y*ecs-cc)/norm(y) < reltol

y = copy(cc); @time gsylvs!(acs,bcs,dcs,ecs,y,adjBD=true)
@test norm(acs*y*bcs'+dcs*y*ecs'-cc)/norm(y) < reltol

y = copy(cc); @time gsylvs!(acs,bcs,dcs,ecs,y,adjAC=true)
@test norm(acs'*y*bcs+dcs'*y*ecs-cc)/norm(y) < reltol

y = copy(cc); @time gsylvs!(acs,bcs,dcs,ecs,y,adjAC=true,adjBD=true)
@test norm(acs'*y*bcs'+dcs'*y*ecs'-cc)/norm(y) < reltol
end
end
end

# Sylvester systems
@testset "Sylvester systems" begin

for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n)
ac = ar+im*rand(Ty,n,n)
br = rand(Ty,m,m)
bc = br+im*rand(Ty,m,m)
cr = rand(Ty,n,m)
cc = cr+im*rand(Ty,n,m)
dr = rand(Ty,n,n)
er = rand(Ty,m,m)
dc = dr+im*rand(Ty,n,n)
ec = er+im*rand(Ty,m,m)
fr = rand(Ty,n,m)
fc = fr+im*rand(Ty,n,m)
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))


@time x, y = sylvsys(ar,br,cr,dr,er,fr)
@test norm(ar*x+y*br-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr*x+y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsys(ar,-br,cr,dr,-er,fr)
@test norm(ar*x-y*br-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr*x-y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsys(ac,bc,cc,dc,ec,fc)
@test norm(ac*x+y*bc-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dc*x+y*ec-fc)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsys(ac,-bc,cc,dc,-ec,fc)
@test norm(ac*x-y*bc-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dc*x-y*ec-fc)/max(norm(x),norm(y)) < reltol


@time x, y = sylvsys(ac,bc,cc,dc,ec,fr)
@test norm(ac*x+y*bc-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dc*x+y*ec-fr)/max(norm(x),norm(y)) < reltol


@time x, y = sylvsys(ar,br,cr,dr,er,fc)
@test norm(ar*x+y*br-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr*x+y*er-fc)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsys(ar,br',cr,dr',er,fr)
@test norm(ar*x+y*br'-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr'*x+y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsyskr(ar,br,cr,dr,er,fr)
@test norm(ar*x+y*br-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr*x+y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsyskr(ar,-br,cr,dr,-er,fr)
@test norm(ar*x-y*br-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr*x-y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsyskr(ac,bc,cc,dc,ec,fc)
@test norm(ac*x+y*bc-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dc*x+y*ec-fc)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsyskr(ac,-bc,cc,dc,-ec,fc)
@test norm(ac*x-y*bc-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dc*x-y*ec-fc)/max(norm(x),norm(y)) < reltol

end
end

# dual Sylvester systems
@testset "Dual Sylvester systems" begin

for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n)
ac = ar+im*rand(Ty,n,n)
br = rand(Ty,m,m)
bc = br+im*rand(Ty,m,m)
cr = rand(Ty,n,m)
cc = cr+im*rand(Ty,n,m)
dr = rand(Ty,n,n)
er = rand(Ty,m,m)
dc = dr+im*rand(Ty,n,n)
ec = er+im*rand(Ty,m,m)
fr = rand(Ty,n,m)
fc = fr+im*rand(Ty,n,m)
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))


@time x, y = dsylvsys(ar,br,cr,dr,er,fr)
@test norm(ar*x+dr*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*br+y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ar',br',cr,dr',er',fr)
@test norm(ar'*x+dr'*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*br'+y*er'-fr)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ar',br',cr,-dr',-er',fr)
@test norm(ar'*x-dr'*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*br'-y*er'-fr)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ar,br',cr,dr',er,fr)
@test norm(ar*x+dr'*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*br'+y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ac,bc,cc,dc,ec,fc)
@test norm(ac*x+dc*y-cc)/max(norm(x),norm(y)) < reltol &&
      norm(x*bc+y*ec-fc)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ac',bc',cc,dc',ec',fc)
@test norm(ac'*x+dc'*y-cc)/max(norm(x),norm(y)) < reltol &&
      norm(x*bc'+y*ec'-fc)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ac',bc',cc,-dc',-ec',fc)
@test norm(ac'*x-dc'*y-cc)/max(norm(x),norm(y)) < reltol &&
      norm(x*bc'-y*ec'-fc)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ac',bc,cc,dc,ec',fc)
@test norm(ac'*x+dc*y-cc)/max(norm(x),norm(y)) < reltol &&
      norm(x*bc+y*ec'-fc)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsys(ar',bc,cc,dr,ec',fc)
@test norm(ar'*x+dr*y-cc)/max(norm(x),norm(y)) < reltol &&
      norm(x*bc+y*ec'-fc)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsyskr(ar',br',cr,dr',er',fr)
@test norm(ar'*x+dr'*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*br'+y*er'-fr)/max(norm(x),norm(y)) < reltol

end
end


# LAPACK wrappers of Sylvester system solvers
@testset "LAPACK wrappers of Sylvester system solvers" begin

for Ty in (Float64, Float32, BigFloat)
#for Ty in (Float64, Float32)

ar = rand(Ty,n,n)
ac = ar+im*rand(Ty,n,n)
br = rand(Ty,m,m)
bc = br+im*rand(Ty,m,m)
cr = rand(Ty,n,m)
cc = cr+im*rand(Ty,n,m)
dr = rand(Ty,n,n)
er = rand(Ty,m,m)
dc = dr+im*rand(Ty,n,n)
ec = er+im*rand(Ty,m,m)
fr = rand(Ty,n,m)
fc = fr+im*rand(Ty,n,m)
as = schur(ar).T
ds = triu(dr)
bs = schur(br).T
es = triu(er)
acs, dcs = schur(ac,dc)
bcs, ecs = schur(bc,ec)
Ty == Float64 ? reltol = eps(float(10*n*m)) : reltol = eps(10*n*m*one(Ty))

if Ty <: LinearAlgebra.BlasFloat

   x = copy(cr); y = copy(fr);
   @time x, y, scale =  tgsyl!(as, bs, x, ds, es, y)
   @test norm(as*x-y*bs-cr)/max(norm(x),norm(y)) < reltol &&
         norm(ds*x-y*es-fr)/max(norm(x),norm(y)) < reltol
   
   x = copy(cr); y = copy(fr);
   @time x, y, scale =  tgsyl!('T',as, bs, x, ds, es, y)
   @test norm(as'*x+ds'*y-cr)/max(norm(x),norm(y)) < reltol &&
         norm(x*bs'+y*es'+fr)/max(norm(x),norm(y)) < reltol  

   x = copy(cc); y = copy(fc);
   @time x, y, scale =  tgsyl!(acs, bcs, x, dcs, ecs, y)
   @test norm(acs*x-y*bcs-cc)/max(norm(x),norm(y)) < reltol &&
         norm(dcs*x-y*ecs-fc)/max(norm(x),norm(y)) < reltol
   
   x = copy(cc); y = copy(fc);
   @time x, y, scale =  tgsyl!('C',acs, bcs, x, dcs, ecs, y)
   @test norm(acs'*x+dcs'*y-cc)/max(norm(x),norm(y)) < reltol &&
         norm(x*bcs'+y*ecs'+fc)/max(norm(x),norm(y)) < reltol
   
   x = copy(cr); y = copy(fr);
   @time x, y, scale =  tgsyl!(as, bs, x, ds, es, y)
   @test norm(as*x-y*bs-cr)/max(norm(x),norm(y)) < reltol &&
         norm(ds*x-y*es-fr)/max(norm(x),norm(y)) < reltol
   
   x = copy(cr); y = copy(fr);
   @time x, y, scale =  tgsyl!('T',as, bs, x, ds, es, y)
   @test norm(as'*x+ds'*y-cr)/max(norm(x),norm(y)) < reltol &&
         norm(x*bs'+y*es'+fr)/max(norm(x),norm(y)) < reltol
   
   
   x = copy(cc); y = copy(fc);
   @time x, y, scale =  tgsyl!(acs, bcs, x, dcs, ecs, y)
   @test norm(acs*x-y*bcs-cc)/max(norm(x),norm(y)) < reltol &&
         norm(dcs*x-y*ecs-fc)/max(norm(x),norm(y)) < reltol
   
   x = copy(cc); y = copy(fc);
   @time x, y, scale =  tgsyl!('C',acs, bcs, x, dcs, ecs, y)
   @test norm(acs'*x+dcs'*y-cc)/max(norm(x),norm(y)) < reltol &&
         norm(x*bcs'+y*ecs'+fc)/max(norm(x),norm(y)) < reltol
   
end

x = copy(cr); y = copy(fr);
@time x, y =  sylvsyss!(as, bs, x, ds, es, y)
@test norm(as*x+y*bs-cr)/max(norm(x),norm(y)) < reltol &&
      norm(ds*x+y*es-fr)/max(norm(x),norm(y)) < reltol

x = copy(cr); y = copy(fr);
@time x, y =  dsylvsyss!(false,as, bs, x, ds, es, y)
@test norm(as*x+ds*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*bs+y*es-fr)/max(norm(x),norm(y)) < reltol

x = copy(cr); y = copy(fr);
@time x, y =  dsylvsyss!(true,as, bs, x, ds, es, y)
@test norm(as'*x+ds'*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*bs'+y*es'-fr)/max(norm(x),norm(y)) < reltol

x = copy(cc); y = copy(fc);
@time x, y =  sylvsyss!(acs, bcs, x, dcs, ecs, y)
@test norm(acs*x+y*bcs-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dcs*x+y*ecs-fc)/max(norm(x),norm(y)) < reltol

x = copy(cc); y = copy(fc);
@time x, y =  dsylvsyss!(false,acs, bcs, x, dcs, ecs, y)
@test norm(acs*x+dcs*y-cc)/max(norm(x),norm(y)) < reltol &&
      norm(x*bcs+y*ecs-fc)/max(norm(x),norm(y)) < reltol

x = copy(cc); y = copy(fc);
@time x, y =  dsylvsyss!(true,acs, bcs, x, dcs, ecs, y)
@test norm(acs'*x+dcs'*y-cc)/max(norm(x),norm(y)) < reltol &&
      norm(x*bcs'+y*ecs'-fc)/max(norm(x),norm(y)) < reltol

end
end

end

end

"""
     isschur(A::AbstractMatrix) -> Bool

Test whether `A` is a square matrix in a real or complex Schur form.
In the real case, it is only tested whether A is a quasi upper triangular matrix,
which may have 2x2 diagonal blocks, which however must not correspond to
complex conjugate eigenvalues. In the complex case, it is tested if `A`
is upper triangular.
"""
function isschur(A)
   require_one_based_indexing(A)
   m, n = size(A)
   m == n || (return false)
   m == 1 && (return true)
   eltype(A)<:Complex && (return istriu(A))
   m == 2 && (return true)
   if istriu(A,-1)
      for i = 1:m-2
         if !iszero(A[i+1,i]) & !iszero(A[i+2,i+1])
            return false
         end
      end
      return true
   else
      return false
   end
end
"""
     isschur(A::AbstractMatrix, B::AbstractMatrix) -> Bool

Test whether `(A,B)` is a pair of square matrices in a real or complex
generalized Schur form.
In the real case, it is only tested whether `B` is upper triangular and `A` is
a quasi upper triangular matrix, which may have 2x2 diagonal blocks, which
however must not correspond to complex conjugate eigenvalues.
In the complex case, it is tested if `A` and `B` are both upper triangular.

"""
function isschur(A::AbstractMatrix,B::AbstractMatrix)
   ma, na = size(A)
   mb, nb = size(B)
   if eltype(A) != eltype(B) || ma != na || mb != nb || na != nb
      return false
   end
   return isschur(A) && istriu(B)
end
function sfstruct(A)
   # determine the structure of the generalized real Schur form
   n = size(A,1)
   ba = fill(1,n)
   p = 0
   i = 1
   while i < n
      p += 1
      iszero(A[i+1,i]) ? (i += 1) : (ba[p] = 2; i += 2)
   end
   i == n && (p += 1)
   return resize!(ba,p), p
   #return ba[1:p], p
end

"""
    utqu!(Q,U) -> Q

Compute efficiently the symmetric/hermitian product `U'QU -> Q`,
where `Q` is a symmetric/hermitian matrix and `U` is a square matrix.
The resulting product overwrites `Q`.
"""
function utqu!(Q,U)
   n = LinearAlgebra.checksquare(Q)
   ishermitian(Q) || error("Q must be a symmetric/hermitian matrix")
   LinearAlgebra.checksquare(U) == n ||
      throw(DimensionMismatch("U must be a matrix of dimension $n x $n"))

   T = promote_type(eltype(Q),eltype(U))
   if !(T <: BlasFloat)
      if T == eltype(Q)
         Q[:,:] = U'*Q*U
         return
      else
         error("TypeError: same type expected for Q and U ")
      end
   end


   Qd = view(Q,diagind(Q))
   rmul!(Qd,one(T)/2)
   if isa(U,Adjoint)
      mul!(Q, U.parent*UpperTriangular(Q), U)
   else
      mul!(Q, Adjoint(U), UpperTriangular(Q)*U)
   end
   #Q = tmp+tmp'
   @inbounds  begin
      for j = 1:n
       Q[j,j] += conj(Q[j,j])
       for i = j+1:n
           Q[i,j] += conj(Q[j,i])
           Q[j,i] = conj(Q[i,j])
       end
   end
   end
   return Q
end

function utqu!(Q::AbstractMatrix{T}, U::AbstractMatrix{T}, W::AbstractMatrix{T}) where {T}
    n = LinearAlgebra.checksquare(Q)
    LinearAlgebra.checksquare(U) == n || throw(DimensionMismatch("U must be $n x $n"))
    size(W) == (n, n)   || throw(DimensionMismatch("Workspace W must be $n x $n"))
    
    # 1. Halve the diagonal in-place safely across all precision types
    @inbounds for i in 1:n
        Q[i, i] /= 2
    end

    # 2. Compute the multi-stage multiplication using pre-allocated workspace W
    if isa(U, Adjoint)
        # Goal: Q = Uparent * UpperTriangular(Q) * Uparent'
        mul!(W, UpperTriangular(Q), Adjoint(U.parent), one(T), zero(T))
        mul!(Q, U.parent, W, one(T), zero(T))
    else
        # Goal: Q = U' * UpperTriangular(Q) * U
        mul!(W, UpperTriangular(Q), U, one(T), zero(T))
        mul!(Q, Adjoint(U), W, one(T), zero(T))
    end

    # 3. Column-major Symmetrization
    @inbounds for j = 1:n
        Q[j, j] = 2 * real(Q[j, j])
        for i = j+1:n
            val = Q[i, j] + conj(Q[j, i])
            Q[i, j] = val
            Q[j, i] = conj(val)
        end
    end
    return Q
end

# Helper to copy only the upper triangle cleanly without allocating a full matrix first
function copy_upper(Q::AbstractMatrix, ::Type{T}) where {T}
    n = size(Q, 1)
    out = Matrix{T}(undef, n, n)
    @inbounds for j in 1:n
        for i in 1:j
            out[i, j] = Q[i, j]
        end
    end
    return out
end

"""
    X = utqu(Q,U)

Compute efficiently the symmetric/hermitian product `X = U'QU`,
where Q is a symmetric/hermitian matrix.
"""
function utqu(Q,U)
   n = LinearAlgebra.checksquare(Q)
   ishermitian(Q) || error("Q must be a symmetric/hermitian matrix")
   adj = isa(U,Adjoint)
   if adj
      m, n1 = size(U.parent)
      n1 == n || throw(DimensionMismatch("U must be a matrix of column dimension $n"))
   else
      n1, m = size(U)
      n1 == n || throw(DimensionMismatch("U must be a matrix of row dimension $n"))
   end

   T = promote_type(eltype(Q),eltype(U))
   # if !(T <: BlasFloat)
   #    return U'*Q*U
   # end

   t = UpperTriangular(Q)-Diagonal(Q[diagind(Q)]./2)
   X = similar(Q, T, m, m)
   if adj
      mul!(X, U.parent*t, U)
   else
      mul!(X, Adjoint(U), t*U)
   end
   @inbounds  begin
   for j = 1:m
       X[j,j] += conj(X[j,j])
       for i = j+1:m
           X[i,j] += conj(X[j,i])
           X[j,i] = conj(X[i,j])
      end
   end
   end
   return X
end
"""
    qrupdate!(R, Y) -> R

Update the upper triangular factor `R` by the
upper triangular factor of the QR factorization  of `[ R; Y' ]`, where `Y` is a
low-rank matrix `Y` (typically with one or two columns). The computation of `R`
only uses `O(n^2)` operations (`n` is the size of `R`). The input matrix `R` is
updated in place and the matrix `Y` is destroyed during the computation.
"""
function qrupdate!(R, Y)
    n, m = size(Y)
    size(R,1) == n || throw(DimensionMismatch("updating matrix must fit size of upper triangular matrix"))
    @inbounds for k in 1:m
        for i in 1:n

            # Compute Givens rotation
            #c, s, r = LinearAlgebra.givensAlgorithm(R[i,i], conj(Y[i,k]))
            c, s, r = LinearAlgebra.givensAlgorithm(R[i,i], Y[i,k])

            # Store new diagonal element
            R[i,i] = r

            # Update remaining elements in row/column
            @simd for j in i+1:n
                Rij = R[i,j]
                yjk  = Y[j,k]
                R[i,j]  =   c*Rij + s*yjk
                Y[j,k]    = -s'*Rij + c*yjk
            end
        end
    end
    return R
end
"""

    rqupdate!(R, Y) -> R

Update the upper triangular factor `R` by the
upper triangular factor of the RQ factorization  of `[ Y R]`, where `Y` is a
low-rank matrix `Y` (typically with one or two columns). The computation of `R`
only uses `O(n^2)` operations (`n` is the size of `R`). The input matrix `R` is
updated in place and the matrix `Y` is destroyed during the computation.
"""
function rqupdate!(R, Y)
    n, m = size(Y)
    size(R,1) == n || throw(DimensionMismatch("updating matrix must fit size of upper triangular matrix"))

    @inbounds for k in 1:m
        for j in n:-1:1

            # Compute Givens rotation
            c, s, r = LinearAlgebra.givensAlgorithm(R[j,j], Y[j,k])

            # Store new diagonal element
            R[j,j] = r

            # Update remaining elements in row/column
            @simd for i in 1:j-1
                Rij = R[i,j]
                yik  = Y[i,k]
                R[i,j]  =   c*Rij + s*yik
                Y[i,k]    = -s'*Rij + c*yik
            end
        end
    end
    return R
end
"""
    x = triu2vec(Q; rowwise = false, her = false)

Reshape the upper triangular part of the `nxn` array `Q` as a one-dimensional column
vector `x` with `n(n+1)/2` elements. `Q` is assumed symmetric/hermitian if `her = true`.
The elements of `x` correspond to stacking the elements of successive columns
of the upper triangular part of `Q`, if `rowwise = false`, or stacking the elements
of successive rows of the upper triangular part of `Q`, if `rowwise = true`.
"""
function triu2vec(Q::AbstractArray{T}; rowwise::Bool = false, her::Bool = false) where T
   n = LinearAlgebra.checksquare(Q)
   her && !ishermitian(Q) && error("Q must be a symmetric/hermitian matrix")
   x = Array{T,1}(undef,Int(n*(n+1)/2))
   k = 1
   if rowwise
      for i = 1:n
         for j = i:n
             x[k] = Q[i,j]
             k += 1
         end
      end
   else
      for j = 1:n
         for i = 1:j
             x[k] = Q[i,j]
             k += 1
         end
      end
   end
   return x
end
"""
    Q = vec2triu(x; rowwise = false, her = false)

Build from a one-dimensional column vector `x` with `n(n+1)/2` elements
an `nxn` upper triangular matrix `Q` if `her = false` or an `nxn` symmetric/hermitian
array `Q` if `her = true`.
The elements of `x` correspond to stacking the elements of successive columns
of the upper triangular part of `Q`, if `rowwise = false`, or stacking the elements
of successive rows of the upper triangular part of `Q`, if `rowwise = true`.
"""
function vec2triu(x::AbstractVector{T}; rowwise = false, her = false) where T
   k = length(x)
   n = (sqrt(1+8*k)-1)/2
   isinteger(n) ? n = Int(n) : error("The lenght of x must be of the form n(n+1)/2")
   her ? Q = Array{T,2}(undef,n,n) : Q = zeros(T,n,n)
   k = 1
   if rowwise
      for i = 1:n
         Q[i,i] = x[k]
         k += 1
         for j = i+1:n
            Q[i,j] = x[k]
            k += 1
         end
      end
   else
      for j = 1:n
         for i = 1:j-1
            Q[i,j] = x[k]
            k += 1
         end
         Q[j,j] = x[k]
         k += 1
      end
   end
   if her
      for j = 1:n
         for i = j+1:n
            Q[i,j] = conj(Q[j,i])
         end
      end
   end
   return Q
end
function utnormalize!(U::UpperTriangular{T},adj::Bool) where T
   # Normalize an upper traiangular matrix U such that its diagonal elements are non-negative
   # using diagonal orthogonal or unitary transformations.
   ZERO = zero(real(T))
   n = size(U,1)
   if adj
      # Make the diagonal elements of U non-negative.
      if T <: Real
            for i = 1:n
               U[i,i] > ZERO || (rmul!(view(U,i,i:n),-1))
            end
      else
         for i = 1:n
            d = abs(U[i,i])
            (!iszero(d) && !(iszero(imag(U[i,i])) && real(U[i,i]) > ZERO)) && 
               (tmp = conj(U[i,i])/d; rmul!(view(U,i,i:n),tmp))
               #(tmp = conj(U[i,i])/d; [@inbounds U[i,j] *= tmp for j = i:n])
         end
      end
   else
      # Make the diagonal elements of U non-negative.
      if T <: Real
         for j = 1:n
            U[j,j] > ZERO || (rmul!(view(U,1:j,j),-1))
         end
      else
         for j = 1:n
            d = abs(U[j,j])
            (!iszero(d) && (iszero(imag(U[j,j])) && real(U[j,j]) > ZERO)) && 
               (tmp = conj(U[j,j]) / d; rmul!(view(U, 1:j, j), tmp))
               #(tmp = conj(U[j,j])/d; [@inbounds U[i,j] *= tmp for i = 1:j])
         end
      end
   end
   return U
end

@inline function luslv!(A::AbstractMatrix{T}, B::AbstractVector{T}, n::Int = length(B)) where T
   # Accepts an optional or explicit `n` to limit operations to a sub-block
   @inbounds begin
         for k = 1:n
            # find index max
            kp = k
            if k < n
                amax = abs(A[k, k])
                for i = k+1:n
                    absi = abs(A[i,k])
                    if absi > amax
                        kp = i
                        amax = absi
                    end
                end
            end
            iszero(A[kp,k]) && return true
            if k != kp
               # Interchange
               for i = 1:n
                   tmp = A[k,i]
                   A[k,i] = A[kp,i]
                   A[kp,i] = tmp
               end
               tmp = B[k]
               B[k] = B[kp]
               B[kp] = tmp
            end
            # Scale first column
            Akkinv = inv(A[k,k])
            
            # Using IdentityUnitRange makes these internal views 0-allocation
            i1 = Base.IdentityUnitRange(k+1:n)
            Ak = view(A, i1, k)
            rmul!(Ak, Akkinv)
            
            # Update the rest of A and B
            for j = k+1:n
                axpy!(-A[k,j], Ak, view(A, i1, j))
            end
            axpy!(-B[k], Ak, view(B, i1))
         end
         
         # Solve the upper triangular system for the active n x n sub-block
         i_all = Base.IdentityUnitRange(1:n)
         ldiv!(UpperTriangular(view(A, i_all, i_all)), view(B, i_all))
         
         # Check finiteness only on the active elements
         for i = 1:n
             !isfinite(B[i]) && return true
         end
         return false
   end
end
function _lanv2(a::T,b::T,c::T,d::T) where {T <: Real}
   # compute the eigenvalues of a real 2x2 [a b; c d] in e1r, e1i, e2r, e2i 
   # extracted from the translation from LAPACK::dlanv2 by Ralph Smith
   # Copyright:
   # Univ. of Tennessee
   # Univ. of California Berkeley
   # Univ. of Colorado Denver
   # NAG Ltd.
   ZERO = zero(T)
   ONE = one(T)
   sgn(x) = (x < 0) ? -ONE : ONE # fortran sign differs from Julia
   half = ONE / 2
   small = 4eps(T) # how big discriminant must be for easy reality check
   if c==0
   elseif b==0
       # swap rows/cols
       a,b,c,d = d,-c,ZERO,a
   elseif ((a-d) == 0) && (b*c < 0)
       # nothing to do
   else
       asubd = a-d
       p = half*asubd
       bcmax = max(abs(b),abs(c))
       bcmis = min(abs(b),abs(c)) * sgn(b) * sgn(c)
       scale = max(abs(p), bcmax)
       z = (p / scale) * p + (bcmax / scale) * bcmis
       # if z is of order machine accuracy: postpone decision
       if z >= small
           # real eigenvalues
           z = p + sqrt(scale) * sqrt(z) * sgn(p)
           a = d + z
           d -= (bcmax / z) * bcmis
           b -= c
           c = ZERO
       else
           # complex or almost equal real eigenvalues
           σ = b + c
           τ = hypot(σ, asubd)
           cs = sqrt(half * (ONE + abs(σ) / τ))
           sn = -(p / (τ * cs)) * sgn(σ)
           # apply rotations
           aa = a*cs + b*sn
           bb = -a*sn + b*cs
           cc = c*cs + d*sn
           dd = -c*sn + d*cs
           a = aa*cs + cc*sn
           b = bb*cs + dd*sn
           c = -aa*sn + cc*cs
           d = -bb*sn + dd*cs
           midad = half * (a+d)
           a = midad
           d = a
           if (c != 0)
               if (b != 0)
                   if b*c >= 0
                       # real eigenvalues
                       sab = sqrt(abs(b))
                       sac = sqrt(abs(c))
                       p = sab*sac*sgn(c)
                       a = midad + p
                       d = midad - p
                       b -= c
                       c = 0
                   end
               else
                   b,c = -c,ZERO
               end
           end
       end
   end

   w1r,w2r = a, d
   if c==0
       w1i,w2i = ZERO,ZERO
   else
       rti = sqrt(abs(b))*sqrt(abs(c))
       w1i,w2i = rti,-rti
   end
   return w1r,w1i,w2r,w2i
end
function _lanv2!(H2::StridedMatrix{T}) where {T <: Real}
   # compute the Schur decomposition of a real 2x2 matrix H2 in standard form
   # return the eigenvalues in e1r, e1i, e2r, e2i and 
   # the elements cs and sn of the corresponding Givens rotation
   # Translated from LAPACK::dlanv2 by Ralph Smith within the GenericSchur.jl
   a,b,c,d = H2[1,1], H2[1,2], H2[2,1], H2[2,2]
   ZERO = zero(T)
   ONE = one(T)
   sgn(x) = (x < 0) ? -ONE : ONE # fortran sign differs from Julia
   half = ONE / 2
   small = 4eps(T) # how big discriminant must be for easy reality check
   if c==0
       cs = ONE
       sn = ZERO
   elseif b==0
       # swap rows/cols
       cs = ZERO
       sn = ONE
       a,b,c,d = d,-c,ZERO,a
   elseif ((a-d) == 0) && (b*c < 0)
       # nothing to do
       cs = ONE
       sn = ZERO
   else
       asubd = a-d
       p = half*asubd
       bcmax = max(abs(b),abs(c))
       bcmis = min(abs(b),abs(c)) * sgn(b) * sgn(c)
       scale = max(abs(p), bcmax)
       z = (p / scale) * p + (bcmax / scale) * bcmis
       # if z is of order machine accuracy: postpone decision
       if z >= small
           # real eigenvalues
           z = p + sqrt(scale) * sqrt(z) * sgn(p)
           a = d + z
           d -= (bcmax / z) * bcmis
           τ = hypot(c,z)
           cs = z / τ
           sn = c / τ
           b -= c
           c = ZERO
       else
           # complex or almost equal real eigenvalues
           σ = b + c
           τ = hypot(σ, asubd)
           cs = sqrt(half * (ONE + abs(σ) / τ))
           sn = -(p / (τ * cs)) * sgn(σ)
           # apply rotations
           aa = a*cs + b*sn
           bb = -a*sn + b*cs
           cc = c*cs + d*sn
           dd = -c*sn + d*cs
           a = aa*cs + cc*sn
           b = bb*cs + dd*sn
           c = -aa*sn + cc*cs
           d = -bb*sn + dd*cs
           midad = half * (a+d)
           a = midad
           d = a
           if (c != 0)
               if (b != 0)
                   if b*c >= 0
                       # real eigenvalues
                       sab = sqrt(abs(b))
                       sac = sqrt(abs(c))
                       p = sab*sac*sgn(c)
                       τ = ONE / sqrt(abs(b+c))
                       a = midad + p
                       d = midad - p
                       b -= c
                       c = 0
                       cs1 = sab*τ
                       sn1 = sac*τ
                       cs, sn = cs*cs1 - sn*sn1, cs*sn1 + sn*cs1
                   end
               else
                   b,c = -c,ZERO
                   cs,sn = -sn,cs
               end
           end
       end
   end

   if c==0
       w1r,w1i,w2r,w2i = a,ZERO,d,ZERO
   else
       rti = sqrt(abs(b))*sqrt(abs(c))
       w1r,w1i,w2r,w2i = a,rti,d,-rti
   end
   H2[1,1], H2[1,2], H2[2,1], H2[2,2] = a,b,c,d

   return w1r,w1i,w2r,w2i,cs,sn
end
"""
A "safe" version of `floatmin`, such that `1/sfmin` does not overflow.
(used in the GenericSchur package of Ralph Smith)
"""
function _safemin(T)
   sfmin = floatmin(T)
   small = one(T) / floatmax(T)
   if small >= sfmin
       sfmin = small * (one(T) + eps(T))
   end
   sfmin
end
function _lag2(a::StridedMatrix{T},b::StridedMatrix{T},safmin::T) where {T <: Real}
   #
   #    _lag2(A, B, SAFMIN) -> (SCALE1, SCALE2, WR1, WR2, WI)
   #
   # Compute the eigenvalues of a 2-by-2 generalized real eigenvalue problem for
   # the matrix pair `(A,B)`, with scaling as necessary to avoid over-/underflow.
   # `SAFMIN` is the smallest positive number s.t. `1/SAFMIN` does not overflow.
   # If `WI = 0`, `WR1/SCALE1` and `WR2/SCALE2` are the resulting real eigenvalues, while
   # if `WI <> 0`, then `(WR1+/-im*WI)/SCALE1` are the resulting complex eigenvalues.
   # Conversion of the LAPACK subroutines DLAG2/SLAG2.

   ZERO = zero(T)
   ONE = one(T)
   two = 2*ONE
   half = ONE/2
   fuzzy1 = ONE+ONE/10000

   rtmin = sqrt( safmin )
   rtmax = ONE / rtmin
   safmax = ONE / safmin
#
#     Scale A
#
   anorm = max( abs( a[ 1, 1 ] )+abs( a[ 2, 1 ] ),
                abs( a[ 1, 2 ] )+abs( a[ 2, 2 ] ), safmin )
   ascale = ONE / anorm
   a11 = ascale*a[ 1, 1 ]
   a21 = ascale*a[ 2, 1 ]
   a12 = ascale*a[ 1, 2 ]
   a22 = ascale*a[ 2, 2 ]
#
#     Perturb B if necessary to insure non-singularity
#
   b11 = b[ 1, 1 ]
   b12 = b[ 1, 2 ]
   b22 = b[ 2, 2 ]
   bmin = rtmin*max( abs( b11 ), abs( b12 ), abs( b22 ), rtmin )
   abs( b11 ) < bmin && (b11 = bmin*sign(b11))
   abs( b22 ) < bmin && (b22 = bmin*sign(b22))
#
#     Scale B
#
   bnorm = max( abs( b11 ), abs( b12 )+abs( b22 ), safmin )
   bsize = max( abs( b11 ), abs( b22 ) )
   bscale = ONE / bsize
   b11 = b11*bscale
   b12 = b12*bscale
   b22 = b22*bscale
#
#     Compute larger eigenvalue by method described by C. van Loan
#
#     ( AS is A shifted by -SHIFT*B )
#
   binv11 = ONE / b11
   binv22 = ONE / b22
   s1 = a11*binv11
   s2 = a22*binv22
   if abs( s1 ) <= abs( s2 ) 
      as12 = a12 - s1*b12
      as22 = a22 - s1*b22
      ss = a21*( binv11*binv22 )
      abi22 = as22*binv22 - ss*b12
      pp = half*abi22
      shift = s1
   else
      as12 = a12 - s2*b12
      as11 = a11 - s2*b11
      ss = a21*( binv11*binv22 )
      abi22 = -ss*b12
      pp = half*( as11*binv11+abi22 )
      shift = s2
   end
   qq = ss*as12
   if abs( pp*rtmin ) >= ONE
      discr = ( rtmin*pp )^2 + qq*safmin
      r = sqrt( abs( discr ) )*rtmax
   else
      if pp^2+abs( qq ) <= safmin 
         discr = ( rtmax*pp )^2 + qq*safmax
         r = sqrt( abs( discr ) )*rtmin
      else
         discr = pp^2 + qq
         r = sqrt( abs( discr ) )
      end
   end
#
#     Note: the test of R in the following IF is to cover the case when
#           DISCR is small and negative and is flushed to zero during
#           the calculation of R.  On machines which have a consistent
#           flush-to-zero threshold and handle numbers above that
#           threshold correctly, it would not be necessary.
#
   if discr >= ZERO  ||  r == ZERO 
      t = r*sign(pp)
      sum = pp + t
      diff = pp - t
      wbig = shift + sum
#
#        Compute smaller eigenvalue
#
      wsmall = shift + diff
      if half*abs( wbig ) > max( abs( wsmall ), safmin ) 
         wdet = ( a11*a22-a12*a21 )*( binv11*binv22 )
         wsmall = wdet / wbig
      end
#
#        Choose (real) eigenvalue closest to 2,2 element of A*B**(-1)
#        for WR1.
#
      if pp > abi22 
         wr1 = min( wbig, wsmall )
         wr2 = max( wbig, wsmall )
      else
         wr1 = max( wbig, wsmall )
         wr2 = min( wbig, wsmall )
      end
      wi = ZERO
   else
#
#        Complex eigenvalues
#
      wr1 = shift + pp
      wr2 = wr1
      wi = r
   end
#
#     Further scaling to avoid underflow and overflow in computing
#     SCALE1 and overflow in computing w*B.
#
#     This scale factor (WSCALE) is bounded from above using C1 and C2,
#     and from below using C3 and C4.
#        C1 implements the condition  s A  must never overflow.
#        C2 implements the condition  w B  must never overflow.
#        C3, with C2,
#           implement the condition that s A - w B must never overflow.
#        C4 implements the condition  s    should not underflow.
#        C5 implements the condition  max(s,|w|) should be at least 2.
#
   c1 = bsize*( safmin*max( ONE, ascale ) )
   c2 = safmin*max( ONE, bnorm )
   c3 = bsize*safmin
   if ascale <= ONE && bsize <= ONE 
      c4 = min( ONE, ( ascale / safmin )*bsize )
   else
      c4 = ONE
   end
   if ascale <= ONE  ||  bsize <= ONE 
      c5 = min( ONE, ascale*bsize )
   else
      c5 = ONE
   end
#
#     Scale first eigenvalue
#
   wabs = abs( wr1 ) + abs( wi )
   wsize = max( safmin, c1, fuzzy1*( wabs*c2+c3 ),
                min( c4, half*max( wabs, c5 ) ) )
   if wsize != ONE 
      wscale = ONE / wsize
      if wsize > ONE 
         scale1 = ( max( ascale, bsize )*wscale ) * min( ascale, bsize )
      else
         scale1 = ( min( ascale, bsize )*wscale ) * max( ascale, bsize )
      end
      wr1 = wr1*wscale
      if wi != ZERO 
         wi = wi*wscale
         wr2 = wr1
         scale2 = scale1
      end
   else
      scale1 = ascale*bsize
      scale2 = scale1
   end
#
#     Scale second eigenvalue (if real)
#
   if wi == ZERO 
      wsize = max( safmin, c1, fuzzy1*( abs( wr2 )*c2+c3 ),
                   min( c4, half*max( abs( wr2 ), c5 ) ) )
      if wsize != ONE 
         wscale = ONE / wsize
         if wsize > ONE 
            scale2 = ( max( ascale, bsize )*wscale ) * min( ascale, bsize )
         else
            scale2 = ( min( ascale, bsize )*wscale ) * max( ascale, bsize )
         end
         wr2 = wr2*wscale
      else
         scale2 = ascale*bsize
      end
   end
#
#     End of DLAG2
#
   return scale1, scale2, wr1, wr2, wi
end
_lag2(a::StridedMatrix{T},b::StridedMatrix{T},safmin::T) where {T <: BlasReal} = LapackUtil.lag2(a,b,safmin)
function _ladiv(A, B, C, D)
#
#    ladiv(A, B, C, D) -> (P, Q)
#
# Perform the complex division in real arithmetic
#
#  P + iQ = (A+iB)/(C+iD)
#
# by avoiding unnecessary overflow.
# Interface to the LAPACK subroutines DLADIV/SLADIV.
   t = complex(A,B) / complex(C,D)
   return real(t), imag(t)
end
_ladiv(A::Float64, B::Float64, C::Float64, D::Float64) = Base.cdiv(A,B,C,D)

"""
    utqu_upd(alpha, beta, R, A, X) -> R

Compute the symmetric rank-2k update

    R ← α·R + β·op(A)·X·op(A)'

in-place, where `R` and `X` are real symmetric matrices, `A` is a general
real matrix, and op(A) = A or op(A) = A' if A' is used on entry.

Generic over `T <: LinearAlgebra.BlasReal`, i.e. `Float32` or `Float64`.
Only the upper triangle of `R` (and `X`) is referenced and updated.

# Arguments
| Arg    | Type         | Description |
|--------|--------------|-------------|
| `alpha`| `T`          | Scalar multiplier for `R` on entry (`alpha=0` ⇒ `R` need not be initialised) |
| `beta` | `T`          | Scalar multiplier for the rank-2k term (`beta=0` ⇒ `A`, `X` not accessed) |
| `R`    | `Matrix{T}`  | M×M symmetric matrix, modified in-place |
| `A`    | `Matrix{T}`  | M×N or N×M (`A'`) general matrix |
| `X`    | `Matrix{T}`  | N×N symmetric matrix; diagonal temporarily halved then restored |
| `W`    | `Matrix{T}`  | M×N or N×M (`Aᴴ`) work matrix |

# Method
Writes `X = T + T'` with `T` the half-diagonal upper triangular factor:

    T = triu(X) − ½·diag(X) 

Then:

    A·X·A' = (A·T)·A' + A·(A·T)'   
    A'·X·A = A'·(T·A) + (T·A)'·A        (if `A'` is on entry)

using one BLAS-3 `trmm!` and one BLAS-3 `syr2k!` call.

# Operation count
Approximately M²N + ½N²M floating-point operations.

# Notes
This is the simpler variant of the SLICOT routine MB01RU.  When `R` and `X`
alias the same array, after the call the caller must divide the diagonal of
`R` by 2 (same caveat as the Fortran original).
"""
function utqu_upd!(alpha::S1, beta::S2, R::AbstractMatrix{T}, A::AbstractMatrix{T},
                 X::AbstractMatrix{T}, W::AbstractMatrix{T}) where {T <: BlasReal, S1 <: Real, S2 <: Real}

    # ------------------------------------------------------------------ #
    #  Decode and validate                                                #
    # ------------------------------------------------------------------ #
    ltrans = isa(A, Adjoint)

    M = size(R, 1)
    N = size(X, 1)

    size(R, 2) == M || throw(ArgumentError("R must be square (M×M)"))
    size(X, 2) == N || throw(ArgumentError("X must be square (N×N)"))

    if ltrans
        size(A.parent) == (N, M) ||
            throw(ArgumentError(
                "With transposed A, A must be $(N)×$(M), got $(size(A))"))
    else
        size(A) == (M, N) ||
            throw(ArgumentError(
                "A must be $(M)×$(N), got $(size(A))"))
    end

    # ------------------------------------------------------------------ #
    #  General case: beta ≠ 0, N > 0                                     #
    #                                                                    #
    #  Halve the diagonal of X so it represents T with X = T + T'.       #
    # ------------------------------------------------------------------ #
    half = one(T) / 2
    for i in 1:N
        X[i, i] *= half
    end

    if ltrans
        # -------------------------------------------------------------- #
        # TRANS = 'T'/'C':  R ← α·R + β·( A'·W + W'·A )                  #
        #   where  W = T·A  (N×M),  T is the triangular factor of X.     #
        # -------------------------------------------------------------- #
        copyto!(W,A.parent)                             # W ← A  (N×M)
        # W ← T · W   (left triangular multiply)
        LinearAlgebra.BLAS.trmm!('L', 'U', 'N', 'N', one(T), X, W)
        # R ← α·R + β·( A'·W + W'·A )
        LinearAlgebra.BLAS.syr2k!('U', 'T', T(beta), W, A.parent, T(alpha), R)
    else
        # -------------------------------------------------------------- #
        # TRANS = 'N':  R ← α·R + β·( W·A' + A·W' )                      #
        #   where  W = A·T  (M×N),  T is the triangular factor of X.     #
        # -------------------------------------------------------------- #
        copyto!(W,A)                                    # W ← A  (N×M)
        # W ← W · T   (right triangular multiply)
        LinearAlgebra.BLAS.trmm!('R', 'U', 'N', 'N', one(T), X, W)
        # R ← α·R + β·( W·A' + A·W' )
        LinearAlgebra.BLAS.syr2k!('U', 'N', T(beta), W, A, T(alpha), R)
    end

    # Restore diagonal of X
    two = 2 * one(T)
    for i in 1:N
        X[i, i] *= two
    end

    return R
end

"""
     utqu_upd!(alpha, beta, R, A, X) -> R

Compute the Hermitian rank-2k update

    R ← α·R + β·op(A)·X·op(A)ᴴ

in-place, where `R` and `X` are complex Hermitian matrices, `A` is a general
complex matrix, and op(A) = A or  op(A) = Aᴴ if Aᴴ is used on entry. 

Generic over `T <: LinearAlgebra.BlasComplex`, i.e. `ComplexF32` or `ComplexF64`.
The real scalars `alpha` and `beta` must have type `real(T)` (`Float32` or
`Float64`) to match — this is what BLAS `her2k!` requires.

Only the upper triangle of `R` (and `X`) is referenced and updated. 
The diagonal of `X` is temporarily halved then restored on exit.

# Arguments
| Arg     | Type           | Description |
|---------|----------------|-------------|
| `alpha` | `real(T)`      | Real scalar multiplier for `R` on entry |
| `beta`  | `real(T)`      | Real scalar multiplier for the rank-2k term |
| `R`     | `Matrix{T}`    | M×M Hermitian matrix, modified in-place |
| `A`     | `Matrix{T}`    | M×N or N×M (`Aᴴ`) general matrix |
| `X`     | `Matrix{T}`    | N×N Hermitian matrix; diagonal temporarily halved then restored |
| `W`     | `Matrix{T}`    | M×N or N×M (`Aᴴ`) work matrix |

# Method
Writes `X = T + Tᴴ` where `T` is the half-diagonal upper triangular factor:

    T = triu(X) − ½·diag(X)   

Then:

    A·X·Aᴴ = (A·T)·Aᴴ + A·(A·T)ᴴ       
    Aᴴ·X·A = Aᴴ·(T·A) + (T·A)ᴴ·A       (if `Aᴴ` is on entry)

using BLAS-3 `trmm!` (non-unit triangular, no conjugation of T) and `her2k!`.

# Notes
This is the complex variant of the SLICOT routine MB01RU.  
- The diagonal of `X` must be real (Hermitian requirement); any imaginary
  part is zeroed when halving/restoring.
- `alpha` and `beta` are real (`Float32`/`Float64`), as required by the Hermitian updating.
- When `R` and `X` alias the same storage, divide the diagonal of `R` by 2
  after the call (same caveat as the real MB01RU).

# Operation count
Approximately M²N + ½N²M complex multiply-adds.
"""
function  utqu_upd!(alpha::S1, beta::S2, R::AbstractMatrix{T}, A::AbstractMatrix{T},
                           X::AbstractMatrix{T}, W::AbstractMatrix{T}) where {T <: BlasComplex, S1 <: Real, S2 <: Real}

    #  Decode and validate                                               
    lconj = isa(A, Adjoint)

    M = size(R, 1)
    N = size(X, 1)

    size(R, 2) == M || throw(ArgumentError("R must be square (M×M)"))
    size(X, 2) == N || throw(ArgumentError("X must be square (N×N)"))

    if lconj
        size(A.parent) == (N, M) ||
            throw(ArgumentError(
                "With adjoint A, A must be $(N)×$(M), got $(size(A))"))
    else
        size(A) == (M, N) ||
            throw(ArgumentError(
                "A must be $(M)×$(N), got $(size(A))"))
    end

    # ------------------------------------------------------------------ #
    #  General case: beta ≠ 0, N > 0                                     #
    #                                                                    #
    #  Halve the diagonal of X so it represents T with X = T + Tᴴ.       #
    #  The diagonal of a Hermitian matrix must be real; zero any         #
    #  floating-point imaginary noise before passing to BLAS.            #
    # ------------------------------------------------------------------ #
    for i in 1:N
        X[i, i] = T(real(X[i, i]) / 2)
    end

    if lconj
        # -------------------------------------------------------------- #
        # TRANS = 'C':  R ← α·R + β·( Aᴴ·W + Wᴴ·A )                      #
        #   where  W = T·A  (N×M).                                       #
        # -------------------------------------------------------------- #
        copyto!(W,A.parent)                             # W ← A  (N×M)
        # W ← T · W   (left, non-unit triangular, no conjugation of T)
        LinearAlgebra.BLAS.trmm!('L', 'U', 'N', 'N', one(T), X, W)
        # R ← α·R + β·( Aᴴ·W + Wᴴ·A )   — Hermitian rank-2k
        LinearAlgebra.BLAS.her2k!('U', 'C', T(beta), W, A.parent, real(T(alpha)), R)
    else
        # -------------------------------------------------------------- #
        # TRANS = 'N':  R ← α·R + β·( W·Aᴴ + A·Wᴴ )                      #
        #   where  W = A·T  (M×N).                                       #
        # -------------------------------------------------------------- #
        copyto!(W,A)                                    # W ← A  (N×M)
        # W ← W · T   (right, non-unit triangular, no conjugation of T)
        LinearAlgebra.BLAS.trmm!('R', 'U', 'N', 'N', one(T), X, W)
        # R ← α·R + β·( W·Aᴴ + A·Wᴴ )   — Hermitian rank-2k
        LinearAlgebra.BLAS.her2k!('U', 'N', T(beta), W, A, real(T(alpha)), R)
    end

    # Restore diagonal of X
    for i in 1:N
        X[i, i] = T(real(X[i, i]) * 2)
    end

    return R
end

# Continuous Lyapunov equations
"""
    X = lyapc(A, C; blocksize = 64)

Compute `X`, the solution of the continuous Lyapunov equation

      AX + XA' + C = 0,

where `A` is a square real or complex matrix and `C` is a square matrix.
`A` must not have eigenvalues `α` and `β` such that `α+β' = 0`.
The solution `X` is symmetric or hermitian if `C` is symmetric or hermitian.

The keyword argument `blocksize` (default: `blocksize = 64`) specifies the 
block size when to switch in the employed recursive blocked algorithm 
to the core algorithm for solving small-sized matrix equations. 
If `blocksize ≤ 4`, the minimum value `blocksize = 4` is used.
Note: This option is only effective for data of types `Float64`, `Float32`, 
      `ComplexF64`, or `ComplexF32`.

The following particular cases are also adressed:

    X = lyapc(α*I,C)  or  X = lyapc(α,C)

Solve the matrix equation `(α+α')X + C = 0`.

    x = lyapc(α,γ)

Solve the equation `(α+α')x + γ = 0`.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> C = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> X = lyapc(A, C)
2×2 Array{Float64,2}:
  0.5  -0.5
 -0.5   0.25

julia> A*X + X*A' + C
2×2 Array{Float64,2}:
 -8.88178e-16   2.22045e-16
  2.22045e-16  -4.44089e-16
```
"""
function lyapc(A::AbstractMatrix, C::AbstractMatrix; blocksize::Int = 64)
   """
   The Bartels-Steward Schur form based method in [1] is employed for matrix dimensions not exceeding
   the specified blocksize. For large dimensions, the recursive blocked algorithm in [2] is used.
   The Sylvester equations during the recursive solution are solved using a native algorithm 
   inspired by [2] for symmetric solutions and the iterative blocking based algorithm of [3] for 
   non-symmetric solutions. Blocking is employed only for BlasFloat type data.  

   Reference:
   [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
       Comm. ACM, 15:820–826, 1972.

   [2] I. Jonsson and B. Kågström, Recursive blocked algorithms for solving triangular systems—
       Part I: One-sided and coupled Sylvester-type matrix equations, ACM Trans. Math. Software, 
       28 (2002), pp. 392–415.

   [3] A. Schwarz and C. C. Kjelgaard Mikkelsen, Robust task-parallel solution of the triangular 
       Sylvester equation. Lecture Notes in Computer Science, vol 12043, pp. 82-92, Springer, 2020.    
   """
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(C) == n ||
      throw(DimensionMismatch("C must be a square matrix of dimension $n"))

   adj = isa(A,Adjoint)
   her = ishermitian(C)

   T2 = promote_type(eltype(A), eltype(C))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   eltype(A) == T2 || (adj ? A = convert(AbstractMatrix{T2},A.parent)' : A = convert(AbstractMatrix{T2},A))
   eltype(C) == T2 || (C = convert(AbstractMatrix{T2},C))

   if isdiag(A) 
      if her
         return lyapcs!(A, copy(C))
      else
         return sylvcs!(A, A, copy(C))
      end
   end

   if ishermitian(A)
      # Reduce A to diagonal form and transform C
      AS, Q = schur(Hermitian(A))
   else
      # Reduce A to Schur form and transform C
      if adj
         AS, Q = schur(A.parent)
      else
         AS, Q = schur(A)
      end
   end
   #X = Q'*C*Q
   if her
      X = utqu(C,Q)
      if T2 <: BlasFloat
         lyapcs_blocked!(AS, X; adj, blocksize)
      else
         lyapcs!(AS, X; adj)
      end
      #X <- Q*X*Q'
      utqu!(X,Q',AS)
      return X
   else
      X = Q' * C * Q
      if T2 <: BlasFloat
         _lyapsylvcs_blocked!(AS, AS, X, adj, blocksize)
         return Q * X * Q'
      else
         sylvcs!(AS, AS, X, adjA = adj, adjB = !adj)
         return rmul!(Q * X * Q',-1)
      end
   end
end
# (α+α')X  + C = 0
lyapc(A::UniformScaling, C::AbstractMatrix) = -C/(A+A')
lyapc(A::Union{Real,Complex}, C::AbstractMatrix) = real(A) == 0 ? throw("ME:SingularException: A has an eigenvalue with zero real part") : -C/(A+A')
# (α+α')x + γ = 0
lyapc(A::Union{Real,Complex}, C::Union{Real,Complex})  = real(A) == 0 ? throw("ME:SingularException: A has an eigenvalue with zero real part") : -C/(A+A')
"""
    X = lyapc(A, E, C; blocksize = 64)

Compute `X`, the solution of the generalized continuous Lyapunov equation

     AXE' + EXA' + C = 0,

where `A` and `E` are square real or complex matrices and `C` is a square matrix.
The pencil `A-λE` must not have eigenvalues `α` and `β` such that `α+β = 0`.
The solution `X` is symmetric or hermitian if `C` is a symmetric or hermitian.

The keyword argument `blocksize` (default: `blocksize = 64`) specifies the 
block size when to switch in the employed recursive blocked algorithm 
to the core algorithm for solving small-sized matrix equations. 
If `blocksize ≤ 4`, the minimum value `blocksize = 4` is used.
Note: This option is only effective for data of types `Float64`, `Float32`, 
      `ComplexF64`, or `ComplexF32`.

The following particular cases are also adressed:

    X = lyapc(A,β*I,C)  or  X = lyapc(A,β,C)

Solve the matrix equation `AXβ' + βXA' + C = 0`.

    X = lyapc(α*I,E,C)  or  X = lyapc(α,E,C)

Solve the matrix equation `αXE' + EXα' + C = 0`.

    X = lyapc(α*I,β*I,C)  or  X = lyapc(α,β,C)

Solve the matrix equation `(αβ'+α'β)X + C = 0`.

    x = lyapc(α,β,γ)

Solve the equation `(αβ'+α'β)x + γ = 0`.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> E = [ 1. 2.; 0. 1.]
2×2 Array{Float64,2}:
 1.0  2.0
 0.0  1.0

julia> C = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> X = lyapc(A, E, C)
2×2 Array{Float64,2}:
 -2.5   2.5
  2.5  -2.25

julia> A*X*E' + E*X*A' + C
2×2 Array{Float64,2}:
 -5.32907e-15  -2.66454e-15
 -4.44089e-15   0.0
```
"""
function lyapc(A::AbstractMatrix, E::AbstractMatrix, C::AbstractMatrix; blocksize::Int = 64)
   """
   The extension [1] of the Bartels-Steward method based on the generalized Schur form
   is employed for matrix dimensions not exceeding the specified blocksize. For large dimensions, 
   the recursive blocked algorithm in [2] is used. The generalized Sylvester equations 
   during the recursive solution are solved using the recursive blocking technique described in [2].
   Blocking is employed only for BlasFloat type data.  

   Reference:
   [1] T. Penzl. Numerical solution of generalized Lyapunov equations.
       Adv. Comput. Math., 8:33–48, 1998.

   [2] I. Jonsson and B. Kågström, Recursive blocked algorithms for solving triangular systems—
       Part I: One-sided and coupled Sylvester-type matrix equations, ACM Trans. Math. Software, 
       28 (2002), pp. 392–415.

   """
   T2 = promote_type(eltype(A), eltype(E), eltype(C))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(C) == n ||
      throw(DimensionMismatch("C must be a square matrix of dimension $n"))
   isequal(E,I) && size(E,1) == n && (return lyapc(A, C))
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a square matrix of dimension $n"))

   adjA = isa(A,Adjoint)
   adjE = isa(E,Adjoint)
   if adjA && !adjE
      A = copy(A)
      adjA = false
   elseif !adjA && adjE
      E = copy(E)
      adjE = false
   end

   adj = adjA & adjE
   her = ishermitian(C)

   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(E) == T2 || (adj ? E = convert(Matrix{T2},E.parent)' : E = convert(Matrix{T2},E))
   eltype(C) == T2 || (C = convert(Matrix{T2},C))

   # Reduce (A,E) to generalized Schur form and transform C
   # (as,es) = (q'*A*z, q'*E*z)
   if adj
      as, es, z, q = schur(A.parent,E.parent)
   else
      as, es, q, z = schur(A,E)
   end
   if her
      #x = q'*C*q
      x = utqu(C,q) 
      if T2 <: BlasFloat
         lyapcs_blocked!(as,es,x; adj, blocksize)
      else
         lyapcs!(as,es,x, adj = adj)
      end
      #x = z*x*z'
      utqu!(x,z',as)
      return x
   else
      if T2 <: BlasFloat
         WS = Matrix{T2}(undef,n,n)
         x = Matrix{T2}(undef,n,n)
         mul!(WS,q',C)
         mul!(x,WS,q) 
         lyapgsylvcs_blocked!(WS, as, es, es, as, x; adj, blocksize)
         mul!(WS,z,x)
         mul!(x,WS,z')
         return x
      else
         x = q' * C * q
         gsylvs!(as,es,es,as,x,adjAC = adj,adjBD=!adj,DBSchur = true)
         return rmul!(z*x*z', -1)
      end
   end
end
# Aβ'X + XA'β + C = 0
lyapc(A::AbstractMatrix, E::Union{Real,Complex,UniformScaling}, C::AbstractMatrix) =
      isa(A,Adjoint) ? lyapc((A.parent*E')',C) : lyapc(A*E',C)
# αXE' + EXα' + C = 0
lyapc(A::Union{Real,Complex,UniformScaling}, E::AbstractMatrix, C::AbstractMatrix) =
      isa(E,Adjoint) ? lyapc((E.parent*A')',C) : lyapc(A'*E,C)
# (αβ'+α'β)X + C = 0
lyapc(A::UniformScaling, E::UniformScaling, C::AbstractMatrix) = -(A*E'+A'*E)\C
lyapc(A::Union{Real,Complex}, E::Union{Real,Complex}, C::AbstractMatrix) = real(A*E') == 0 ? throw(SingularException(1)) : -C/(A*E'+A'*E)
# (αβ'+α'β)X  + γ = 0
lyapc(A::Union{Real,Complex}, E::Union{Real,Complex}, C::Union{Real,Complex}) = real(A*E') == 0 ? throw(SingularException(1)) : -C/(A*E'+A'*E)
# Discrete Lyapunov equations
"""
    X = lyapd(A, C; blocksize::Int = 64)

Compute `X`, the solution of the discrete Lyapunov equation

       AXA' - X + C = 0,

where `A` is a square real or complex matrix and `C` is a square matrix.
`A` must not have eigenvalues `α` and `β` such that `αβ = 1`.
The solution `X` is symmetric or hermitian if `C` is a symmetric or hermitian.

The keyword argument `blocksize` (default: `blocksize = 64`) specifies the 
block size when to switch in the employed recursive blocked algorithm 
to the standard algorithm for solving small-sized matrix equations. 
If `blocksize < 4`, the minimum value `blocksize = 4` is used.
Note: This option is only effective for data of types `Float64`, `Float32`, 
      `ComplexF64`, or `ComplexF32`.
   

The following particular cases are also adressed:

    X = lyapd(α*I,C)  or  X = lyapd(α,C)

Solve the matrix equation `(αα'-1)X + C = 0`.

    x = lyapd(α,γ)

Solve the equation `(αα'-1)x + γ = 0`.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> C = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> X = lyapd(A, C)
2×2 Array{Float64,2}:
  0.2375  -0.2125
 -0.2125   0.1375

julia> A*X*A' - X + C
2×2 Array{Float64,2}:
 5.55112e-16  6.66134e-16
 2.22045e-16  4.44089e-16
```
"""
function lyapd(A::AbstractMatrix, C::AbstractMatrix; blocksize::Int = 64)
   """
   The discrete analog of the Bartels-Steward Schur form based method [1] is employed 
   for matrix dimensions not exceeding the specified blocksize. For large dimensions, 
   the recursive blocked algorithm in [2] is used.

   Reference:
   [1] G. Kitagawa. An Algorithm for solving the matrix equation X = F X F' + S,
       International Journal of Control, 25:745-753, 1977.

   [2] I. Jonsson and B. Kågström, Recursive blocked algorithms for solving triangular systems — 
       Part II: Two-sided and generalized Sylvester and Lyapunov matrix equations, 
       ACM Trans. Math. Software, 28 (2002), pp. 416–435.
   """
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(C) == n ||
       throw(DimensionMismatch("C must be a square matrix of dimension $n"))

   adj = isa(A,Adjoint)
   her = ishermitian(C)

   T2 = promote_type(eltype(A), eltype(C))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   eltype(A) == T2 || (adj ? A = convert(AbstractMatrix{T2},A.parent)' : A = convert(AbstractMatrix{T2},A))
   eltype(C) == T2 || (C = convert(AbstractMatrix{T2},C))

   if isdiag(A) 
      if her
         return lyapds!(A, copy(C))
      else
         return sylvds!(-A, A, copy(C))
      end
   end


   if ishermitian(A)
      # Reduce A to diagonal form and transform C
      AS, Q = schur(Hermitian(A))
   else
      # Reduce A to Schur form and transform C
      if adj
         AS, Q = schur(A.parent)
      else
         AS, Q = schur(A)
      end
   end
   #X = Q'*C*Q
   if her
      X = utqu(C,Q)
      if T2 <: BlasFloat
         lyapds_blocked!(AS, X; adj, blocksize)
      else
         lyapds!(AS, X; adj)
      end
      #X <- Q*X*Q'
      utqu!(X,Q',AS)
      return X
   else
      if T2 <: BlasFloat
         WS = Matrix{T2}(undef,n,n)
         X = Matrix{T2}(undef,n,n)
         mul!(WS,Q',C)
         mul!(X,WS,Q) 
         lyapsylvds_blocked!(WS, AS, AS, X; adj, isgn = -1, blocksize)
         mul!(WS,Q,X)
         mul!(X,WS,Q')
         return X
      else
         X = Q' * C * Q
         sylvds!(AS, AS, X, adjA = adj, adjB = !adj, isgn = -1)
         return rmul!(Q * X * Q',-1)
      end
   end
end
# (αα'-1)X + C = 0
lyapd(A::UniformScaling, C::AbstractMatrix) = (I-A'*A)\C
lyapd(A::Union{Real,Complex}, C::AbstractMatrix) = A*A' == 1 ? throw(SingularException(1)) : C/(1-A'*A)
# (αα'-1)x + γ = 0
lyapd(A::Union{Real,Complex}, C::Union{Real,Complex}) = A*A' == 1 ? throw(SingularException(1)) : C/(one(C)-A'*A)
"""
    X = lyapd(A, E, C)

Compute `X`, the solution of the generalized discrete Lyapunov equation

         AXA' - EXE' + C = 0,

where `A` and `E` are square real or complex matrices and `C` is a square matrix.
The pencil `A-λE` must not have eigenvalues `α` and `β` such that `αβ = 1`.
The solution `X` is symmetric or hermitian if `C` is a symmetric or hermitian.

The following particular cases are also adressed:

    X = lyapd(A,β*I,C)  or  X = lyapd(A,β,C)

Solve the matrix equation `AXA' - βXβ' + C = 0`.

    X = lyapd(α*I,E,C)  or  X = lyapd(α,E,C)

Solve the matrix equation `αXα' - EXE' + C = 0`.

    X = lyapd(α*I,β*I,C)  or  X = lyapd(α,β,C)

Solve the matrix equation `(αα'-ββ')X + C = 0`.

    x = lyapd(α,β,γ)

Solve the equation `(αα'-ββ')x + γ = 0`.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> E = [ 1. 2.; 0. -1.]
2×2 Array{Float64,2}:
 1.0   2.0
 0.0  -1.0

julia> C = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> X = lyapd(A, E, C)
2×2 Array{Float64,2}:
  1.775  -1.225
 -1.225   0.775

julia> A*X*A' - E*X*E' + C
2×2 Array{Float64,2}:
 -2.22045e-16  -4.44089e-16
 -1.33227e-15   1.11022e-15
```
"""
function lyapd(A::AbstractMatrix, E::AbstractMatrix, C::AbstractMatrix; blocksize::Int = 64)
   """
   The extension of the Bartels-Stewart method based on the generalized Schur form
   is employed. For large dimensions, the recursive blocked algorithm in [2] is used.
   The generalized Sylvester equations during the recursive solution are solved using a native algorithm 
   described in [2]. Blocking is employed only for BlasFloat type data.  

   Reference:
   [1] T. Penzl. Numerical solution of generalized Lyapunov equations.
       Adv. Comput. Math., 8:33–48, 1998.

   [2] I. Jonsson and B. Kågström, Recursive blocked algorithms for solving triangular systems—
       Part I: One-sided and coupled Sylvester-type matrix equations, ACM Trans. Math. Software, 
       28 (2002), pp. 392–415.

   """
   T2 = promote_type(eltype(A), eltype(E), eltype(C))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(C) == n ||
      throw(DimensionMismatch("C must be a square matrix of dimension $n"))
   isequal(E,I) && size(E,1) == n && (return lyapd(A, C))
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a square matrix of dimension $n"))

   adjA = isa(A,Adjoint)
   adjE = isa(E,Adjoint)
   if adjA && !adjE
      A = copy(A)
      adjA = false
   elseif !adjA && adjE
      E = copy(E)
      adjE = false
   end

   adj = adjA & adjE
   her = ishermitian(C)

   eltype(A) == T2 || (adj ? A = convert(Matrix{T2},A.parent)' : A = convert(Matrix{T2},A))
   eltype(E) == T2 || (adj ? E = convert(Matrix{T2},E.parent)' : E = convert(Matrix{T2},E))
   eltype(C) == T2 || (C = convert(Matrix{T2},C))

   # Reduce (A,E) to generalized Schur form and transform C
   # (as,es) = (q'*A*z, q'*E*z)
   if adj
      as, es, z, q = schur(A.parent,E.parent)
   else
      as, es, q, z = schur(A,E)
   end
   if her
      #x = q'*C*q
      x = utqu(C,q)
      if T2 <: BlasFloat
         lyapds_blocked!(as,es,x; adj, blocksize)
      else
         lyapds!(as,es,x, adj = adj)
      end
      #x = z*x*z'
      utqu!(x,z',as)
      return x
   else
      if T2 <: BlasFloat
         WS = Matrix{T2}(undef,n,n)
         x = Matrix{T2}(undef,n,n)
         WS2 = Matrix{T2}(undef,n,4)
         mul!(WS,q',C)
         mul!(x,WS,q) 
         lyapgsylvds_blocked!(WS, WS2, as, as, es, es, x; adj, blocksize)
         mul!(WS,z,x)
         mul!(x,WS,z')
         return x
      else
         x = q' * C * q
         gsylvs!(as, as, es, es, x, adjAC = adj, adjBD = !adj, isgn = -1)
         return rmul!(z*x*z', -1)
      end
   end
end
# AXA' - Xββ' + C = 0
lyapd(A::AbstractMatrix, E::Union{Real,Complex,UniformScaling}, C::AbstractMatrix) =
      isa(A,Adjoint) ? lyapd((A.parent/E)',C/(E*E')) : lyapd(A/E,C/(E*E'))
# αXα' - EXE' + C = 0
lyapd(A::Union{Real,Complex,UniformScaling}, E::AbstractMatrix, C::AbstractMatrix) =
      isa(E,Adjoint) ? lyapd((E.parent/A)',C/(-A*A')) : lyapd(E/A,C/(-A*A'))
# (α'α-β'β)X + C = 0
lyapd(A::UniformScaling, E::UniformScaling, C::AbstractMatrix) = C/(E'*E-A'*A)
lyapd(A::Union{Real,Complex}, E::Union{Real,Complex}, C::AbstractMatrix) = A*A'== E*E' ? throw(SingularException(1)) : C/(E'*E-A'*A)
# (α'α-β'β)X + γ  = 0
lyapd(A::Union{Real,Complex}, E::Union{Real,Complex}, C::Union{Real,Complex}) = A*A'== E*E' ? throw(SingularException(1)) : C/(E'*E-A'*A)
"""
    lyapcs!(A,C;adj = false)

Solve the continuous Lyapunov matrix equation

                op(A)X + Xop(A)' + C = 0,

where `op(A) = A` if `adj = false` and `op(A) = A'` if `adj = true`.
`A` is a square real matrix in a real Schur form, or a square complex matrix in a
complex Schur form and `C` is a symmetric or hermitian matrix.
`A` must not have eigenvalues `α` and `β` such that `α+β = 0`.
`C` contains on output the solution `X`.
"""
function lyapcs!(A::AbstractMatrix{T1},C::AbstractMatrix{T1}; adj = false) where {T1<:Real}
   n = LinearAlgebra.checksquare(A)
   # (LinearAlgebra.checksquare(C) == n && issymmetric(C)) ||
   #    throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
   if isdiag(A) 
      for i = 1:n
         C[i,i] = -C[i,i]/(2*A[i,i])
         isfinite(C[i,i]) || throw("ME:SingularException: A has eigenvalue(s) = 0")
         for j = i+1:n
            C[i,j] = -C[i,j]/(A[i,i]+A[j,j])
            isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and β such that α+β = 0")
            C[j,i] = C[i,j]
         end
      end
      return C[:,:]
   end      

   ONE = one(T1)

   # determine the structure of the real Schur form
   ba, p = sfstruct(A)

   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   if adj
      # """
      # The (K,L)th block of X is determined starting from
      # upper-left corner column by column by

      # A(K,K)'*X(K,L) + X(K,L)*A(L,L) = -C(K,L) - R(K,L),

      # where
      #          K-1                    L-1
      # R(K,L) = SUM [A(I,K)'*X(I,L)] + SUM [X(K,J)*A(J,L)].
      #          I=1                    J=1
      # """
      j = 1
      for ll = 1:p
          dl = ba[ll]
          l = j:j+dl-1
          i = j
          for kk = ll:p
              dk = ba[kk]
              k = i:i+dk-1
              y = view(C,k,l)
              if kk > ll
                 ia = j:i-1
                 # y += A[ia,k]'*C[ia,l]
                 mul!(y,transpose(view(A,ia,k)),view(C,ia,l),ONE,ONE)
               end
               if i == j
                  lyapc2!(adj,y,dk,view(A,k,k),Xw,Yw)
               else
                  lyapcsylv2!(adj,y,dk,dl,view(A,k,k),view(A,l,l),Xw,Yw)
                  transpose!(view(C,l,k),y)
               end
               i += dk
          end
          j += dl
          if j <= n
             for jr = j:n
                for ir = jr:n
                    for lll = l
                        C[ir,jr] += C[ir,lll]*A[lll,jr] + A[lll,ir]*C[jr,lll]
                    end
                    C[jr,ir] = C[ir,jr]
                end
             end
          end
       end
   else
      # """
      # The (K,L)th block of X is determined starting from
      # bottom-right corner column by column by

      # A(K,K)*X(K,L) + X(K,L)*A(L,L)' = -C(K,L) - R(K,L),

      # where
      #           N                     N
      # R(K,L) = SUM [A(K,I)*X(I,L)] + SUM [X(K,J)*A(L,J)'].
      #         I=K+1                 J=L+1
      # """
      j = n
      for ll = p:-1:1
          dl = ba[ll]
          l = j-dl+1:j
          i = j
          for kk = ll:-1:1
              dk = ba[kk]
              i1 = i-dk+1
              k = i1:i
              y = view(C,k,l)
              if kk < ll
                 ia = i+1:j
                 #  y += A[k,ia]*C[ia,l]
                 mul!(y,view(A,k,ia),view(C,ia,l),ONE,ONE)
              end
              if i == j
                 lyapc2!(adj,y,dk,view(A,k,k),Xw,Yw)
              else
                 lyapcsylv2!(adj,y,dk,dl,view(A,k,k),view(A,l,l),Xw,Yw)
                 transpose!(view(C,l,k),y)
              end
              i -= dk
           end
           j -= dl
           if j >= 0
              for jr = 1:j
                 for ir = 1:jr
                     for lll = l
                         C[ir,jr] += C[ir,lll]*A[jr,lll] + A[ir,lll]*C[lll,jr]
                      end
                      C[jr,ir] = C[ir,jr]
                 end
              end
           end
       end
   end
end
function lyapcs_blocked!(A::AbstractMatrix{T1}, C::AbstractMatrix{T1}; adj = false, blocksize::Integer = 64) where {T1<:BlasFloat}
    n = LinearAlgebra.checksquare(A)  
    n == LinearAlgebra.checksquare(C) 
    if T1 <: Real  
       # Check symmetry ONCE here
       issymmetric(C) ||  throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
    else
       ishermitian(C) ||  throw(DimensionMismatch("C must be a $n x $n Hermitian matrix"))
    end
   _lyapcs_blocked!(A, C, adj, blocksize)
    # Fill the lower triangle ONCE at the very end
    return LinearAlgebra.copytri!(C, 'U',T1 <: Complex)
end
function _lyapcs_blocked!(A::AbstractMatrix{T1},C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasReal}
   n = size(A, 1)
   ONE = one(T1)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U')
      lyapcs!(A,C;adj)
   else
      # split A and C (by rows and columns)
      mid = n ÷ 2
      n1 =  A[mid+1, mid] != 0 ? mid + 1 : mid
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
      end
      if adj
         _lyapcs_blocked!(A11,C11,adj,blocksize)
         mul!(C12,Symmetric(C11),A12,1,1)
         #sylvcs!(A11, A22, C12, adjA = true)
         #rmul!(C12,-1)
         _lyapsylvcs_blocked!(A11, A22, C12, true, blocksize)
         BLAS.syr2k!('U', 'T', ONE, A12, C12, ONE, C22)
         _lyapcs_blocked!(A22,C22,adj,blocksize)
      else
         _lyapcs_blocked!(A22,C22,adj,blocksize)
         mul!(C12,A12,Symmetric(C22),1,1)
         # sylvcs!(A11, A22, C12, adjB = true)
         # rmul!(C12,-1)
         _lyapsylvcs_blocked!(A11, A22, C12, false, blocksize)
         BLAS.syr2k!('U', 'N', ONE, A12, C12, ONE, C11)
         _lyapcs_blocked!(A11,C11,adj,blocksize)
      end
   end
end

function lyapc2!(adj,C::AbstractMatrix{T},na::Int,A::AbstractMatrix{T},R::AbstractMatrix{T},Y::StridedVector{T}) where T <:Real
# speed and reduced allocation oriented implementation of a solver for 1x1 or 2x2 continuous Lyapunov equations
#      A'*X + X*A = -C if adj = true  -> R = kron(I,A')+kron(A',I) = (kron(I,A)+kron(A,I))'
#      A*X + X*A' = -C if adj = false -> R = kron(I,A)+kron(A,I)
   if na == 1
      rmul!(C,inv(-2*A[1,1]))
      any(!isfinite, C) && throw("ME:SingularException: A has eigenvalue(s) ≈ 0")
      return C
   end
   ZERO = zero(T)
   @inbounds  Y[1] = -C[1,1]/2
   @inbounds  Y[2] = -C[2,1]
   @inbounds  Y[3] = -C[2,2]/2
   if adj
      # @inbounds R = [ A[1,1]    A[2,1]         0;
      #                 A[1,2]    A[1,1]+A[2,2]  A[2,1];
      #                 0         A[1,2]         A[2,2] ]
      @inbounds  R[1,1] = A[1,1]
      @inbounds  R[1,2] = A[2,1]
      @inbounds  R[1,3] = ZERO
      @inbounds  R[2,1] = A[1,2]
      @inbounds  R[2,2] = A[1,1]+A[2,2]
      @inbounds  R[2,3] = A[2,1]
      @inbounds  R[3,1] = ZERO
      @inbounds  R[3,2] = A[1,2]
      @inbounds  R[3,3] = A[2,2]
   else
      # @inbounds R = [ A[1,1]    A[1,2]         0;
      #                 A[2,1]    A[1,1]+A[2,2]  A[1,2];
      #                 0         A[2,1]         A[2,2] ]
      @inbounds  R[1,1] = A[1,1]
      @inbounds  R[1,2] = A[1,2]
      @inbounds  R[1,3] = ZERO
      @inbounds  R[2,1] = A[2,1]
      @inbounds  R[2,2] = A[1,1]+A[2,2]
      @inbounds  R[2,3] = A[1,2]
      @inbounds  R[3,1] = ZERO
      @inbounds  R[3,2] = A[2,1]
      @inbounds  R[3,3] = A[2,2]
   end
   luslv!(R,Y,3) && throw("ME:SingularException: A has eigenvalues α and β such that α+β' ≈ 0")
   @inbounds C[1,1] = Y[1]
   @inbounds C[1,2] = Y[2]
   @inbounds C[2,1] = Y[2]
   @inbounds C[2,2] = Y[3]
   return C
end

function lyapcsylv2!(adj,C::AbstractMatrix{T},na::Int,nb::Int,A::AbstractMatrix{T},B::AbstractMatrix{T},R::AbstractMatrix{T},Y::StridedVector{T}) where T <:Real
# speed and reduced allocation oriented implementation of a solver for 1x1 and 2x2 Sylvester equations
# encountered in solving continuous Lyapunov equations:
#      A'*X + X*B = -C if adj = true  -> R = kron(I,A')+kron(B',I) = (kron(I,A)+kron(B,I))'
#      A*X + X*B' = -C if adj = false -> R = kron(I,A)+kron(B,I)
   if na == 1 && nb == 1
      temp = A[1,1] + B[1,1]
      rmul!(C,inv(-temp))
      any(!isfinite, C) && throw("ME:SingularException: A has eigenvalues α and β such that α+β ≈ 0")
      return C
   end
   ZERO = zero(T)
   if adj
      if na == 1
         # @inbounds R = [ A[1,1]+B[1,1]    B[2,1];
         #                      B[1,2]      A[1,1]+B[2,2]]
         @inbounds  R[1,1] = A[1,1]+B[1,1]
         @inbounds  R[1,2] = B[2,1]
         @inbounds  R[2,1] = B[1,2]
         @inbounds  R[2,2] = A[1,1]+B[2,2]
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
      else
         if nb == 1
            # @inbounds R = [ A[1,1]+B[1,1]       A[2,1];
            #                  A[1,2]          A[2,2]+B[1,1] ]
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = A[2,1]
            @inbounds  R[2,1] = A[1,2]
            @inbounds  R[2,2] = A[2,2]+B[1,1]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # @inbounds R = [ A[1,1]+B[1,1]       A[2,1]       B[2,1]           0;
            #                 A[1,2]        A[2,2]+B[1,1]      0             B[2,1];
            #                 B[1,2]              0       A[1,1]+B[2,2]     A[2,1];
            #                   0               B[1,2]       A[1,2]       A[2,2]+B[2,2]]
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = A[2,1]
            @inbounds  R[1,3] = B[2,1]
            @inbounds  R[1,4] = ZERO
            @inbounds  R[2,1] = A[1,2]
            @inbounds  R[2,2] = A[2,2]+B[1,1]
            @inbounds  R[2,3] = ZERO
            @inbounds  R[2,4] = B[2,1]
            @inbounds  R[3,1] = B[1,2]
            @inbounds  R[3,2] = ZERO
            @inbounds  R[3,3] = A[1,1]+B[2,2]
            @inbounds  R[3,4] = A[2,1]
            @inbounds  R[4,1] = ZERO
            @inbounds  R[4,2] = B[1,2]
            @inbounds  R[4,3] = A[1,2]
            @inbounds  R[4,4] = A[2,2]+B[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   else
      if na == 1
         # @inbounds R = [ A[1,1]+B[1,1]       B[1,2];
         #                    B[2,1]       A[1,1] + B[2,2]]
         @inbounds  R[1,1] = A[1,1]+B[1,1]
         @inbounds  R[1,2] = B[1,2]
         @inbounds  R[2,1] = B[2,1]
         @inbounds  R[2,2] = A[1,1]+B[2,2]
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
      else
         if nb == 1
            # @inbounds R = [ A[1,1]+B[1,1]       A[1,2];
            #                 A[2,1]        A[2,2]+B[1,1]]
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = A[1,2]
            @inbounds  R[2,1] = A[2,1]
            @inbounds  R[2,2] = A[2,2]+B[1,1]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # @inbounds R = [ A[1,1]+B[1,1]       A[1,2]       B[1,2]         0;
            #                 A[2,1]      A[2,2]+B[1,1]       0         B[1,2];
            #                  B[2,1]            0      A[1,1]+B[2,2]     A[1,2];
            #                  0             B[2,1]        A[2,1]    A[2,2]+B[2,2]]
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = A[1,2]
            @inbounds  R[1,3] = B[1,2]
            @inbounds  R[1,4] = ZERO
            @inbounds  R[2,1] = A[2,1]
            @inbounds  R[2,2] = A[2,2]+B[1,1]
            @inbounds  R[2,3] = ZERO
            @inbounds  R[2,4] = B[1,2]
            @inbounds  R[3,1] = B[2,1]
            @inbounds  R[3,2] = ZERO
            @inbounds  R[3,3] = A[1,1]+B[2,2]
            @inbounds  R[3,4] = A[1,2]
            @inbounds  R[4,1] = ZERO
            @inbounds  R[4,2] = B[2,1]
            @inbounds  R[4,3] = A[2,1]
            @inbounds  R[4,4] = A[2,2]+B[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   end
   luslv!(R,Y,na*nb) && throw("ME:SingularException: A has eigenvalues α and β such that α+β ≈ 0")
   if na == 1 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[1,2] = Y[2]
   elseif na == 2 && nb == 1
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
   else # na == 2 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
      @inbounds C[1,2] = Y[3]
      @inbounds C[2,2] = Y[4]
   end
   return C
end
function lyapcs!(A::AbstractMatrix{T1},C::AbstractMatrix{T1}; adj = false) where {T1<:Complex}
   n = LinearAlgebra.checksquare(A)
   (LinearAlgebra.checksquare(C) == n && ishermitian(C)) ||
      throw(DimensionMismatch("C must be a $n x $n hermitian matrix"))
   if isdiag(A) 
      if adj 
         for i = 1:n
            C[i,i] = -C[i,i]/(2*real(A[i,i]))
            isfinite(C[i,i]) || throw("ME:SingularException: A has eigenvalue(s) with zero real part(s)")
            for j = i+1:n
               C[i,j] = -C[i,j]/(A[i,i]'+A[j,j])
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and β such that α+β' = 0")
               C[j,i] = C[i,j]'
            end
         end
      else
         for i = 1:n
            C[i,i] = -C[i,i]/(2*real(A[i,i]))
            isfinite(C[i,i]) || throw("ME:SingularException: A has eigenvalue(s) with zero real part(s)")
            for j = i+1:n
               C[i,j] = -C[i,j]/(A[i,i]+A[j,j]')
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and β such that α+β' = 0")
               C[j,i] = C[i,j]'
            end
         end
      end   
      return C[:,:]
   end      

   if adj
      # """
      # The (K,L)th element of X is determined starting from
      # upper-left corner column by column by

      # A(K,K)'*X(K,L) + X(K,L)*A(L,L) = -C(K,L) - R(K,L),

      # where
      #          K-1                    L-1
      # R(K,L) = SUM [A(I,K)'*X(I,L)] + SUM [X(K,J)*A(J,L)].
      #          I=1                    J=1
      # """
      for l = 1:n
          for k = l:n
              y = C[k,l]
              for ia = l:k-1
                  y += A[ia,k]'*C[ia,l]
              end
              C[k,l] = -y/(A[k,k]'+A[l,l])
              isfinite(C[k,l]) || throw("ME:SingularException: A has eigenvalues α and β such that α+β ≈ 0")
              k == l ? (C[k,k] = real(C[k,k])) : (C[l,k] = C[k,l]')
           end
           for jr = l+1:n
               for ir = jr:n
                   C[ir,jr] += C[ir,l]*A[l,jr] + (A[l,ir]*C[jr,l])'
                   if jr != ir
                      C[jr,ir] = C[ir,jr]'
                   end
               end
           end
      end
   else
      # """
      # The (K,L)th element of X is determined starting from
      # bottom-right corner column by column by

      # A(K,K)*X(K,L) + X(K,L)*A(L,L)' = -C(K,L) - R(K,L),

      # where
      #           N                     N
      # R(K,L) = SUM [A(K,I)*X(I,L)] + SUM [X(K,J)*A(L,J)'].
      #         I=K+1                 J=L+1
      # """
      for l = n:-1:1
          for k = l:-1:1
              y = C[k,l]
              for ia = k+1:l
                 y += A[k,ia]*C[ia,l]
              end
              C[k,l] = -y/(A[k,k]+A[l,l]')
              isfinite(C[k,l]) || throw("ME:SingularException: A has eigenvalues α and β such that α+β ≈ 0")
              k == l ? (C[k,k] = real(C[k,k])) : (C[l,k] = C[k,l]')
           end
           for jr = 1:l-1
               for ir = 1:jr
                  C[ir,jr] += C[ir,l]*A[jr,l]' + A[ir,l]*C[l,jr]
                  if ir != jr
                     C[jr,ir] = C[ir,jr]'
                  end
               end
           end
       end
   end
end
function _lyapcs_blocked!(A::AbstractMatrix{T1},C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasComplex}
   n = size(A, 1)
   ONE = one(T1)
   RONE = real(ONE)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U',true)
      lyapcs!(A,C;adj)
   else
      # split A and C (by rows and columns)
      n1 = n ÷ 2
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
      end
      if adj
         _lyapcs_blocked!(A11,C11,adj,blocksize)
         mul!(C12,Hermitian(C11),A12,1,1)
         #sylvcs!(A11, A22, C12, adjA = true)
         #rmul!(C12,-1)
         _lyapsylvcs_blocked!(A11, A22, C12, true, blocksize)
         BLAS.her2k!('U', 'C', ONE, A12, C12, RONE, C22)
         _lyapcs_blocked!(A22,C22,adj,blocksize)
      else
         _lyapcs_blocked!(A22,C22,adj,blocksize)
         mul!(C12,A12,Hermitian(C22),1,1)
         # sylvcs!(A11, A22, C12, adjB = true)
         # rmul!(C12,-1)
         _lyapsylvcs_blocked!(A11, A22, C12, false, blocksize)
         BLAS.her2k!('U', 'N', ONE, A12, C12, RONE, C11)
         _lyapcs_blocked!(A11,C11,adj,blocksize)
      end
   end
end

function _lyapsylvcs_blocked!(A, B, C, adj::Bool, blocksize::Integer)
   m = size(A, 1)
   n = size(B, 1)
   if m <= max(blocksize,4) && n <= max(blocksize,4)
      sylvcs!(A,B,C;adjA = adj,adjB = !adj)
      rmul!(C, -1)
   else
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 
      midn = n ÷ 2
      n1 = B[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
         B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
         C11, C12, C21, C22 = C[ia1,ib1], C[ia1,ib2], C[ia2,ib1], C[ia2,ib2]
      end
      if adj
         # solve A' X + X B + C = 0

         # X11 solver
         _lyapsylvcs_blocked!(A11, B11, C11, adj, blocksize)

         # C12 update: C12 = C12 + X11*B12
         mul!(C12,C11,B12,1,1)

         # X12 solver
         _lyapsylvcs_blocked!(A11, B22, C12, adj, blocksize)

         # C21 update: C21 = C21 + A12'*X11
         mul!(C21,A12',C11,1,1)

         # X21 solver
         _lyapsylvcs_blocked!(A22, B11, C21, adj, blocksize)

         # C22 update: C22 = C22 + A12'*X12 + X21*B12

         # C22 = C22 + A12'*X12
         mul!(C22, A12', C12, 1, 1)
         # C22 = C22 + X21*B12
         mul!(C22, C21, B12, 1, 1)

         # X22 solver
         _lyapsylvcs_blocked!(A22, B22, C22, adj, blocksize)
      else
         # solve A X  + X B' + C = 0

         # X22 solver
         _lyapsylvcs_blocked!(A22, B22, C22, adj, blocksize)

         # C12 update: C12 = C12 + A12*X22
         mul!(C12,A12,C22,1,1)

         # X12 solver
         _lyapsylvcs_blocked!(A11, B22, C12, adj, blocksize)

         # C21 update: C21 = C21 + X22*B12'
         mul!(C21,C22,B12',1,1)

         # X21 solver
         _lyapsylvcs_blocked!(A22, B11, C21, adj, blocksize)

         # C11 update: C11 = C11 + A12*X21 + X12*B12' 
         # C11 = C11 + A12*X21
         mul!(C11, A12, C21, 1, 1)
         # C11 = C11 + X12*B12'
         mul!(C11, C12, B12', 1, 1) 
 
         # X11 solver
         _lyapsylvcs_blocked!(A11, B11, C11, adj, blocksize)
      end
   end   
end


"""
    lyapcs!(A, E, C; adj = false)

Solve the generalized continuous Lyapunov matrix equation

                op(A)Xop(E)' + op(E)Xop(A)' + C = 0,

where `op(A) = A` and `op(E) = E` if `adj = false` and `op(A) = A'` and
`op(E) = E'` if `adj = true`. The pair `(A,E)` is in a generalized real or
complex Schur form and `C` is a symmetric or hermitian matrix.
The pencil `A-λE` must not have eigenvalues `α` and `β` such that `α+β = 0`.
The computed symmetric or hermitian solution `X` is contained in `C`.
"""
function lyapcs!(A::AbstractMatrix{T1},E::Union{AbstractMatrix{T1},UniformScaling{Bool}}, C::AbstractMatrix{T1}; adj = false) where {T1<:Real}
   n = LinearAlgebra.checksquare(A)
   (LinearAlgebra.checksquare(C) == n && issymmetric(C)) ||
      throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) && size(E,1) == n)) && (lyapcs!(A, C, adj = adj); return)
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))

   ONE = one(T1)
   ZERO = zero(T1)

   # determine the structure of the real Schur form
   ba, p = sfstruct(A)

   G = Matrix{T1}(undef,2,2)
   W = Array{T1,2}(undef,n,2)
   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   if adj
      # """
      # The (K,L)th block of X is determined starting from the
      # upper-left corner column by column by

      # A(K,K)'*X(K,L)*E(L,L) + E(K,K)'*X(K,L)*A(L,L) = -C(K,L) - R(K,L),

      # where
      #           K           L-1
      # R(K,L) = SUM {A(I,K)'*SUM [X(I,J)*E(J,L)]} +
      #          I=1          J=1

      #           K           L-1
      #          SUM {E(I,K)'*SUM [X(I,J)*A(J,L)]} +
      #          I=1          J=1

      #          K-1
      #         {SUM [A(I,K)'*X(I,L)]}*E(L,L) +
      #          I=1

      #          K-1
      #         {SUM [E(I,K)'*X(I,L)]}*A(L,L).
      #          I=1
      # """
      i = 1
      for kk = 1:p
          dk = ba[kk]
          dkk = 1:dk
          k = i:i+dk-1
          j = 1
          ir = 1:i-1
          for ll = 1:kk
             dl = ba[ll]
             j1 = j+dl-1
             l = j:j1
             y = view(G,1:dk,1:dl)
             Ckl = view(C,k,l)
             copyto!(y,Ckl)
             if kk > 1
                 #   C[l,k] = C[l,ir]*A[ir,k]
                 #   W[l,dkk] = C[l,ir]*E[ir,k]
                 mul!(view(C,l,k),view(C,l,ir),view(A,ir,k))
                 mul!(view(W,l,dkk),view(C,l,ir),view(E,ir,k))
                 ic = 1:j1
                 #   y += C[ic,k]'*E[ic,l] + W[ic,dkk]'*A[ic,l]
                 mul!(y,transpose(view(C,ic,k)),view(E,ic,l),ONE,ONE)
                 mul!(y,transpose(view(W,ic,dkk)),view(A,ic,l),ONE,ONE)
             end
             if i == j
                lyapc2!(adj,y,dk,view(A,k,k),view(E,k,k),Xw,Yw)
                copyto!(Ckl,y)
               else
                lyapcsylv2!(adj,y,dk,dl,view(A,k,k),view(E,k,k),view(A,l,l),view(E,l,l),Xw,Yw)
                copyto!(Ckl,y)
             end
             j += dl
             if j <= i
                #  C[l,k] += C[k,l]'*A[k,k]
                #  W[l,dkk] += C[k,l]'*E[k,k]
                mul!(view(C,l,k),transpose(Ckl),view(A,k,k),ONE,ONE)
                mul!(view(W,l,dkk),transpose(Ckl),view(E,k,k),ONE,ONE)
             end
          end
          if kk > 1
             ir = 1:i-1
             #C[ir,k] = C[k,ir]'
             transpose!(view(C,ir,k),view(C,k,ir))
          end
          i += dk
      end
   else
      # """
      # The (K,L)th block of X is determined starting from
      # bottom-right corner column by column by

      # A(K,K)*X(K,L)*E(L,L)' + E(K,K)*X(K,L)*A(L,L)' = -C(K,L) - R(K,L),

      # where

      #           N            N
      # R(K,L) = SUM {A(K,I)* SUM [X(I,J)*E(L,J)']} +
      #          I=K         J=L+1

      #           N            N
      #          SUM {E(K,I)* SUM [X(I,J)*A(L,J)']} +
      #          I=K         J=L+1

      #             N
      #          { SUM [A(K,J)*X(J,L)]}*E(L,L)' +
      #           J=K+1

      #             N
      #          { SUM [E(K,J)*X(J,L)]}*A(L,L)'
      #           J=K+1
      # """
      j = n
      for ll = p:-1:1
        dl = ba[ll]
        l = j-dl+1:j
        dll = 1:dl
        i = n
        ir = j+1:n
        for kk = p:-1:ll
            dk = ba[kk]
            i1 = i-dk+1
            k = i1:i
            Clk = view(C,l,k)
            y = view(G,1:dl,1:dk)
            copyto!(y,Clk)
            if ll < p
               # C[k,l] = C[k,ir]*A[l,ir]'
               # W[k,dll] = C[k,ir]*E[l,ir]'
               mul!(view(C,k,l),view(C,k,ir),transpose(view(A,l,ir)))
               mul!(view(W,k,dll),view(C,k,ir),transpose(view(E,l,ir)))
               ic = i1:n
               # y += (E[k,ic]*C[ic,l] + A[k,ic]*W[ic,dll])'
               mul!(y,transpose(view(C,ic,l)),transpose(view(E,k,ic)),ONE,ONE)
               mul!(y,transpose(view(W,ic,dll)),transpose(view(A,k,ic)),ONE,ONE)
            end
            if i == j
               lyapc2!(adj,y,dk,view(A,k,k),view(E,k,k),Xw,Yw)
               copyto!(Clk,y)
            else
               lyapcsylv2!(adj,y,dl,dk,view(A,l,l),view(E,l,l),view(A,k,k),view(E,k,k),Xw,Yw)
               copyto!(Clk,y)
            end
            i -= dk
            if i >= j
               # C[k,l] += (A[l,l]*C[l,k])'
               # W[k,dll] += (E[l,l]*C[l,k])'
               mul!(view(C,k,l),transpose(Clk),transpose(view(A,l,l)),ONE,ONE)
               mul!(view(W,k,dll),transpose(Clk),transpose(view(E,l,l)),ONE,ONE)
            else
               break
            end
        end
        if ll < p
           ir = j+1:n
           # C[ir,l] = C[l,ir]'
           transpose!(view(C,ir,l),view(C,l,ir))
         end
        j -= dl
      end
   end
end
@inline function lyapc2!(adj,C::AbstractMatrix{T},na::Int,A::AbstractMatrix{T},E::AbstractMatrix{T},R::AbstractMatrix{T},Y::StridedVector{T}) where T <:Real
#  @inline function lyapc2!(adj,C::AbstractMatrix{T},na::Int,A::AbstractMatrix{T},E::AbstractMatrix{T},Xw::AbstractMatrix{T},Yw::StridedVector{T}) where T <:BlasReal
      # speed and reduced allocation oriented implementation of a solver for 1x1 or 2x2 generalized continuous Lyapunov equations
# LAPACK generated diagonal structure of E is exploited when possible
#      A'*X*E + E'*X*A = -C if adj = true  -> R = kron(E',A')+kron(A',E') = (kron(E,A)+kron(A,E))'
#      A*X*E' + E*X*A' = -C if adj = false -> R = kron(E,A)+kron(A,E)
   if na == 1
      temp = E[1,1]*A[1,1]
      rmul!(C,inv(-2*temp))
      any(!isfinite, C) &&  throw("ME:SingularException: A-λE has zero or infinite eigenvalue(s)")
      return C
   end
   ZERO = zero(T)
   @inbounds  Y[1] = -C[1,1]/2
   @inbounds  Y[2] = -C[2,1]
   @inbounds  Y[3] = -C[2,2]/2
   if adj
      # Rt =
      #  [        a11*e11,                   a21*e11,         0
      #  a11*e12 + a12*e11, a11*e22 + a21*e12 + a22*e11,   a21*e22
      #          a12*e12,       a12*e22 + a22*e12, a22*e22]
      # iszero(E[1,2]) ?
      #    (@inbounds R = [  A[1,1]*E[1,1]             A[2,1]*E[1,1]               0 ;
      #                      A[1,2]*E[1,1]    A[1,1]*E[2,2]+A[2,2]*E[1,1]    A[2,1]*E[2,2];
      #                           0                   A[1,2]*E[2,2]          A[2,2]*E[2,2]]) :
      #    (@inbounds R = [  A[1,1]*E[1,1]                    A[2,1]*E[1,1]                              0 ;
      #          A[1,1]*E[1,2]+A[1,2]*E[1,1]    A[1,1]*E[2,2]+A[2,1]*E[1,2]+A[2,2]*E[1,1]    A[2,1]*E[2,2];
      #          A[1,2]*E[1,2]                    A[1,2]*E[2,2]+A[2,2]*E[1,2]                A[2,2]*E[2,2]] )
      @inbounds  R[1,1] = A[1,1]*E[1,1]
      @inbounds  R[1,2] = A[2,1]*E[1,1]
      @inbounds  R[1,3] = ZERO
      @inbounds  R[2,1] = A[1,1]*E[1,2]+A[1,2]*E[1,1]
      @inbounds  R[2,2] = A[1,1]*E[2,2]+A[2,1]*E[1,2]+A[2,2]*E[1,1]
      @inbounds  R[2,3] = A[2,1]*E[2,2]
      @inbounds  R[3,1] = A[1,2]*E[1,2]
      @inbounds  R[3,2] = A[1,2]*E[2,2]+A[2,2]*E[1,2]
      @inbounds  R[3,3] = A[2,2]*E[2,2]
   else
      # R =
      # [ a11*e11,       a11*e12 + a12*e11,         a12*e12
      # a21*e11, a11*e22 + a21*e12 + a22*e11, a12*e22 + a22*e12
      #       0,                   a21*e22,         a22*e22]
      # iszero(E[1,2]) ?
      #    (@inbounds  R = [  A[1,1]*E[1,1]            A[1,2]*E[1,1]                    0;
      #                       A[2,1]*E[1,1]    A[1,1]*E[2,2]+A[2,2]*E[1,1]     A[1,2]*E[2,2];
      #                             0                  A[2,1]*E[2,2]           A[2,2]*E[2,2]] ) :
      #    (@inbounds  R = [  A[1,1]*E[1,1]    A[1,1]*E[1,2]+A[1,2]*E[1,1]             A[1,2]*E[1,2];
      #           A[2,1]*E[1,1]    A[1,1]*E[2,2]+A[2,1]*E[1,2]+A[2,2]*E[1,1]     A[1,2]*E[2,2]+A[2,2]*E[1,2];
      #                 0                   A[2,1]*E[2,2]                              A[2,2]*E[2,2]] )
      @inbounds  R[1,1] = A[1,1]*E[1,1]
      @inbounds  R[1,2] = A[1,1]*E[1,2]+A[1,2]*E[1,1]
      @inbounds  R[1,3] = A[1,2]*E[1,2]
      @inbounds  R[2,1] = A[2,1]*E[1,1]
      @inbounds  R[2,2] = A[1,1]*E[2,2]+A[2,1]*E[1,2]+A[2,2]*E[1,1]
      @inbounds  R[2,3] = A[1,2]*E[2,2]+A[2,2]*E[1,2]
      @inbounds  R[3,1] = ZERO
      @inbounds  R[3,2] = A[2,1]*E[2,2]
      @inbounds  R[3,3] = A[2,2]*E[2,2]
   end
   luslv!(R,Y,3) && throw("ME:SingularException: A-λE has eigenvalues α and β such that α+β ≈ 0")
   @inbounds C[1,1] = Y[1]
   @inbounds C[1,2] = Y[2]
   @inbounds C[2,1] = Y[2]
   @inbounds C[2,2] = Y[3]
   return C
end
@inline function lyapcsylv2!(adj,C::AbstractMatrix{T},na::Int,nb::Int,A::AbstractMatrix{T},E::AbstractMatrix{T},B::AbstractMatrix{T},F::AbstractMatrix{T},R::AbstractMatrix{T},Y::StridedVector{T}) where T <:Real
#  @inline function lyapcsylv2!(adj,C::AbstractMatrix{T},na::Int,nb::Int,A::AbstractMatrix{T},E::AbstractMatrix{T},B::AbstractMatrix{T},F::AbstractMatrix{T},Xw::AbstractMatrix{T},Yw::StridedVector{T}) where T <:BlasReal
# speed and reduced allocation oriented implementation of a solver for 1x1 and 2x2 Sylvester equations
# encountered in solving generalized continuous Lyapunov equations:
#      A'*X*F + E'*X*B = -C if adj = true  -> R = kron(F',A')+kron(B',E') = (kron(F,A)+kron(B,E))'
#      A*X*F' + E*X*B' = -C if adj = false -> R = kron(F,A)+kron(B,E)
   if na == 1 && nb == 1
      temp = A[1,1]*F[1,1] + E[1,1]*B[1,1]
      rmul!(C,inv(-temp))
      any(!isfinite, C) && throw("ME:SingularException: A-λE has eigenvalues α and β such that α+β ≈ 0")
      return C
   end
   ZERO = zero(T)
   if adj
      if na == 1
         # R12t =
         # [ a11*f11+b11*e11           b21*e11]
         # [ a11*f12+b12*e11 a11*f22+b22*e11]
         # @inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1]           B[2,1]*E[1,1];
         #                 A[1,1]*F[1,2]+B[1,2]*E[1,1] A[1,1]*F[2,2]+B[2,2]*E[1,1]]
         @inbounds  R[1,1] = A[1,1]*F[1,1]+B[1,1]*E[1,1]
         @inbounds  R[1,2] = B[2,1]*E[1,1]
         @inbounds  R[2,1] = A[1,1]*F[1,2]+B[1,2]*E[1,1]
         @inbounds  R[2,2] = A[1,1]*F[2,2]+B[2,2]*E[1,1]
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
      else
         if nb == 1
            # R21t =
            # [ a11*f11+b11*e11           a21*f11]
            # [ a12*f11+b11*e12 a22*f11+b11*e22]
            # @inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1]           A[2,1]*F[1,1];
            #                 A[1,2]*F[1,1]+B[1,1]*E[1,2] A[2,2]*F[1,1]+B[1,1]*E[2,2] ]
            @inbounds  R[1,1] = A[1,1]*F[1,1]+B[1,1]*E[1,1]
            @inbounds  R[1,2] = A[2,1]*F[1,1]
            @inbounds  R[2,1] = A[1,2]*F[1,1]+B[1,1]*E[1,2]
            @inbounds  R[2,2] = A[2,2]*F[1,1]+B[1,1]*E[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # Rt =
            # [ a11*f11+b11*e11           a21*f11           b21*e11                 0]
            # [ a12*f11+b11*e12 a22*f11+b11*e22           b21*e12           b21*e22]
            # [ a11*f12+b12*e11           a21*f12 a11*f22+b22*e11           a21*f22]
            # [ a12*f12+b12*e12 a22*f12+b12*e22 a12*f22+b22*e12 a22*f22+b22*e22]
            # (iszero(E[1,2]) && iszero(F[1,2])) ?
            #  (@inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1]           A[2,1]*F[1,1]           B[2,1]*E[1,1]                 0;
            #                A[1,2]*F[1,1]  A[2,2]*F[1,1]+B[1,1]*E[2,2]           0           B[2,1]*E[2,2];
            #                B[1,2]*E[1,1]        0  A[1,1]*F[2,2]+B[2,2]*E[1,1]           A[2,1]*F[2,2];
            #                0  B[1,2]*E[2,2] A[1,2]*F[2,2]+B[2,2]*E[1,2] A[2,2]*F[2,2]+B[2,2]*E[2,2]]) :
            #  (@inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1]           A[2,1]*F[1,1]           B[2,1]*E[1,1]                 0;
            #                A[1,2]*F[1,1]+B[1,1]*E[1,2] A[2,2]*F[1,1]+B[1,1]*E[2,2]           B[2,1]*E[1,2]           B[2,1]*E[2,2];
            #                A[1,1]*F[1,2]+B[1,2]*E[1,1]           A[2,1]*F[1,2] A[1,1]*F[2,2]+B[2,2]*E[1,1]           A[2,1]*F[2,2];
            #                A[1,2]*F[1,2]+B[1,2]*E[1,2] A[2,2]*F[1,2]+B[1,2]*E[2,2] A[1,2]*F[2,2]+B[2,2]*E[1,2] A[2,2]*F[2,2]+B[2,2]*E[2,2]])
            @inbounds  R[1,1] = A[1,1]*F[1,1]+B[1,1]*E[1,1]
            @inbounds  R[1,2] = A[2,1]*F[1,1]
            @inbounds  R[1,3] = B[2,1]*E[1,1]
            @inbounds  R[1,4] = ZERO
            @inbounds  R[2,1] = A[1,2]*F[1,1]+B[1,1]*E[1,2]
            @inbounds  R[2,2] = A[2,2]*F[1,1]+B[1,1]*E[2,2]
            @inbounds  R[2,3] = B[2,1]*E[1,2]
            @inbounds  R[2,4] = B[2,1]*E[2,2]
            @inbounds  R[3,1] = A[1,1]*F[1,2]+B[1,2]*E[1,1]
            @inbounds  R[3,2] = A[2,1]*F[1,2]
            @inbounds  R[3,3] = A[1,1]*F[2,2]+B[2,2]*E[1,1]
            @inbounds  R[3,4] = A[2,1]*F[2,2]
            @inbounds  R[4,1] = A[1,2]*F[1,2]+B[1,2]*E[1,2]
            @inbounds  R[4,2] = A[2,2]*F[1,2]+B[1,2]*E[2,2]
            @inbounds  R[4,3] = A[1,2]*F[2,2]+B[2,2]*E[1,2]
            @inbounds  R[4,4] = A[2,2]*F[2,2]+B[2,2]*E[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   else
      if na == 1
         # R12 =
         # [ a11*f11+b11*e11 a11*f12+b12*e11]
         # [           b21*e11 a11*f22+b22*e11]
         # @inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1] A[1,1]*F[1,2]+B[1,2]*E[1,1];
         #                    B[2,1]*E[1,1] A[1,1]*F[2,2]+B[2,2]*E[1,1]]
         @inbounds  R[1,1] = A[1,1]*F[1,1]+B[1,1]*E[1,1]
         @inbounds  R[1,2] = A[1,1]*F[1,2]+B[1,2]*E[1,1]
         @inbounds  R[2,1] = B[2,1]*E[1,1]
         @inbounds  R[2,2] = A[1,1]*F[2,2]+B[2,2]*E[1,1]
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
      else
         if nb == 1
            # R21 =
            # [ a11*f11+b11*e11 a12*f11+b11*e12]
            # [           a21*f11 a22*f11+b11*e22]
            # @inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1] A[1,2]*F[1,1]+B[1,1]*E[1,2];
            #                  A[2,1]*F[1,1] A[2,2]*F[1,1]+B[1,1]*E[2,2]]
            @inbounds  R[1,1] = A[1,1]*F[1,1]+B[1,1]*E[1,1]
            @inbounds  R[1,2] = A[1,2]*F[1,1]+B[1,1]*E[1,2]
            @inbounds  R[2,1] = A[2,1]*F[1,1]
            @inbounds  R[2,2] = A[2,2]*F[1,1]+B[1,1]*E[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # R =
            # [ a11*f11+b11*e11 a12*f11+b11*e12 a11*f12+b12*e11 a12*f12+b12*e12]
            # [           a21*f11 a22*f11+b11*e22           a21*f12 a22*f12+b12*e22]
            # [           b21*e11           b21*e12 a11*f22+b22*e11 a12*f22+b22*e12]
            # [                 0           b21*e22           a21*f22 a22*f22+b22*e22]
            # (iszero(E[1,2]) && iszero(F[1,2])) ?
            # (@inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1] A[1,2]*F[1,1] B[1,2]*E[1,1] 0;
            #                A[2,1]*F[1,1] A[2,2]*F[1,1]+B[1,1]*E[2,2]           0   B[1,2]*E[2,2];
            #                B[2,1]*E[1,1]           0   A[1,1]*F[2,2]+B[2,2]*E[1,1] A[1,2]*F[2,2];
            #                0           B[2,1]*E[2,2]           A[2,1]*F[2,2] A[2,2]*F[2,2]+B[2,2]*E[2,2]]) :
            # (@inbounds R = [ A[1,1]*F[1,1]+B[1,1]*E[1,1] A[1,2]*F[1,1]+B[1,1]*E[1,2] A[1,1]*F[1,2]+B[1,2]*E[1,1] A[1,2]*F[1,2]+B[1,2]*E[1,2];
            #                A[2,1]*F[1,1] A[2,2]*F[1,1]+B[1,1]*E[2,2]           A[2,1]*F[1,2] A[2,2]*F[1,2]+B[1,2]*E[2,2];
            #                B[2,1]*E[1,1]           B[2,1]*E[1,2] A[1,1]*F[2,2]+B[2,2]*E[1,1] A[1,2]*F[2,2]+B[2,2]*E[1,2];
            #                0           B[2,1]*E[2,2]           A[2,1]*F[2,2] A[2,2]*F[2,2]+B[2,2]*E[2,2]])
            @inbounds  R[1,1] = A[1,1]*F[1,1]+B[1,1]*E[1,1]
            @inbounds  R[1,2] = A[1,2]*F[1,1]+B[1,1]*E[1,2]
            @inbounds  R[1,3] = A[1,1]*F[1,2]+B[1,2]*E[1,1]
            @inbounds  R[1,4] = A[1,2]*F[1,2]+B[1,2]*E[1,2]
            @inbounds  R[2,1] = A[2,1]*F[1,1]
            @inbounds  R[2,2] = A[2,2]*F[1,1]+B[1,1]*E[2,2]
            @inbounds  R[2,3] = A[2,1]*F[1,2]
            @inbounds  R[2,4] = A[2,2]*F[1,2]+B[1,2]*E[2,2]
            @inbounds  R[3,1] = B[2,1]*E[1,1]
            @inbounds  R[3,2] = B[2,1]*E[1,2]
            @inbounds  R[3,3] = A[1,1]*F[2,2]+B[2,2]*E[1,1]
            @inbounds  R[3,4] = A[1,2]*F[2,2]+B[2,2]*E[1,2]
            @inbounds  R[4,1] = ZERO
            @inbounds  R[4,2] = B[2,1]*E[2,2]
            @inbounds  R[4,3] = A[2,1]*F[2,2]
            @inbounds  R[4,4] = A[2,2]*F[2,2]+B[2,2]*E[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   end
   luslv!(R,Y,na*nb) && throw("ME:SingularException: A-λE has eigenvalues α and β such that α+β ≈ 0")
   if na == 1 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[1,2] = Y[2]
   elseif na == 2 && nb == 1
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
   else # na == 2 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
      @inbounds C[1,2] = Y[3]
      @inbounds C[2,2] = Y[4]
   end
   return C
end
function lyapcs!(A::AbstractMatrix{T1},E::Union{AbstractMatrix{T1},UniformScaling{Bool}}, C::AbstractMatrix{T1}; adj = false) where {T1<:Complex}
   n = LinearAlgebra.checksquare(A)
   (LinearAlgebra.checksquare(C) == n && ishermitian(C)) ||
      throw(DimensionMismatch("C must be a $n x $n hermitian matrix"))
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) && size(E,1) == n)) && (lyapcs!(A, C, adj = adj); return)
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))

   W = Array{T1,1}(undef,n)
   # Compute the hermitian solution
   if adj
      for k = 1:n
         for l = 1:k
            y = C[k,l]
            if k > 1
               C[l,k] = C[l,1]*A[1,k]
               W[l] = C[l,1]*E[1,k]
               for ir = 2:k-1
                  C[l,k] +=  C[l,ir]*A[ir,k]
                  W[l] += C[l,ir]*E[ir,k]
               end
               for ic = 1:l
                   y += C[ic,k]'*E[ic,l] + W[ic]'*A[ic,l]
                end
            end
            C[k,l] = -y/(A[k,k]'*E[l,l]+E[k,k]'*A[l,l])
            isfinite(C[k,l]) || throw("ME:SingularException: A-λE has eigenvalues α and β such that α+β ≈ 0")
            k == l && (C[k,k] = real(C[k,k]))
            if l < k
               C[l,k] += C[k,l]'*A[k,k]
               W[l] += C[k,l]'*E[k,k]
            end
         end
         for ir = 1:k-1
             C[ir,k] = C[k,ir]'
         end
      end
   else
      for l = n:-1:1
        for k = n:-1:l
            y = C[l,k]
            if l < n
               C[k,l] = C[k,l+1]*A[l,l+1]'
               W[k] = C[k,l+1]*E[l,l+1]'
               for ir = l+2:n
                   C[k,l] += C[k,ir]*A[l,ir]'
                   W[k] += C[k,ir]*E[l,ir]'
               end
               for ic = k:n
                   y += (E[k,ic]*C[ic,l] + A[k,ic]*W[ic])'
               end
            end
            C[l,k] = -y/(A[k,k]'*E[l,l]+E[k,k]'*A[l,l])
            isfinite(C[l,k]) ||  throw("ME:SingularException: A-λE has eigenvalues α and β such that α+β ≈ 0")
            k == l && (C[k,k] = real(C[k,k]))
            if k > l
               C[k,l] += (A[l,l]*C[l,k])'
               W[k] += (E[l,l]*C[l,k])'
            end
        end
        if l < n
           for ir = l+1:n
               C[ir,l] = C[l,ir]'
           end
        end
      end
   end
end
function lyapcs_blocked!(A::AbstractMatrix{T1}, E::AbstractMatrix{T1}, C::AbstractMatrix{T1}; adj = false, blocksize::Integer = 64) where {T1<:BlasFloat}
    n = LinearAlgebra.checksquare(A)  
    LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
    LinearAlgebra.checksquare(C) == n || throw(DimensionMismatch("C must be a $n x $n matrix or I"))
    mid = n ÷ 2
    if T1 <: Real  
       # Check symmetry ONCE here
       issymmetric(C) ||  throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
       mid += 2
    else
       ishermitian(C) ||  throw(DimensionMismatch("C must be a $n x $n Hermitian matrix"))
       mid += 1
    end
    
    # Allocate a full-sized WS and half-sized WS1 once. 
    WS = Matrix{T1}(undef,n,n)
    WS1 = Matrix{T1}(undef,mid,mid)
    _lyapcs_blocked!(WS, WS1, A, E, C, adj, blocksize)

    # Fill the lower triangle ONCE at the very end
    return LinearAlgebra.copytri!(C, 'U', T1 <: Complex)
end
function _lyapcs_blocked!(WS::AbstractMatrix{T1},WS1::AbstractMatrix{T1},A::AbstractMatrix{T1},E::AbstractMatrix{T1},
                          C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasReal}
   n = size(A, 1)
   ONE = one(T1)
   ZERO = zero(T1)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U')
      lyapcs!(A,E,C;adj)
   else
      # split A, E and C (by rows and columns)
      mid = n ÷ 2
      n1 =  A[mid+1, mid] != 0 ? mid + 1 : mid
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         E11, E12, E22 = E[i1,i1], E[i1,i2], E[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
         WS11, WS12, WS22 = WS[i1,i1], WS[i1,i2], WS[i2,i2]
      end
      if adj
         # Adjoint Case: A' X E + E' X A + C = 0  
         
         # 1. Solve X11
        _lyapcs_blocked!(WS11, WS1, A11, E11, C11, adj, blocksize)

         # 2. Update C12 = C12 + A11' * X11 * E12 + E11' * X11 * A12
         mul!(WS12, Symmetric(C11, :U), E12)
         BLAS.gemm!('T', 'N', ONE, A11, WS12, ONE, C12)
    
         mul!(WS12, Symmetric(C11, :U), A12)
         BLAS.gemm!('T', 'N', ONE, E11, WS12, ONE, C12)    

         # 3. Solve Generalized Dual Sylvester for X12
         # Ensure your sylvester solver configuration treats A11 and E11 as transposed
         lyapgsylvcs_blocked!(WS1, A11, E22, E11, A22, C12; adj, blocksize)

         # 4. Update C22 = C22 + A12'*(X11*E12+X12*E22)+(X11*E12+X12*E22)'*A12
         mul!(WS12, Symmetric(C11, :U), E12)
         mul!(WS12, C12, E22, ONE, ONE)
         BLAS.syr2k!('U', 'T', ONE, A12, WS12, ONE, C22)

         # Update C22 = C22 + E12'*(X12*A22)+(X12*A22)'*E12
         mul!(WS12, C12, A22)
         BLAS.syr2k!('U', 'T', ONE, E12, WS12, ONE, C22)

         # 5. Solve X22
         _lyapcs_blocked!(WS22, WS1, A22, E22, C22, adj, blocksize)
      else
         # Standard Case: A X E' + E X A' + C = 0

         # X22 solver
         _lyapcs_blocked!(WS22, WS1, A22, E22, C22, adj, blocksize)

         # Update C12: C12 = C12 + A12 * X22 * E22' + E12 * X22 * A22'
         # Use WS[i1, i2] for (E12 * C22)
         BLAS.symm!('R', 'U', ONE, C22, E12, ZERO, WS12)
         BLAS.gemm!('N', 'T', ONE, WS12, A22, ONE, C12)
         # Use WS[i1, i2] for (A12 * C22)
         BLAS.symm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         BLAS.gemm!('N', 'T', ONE, WS12, E22, ONE, C12)

         # Solve generalized Sylvester: A11 * X12 * E22' + E11 X12 A22' + C12 = 0
         lyapgsylvcs_blocked!(WS1, A11, E22, E11, A22, C12; adj, blocksize)

         # Update C11: C11 = C11 + (A11*X12+A12*X22)*E12' + E12*(A11*X12+A12*X22)'
         # 1. WS12 = WS12 + A11*C12   [WS12 contains A11*C12+A12*C22]
         BLAS.gemm!('N', 'N', ONE, A11, C12, ONE, WS12)
         # 2. C11 = C11 + WS12*E12' + E12*WS12' -> syr2k
         BLAS.syr2k!('U', 'N', ONE, WS12, E12, ONE, C11)
  
         # 3. C11 = C11 + (E11*X12)*A12' + A12*(E11*X12)' -> syr2k
         BLAS.gemm!('N', 'N', ONE, E11, C12, ZERO, WS12)
         BLAS.syr2k!('U', 'N', ONE, WS12, A12, ONE, C11)

         # X11 solver
         _lyapcs_blocked!(WS11, WS1, A11, E11, C11, adj, blocksize)
      end
   end
end
function _lyapcs_blocked!(WS::AbstractMatrix{T1},WS1::AbstractMatrix{T1},A::AbstractMatrix{T1},E::AbstractMatrix{T1},
                          C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasComplex}
   n = size(A, 1)
   ONE = one(T1)
   RONE = real(ONE)
   ZERO = zero(T1)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U',true)
      lyapcs!(A,E,C;adj)
   else
      # split A, E and C (by rows and columns)
      n1 = n ÷ 2
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         E11, E12, E22 = E[i1,i1], E[i1,i2], E[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
         WS11, WS12, WS22 = WS[i1,i1], WS[i1,i2], WS[i2,i2]
      end
      if adj
         # Adjoint Case: A' X E + E' X A + C = 0  
         
         # 1. Solve X11
        _lyapcs_blocked!(WS11, WS1, A11, E11, C11, adj, blocksize)

         # 2. Update C12 = C12 + A11' * X11 * E12 + E11' * X11 * A12
         mul!(WS12, Hermitian(C11, :U), E12)
         BLAS.gemm!('C', 'N', ONE, A11, WS12, ONE, C12)
    
         mul!(WS12, Hermitian(C11, :U), A12)
         BLAS.gemm!('C', 'N', ONE, E11, WS12, ONE, C12)    

         # 3. Solve Generalized Dual Sylvester for X12
         # Ensure your sylvester solver configuration treats A11 and E11 as transposed
         lyapgsylvcs_blocked!(WS1, A11, E22, E11, A22, C12; adj, blocksize)

         # 4. Update C22 = C22 + A12'*(X11*E12+X12*E22)+(X11*E12+X12*E22)'*A12
         mul!(WS12, Hermitian(C11, :U), E12)
         mul!(WS12, C12, E22, ONE, ONE)
         BLAS.her2k!('U', 'C', ONE, A12, WS12, RONE, C22)

         # Update C22 = C22 + E12'*(X12*A22)+(X12*A22)'*E12
         mul!(WS12, C12, A22)
         BLAS.her2k!('U', 'C', ONE, E12, WS12, RONE, C22)

         # 5. Solve X22
         _lyapcs_blocked!(WS22, WS1, A22, E22, C22, adj, blocksize)
      else
         # Standard Case: A X E' + E X A' + C = 0

         # X22 solver
         _lyapcs_blocked!(WS22, WS1, A22, E22, C22, adj, blocksize)

         # Update C12: C12 = C12 + A12 * X22 * E22' + E12 * X22 * A22'
         # Use WS[i1, i2] for (E12 * C22)
         BLAS.hemm!('R', 'U', ONE, C22, E12, ZERO, WS12)
         BLAS.gemm!('N', 'C', ONE, WS12, A22, ONE, C12)
         # Use WS[i1, i2] for (A12 * C22)
         BLAS.hemm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         BLAS.gemm!('N', 'C', ONE, WS12, E22, ONE, C12)

         # Solve generalized Sylvester: A11 * X12 * E22' + E11 X12 A22' + C12 = 0
         lyapgsylvcs_blocked!(WS1, A11, E22, E11, A22, C12; adj, blocksize)

         # Update C11: C11 = C11 + (A11*X12+A12*X22)*E12' + E12*(A11*X12+A12*X22)'
         # 1. WS12 = WS12 + A11*C12   [WS12 contains A11*C12+A12*C22]
         BLAS.gemm!('N', 'N', ONE, A11, C12, ONE, WS12)
         # 2. C11 = C11 + WS12*E12' + E12*WS12' -> syr2k
         BLAS.her2k!('U', 'N', ONE, WS12, E12, RONE, C11)
  
         # 3. C11 = C11 + (E11*X12)*A12' + A12*(E11*X12)' -> syr2k
         BLAS.gemm!('N', 'N', ONE, E11, C12, ZERO, WS12)
         BLAS.her2k!('U', 'N', ONE, WS12, A12, RONE, C11)

         # X11 solver
         _lyapcs_blocked!(WS11, WS1, A11, E11, C11, adj, blocksize)
      end
   end
end

function lyapgsylvcs_blocked!(WS::AbstractMatrix{T1}, A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}, D::AbstractMatrix{T1}, E::AbstractMatrix{T1}; adj = false, blocksize::Integer = 64) where {T1<:BlasFloat}
   m = LinearAlgebra.checksquare(A)  
   n = LinearAlgebra.checksquare(B)
   (m, n) == size(E) || throw(DimensionMismatch("E must be a $m x $n"))
   
   # Call the positional recursive worker
   _lyapgsylvcs_blocked!(WS, A, B, C, D, E, adj, blocksize)
end
function _lyapgsylvcs_blocked!(WS, A, B, C, D, E, adj::Bool, blocksize::Integer)
   m = size(A, 1)
   n = size(B, 1)
   if m <= max(blocksize,4) && n <= max(blocksize,4)
      gsylvs!(A,B,C,D,E;adjAC = adj,adjBD = !adj,DBSchur = true)
      rmul!(E, -1)
   else
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 
      midn = n ÷ 2
      n1 = D[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n 
      if eltype(A) <: Real
         @views begin
            A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
            B11, B12, B22 = UpperTriangular(B[ib1,ib1]), B[ib1,ib2], UpperTriangular(B[ib2,ib2])
            C11, C12, C22 = UpperTriangular(C[ia1,ia1]), C[ia1,ia2], UpperTriangular(C[ia2,ia2])
            D11, D12, D22 = D[ib1,ib1], D[ib1,ib2], D[ib2,ib2]
            E11, E12, E21, E22 = E[ia1,ib1], E[ia1,ib2], E[ia2,ib1], E[ia2,ib2]
            WS11, WS12, WS21, WS22 = WS[ia1,ib1], WS[ia1,ib2], WS[ia2,ib1], WS[ia2,ib2]
         end
      else
         @views begin
            A11, A12, A22 = UpperTriangular(A[ia1,ia1]), A[ia1,ia2], UpperTriangular(A[ia2,ia2])
            B11, B12, B22 = UpperTriangular(B[ib1,ib1]), B[ib1,ib2], UpperTriangular(B[ib2,ib2])
            C11, C12, C22 = UpperTriangular(C[ia1,ia1]), C[ia1,ia2], UpperTriangular(C[ia2,ia2])
            D11, D12, D22 =  UpperTriangular(D[ib1,ib1]), D[ib1,ib2],  UpperTriangular(D[ib2,ib2])
            E11, E12, E21, E22 = E[ia1,ib1], E[ia1,ib2], E[ia2,ib1], E[ia2,ib2]
            WS11, WS12, WS21, WS22 = WS[ia1,ib1], WS[ia1,ib2], WS[ia2,ib1], WS[ia2,ib2]
         end
      end
      if adj
         # solve A' X B + C' X D + E = 0

         # X11 solver
         _lyapgsylvcs_blocked!(WS11, A11, B11, C11, D11, E11, adj, blocksize)

         # E12 update: E12 = E12 + A11'*X11*B12 + C11'*X11*D12
         mul!(WS11, A11', E11)
         mul!(E12, WS11, B12, 1, 1)
         mul!(WS11, C11', E11)
         mul!(E12, WS11, D12, 1, 1)
 
         # X12 solver
         _lyapgsylvcs_blocked!(WS12, A11, B22, C11, D22, E12, adj, blocksize)

         # E21 update: E21 = E21 + A12'*X11*B11 + C12'*X11*D11
         #mul!(WS11,E11, UpperTriangular(B11))
         mul!(WS11,E11, B11)
         mul!(E21,A12',WS11,1,1)
         mul!(WS11, E11, D11)
         mul!(E21, C12', WS11,1,1)

         # X21 solver
         _lyapgsylvcs_blocked!(WS21, A22, B11, C22, D11, E21, adj, blocksize)

         # E22 update: E22 = E22 + A12'*X12*B22 + C12'*X12*D22 +
         #                   (A12'*X11+A22'*X21)*B12 + (C12'*X11+C22'*X21)*D12
         # WS21 = A12'*X11+A22'*X21
         # mul!(WS21, A12', E11)
         # mul!(WS21, A22', E21, 1, 1)
         mul!(WS21, A22', E21)
         mul!(WS21, A12', E11, 1, 1)
         # E22 = E22 + WS21 * B12
         mul!(E22, WS21, B12, 1, 1)
         # WS12 = C12'*X11+C22'*X22)
         # mul!(WS21, C12', E11)
         # mul!(WS21, C22', E21, 1, 1)
         mul!(WS21, C22', E21)
         mul!(WS21, C12', E11, 1, 1)
         # E22 = E22 + WS21 * D12
         mul!(E22, WS21, D12, 1, 1)

         # E22 = E22 + A12'*X12*B22
         mul!(WS12, E12, B22)
         mul!(E22, A12', WS12, 1, 1) 
         # E22 = E22 + A12'*X12*B22
         mul!(WS12, E12, D22)
         mul!(E22, C12', WS12, 1, 1) 

         # X22 solver
         _lyapgsylvcs_blocked!(WS22, A22, B22, C22, D22, E22, adj, blocksize)
      else
         # solve A X B' + C X D' + E = 0

         # X22 solver
         _lyapgsylvcs_blocked!(WS22, A22, B22, C22, D22, E22, adj, blocksize)

         # E12 update: E12 = E12 + A12*X22*B22' + C12*X22*D22'
         mul!(WS22,E22,B22')
         mul!(E12,A12,WS22,1,1)
         mul!(WS22,E22,D22')
         mul!(E12,C12,WS22,1,1)

         # X12 solver
         _lyapgsylvcs_blocked!(WS12, A11, B22, C11, D22, E12, adj, blocksize)

         # E21 update: E21 = E21 + A22*X22*B12' + C22*X22*D12'
         mul!(WS22,A22,E22)
         mul!(E21,WS22,B12',1,1)
         mul!(WS22,C22,E22)
         mul!(E21,WS22,D12',1,1)

         # X21 solver
         _lyapgsylvcs_blocked!(WS21, A22, B11, C22, D11, E21, adj, blocksize)


         # E11 update: E11 = E11 + A12*X21*B11' + C12*X21*D11' +
         #                   (A11*X12+A12*X22)*B12' + (C11*X12+C12*X22)*D12'
         # WS12 = A11*X12+A12*X22
         mul!(WS12, A11, E12)
         mul!(WS12, A12, E22, 1, 1)
         # E11 = E11 + WS12 * B12'
         mul!(E11, WS12, B12', 1, 1)
         # WS12 = C11*X12+C12*X22
         mul!(WS12, C11, E12)
         mul!(WS12, C12, E22, 1, 1)
         # E11 = E11 + WS12 * D12'
         mul!(E11, WS12, D12', 1, 1)

         # E11 = E11 + A12*X21*B11'
         mul!(WS21, E21, B11')
         mul!(E11, A12, WS21, 1, 1) 
         # E11 = E11 + C12*X21*D11'
         mul!(WS21, E21, D11')
         mul!(E11, C12, WS21, 1, 1) 

         # X11 solver
         _lyapgsylvcs_blocked!(WS11, A11, B11, C11, D11, E11, adj, blocksize)
      end
   end   
end


"""
    lyapds!(A, C; adj = false)

Solve the discrete Lyapunov matrix equation

                op(A)Xop(A)' - X + C = 0,

where `op(A) = A` if `adj = false` and `op(A) = A'` if `adj = true`.
`A` is in a real or complex Schur form and `C` is a symmetric or hermitian matrix.
`A` must not have eigenvalues `α` and `β` such that `αβ = 1`.
The computed symmetric or hermitian solution `X` is contained in `C`.
"""
function lyapds!(A::AbstractMatrix{T1},C::AbstractMatrix{T1}; adj = false) where {T1<:Real}
   n = LinearAlgebra.checksquare(A)
   (LinearAlgebra.checksquare(C) == n && issymmetric(C)) ||
      throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
   ONE = one(T1)  
   if isdiag(A) 
      for i = 1:n
         C[i,i] = -C[i,i]/(A[i,i]*A[i,i]-ONE)
         isfinite(C[i,i]) || throw("ME:SingularException: A has eigenvalue(s) = 1")
         for j = i+1:n
            C[i,j] = -C[i,j]/(A[i,i]*A[j,j]-ONE)
            isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and β such that αβ = 1")
            C[j,i] = C[i,j]
         end
      end
      return C[:,:]
   end      

   # determine the dimensions of the diagonal blocks of real Schur form

   G = Matrix{T1}(undef,2,2)
   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   ba, p = sfstruct(A)
   if adj
      # """
      # The (K,L)th block of X is determined starting from the
      # upper-left corner column by column by

      # A(K,K)'*X(K,L)*A(L,L) - X(K,L) = -C(K,L) - R(K,L),

      # where
      #           K           L-1
      # R(K,L) = SUM {A(I,K)'*SUM [X(I,J)*A(J,L)]} +
      #          I=1          J=1

      #           K-1
      #          {SUM [A(I,K)'*X(I,L)]}*A(L,L).
      #           I=1
      # """
      i = 1
      @inbounds  for kk = 1:p
          dk = ba[kk]
          k = i:i+dk-1
          j = 1
          ir = 1:i-1
          for ll = 1:kk
              dl = ba[ll]
              j1 = j+dl-1
              l = j:j1
              Ckl = view(C,k,l)
              y = view(G,1:dk,1:dl)
              copyto!(y,Ckl)
              if kk > 1
                # C[l,k] = C[l,ir]*A[ir,k]
                 mul!(view(C,l,k),view(C,l,ir),view(A,ir,k))
                 ic = 1:j1
                 #y += C[ic,k]'*A[ic,l]
                 mul!(y,transpose(view(C,ic,k)),view(A,ic,l),ONE,ONE)
              end
              if kk == ll
                 lyapd2!(adj,y,dk,view(A,k,k),Xw,Yw)
                 copyto!(Ckl,y)
              else
                 lyapdsylv2!(adj,y,dk,dl,view(A,k,k),view(A,l,l),Xw,Yw)
                 copyto!(Ckl,y)
              end
              j += dl
              if ll < kk
                 # C[l,k] += C[k,l]'*A[k,k]
                 mul!(view(C,l,k),transpose(Ckl),view(A,k,k),ONE,ONE)
               end
          end
          if kk > 1
             # C[ir,k] = C[k,ir]'
             transpose!(view(C,ir,k),view(C,k,ir))
          end
          i += dk
      end
   else
      # """
      # The (K,L)th block of X is determined starting from
      # bottom-right corner column by column by

      # A(K,K)*X(K,L)*A(L,L)' - X(K,L) = -C(K,L) - R(K,L),

      # where

      #           N            N
      # R(K,L) = SUM {A(K,I)* SUM [X(I,J)*A(L,J)']} +
      #          I=K         J=L+1

      #             N
      #          { SUM [A(K,J)*X(J,L)]}*A(L,L)'
      #           J=K+1
      # """
      j = n
      for ll = p:-1:1
          dl = ba[ll]
          l = j-dl+1:j
          i = n
          ir = j+1:n
          for kk = p:-1:ll
              dk = ba[kk]
              i1 = i-dk+1
              k = i1:i
              Clk = view(C,l,k)
              y = view(G,1:dl,1:dk)
              copyto!(y,Clk)
              if ll < p
                 # C[k,l] = C[k,ir]*A[l,ir]'
                 mul!(view(C,k,l),view(C,k,ir),transpose(view(A,l,ir)))
                 ic = i1:n
                 # y += (A[k,ic]*C[ic,l])'
                 mul!(y,transpose(view(C,ic,l)),transpose(view(A,k,ic)),ONE,ONE)
              end
              if i == j
                 lyapd2!(adj,y,dk,view(A,k,k),Xw,Yw)
                 copyto!(Clk,y)
              else
                 lyapdsylv2!(adj,y,dl,dk,view(A,l,l),view(A,k,k),Xw,Yw)
                 copyto!(Clk,y)
              end
              i -= dk
              if i >= j
                 #C[k,l] += (A[l,l]*C[l,k])'
                 mul!(view(C,k,l),transpose(Clk),transpose(view(A,l,l)),ONE,ONE)
              else
                 break
              end
          end
          if ll < p
             ir = i+2:n
             # C[ir,l] = C[l,ir]'
             transpose!(view(C,ir,l),view(C,l,ir))
          end
          j -= dl
      end
   end
end

function lyapd2!(adj,C::AbstractMatrix{T},na::Int,A::AbstractMatrix{T},R::AbstractMatrix{T},Y::StridedVector{T}) where T <:Real
   # speed and reduced allocation oriented implementation of a solver for 1x1 or 2x2 continuous Lyapunov equations
   #      A'*X*A - X = -C if adj = true  -> R = kron(A',A')-I = (kron(A,A)-I)'
   #      A*X*A' - X = -C if adj = false -> R = kron(A,A)-I
   MONE = -one(T)
   if na == 1
      temp = A[1,1]^2+MONE
      rmul!(C,inv(-temp))
      any(!isfinite, C) && throw("ME:SingularException: A has eigenvalue(s) with moduli ≈ 1")
      return C
   end
   TWO = 2*one(T)
   @inbounds  Y[1] = -C[1,1]
   @inbounds  Y[2] = -C[2,1]
   @inbounds  Y[3] = -C[2,2]
   if adj
      # Rt =
      # [ a11^2-1              2*a11*a21      a21^2]
      # [   a11*a12  a11*a22+a12*a21-1    a21*a22]
      # [     a12^2              2*a12*a22  a22^2-1]
      # @inbounds R = [ A[1,1]^2+MONE    TWO*A[1,1]*A[2,1]         A[2,1]^2;
      #                 A[1,1]*A[1,2]    A[1,1]*A[2,2]+A[1,2]*A[2,1]+MONE  A[2,1]*A[2,2];
      #                 A[1,2]^2         TWO*A[1,2]*A[2,2]         A[2,2]^2+MONE ]
      @inbounds  R[1,1] = A[1,1]^2+MONE
      @inbounds  R[1,2] = TWO*A[1,1]*A[2,1]
      @inbounds  R[1,3] = A[2,1]^2
      @inbounds  R[2,1] = A[1,1]*A[1,2]
      @inbounds  R[2,2] = A[1,1]*A[2,2]+A[1,2]*A[2,1]+MONE
      @inbounds  R[2,3] = A[2,1]*A[2,2]
      @inbounds  R[3,1] = A[1,2]^2
      @inbounds  R[3,2] = TWO*A[1,2]*A[2,2]
      @inbounds  R[3,3] = A[2,2]^2+MONE
   else
      # R =
      # [ a11^2-1              2*a11*a12      a12^2]
      # [   a11*a21  a11*a22+a12*a21-1    a12*a22]
      # [     a21^2              2*a21*a22  a22^2-1]

      # @inbounds R = [ A[1,1]^2+MONE    TWO*A[1,1]*A[1,2]         A[1,2]^2;
      #                 A[1,1]*A[2,1]    A[1,1]*A[2,2]+A[1,2]*A[2,1]+MONE  A[1,2]*A[2,2];
      #                 A[2,1]^2         TWO*A[2,1]*A[2,2]         A[2,2]^2+MONE ]
      @inbounds  R[1,1] = A[1,1]^2+MONE
      @inbounds  R[1,2] = TWO*A[1,1]*A[1,2]
      @inbounds  R[1,3] = A[1,2]^2
      @inbounds  R[2,1] = A[1,1]*A[2,1]
      @inbounds  R[2,2] = A[1,1]*A[2,2]+A[1,2]*A[2,1]+MONE
      @inbounds  R[2,3] = A[1,2]*A[2,2]
      @inbounds  R[3,1] = A[2,1]^2
      @inbounds  R[3,2] = TWO*A[2,1]*A[2,2]
      @inbounds  R[3,3] = A[2,2]^2+MONE
   end
   luslv!(R,Y,3) && throw("ME:SingularException: A has eigenvalues α and β such that αβ ≈ 1")
   @inbounds C[1,1] = Y[1]
   @inbounds C[1,2] = Y[2]
   @inbounds C[2,1] = Y[2]
   @inbounds C[2,2] = Y[3]
   return C
end
function lyapdsylv2!(adj::Bool,C::AbstractMatrix{T},na::Int,nb::Int,A::AbstractMatrix{T},B::AbstractMatrix{T},R::AbstractMatrix{T},Y::AbstractVector{T}) where T <: Real
#    # speed and reduced allocation oriented implementation of a solver for 1x1 and 2x2 Sylvester equations
#    # encountered in solving discrete Lyapunov equations:
#    #      A'*X*B - X = -C if adj = true  -> R = kron(B',A') - I = (kron(B,A)-I)'
#    #      A*X*B' - X = -C if adj = false -> R = kron(B,A)-I

   MONE = -one(T)
   if na == 1 && nb == 1
      temp = A[1,1]*B[1,1] + MONE
      rmul!(C,inv(-temp))
      any(!isfinite, C) && throw("ME:SingularException: A has eigenvalues α and β such that αβ ≈ 1")
      return C
   end
   if adj
      # @inbounds  R = kron(transpose(B),transpose(A)) - I
      if na == 1
         # R12t =
         # [ a11*b11-1      a11*b21]
         # [     a11*b12  a11*b22-1]
         # @inbounds R = [ A[1,1]*B[1,1]+MONE      A[1,1]*B[2,1];
         #                 A[1,1]*B[1,2]  A[1,1]*B[2,2]+MONE]
         @inbounds  R[1,1] = A[1,1]*B[1,1]+MONE
         @inbounds  R[1,2] = A[1,1]*B[2,1]
         @inbounds  R[2,1] = A[1,1]*B[1,2]
         @inbounds  R[2,2] = A[1,1]*B[2,2]+MONE
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
   else
         if nb == 1
            # R21t =
            # [ a11*b11-1      a21*b11]
            # [     a12*b11  a22*b11-1]
            # @inbounds R = [ A[1,1]*B[1,1]+MONE      A[2,1]*B[1,1];
            #                 A[1,2]*B[1,1]  A[2,2]*B[1,1]+MONE ]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+MONE
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[2,1] = A[1,2]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+MONE
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # Rt =
            # [ a11*b11-1      a21*b11      a11*b21      a21*b21]
            # [     a12*b11  a22*b11-1      a12*b21      a22*b21]
            # [     a11*b12      a21*b12  a11*b22-1      a21*b22]
            # [     a12*b12      a22*b12      a12*b22  a22*b22-1]
            # @inbounds R = [ A[1,1]*B[1,1]+MONE      A[2,1]*B[1,1]      A[1,1]*B[2,1]      A[2,1]*B[2,1];
            # A[1,2]*B[1,1]  A[2,2]*B[1,1]+MONE      A[1,2]*B[2,1]      A[2,2]*B[2,1];
            # A[1,1]*B[1,2]      A[2,1]*B[1,2]  A[1,1]*B[2,2]+MONE      A[2,1]*B[2,2];
            # A[1,2]*B[1,2]      A[2,2]*B[1,2]      A[1,2]*B[2,2]  A[2,2]*B[2,2]+MONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+MONE
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[1,3] = A[1,1]*B[2,1]
            @inbounds  R[1,4] = A[2,1]*B[2,1]
            @inbounds  R[2,1] = A[1,2]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+MONE
            @inbounds  R[2,3] = A[1,2]*B[2,1]
            @inbounds  R[2,4] = A[2,2]*B[2,1]
            @inbounds  R[3,1] = A[1,1]*B[1,2]
            @inbounds  R[3,2] = A[2,1]*B[1,2]
            @inbounds  R[3,3] = A[1,1]*B[2,2]+MONE
            @inbounds  R[3,4] = A[2,1]*B[2,2]
            @inbounds  R[4,1] = A[1,2]*B[1,2]
            @inbounds  R[4,2] = A[2,2]*B[1,2]
            @inbounds  R[4,3] = A[1,2]*B[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]+MONE
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   else
      # @inbounds  R = kron(B,A) - I
      if na == 1
         # R12 =
         # [ a11*b11-1      a11*b12]
         # [     a11*b21  a11*b22-1]
         # @inbounds R = [ A[1,1]*B[1,1]+MONE      A[1,1]*B[1,2];
         #                 A[1,1]*B[2,1]  A[1,1]*B[2,2]+MONE]
         @inbounds  R[1,1] = A[1,1]*B[1,1]+MONE
         @inbounds  R[1,2] = A[1,1]*B[1,2]
         @inbounds  R[2,1] = A[1,1]*B[2,1]
         @inbounds  R[2,2] = A[1,1]*B[2,2]+MONE
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
   else
         if nb == 1
            # R21 =
            #    [ a11*b11-1      a12*b11]
            #    [     a21*b11  a22*b11-1]
            # @inbounds R = [ A[1,1]*B[1,1]+MONE      A[1,2]*B[1,1];
            #                 A[2,1]*B[1,1]  A[2,2]*B[1,1]+MONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+MONE
            @inbounds  R[1,2] = A[1,2]*B[1,1]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+MONE
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # R =
            # [ a11*b11-1      a12*b11      a11*b12      a12*b12]
            # [     a21*b11  a22*b11-1      a21*b12      a22*b12]
            # [     a11*b21      a12*b21  a11*b22-1      a12*b22]
            # [     a21*b21      a22*b21      a21*b22  a22*b22-1]
            # @inbounds R = [ A[1,1]*B[1,1]+MONE      A[1,2]*B[1,1]      A[1,1]*B[1,2]      A[1,2]*B[1,2];
            # A[2,1]*B[1,1]  A[2,2]*B[1,1]+MONE      A[2,1]*B[1,2]      A[2,2]*B[1,2];
            # A[1,1]*B[2,1]      A[1,2]*B[2,1]  A[1,1]*B[2,2]+MONE      A[1,2]*B[2,2];
            # A[2,1]*B[2,1]      A[2,2]*B[2,1]      A[2,1]*B[2,2]  A[2,2]*B[2,2]+MONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+MONE
            @inbounds  R[1,2] = A[1,2]*B[1,1]
            @inbounds  R[1,3] = A[1,1]*B[1,2]
            @inbounds  R[1,4] = A[1,2]*B[1,2]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+MONE
            @inbounds  R[2,3] = A[2,1]*B[1,2]
            @inbounds  R[2,4] = A[2,2]*B[1,2]
            @inbounds  R[3,1] = A[1,1]*B[2,1]
            @inbounds  R[3,2] = A[1,2]*B[2,1]
            @inbounds  R[3,3] = A[1,1]*B[2,2]+MONE
            @inbounds  R[3,4] = A[1,2]*B[2,2]
            @inbounds  R[4,1] = A[2,1]*B[2,1]
            @inbounds  R[4,2] = A[2,2]*B[2,1]
            @inbounds  R[4,3] = A[2,1]*B[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]+MONE
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   end
   luslv!(R,Y,na*nb) && throw("ME:SingularException: A-λE has eigenvalues α and β such that αβ ≈ 1")
   if na == 1 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[1,2] = Y[2]
   elseif na == 2 && nb == 1
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
   else # na == 2 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
      @inbounds C[1,2] = Y[3]
      @inbounds C[2,2] = Y[4]
   end
return C
end
function lyapds_blocked!(A::AbstractMatrix{T1}, C::AbstractMatrix{T1}; adj = false, blocksize::Integer = 64) where {T1<:BlasFloat}
    n = LinearAlgebra.checksquare(A)  
    n == LinearAlgebra.checksquare(C) 
    mid = n ÷ 2
    if T1 <: Real  
       # Check symmetry ONCE here
       issymmetric(C) ||  throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
       mid += 2
    else
       ishermitian(C) ||  throw(DimensionMismatch("C must be a $n x $n Hermitian matrix"))
       mid += 1
    end
    
    # Allocate a full-sized WS and half-sized WS1 once. 
    WS = Matrix{T1}(undef,n,n)
    WS1 = Matrix{T1}(undef,mid,mid)
    _lyapds_blocked!(WS, WS1, A, C, adj, blocksize)

    # Fill the lower triangle ONCE at the very end
    return LinearAlgebra.copytri!(C, 'U', T1 <: Complex)
end
function _lyapds_blocked!(WS::AbstractMatrix{T1},WS1::AbstractMatrix{T1},A::AbstractMatrix{T1},C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasReal}
   n = size(A, 1)
   ONE = one(T1)
   ZERO = zero(T1)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U',T1 <: Complex)
      lyapds!(A,C;adj)
   else
      # split A and C (by rows and columns)
      mid = n ÷ 2
      n1 =  A[mid+1, mid] != 0 ? mid + 1 : mid
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
         WS11, WS12, WS22 = WS[i1,i1], WS[i1,i2], WS[i2,i2]
      end
      if adj
         # Adjoint Case: A' X A - X + C = 0

         # C11 solver
         _lyapds_blocked!(WS11,WS1,A11,C11,adj,blocksize)

         # Update C12: C12 = C12 + A11' * C11 * A12
         # Use WS as a temporary for (C11 * A12)
         # Note: C11 is symmetric/hermitian         
         BLAS.symm!('L', 'U', ONE, C11, A12, ZERO, WS12)
         BLAS.gemm!('T', 'N', ONE, A11, WS12, ONE, C12)         

         # Solve discrete Sylvester: A11' X12 A22 - X12 + C12 = 0
         lyapsylvds_blocked!(WS1, A11, A22, C12; adj, isgn = -1, blocksize)

         # Update C22: C22 = C22 + A12' * C11 * A12 + A22' * X12' * A12 + A12' * X12 * A22
         # 1. C22 = C22 + A12' * (C11 * A12)  [The WS we calculated earlier]         
         BLAS.gemm!('T', 'N', ONE, A12, WS12, ONE, C22)
         # 2. C22 = C22 + (X12' * A11' * A12 ...) which simplifies to a rank-2k update
         # Using syr2k! with A12 and (X12 * A22)         
         BLAS.gemm!('N', 'N', ONE, C12, A22, ZERO, WS12)
         BLAS.syr2k!('U', 'T', ONE, A12, WS12, ONE, C22)

         # C22 solver
         _lyapds_blocked!(WS22, WS1, A22, C22, adj, blocksize)

      else
         # Standard Case: A X A' - X + C = 0

         # X22 solver
         _lyapds_blocked!(WS22, WS1, A22, C22, adj, blocksize)
         
         # Update C12: C12 = C12 + A12 * C22 * A22'
         # Use WS[i1, i2] for (A12 * C22)
         BLAS.symm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         BLAS.gemm!('N', 'T', ONE, WS12, A22, ONE, C12)

         # Solve discrete Sylvester: A11 * X12 * A22' - X12 + C12 = 0
         lyapsylvds_blocked!(WS1, A11, A22, C12; adj, isgn = -1, blocksize)

         # Update C11: C11 = C11 + A12*X22*A12' + A11*X12*A12' + A12*X12'*A11'
         # 1. C11 = C11 + (A12*C22) * A12'  [WS contains A12*C22]
         BLAS.gemm!('N', 'T', ONE, WS12, A12, ONE, C11)
    
         # 2. C11 = C11 + (A11*X12)*A12' + A12*(A11*X12)' -> syr2k
         BLAS.gemm!('N', 'N', ONE, A11, C12, ZERO, WS12)
         BLAS.syr2k!('U', 'N', ONE, WS12, A12, ONE, C11)

         # X11 solver
         _lyapds_blocked!(WS11, WS1, A11, C11, adj, blocksize)
      end
   end
end

function _lyapds_blocked!(WS::AbstractMatrix{T1},WS1::AbstractMatrix{T1},A::AbstractMatrix{T1},C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasComplex}
   n = size(A, 1)
   ONE = one(T1)
   RONE = real(ONE)
   ZERO = zero(T1)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U',T1 <: Complex)
      lyapds!(A,C;adj)
   else
      # split A and C (by rows and columns)
      n1 = n ÷ 2
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
         WS11, WS12, WS22 = WS[i1,i1], WS[i1,i2], WS[i2,i2]
      end
      if adj
         # Adjoint Case: A' X A - X + C = 0

         # C11 solver
         _lyapds_blocked!(WS11,WS1,A11,C11,adj,blocksize)

         # Update C12: C12 = C12 + A11' * C11 * A12
         # Use WS as a temporary for (C11 * A12)
         # Note: C11 is symmetric/hermitian         
         BLAS.hemm!('L', 'U', ONE, C11, A12, ZERO, WS12)
         BLAS.gemm!('C', 'N', ONE, A11, WS12, ONE, C12)         

         # Solve discrete Sylvester: A11' X12 A22 - X12 + C12 = 0
         lyapsylvds_blocked!(WS1, A11, A22, C12; adj, isgn = -1, blocksize)

         # Update C22: C22 = C22 + A12' * C11 * A12 + A22' * X12' * A12 + A12' * X12 * A22
         # 1. C22 = C22 + A12' * (C11 * A12)  [The WS we calculated earlier]         
         BLAS.gemm!('C', 'N', ONE, A12, WS12, ONE, C22)
         # 2. C22 = C22 + (X12' * A11' * A12 ...) which simplifies to a rank-2k update
         # Using syr2k! with A12 and (X12 * A22)         
         BLAS.gemm!('N', 'N', ONE, C12, A22, ZERO, WS12)
         BLAS.her2k!('U', 'C', ONE, A12, WS12, RONE, C22)

         # C22 solver
         _lyapds_blocked!(WS22, WS1, A22, C22, adj, blocksize)

      else
         # Standard Case: A X A' - X + C = 0

         # X22 solver
         _lyapds_blocked!(WS22, WS1, A22, C22, adj, blocksize)
         
         # Update C12: C12 = C12 + A12 * C22 * A22'
         # Use WS[i1, i2] for (A12 * C22)
         BLAS.hemm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         BLAS.gemm!('N', 'C', ONE, WS12, A22, ONE, C12)

         # Solve discrete Sylvester: A11 * X12 * A22' - X12 + C12 = 0
         lyapsylvds_blocked!(WS1, A11, A22, C12; adj, isgn = -1, blocksize)

         # Update C11: C11 = C11 + A12*X22*A12' + A11*X12*A12' + A12*X12'*A11'
         # 1. C11 = C11 + (A12*C22) * A12'  [WS contains A12*C22]
         BLAS.gemm!('N', 'C', ONE, WS12, A12, ONE, C11)
    
         # 2. C11 = C11 + (A11*X12)*A12' + A12*(A11*X12)' -> syr2k
         BLAS.gemm!('N', 'N', ONE, A11, C12, ZERO, WS12)
         BLAS.her2k!('U', 'N', ONE, WS12, A12, RONE, C11)

         # X11 solver
         _lyapds_blocked!(WS11, WS1, A11, C11, adj, blocksize)
      end
   end
end

function lyapsylvds_blocked!(WS::AbstractMatrix{T1}, A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}; adj = false, isgn = -1, blocksize::Integer = 64) where {T1<:Real}
   m = LinearAlgebra.checksquare(A)  
   n = LinearAlgebra.checksquare(B)
   (m, n) == size(C) || throw(DimensionMismatch("C must be a $m x $n"))
   
   # Call the positional recursive worker
   _lyapsylvds_blocked!(WS, A, B, C, adj, isgn, blocksize)
end
function _lyapsylvds_blocked!(WS, A, B, C, adj::Bool, isgn::Integer, blocksize::Integer)
   m = size(A, 1)
   n = size(B, 1)
   if m <= max(blocksize,4) && n <= max(blocksize,4)
      sylvds!(A,B,C;adjA = adj,adjB = !adj,isgn)
      rmul!(C, -1)
   else
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 
      midn = n ÷ 2
      n1 = B[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
         B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
         C11, C12, C21, C22 = C[ia1,ib1], C[ia1,ib2], C[ia2,ib1], C[ia2,ib2]
         WS11, WS12, WS21, WS22 = WS[ia1,ib1], WS[ia1,ib2], WS[ia2,ib1], WS[ia2,ib2]
      end
      if adj
         # solve A' X B + isgn X + C = 0

         # X11 solver
         _lyapsylvds_blocked!(WS11, A11, B11, C11, adj, isgn, blocksize)

         # C12 update: C12 = C12 + A11'*X11*B12
         mul!(WS11,A11',C11)
         mul!(C12,WS11,B12,1,1)

         # X12 solver
         _lyapsylvds_blocked!(WS12, A11, B22, C12, adj, isgn, blocksize)

         # C21 update: C21 = C21 + A12'*X11*B11
         mul!(WS11,C11,B11)
         mul!(C21,A12',WS11,1,1)

         # X21 solver
         _lyapsylvds_blocked!(WS21, A22, B11, C21, adj, isgn, blocksize)

         # C22 update: C22 = C22 + A12'*X11*B12 + A12'*X12*B22 + A22'*X21*B12

         # WS12 = X11*B12 + X12*B22
         mul!(WS12, C11, B12)
         mul!(WS12, C12, B22, 1, 1)
         # C22 = C22 + A12'*(WS12)
         mul!(C22, A12', WS12, 1, 1)
         # C22 = C22 + A22'*X21*B12
         mul!(WS22, C21, B12)
         mul!(C22, A22', WS22, 1, 1)

         # X22 solver
         _lyapsylvds_blocked!(WS22, A22, B22, C22, adj, isgn, blocksize)
      else
         # solve A X B' + isgn X + C = 0

         # X22 solver
         _lyapsylvds_blocked!(WS22, A22, B22, C22, adj, isgn, blocksize)

         # C12 update: C12 = C12 + A12*X22*B22'
         mul!(WS22,C22,B22')
         mul!(C12,A12,WS22,1,1)

         # X12 solver
         _lyapsylvds_blocked!(WS12, A11, B22, C12, adj, isgn, blocksize)

         # C21 update: C21 = C21 + A22*X22*B12'
         mul!(WS22,A22,C22)
         mul!(C21,WS22,B12',1,1)

         # X21 solver
         _lyapsylvds_blocked!(WS21, A22, B11, C21, adj, isgn, blocksize)

         # C11 update: C11 = C11 + A12*X21*B11' + A11*X12*B12' + A12*X22*B12'
         # WS21 = X21*B11' + X22*B12'
         mul!(WS21, C21, B11')
         mul!(WS21, C22, B12', 1, 1)
         # C11 = C11 + A12*(WS21)
         mul!(C11, A12, WS21, 1, 1)
         # C11 = C11 + A11*X12*B12'
         mul!(WS12, A11, C12)
         mul!(C11, WS12, B12', 1, 1) 
 
         # X11 solver
         _lyapsylvds_blocked!(WS11, A11, B11, C11, adj, isgn, blocksize)
      end
   end   
end

function lyapds_blocked!(A::AbstractMatrix{T1}, E::AbstractMatrix{T1}, C::AbstractMatrix{T1}; adj = false, blocksize::Integer = 64) where {T1<:BlasFloat}
    n = LinearAlgebra.checksquare(A)  
    LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
    LinearAlgebra.checksquare(C) == n || throw(DimensionMismatch("C must be a $n x $n matrix or I"))
    mid = n ÷ 2
    if T1 <: Real  
       # Check symmetry ONCE here
       issymmetric(C) ||  throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
       mid += 2
    else
       ishermitian(C) ||  throw(DimensionMismatch("C must be a $n x $n Hermitian matrix"))
       mid += 1
    end
    
    # Allocate a full-sized WS and half-sized WS1 once. 
    WS = Matrix{T1}(undef,n,n)
    WS1 = Matrix{T1}(undef,mid,mid)
    WS2 = Matrix{T1}(undef,n,4)
    _lyapds_blocked!(WS, WS1, WS2, A, E, C, adj, blocksize)

    # Fill the lower triangle ONCE at the very end
    return LinearAlgebra.copytri!(C, 'U', T1 <: Complex)
end

function _lyapds_blocked!(WS::AbstractMatrix{T1},WS1::AbstractMatrix{T1},WS2::AbstractMatrix{T1},A::AbstractMatrix{T1},E::AbstractMatrix{T1},
                          C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasReal}
   n = size(A, 1)
   ONE = one(T1)
   MONE = -ONE
   ZERO = zero(T1)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U')
      lyapds!(A,E,C,view(WS2,1:n,1:2);adj)
   else
      # split A, E and C (by rows and columns)
      mid = n ÷ 2
      n1 =  A[mid+1, mid] != 0 ? mid + 1 : mid
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         E11, E12, E22 = E[i1,i1], E[i1,i2], E[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
         WS11, WS12, WS22 = WS[i1,i1], WS[i1,i2], WS[i2,i2]
      end
      if adj
         # Adjoint Case: A' X A - E' X E + C = 0  
         
         # X11 solver
         _lyapds_blocked!(WS11, WS1, WS2, A11, E11, C11, adj, blocksize)

         # Update C12 = C12 + A11' * X11 * A12 - E11' * X11 * E12
         BLAS.symm!('L', 'U', ONE, C11, A12, ZERO, WS12)
         BLAS.gemm!('T', 'N', ONE, A11, WS12, ONE, C12)
    
         BLAS.symm!('L', 'U', ONE, C11, E12, ZERO, WS12)
         BLAS.gemm!('T', 'N', MONE, E11, WS12, ONE, C12)    

         # Solve generalized dual Sylvester: A11' * X12 * A22 - E11' * X12 * E22 + C12 = 0 
         lyapgsylvds_blocked!(WS1, WS2, A11, A22, E11, E22, C12; adj, blocksize)

         # Update C22 = C22 + (X12*A22)'*A12 + A12'*(X12*A22)
         # 1. WS12 = C12*A22   
         mul!(WS12, C12, A22)
         # 2. C22 = C22 + WS12'*A12 + A12'*WS12 -> syr2k
         BLAS.syr2k!('U', 'T', ONE, WS12, A12, ONE, C22)

         # 2. WS12 = C12*E22   
         mul!(WS12, C12, E22)
         # 2. C22 = C22 - WS12'*E12 - E12'*WS12 -> syr2k
         BLAS.syr2k!('U', 'T', MONE, WS12, E12, ONE, C22)

         # 3. C22 = C22 + A12'*(X11*A12) - E12'*(X11*E12) 
          utqu_upd!(ONE, ONE, C22, A12', C11, WS12)
         # BLAS.symm!('L', 'U', ONE, C11, A12, ZERO, WS12)
         # BLAS.gemm!('T', 'N', ONE, A12, WS12, ONE, C22)
          utqu_upd!(ONE, MONE, C22, E12', C11, WS12)
         # BLAS.symm!('L', 'U', ONE, C11, E12, ZERO, WS12)
         # BLAS.gemm!('T', 'N', MONE, E12, WS12, ONE, C22)

         # X22 solver
         _lyapds_blocked!(WS22, WS1, WS2, A22, E22, C22, adj, blocksize)
      else
         # Standard Case: A X A' - E X E' + C = 0

         # X22 solver
         _lyapds_blocked!(WS22, WS1, WS2, A22, E22, C22, adj, blocksize)

         # Update C12: C12 = C12 + A12 * X22 * A22' - E12 * X22 * E22'
         # Use WS[i1, i2] for (A12 * C22)
         BLAS.symm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         BLAS.gemm!('N', 'T', ONE, WS12, A22, ONE, C12)
         # Use WS[i1, i2] for (E12 * C22)
         BLAS.symm!('R', 'U', ONE, C22, E12, ZERO, WS12)
         BLAS.gemm!('N', 'T', MONE, WS12, E22, ONE, C12)

         # Solve generalized Sylvester: A11 * X12 * A22' - E11 X12 E22' + C12 = 0
         lyapgsylvds_blocked!(WS1, WS2, A11, A22, E11, E22, C12; adj, blocksize)

         # Update C11: C11 = C11 + (A11*X12)*A12' + A12*(A11*X12)'
         # 1. WS12 = A11*C12   
         BLAS.gemm!('N', 'N', ONE, A11, C12, ZERO, WS12)
         # 2. C11 = C11 + WS12*A12' + A12*WS12' -> syr2k
         BLAS.syr2k!('U', 'N', ONE, WS12, A12, ONE, C11)

         # Update C11: C11 = C11 - (E11*X12)*E12' - E12*(E11*X12)'
         # 1. WS12 = E11*C12   
         BLAS.gemm!('N', 'N', ONE, E11, C12, ZERO, WS12)
         # 2. C11 = C11 - WS12*E12' - E12*WS12' -> syr2k
         BLAS.syr2k!('U', 'N', MONE, WS12, E12, ONE, C11)
  
         # 3. C11 = C11 + (A12*X22)*A12' - E12*(E12*X22)' 
          utqu_upd!(ONE, ONE, C11, A12, C22, WS12)
         # BLAS.symm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         # BLAS.gemm!('N', 'T', ONE, WS12, A12, ONE, C11)
          utqu_upd!(ONE, MONE, C11, E12, C22, WS12)
         # BLAS.symm!('R', 'U', ONE, C22, E12, ZERO, WS12)
         # BLAS.gemm!('N', 'T', MONE, WS12, E12, ONE, C11)

         # X11 solver
         _lyapds_blocked!(WS11, WS1, WS2, A11, E11, C11, adj, blocksize)
      end
   end
end
function _lyapds_blocked!(WS::AbstractMatrix{T1},WS1::AbstractMatrix{T1},WS2::AbstractMatrix{T1},A::AbstractMatrix{T1},E::AbstractMatrix{T1},
                          C::AbstractMatrix{T1}, adj, blocksize) where {T1<:BlasComplex}
   n = size(A, 1)
   ONE = one(T1)
   RONE = real(ONE)
   MONE = -ONE
   ZERO = zero(T1)
   if n <= max(blocksize,4)
      LinearAlgebra.copytri!(C,'U',true)
      # fix for small nonzero imaginary values!!! an alternative is to use better updating 
      #ishermitian(C) || (for i in 1:size(C, 1);  C[i, i] = Complex(real(C[i, i]), 0.0); end)
      lyapds!(A,E,C,view(WS2,1:n,1);adj)
   else
      # split A, E and C (by rows and columns)
      n1 = n ÷ 2
      i1 = 1:n1; i2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[i1,i1], A[i1,i2], A[i2,i2]
         E11, E12, E22 = E[i1,i1], E[i1,i2], E[i2,i2]
         C11, C12, C22 = C[i1,i1], C[i1,i2], C[i2,i2]
         WS11, WS12, WS22, WS21 = WS[i1,i1], WS[i1,i2], WS[i2,i2], WS[i2,i1]
      end
      if adj
         # Adjoint Case: A' X A - E' X E + C = 0  
         
         # X11 solver
         _lyapds_blocked!(WS11, WS1, WS2, A11, E11, C11, adj, blocksize)

         # Update C12 = C12 + A11' * X11 * A12 - E11' * X11 * E12
         BLAS.hemm!('L', 'U', ONE, C11, A12, ZERO, WS12)
         BLAS.gemm!('C', 'N', ONE, A11, WS12, ONE, C12)
    
         BLAS.hemm!('L', 'U', ONE, C11, E12, ZERO, WS12)
         BLAS.gemm!('C', 'N', MONE, E11, WS12, ONE, C12)    

         # Solve generalized dual Sylvester: A11' * X12 * A22 - E11' * X12 * E22 + C12 = 0 
         lyapgsylvds_blocked!(WS1, WS2, A11, A22, E11, E22, C12; adj, blocksize)

         # Update C22 = C22 + (X12*A22)'*A12 + A12'*(X12*A22)
         # 1. WS12 = C12*A22   
         mul!(WS12, C12, A22)
         # 2. C22 = C22 + WS12'*A12 + A12'*WS12 -> her2k
         BLAS.her2k!('U', 'C', ONE, WS12, A12, RONE, C22)

         # 2. WS12 = C12*E22   
         mul!(WS12, C12, E22)
         # 2. C22 = C22 - WS12'*E12 - E12'*WS12 -> her2k
         BLAS.her2k!('U', 'C', MONE, WS12, E12, RONE, C22)

         # 3. C22 = C22 + A12'*(X11*A12) - E12'*(X11*E12) 
          utqu_upd!(RONE, RONE, C22, A12', C11, WS12)
         # BLAS.hemm!('L', 'U', ONE, C11, A12, ZERO, WS12)
         # BLAS.gemm!('C', 'N', ONE, A12, WS12, ONE, C22)
          utqu_upd!(RONE, -RONE, C22, E12', C11, WS12)
         # BLAS.hemm!('L', 'U', ONE, C11, E12, ZERO, WS12)
         # BLAS.gemm!('C', 'N', MONE, E12, WS12, ONE, C22)

         # X22 solver
         _lyapds_blocked!(WS22, WS1, WS2, A22, E22, C22, adj, blocksize)
      else
         # Standard Case: A X A' - E X E' + C = 0

         # X22 solver
         _lyapds_blocked!(WS22, WS1, WS2, A22, E22, C22, adj, blocksize)

         # Update C12: C12 = C12 + A12 * X22 * A22' - E12 * X22 * E22'
         # Use WS[i1, i2] for (A12 * C22)
         BLAS.hemm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         BLAS.gemm!('N', 'C', ONE, WS12, A22, ONE, C12)
         # Use WS[i1, i2] for (E12 * C22)
         BLAS.hemm!('R', 'U', ONE, C22, E12, ZERO, WS12)
         BLAS.gemm!('N', 'C', MONE, WS12, E22, ONE, C12)

         # Solve generalized Sylvester: A11 * X12 * A22' - E11 X12 E22' + C12 = 0
         lyapgsylvds_blocked!(WS1, WS2, A11, A22, E11, E22, C12; adj, blocksize)

         # Update C11: C11 = C11 + (A11*X12)*A12' + A12*(A11*X12)'
         # 1. WS12 = A11*C12   
         BLAS.gemm!('N', 'N', ONE, A11, C12, ZERO, WS12)
         # 2. C11 = C11 + WS12*A12' + A12*WS12' -> syr2k
         BLAS.her2k!('U', 'N', ONE, WS12, A12, RONE, C11)

         # Update C11: C11 = C11 - (E11*X12)*E12' - E12*(E11*X12)'
         # 1. WS12 = E11*C12   
         BLAS.gemm!('N', 'N', ONE, E11, C12, ZERO, WS12)
         # 2. C11 = C11 - WS12*E12' - E12*WS12' -> syr2k
         BLAS.her2k!('U', 'N', MONE, WS12, E12, RONE, C11)
  
         # 3. C11 = C11 + (A12*X22)*A12' - E12*(E12*X22)' 
          utqu_upd!(RONE, RONE, C11, A12, C22, WS12)
         # BLAS.hemm!('R', 'U', ONE, C22, A12, ZERO, WS12)
         # BLAS.gemm!('N', 'C', ONE, WS12, A12, ONE, C11)
          utqu_upd!(RONE, -RONE, C11, E12, C22, WS12)
         #  BLAS.hemm!('R', 'U', ONE, C22, E12, ZERO, WS12)
         # BLAS.gemm!('N', 'C', MONE, WS12, E12, ONE, C11)
         # LinearAlgebra.copytri!(C11,'U',true)
         # @show ishermitian(C11)

         # X11 solver
         _lyapds_blocked!(WS11, WS1, WS2, A11, E11, C11, adj, blocksize)
      end
   end
end



function lyapsylvds_blocked!(WS::AbstractMatrix{T1}, A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}; adj = false, isgn = -1, blocksize::Integer = 64) where {T1<:BlasComplex}
   m = LinearAlgebra.checksquare(A)  
   n = LinearAlgebra.checksquare(B)
   (m,n) == size(C) || throw(DimensionMismatch("C must be a $m x $n"))
   if m <= max(blocksize,4) && n <= max(blocksize,4)
      sylvds!(A,B,C;adjA = adj,adjB = !adj,isgn)
      rmul!(C, -1)
   else
      m1 = m ÷ 2
      ia1 = 1:m1; ia2 = m1+1:m 
      n1 = n ÷ 2
      ib1 = 1:n1; ib2 = n1+1:n 
      @views begin
         A12 = A[ia1,ia2]
         B12 = B[ib1,ib2]
         # A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
         # B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
         # Exploit upper-triangular shape of diagonal sub-blocks via type wrapping
         A11 = UpperTriangular(A[ia1,ia1])
         A22 = UpperTriangular(A[ia2,ia2])
         B11 = UpperTriangular(B[ib1,ib1])
         B22 = UpperTriangular(B[ib2,ib2])
         C11, C12, C21, C22 = C[ia1,ib1], C[ia1,ib2], C[ia2,ib1], C[ia2,ib2]
         WS11, WS12, WS21, WS22 = WS[ia1,ib1], WS[ia1,ib2], WS[ia2,ib1], WS[ia2,ib2]
      end
      if adj
         # solve A' X B + isgn X + C = 0

         # X11 solver
         lyapsylvds_blocked!(WS11, A11, B11, C11; adj, isgn, blocksize)

         # C12 update: C12 = C12 + A11'*X11*B12
         mul!(WS11,A11',C11)
         mul!(C12,WS11,B12,1,1)

         # X12 solver
         lyapsylvds_blocked!(WS12, A11, B22, C12; adj, isgn, blocksize)

         # C21 update: C21 = C21 + A12'*X11*B11
         mul!(WS11,C11,B11)
         mul!(C21,A12',WS11,1,1)

         # X21 solver
         lyapsylvds_blocked!(WS21, A22, B11, C21; adj, isgn, blocksize)

         # C22 update: C22 = C22 + A12'*X11*B12 + A12'*X12*B22 + A22'*X21*B12

         # WS12 = X11*B12 + X12*B22
         mul!(WS12, C11, B12)
         mul!(WS12, C12, B22, 1, 1)
         # C22 = C22 + A12'*(WS12)
         mul!(C22, A12', WS12, 1, 1)
         # C22 = C22 + A22'*X21*B12
         mul!(WS22, C21, B12)
         mul!(C22, A22', WS22, 1, 1)

         # X22 solver
         lyapsylvds_blocked!(WS22, A22, B22, C22; adj, isgn, blocksize)
      else
         # solve A X B' + isgn X + C = 0

         # X22 solver
         lyapsylvds_blocked!(WS22, A22, B22, C22; adj, isgn, blocksize)

         # C12 update: C12 = C12 + A12*X22*B22'
         mul!(WS22,C22,B22')
         mul!(C12,A12,WS22,1,1)

         # X12 solver
         lyapsylvds_blocked!(WS12, A11, B22, C12; adj, isgn, blocksize)

         # C21 update: C21 = C21 + A22*X22*B12'
         mul!(WS22,A22,C22)
         mul!(C21,WS22,B12',1,1)

         # X21 solver
         lyapsylvds_blocked!(WS21, A22, B11, C21; adj, isgn, blocksize)

         # C11 update: C11 = C11 + A12*X21*B11' + A11*X12*B12' + A12*X22*B12'

         # WS21 = X21*B11' + X22*B12'
         mul!(WS21, C21, B11')
         mul!(WS21, C22, B12', 1, 1)
         # C11 = C11 + A12*(WS21)
         mul!(C11, A12, WS21, 1, 1)
         # C11 = C11 + A11*X12*B12'
         mul!(WS12, A11, C12)
         mul!(C11, WS12, B12', 1, 1) 

         # X11 solver
         lyapsylvds_blocked!(WS11, A11, B11, C11; adj, isgn, blocksize)
      end
   end   
end

function lyapgsylvds_blocked!(WS::AbstractMatrix{T1}, WS2::AbstractMatrix{T1}, A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}, D::AbstractMatrix{T1}, E::AbstractMatrix{T1}; adj = false, blocksize::Integer = 64) where {T1<:BlasFloat}
   m = LinearAlgebra.checksquare(A)  
   n = LinearAlgebra.checksquare(B)
   (m, n) == size(E) || throw(DimensionMismatch("E must be a $m x $n"))
   
   # Call the positional recursive worker
   _lyapgsylvds_blocked!(WS, WS2, A, B, C, D, E, adj, blocksize)
end
function _lyapgsylvds_blocked!(WS, WS2, A, B, C, D, E, adj::Bool, blocksize::Integer)
   m = size(A, 1)
   n = size(B, 1)
   if m <= max(blocksize,4) && n <= max(blocksize,4)
      if eltype(A) <: Real
         WB = view(WS2,1:m,1:2); WD = view(WS2,1:m,3:4);   
      else
         WB = view(WS2,1:m,1); WD = view(WS2,1:m,2);   
      end
      gsylvs!(A,B,C,D,E,WB,WD;adjAC = adj,adjBD = !adj,isgn = -1)
      rmul!(E, -1)
  else
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 
      midn = n ÷ 2
      n1 = B[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n;  
      if eltype(A) <: Real
         @views begin
            A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
            B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
            C11, C12, C22 = UpperTriangular(C[ia1,ia1]), C[ia1,ia2], UpperTriangular(C[ia2,ia2])
            D11, D12, D22 = UpperTriangular(D[ib1,ib1]), D[ib1,ib2], UpperTriangular(D[ib2,ib2])
            E11, E12, E21, E22 = E[ia1,ib1], E[ia1,ib2], E[ia2,ib1], E[ia2,ib2]
            WS11, WS12, WS21, WS22 = WS[ia1,ib1], WS[ia1,ib2], WS[ia2,ib1], WS[ia2,ib2]
         end
      else
         @views begin
            A11, A12, A22 = UpperTriangular(A[ia1,ia1]), A[ia1,ia2], UpperTriangular(A[ia2,ia2])
            B11, B12, B22 = UpperTriangular(B[ib1,ib1]), B[ib1,ib2], UpperTriangular(B[ib2,ib2])
            C11, C12, C22 = UpperTriangular(C[ia1,ia1]), C[ia1,ia2], UpperTriangular(C[ia2,ia2])
            D11, D12, D22 = UpperTriangular(D[ib1,ib1]), D[ib1,ib2],  UpperTriangular(D[ib2,ib2])
            E11, E12, E21, E22 = E[ia1,ib1], E[ia1,ib2], E[ia2,ib1], E[ia2,ib2]
            WS11, WS12, WS21, WS22 = WS[ia1,ib1], WS[ia1,ib2], WS[ia2,ib1], WS[ia2,ib2]
         end
      end
      if adj
         # solve A' X B - C' X D + E = 0

         # X11 solver
         _lyapgsylvds_blocked!(WS11, WS2, A11, B11, C11, D11, E11, adj, blocksize)

         # E12 update: E12 = E12 + A11'*X11*B12 - C11'*X11*D12
         mul!(WS11, A11', E11)
         mul!(E12, WS11, B12, 1, 1)
         mul!(WS11, C11', E11)
         mul!(E12, WS11, D12, -1, 1)
 
         # X12 solver
         _lyapgsylvds_blocked!(WS12, WS2, A11, B22, C11, D22, E12, adj, blocksize)

         # E21 update: E21 = E21 + A12'*X11*B11 - C12'*X11*D11
         #mul!(WS11,E11, UpperTriangular(B11))
         mul!(WS11,E11, B11)
         mul!(E21,A12',WS11,1,1)
         mul!(WS11, E11, D11)
         mul!(E21, C12', WS11,-1,1)

         # X21 solver
         _lyapgsylvds_blocked!(WS21, WS2, A22, B11, C22, D11, E21, adj, blocksize)

         # E22 update: E22 = E22 + A12'*X12*B22 - C12'*X12*D22 +
         #                   (A12'*X11+A22'*X21)*B12 - (C12'*X11+C22'*X21)*D12
         # WS21 = A12'*X11+A22'*X21
         mul!(WS21, A22', E21)
         mul!(WS21, A12', E11, 1, 1)
         # E22 = E22 + WS21 * B12
         mul!(E22, WS21, B12, 1, 1)
         # WS12 = C12'*X11+C22'*X22)
         mul!(WS21, C22', E21)
         mul!(WS21, C12', E11, 1, 1)
         # E22 = E22 + WS21 * D12
         mul!(E22, WS21, D12, -1, 1)

         # E22 = E22 + A12'*X12*B22
         mul!(WS12, E12, B22)
         mul!(E22, A12', WS12, 1, 1) 
         # E22 = E22 - C12'*X12*D22
         mul!(WS12, E12, D22)
         mul!(E22, C12', WS12, -1, 1) 

         # X22 solver
         _lyapgsylvds_blocked!(WS22, WS2, A22, B22, C22, D22, E22, adj, blocksize)
      else
         # solve A X B' - C X D' + E = 0

         # X22 solver
         _lyapgsylvds_blocked!(WS22, WS2, A22, B22, C22, D22, E22, adj, blocksize)

         # E12 update: E12 = E12 + A12*X22*B22' - C12*X22*D22'
         mul!(WS22,E22,B22')
         mul!(E12,A12,WS22,1,1)
         mul!(WS22,E22,D22')
         mul!(E12,C12,WS22,-1,1)

         # X12 solver
         _lyapgsylvds_blocked!(WS12, WS2, A11, B22, C11, D22, E12, adj, blocksize)

         # E21 update: E21 = E21 + A22*X22*B12' - C22*X22*D12'
         mul!(WS22,A22,E22)
         mul!(E21,WS22,B12',1,1)
         mul!(WS22,C22,E22)
         mul!(E21,WS22,D12',-1,1)

         # X21 solver
         _lyapgsylvds_blocked!(WS21, WS2, A22, B11, C22, D11, E21, adj, blocksize)


         # E11 update: E11 = E11 + A12*X21*B11' - C12*X21*D11' +
         #                   (A11*X12+A12*X22)*B12' - (C11*X12+C12*X22)*D12'
         # WS12 = A11*X12+A12*X22
         mul!(WS12, A11, E12)
         mul!(WS12, A12, E22, 1, 1)
         # E11 = E11 + WS12 * B12'
         mul!(E11, WS12, B12', 1, 1)
         # WS12 = C11*X12+C12*X22
         mul!(WS12, C11, E12)
         mul!(WS12, C12, E22, 1, 1)
         # E11 = E11 + WS12 * D12'
         mul!(E11, WS12, D12', -1, 1)

         # E11 = E11 + A12*X21*B11'
         mul!(WS21, E21, B11')
         mul!(E11, A12, WS21, 1, 1) 
         # E11 = E11 - C12*X21*D11'
         mul!(WS21, E21, D11')
         mul!(E11, C12, WS21, -1, 1) 

         # X11 solver
         _lyapgsylvds_blocked!(WS11, WS2, A11, B11, C11, D11, E11, adj, blocksize)
      end
   end   
end


function lyapds!(A::AbstractMatrix{T1},C::AbstractMatrix{T1}; adj = false) where {T1<:Complex}
   n = LinearAlgebra.checksquare(A)
   (LinearAlgebra.checksquare(C) == n && ishermitian(C)) ||
      throw(DimensionMismatch("C must be a $n x $n hermitian matrix"))
   ONE = one(T1)
   RONE = real(ONE)
   if isdiag(A) 
      if adj 
         for i = 1:n
            C[i,i] = -C[i,i]/(abs(A[i,i])^2-RONE)
            isfinite(C[i,i]) || throw("ME:SingularException: A has eigenvalue(s) α such that |α| = 1")
            for j = i+1:n
               C[i,j] = -C[i,j]/(A[i,i]'*A[j,j]-ONE)
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and β such that αβ' = 1")
               C[j,i] = C[i,j]'
            end
         end
      else
         for i = 1:n
            C[i,i] = -C[i,i]/(abs(A[i,i])^2-RONE)
            for j = i+1:n
               C[i,j] = -C[i,j]/(A[i,i]*A[j,j]'-ONE)
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and β such that α+β = 0")
               C[j,i] = C[i,j]'
            end
         end
      end   
      return C[:,:]
   end      

   # Compute the hermitian solution
   if adj
      for k = 1:n
         for l = 1:k
            y = C[k,l]
            if k > 1
               C[l,k] = C[l,1]*A[1,k]
               for ir = 2:k-1
                  C[l,k] +=  C[l,ir]*A[ir,k]
               end
               for ic = 1:l
                  y += C[ic,k]'*A[ic,l]
               end
            end
            temp = ONE-A[k,k]'*A[l,l]
            C[k,l] = y/temp
            isfinite(C[k,l]) || throw("ME:SingularException: A has eigenvalues α and β such that αβ ≈ 1")
            k == l && (C[k,k] = real(C[k,k]))
            if l < k
               C[l,k] += C[k,l]'*A[k,k]
            end
         end
         for ir = 1:k-1
             C[ir,k] = C[k,ir]'
         end
      end
   else
      for l = n:-1:1
        for k = n:-1:l
            y = C[l,k]
            if l < n
               C[k,l] = C[k,l+1]*A[l,l+1]'
               for ir = l+2:n
                  C[k,l] += C[k,ir]*A[l,ir]'
               end
               for ic = k:n
                   y += (A[k,ic]*C[ic,l])'
               end
            end
            temp = ONE-A[k,k]'*A[l,l]
            C[l,k] = y/temp
            isfinite(C[l,k]) || throw("ME:SingularException: A has eigenvalues α and β such that αβ' ≈ 1")
            k == l && (C[k,k] = real(C[k,k]))
            if k > l
               C[k,l] += (A[l,l]*C[l,k])'
            end
        end
        if l < n
           for ir = l+1:n
               C[ir,l] = C[l,ir]'
           end
        end
      end
   end
end
"""
    lyapds!(A, E, C; adj = false)

Solve the generalized discrete Lyapunov matrix equation

                op(A)Xop(A)' - op(E)Xop(E)' + C = 0,

where `op(A) = A` and `op(E) = E` if `adj = false` and `op(A) = A'` and
`op(E) = E'` if `adj = true`. The pair `(A,E)` is in a generalized real or
complex Schur form and `C` is a symmetric or hermitian matrix.
The pencil `A-λE` must not have eigenvalues `α` and `β` such that `αβ = 1`.
The computed symmetric or hermitian solution `X` is contained in `C`.
"""
function lyapds!(A::AbstractMatrix{T1},E::Union{AbstractMatrix{T1},UniformScaling{Bool}}, C::AbstractMatrix{T1}, W::AbstractMatrix{T1} = Array{T1,2}(undef,size(A,1),2); adj = false) where {T1<:Real}
   n = LinearAlgebra.checksquare(A)
   (LinearAlgebra.checksquare(C) == n && issymmetric(C)) ||
      throw(DimensionMismatch("C must be a $n x $n symmetric matrix"))
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) && size(E,1) == n)) && (lyapds!(A, C, adj = adj); return)
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))

   ONE = one(T1)
   MONE = -ONE

   # determine the structure of the real Schur form
   ba, p = sfstruct(A)

   G = Matrix{T1}(undef,2,2)
   #W = Array{T1,2}(undef,n,2)
   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   if adj
      # """
      # The (K,L)th block of X is determined starting from the
      # upper-left corner column by column by

      # A(K,K)'*X(K,L)*A(L,L) - E(K,K)'*X(K,L)*E(L,L) = -C(K,L) - R(K,L),

      # where
      #           K           L-1
      # R(K,L) = SUM {A(I,K)'*SUM [X(I,J)*A(J,L)]} -
      #          I=1          J=1

      #           K           L-1
      #          SUM {E(I,K)'*SUM [X(I,J)*E(J,L)]} +
      #          I=1          J=1

      #           K-1
      #          {SUM [A(I,K)'*X(I,L)]}*A(L,L) -
      #           I=1

      #           K-1
      #          {SUM [E(I,K)'*X(I,L)]}*E(L,L).
      #           I=1
      # """
      i = 1
      for kk = 1:p
          dk = ba[kk]
          dkk = 1:dk
          k = i:i+dk-1
          j = 1
          ir = 1:i-1
          for ll = 1:kk
             dl = ba[ll]
             j1 = j+dl-1
             l = j:j1
             #y = C[k,l]
             y = view(G,1:dk,1:dl)
             Ckl = view(C,k,l)
             copyto!(y,Ckl)
             if kk > 1
                 # C[l,k] = C[l,ir]*A[ir,k]
                 # W[l,dkk] = C[l,ir]*E[ir,k]
                 mul!(view(C,l,k),view(C,l,ir),view(A,ir,k))
                 mul!(view(W,l,dkk),view(C,l,ir),view(E,ir,k))
                 ic = 1:j1
                 # y += C[ic,k]'*A[ic,l] -W[ic,dkk]'*E[ic,l]
                 mul!(y,transpose(view(C,ic,k)),view(A,ic,l),ONE,ONE)
                 mul!(y,transpose(view(W,ic,dkk)),view(E,ic,l),MONE,ONE)
             end
             if i == j
                lyapd2!(adj,y,dk,view(A,k,k),view(E,k,k),Xw,Yw)
                copyto!(Ckl,y)
             else
                lyapdsylv2!(adj,y,dk,dl,view(A,k,k),view(E,k,k),view(A,l,l),view(E,l,l),Xw,Yw)
                copyto!(Ckl,y)
             end
             j += dl
             if j <= i
                 # C[l,k] += C[k,l]'*A[k,k]
                 # W[l,dkk] += C[k,l]'*E[k,k]
                 mul!(view(C,l,k),transpose(view(C,k,l)),view(A,k,k),ONE,ONE)
                 mul!(view(W,l,dkk),transpose(view(C,k,l)),view(E,k,k),ONE,ONE)
              end
          end
          if kk > 1
             # C[ir,k] = C[k,ir]'
             transpose!(view(C,ir,k),view(C,k,ir))
          end
          i += dk
      end
   else
      # """
      # The (K,L)th block of X is determined starting from
      # bottom-right corner column by column by

      # A(K,K)*X(K,L)*A(L,L)' - E(K,K)*X(K,L)*E(L,L)' = -C(K,L) - R(K,L),

      # where

      #           N            N
      # R(K,L) = SUM {A(K,I)* SUM [X(I,J)*A(L,J)']} -
      #          I=K         J=L+1

      #           N            N
      #          SUM {E(K,I)* SUM [X(I,J)*E(L,J)']} +
      #          I=K         J=L+1

      #             N
      #          { SUM [A(K,J)*X(J,L)]}*A(L,L)' -
      #           J=K+1

      #             N
      #          { SUM [E(K,J)*X(J,L)]}*E(L,L)'
      #           J=K+1
      # """
      j = n
      for ll = p:-1:1
        dl = ba[ll]
        l = j-dl+1:j
        dll = 1:dl
        i = n
        ir = j+1:n
        for kk = p:-1:ll
            dk = ba[kk]
            i1 = i-dk+1
            k = i1:i
            Clk = view(C,l,k)
            y = view(G,1:dl,1:dk)
            copyto!(y,Clk)
            if ll < p
               # C[k,l] = C[k,ir]*A[l,ir]'
               # W[k,dll] = C[k,ir]*E[l,ir]'
               mul!(view(C,k,l),view(C,k,ir),transpose(view(A,l,ir)))
               mul!(view(W,k,dll),view(C,k,ir),transpose(view(E,l,ir)))
               ic = i1:n
               # y += (A[k,ic]*C[ic,l] - E[k,ic]*W[ic,dll])'
               mul!(y,transpose(view(C,ic,l)),transpose(view(A,k,ic)),ONE,ONE)
               mul!(y,transpose(view(W,ic,dll)),transpose(view(E,k,ic)),MONE,ONE)
            end
            if i == j
               lyapd2!(adj,y,dk,view(A,k,k),view(E,k,k),Xw,Yw)
               copyto!(Clk,y)
            else
               lyapdsylv2!(adj,y,dl,dk,view(A,l,l),view(E,l,l),view(A,k,k),view(E,k,k),Xw,Yw)
               copyto!(Clk,y)
            end
            i -= dk
            if i >= j
               # C[k,l] += (A[l,l]*C[l,k])'
               # W[k,dll] += (E[l,l]*C[l,k])'
               mul!(view(C,k,l),transpose(view(C,l,k)),transpose(view(A,l,l)),ONE,ONE)
               mul!(view(W,k,dll),transpose(view(C,l,k)),transpose(view(E,l,l)),ONE,ONE)
            else
               break
            end
        end
        if ll < p
           ir = i+2:n
           # C[ir,l] = C[l,ir]'
           transpose!(view(C,ir,l),view(C,l,ir))
         end
        j -= dl
      end
   end
end
@inline function lyapd2!(adj,C::AbstractMatrix{T},na::Int,A::AbstractMatrix{T},E::AbstractMatrix{T},R::AbstractMatrix{T},Y::StridedVector{T}) where T <:Real
   # speed and reduced allocation oriented implementation of a solver for 1x1 or 2x2 continuous Lyapunov equations
   #      A'*X*A - E'*X*E = -C if adj = true  -> R = kron(A',A')-kron(E',E') = (kron(A,A)-kron(E,E))'
   #      A*X*A' - E*X*E' = -C if adj = false -> R = kron(A,A)-kron(E,E)
   MONE = -one(T)
   if na == 1
      temp = E[1,1]^2-A[1,1]^2
      rmul!(C,inv(temp))
      any(!isfinite, C) &&  throw("ME:SingularException: A-λE has eigenvalue(s) with moduli equal to one")
      return C
   end
   TWO = 2*one(T)
   @inbounds  Y[1] = -C[1,1]
   @inbounds  Y[2] = -C[2,1]
   @inbounds  Y[3] = -C[2,2]
   if adj
      # Rt =
      # [     a11^2 - e11^2,                   2*a11*a21,         a21^2]
      # [ a11*a12 - e11*e12, a11*a22 + a12*a21 - e11*e22,       a21*a22]
      # [     a12^2 - e12^2,       2*a12*a22 - 2*e12*e22, a22^2 - e22^2]
      # iszero(E[1,2]) ?
      #    (@inbounds R = [ A[1,1]^2-E[1,1]^2    TWO*A[1,1]*A[2,1]         A[2,1]^2;
      #                 A[1,1]*A[1,2]    A[1,1]*A[2,2]+A[1,2]*A[2,1]-E[1,1]*E[2,2]  A[2,1]*A[2,2];
      #                 A[1,2]^2         TWO*A[1,2]*A[2,2]         A[2,2]^2-E[2,2]^2 ] ) :
         # (@inbounds R = [ A[1,1]^2-E[1,1]^2    TWO*A[1,1]*A[2,1]         A[2,1]^2;
         #              A[1,1]*A[1,2]-E[1,1]*E[1,2]    A[1,1]*A[2,2]+A[1,2]*A[2,1]-E[1,1]*E[2,2]  A[2,1]*A[2,2];
         #              A[1,2]^2-E[1,2]^2         TWO*(A[1,2]*A[2,2]-E[1,2]*E[2,2])         A[2,2]^2-E[2,2]^2 ])
      @inbounds  R[1,1] = A[1,1]^2-E[1,1]^2
      @inbounds  R[1,2] = TWO*A[1,1]*A[2,1]
      @inbounds  R[1,3] = A[2,1]^2
      @inbounds  R[2,1] = A[1,1]*A[1,2]-E[1,1]*E[1,2]
      @inbounds  R[2,2] = A[1,1]*A[2,2]+A[1,2]*A[2,1]-E[1,1]*E[2,2]
      @inbounds  R[2,3] = A[2,1]*A[2,2]
      @inbounds  R[3,1] = A[1,2]^2-E[1,2]^2
      @inbounds  R[3,2] = TWO*(A[1,2]*A[2,2]-E[1,2]*E[2,2])
      @inbounds  R[3,3] = A[2,2]^2-E[2,2]^2
   else
      # R =
      # [ a11^2 - e11^2,       2*a11*a12 - 2*e11*e12,     a12^2 - e12^2]
      # [       a11*a21, a11*a22 + a12*a21 - e11*e22, a12*a22 - e12*e22]
      # [         a21^2,                   2*a21*a22,     a22^2 - e22^2]
      # iszero(E[1,2]) ?
      #    (@inbounds R = [ A[1,1]^2-E[1,1]^2    TWO*A[1,1]*A[1,2]         A[1,2]^2;
      #                 A[1,1]*A[2,1]    A[1,1]*A[2,2]+A[1,2]*A[2,1]-E[1,1]*E[2,2]  A[1,2]*A[2,2];
      #                 A[2,1]^2         TWO*A[2,1]*A[2,2]         A[2,2]^2-E[2,2]^2 ] ) :

      #    (@inbounds R = [ A[1,1]^2-E[1,1]^2    TWO*(A[1,1]*A[1,2]-E[1,1]*E[1,2])         A[1,2]^2-E[1,2]^2;
      #                 A[1,1]*A[2,1]    A[1,1]*A[2,2]+A[1,2]*A[2,1]-E[1,1]*E[2,2]  A[1,2]*A[2,2]-E[1,2]*E[2,2];
      #                 A[2,1]^2         TWO*A[2,1]*A[2,2]         A[2,2]^2-E[2,2]^2 ] )
      @inbounds  R[1,1] = A[1,1]^2-E[1,1]^2
      @inbounds  R[1,2] = TWO*(A[1,1]*A[1,2]-E[1,1]*E[1,2])
      @inbounds  R[1,3] = A[1,2]^2-E[1,2]^2
      @inbounds  R[2,1] = A[1,1]*A[2,1]
      @inbounds  R[2,2] = A[1,1]*A[2,2]+A[1,2]*A[2,1]-E[1,1]*E[2,2]
      @inbounds  R[2,3] = A[1,2]*A[2,2]-E[1,2]*E[2,2]
      @inbounds  R[3,1] = A[2,1]^2
      @inbounds  R[3,2] = TWO*A[2,1]*A[2,2]
      @inbounds  R[3,3] = A[2,2]^2-E[2,2]^2
   end
   luslv!(R,Y,3) && throw("ME:SingularException: A-λE has eigenvalues α and β such that αβ ≈ 1")
   @inbounds C[1,1] = Y[1]
   @inbounds C[1,2] = Y[2]
   @inbounds C[2,1] = Y[2]
   @inbounds C[2,2] = Y[3]
   return C
end
@inline function lyapdsylv2!(adj,C::AbstractMatrix{T},na::Int,nb::Int,A::AbstractMatrix{T},E::AbstractMatrix{T},B::AbstractMatrix{T},F::AbstractMatrix{T},R::AbstractMatrix{T},Y::StridedVector{T}) where T <:Real
   # speed and reduced allocation oriented implementation of a solver for 1x1 and 2x2 Sylvester equations
   # encountered in solving discrete Lyapunov equations:
   #      A'*X*B - E'*X*F = -C if adj = true  -> R = kron(B',A') - kron(F',E') = (kron(B,A)-kron(F,E))'
   #      A*X*B' - E*X*F' = -C if adj = false -> R = kron(B,A)-kron(F,E)
   if na == 1 && nb == 1
      temp = E[1,1]*F[1,1] - A[1,1]*B[1,1]
      rmul!(C,inv(temp))
      any(!isfinite, C) && throw("ME:SingularException: A-λE has eigenvalues α and β such that αβ ≈ 1")
      return C
   end
   if adj
      if na == 1
         # R12t =
         # [ a11*b11 - e11*f11,           a11*b21]
         # [ a11*b12 - e11*f12, a11*b22 - e11*f22]
         # @inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[1,1]*B[2,1];
         #                 A[1,1]*B[1,2]-E[1,1]*F[1,2]  A[1,1]*B[2,2]-E[1,1]*F[2,2]]
         @inbounds  R[1,1] = A[1,1]*B[1,1]-E[1,1]*F[1,1]
         @inbounds  R[1,2] = A[1,1]*B[2,1]
         @inbounds  R[2,1] = A[1,1]*B[1,2]-E[1,1]*F[1,2]
         @inbounds  R[2,2] = A[1,1]*B[2,2]-E[1,1]*F[2,2]
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
      else
         if nb == 1
            # R21t =
            # [ a11*b11 - e11*f11,           a21*b11]
            # [ a12*b11 - e12*f11, a22*b11 - e22*f11]
            # @inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[2,1]*B[1,1];
            #                 A[1,2]*B[1,1]-E[1,2]*F[1,1]  A[2,2]*B[1,1]-E[2,2]*F[1,1] ]
            @inbounds  R[1,1] = A[1,1]*B[1,1]-E[1,1]*F[1,1]
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[2,1] = A[1,2]*B[1,1]-E[1,2]*F[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]-E[2,2]*F[1,1]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # Rt =
            # [ a11*b11 - e11*f11,           a21*b11,           a11*b21,           a21*b21]
            # [ a12*b11 - e12*f11, a22*b11 - e22*f11,           a12*b21,           a22*b21]
            # [ a11*b12 - e11*f12,           a21*b12, a11*b22 - e11*f22,           a21*b22]
            # [ a12*b12 - e12*f12, a22*b12 - e22*f12, a12*b22 - e12*f22, a22*b22 - e22*f22]
            # (iszero(E[1,2]) && iszero(F[1,2])) ?
            # (@inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[2,1]*B[1,1]      A[1,1]*B[2,1]      A[2,1]*B[2,1];
            # A[1,2]*B[1,1]  A[2,2]*B[1,1]-E[2,2]*F[1,1]      A[1,2]*B[2,1]      A[2,2]*B[2,1];
            # A[1,1]*B[1,2]      A[2,1]*B[1,2]  A[1,1]*B[2,2]-E[1,1]*F[2,2]      A[2,1]*B[2,2];
            # A[1,2]*B[1,2]      A[2,2]*B[1,2]      A[1,2]*B[2,2]  A[2,2]*B[2,2]-E[2,2]*F[2,2]]) :
            # (@inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[2,1]*B[1,1]      A[1,1]*B[2,1]      A[2,1]*B[2,1];
            # A[1,2]*B[1,1]-E[1,1]*F[1,2]  A[2,2]*B[1,1]-E[2,2]*F[1,1]      A[1,2]*B[2,1]      A[2,2]*B[2,1];
            # A[1,1]*B[1,2]-E[1,1]*F[1,2]      A[2,1]*B[1,2]  A[1,1]*B[2,2]-E[1,1]*F[2,2]      A[2,1]*B[2,2];
            # A[1,2]*B[1,2]-E[1,2]*F[1,2]      A[2,2]*B[1,2]-E[2,2]*F[1,2]      A[1,2]*B[2,2]-E[1,2]*F[2,2]  A[2,2]*B[2,2]-E[2,2]*F[2,2]])
            @inbounds  R[1,1] = A[1,1]*B[1,1]-E[1,1]*F[1,1]
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[1,3] = A[1,1]*B[2,1]
            @inbounds  R[1,4] = A[2,1]*B[2,1]
            #@inbounds  R[2,1] = A[1,2]*B[1,1]-E[1,1]*F[1,2]
            @inbounds  R[2,1] = A[1,2]*B[1,1]-E[1,2]*F[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]-E[2,2]*F[1,1]
            @inbounds  R[2,3] = A[1,2]*B[2,1]
            @inbounds  R[2,4] = A[2,2]*B[2,1]
            @inbounds  R[3,1] = A[1,1]*B[1,2]-E[1,1]*F[1,2]
            @inbounds  R[3,2] = A[2,1]*B[1,2]
            @inbounds  R[3,3] = A[1,1]*B[2,2]-E[1,1]*F[2,2]
            @inbounds  R[3,4] = A[2,1]*B[2,2]
            @inbounds  R[4,1] = A[1,2]*B[1,2]-E[1,2]*F[1,2]
            @inbounds  R[4,2] = A[2,2]*B[1,2]-E[2,2]*F[1,2]
            @inbounds  R[4,3] = A[1,2]*B[2,2]-E[1,2]*F[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]-E[2,2]*F[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   else
      if na == 1
         # R12 =
         # [ a11*b11 - e11*f11, a11*b12 - e11*f12]
         # [           a11*b21, a11*b22 - e11*f22]
         # @inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[1,1]*B[1,2]-E[1,1]*F[1,2];
         #                 A[1,1]*B[2,1]  A[1,1]*B[2,2]-E[1,1]*F[2,2]]
         @inbounds  R[1,1] = A[1,1]*B[1,1]-E[1,1]*F[1,1]
         @inbounds  R[1,2] = A[1,1]*B[1,2]-E[1,1]*F[1,2]
         @inbounds  R[2,1] = A[1,1]*B[2,1]
         @inbounds  R[2,2] = A[1,1]*B[2,2]-E[1,1]*F[2,2]
         @inbounds  Y[1] = -C[1,1]
         @inbounds  Y[2] = -C[1,2]
      else
         if nb == 1
            # R21 =
            # [ a11*b11 - e11*f11, a12*b11 - e12*f11]
            # [           a21*b11, a22*b11 - e22*f11]
            # @inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[1,2]*B[1,1]-E[1,2]*F[1,1];
            #                 A[2,1]*B[1,1]  A[2,2]*B[1,1]-E[2,2]*F[1,1]]
            @inbounds  R[1,1] = A[1,1]*B[1,1]-E[1,1]*F[1,1]
            @inbounds  R[1,2] = A[1,2]*B[1,1]-E[1,2]*F[1,1]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]-E[2,2]*F[1,1]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
         else
            # R =
            # [ a11*b11 - e11*f11, a12*b11 - e12*f11, a11*b12 - e11*f12, a12*b12 - e12*f12]
            # [           a21*b11, a22*b11 - e22*f11,           a21*b12, a22*b12 - e22*f12]
            # [           a11*b21,           a12*b21, a11*b22 - e11*f22, a12*b22 - e12*f22]
            # [           a21*b21,           a22*b21,           a21*b22, a22*b22 - e22*f22]
            # (iszero(E[1,2]) && iszero(F[1,2])) ?
            # (@inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[1,2]*B[1,1]      A[1,1]*B[1,2]      A[1,2]*B[1,2];
            # A[2,1]*B[1,1]  A[2,2]*B[1,1]-E[2,2]*F[1,1]      A[2,1]*B[1,2]      A[2,2]*B[1,2];
            # A[1,1]*B[2,1]      A[1,2]*B[2,1]  A[1,1]*B[2,2]-E[1,1]*F[2,2]      A[1,2]*B[2,2];
            # A[2,1]*B[2,1]      A[2,2]*B[2,1]      A[2,1]*B[2,2]  A[2,2]*B[2,2]-E[2,2]*F[2,2]]) :
            # (@inbounds R = [ A[1,1]*B[1,1]-E[1,1]*F[1,1]      A[1,2]*B[1,1]-E[1,2]*F[1,1]      A[1,1]*B[1,2]-E[1,1]*F[1,2]      A[1,2]*B[1,2]-E[1,2]*F[1,2];
            # A[2,1]*B[1,1]  A[2,2]*B[1,1]-E[2,2]*F[1,1]      A[2,1]*B[1,2]      A[2,2]*B[1,2]-E[2,2]*F[1,2];
            # A[1,1]*B[2,1]      A[1,2]*B[2,1]  A[1,1]*B[2,2]-E[1,1]*F[2,2]      A[1,2]*B[2,2]-E[1,2]*F[2,2];
            # A[2,1]*B[2,1]      A[2,2]*B[2,1]      A[2,1]*B[2,2]  A[2,2]*B[2,2]-E[2,2]*F[2,2]])
            @inbounds  R[1,1] = A[1,1]*B[1,1]-E[1,1]*F[1,1]
            @inbounds  R[1,2] = A[1,2]*B[1,1]-E[1,2]*F[1,1]
            @inbounds  R[1,3] = A[1,1]*B[1,2]-E[1,1]*F[1,2]
            @inbounds  R[1,4] = A[1,2]*B[1,2]-E[1,2]*F[1,2]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]-E[2,2]*F[1,1]
            @inbounds  R[2,3] = A[2,1]*B[1,2]
            @inbounds  R[2,4] = A[2,2]*B[1,2]-E[2,2]*F[1,2]
            @inbounds  R[3,1] = A[1,1]*B[2,1]
            @inbounds  R[3,2] = A[1,2]*B[2,1]
            @inbounds  R[3,3] = A[1,1]*B[2,2]-E[1,1]*F[2,2]
            @inbounds  R[3,4] = A[1,2]*B[2,2]-E[1,2]*F[2,2]
            @inbounds  R[4,1] = A[2,1]*B[2,1]
            @inbounds  R[4,2] = A[2,2]*B[2,1]
            @inbounds  R[4,3] = A[2,1]*B[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]-E[2,2]*F[2,2]
            @inbounds  Y[1] = -C[1,1]
            @inbounds  Y[2] = -C[2,1]
            @inbounds  Y[3] = -C[1,2]
            @inbounds  Y[4] = -C[2,2]
         end
      end
   end
   luslv!(R,Y,na*nb) && throw("ME:SingularException: A-λE has eigenvalues α and β such that αβ ≈ 1")
   if na == 1 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[1,2] = Y[2]
   elseif na == 2 && nb == 1
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
   else # na == 2 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
      @inbounds C[1,2] = Y[3]
      @inbounds C[2,2] = Y[4]
   end
   return C
end
function lyapds!(A::AbstractMatrix{T1},E::Union{AbstractMatrix{T1},UniformScaling{Bool}}, C::AbstractMatrix{T1},W::AbstractVector{T1} = Array{T1,1}(undef,size(A,1)); adj = false) where {T1<:Complex}
   n = LinearAlgebra.checksquare(A)
   LinearAlgebra.checksquare(C) == n || throw(DimensionMismatch("C must be a $n x $n matrix"))
   ishermitian(C) || throw(ArgumentError("C must be a hermitian matrix"))
   (typeof(E) == UniformScaling{Bool} || (isequal(E,I) && size(E,1) == n)) && (lyapds!(A, C, adj = adj); return)
   LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))

   # Compute the hermitian solution
   if adj
      for k = 1:n
         for l = 1:k
            y = C[k,l]
            if k > 1
               C[l,k] = C[l,1]*A[1,k]
               W[l] = C[l,1]*E[1,k]
               for ir = 2:k-1
                  C[l,k] +=  C[l,ir]*A[ir,k]
                  W[l] += C[l,ir]*E[ir,k]
               end
               for ic = 1:l
                   y += C[ic,k]'*A[ic,l] - W[ic]'*E[ic,l]
                end
            end
            C[k,l] = y/(E[k,k]'*E[l,l]-A[k,k]'*A[l,l])
            isfinite(C[k,l]) || throw("ME:SingularException: A-λE has eigenvalues α and β such that αβ ≈ 1")
            k == l && (C[k,k] = real(C[k,k]))
            if l < k
               C[l,k] += C[k,l]'*A[k,k]
               W[l] += C[k,l]'*E[k,k]
            end
         end
         for ir = 1:k-1
             C[ir,k] = C[k,ir]'
         end
      end
   else
      for l = n:-1:1
        for k = n:-1:l
            y = C[l,k]
            if l < n
               C[k,l] = C[k,l+1]*A[l,l+1]'
               W[k] = C[k,l+1]*E[l,l+1]'
               for ir = l+2:n
                  C[k,l] += C[k,ir]*A[l,ir]'
                  W[k] += C[k,ir]*E[l,ir]'
               end
               for ic = k:n
                   y += (A[k,ic]*C[ic,l] - E[k,ic]*W[ic])'
               end
            end
            C[l,k] = y/(E[k,k]'*E[l,l]-A[k,k]'*A[l,l])
            isfinite(C[l,k]) || throw("ME:SingularException: A-λE has eigenvalues α and β such that αβ ≈ 1")
            k == l && (C[k,k] = real(C[k,k]))
            if k > l
               C[k,l] += (A[l,l]*C[l,k])'
               W[k] += (E[l,l]*C[l,k])'
            end
        end
        if l < n
           for ir = l+1:n
               C[ir,l] = C[l,ir]'
           end
        end
      end
   end
end
# Lyapunov-like equations 
"""
    X = tlyapc(A,C, isig = 1; fast = true, atol::Real=0, rtol::Real=atol>0 ? 0 : N*ϵ)

Compute for `isig = ±1` a solution of the continuous T-Lyapunov matrix equation

                A*X + isig*transpose(X)*transpose(A) + C = 0

using explicit formulas based on full rank factorizations of `A`  (see [1] and [2]). 
`A` and `C` are `m×n` and `m×m` matrices, respectively, and `X` is an `n×m` matrix.
The matrix `C` must be symmetric if `isig = 1` and skew-symmetric if `isig = -1`.
`atol` and `rtol` are the absolute and relative tolerances, respectively, used for rank computation. 
The default relative tolerance is `N*ϵ`, where `N = min(m,n)` and ϵ is the machine precision of 
the element type of `A`.

The underlying rank revealing factorization of `A` is the QR-factorization with column pivoting, 
if `fast = true` (default), or the more reliable SVD-decomposition, if `fast = false`.

[1] H. W. Braden. The equations A^T X ± X^T A = B. SIAM J. Matrix Anal. Appl., 20(2):295–302, 1998.

[2] C.-Y. Chiang, E. K.-W. Chu, W.-W. Lin, On the ★-Sylvester equation AX ± X^★ B^★ = C.
    Applied Mathematics and Computation, 218:8393–8407, 2012.
"""
function tlyapc(A, C, isig = 1; fast::Bool = true, atol::Real = 0.0, rtol::Real = (min(size(A)...)*eps(real(float(one(eltype(A))))))*iszero(atol))
    m = LinearAlgebra.checksquare(C)
    ma, n = size(A)
    ma == m || throw(DimensionMismatch("A and C have incompatible dimensions"))
    abs(isig) == 1 || error(" isig must be either 1 or -1")
    if isig == 1
       issymmetric(C) || error("C must be symmetric for isig = 1")
       # temporary fix to avoid false results for DoubleFloats 
       # C == transpose(C) || error("C must be symmetric for isig = 1")
    else
       iszero(C+transpose(C)) || error("C must be skew-symmetric for isig = -1")
    end
    T2 = promote_type(eltype(A), eltype(C))
    T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
    eltype(A) == T2 || (A = convert(Matrix{T2},A))
    eltype(C) == T2 || (C = convert(Matrix{T2},C))
    if fast 
       F = qr(A, ColumnNorm())
       tol = max(atol, rtol*norm(F.R,Inf))
       r = count(x -> abs(x) > tol, diag(F.R))
       Ct = F.Q'*C*conj(Matrix(F.Q))
       i1 = 1:r; j2 = r+1:m
       norm(view(Ct,j2,j2),Inf) <= tol || @warn "Incompatible equation: least-squares solution computed"
       return ([ldiv!(UpperTriangular(2*F.R[i1,i1]),view(Ct,i1,i1)) ldiv!(UpperTriangular(F.R[i1,i1]),view(Ct,i1,j2));
                zeros(T2,n-r,m)]*transpose(Matrix(F.Q)))[invperm(F.p),:]
   else
       m > n ? F = svd(A,full = true) : F = svd(A)
       tol = max(atol, rtol*F.S[1])
       r = count(x -> x > tol, F.S)
       Ct = F.U'*C*conj(F.U)
       i1 = 1:r; j2 = r+1:m
       norm(view(Ct,j2,j2),Inf) <= tol || @warn "Incompatible equation: least-squares solution computed"
       return view(F.Vt,i1,:)'*([Diagonal(F.S[i1]*2)\Ct[i1,i1] Diagonal(F.S[i1])\Ct[i1,j2]]*transpose(F.U))
    end
end 
"""
    X = hlyapc(A,C, isig = 1; atol::Real=0, rtol::Real=atol>0 ? 0 : N*ϵ)

Compute for `isig = ±1` a solution of the continuous H-Lyapunov matrix equation

                A*X + isig*adjoint(X)*adjoint(A) + C = 0

using explicit formulas based on full rank factorizations of `A`  (see [1] and [2]). 
`A` and `C` are `m×n` and `m×m` matrices, respectively, and `X` is an `n×m` matrix.
The matrix `C` must be hermitian if `isig = 1` and skew-hermitian if `isig = -1`.
`atol` and `rtol` are the absolute and relative tolerances, respectively, used for rank computation. 
The default relative tolerance is `N*ϵ`, where `N = min(m,n)` and ϵ is the machine precision 
of the element type of `A`.

The underlying rank revealing factorization of `Ae` (or of `A` if real) is the QR-factorization with column pivoting, 
if `fast = true` (default), or the more reliable SVD-decomposition, if `fast = false`.

[1]  H. W. Braden. The equations A^T X ± X^T A = B. SIAM J. Matrix Anal. Appl., 20(2):295–302, 1998.

[2] C.-Y. Chiang, E. K.-W. Chu, W.-W. Lin, On the ★-Sylvester equation AX ± X^★ B^★ = C.
    Applied Mathematics and Computation, 218:8393–8407, 2012.
"""
function hlyapc(A, C, isig = 1; fast::Bool = true, atol::Real = 0.0, rtol::Real = (min(size(A)...)*eps(real(float(one(eltype(A))))))*iszero(atol))
   promote_type(eltype(A),eltype(C)) <: Real && (return tlyapc(A, C; fast, atol, rtol))
   m = LinearAlgebra.checksquare(C)
   ma, n = size(A)
   ma == m || throw(DimensionMismatch("A and C have incompatible dimensions"))
   abs(isig) == 1 || error(" isig must be either 1 or -1")
   if isig == 1
      ishermitian(C) || error("C must be hermitian for isig = 1")
      # temporary fix to avoid false results for DoubleFloats 
      # C == adjoint(C) || error("C must be hermitian for isig = 1")
   else
      iszero(C+adjoint(C)) || error("C must be skew-hermitian for isig = -1")
   end
   T2 = promote_type(eltype(A), eltype(C))
   T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
   eltype(A) == T2 || (A = convert(Matrix{T2},A))
   eltype(C) == T2 || (C = convert(Matrix{T2},C))
   if fast 
      F = qr(A, ColumnNorm())
      tol = max(atol, rtol*norm(F.R,Inf))
      r = count(x -> abs(x) > tol, diag(F.R))
      Ct = F.Q'*C*F.Q
      i1 = 1:r; j2 = r+1:m
      norm(view(Ct,j2,j2),Inf) <= tol || @warn "Incompatible equation: least-squares solution computed"
      return ([ldiv!(UpperTriangular(2*F.R[i1,i1]),view(Ct,i1,i1)) ldiv!(UpperTriangular(F.R[i1,i1]),view(Ct,i1,j2));
               zeros(T2,n-r,m)]*F.Q')[invperm(F.p),:]
  else
      m > n ? F = svd(A,full = true) : F = svd(A)
      tol = max(atol, rtol*F.S[1])
      r = count(x -> x > tol, F.S)
      Ct = F.U'*C*F.U
      i1 = 1:r; j2 = r+1:m
      norm(view(Ct,j2,j2),Inf) <= tol || @warn "Incompatible equation: least-squares solution computed"
      return view(F.Vt,i1,:)'*[Diagonal(F.S[i1]*2)\Ct[i1,i1] Diagonal(F.S[i1])\Ct[i1,j2]]*F.U'
   end
end
"""
    X = tulyapc!(U, Q; adj = false)

Compute for an upper triangular `U` and a symmetric `Q` an upper triangular solution `X` of the continuous T-Lyapunov matrix equation

                transpose(U)*X + transpose(X)*U = Q  if adj = false, 

or

                U*transpose(X) + X*transpose(U) = Q   if adj = true.

The solution `X` overwrites the matrix `Q`, while `U` is unchanged.

If `U` is nonsingular, a backward elimination method is used, if `adj = false`, or a forward elimination method is used if `adj = true`, by adapting the approach 
employed in the function `dU_from_dQ!` of the [`DiffOpt.jl`](https://github.com/jump-dev/DiffOpt.jl) package. 
For a `n×n`  singular `U`, a least-squares upper-triangular solution `X` is determined using a conjugate-gradient based iterative method applied 
to a suitably defined T-Lyapunov linear operator `L:X -> Y`, which maps upper triangular matrices `X`
into upper triangular matrices `Y`, and the associated matrix `M = Matrix(L)` is ``n(n+1)/2 \\times n(n+1)/2``. 
In this case, the keyword argument `tol` (default: `tol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: maxiter = 1000). 
"""
function tulyapc!(U::AbstractMatrix{T}, Q::AbstractMatrix{T}; adj = false, abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T}
   n = LinearAlgebra.checksquare(Q)
   n == LinearAlgebra.checksquare(Q) || throw(DimensionMismatch("U and Q have incompatible dimensions"))
   istriu(U) || throw(ArgumentError("U must be upper triangular"))
   issymmetric(Q) || throw(ArgumentError("Q must be symmetric"))
   if !any(iszero.(diag(U))) 
      if adj
         # U*transpose(X) + X*transpose(U) = Q
         for i in n:-1:1
            for j in n:-1:1
                if i < j
                   Q[i, j] -= transpose(view(U, i, j:n))*view(Q, j, j:n)
                elseif i == j
                   Q[i, j] /= 2
                else
                   Q[i, j] = 0
                end
            end
            Ut = transpose(LinearAlgebra.UpperTriangular(view(U, i:n, i:n)))
            LinearAlgebra.rdiv!(view(Q, i:i, i:n), Ut)
        end
     else
         # transpose(U)*X + transpose(X)*U = Q
         for j in 1:n
            for i in 1:n
                if i < j
                   Q[i, j] -= transpose(view(U, 1:i, j))*view(Q, 1:i, i)
                elseif i == j
                   Q[i, j] /= 2
                else
                   Q[i, j] = 0
                end
            end
            Ut = transpose(LinearAlgebra.UpperTriangular(view(U, 1:j, 1:j)))
            LinearAlgebra.ldiv!(Ut, view(Q, 1:j, j))
         end
      end
   else
      LT = tulyaplikeop(U; adj)
      xt, info = MatrixEquations.cgls(LT,triu2vec(Q); abstol, reltol, maxiter)
      info.flag == 1 || @warn "convergence issues: info = $info"
      Q[:] = vec2triu(xt)
   end
   return Q
end
"""
    X = hulyapc!(U, Q; adj = false)

Compute for an upper triangular `U` and a hermitian `Q` an upper triangular solution `X` of the continuous H-Lyapunov matrix equation

                U'*X + X'*U = Q   if adj = false, 

or

                U*X' + X*U' = Q   if adj = true.

The solution `X` overwrites the matrix `Q`, while `U` is unchanged.

If `U` is nonsingular, a backward elimination method is used, if `adj = false`, or a forward elimination method is used if `adj = true`, by adapting the approach 
employed in the function `dU_from_dQ!` of the [`DiffOpt.jl`](https://github.com/jump-dev/DiffOpt.jl) package. 
For a `n×n`  singular `U`, a least-squares upper-triangular solution `X` is determined using a conjugate-gradient based iterative method applied 
to a suitably defined T-Lyapunov linear operator `L:X -> Y`, which maps upper triangular matrices `X`
into upper triangular matrices `Y`, and the associated matrix `M = Matrix(L)` is ``n(n+1)/2 \\times n(n+1)/2``. 
In this case, the keyword argument `tol` (default: `tol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: maxiter = 1000). 
"""
function hulyapc!(U::AbstractMatrix{T}, Q::AbstractMatrix{T}; adj = false, abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T}
   n = LinearAlgebra.checksquare(Q)
   n == LinearAlgebra.checksquare(Q) || throw(DimensionMismatch("U and Q have incompatible dimensions"))
   istriu(U) || throw(ArgumentError("U must be upper triangular"))
   ishermitian(Q) || throw(ArgumentError("Q must be hermitian"))
   if !any(iszero.(diag(U))) 
      if adj
         # U*X' + X*U' = Q
         for i in n:-1:1
            for j in n:-1:1
                if i < j
                   Q[i, j] -= view(Q, j, j:n)'*view(U, i, j:n)
                elseif i == j
                   Q[i, j] /= 2
                else
                   Q[i, j] = 0
                end
            end
            Ut = LinearAlgebra.UpperTriangular(view(U, i:n, i:n))'
            LinearAlgebra.rdiv!(view(Q, i:i, i:n), Ut)
        end
     else
         # U'*X + X'*U = Q
         for j in 1:n
            for i in 1:n
                if i < j
                   Q[i, j] -= view(Q, 1:i, i)'*view(U, 1:i, j)
                elseif i == j
                   Q[i, j] /= 2
                else
                   Q[i, j] = 0
                end
            end
            Ut = LinearAlgebra.UpperTriangular(view(U, 1:j, 1:j))'
            LinearAlgebra.ldiv!(Ut, view(Q, 1:j, j))
        end
     end
   else
      LT = hulyaplikeop(U; adj)
      xt, info = cgls(LT,triu2vec(Q); abstol, reltol, maxiter)
      info.flag == 1 || @warn "convergence issues: info = $info"
      Q[:] = vec2triu(xt)
   end
   return Q
end

module Test_dplyap

using LinearAlgebra
using LinearAlgebra: BlasFloat
using MatrixEquations
using GenericSchur
using Test

println("Test_dplyap")
@testset "Testing positive discrete Lyapunov equation solvers" begin

n = 30
m = 5
p = 3
Ty = Float64

@testset "Positive discrete Lyapunov equations" begin

reltol = eps(float(100))
a = -.1+0.2im; b = 2im; @time u = plyapd(a,b)
@test abs(a*u*u'*a'-u*u'+b*b') < reltol

reltol = eps(float(100f0))
a = -.1f0+-.1f0*im; b = 2f0im; @time u = plyapd(a,b)
@test abs(a*u*u'*a'-u*u'+b*b')  < reltol

for Ty in (Float64, Float32, BigFloat)

ar = rand(Ty,n,n);
ar = ar/(one(Ty) + norm(ar));
ac = rand(Ty,n,n)+im*rand(Ty,n,n);
ac = ac/(one(Ty) + norm(ac));
br = rand(Ty,n,m);
brw = rand(Ty,n,n+m)
bc = br+im*rand(Ty,n,m);
bcw = brw+im*rand(Ty,n,n+m)
cr = rand(Ty,p,n)
crt = rand(Ty,n+p,n)
cc = cr+im*rand(Ty,p,n)
cct = crt+im*rand(Ty,n+p,n)
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))


@time u = plyapd(ar,br);
x = u*u'; @test norm(ar*x*ar'-x+br*br')/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ar,0*br);
x = u*u'; @test norm(ar*x*ar'-x) < reltol

@time u = plyapd(ar,brw);
x = u*u'; @test norm(ar*x*ar'-x+brw*brw')/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ar,I,br);
x = u*u'; @test norm(ar*x*ar'-x+br*br')/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ar',cr');
x = u'*u; @test norm(ar'*x*ar-x+cr'*cr)/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ar',crt');
x = u'*u; @test norm(ar'*x*ar-x+crt'*crt)/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ac,bc);
x = u*u'; @test norm(ac*x*ac'-x+bc*bc')/norm(x)/max(1.,norm(ac)^2) < reltol

@time u = plyapd(ac,0*bc);
x = u*u'; @test norm(ac*x*ac'-x) < reltol

@time u = plyapd(ac,bcw);
x = u*u'; @test norm(ac*x*ac'-x+bcw*bcw')/norm(x)/max(1.,norm(ac)^2) < reltol

@time u = plyapd(ac',cc');
x = u'*u; @test norm(ac'*x*ac-x+cc'*cc)/norm(x)/max(1.,norm(ac)^2) < reltol

@time u = plyapd(ac',cct');
x = u'*u; @test norm(ac'*x*ac-x+cct'*cct)/norm(x)/max(1.,norm(ac)^2) < reltol

@time u = plyapd(ac',cr');
x = u'*u; @test norm(ac'*x*ac-x+cr'*cr)/norm(x)/max(1.,norm(ac)^2) < reltol

@time u = plyapd(ar,bc);
x = u*u'; @test norm(ar*x*ar'-x+bc*bc')/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ar',cc');
x = u'*u; @test norm(ar'*x*ar-x+cc'*cc)/norm(x)/max(1.,norm(ar)^2) < reltol

if Ty <: BlasFloat
@time u = plyapd(ar,br; blocksize = 10);
x = u*u'; @test norm(ar*x*ar'-x+br*br')/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ar',cr'; blocksize = 10);
x = u'*u; @test norm(ar'*x*ar-x+cr'*cr)/norm(x)/max(1.,norm(ar)^2) < reltol

@time u = plyapd(ac,bc; blocksize = 10);
x = u*u'; @test norm(ac*x*ac'-x+bc*bc')/norm(x)/max(1.,norm(ac)^2) < reltol

@time u = plyapd(ac',cc'; blocksize = 10);
x = u'*u; @test norm(ac'*x*ac-x+cc'*cc)/norm(x)/max(1.,norm(ac)^2) < reltol 
end


end
end

@testset "Positive discrete generalized Lyapunov equations" begin

reltol = eps(float(100))
a = -1+im; ee = 4; b = 2im; @time u = plyapd(a,ee,b)
@test abs(a*u*u'*a'-ee*u*u'*ee'+b*b') < reltol

reltol = eps(float(100f0))
a = -1f0+1f0*im; ee = 4f0; b = 2f0im; @time u = plyapd(a,ee,b)
@test abs(a*u*u'*a'-ee*u*u'*ee'+b*b')  < reltol

for Ty in (Float64, Float32, BigFloat)
# for Ty in (Float64, Float32)
    
ar = rand(Ty,n,n)
ar = ar/(one(Ty) + norm(ar))
er = rand(Ty,n,n)
ar = er*ar
ac = rand(Ty,n,n)+im*rand(Ty,n,n)
ac = ac/(one(Ty) + norm(ac))
ec = er+im*rand(Ty,n,n)
ac = ec*ac
br = rand(Ty,n,m)
brw = rand(Ty,n,n+m)
bc = br+im*rand(Ty,n,m)
bcw = brw+im*rand(Ty,n,n+m)
cr = rand(Ty,p,n)
crt = rand(Ty,n+p,n)
cc = cr+im*rand(Ty,p,n)
cct = crt+im*rand(Ty,n+p,n)
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))


@time u = plyapd(ar',er',cr');
x = u'*u; @test norm(ar'*x*ar-er'*x*er+cr'*cr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time u = plyapd(ar',er',crt');
x = u'*u; @test norm(ar'*x*ar-er'*x*er+crt'*crt)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time u = plyapd(ar,er,br);
x = u*u'; @test norm(ar*x*ar'-er*x*er'+br*br')/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time u = plyapd(ar,er,0*br);
x = u*u'; @test norm(ar*x*ar'-er*x*er') < reltol

@time u = plyapd(ar,er,brw);
x = u*u'; @test norm(ar*x*ar'-er*x*er'+brw*brw')/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time u = plyapd(ac,ec,bc);
x = u*u'; @test norm(ac*x*ac'-ec*x*ec'+bc*bc')/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time u = plyapd(ac,ec,0*bc);
x = u*u'; @test norm(ac*x*ac'-ec*x*ec') < reltol

@time u = plyapd(ac,ec,bcw);
x = u*u'; @test norm(ac*x*ac'-ec*x*ec'+bcw*bcw')/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time u = plyapd(ac',ec',cc');
x = u'*u; @test norm(ac'*x*ac-ec'*x*ec+cc'*cc)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time u = plyapd(ac',ec',cct');
x = u'*u; @test norm(ac'*x*ac-ec'*x*ec+cct'*cct)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time u = plyapd(ar,er,bc);
x = u*u'; @test norm(ar*x*ar'-er*x*er'+bc*bc')/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time u = plyapd(ar',er',cc');
x = u'*u; @test norm(ar'*x*ar-er'*x*er+cc'*cc)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time u = plyapd(ac,ec,br);
x = u*u'; @test norm(ac*x*ac'-ec*x*ec'+br*br')/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time u = plyapd(ac',ec',cr');
x = u'*u; @test norm(ac'*x*ac-ec'*x*ec+cr'*cr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol
end
end

@testset "Positive discrete 2x2 Lyapunov equations" begin

A = [-1.1 1.; -1. -1.]/10
E = [1. 1.; 0. 1.]
R = [1. 1.; 0. 1.]
reltol = eps(float(100))
β = rand(2,2); α = rand(2,2);


U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = true, disc = true)
#U, scale, β, α = plyap2(A, R, adj = true, disc = true)
X = U'*U; @test norm(A'*X*A-X+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U - R)/max(1,norm(R)) < reltol

U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = false, disc = true)
X = U*U'; @test norm(A*X*A'-X+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(U*β-A*U)/max(1,norm(U))/norm(A) < reltol &&
                norm(U*α - R)/max(1,norm(R)) < reltol

U = copy(R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = true, disc = true)
X = U'*U; @test norm(A'*X*A-E'*X*E+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U*E-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U*E - R)/max(1,norm(R)) < reltol

U = copy(R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = false, disc = true)
X = U*U'; @test norm(A*X*A'-E*X*E'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(A*U-E*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E*U*α - R)/max(1,norm(R)) < reltol

U = copy(R)
Q = qr(rand(2,2)).Q; A1 = Q*A; E1 = Q*E;
β, α = MatrixEquations.pglyap2!(A1, E1, U, adj = false, disc = true)
X = U*U'; @test norm(A1*X*A1'-E1*X*E1'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(A1*U-E1*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E1*U*α - R)/max(1,norm(R)) < reltol

U = copy(0*R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = false, disc = true)
X = U*U'; @test norm(A*X*E'+E*X*A')/max(1,norm(X))/norm(A) < reltol &&
                norm(A*U-E*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E*U*α)/max(1,norm(R)) < reltol


A = [-1.1 1.; -1. -1.]/10; A = convert(Matrix{Float32},A)
E = [1. 1.; 0. 1.]; E = convert(Matrix{Float32},E)
R = [1. 1.; 0. 1.]; R = convert(Matrix{Float32},R)
reltol = eps(100f0)
β = rand(Float32,2,2); α = rand(Float32,2,2);

U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = true, disc = true)
X = U'*U; @test norm(A'*X*A-X+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U - R)/max(1,norm(R)) < reltol

U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = false, disc = true)
X = U*U'; @test norm(A*X*A'-X+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(U*β-A*U)/max(1,norm(U))/norm(A) < reltol &&
                norm(U*α - R)/max(1,norm(R)) < reltol

U = copy(R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = true, disc = true)
X = U'*U; @test norm(A'*X*A-E'*X*E+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U*E-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U*E - R)/max(1,norm(R)) < reltol

U = copy(R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = false, disc = true)
X = U*U'; @test norm(A*X*A'-E*X*E'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(A*U-E*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E*U*α - R)/max(1,norm(R)) < reltol

end


@testset "Positive discrete Lyapunov equations - Schur form" begin


for Ty in (Float64, Float32, BigFloat)

ar = rand(Ty,n,n);
ar = ar/(one(Ty) + norm(ar));
as,  = schur(ar);
ac = rand(Ty,n,n)+im*rand(Ty,n,n);
ac = ac/(one(Ty) + norm(ac));
acs,  = schur(ac);
br = rand(Ty,n,m);
bc = br+im*rand(Ty,n,m);
cr = rand(Ty,p,n);
cc = cr+im*rand(Ty,p,n);
Ty == Float64 ? reltol = eps(float(1000)) : reltol = eps(1000*n*one(Ty))


@time u = plyaps(as,br,disc = true);
x = u*u'; @test norm(as*x*as'-x+br*br')/norm(x)/norm(as) < reltol

@time u = plyaps(as,0*br,disc = true);
x = u*u'; @test norm(as*x*as'-x) < reltol

@time u = plyaps(as,ar,disc = true);
x = u*u'; @test norm(as*x*as'-x+ar*ar')/norm(x)/norm(as) < reltol

@time u = plyaps(as',cr',disc = true);
x = u'*u; @test norm(as'*x*as-x+cr'*cr)/norm(x)/norm(as) < reltol

@time u = plyaps(as',ar',disc = true);
x = u'*u; @test norm(as'*x*as-x+ar'*ar)/norm(x)/norm(as) < reltol

@time u = plyaps(acs,bc,disc = true);
x = u*u'; @test norm(acs*x*acs'-x+bc*bc')/norm(x)/norm(acs) < reltol

@time u = plyaps(acs,0*bc,disc = true);
x = u*u'; @test norm(acs*x*acs'-x) < reltol

@time u = plyaps(acs',cc',disc = true);
x = u'*u; @test norm(acs'*x*acs-x+cc'*cc)/norm(x)/norm(as) < reltol

if Ty <: BlasFloat
@time u = plyaps(as,br,disc = true,blocksize = 10);
x = u*u'; @test norm(as*x*as'-x+br*br')/norm(x)/norm(as) < reltol

@time u = plyaps(as',cr',disc = true,blocksize = 10);
x = u'*u; @test norm(as'*x*as-x+cr'*cr)/norm(x)/norm(as) < reltol

@time u = plyaps(acs,bc,disc = true,blocksize = 10);
x = u*u'; @test norm(acs*x*acs'-x+bc*bc')/norm(x)/norm(acs) < reltol

@time u = plyaps(acs',cc',disc = true,blocksize = 10);
x = u'*u; @test norm(acs'*x*acs-x+cc'*cc)/norm(x)/norm(as) < reltol
end

R = UpperTriangular(rand(Ty,n,n));
U = copy(R);
@time plyapds!(as, U, adj = false);
X = U*U'; @test norm(as*X*as'-X+R*R')/max(1,norm(X))/norm(as) < reltol

R = UpperTriangular(rand(Ty,n,n));
U = copy(R);
@time plyapds!(as,U,adj = true);
X = U'*U; @test norm(as'*X*as-X+R'*R)/max(1,norm(X))/norm(as) < reltol

R = UpperTriangular(rand(Complex{Ty},n,n))
U = copy(R)
@time plyapds!(acs,U,adj = false)
X = U*U'; @test norm(acs*X*acs'-X+R*R')/max(1,norm(X))/norm(acs) < reltol

R = UpperTriangular(complex(rand(Ty,n,n)))
U = copy(R)
@time plyapds!(acs,U,adj = true)
X = U'*U; @test norm(acs'*X*acs-X+R'*R)/max(1,norm(X))/norm(acs) < reltol

if Ty <: BlasFloat
R = UpperTriangular(rand(Ty,n,n));
U = copy(R);
@time plyapds!(as, U, adj = false,blocksize = 10);
X = U*U'; @test norm(as*X*as'-X+R*R')/max(1,norm(X))/norm(as) < reltol

R = UpperTriangular(rand(Ty,n,n));
U = copy(R);
@time plyapds!(as,U,adj = true,blocksize = 10);
X = U'*U; @test norm(as'*X*as-X+R'*R)/max(1,norm(X))/norm(as) < reltol

R = UpperTriangular(rand(Complex{Ty},n,n))
U = copy(R)
@time plyapds!(acs,U,adj = false,blocksize = 10)
X = U*U'; @test norm(acs*X*acs'-X+R*R')/max(1,norm(X))/norm(acs) < reltol

R = UpperTriangular(complex(rand(Ty,n,n)))
U = copy(R)
@time plyapds!(acs,U,adj = true,blocksize = 10)
X = U'*U; @test norm(acs'*X*acs-X+R'*R)/max(1,norm(X))/norm(acs) < reltol
end

as = schur(ar).T
er = rand(Ty,n,n)
ar = er*ar
es = triu(er)
as = es*as
#as, es = schur(ar,er)
ec = er+im*rand(Ty,n,n)
ac = ec*ac
acs, ecs = schur(ac,ec)


@time u = plyaps(as,es,br,disc = true);
x = u*u'; @test norm(as*x*as'-es*x*es'+br*br')/norm(x)/norm(as) < reltol

@time u = plyaps(as,es,ar,disc = true);
x = u*u'; @test norm(as*x*as'-es*x*es'+ar*ar')/norm(x)/norm(as) < reltol

@time u = plyaps(as',es',cr',disc = true);
x = u'*u; @test norm(as'*x*as-es'*x*es+cr'*cr)/norm(x)/norm(as) < reltol

@time u = plyaps(as',es',ar',disc = true);
x = u'*u; @test norm(as'*x*as-es'*x*es+ar'*ar)/norm(x)/norm(as) < reltol

@time u = plyaps(acs,ecs,bc,disc = true);
x = u*u'; @test norm(acs*x*acs'-ecs*x*ecs'+bc*bc')/norm(x)/norm(as) < reltol

@time u = plyaps(acs',ecs',cc',disc = true);
x = u'*u; @test norm(acs'*x*acs-ecs'*x*ecs+cc'*cc)/norm(x)/norm(as) < reltol

R = UpperTriangular(rand(Ty,n,n))
U = copy(R)
@time plyapds!(as,es,U,adj = false)
X = U*U'; @test norm(as*X*as'-es*X*es'+R*R')/max(1,norm(X))/norm(as) < reltol

R = UpperTriangular(rand(Ty,n,n))
U = copy(R)
@time plyapds!(as,es,U,adj = true)
X = U'*U; @test norm(as'*X*as-es'*X*es+R'*R)/max(1,norm(X))/norm(as) < reltol

R = UpperTriangular(rand(Complex{Ty},n,n)) # error
U = copy(R)
@time plyapds!(acs,ecs,U,adj = false)
X = U*U'; @test norm(acs*X*acs'-ecs*X*ecs'+R*R')/max(1,norm(X))/norm(acs) < reltol

R = UpperTriangular(rand(Complex{Ty},n,n)) # error
U = copy(R)
@time plyapds!(acs,ecs,U,adj = true)
X = U'*U; @test norm(acs'*X*acs-ecs'*X*ecs+R'*R)/max(1,norm(X))/norm(acs) < reltol
end
end
end

end

module MatrixEquations

const BlasFloat = Union{Float64,Float32,ComplexF64,ComplexF32}
const BlasReal = Union{Float64,Float32}
const BlasComplex = Union{ComplexF64,ComplexF32}

using LinearAlgebra
using LinearAlgebra: require_one_based_indexing
import LinearAlgebra: mul!
using LinearMaps


include("lapackutil.jl")
using .LapackUtil: tgsyl!, lanv2, ladiv, lag2, lacn2!, safemin, smlnum, trsyl3!

export MatrixEquationsMaps
export utqu, utqu!, qrupdate!, rqupdate!, isschur, triu2vec, vec2triu, utnormalize!, utqu_upd!
export lanv2, ladiv, lag2, lacn2!, trsyl3!
export _lanv2, _safemin, _lag2, _ladiv
export lyapc, lyapd, lyapcs!, lyapds!, tlyapc, tulyapc!, hlyapc, hulyapc! 
export cgls, lyapci, lyapdi, tlyapci, hlyapci, tulyapci, hulyapci, sylvci, sylvdi, gsylvi, gtsylvi, ghsylvi
export plyapc, plyaps, plyapcs!, plyapd, plyapds!  
export arec, ared, garec, gared
export sylvc, sylvd, gsylv, sylvcs!, sylvcs1!, sylvcs2!, sylvds!, gsylvs!
export lyapcs_blocked!, lyapds_blocked!, sylvcs_blocked!, sylvds_blocked!
export sylvsys, dsylvsys, sylvsyss!, dsylvsyss!, tgsyl!
export sylvckr, sylvdkr, gsylvkr, sylvsyskr, dsylvsyskr, 
       tsylvckr, hsylvckr, csylvckr, tsylvdkr, hsylvdkr, csylvdkr, tlyapckr, hlyapckr
export opnorm1, opnorm1est, oprcondest, opsepest
export lyapop, invlyapop, sylvop, invsylvop, sylvsysop, invsylvsysop, trmatop, eliminationop, duplicationop
export tulyaplikeop, hulyaplikeop, lyaplikeop, gsylvop
export plyapci, plyapdi
export lyapc02, lyapcs02!, lyapc12, lyapcs12!

include("meutil.jl")
include("sylvester.jl")
include("lyapunov.jl")
include("riccati.jl")
include("sylvkr.jl")
include("plyapunov.jl")
include("meoperators.jl")
include("condest.jl")
include("iterative_methods.jl")
 
end

module LapackUtil

import LinearAlgebra.BLAS.@blasfunc

using LinearAlgebra
import LinearAlgebra: BlasFloat, BlasInt, BlasReal, BlasComplex, LAPACKException,
    DimensionMismatch, SingularException, PosDefException, chkstride1, checksquare, require_one_based_indexing

using Base: iszero, has_offset_axes

export tgsyl!, lanv2, ladiv, lag2, lacn2!, trsyl3!

@static if VERSION < v"1.7"
    using LinearAlgebra.LAPACK: liblapack
elseif VERSION < v"1.9"
    const liblapack = "libblastrampoline"
else
    const liblapack = LinearAlgebra.libblastrampoline
end


function chklapackerror(ret::BlasInt)
   ret == 0 && return
   ret < 0 ? throw(ArgumentError("invalid argument #$(-ret) to LAPACK call")) : throw(LAPACKException(ret))
end
function chktrans(trans::AbstractChar)
    if !(trans == 'N' || trans == 'C' || trans == 'T')
        throw(ArgumentError(lazy"trans argument must be 'N' (no transpose), 'T' (transpose), or 'C' (conjugate transpose), got '$trans'"))
    end
    trans
end


for (fn, elty) in ((:dtrsyl3_, :Float64),
    (:strsyl3_, :Float32))
@eval begin
  function trsyl3!(transa::AbstractChar, transb::AbstractChar, A::AbstractMatrix{$elty},
                B::AbstractMatrix{$elty}, C::AbstractMatrix{$elty}, isgn::Int=1)
    require_one_based_indexing(A, B, C)
    chktrans(transa)
    chktrans(transb)
    chkstride1(A, B, C)
    m, n = checksquare(A), checksquare(B)
    lda = max(1, stride(A, 2))
    ldb = max(1, stride(B, 2))
    m1, n1 = size(C)
    if m != m1 || n != n1
        throw(DimensionMismatch(lazy"dimensions of A, ($m,$n), and C, ($m1,$n1), must match"))
    end
    ldc = max(1, stride(C, 2))
    scale = Ref{$elty}()
    info  = Ref{BlasInt}()
    iwork = Vector{BlasInt}(undef, 1)
    swork  = Matrix{$elty}(undef, 2, 1)
    liwork = BlasInt(-1)    
    ldswork = BlasInt(-1)
    for i = 1:2  
        # first call returns liwork as iwork[1] and 
        # ldswork as swork[1,1] and ncols as swork[2,1]
        # SUBROUTINE DTRSYL3( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C, LDC, 
        #                     SCALE, IWORK, LIWORK, SWORK, LDSWORK, INFO )
        ccall((@blasfunc($fn), liblapack), Cvoid,
          (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
           Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
           Ptr{$elty}, Ptr{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ref{BlasInt}, Clong, Clong),
           transa, transb, isgn, m, n,
           A, lda, B, ldb, C, ldc,
           scale, iwork, liwork, swork, ldswork, info, 1, 1)
       chklapackerror(info[])
       if i == 1
          liwork = iwork[1]
          iwork = Vector{BlasInt}(undef, liwork)
          ldswork = max(2,BlasInt(real(swork[1,1])))
          ncol = BlasInt(real(swork[2,1]))
          swork  = Matrix{$elty}(undef, ldswork, ncol)
       end
    end
    return C, scale[]
  end
end
end
for (fn, elty, relty) in ((:ztrsyl3_, :ComplexF64, :Float64),
    (:ctrsyl3_, :ComplexF32, :Float32))
@eval begin
  function trsyl3!(transa::AbstractChar, transb::AbstractChar, A::AbstractMatrix{$elty},
                B::AbstractMatrix{$elty}, C::AbstractMatrix{$elty}, isgn::Int=1)
    require_one_based_indexing(A, B, C)
    chktrans(transa)
    chktrans(transb)
    chkstride1(A, B, C)
    m, n = checksquare(A), checksquare(B)
    lda = max(1, stride(A, 2))
    ldb = max(1, stride(B, 2))
    m1, n1 = size(C)
    if m != m1 || n != n1
        throw(DimensionMismatch(lazy"dimensions of A, ($m,$n), and C, ($m1,$n1), must match"))
    end
    ldc = max(1, stride(C, 2))
    scale = Ref{$relty}()
    info  = Ref{BlasInt}()
    swork  = Matrix{$relty}(undef, 2, 1)
    ldswork = BlasInt(-1)
    for i = 1:2  
        # first call returns liwork as iwork[1] and 
        # ldswork as swork[1,1] and ncols as swork[2,1]
        # SUBROUTINE ZTRSYL3( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB,
        #                     C, LDC, SCALE, SWORK, LDSWORK, INFO )
        ccall((@blasfunc($fn), liblapack), Cvoid,
          (Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
           Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
           Ptr{$relty}, Ptr{$relty}, Ref{BlasInt}, Ref{BlasInt}, Clong, Clong),
           transa, transb, isgn, m, n,
           A, lda, B, ldb, C, ldc,
           scale, swork, ldswork, info, 1, 1)
       chklapackerror(info[])
       if i == 1
          ldswork = BlasInt(real(swork[1,1]))
          ncol = BlasInt(real(swork[2,1]))
          swork  = Matrix{$relty}(undef, ldswork, ncol)
       end
    end
    return C, scale[]
  end
end
end
"""
    trsyl3!(transa, transb, A, B, C, isgn=1) -> (C, scale)

Solves the Sylvester matrix equation `A * X +/- X * B = scale*C` where `A` and
`B` are both quasi-upper triangular. If `transa = N`, `A` is not modified.
If `transa = T`, `A` is transposed. If `transa = C`, `A` is conjugate
transposed. Similarly for `transb` and `B`. If `isgn = 1`, the equation
`A * X + X * B = scale * C` is solved. If `isgn = -1`, the equation
`A * X - X * B = scale * C` is solved.

Returns `X` (overwriting `C`) and `scale`.

The block-algorithm of [1] and [2] is used. 

References:

[1] E. S. Quintana-Orti and R. A. Van De Geijn (2003). Formal derivation of
    algorithms: The triangular Sylvester equation, ACM Transactions
    on Mathematical Software (TOMS), volume 29, pages 218-243.

[2] A. Schwarz and C. C. Kjelgaard Mikkelsen (2020). Robust Task-Parallel
    Solution of the Triangular Sylvester Equation. Lecture Notes in
    Computer Science, vol 12043, pages 82-92, Springer.

"""
trsyl3!(transa::AbstractChar, transb::AbstractChar, A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, isgn::Int=1)



for (fn, elty, relty) in ((:dtgsyl_, :Float64, :Float64),
                   (:stgsyl_, :Float32, :Float32),
                   (:ztgsyl_, :ComplexF64, :Float64),
                   (:ctgsyl_, :ComplexF32, :Float32))
    @eval begin
        function tgsyl!(trans::AbstractChar, A::AbstractMatrix{$elty}, B::AbstractMatrix{$elty}, C::AbstractMatrix{$elty},
                        D::AbstractMatrix{$elty}, E::AbstractMatrix{$elty}, F::AbstractMatrix{$elty})
            @assert !has_offset_axes(A, B, C, D, E, F)
            chkstride1(A, B, C, D, E, F)
            chktrans(trans)
            m, n = checksquare(A, B)
            lda = max(1, stride(A, 2))
            ldb = max(1, stride(B, 2))
            ldc = max(1, stride(C, 2))
            m1, n1 = size(C)
            (m == m1 && n == n1) ||
                throw(DimensionMismatch("dimensions of A($m,$m),  B($n,$n), and C($m1,$n1) must match"))
            m2, n2 = checksquare(D, E)
            m == m2 || throw(DimensionMismatch("dimensions of A($m,$m) and D($m2,$m2) must match"))
            n == n2 || throw(DimensionMismatch("dimensions of B($n,$n) and E($n2,$n2), must match"))
            ldd = max(1, stride(D, 2))
            lde = max(1, stride(E, 2))
            ldf = max(1, stride(F, 2))
            m3, n3 = size(F)
            (m2 == m3 && n2 == n3) ||
                throw(DimensionMismatch("dimensions of D($m,$m),  E($n,$n), and F($m3,$n3) must match"))
            dif = Vector{$relty}(undef, 1)
            scale = Vector{$relty}(undef, 1)
            info  = Ref{BlasInt}()
            ijob = 0
            work = Vector{$elty}(undef, 1)
            lwork = 1
            iwork = Vector{BlasInt}(undef,m+n+6)
            # SUBROUTINE DTGSYL( TRANS, IJOB, M, N, A, LDA, B, LDB, C, LDC, D,
            #       LDD, E, LDE, F, LDF, SCALE, DIF, WORK, LWORK,
            #       IWORK, INFO )
            ccall((@blasfunc($fn), liblapack), Cvoid,
                (Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                 Ptr{$relty}, Ptr{$relty}, Ptr{$relty}, Ref{BlasInt}, Ptr{BlasInt}, Ptr{BlasInt}, Clong),
                 trans, ijob, m, n,
                 A, lda, B, ldb, C, ldc, D, ldd, E, lde, F, ldf,
                 scale, dif, work, lwork, iwork, info, 1)
            chklapackerror(info[])
            C, F, scale[1]
        end
    end
end

"""
    tgsyl!(A, B, C, D, E, F) -> (C, F, scale)

Solve the Sylvester system of matrix equations

      AX - YB = scale*C
      DX - YE = scale*F ,

where `X` and `Y` are unknown matrices, the pairs `(A, D)`, `(B, E)` and  `(C, F)`
have the same sizes, and the pairs `(A, D)` and `(B, E)` are in
generalized (real) Schur canonical form, i.e. `A`, `B` are upper quasi
triangular and `D`, `E` are upper triangular.
Returns `X` (overwriting `C`), `Y` (overwriting `F`) and `scale`.

    tgsyl!(trans, A, B, C, D, E, F) -> (C, F, scale)

Solve for `trans = 'T'` and real matrices or for `trans = 'C'` and complex
matrices,  the (adjoint) Sylvester system of matrix equations

      A'X + D'Y = scale*C
      XB' + YE' = scale*(-F) .

`tgsyl!('N', A, B, C, D, E, F)` corresponds to the call `tgsyl!(A, B, C, D, E, F)`.

Interface to the LAPACK subroutines DTGSYL/STGSYL/ZTGSYL/CTGSYL.
"""
tgsyl!(trans::AbstractChar,A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix, E::AbstractMatrix, F::AbstractMatrix)

tgsyl!(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix, E::AbstractMatrix, F::AbstractMatrix) =
tgsyl!('N',A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix, E::AbstractMatrix, F::AbstractMatrix)

for (fn, elty) in ((:dlanv2_, :Float64),
                   (:slanv2_, :Float32))
    @eval begin
        function lanv2(A::$elty, B::$elty, C::$elty, D::$elty)
           """
           SUBROUTINE DLANV2( A, B, C, D, RT1R, RT1I, RT2R, RT2I, CS, SN )

           DOUBLE PRECISION A, B, C, CS, D, RT1I, RT1R, RT2I, RT2R, SN
           """
           RT1R = Ref{$elty}(1.0)
           RT1I = Ref{$elty}(1.0)
           RT2R = Ref{$elty}(1.0)
           RT2I = Ref{$elty}(1.0)
           CS = Ref{$elty}(1.0)
           SN = Ref{$elty}(1.0)
           ccall((@blasfunc($fn), liblapack), Cvoid,
                 (Ref{$elty},Ref{$elty},Ref{$elty},Ref{$elty},
                 Ref{$elty},Ref{$elty},Ref{$elty},Ref{$elty},Ref{$elty},Ref{$elty}),
                 A, B, C, D,
                 RT1R, RT1I, RT2R, RT2I, CS, SN)
           return RT1R[], RT1I[], RT2R[], RT2I[], CS[], SN[]
        end
    end
end
"""
    lanv2(A, B, C, D) -> (RT1R, RT1I, RT2R, RT2I, CS, SN)

Compute the Schur factorization of a real 2-by-2 nonsymmetric matrix `[A,B;C,D]` in
standard form. `A`, `B`, `C`, `D` are overwritten on output by the corresponding elements of the
standardised Schur form. `RT1R+im*RT1I` and `RT2R+im*RT2I` are the resulting eigenvalues.
`CS` and `SN` are the parameters of the rotation matrix.
Interface to the LAPACK subroutines DLANV2/SLANV2.
"""
lanv2(A::BlasReal, B::BlasReal, C::BlasReal, D::BlasReal)


for (fn, elty) in ((:dlag2_, :Float64),
                   (:slag2_, :Float32))
    @eval begin
        function lag2(A::StridedMatrix{$elty}, B::StridedMatrix{$elty}, SAFMIN::$elty)
           """
           SUBROUTINE DLAG2( A, LDA, B, LDB, SAFMIN, SCALE1, SCALE2, WR1, WR2, WI )

           INTEGER            LDA, LDB
           DOUBLE PRECISION   SAFMIN, SCALE1, SCALE2, WI, WR1, WR2
           DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
           """
           LDA = stride(A,2)
           LDB = stride(B,2)
           SCALE1 = Ref{$elty}(1.0)
           SCALE2 = Ref{$elty}(1.0)
           WR1 = Ref{$elty}(1.0)
           WR2 = Ref{$elty}(1.0)
           WI = Ref{$elty}(1.0)
           ccall((@blasfunc($fn), liblapack), Cvoid,
                (Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ref{$elty},
                Ref{$elty},Ref{$elty},Ref{$elty},Ref{$elty},Ref{$elty}),
                A, LDA, B, LDB, SAFMIN,
                SCALE1, SCALE2, WR1, WR2, WI)
           return SCALE1[], SCALE2[], WR1[], WR2[], WI[]
        end
    end
end
"""
    lag2(A, B, SAFMIN) -> (SCALE1, SCALE2, WR1, WR2, WI)

Compute the eigenvalues of a 2-by-2 generalized real eigenvalue problem for
the matrix pair `(A,B)`, with scaling as necessary to avoid over-/underflow.
`SAFMIN` is the smallest positive number s.t. `1/SAFMIN` does not overflow.
If `WI = 0`, `WR1/SCALE1` and `WR2/SCALE2` are the resulting real eigenvalues, while
if `WI <> 0`, then `(WR1+/-im*WI)/SCALE1` are the resulting complex eigenvalues.
Interface to the LAPACK subroutines DLAG2/SLAG2.
"""
lag2(A::StridedMatrix{BlasReal}, B::StridedMatrix{BlasReal}, SAFMIN::BlasReal)

# lag2(A::StridedMatrix{T}, B::StridedMatrix{T}) where T <: BlasReal = lag2(A,B,safemin(T))

# function safemin(::Type{T}) where T <: BlasReal
#     SMLNUM = (T == Float64) ? reinterpret(Float64, 0x2000000000000000) : reinterpret(Float32, 0x20000000)
#     return SMLNUM * 2/ eps(T)
# end
function smlnum(::Type{T}) where T <: BlasReal
    (T == Float64) ? reinterpret(Float64, 0x2000000000000000) : reinterpret(Float32, 0x20000000)
end
function safemin(::Type{T}) where T <: BlasReal
    smlnum(T) * 2/ eps(T)
end
for (fn, elty) in ((:dladiv_, :Float64),
                   (:sladiv_, :Float32))
    @eval begin
        function ladiv(A::$elty, B::$elty, C::$elty, D::$elty)
           """
           SUBROUTINE DLADIV( A, B, C, D, P, Q )

           DOUBLE PRECISION   A, B, C, D, P, Q
           """
           P = Ref{$elty}(1.0)
           Q = Ref{$elty}(1.0)
           ccall((@blasfunc($fn), liblapack), Cvoid,
                (Ref{$elty},Ref{$elty},Ref{$elty},Ref{$elty},
                 Ref{$elty},Ref{$elty}),
                 A, B, C, D, P, Q)
           return P[], Q[]
        end
    end
end
"""
    ladiv(A, B, C, D) -> (P, Q)

Perform the complex division in real arithmetic

  ``P + iQ = \\displaystyle\\frac{A+iB}{C+iD}``

by avoiding unnecessary overflow.
Interface to the LAPACK subroutines DLADIV/SLADIV.
"""
ladiv(A::BlasReal, B::BlasReal, C::BlasReal, D::BlasReal)

for (fn, elty) in ((:dlacn2_, :Float64),
                   (:slacn2_, :Float32))
    @eval begin
        function lacn2!(V::AbstractVector{$elty}, X::AbstractVector{$elty}, ISGN::AbstractVector{BlasInt},
                        EST::$elty, KASE::BlasInt, ISAVE::AbstractVector{BlasInt})
            """
            *       SUBROUTINE DLACN2( N, V, X, ISGN, EST, KASE, ISAVE )
            *
            *       .. Scalar Arguments ..
            *       INTEGER            KASE, N
            *       DOUBLE PRECISION   EST
            *       ..
            *       .. Array Arguments ..
            *       INTEGER            ISGN( * ), ISAVE( 3 )
            *       DOUBLE PRECISION   V( * ), X( * )
            """
            @assert !has_offset_axes(V, X)
            chkstride1(V,X)
            n = length(V)
            (n != length(X) || n != length(ISGN)) && throw(DimensionMismatch("dimensions of V,  X, and ISIGN must be equal"))
            KASE1 = Array{BlasInt,1}(undef,1)
            KASE1[1] = KASE
            EST1 = Vector{$elty}(undef, 1)
            EST1[1] = EST
            ccall((@blasfunc($fn), liblapack), Cvoid,
                (Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ptr{BlasInt},
                Ptr{$elty}, Ptr{BlasInt}, Ptr{BlasInt}),
                n, V, X, ISGN, EST1, KASE1, ISAVE)
            return EST1[1], KASE1[1]
        end
    end
end
"""
    lacn2!(V, X, ISGN, EST, KASE, ISAVE ) -> (EST, KASE )
Estimate the 1-norm of a `real` linear operator `A`, using reverse communication
by applying the operator or its transpose/adjoint to a vector.
`KASE` is a parameter to control the norm evaluation process as follows.
On the initial call, `KASE` should be `0`. On an intermediate return,
`KASE` will be `1` or `2`, indicating whether the `real` vector `X` should be overwritten
by `A * X`  or `A' * X` at the next call.
On the final return, `KASE` will again be `0` and `EST` is an estimate (a lower bound)
for the 1-norm of `A`. `V` is a real work vector, `ISGN` is an integer work
vector and `ISAVE` is a 3-dimensional integer vector used to save information
between the calls.
Interface to the LAPACK subroutines DLACN2/SLACN2.
"""
lacn2!(V::AbstractVector{BlasReal}, X::AbstractVector{BlasReal}, ISGN::AbstractVector{BlasInt}, EST::BlasReal, KASE::BlasInt, ISAVE::AbstractVector{BlasInt})


for (fn, elty, relty) in ((:zlacn2_, :ComplexF64, :Float64),
                          (:clacn2_, :ComplexF32, :Float32))
    @eval begin
        function lacn2!(V::AbstractVector{$elty}, X::AbstractVector{$elty},
                        EST::$relty, KASE::BlasInt, ISAVE::AbstractVector{BlasInt})
            """
            *       SUBROUTINE ZLACN2( N, V, X, EST, KASE, ISAVE )
            *
            *       .. Scalar Arguments ..
            *       INTEGER            KASE, N
            *       DOUBLE PRECISION   EST
            *       ..
            *       .. Array Arguments ..
            *       INTEGER            ISGN( * ), ISAVE( 3 )
            *       COMPLEX*16         V( * ), X( * )
            """
            @assert !has_offset_axes(V, X)
            chkstride1(V,X)
            n = length(V)
            n == length(X) || throw(DimensionMismatch("dimensions of V and X must be equal"))
            KASE1 = Array{BlasInt,1}(undef,1)
            KASE1[1] = KASE
            EST1 = Vector{$relty}(undef, 1)
            EST1[1] = EST
            ccall((@blasfunc($fn), liblapack), Cvoid,
                (Ref{BlasInt}, Ptr{$elty}, Ptr{$elty},
                Ptr{$relty}, Ptr{BlasInt}, Ptr{BlasInt}),
                n, V, X, EST1, KASE1, ISAVE)
            return EST1[1], KASE1[1]
        end
    end
end
"""
    lacn2!(V, X, EST, KASE, ISAVE ) -> (EST, KASE )
Estimate the 1-norm of a `complex` linear operator `A`, using reverse communication
by applying the operator or its adjoint to a vector.
`KASE` is a parameter to control the norm evaluation process as follows.
On the initial call, `KASE` should be `0`. On an intermediate return,
`KASE` will be `1` or `2`, indicating whether the `complex` vector `X` should be overwritten
by `A * X`  or `A' * X` at the next call.
On the final return, `KASE` will again be `0` and `EST` is an estimate (a lower bound)
for the 1-norm of `A`. `V` is a complex work vector and `ISAVE` is a 3-dimensional
integer vector used to save information between the calls.
Interface to the LAPACK subroutines ZLACN2/CLACN2.
"""
lacn2!(V::AbstractVector{BlasComplex}, X::AbstractVector{BlasComplex}, EST::BlasReal, KASE::BlasInt, ISAVE::AbstractVector{BlasInt})

end

"""
    X = sylvckr(A,B,C)

Solve the continuous Sylvester matrix equation

                AX + XB = C

using the Kronecker product expansion of equations. `A` and `B` are
square matrices, and `A` and `-B` must not have common eigenvalues.
This function is not recommended for large order matrices.
"""
function sylvckr(A, B, C)
    m, n = size(C)
    [m; n] == LinearAlgebra.checksquare(A, B) ||
             throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    reshape((kron(Array{eltype(A),2}(I, n, n), A) +
            kron(transpose(B), Array{eltype(B),2}(I, m, m))) \ (C[:]),m,n)
end

"""
    X = sylvdkr(A,B,C)

Solve the discrete Sylvester matrix equation

                AXB + X = C

using the Kronecker product expansion of equations. `A` and `B` are
square matrices, and `A` and `-B` must not have common reciprocal eigenvalues.
This function is not recommended for large order matrices.
"""
function sylvdkr(A, B, C)
    m, n = size(C)
    [m; n] == LinearAlgebra.checksquare(A, B) ||
            throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    reshape((kron(transpose(B), A) + I) \ (C[:]), m, n)
end

"""
    X = gsylvkr(A,B,C,D,E)

Solve the generalized Sylvester matrix equation

                AXB + CXD = E

using the Kronecker product expansion of equations. `A`, `B`, `C` and `D` are
square matrices. The pencils `A-λC` and `D+λB` must be regular and
must not have common eigenvalues.
This function is not recommended for large order matrices.
"""
function gsylvkr(A, B, C, D, E)
   m, n = size(E)
   [m; n; m; n] == LinearAlgebra.checksquare(A, B, C, D) ||
                  throw(DimensionMismatch("A, B, C, D and E have incompatible dimensions"))
   reshape((kron(transpose(B), A) + kron(transpose(D), C)) \ (E[:]), m, n)
end

"""
    sylvsyskr(A,B,C,D,E,F) -> (X,Y)

Solve the Sylvester system of matrix equations

                AX + YB = C
                DX + YE = F

using the Kronecker product expansion of equations. `(A,D)`, `(B,E)` are
pairs of square matrices of the same size.
The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues.
This function is not recommended for large order matrices.
"""
function sylvsyskr(A, B, C, D, E, F)
   m, n = size(C)
   (m == size(F, 1) && n == size(F, 2)) ||
         throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A, B, D, E) ||
                  throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))
   z = [ kron(Array{eltype(A),2}(I, n, n), A) kron(transpose(B), Array{eltype(B),2}(I, m, m)) ;
         kron(Array{eltype(D),2}(I, n, n), D) kron(transpose(E), Array{eltype(E),2}(I, m, m))] \ [C[:];F[:]]
   (reshape(z[1:m * n], m, n), reshape(z[m * n + 1:end], m, n))
end

"""
    dsylvsyskr(A,B,C,D,E,F) -> (X,Y)

Solve the dual Sylvester system of matrix equations

       AX + DY = C
       XB + YE = F

using the Kronecker product expansion of equations. `(A,D)`, `(B,E)` are
pairs of square matrices of the same size.
The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues.
This function is not recommended for large order matrices.
"""
function dsylvsyskr(A, B, C, D, E, F)
   m, n = size(C)
   (m == size(F, 1) && n == size(F, 2)) ||
         throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A, B, D, E) ||
                  throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))
   z = [ kron(Array{eltype(A),2}(I, n, n), A) kron(Array{eltype(D),2}(I, n, n), D);
         kron(transpose(B), Array{eltype(B),2}(I, m, m)) kron(transpose(E), Array{eltype(E),2}(I, m, m))] \ [C[:];F[:]]
   (reshape(z[1:m * n], m, n), reshape(z[m * n + 1:end], m, n))
end
"""
    X = tlyapckr(A,C, isig = 1; atol::Real=0, rtol::Real=atol>0 ? 0 : N*ϵ)

Compute for `isig = ±1` a solution of the the continuous T-Lyapunov matrix equation

                A*X + isig*transpose(X)*transpose(A) + C = 0

using the Kronecker product expansion of equations. `A` and `C` are
`m×n` and `m×m` matrices, respectively, and `X` is an `n×m` matrix.
The matrix `C` must be symmetric if `isig = 1` and skew-symmetric if `isig = -1`.
`atol` and `rtol` are the absolute and relative tolerances, respectively, used for rank computation. 
The default relative tolerance is `N*ϵ`,
  where `N = 4*min(m,n)^2` and ϵ is the machine precision of the element type of `A`.
This function is not recommended for large order matrices.
"""
function tlyapckr(A, C, isig = 1; atol::Real = 0.0, rtol::Real = (4*min(size(A)...)^2*eps(real(float(one(eltype(A))))))*iszero(atol))
    m = LinearAlgebra.checksquare(C)
    ma, n = size(A)
    ma == m || throw(DimensionMismatch("A and C have incompatible dimensions"))
    abs(isig) == 1 || error(" isig must be either 1 or -1")
    if isig == 1
       T1 =  eltype(C)
       if T1 <: BlasFloat ||  T1 <: BigFloat
          issymmetric(C) || error("C must be symmetric for isig = 1")
       else
          # alternative test to overcome issue #168 in DoubleFloats
          iszero(C-transpose(C)) || error("C must be symmetric for isig = 1")   
       end       
    else
       iszero(C+transpose(C)) || error("C must be skew-symmetric for isig = -1")
    end
    it = [(i-1)*n+j for i in 1:m, j in 1:n][:]    
    T =  kron(Array{eltype(A),2}(I, m, m), A) + isig*kron(A, Array{eltype(A),2}(I, m, m))[:,invperm(it)]  
    mn = m*n
    m > n ? F = svd(T,full = true) : F = svd(T)
    tol = max(atol, rtol*F.S[1])
    r = count(x -> x > tol, F.S)
    Xe = F.U'*C[:]
    norm(view(Xe,r+1:m*m),Inf) <= tol || @warn "Incompatible equation: least-squares solution computed"
    Xe[1:r] ./= F.S[1:r]
    reshape(view(F.Vt,1:r,1:mn)'*view(Xe,1:r),n,m)
end
"""
    X = hlyapckr(A,C, isig = 1; atol::Real=0, rtol::Real=atol>0 ? 0 : N*ϵ)

Compute for `isig = ±1` a solution of the continuous H-Lyapunov matrix equation

                A*X + isig*adjoint(X)*adjoint(A) + C = 0

using the Kronecker product expansion of equations. `A` and `C` are
`m×n` and `m×m` matrices, respectively, and `X` is an `n×m` matrix.
The matrix `C` must be hermitian if `isig = 1` and skew-hermitian if `isig = -1`.
`atol` and `rtol` are the absolute and relative tolerances, respectively, used for rank computation. 
The default relative tolerance is `N*ϵ`,
  where `N = 4*min(m,n)^2` and ϵ is the machine precision of the element type of `A`.
This function is not recommended for large order matrices.
"""
function hlyapckr(A, C, isig = 1; atol::Real = 0.0, rtol::Real = (4*min(size(A)...)^2*eps(real(float(one(eltype(A))))))*iszero(atol))
    promote_type(eltype(A),eltype(C)) <: Real && (return tlyapckr(A, C; atol, rtol))
    m = LinearAlgebra.checksquare(C)
    ma, n = size(A)
    ma == m || throw(DimensionMismatch("A and C have incompatible dimensions"))
    abs(isig) == 1 || error(" isig must be either 1 or -1")
    if isig == 1
       ishermitian(C) || error("C must be symmetric for isig = 1")
    else
       iszero(C+adjoint(C)) || error("C must be skew-hermitian for isig = -1")
    end
    Ae = [real(A) imag(A); -imag(A) real(A)]     
    Ce = [real(C) imag(C); -imag(C) real(C)] 
    Xe = tlyapckr(Ae, Ce, isig; atol, rtol)   
    i1 = 1:n; i2 = n+1:2n; j1 = 1:m; j2 = m+1:2m
    (Xe[i1,j1] ≈ Xe[i2,j2] && Xe[i2,j1] ≈ -Xe[i1,j2]) || @warn "Solution possibly inaccurate"
    return complex.((Xe[i1,j1]+Xe[i2,j2])/2,(Xe[i1,j2]-Xe[i2,j1])/2)
end
"""
    X = tsylvckr(A,B,C; atol::Real=0, rtol::Real=atol>0 ? 0 : N*ϵ)

Compute a solution of the continuous T-Sylvester matrix equation

                A*X + transpose(X)*B = C

using the Kronecker product expansion of equations. `A`, `B` and `C` are
`m×n`, `n×m` and `m×m` matrices, respectively, and `X` is an `n×m` matrix.
`atol` and `rtol` are the absolute and relative tolerances, respectively, used for rank computation. 
The default relative tolerance is `N*ϵ`,
  where `N = 4*min(m,n)^2` and ϵ is the machine precision of the element type of `A`.
This function is not recommended for large order matrices.
"""
function tsylvckr(A, B, C; atol::Real = 0.0, rtol::Real = (4*min(size(A)...)^2*eps(real(float(one(eltype(A))))))*iszero(atol))
    m = LinearAlgebra.checksquare(C)
    ma, na = size(A)
    n, mb = size(B)
    (ma == m && na == n && mb == m) ||
             throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    it = [(i-1)*n+j for i in 1:m, j in 1:n][:]    
    T =  kron(Array{eltype(A),2}(I, m, m), A) + kron(transpose(B), Array{eltype(B),2}(I, m, m))[:,invperm(it)]  
    F = svd(T)
    tol = max(atol, rtol*F.S[1])
    r = count(x -> x > tol, F.S)
    Xe = F.U'*C[:]
    Xe[1:r] ./= F.S[1:r]
    reshape(F.Vt'*Xe,n,m)
end
"""
    X = hsylvckr(A,B,C; atol::Real=0, rtol::Real=atol>0 ? 0 : N*ϵ)

Compute a solution of the continuous H-Sylvester matrix equation

                A*X + adjoint(X)*B = C

using the Kronecker product expansion of equations. `A`, `B` and `C` are
`m×n`, `n×m` and `m×m` matrices, respectively, and `X` is an `n×m` matrix.
`atol` and `rtol` are the absolute and relative tolerances, respectively, used for rank computation. 
The default relative tolerance is `N*ϵ`,
  where `N = 4*min(m,n)^2` and ϵ is the machine precision of the element type of `A`.
This function is not recommended for large order matrices.
"""
function hsylvckr(A, B, C; atol::Real = 0.0, rtol::Real = (4*min(size(A)...)*min(size(B)...)*eps(real(float(one(eltype(A))))))*iszero(atol))
    promote_type(eltype(A),eltype(B),eltype(C)) <: Real && (return tsylvckr(A, B, C; atol, rtol))
    m = LinearAlgebra.checksquare(C)
    ma, na = size(A)
    n, mb = size(B)
    (ma == m && na == n && mb == m) ||
             throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    Ae = [real(A) imag(A); -imag(A) real(A)]     
    Be = [real(B) imag(B); -imag(B) real(B)] 
    Ce = [real(C) imag(C); -imag(C) real(C)] 
    Xe = tsylvckr(Ae,Be,Ce; atol, rtol)   
    i1 = 1:n; i2 = n+1:2n; j1 = 1:m; j2 = m+1:2m
    (Xe[i1,j1] ≈ Xe[i2,j2] && Xe[i2,j1] ≈ -Xe[i1,j2]) || @warn "Solution possibly inaccurate"
    return complex.((Xe[i1,j1]+Xe[i2,j2])/2,(Xe[i1,j2]-Xe[i2,j1])/2)
end
"""
    X = csylvckr(A,B,C)

Solve the continuous C-Sylvester matrix equation

                A*X + conj(X)*B = C

using the Kronecker product expansion of equations. `A`, `B` and `C` are
`m×m`, `n×n` and `m×n` matrices, respectively, and `X` is an `m×n` matrix.
This function is not recommended for large order matrices.
"""
function csylvckr(A, B, C)
    promote_type(eltype(A),eltype(B),eltype(C)) <: Real && (return sylvckr(A, B, C))
    m, n = size(C)
    [m; n] == LinearAlgebra.checksquare(A, B) ||
             throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    Ae = [real(A) imag(A); imag(A) -real(A)]     
    Be = [real(B) imag(B); imag(B) -real(B)] 
    Ce = [real(C) imag(C); imag(C) -real(C)] 
    m2 = 2m; n2 = 2n
    Xe = reshape((kron(Array{real(eltype(A)),2}(I, n2, n2), Ae) +
                  kron(transpose(Be), Array{real(eltype(B)),2}(I, m2, m2))) \ (Ce[:]),m2,n2)
    i1 = 1:m; i2 = m+1:m2; j1 = 1:n; j2 = n+1:n2
    (Xe[i1,j1] ≈ Xe[i2,j2] && Xe[i2,j1] ≈ -Xe[i1,j2]) || @warn "Solution possibly inaccurate"              
    return complex.((Xe[i1,j1]+Xe[i2,j2])/2,(Xe[i1,j2]-Xe[i2,j1])/2)
end

"""
    X = tsylvdkr(A,B,C)

Solve the discrete T-Sylvester matrix equation

                A*transpose(X)*B + X = C

using the Kronecker product expansion of equations. `A`, `B` and `C` are
`m×n` matrices and `X` is an `m×n` matrix.
This function is not recommended for large order matrices.
"""
function tsylvdkr(A, B, C)
    m, n = size(C)
    ma, na = size(A)
    mb, nb = size(B)
    (ma == m && na == n && mb == m && nb == n) ||
             throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    it = [(i-1)*m+j for i in 1:n, j in 1:m][:]   
    reshape((kron(transpose(B), A)[:,invperm(it)] + I) \ (C[:]), m, n)
end
"""
    X = hsylvdkr(A,B,C)

Solve the discrete H-Sylvester matrix equation

                A*adjoint(X)*B + X = C

using the Kronecker product expansion of equations. `A`, `B` and `C` are
`m×n` matrices and `X` is an `m×n` matrix.
This function is not recommended for large order matrices.
"""
function hsylvdkr(A, B, C)
    promote_type(eltype(A),eltype(B),eltype(C)) <: Real && (return tsylvdkr(A, B, C))
    m, n = size(C)
    ma, na = size(A)
    mb, nb = size(B)
    (ma == m && na == n && mb == m && nb == n) ||
             throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    Ae = [real(A) imag(A); imag(A) -real(A)]     
    Be = [real(B) imag(B); imag(B) -real(B)] 
    Ce = [real(C) imag(C); imag(C) -real(C)] 
    m2 = 2m; n2 = 2n
    it = [(i-1)*m2+j for i in 1:n2, j in 1:m2][:]   
    Ye = reshape((kron(transpose(Be), Ae)[:,invperm(it)] + I) \ (Ce[:]), m2, n2)
    return complex.((Ye[1:m,1:n]-Ye[m+1:m2,n+1:n2])/2,(Ye[1:m,n+1:n2]+Ye[m+1:m2,1:n])/2)
end


"""
    X = csylvdkr(A,B,C)

Solve the discrete C-Sylvester matrix equation

                A*conj(X)*B + X = C

using the Kronecker product expansion of equations. `A`, `B` and `C` are
`m×m`, `n×n` and `m×n` matrices, respectively, and `X` is an `m×n` matrix.
This function is not recommended for large order matrices.
"""
function csylvdkr(A, B, C)
    promote_type(eltype(A),eltype(B),eltype(C)) <: Real && (return sylvdkr(A, B, C))
    m, n = size(C)
    [m; n] == LinearAlgebra.checksquare(A, B) ||
             throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    Ae = [real(A) imag(A); imag(A) -real(A)]     
    Be = [real(B) imag(B); imag(B) -real(B)] 
    Ce = [real(C) imag(C); imag(C) -real(C)] 
    m2 = 2m; n2 = 2n
    Xe = reshape((kron(transpose(Be), Ae) + I) \ (Ce[:]), m2, n2)
    i1 = 1:m; i2 = m+1:m2; j1 = 1:n; j2 = n+1:n2
    (Xe[i1,j1] ≈ -Xe[i2,j2] && Xe[i2,j1] ≈ Xe[i1,j2]) || @warn "Solution possibly inaccurate"              
    return complex.((Xe[i1,j1]-Xe[i2,j2])/2,(Xe[i1,j2]+Xe[i2,j1])/2)
end

"""
    X = sylvc(A,B,C; blocksize = 64)

Solve the continuous Sylvester matrix equation

                AX + XB = C

combusing recursive-blocking ined with explicit loop tiling techniques. 
The underlying core algorithm is the Bartels-Stewart Schur form based approach. `A` and `B` are
square matrices, and `A` and `-B` must not have common eigenvalues.

The keyword argument `blocksize` (default: `blocksize = 64`) specifies the 
block size when to switch in the employed recursive blocked algorithm 
to the core algorithm for solving small-sized matrix equations. 
If `blocksize ≤ 4`, the minimum value `blocksize = 4` is used.
Note: This option is only effective for data of types `Float64`, `Float32`, 
      `ComplexF64`, or `ComplexF32`.


The following particular cases are also adressed:

    X = sylvc(α*I,B,C)  or  X = sylvc(α,B,C)

Solve the matrix equation `X(αI+B)  = C`.

    X = sylvc(A,β*I,C)  or  X = sylvc(A,β,C)

Solve the matrix equation `(A+βI)X = C`.

    X = sylvc(α*I,β*I,C)  or  sylvc(α,β,C)

Solve the matrix equation `(α+β)X = C`.

    x = sylvc(α,β,γ)

Solve the equation `(α+β)x = γ`.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> B = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> C = [-1. -2.; 2. -1.]
2×2 Array{Float64,2}:
 -1.0  -2.0
  2.0  -1.0

julia> X = sylvc(A, B, C)
2×2 Array{Float64,2}:
 -4.46667   1.93333
  3.73333  -1.8

julia> A*X + X*B - C
2×2 Array{Float64,2}:
  2.66454e-15  1.77636e-15
 -3.77476e-15  4.44089e-16
```
"""
function sylvc(A::AbstractMatrix,B::AbstractMatrix,C::AbstractMatrix; blocksize = 64)
   """
   The Bartels-Steward Schur form based method in [1] is employed for matrix dimensions not exceeding
   the specified blocksize. For large dimensions, the recursive blocked algorithm in [2] is used.
   The iterative blocking based algorithm of [3] is used for matrix dimensions not exceeding `blocksize`. 
   Blocking is employed only for `BlasFloat` type data.  

   Reference:
   [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
       Comm. ACM, 15:820–826, 1972.

   [2] I. Jonsson and B. Kågström, Recursive blocked algorithms for solving triangular systems—
       Part I: One-sided and coupled Sylvester-type matrix equations, ACM Trans. Math. Software, 
       28 (2002), pp. 392–415.

   [3] A. Schwarz and C. C. Kjelgaard Mikkelsen, Robust task-parallel solution of the triangular 
       Sylvester equation. Lecture Notes in Computer Science, vol 12043, pp. 82-92, Springer, 2020.    
   """

   m, n = size(C);
   [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))

   T2 = promote_type(eltype(A), eltype(B), eltype(C))
   T2 <: BlasFloat || (T2 = promote_type(Float64,T2))

   eltype(A) == T2 || (A = convert(AbstractMatrix{T2},A))
   eltype(B) == T2 || (B = convert(AbstractMatrix{T2},B))
   eltype(C) == T2 || (C = convert(AbstractMatrix{T2},C))

   if isdiag(A) && isdiag(B)
      return sylvcs!(A, B, copy(C))
   end

   adjA = isa(A,Adjoint)
   adjB = isa(B,Adjoint)
   if ishermitian(A) && ishermitian(B)
      RA, QA = schur(Hermitian(A))
      RB, QB = schur(Hermitian(B))
   else
      if adjA
         RA, QA = schur(A.parent)
      else
         RA, QA = schur(A)
      end
      if adjB
         RB, QB = schur(B.parent)
      else
         RB, QB = schur(B)
      end
   end

   #Y = QA' * C * QB
   WS = Matrix{T2}(undef,m,n)
   Y = Matrix{T2}(undef,m,n)
   mul!(WS,QA',C)
   mul!(Y,WS,QB) 


   if T2 <: BlasFloat
      sylvcs_blocked!(RA, RB, Y; adjA, adjB, blocksize)
   else
      sylvcs!(RA, RB, Y; adjA, adjB)
   end

   #mul!(Y, QA, Y*QB')
   mul!(WS,Y,QB')
   mul!(Y,QA, WS)

   return Y
end
# solve X(B+α) = C or (α+β)X = C
sylvc(A::Union{Real,Complex,UniformScaling},B::Union{AbstractMatrix,UniformScaling},C::AbstractMatrix) = C/(A*I+B)
# solve (A+β)X = C
sylvc(A::AbstractMatrix,B::Union{Real,Complex,UniformScaling},C::AbstractMatrix) = (A+B*I)\C
# solve (α+β)X = C
sylvc(A::Union{Real,Complex},B::Union{Real,Complex},C::AbstractMatrix) = A+B == 0 ? throw("ME:SingularException: A and -B have common eigenvalues") : C/(A+B)
# solve (α+β)x = γ
sylvc(A::Union{Real,Complex}, B::Union{Real,Complex}, C::Union{Real,Complex}) = A+B == 0 ? throw("ME:SingularException: A and -B have common eigenvalues") : C/(A+B)
"""
    X = sylvd(A,B,C; blocksize = 64)

Solve the discrete Sylvester matrix equation

                AXB + X = C

using using recursive-blocking in combination with an extension of the Bartels-Stewart 
Schur form based approach. `A` and `B` are square matrices, and `A` and `-B` must not have
common reciprocal eigenvalues.

The keyword argument `blocksize` (default: `blocksize = 64`) specifies the 
block size when to switch in the employed recursive blocked algorithm 
to the core algorithm for solving small-sized matrix equations. 
If `blocksize ≤ 4`, the minimum value `blocksize = 4` is used.
Note: This option is only effective for data of types `Float64`, `Float32`, 
      `ComplexF64`, or `ComplexF32`.


The following particular cases are also adressed:

    X = sylvd(α*I,B,C)  or  X = sylvd(α,B,C)

Solve the matrix equation `X(αB+I)  = C`.

    X = sylvd(A,β*I,C)   or  X = sylvd(A,β,C)

Solve the matrix equation `(βA+I)X = C`.

    X = sylvd(α*I,β*I,C)  or  X = sylvd(α,β,C)

Solve the matrix equation `(αβ+1)X = C`.

    x = sylvd(α,β,γ)

Solve the equation `(αβ+1)x = γ`.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> B = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> C = [-1. -2.; 2. -1.]
2×2 Array{Float64,2}:
 -1.0  -2.0
  2.0  -1.0

julia> X = sylvd(A, B, C)
2×2 Array{Float64,2}:
 -2.46667  -2.73333
  2.4       1.86667

julia> A*X*B + X - C
2×2 Array{Float64,2}:
  8.88178e-16   8.88178e-16
 -3.9968e-15   -5.55112e-15
```
"""
function sylvd(A::AbstractMatrix,B::AbstractMatrix,C::AbstractMatrix; blocksize = 64)
   """
   An extension of the Bartels-Steward Schur form based method in [1] is employed for matrix dimensions not exceeding
   the specified blocksize. For large dimensions, the recursive blocked algorithm in [2] is used.
   The iterative blocking based algorithm of [3] is used for matrix dimensions not exceeding `blocksize`. 
   Blocking is employed only for `BlasFloat` type data.  

   Reference:
   [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
       Comm. ACM, 15:820–826, 1972.

   [2] I. Jonsson and B. Kågström, Recursive blocked algorithms for solving triangular systems — 
       Part II: Two-sided and generalized Sylvester and Lyapunov matrix equations, 
       ACM Trans. Math. Software, 28 (2002), pp. 416–435.
  """

   m, n = size(C);
   [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
   T2 = promote_type(eltype(A), eltype(B), eltype(C))
   T2 <: BlasFloat || (T2 = promote_type(Float64,T2))
   eltype(A) == T2 || (A = convert(Matrix{T2},A))
   eltype(B) == T2 || (B = convert(Matrix{T2},B))
   eltype(C) == T2 || (C = convert(Matrix{T2},C))

   if isdiag(A) && isdiag(B)
      return sylvds!(A, B, copy(C))
   end

   adjA = isa(A,Adjoint)
   adjB = isa(B,Adjoint)
   if ishermitian(A) && ishermitian(B)
      RA, QA = schur(Hermitian(A))
      RB, QB = schur(Hermitian(B))
   else
      if adjA
         RA, QA = schur(A.parent)
      else
         RA, QA = schur(A)
      end
      if adjB
         RB, QB = schur(B.parent)
      else
         RB, QB = schur(B)
      end
   end

   # Y = QA' * C * QB
   WS = Matrix{T2}(undef,m,n)
   Y = Matrix{T2}(undef,m,n)
   mul!(WS,QA',C)
   mul!(Y,WS,QB) 

   if T2 <: BlasFloat
      sylvds_blocked!(RA, RB, Y; adjA, adjB, blocksize)
   else
      sylvds!(RA, RB, Y; adjA, adjB)
   end

   # mul!(Y, QA, Y*QB')
   mul!(WS,Y,QB')
   mul!(Y,QA, WS)

   return Y
end
# solve X(αB+I) = C or X(αβ+1) = C
sylvd(A::Union{Real,Complex,UniformScaling},B::Union{AbstractMatrix,UniformScaling},C::AbstractMatrix) = C/(A*B+I)
# solve (Aβ+I)X = C
sylvd(A::AbstractMatrix,B::Union{Real,Complex,UniformScaling},C::AbstractMatrix) = (A*B+I)\C
# solve (αβ+1)X = C
sylvd(A::Union{Real,Complex},B::Union{Real,Complex},C::AbstractMatrix) = A*B+1 == 0 ? throw(SingularException(1)) : C/(A*B+1)
# solve (αβ+1)x = γ
sylvd(A::Union{Real,Complex}, B::Union{Real,Complex}, C::Union{Real,Complex}) = A*B+1 == 0 ? throw(SingularException(1)) : C/(A*B+one(C))
"""
    X = gsylv(A,B,C,D,E)

Solve the generalized Sylvester matrix equation

              AXB + CXD = E

using a generalized Schur form based approach. `A`, `B`, `C` and `D` are
square matrices. The pencils `A-λC` and `D+λB` must be regular and
must not have common eigenvalues.

The following particular cases are also adressed:

    X = gsylv(A,B,E)

Solve the generalized Sylvester matrix equation `AXB  = E`.

    X = gsylv(A,B,γ*I,E)  or  X = gsylv(A,B,γ,E)

Solve the generalized Sylvester matrix equation `AXB +γX = E`.

    X = gsylv(A,B,γ*I,D,E)  or  X = gsylv(A,B,γ,D,E)

Solve the generalized Sylvester matrix equation `AXB +γXD = E`.

    X = gsylv(A,B,C,δ*I,E)  or  X = gsylv(A,B,C,δ,E)

Solve the generalized Sylvester matrix equation `AXB +CXδ = E`.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> B = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> C = [-1. -2.; 2. -1.]
2×2 Array{Float64,2}:
 -1.0  -2.0
  2.0  -1.0

julia> D = [1. -2.; -2. -1.]
2×2 Array{Float64,2}:
  1.0  -2.0
 -2.0  -1.0

julia> E = [1. -1.; -2. 2.]
2×2 Array{Float64,2}:
  1.0  -1.0
 -2.0   2.0

julia> X = gsylv(A, B, C, D, E)
2×2 Array{Float64,2}:
 -0.52094   -0.0275792
 -0.168539   0.314607

julia> A*X*B + C*X*D - E
2×2 Array{Float64,2}:
 4.44089e-16  8.88178e-16
 6.66134e-16  0.0
```
"""
function gsylv(A::AbstractMatrix,B::AbstractMatrix,C::AbstractMatrix,D::AbstractMatrix,E::AbstractMatrix)

   m, n = size(E);
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,C,D) ||
   throw(DimensionMismatch("A, B, C, D and E have incompatible dimensions"))
   T2 = promote_type(eltype(A), eltype(B), eltype(C), eltype(D), eltype(E))
   T2 <: BlasFloat || (T2 = promote_type(Float64,T2))

   eltype(A) == T2 || (A = convert(Matrix{T2},A))
   eltype(B) == T2 || (B = convert(Matrix{T2},B))
   eltype(C) == T2 || (C = convert(Matrix{T2},C))
   eltype(D) == T2 || (D = convert(Matrix{T2},D))
   eltype(E) == T2 || (E = convert(Matrix{T2},E))

   adjA = isa(A,Adjoint)
   adjB = isa(B,Adjoint)
   adjC = isa(C,Adjoint)
   adjD = isa(D,Adjoint)
   adjAC = adjA && adjC
   adjBD = adjB && adjD

   if adjAC
      AS, CS, Z1, Q1 = schur(A.parent,C.parent)
   else
      adjA && (A = copy(A))
      adjC && (C = copy(C))
      AS, CS, Q1, Z1 = schur(A,C)
   end
   if adjBD
      BS, DS, Z2, Q2 = schur(B.parent,D.parent)
   else
      adjB && (B = copy(B))
      adjD && (D = copy(D))
      BS, DS, Q2, Z2 = schur(B,D)
   end

   Y = Q1' * E *Z2

   gsylvs!(AS, BS, CS, DS, Y, adjAC = adjAC, adjBD = adjBD)

   mul!(Y, Z1, Y*Q2')

   return Y
end
# solve AXB = C
gsylv(A::Union{AbstractMatrix,UniformScaling,Real,Complex},B::Union{AbstractMatrix,UniformScaling,Real,Complex},E::AbstractMatrix) = (A\E)/B
# solve AXB+γX = E
gsylv(A::AbstractMatrix,B::AbstractMatrix,C::Union{UniformScaling,Real,Complex},E::AbstractMatrix) =
size(A,1) == size(A,2) && size(B,1) == size(B,2) ? gsylv(A,B,Matrix{eltype(C)}(C*I,size(A)),Matrix{eltype(C)}(I,size(B)),E) :
throw(DimensionMismatch("A and B must be square matrices"))
# solve AXB+γXδ = E
gsylv(A::AbstractMatrix,B::AbstractMatrix,C::Union{UniformScaling,Real,Complex},D::Union{UniformScaling,Real,Complex},E::AbstractMatrix) = gsylv(A,B,C*D,E)
# solve AXB+γXD = E
gsylv(A::AbstractMatrix,B::AbstractMatrix,C::Union{UniformScaling,Real,Complex},D::AbstractMatrix,E::AbstractMatrix) =
size(A,1) == size(A,2) ? gsylv(A,B,Matrix{eltype(C)}(C*I,size(A)),D,E) :
throw(DimensionMismatch("A must be a square matrix"))
# solve AXB+CXδ = E
gsylv(A::AbstractMatrix,B::AbstractMatrix,C::AbstractMatrix,D::Union{UniformScaling,Real,Complex},E::AbstractMatrix) =
size(B,1) == size(B,2) ? gsylv(A,B,C,Matrix{eltype(D)}(D*I,size(B)),E) :
throw(DimensionMismatch("B must be a square matrix"))

"""
    (X,Y) = sylvsys(A,B,C,D,E,F)

Solve the Sylvester system of matrix equations

                AX + YB = C
                DX + YE = F,

where `(A,D)`, `(B,E)` are pairs of square matrices of the same size.
The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> B = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> C = [-1. -2.; 2. -1.]
2×2 Array{Float64,2}:
 -1.0  -2.0
  2.0  -1.0

julia> D = [1. -2.; -2. -1.]
2×2 Array{Float64,2}:
  1.0  -2.0
 -2.0  -1.0

julia> E = [1. -1.; -2. 2.]
2×2 Array{Float64,2}:
  1.0  -1.0
 -2.0   2.0

julia> F = [1. -1.; -2. 2.]
2×2 Array{Float64,2}:
  1.0  -1.0
 -2.0   2.0

julia> X, Y = sylvsys(A, B, C, D, E, F);

julia> X
2×2 Array{Float64,2}:
  1.388  -1.388
 -0.892   0.892

julia> Y
2×2 Array{Float64,2}:
 -1.788  0.192
  0.236  0.176

julia> A*X + Y*B - C
2×2 Array{Float64,2}:
  6.66134e-16  2.22045e-15
 -3.10862e-15  2.66454e-15

julia> D*X + Y*E - F
2×2 Array{Float64,2}:
  1.33227e-15  -2.22045e-15
 -4.44089e-16   4.44089e-16
```
"""
function sylvsys(A::AbstractMatrix,B::AbstractMatrix,C::AbstractMatrix,D::AbstractMatrix,E::AbstractMatrix,F::AbstractMatrix)

   m, n = size(C);
   (m == size(F,1) && n == size(F,2)) ||
      throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,D,E) ||
       throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))
   T2 = promote_type(eltype(A), eltype(B), eltype(C), eltype(D), eltype(E), eltype(F))
   T2 <: BlasFloat || (T2 = promote_type(Float64,T2))

   eltype(A) == T2 || (A = convert(Matrix{T2},A))
   eltype(B) == T2 || (B = convert(Matrix{T2},B))
   eltype(C) == T2 || (C = convert(Matrix{T2},C))
   eltype(D) == T2 || (D = convert(Matrix{T2},D))
   eltype(E) == T2 || (E = convert(Matrix{T2},E))
   eltype(F) == T2 || (F = convert(Matrix{T2},F))

   isa(A,Adjoint) && (A = copy(A))
   isa(B,Adjoint) && (B = copy(B))
   isa(D,Adjoint) && (D = copy(D))
   isa(E,Adjoint) && (E = copy(E))

   AS, DS, Q1, Z1 = schur(A,D)
   BS, ES, Q2, Z2 = schur(B,E)

   CS = adjoint(Q1) * (C*Z2)
   FS = adjoint(Q1) * (F*Z2)

   # if T2 <: BlasFloat 
   #    X, Y, scale =  tgsyl!('N',AS,BS,CS,DS,ES,FS)
   #    return (rmul!(Z1*(X * adjoint(Z2)), inv(scale)), rmul!(Q1*(Y * adjoint(Q2)), inv(-scale)) )
   # else
   #    X, Y =  sylvsyss!(AS,BS,CS,DS,ES,FS)
   #    return Z1*(X * adjoint(Z2)), Q1*(Y * adjoint(Q2))
   # end
   X, Y =  sylvsyss!(AS,BS,CS,DS,ES,FS)
   return Z1*(X * adjoint(Z2)), Q1*(Y * adjoint(Q2))

end
"""
    (X,Y) = dsylvsys(A,B,C,D,E,F)

Solve the dual Sylvester system of matrix equations

       AX + DY = C
       XB + YE = F ,

where `(A,D)`, `(B,E)` are pairs of square matrices of the same size.
The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues.

# Example
```jldoctest
julia> A = [3. 4.; 5. 6.]
2×2 Array{Float64,2}:
 3.0  4.0
 5.0  6.0

julia> B = [1. 1.; 1. 2.]
2×2 Array{Float64,2}:
 1.0  1.0
 1.0  2.0

julia> C = [-1. -2.; 2. -1.]
2×2 Array{Float64,2}:
 -1.0  -2.0
  2.0  -1.0

julia> D = [1. -2.; -2. -1.]
2×2 Array{Float64,2}:
  1.0  -2.0
 -2.0  -1.0

julia> E = [1. -1.; -2. 2.]
2×2 Array{Float64,2}:
  1.0  -1.0
 -2.0   2.0

julia> F = [1. -1.; -2. 2.]
2×2 Array{Float64,2}:
  1.0  -1.0
 -2.0   2.0

julia> X, Y = dsylvsys(A, B, C, D, E, F);

julia> X
2×2 Array{Float64,2}:
  2.472  -1.648
 -1.848   1.232

julia> Y
2×2 Array{Float64,2}:
 -0.496  -0.336
  0.264   0.824

julia> A*X + D*Y - C
2×2 Array{Float64,2}:
  4.44089e-16  0.0
 -3.55271e-15  1.55431e-15

julia> X*B + Y*E - F
2×2 Array{Float64,2}:
 -8.88178e-16   0.0
  8.88178e-16  -4.44089e-16
```
"""
function dsylvsys(A::AbstractMatrix,B::AbstractMatrix,C::AbstractMatrix,D::AbstractMatrix,E::AbstractMatrix,F::AbstractMatrix)

   m, n = size(C);
   (m == size(F,1) && n == size(F,2)) ||
      throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,D,E) ||
       throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))

   T2 = promote_type(eltype(A), eltype(B), eltype(C), eltype(D), eltype(E), eltype(F))
   T2 <: BlasFloat || (T2 = promote_type(Float64,T2))

   eltype(A) == T2 || (A = convert(Matrix{T2},A))
   eltype(B) == T2 || (B = convert(Matrix{T2},B))
   eltype(C) == T2 || (C = convert(Matrix{T2},C))
   eltype(D) == T2 || (D = convert(Matrix{T2},D))
   eltype(E) == T2 || (E = convert(Matrix{T2},E))
   eltype(F) == T2 || (F = convert(Matrix{T2},F))
   realcase = T2 <: AbstractFloat
   transsylv = isa(A,Adjoint) && isa(B,Adjoint) && isa(D,Adjoint) && isa(E,Adjoint)
   realcase ? trans = 'T' : trans = 'C'
   if transsylv
      AS, DS, Q1, Z1 = schur(A.parent,D.parent)
      BS, ES, Q2, Z2 = schur(B.parent,E.parent)
      CS = adjoint(Z1) * (C*Z2)
      FS = adjoint(Q1) * (F*Q2)
      if T2 <: BlasFloat 
         X, Y =  dsylvsyss!(true,AS,BS,CS,DS,ES,FS)
         return Q1*(X * adjoint(Z2)), Q1*(Y * adjoint(Z2))
         #X, Y, scale =  tgsyl!(trans,AS,BS,CS,DS,ES,-FS)
         #return (rmul!(Q1*(X * adjoint(Z2)), inv(scale)), rmul!(Q1*(Y * adjoint(Z2)), inv(scale)) )
      else
         X, Y =  dsylvsyss!(true,AS,BS,CS,DS,ES,FS)
         return Q1*(X * adjoint(Z2)), Q1*(Y * adjoint(Z2))
      end
   else
      if T2 <: BlasFloat 
         AS, DS, Q1, Z1 = schur(copy(A'),copy(D'))
         BS, ES, Q2, Z2 = schur(copy(B'),copy(E'))
         CS = adjoint(Z1) * (C*Z2)
         FS = adjoint(Q1) * (F*Q2)
         X, Y, scale =  tgsyl!(trans,AS,BS,CS,DS,ES,-FS)
         return (rmul!(Q1*(X * adjoint(Z2)), inv(scale)), rmul!(Q1*(Y * adjoint(Z2)), inv(scale)) )
      else
         AS, DS, Q1, Z1 = schur(isa(A,Adjoint) ? copy(A) : A, isa(D,Adjoint) ? copy(D) : D)
         BS, ES, Q2, Z2 = schur(isa(B,Adjoint) ? copy(B) : B, isa(E,Adjoint) ? copy(E) : E)
         CS = adjoint(Q1) * (C*Q2)
         FS = adjoint(Z1) * (F*Z2)
         X, Y =  dsylvsyss!(false,AS,BS,CS,DS,ES,FS)
         return Z1*(X * adjoint(Q2)), Z1*(Y * adjoint(Q2))
      end
   end
end
"""
    sylvcs!(A, B, C; isgn = 1, adjA = false, adjB = false)

Solve the continuous Sylvester matrix equation

                op(A)X + isgn*Xop(B) =  C,

where `op(A) = A` or `op(A) = A'` if `adjA = false` or `adjA = true`, respectively,
and `op(B) = B` or `op(B) = B'` if `adjB = false` or `adjB = true`, respectively, and
`isgn` is an integer such that `abs(isgn)` = 1.
`A` and `B` are square matrices in Schur forms, and `A` and `-isgn*B` must not have
common eigenvalues. `C` contains on output the solution `X`.
"""
function sylvcs!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}; isgn::Int = 1, adjA::Bool = false, adjB::Bool = false) where  T1<:BlasFloat
   """
   This function calls appropriate wrappers to the LAPACK.trsylv! or LAPACK.trsylv3! function, 
   which are based on the Bartels-Stewart Schur form based approach.
   Reference:
   R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
   Comm. ACM, 15:820–826, 1972.
   """
   abs(isgn) == 1 || throw(ArgumentError(" isgn must be 1 or -1; got $isgn"))
   m, n = size(C);
   [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
   if isdiag(A) && isdiag(B)
      if T1 <: Real || (!adjA && !adjB)
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]+isgn*B[j,j])
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      elseif !adjA && adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]+isgn*B[j,j]')
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      elseif adjA && !adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]'+isgn*B[j,j])
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      else
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]'+isgn*B[j,j]')
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      end
      return C[:,:]
   end      
   try
      trans = T1 <: Complex ? 'C' : 'T'
      if VERSION < v"1.12"
         C, scale = LAPACK.trsyl!(adjA ? trans : 'N', adjB ? trans : 'N', A, B, C, isgn)
      else
         C, scale = trsyl3!(adjA ? trans : 'N', adjB ? trans : 'N', A, B, C, isgn)
      end
      rmul!(C, inv(scale))
      return C[:,:]
   catch err
      findfirst("LAPACKException(1)",string(err)) === nothing ? rethrow() :
               throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
   end
end
function sylvcs_blocked!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}; isgn::Int = 1, adjA::Bool = false, adjB::Bool = false, blocksize::Integer) where {T1<:BlasFloat}
   abs(isgn) == 1 || throw(ArgumentError(" isgn must be 1 or -1; got $isgn"))
   m, n = size(C);
   [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
   _sylvcs_blocked!(A, B, C, isgn, adjA, adjB, blocksize)
end
function _sylvcs_blocked!(A, B, C, isgn::Int, adjA::Bool, adjB, blocksize::Integer)
   m = size(A, 1)
   n = size(B, 1)
   if m <= max(blocksize,4) && n <= max(blocksize,4)
      sylvcs!(A, B, C; adjA, adjB, isgn)
   elseif 2*n <= m 
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 

      @views begin
         A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
         C1, C2 = C[ia1,1:n], C[ia2,1:n]
      end
      if adjA 
         # solve A' X + isgn*X B = C or A' X + isgn*X B' = C

         # X1 solver
         _sylvcs_blocked!(A11, B, C1, isgn, adjA, adjB, blocksize)

         # C2 update: C2 = C2 - A12'*X1
         mul!(C2,A12',C1,-1,1)

         # X2 solver
         _sylvcs_blocked!(A22, B, C2, isgn, adjA, adjB, blocksize)
      else 
         # solve A X  + isgn*X B = C or A X  + isgn*X B' = C

         # X22 solver
         _sylvcs_blocked!(A22, B, C2, isgn, adjA, adjB, blocksize)

         # C1 update: C1 = C1 - A12*X2
         mul!(C1,A12,C2,-1,1)

         # X1 solver
         _sylvcs_blocked!(A11, B, C1, isgn, adjA, adjB, blocksize)
      end
   elseif 2*m <= n 
      midn = n ÷ 2
      n1 = B[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n 

      @views begin
         B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
         C1, C2 = C[1:m,ib1], C[1:m,ib2]
      end
      if !adjB
         # solve A X + isgn*X B = C or A' X + isgn*X B = C 

         # X1 solver
         _sylvcs_blocked!(A, B11, C1, isgn, adjA, adjB, blocksize)

         # C2 update: C2 = C2 - isgn*X1*B12
         mul!(C2,C1,B12,-isgn,1)

         # X2 solver
         _sylvcs_blocked!(A, B22, C2, isgn, adjA, adjB, blocksize)

      else
         # solve A X  + isgn*X B' = C or A' X  + isgn*X B' = C 

         # X2 solver
         _sylvcs_blocked!(A, B22, C2, isgn, adjA, adjB, blocksize)

         # C1 update: C1 = C1 - isgn*X2*B12'
         mul!(C1,C2,B12',-isgn,1)

         # X1 solver
         _sylvcs_blocked!(A, B11, C1, isgn, adjA, adjB, blocksize)

      end
   else
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 
      midn = n ÷ 2
      n1 = B[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
         B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
         C11, C12, C21, C22 = C[ia1,ib1], C[ia1,ib2], C[ia2,ib1], C[ia2,ib2]
      end
      if !adjA && !adjB
         # solve A X + isgn*X B = C

         # X21 solver
         _sylvcs_blocked!(A22, B11, C21, isgn, adjA, adjB, blocksize)

         # C11 update: C11 = C11 - A12*X21  
         mul!(C11, A12, C21, -1, 1)

         # X11 solver
         _sylvcs_blocked!(A11, B11, C11, isgn, adjA, adjB, blocksize)

         # C22 update: C22 = C22 - isgn*X21*B12
         mul!(C22, C21, B12, -isgn, 1)

         # X22 solver
         _sylvcs_blocked!(A22, B22, C22, isgn, adjA, adjB, blocksize)

         # C12 update: C12 = C12 - A12*X22 - isgn*X11*B12
         mul!(C12,A12,C22,-1,1)
         mul!(C12,C11,B12,-isgn,1)

         # X12 solver
         _sylvcs_blocked!(A11, B22, C12, isgn, adjA, adjB, blocksize)

      elseif adjA && !adjB
         # solve A' X + isgn*X B = C

         # X11 solver
         _sylvcs_blocked!(A11, B11, C11, isgn, adjA, adjB, blocksize)

         # C12 update: C12 = C12 - isgn*X11*B12
         mul!(C12,C11,B12,-isgn,1)

         # X12 solver
         _sylvcs_blocked!(A11, B22, C12, isgn, adjA, adjB, blocksize)

         # C21 update: C21 = C21 - A12'*X11
         mul!(C21,A12',C11,-1,1)

         # X21 solver
         _sylvcs_blocked!(A22, B11, C21, isgn, adjA, adjB, blocksize)

         # C22 update: C22 = C22 - A12'*X12 - isgn*X21*B12

         # C22 = C22 + A12'*X12
         mul!(C22, A12', C12, -1, 1)
         # C22 = C22 + X21*B12
         mul!(C22, C21, B12, -isgn, 1)

         # X22 solver
         _sylvcs_blocked!(A22, B22, C22, isgn, adjA, adjB, blocksize)
      elseif !adjA && adjB
         # solve A X  + isgn*X B' = C

         # X22 solver
         _sylvcs_blocked!(A22, B22, C22, isgn, adjA, adjB, blocksize)

         # C12 update: C12 = C12 - A12*X22
         mul!(C12,A12,C22,-1,1)

         # X12 solver
         _sylvcs_blocked!(A11, B22, C12, isgn, adjA, adjB, blocksize)

         # C21 update: C21 = C21 - isgn*X22*B12'
         mul!(C21,C22,B12',-isgn,1)

         # X21 solver
         _sylvcs_blocked!(A22, B11, C21, isgn, adjA, adjB, blocksize)

         # C11 update: C11 = C11 - A12*X21 - isgn*X12*B12' 
         # C11 = C11 - A12*X21
         mul!(C11, A12, C21, -1, 1)
         # C11 = C11 - isgn*X12*B12'
         mul!(C11, C12, B12', -isgn, 1) 
 
         # X11 solver
         _sylvcs_blocked!(A11, B11, C11, isgn, adjA, adjB, blocksize)
      else
         # solve A' X + isgn*X B' = C

         # X12 solver
         _sylvcs_blocked!(A11, B22, C12, isgn, adjA, adjB, blocksize)

         # C11 update: C11 = C11 - isgn*X12*B12' 
         mul!(C11, C12, B12', -isgn, 1) 

         # X11 solver
         _sylvcs_blocked!(A11, B11, C11, isgn, adjA, adjB, blocksize)

         # C22 update: C22 = C22 - A12'*X12 
         mul!(C22, A12', C12, -1, 1)

         # X22 solver
         _sylvcs_blocked!(A22, B22, C22, isgn, adjA, adjB, blocksize)

         # C21 update: C21 = C21 - isgn*X22*B12' - A12'*X11
         mul!(C21,C22,B12',-isgn,1)
         mul!(C21,A12',C11,-1,1)

         # X21 solver
         _sylvcs_blocked!(A22, B11, C21, isgn, adjA, adjB, blocksize)
      end
   end   
end

function sylvcs!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}; isgn::Int = 1,
                 adjA::Bool = false, adjB::Bool = false) where T1<:Real
   """
   The Bartels-Stewart Schur form based approach [1] is employed.

   References:
   [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
       Comm. ACM, 15:820–826, 1972.
   """
   abs(isgn) == 1 || throw(ArgumentError(" isgn must be 1 or -1; got $isgn"))
   m, n = size(C);
   [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
   if isdiag(A) && isdiag(B)
      for i = 1:m
         for j = 1:n
            C[i,j] = C[i,j]/(A[i,i]+isgn*B[j,j])
            isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
         end
      end
      return C[:,:]
   end      
 
   ONE = one(T1)

   # determine the structure of the generalized real Schur forms of A and B
   (ba, pa) = sfstruct(A)
   (bb, pb) = sfstruct(B)

   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   if !adjA && !adjB
      # """
      # The (K,L)th block of X is determined starting from
      # bottom-left corner column by column by

      #       A(K,K)*X(K,L) + X(K,L)*B(L,L) = C(K,L) - R(K,L)

      # where
      #                        M                       L-1
      #            R(K,L) =   SUM [A(K,J)*X(J,L)]    + SUM [X(K,I)*B(I,L)] 
      #                      J=K+1                     I=1
      #
      # """
      j = 1
      for ll = 1:pb
          dl = bb[ll]
          il1 = 1:j-1
          l = j:j+dl-1
          i = m
          for kk = pa:-1:1
              dk = ba[kk]
              k = i-dk+1:i
              y = view(C,k,l)
              if kk < pa
                 ir = i+1:m
                 mul!(y,view(A,k,ir),view(C,ir,l),-ONE,ONE)
              end
              if ll > 1
                 mul!(y,view(C,k,il1),view(B,il1,l),-isgn*ONE,ONE)
              end
              sylvc2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw) 
              i -= dk
          end
          j += dl
      end
   elseif !adjA && adjB
         # """
         #  The (K,L)th element of X is determined starting from
         #  bottom-right corner column by column by

         #       A(K,K)*X(K,L) + X(K,L)*B(L,L)' = C(K,L) - R(K,L)

         #  where
         #                        M                       N
         #            R(K,L) =   SUM [A(K,J)*X(J,L)] } + SUM [X(K,I)*B(L,I)'] 
         #                      J=K+1                   I=L+1
         # """
         j = n
         for ll = pb:-1:1
             dl = bb[ll]
             il1 = j+1:n
             l = j-dl+1:j
             i = m
             for kk = pa:-1:1
                 dk = ba[kk]
                 i1 = i-dk+1
                 k = i1:i
                 y = view(C,k,l)
                 if kk < pa
                    ir = i+1:m
                    mul!(y,view(A,k,ir),view(C,ir,l),-ONE,ONE)
                 end
                 if ll < pb
                    mul!(y,view(C,k,il1),transpose(view(B,l,il1)),-isgn*ONE,ONE)
                 end
                 sylvc2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw) 
                 i -= dk
             end
             j -= dl
         end
   elseif adjA && !adjB
      # """
      # The (K,L)th element of X is determined starting from the
      # upper-left corner column by column as

      #     A(K,K)'*X(K,L) + X(K,L)*B(L,L) = C(K,L) - R(K,L),

      # where
      #                       K-1                      L-1
      #            R(K,L) =   SUM [A(J,K)'*X(J,L)]  +  SUM [X(k,I)*B(I,L)]
      #                       J=1                      I=1
      # """
      j = 1
      for ll = 1:pb
          dl = bb[ll]
          il1 = 1:j-1
          l = j:j+dl-1
          i = 1
          for kk = 1:pa
              dk = ba[kk]
              k = i:i+dk-1
              y = view(C,k,l)
              if kk > 1
                 ir = 1:i-1
                 mul!(y,transpose(view(A,ir,k)),view(C,ir,l),-ONE,ONE)
              end
              if ll > 1
                 mul!(y,view(C,k,il1),view(B,il1,l),-isgn*ONE,ONE)
              end
              sylvc2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw) 
              i += dk
          end
          j += dl
      end
   elseif adjA && adjB
      # """
      # The (K,L)th element of X is determined starting from
      # upper-rght corner column by column by

      #       A(K,K)'*X(K,L) + X(K,L)*B(L,L)' = C(K,L) - R(K,L)

      # where
      #                       K-1                        N
      #            R(K,L) =   SUM [A(J,K)'*X(J,L)]  +   SUM [X(k,I)*B(L,I)'] 
      #                       J=1                      I=L+1
      # """
      j = n
      for ll = pb:-1:1
          dl = bb[ll]
          il1 = j+1:n
          l = j-dl+1:j
          i = 1
          for kk = 1:pa
              dk = ba[kk]
              k = i:i+dk-1
              y = view(C,k,l)
              if kk > 1
                 ir = 1:i-1
                 mul!(y,transpose(view(A,ir,k)),view(C,ir,l),-ONE,ONE)
              end
              if ll < pb
                 mul!(y,view(C,k,il1),transpose(view(B,l,il1)),-isgn*ONE,ONE)
              end
              sylvc2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw) 
              i += dk
          end
          j -= dl
      end
   end
   return C
end
function sylvcs!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}; isgn::Int = 1, 
                 adjA::Bool = false, adjB::Bool = false) where T1<:Complex
   """
   The Bartels-Stewart Schur form based approach [1] is employed.

   References:
   [1] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
       Comm. ACM, 15:820–826, 1972.
   """
   abs(isgn) == 1 || throw(ArgumentError(" isgn must be 1 or -1; got $isgn"))
   m, n = size(C);
   [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
   if isdiag(A) && isdiag(B)
      if !adjA && !adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]+isgn*B[j,j])
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      elseif !adjA && adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]+isgn*B[j,j]')
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      elseif adjA && !adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]'+isgn*B[j,j])
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      else
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]'+isgn*B[j,j]')
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      end
      return C[:,:]
   end      
   if !adjA && !adjB
      # """
      # The (K,L)th element of X is determined starting from
      # bottom-left corner column by column by

      #       A(K,K)*X(K,L) + X(K,L)*B(L,L) = C(K,L) - R(K,L)

      # where
      #                        M                       L-1
      #            R(K,L) =   SUM [A(K,J)*X(J,L)]    + SUM [X(K,I)*B(I,L)] 
      #                      J=K+1                     I=1
      #
      # """
      for l = 1:n
          il1 = 1:l-1
          for k = m:-1:1
              y = C[k,l]
              if k < m
                 for ir = k+1:m
                     y -= A[k,ir]*C[ir,l]
                  end
              end
              if l > 1
                 for ir = il1
                     y -= isgn*C[k,ir]*B[ir,l]
                 end
              end
              C[k,l] = y/(A[k,k]+isgn*B[l,l])
              isfinite(C[k,l]) || throw("ME:SingularException: A and -B have common or close eigenvalues")
          end
      end
   elseif !adjA && adjB
         # """
         #  The (K,L)th element of X is determined starting from
         #  bottom-right corner column by column by

         #       A(K,K)*X(K,L) + X(K,L)*B(L,L)' = C(K,L) - R(K,L)

         #  where
         #                        M                       N
         #            R(K,L) =   SUM [A(K,J)*X(J,L)] } + SUM [X(K,I)*B(L,I)'] 
         #                      J=K+1                   I=L+1
         # """
         for l = n:-1:1
             il1 = l+1:n
             for k = m:-1:1
                 y = C[k,l]
                 if k < m
                    for ir = k+1:m
                        y -= A[k,ir]*C[ir,l]
                    end
                 end
                 if l < n
                    for ir = il1
                        y -= isgn*C[k,ir]*B[l,ir]'
                    end
                 end
                 C[k,l] = y/(A[k,k]+isgn*B[l,l]')
                 isfinite(C[k,l]) || throw("ME:SingularException: A and -B' have common or close eigenvalues")
             end
         end
   elseif adjA && !adjB
      # """
      # The (K,L)th element of X is determined starting from the
      # upper-left corner column by column by

      #     A(K,K)'*X(K,L) + X(K,L)*B(L,L) = C(K,L) - R(K,L),

      # where
      #                       K-1                      L-1
      #            R(K,L) =   SUM [A(J,K)'*X(J,L)]  +  SUM [X(k,I)*B(I,L)]
      #                       J=1                      I=1
      # """
      for l = 1:n
          il1 = 1:l-1
          for k = 1:m
              y = C[k,l]
              if k > 1
                 for ir = 1:k-1
                     y -= A[ir,k]'*C[ir,l]
                 end
              end
              if l > 1
                 for ir = il1
                     y -= isgn*C[k,ir]*B[ir,l]
                 end
              end
              C[k,l] = y/(A[k,k]'+isgn*B[l,l])
              isfinite(C[k,l]) || throw("ME:SingularException: A' and -B have common or close eigenvalues")
          end
      end
   elseif adjA && adjB
      # """
      # The (K,L)th element of X is determined starting from
      # upper-rght corner column by column by

      #       A(K,K)'*X(K,L) + X(K,L)*B(L,L)' = C(K,L) - R(K,L)

      # where
      #                       K-1                        N
      #            R(K,L) =   SUM [A(J,K)'*X(J,L)]  +   SUM [X(k,I)*B(L,I)'] 
      #                       J=1                      I=L+1
      # """
      for l = n:-1:1
          il1 = l+1:n
          for k = 1:m
              y = C[k,l]
              if k > 1
                 for ir = 1:k-1
                     y -= A[ir,k]'*C[ir,l]
                 end
               end
               if l < n
                  for ir = il1
                      y -= isgn*C[k,ir]*B[l,ir]'
                 end
               end
              C[k,l] = y/(A[k,k]'+isgn*B[l,l]')
              isfinite(C[k,l]) || throw("ME:SingularException: A' and -B' have common or close eigenvalues")
          end
      end
   end
   return C
end

function sylvd2!(adjA::Bool, adjB::Bool, C::AbstractMatrix{T}, na::Int, nb::Int, A::AbstractMatrix{T}, B::AbstractMatrix{T}, isgn::Int, R::AbstractMatrix{T}, Y::AbstractVector{T}) where {T <:Real}
   # speed and reduced allocation oriented implementation of a solver for 1x1 and 2x2 Sylvester equations 
   # encountered in solving discrete Lyapunov equations: 
   # A*X*B + isgn*X = C   if adjA = false and adjB = false -> R = kron(B',A) + I 
   # A'*X*B + isgn*X = C  if adjA = true  and adjB = false -> R = kron(B',A') + I 
   # A*X*B' + isgn*X = C  if adjA = false and adjB = true  -> R = kron(B,A) + I
   # A'*X*B' +isgn*X = C if adjA = true  and adjB = true  -> R = kron(B,A') + I
   ONE = isgn*one(T)
   if na == 1 && nb == 1
      temp = A[1,1]*B[1,1] + ONE
      rmul!(C,inv(temp))
      any(!isfinite, C) && throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that αβ = -1")
      return C
   end
   #Y .= vec(C)
   if adjA && !adjB
      if na == 1
         # R12 =
         # [ a11*b11+1      a11*b21]
         # [     a11*b12  a11*b22+1]
         # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,1]*B[2,1];
         #                 A[1,1]*B[1,2]  A[1,1]*B[2,2]+ONE]
         @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
         @inbounds  R[1,2] = A[1,1]*B[2,1]
         @inbounds  R[2,1] = A[1,1]*B[1,2]
         @inbounds  R[2,2] = A[1,1]*B[2,2]+ONE
         @inbounds  Y[1] = C[1,1]
         @inbounds  Y[2] = C[1,2]
      else
         if nb == 1
            # R21 =
            # [ a11*b11+1      a21*b11]
            # [     a12*b11  a22*b11+1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[2,1]*B[1,1];
            #                 A[1,2]*B[1,1]  A[2,2]*B[1,1]+ONE ]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[2,1] = A[1,2]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
         else
            # R =
            # [ a11*b11+1      a21*b11      a11*b21      a21*b21]
            # [     a12*b11  a22*b11+1      a12*b21      a22*b21]
            # [     a11*b12      a21*b12  a11*b22+1      a21*b22]
            # [     a12*b12      a22*b12      a12*b22  a22*b22+1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[2,1]*B[1,1]      A[1,1]*B[2,1]      A[2,1]*B[2,1];
            # A[1,2]*B[1,1]  A[2,2]*B[1,1]+ONE      A[1,2]*B[2,1]      A[2,2]*B[2,1];
            # A[1,1]*B[1,2]      A[2,1]*B[1,2]  A[1,1]*B[2,2]+ONE      A[2,1]*B[2,2];
            # A[1,2]*B[1,2]      A[2,2]*B[1,2]      A[1,2]*B[2,2]  A[2,2]*B[2,2]+ONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[1,3] = A[1,1]*B[2,1]
            @inbounds  R[1,4] = A[2,1]*B[2,1]
            @inbounds  R[2,1] = A[1,2]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  R[2,3] = A[1,2]*B[2,1]
            @inbounds  R[2,4] = A[2,2]*B[2,1]
            @inbounds  R[3,1] = A[1,1]*B[1,2]
            @inbounds  R[3,2] = A[2,1]*B[1,2]
            @inbounds  R[3,3] = A[1,1]*B[2,2]+ONE
            @inbounds  R[3,4] = A[2,1]*B[2,2]
            @inbounds  R[4,1] = A[1,2]*B[1,2]
            @inbounds  R[4,2] = A[2,2]*B[1,2]
            @inbounds  R[4,3] = A[1,2]*B[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
            @inbounds  Y[3] = C[1,2]
            @inbounds  Y[4] = C[2,2]
         end
      end
      #R = kron(transpose(B),A) + I
   elseif !adjA && adjB
      if na == 1
         # R12 =
         # [ a11*b11+1      a11*b12]
         # [     a11*b21  a11*b22+1]
         # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,1]*B[1,2];
         #                 A[1,1]*B[2,1]  A[1,1]*B[2,2]+ONE]
         @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
         @inbounds  R[1,2] = A[1,1]*B[1,2]
         @inbounds  R[2,1] = A[1,1]*B[2,1]
         @inbounds  R[2,2] = A[1,1]*B[2,2]+ONE
         @inbounds  Y[1] = C[1,1]
         @inbounds  Y[2] = C[1,2]
      else
         if nb == 1
            # R21 =
            #    [ a11*b11+1      a12*b11]
            #    [     a21*b11  a22*b11+1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,2]*B[1,1];
            #                 A[2,1]*B[1,1]  A[2,2]*B[1,1]+ONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[1,2]*B[1,1]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
         else
            # R =
            # [ a11*b11+1      a12*b11      a11*b12      a12*b12]
            # [     a21*b11  a22*b11+1      a21*b12      a22*b12]
            # [     a11*b21      a12*b21  a11*b22+1      a12*b22]
            # [     a21*b21      a22*b21      a21*b22  a22*b22+1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,2]*B[1,1]      A[1,1]*B[1,2]      A[1,2]*B[1,2];
            # A[2,1]*B[1,1]  A[2,2]*B[1,1]+ONE      A[2,1]*B[1,2]      A[2,2]*B[1,2];
            # A[1,1]*B[2,1]      A[1,2]*B[2,1]  A[1,1]*B[2,2]+ONE      A[1,2]*B[2,2];
            # A[2,1]*B[2,1]      A[2,2]*B[2,1]      A[2,1]*B[2,2]  A[2,2]*B[2,2]+ONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[1,2]*B[1,1]
            @inbounds  R[1,3] = A[1,1]*B[1,2]
            @inbounds  R[1,4] = A[1,2]*B[1,2]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  R[2,3] = A[2,1]*B[1,2]
            @inbounds  R[2,4] = A[2,2]*B[1,2]
            @inbounds  R[3,1] = A[1,1]*B[2,1]
            @inbounds  R[3,2] = A[1,2]*B[2,1]
            @inbounds  R[3,3] = A[1,1]*B[2,2]+ONE
            @inbounds  R[3,4] = A[1,2]*B[2,2]
            @inbounds  R[4,1] = A[2,1]*B[2,1]
            @inbounds  R[4,2] = A[2,2]*B[2,1]
            @inbounds  R[4,3] = A[2,1]*B[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
            @inbounds  Y[3] = C[1,2]
            @inbounds  Y[4] = C[2,2]
         end
      end
      #R = kron(transpose(B),transpose(A)) + I
   elseif !adjA && !adjB
      if na == 1
         # R12 =
         # [ a11*b11 + 1,     a11*b21]
         # [     a11*b12, a11*b22 + 1]
         # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,1]*B[2,1];
         #                 A[1,1]*B[1,2]  A[1,1]*B[2,2]+ONE]
         @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
         @inbounds  R[1,2] = A[1,1]*B[2,1]
         @inbounds  R[2,1] = A[1,1]*B[1,2]
         @inbounds  R[2,2] = A[1,1]*B[2,2]+ONE
         @inbounds  Y[1] = C[1,1]
         @inbounds  Y[2] = C[1,2]
      else
         if nb == 1
            # R21 =
            # [ a11*b11 + 1,     a12*b11]
            # [     a21*b11, a22*b11 + 1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,2]*B[1,1];
            #                 A[2,1]*B[1,1]  A[2,2]*B[1,1]+ONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[1,2]*B[1,1]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
         else
            # R =
            # [ a11*b11 + 1,     a12*b11,     a11*b21,     a12*b21]
            # [     a21*b11, a22*b11 + 1,     a21*b21,     a22*b21]
            # [     a11*b12,     a12*b12, a11*b22 + 1,     a12*b22]
            # [     a21*b12,     a22*b12,     a21*b22, a22*b22 + 1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,2]*B[1,1]      A[1,1]*B[2,1]      A[1,2]*B[2,1];
            # A[2,1]*B[1,1]  A[2,2]*B[1,1]+ONE      A[2,1]*B[2,1]      A[2,2]*B[2,1];
            # A[1,1]*B[1,2]      A[1,2]*B[1,2]  A[1,1]*B[2,2]+ONE      A[1,2]*B[2,2];
            # A[2,1]*B[1,2]      A[2,2]*B[1,2]      A[2,1]*B[2,2]  A[2,2]*B[2,2]+ONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[1,2]*B[1,1]
            @inbounds  R[1,3] = A[1,1]*B[2,1]
            @inbounds  R[1,4] = A[1,2]*B[2,1]
            @inbounds  R[2,1] = A[2,1]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  R[2,3] = A[2,1]*B[2,1]
            @inbounds  R[2,4] = A[2,2]*B[2,1]
            @inbounds  R[3,1] = A[1,1]*B[1,2]
            @inbounds  R[3,2] = A[1,2]*B[1,2]
            @inbounds  R[3,3] = A[1,1]*B[2,2]+ONE
            @inbounds  R[3,4] = A[1,2]*B[2,2]
            @inbounds  R[4,1] = A[2,1]*B[1,2]
            @inbounds  R[4,2] = A[2,2]*B[1,2]
            @inbounds  R[4,3] = A[2,1]*B[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
            @inbounds  Y[3] = C[1,2]
            @inbounds  Y[4] = C[2,2]
         end
      end
      #R = kron(B,A) + I
   else
      if na == 1
         # R12 =
         # [ a11*b11 + 1,     a11*b12]
         # [     a11*b21, a11*b22 + 1]
         # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[1,1]*B[1,2];
         #                 A[1,1]*B[2,1]  A[1,1]*B[2,2]+ONE]
         @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
         @inbounds  R[1,2] = A[1,1]*B[1,2]
         @inbounds  R[2,1] = A[1,1]*B[2,1]
         @inbounds  R[2,2] = A[1,1]*B[2,2]+ONE
         @inbounds  Y[1] = C[1,1]
         @inbounds  Y[2] = C[1,2]
      else
         if nb == 1
            # R21 =
            # [ a11*b11 + 1,     a21*b11]
            # [     a12*b11, a22*b11 + 1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[2,1]*B[1,1];
            #                 A[1,2]*B[1,1]  A[2,2]*B[1,1]+ONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[2,1] = A[1,2]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
         else
            # R =
            # [ a11*b11 + 1,     a21*b11,     a11*b12,     a21*b12]
            # [     a12*b11, a22*b11 + 1,     a12*b12,     a22*b12]
            # [     a11*b21,     a21*b21, a11*b22 + 1,     a21*b22]
            # [     a12*b21,     a22*b21,     a12*b22, a22*b22 + 1]
            # @inbounds R = [ A[1,1]*B[1,1]+ONE      A[2,1]*B[1,1]      A[1,1]*B[1,2]      A[2,1]*B[1,2];
            # A[1,2]*B[1,1]  A[2,2]*B[1,1]+ONE      A[1,2]*B[1,2]      A[2,2]*B[1,2];
            # A[1,1]*B[2,1]      A[2,1]*B[2,1]  A[1,1]*B[2,2]+ONE      A[2,1]*B[2,2];
            # A[1,2]*B[2,1]      A[2,2]*B[2,1]      A[1,2]*B[2,2]  A[2,2]*B[2,2]+ONE]
            @inbounds  R[1,1] = A[1,1]*B[1,1]+ONE
            @inbounds  R[1,2] = A[2,1]*B[1,1]
            @inbounds  R[1,3] = A[1,1]*B[1,2]
            @inbounds  R[1,4] = A[2,1]*B[1,2]
            @inbounds  R[2,1] = A[1,2]*B[1,1]
            @inbounds  R[2,2] = A[2,2]*B[1,1]+ONE
            @inbounds  R[2,3] = A[1,2]*B[1,2]
            @inbounds  R[2,4] = A[2,2]*B[1,2]
            @inbounds  R[3,1] = A[1,1]*B[2,1]
            @inbounds  R[3,2] = A[2,1]*B[2,1]
            @inbounds  R[3,3] = A[1,1]*B[2,2]+ONE
            @inbounds  R[3,4] = A[2,1]*B[2,2]
            @inbounds  R[4,1] = A[1,2]*B[2,1]
            @inbounds  R[4,2] = A[2,2]*B[2,1]
            @inbounds  R[4,3] = A[1,2]*B[2,2]
            @inbounds  R[4,4] = A[2,2]*B[2,2]+ONE
            @inbounds  Y[1] = C[1,1]
            @inbounds  Y[2] = C[2,1]
            @inbounds  Y[3] = C[1,2]
            @inbounds  Y[4] = C[2,2]
         end
         #R = kron(B,transpose(A)) + I
      end
   end
   luslv!(R,Y,na*nb) && throw("ME:SingularException: A has eigenvalue(s) α and B has eingenvalu(s) β such that αβ = -1")
   if na == 1 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[1,2] = Y[2]
   elseif na == 2 && nb == 1
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
   else # na == 2 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
      @inbounds C[1,2] = Y[3]
      @inbounds C[2,2] = Y[4]
   end
   return C
end

function sylvds_blocked!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}; adjA = false, adjB = false, isgn = 1, blocksize::Integer = 64) where {T1<:BlasFloat}
   m = LinearAlgebra.checksquare(A)  
   n = LinearAlgebra.checksquare(B)
   (m, n) == size(C) || throw(DimensionMismatch("C must be a $m x $n"))
   
    WS = Matrix{T1}(undef,m,n)
    T1 <: Complex ? WS2 = Vector{T1}(undef,m) : WS2 = Matrix{T1}(undef,m,2) 
   # Call the positional recursive worker
   _sylvds_blocked!(WS, WS2, A, B, C, adjA, adjB, isgn, blocksize)
end
function _sylvds_blocked!(WS, WS2, A, B, C, adjA::Bool, adjB::Bool, isgn::Integer, blocksize::Integer)
   m = size(A, 1)
   n = size(B, 1)
   if m <= max(blocksize,4) && n <= max(blocksize,4)
      compl = eltype(A) <: Complex
      sylvds!(A, B, C, compl ? view(WS2,1:m) : view(WS2,1:m,1:2); adjA, adjB, isgn)
   elseif 2*n <= m 
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 

      @views begin
         A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
         C1, C2 = C[ia1,1:n], C[ia2,1:n]
         WS11, WS21 = WS[ia1,1:n], WS[ia2,1:n]
      end
      if adjA 
         # solve A' X op(B) + isgn*X = C where 
         # op(B) = B if adjB = false and op(B) = B' if adjB = true

         # X1 solver
         _sylvds_blocked!(WS11, WS2, A11, B, C1, adjA, adjB, isgn, blocksize)

         # C2 update: C2 = C2 - A12'*X1*op(B)
         mul!(WS21,A12',C1)
         mul!(C2, WS21, adjB ? B' : B,-1,1)

         # X2 solver
         _sylvds_blocked!(WS21, WS2, A22, B, C2, adjA, adjB, isgn, blocksize)
      else 
         # solve A X op(B)  + isgn*X = C where 
         # op(B) = B if adjB = false and op(B) = B' if adjB = true

         # X22 solver
         _sylvds_blocked!(WS21, WS2, A22, B, C2, adjA, adjB, isgn, blocksize)

         # C1 update: C1 = C1 - A12*X2*op(B)
         mul!(WS11, A12, C2)
         mul!(C1, WS11, adjB ? B' : B, -1, 1)

         # X1 solver
         _sylvds_blocked!(WS11, WS2, A11, B, C1, adjA, adjB, isgn, blocksize)
      end
   elseif 2*m <= n 
      midn = n ÷ 2
      n1 = B[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n 

      @views begin
         B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
         C1, C2 = C[1:m,ib1], C[1:m,ib2]
         WS11, WS12 = WS[1:m,ib1], WS[1:m,ib2]
      end
      if !adjB
         # solve op(A) X B + isgn*X = C 

         # X1 solver
         _sylvds_blocked!(WS11, WS2, A, B11, C1, adjA, adjB, isgn, blocksize)

         # C2 update: C2 = C2 - op(A)*X1*B12
         mul!(WS12,C1,B12)
         mul!(C2, adjA ? A' : A, WS12, -1, 1)

         # X2 solver
         _sylvds_blocked!(WS12, WS2, A, B22, C2, adjA, adjB, isgn, blocksize)

      else
         # solve op(A) X B'  + isgn*X = C  

         # X2 solver
         _sylvds_blocked!(WS12, WS2, A, B22, C2, adjA, adjB, isgn, blocksize)

         # C1 update: C1 = C1 - op(A)*X2*B12'
         # mul!(WS12, C2, B12')
         # mul!(C1, adjA ? A' : A, WS12, -1, 1)

         mul!(WS12, adjA ? A' : A, C2)
         mul!(C1, WS12, B12', -1, 1)


         # X1 solver
         _sylvds_blocked!(WS11, WS2, A, B11, C1, adjA, adjB, isgn, blocksize)

      end
   else
      midm = m ÷ 2
      m1 = A[midm+1, midm] != 0 ? midm + 1 : midm
      ia1 = 1:m1; ia2 = m1+1:m 
      midn = n ÷ 2
      n1 = B[midn+1, midn] != 0 ? midn + 1 : midn
      ib1 = 1:n1; ib2 = n1+1:n 
      @views begin
         A11, A12, A22 = A[ia1,ia1], A[ia1,ia2], A[ia2,ia2]
         B11, B12, B22 = B[ib1,ib1], B[ib1,ib2], B[ib2,ib2]
         C11, C12, C21, C22 = C[ia1,ib1], C[ia1,ib2], C[ia2,ib1], C[ia2,ib2]
         WS11, WS12, WS21, WS22 = WS[ia1,ib1], WS[ia1,ib2], WS[ia2,ib1], WS[ia2,ib2]
      end
      if !adjA && !adjB
         # solve A X B + isgn X + C = 0

         # X21 solver
         _sylvds_blocked!(WS21, WS2, A22, B11, C21, adjA, adjB, isgn, blocksize)

         # C11 update: C11 = C11 - A12*X21*B11
         mul!(WS21,C21,B11)
         mul!(C11,A12,WS21,-1,1)

         # X11 solver
         _sylvds_blocked!(WS11, WS2, A11, B11, C11, adjA, adjB, isgn, blocksize)

         # C22 update: C22 = C22 - A22*X21*B12
         mul!(WS21,A22,C21)
         mul!(C22,WS21,B12,-1,1)
         
         # X22 solver
         _sylvds_blocked!(WS22, WS2, A22, B22, C22, adjA, adjB, isgn, blocksize)

         # C12 update: C12 = C12 - A11*X11*B12 - A12*X21*B12 - A12*X22*B22

         # WS11 = A11*X11 + A12*X21
         mul!(WS11, A11, C11)
         mul!(WS11, A12, C21, 1, 1)
         # C12 = C12 - (WS11)*B12
         mul!(C12, WS11, B12, -1, 1)
         # C12 = C12 - A12*X22*B22
         mul!(WS22, C22, B22)
         mul!(C12, A12, WS22, -1, 1)

         # X12 solver
         _sylvds_blocked!(WS12, WS2, A11, B22, C12, adjA, adjB, isgn, blocksize)

      elseif adjA && !adjB
         # solve A' X B + isgn X + C = 0

         # X11 solver
         _sylvds_blocked!(WS11, WS2, A11, B11, C11, adjA, adjB, isgn, blocksize)

         # C12 update: C12 = C12 - A11'*X11*B12
         mul!(WS11,A11',C11)
         mul!(C12,WS11,B12,-1,1)

         # X12 solver
         _sylvds_blocked!(WS12, WS2, A11, B22, C12, adjA, adjB, isgn, blocksize)

         # C21 update: C21 = C21 - A12'*X11*B11
         mul!(WS11,C11,B11)
         mul!(C21,A12',WS11,-1,1)

         # X21 solver
         _sylvds_blocked!(WS21, WS2, A22, B11, C21, adjA, adjB, isgn, blocksize)

         # C22 update: C22 = C22 - A12'*X11*B12 - A12'*X12*B22 - A22'*X21*B12

         # WS12 = X11*B12 + X12*B22
         mul!(WS12, C11, B12)
         mul!(WS12, C12, B22, 1, 1)
         # C22 = C22 - A12'*(WS12)
         mul!(C22, A12', WS12, -1, 1)
         # C22 = C22 - A22'*X21*B12
         mul!(WS22, C21, B12)
         mul!(C22, A22', WS22,- 1, 1)

         # X22 solver
         _sylvds_blocked!(WS22, WS2, A22, B22, C22, adjA, adjB, isgn, blocksize)
      elseif !adjA && adjB
         # solve A X B' + isgn X + C = 0

         # X22 solver
         _sylvds_blocked!(WS22, WS2, A22, B22, C22, adjA, adjB, isgn, blocksize)

         # C12 update: C12 = C12 - A12*X22*B22'
         mul!(WS22,C22,B22')
         mul!(C12,A12,WS22,-1,1)

         # X12 solver
         _sylvds_blocked!(WS12, WS2, A11, B22, C12, adjA, adjB, isgn, blocksize)

         # C21 update: C21 = C21 - A22*X22*B12'
         mul!(WS22,A22,C22)
         mul!(C21,WS22,B12',-1,1)

         # X21 solver
         _sylvds_blocked!(WS21, WS2, A22, B11, C21, adjA, adjB, isgn, blocksize)

         # C11 update: C11 = C11 - A12*X21*B11' - A11*X12*B12' - A12*X22*B12'
         # WS21 = X21*B11' + X22*B12'
         mul!(WS21, C21, B11')
         mul!(WS21, C22, B12', 1, 1)
         # C11 = C11 - A12*(WS21)
         mul!(C11, A12, WS21, -1, 1)
         # C11 = C11 - A11*X12*B12'
         mul!(WS12, A11, C12)
         mul!(C11, WS12, B12', -1, 1) 
 
         # X11 solver
         _sylvds_blocked!(WS11, WS2, A11, B11, C11, adjA, adjB, isgn, blocksize)
      else
         # solve A' X B' + isgn X + C = 0

         # X12 solver
         _sylvds_blocked!(WS12, WS2, A11, B22, C12, adjA, adjB, isgn, blocksize)

         # C11 update: C11 = C11 - A11'*X12*B12' 
         mul!(WS12, A11', C12)
         mul!(C11, WS12, B12', -1, 1) 

         # X11 solver
         _sylvds_blocked!(WS11, WS2, A11, B11, C11, adjA, adjB, isgn, blocksize)

         # C22 update: C22 = C22 - A12'*X12*B22' 
         mul!(WS12, C12, B22')
         mul!(C22, A12', WS12, -1, 1) 

         # X22 solver
         _sylvds_blocked!(WS22, WS2, A22, B22, C22, adjA, adjB, isgn, blocksize)

         # C21 update: C21 = C21 - A12'*X12*B12' - A22'*X22*B12' - A12'*X11*B11'

         # WS22 =  A12'*X12 + A22'*X22
         mul!(WS22,A12',C12)
         mul!(WS22, A22', C22, 1, 1)
         # C21 = C21 - (WS22)*B12'
         mul!(C21, WS22, B12', -1, 1)
         # C21 = C21 - A12'*X11*B11'
         mul!(WS21, A12', C11)
         mul!(C21, WS21, B11', -1, 1)

         # X21 solver
         _sylvds_blocked!(WS21, WS2, A22, B11, C21, adjA, adjB, isgn, blocksize)

      end
   end   
end


"""
    sylvds!(A,B,C; isgn = 1, adjA = false, adjB = false)

Solve the discrete Sylvester matrix equation

                op(A)Xop(B) + isgn*X =  C,

where `op(A) = A` or `op(A) = A'` if `adjA = false` or `adjA = true`, respectively,
and `op(B) = B` or `op(B) = B'` if `adjB = false` or `adjB = true`, respectively, and
`isgn` is an integer such that `abs(isgn)` = 1.
`A` and `B` are square matrices in Schur forms, and `A` and `-B` must not have
common reciprocal eigenvalues. `C` contains on output the solution `X`.
"""
function sylvds!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}, W::AbstractMatrix{T1} = similar(A,size(A,1),2); isgn::Int = 1, adjA::Bool = false, adjB::Bool = false) where  T1<:Real
   """
   An extension of the Bartels-Stewart Schur form based approach is employed.

   Reference:
   R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
   Comm. ACM, 15:820–826, 1972.
   """
   abs(isgn) == 1 || throw(ArgumentError(" isgn must be 1 or -1; got $isgn"))
   m, n = LinearAlgebra.checksquare(A,B)
   (size(C,1) == m && size(C,2) == n ) || throw(DimensionMismatch("C must be an $m x $n matrix"))
   m, n = size(C);
   [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
   ONE = one(T1)
   if isdiag(A) && isdiag(B)
      for i = 1:m
         for j = 1:n
            C[i,j] = C[i,j]/(A[i,i]*B[j,j]+isgn*ONE)
            isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α*β = $(-isgn)")
         end
      end
      return C[:,:]
   end      

   (m, 2) == size(W) || throw(DimensionMismatch("W must be an $m x 2 matrix"))


   # determine the structure of the real Schur form of A
   ba, pa = sfstruct(A)
   bb, pb = sfstruct(B)
   
   G = Matrix{T1}(undef,2,2)
   WA = Matrix{T1}(undef,2,2)

   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   if !adjA && !adjB
      # """
      # The (K,L)th block of X is determined starting from
      # bottom-left corner column by column by

      #            A(K,K)*X(K,L)*B(L,L) + isgn*X(K,L) = C(K,L) - R(K,L)

      # where
      #                        M
      #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L) +
      #                      J=K+1
      #                        M             L-1
      #                       SUM { A(K,J) * SUM [X(J,I)*B(I,L)] }.
      #                       J=K            I=1
      # """
      j = 1
      for ll = 1:pb
          dl = bb[ll]
          dll = 1:dl
          il1 = 1:j-1
          j1 = j+dl-1
          l = j:j1
          i = m
          for kk = pa:-1:1
              dk = ba[kk]
              dkk = 1:dk
              i1 = i-dk+1
              k = i1:i
              Ckl = view(C,k,l)
              y = view(G,1:dk,1:dl)
              copyto!(y,Ckl)
              if kk < pa
                 ir = i+1:m
                 W1 = view(WA,dkk,dll)
                 mul!(W1,view(A,k,ir),view(C,ir,l))
                 mul!(y,W1,view(B,l,l),-ONE,ONE)
              end
              if ll > 1
                 ic = i1:m
                 mul!(view(W,k,dll),view(C,k,il1),view(B,il1,l))
                 mul!(y,view(A,k,ic),view(W,ic,dll),-ONE,ONE)
              end
              sylvd2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw)  
              copyto!(Ckl,y)
           i -= dk
          end
          j += dl
      end
   elseif !adjA && adjB
         # """
         # The (K,L)th block of X is determined starting from
         # bottom-right corner column by column by

         #             A(K,K)*X(K,L)*B(L,L)' + X(K,L) = C(K,L) - R(K,L)

         # where
         #                        M
         #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L)' +
         #                      J=K+1
         #                        M              N
         #                       SUM { A(K,J) * SUM [X(J,I)*B(L,I)'] }.
         #                       J=K           I=L+1
         # """
         j = n
         for ll = pb:-1:1
             dl = bb[ll]
             dll = 1:dl
             il1 = j+1:n
             l = j-dl+1:j
             i = m
             for kk = pa:-1:1
                 dk = ba[kk]
                 dkk = 1:dk
                 i1 = i-dk+1
                 k = i1:i
                 Ckl = view(C,k,l)
                 y = view(G,1:dk,1:dl)
                 copyto!(y,Ckl)
                 if kk < pa
                    ir = i+1:m
                    W1 = view(WA,dkk,dll)
                    mul!(W1,view(A,k,ir),view(C,ir,l))
                    mul!(y,W1,adjoint(view(B,l,l)),-ONE,ONE)
                 end
                 if ll < pb
                    ic = i1:m
                    mul!(view(W,k,dll),view(C,k,il1),adjoint(view(B,l,il1)))
                    mul!(y,view(A,k,ic),view(W,ic,dll),-ONE,ONE)
                 end
                 sylvd2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw)  
                 copyto!(Ckl,y)
                 i -= dk
             end
             j -= dl
         end
   elseif adjA && !adjB
      # """
      # The (K,L)th block of X is determined starting from the
      # upper-left corner column by column by

      # A(K,K)'*X(K,L)*B(L,L) + X(K,L) = C(K,L) - R(K,L),

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L) +
      #                       J=1
      #                        K              L-1
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(I,L)] }.
      #                       J=1             I=1
      # """
      j = 1
      for ll = 1:pb
          dl = bb[ll]
          dll = 1:dl
          il1 = 1:j-1
          j1 = j+dl-1
          l = j:j1
          i = 1
          for kk = 1:pa
              dk = ba[kk]
              dkk = 1:dk
              i1 = i+dk-1
              k = i:i1
              Ckl = view(C,k,l)
              y = view(G,1:dk,1:dl)
              copyto!(y,Ckl)
              if kk > 1
                 ir = 1:i-1
                 W1 = view(WA,dkk,dll)
                 mul!(W1,adjoint(view(A,ir,k)),view(C,ir,l))
                 mul!(y,W1,view(B,l,l),-ONE,ONE)
              end
              if ll > 1
                 ic = 1:i1
                 mul!(view(W,k,dll),view(C,k,il1),view(B,il1,l))
                 mul!(y,adjoint(view(A,ic,k)),view(W,ic,dll),-ONE,ONE)
              end
              sylvd2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw)  
              copyto!(Ckl,y)
           i += dk
          end
          j += dl
      end
   elseif adjA && adjB
      # """
      # The (K,L)th block of X is determined starting from the
      # lower-left corner column by column by

      #            A(K,K)'*X(K,L)*B(L,L)' + X(K,L) = C(K,L) - R(K,L)

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L)' +
      #                       J=1
      #                        K               N
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(L,I)'] }.
      #                       J=1            I=L+1
      # """
      j = n
      for ll = pb:-1:1
          dl = bb[ll]
          dll = 1:dl
          il1 = j+1:n
          l = j-dl+1:j
          i = 1
          for kk = 1:pa
              dk = ba[kk]
              dkk = 1:dk
              i1 = i+dk-1
              k = i:i1
              Ckl = view(C,k,l)
              y = view(G,1:dk,1:dl)
              copyto!(y,Ckl)
              if kk > 1
                 ir = 1:i-1
                 W1 = view(WA,dkk,dll)
                 mul!(W1,adjoint(view(A,ir,k)),view(C,ir,l))
                 mul!(y,W1,adjoint(view(B,l,l)),-ONE,ONE)
              end
              if ll < pb
                 ic = 1:i1
                 mul!(view(W,k,dll),view(C,k,il1),adjoint(view(B,l,il1)))
                 mul!(y,adjoint(view(A,ic,k)),view(W,ic,dll),-ONE,ONE)
              end
              sylvd2!(adjA,adjB,y,dk,dl,view(A,k,k),view(B,l,l),isgn,Xw,Yw)  
              copyto!(Ckl,y)
           i += dk
          end
          j -= dl
      end
   end
   return C
end
function sylvds!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}, W::AbstractVector{T1} = similar(A,size(A,1)); isgn::Int = 1, adjA::Bool = false, adjB::Bool = false) where  T1<:Complex
   """
   An extension of the Bartels-Stewart Schur form based approach is employed.

   Reference:
   R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
   Comm. ACM, 15:820–826, 1972.
   """
   abs(isgn) == 1 || throw(ArgumentError(" isgn must be 1 or -1; got $isgn"))
   m, n = LinearAlgebra.checksquare(A,B)
   (size(C,1) == m && size(C,2) == n ) || throw(DimensionMismatch("C must be an $m x $n matrix"))
  
   ONE = isgn*one(T1)
   if isdiag(A) && isdiag(B)
      if !adjA && !adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]*B[j,j]+ONE)
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      elseif !adjA && adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]*B[j,j]'+ONE)
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      elseif adjA && !adjB
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]'*B[j,j]+ONE)
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      else
         for i = 1:m
            for j = 1:n
               C[i,j] = C[i,j]/(A[i,i]'*B[j,j]'+ONE)
               isfinite(C[i,j]) || throw("ME:SingularException: A has eigenvalue(s) α and B has eigenvalues(s) β such that α+β = 0")
            end
         end
      end
      return C[:,:]
   end     

   ZERO = zero(T1)
   if !adjA && !adjB
      # """
      # The (K,L)th element of X is determined starting from
      # bottom-left corner column by column by

      #            A(K,K)*X(K,L)*B(L,L) + X(K,L) = C(K,L) - R(K,L)

      # where
      #                        M
      #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L) +
      #                      J=K+1
      #                        M             L-1
      #                       SUM { A(K,J) * SUM [X(J,I)*B(I,L)] }.
      #                       J=K            I=1
      # """
      for l = 1:n
          il1 = 1:l-1
          for k = m:-1:1
              y = C[k,l]
              if k < m
                 ta = ZERO
                 for ir = k+1:m
                     ta += A[k,ir]*C[ir,l]
                 end
                 y -= ta*B[l,l]
              end
              if l > 1
                 tz = ZERO
                 for ir = il1
                     tz += C[k,ir]*B[ir,l]
                 end
                 W[k] = tz
                 for ic = k:m
                     y -= A[k,ic]*W[ic]
                 end
              end
              C[k,l] = y/(B[l,l]*A[k,k]+ONE)
              isfinite(C[k,l]) || throw("ME:SingularException: A and -B have common or close reciprocal eigenvalues")
             end
      end
   elseif !adjA && adjB
         # """
         # The (K,L)th element of X is determined starting from
         # bottom-right corner column by column by

         #          A(K,K)*X(K,L)*B(L,L)' + X(K,L) = C(K,L) - R(K,L)

         # where
         #                        M
         #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L)' +
         #                      J=K+1
         #                        M              N
         #                       SUM { A(K,J) * SUM [X(J,I)*B(L,I)'] }.
         #                       J=K           I=L+1
         # """
         for l = n:-1:1
             il1 = l+1:n
             for k = m:-1:1
                 y = C[k,l]
                 if k < m
                    ta = ZERO
                    for ir = k+1:m
                       ta += A[k,ir]*C[ir,l]
                    end
                    y -= ta*B[l,l]'
                 end
                 if l < n
                    tz = ZERO
                    for ir = il1
                        tz += C[k,ir]*B[l,ir]'
                    end
                    W[k] = tz
                    for ic = k:m
                        y -= A[k,ic]*W[ic]
                    end
                 end
                 C[k,l] = y/(B[l,l]'*A[k,k]+ONE)
                 isfinite(C[k,l]) || throw("ME:SingularException: A and -B have common or close reciprocal eigenvalues")
             end
         end
   elseif adjA && !adjB
      # """
      # The (K,L)th element of X is determined starting from the
      # upper-left corner column by column by

      #          A(K,K)'*X(K,L)*B(L,L) + X(K,L) = C(K,L) - R(K,L),

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L) +
      #                       J=1
      #                        K              L-1
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(I,L)] }.
      #                       J=1             I=1
      # """
      for l = 1:n
          il1 = 1:l-1
          for k = 1:m
              y = C[k,l]
              if k > 1
                 ta = ZERO
                 for ir = 1:k-1
                     ta += A[ir,k]'*C[ir,l]
                 end
                 y -= ta*B[l,l]
              end
              if l > 1
                 tz = ZERO
                 for ir = il1
                     tz += C[k,ir]*B[ir,l]
                 end
                 W[k] = tz
                 for ic = 1:k
                     y -= A[ic,k]'*W[ic]
                 end
              end
              C[k,l] = y/(B[l,l]*A[k,k]'+ONE)
              isfinite(C[k,l]) || throw("ME:SingularException: A and -B have common or close reciprocal eigenvalues")
         end
      end
   elseif adjA && adjB
      # """
      # The (K,L)th element of X is determined starting from the
      # upper-right corner column by column by

      #         A(K,K)'*X(K,L)*B(L,L)' + X(K,L) = C(K,L) - R(K,L)

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L)' +
      #                       J=1
      #                        K               N
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(L,I)'] }.
      #                       J=1            I=L+1
      # """
      for l = n:-1:1
          il1 = l+1:n
          for k = 1:m
              y = C[k,l]
              if k > 1
                 ta = ZERO
                 for ir = 1:k-1
                     ta += A[ir,k]'*C[ir,l]
                 end
                 y -= ta*B[l,l]'
              end
              if l < n
                 tz = ZERO
                 for ir = il1
                     tz += C[k,ir]*B[l,ir]'
                 end
                 W[k] = tz
                 for ic = 1:k
                     y -= A[ic,k]'*W[ic]
                 end
              end
              C[k,l] = y/(B[l,l]'*A[k,k]'+ONE)
              isfinite(C[k,l]) || throw("ME:SingularException: A and -B have common or close reciprocal eigenvalues")
          end
      end
   end
   return C
end
"""
    X = gsylvs!(A,B,C,D,E; adjAC=false, adjBD=false, CASchur = false, DBSchur = false, isgn = 1)

Solve the generalized Sylvester matrix equation

                op1(A)Xop2(B) + isgn*op1(C)Xop2(D) = E,

where `A`, `B`, `C` and `D` are square matrices, and

`op1(A) = A` and `op1(C) = C` if `adjAC = false`;

`op1(A) = A'` and `op1(C) = C'` if `adjAC = true`;

`op2(B) = B` and `op2(D) = D` if `adjBD = false`;

`op2(B) = B'` and `op2(D) = D'` if `adjBD = true`.

The matrix pair `(A,C)` is in a generalized real or complex Schur form.
The matrix pair `(B,D)` is in a generalized real or complex Schur form if `DBSchur = false`
or the matrix pair `(D,B)` is in a generalized real or complex Schur form if `DBSchur = true`.
The pencils `A - λ isgn*C` and `isgn*D + λ B` must be regular and must not have common eigenvalues.
"""
function gsylvs!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}, D::AbstractMatrix{T1}, E::AbstractMatrix{T1}, 
                 WB::AbstractMatrix{T1} = similar(A,size(A,1),2), WD::AbstractMatrix{T1} = similar(A,size(A,1),2); 
                 adjAC::Bool = false, adjBD::Bool = false, isgn::Int = 1, CASchur::Bool = false, DBSchur::Bool = false) where T1<:Real
   """
   An extension proposed in [1] of the Bartels-Stewart Schur form based approach [2] is employed.

   References:
   [1] K.-W. E. Chu. The solution of the matrix equation AXB – CXD = E and
       (YA – DZ, YC– BZ) = (E, F). Lin. Alg. Appl., 93:93-105, 1987.
   [2] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
       Comm. ACM, 15:820–826, 1972.
   """
   m, n = size(E);
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,C,D) ||
      throw(DimensionMismatch("A, B, C, D and E have incompatible dimensions"))

   (m, 2) == size(WB) || throw(DimensionMismatch("WB must be an $m x 2 matrix"))
   (m, 2) == size(WD) || throw(DimensionMismatch("WD must be an $m x 2 matrix"))
   
   ONE = one(T1)
   SONE = isgn*ONE

   # determine the structure of the generalized real Schur form of (A,C)
   CASchur ? ((ba, pa) = sfstruct(C)) : ((ba, pa) = sfstruct(A))
   DBSchur ? ((bb, pb) = sfstruct(D)) : ((bb, pb) = sfstruct(B))

   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   if !adjAC && !adjBD
      # """
      # The (K,L)th block of X is determined starting from
      # bottom-left corner column by column by

      #       A(K,K)*X(K,L)*B(L,L) + C(K,K)*X(K,L)*D(L,L) = E(K,L) - R(K,L)

      # where
      #                        M
      #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L) +
      #                      J=K+1
      #                        M             L-1
      #                       SUM { A(K,J) * SUM [X(J,I)*B(I,L)] } +
      #                       J=K            I=1

      #                        M
      #                     { SUM [C(K,J)*X(J,L)] } * D(L,L) +
      #                      J=K+1
      #                        M             L-1
      #                       SUM { C(K,J) * SUM [X(J,I)*D(I,L)] }.
      #                       J=K            I=1
      # """
      j = 1
      for ll = 1:pb
          dl = bb[ll]
          dll = 1:dl
          il1 = 1:j-1
          j1 = j+dl-1
          l = j:j1
          i = m
          for kk = pa:-1:1
              dk = ba[kk]
              dkk = 1:dk
              i1 = i-dk+1
              k = i1:i
              y = view(E,k,l)
              W1 = view(Xw,dkk,dll)
              if kk < pa
                 ir = i+1:m
                 #W1 = A[k,ir]*E[ir,l]
                 mul!(W1,view(A,k,ir),view(E,ir,l))
                 #y -= W1*B[l,l]
                 mul!(y,W1,view(B,l,l),-ONE,ONE)
                 #W1 = C[k,ir]*E[ir,l]
                 mul!(W1,view(C,k,ir),view(E,ir,l))
                 #y -= W1*D[l,l]
                 mul!(y,W1,view(D,l,l),-SONE,ONE)
              end
              if ll > 1
                 ic = i1:m
                 # WB[k,dll] = E[k,il1]*B[il1,l]
                 mul!(view(WB,k,dll),view(E,k,il1),view(B,il1,l))
                 # WD[k,dll] = E[k,il1]*D[il1,l]
                 mul!(view(WD,k,dll),view(E,k,il1),view(D,il1,l))
                 # y -= (A[k,ic]*WB[ic,dll] + C[k,ic]*WD[ic,dll])
                 mul!(y,view(A,k,ic),view(WB,ic,dll),-ONE,ONE)
                 mul!(y,view(C,k,ic),view(WD,ic,dll),-SONE,ONE)
              end
              gsylv2!(adjAC,adjBD,y,dk,dl,view(A,k,k),view(B,l,l),view(C,k,k),view(D,l,l),Xw,Yw,isgn) 
              i -= dk
          end
          j += dl
      end
   elseif !adjAC && adjBD
         # """
         #  The (K,L)th block of X is determined starting from
         #  bottom-right corner column by column by

         #       A(K,K)*X(K,L)*B(L,L)' + C(K,K)*X(K,L)*D(L,L)' = E(K,L) - R(K,L)

         #  where
         #                        M
         #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L)' +
         #                      J=K+1
         #                        M              N
         #                       SUM { A(K,J) * SUM [X(J,I)*B(L,I)'] } +
         #                       J=K           I=L+1

         #                       M
         #                    { SUM [C(K,J)*X(J,L)] } * D(L,L)' +
         #                     J=K+1
         #                       M              N
         #                      SUM { C(K,J) * SUM [X(J,I)*D(L,I)'] }.
         #                      J=K           I=L+1
         # """
         j = n
         for ll = pb:-1:1
             dl = bb[ll]
             dll = 1:dl
             il1 = j+1:n
             l = j-dl+1:j
             i = m
             for kk = pa:-1:1
                 dk = ba[kk]
                 dkk = 1:dk
                 i1 = i-dk+1
                 k = i1:i
                 y = view(E,k,l)
                 W1 = view(Xw,dkk,dll)
                 if kk < pa
                    ir = i+1:m
                    #W1 = A[k,ir]*E[ir,l]
                    mul!(W1,view(A,k,ir),view(E,ir,l))
                    #y -= W1*B[l,l]'
                    mul!(y,W1,transpose(view(B,l,l)),-ONE,ONE)
                    #W2 = C[k,ir]*E[ir,l]
                    mul!(W1,view(C,k,ir),view(E,ir,l))
                    # y -= W1*D[l,l]'
                    mul!(y,W1,transpose(view(D,l,l)),-SONE,ONE)
                  end
                 if ll < pb
                    ic = i1:m
                    #WB[k,dll] = E[k,il1]*B[l,il1]'
                    mul!(view(WB,k,dll),view(E,k,il1),transpose(view(B,l,il1)))
                    #WD[k,dll] = E[k,il1]*D[l,il1]'
                    mul!(view(WD,k,dll),view(E,k,il1),transpose(view(D,l,il1)))
                    #y -= (A[k,ic]*WB[ic,dll]+C[k,ic]*WD[ic,dll])
                    mul!(y,view(A,k,ic),view(WB,ic,dll),-ONE,ONE)
                    mul!(y,view(C,k,ic),view(WD,ic,dll),-SONE,ONE)
                 end
                 gsylv2!(adjAC,adjBD,y,dk,dl,view(A,k,k),view(B,l,l),view(C,k,k),view(D,l,l),Xw,Yw,isgn) 
                 i -= dk
             end
             j -= dl
         end
   elseif adjAC && !adjBD
      # """
      # The (K,L)th block of X is determined starting from the
      # upper-left corner column by column by

      # A(K,K)'*X(K,L)*B(L,L) + C(K,K)'*X(K,L)*D(L,L) = E(K,L) - R(K,L),

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L) +
      #                       J=1
      #                        K              L-1
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(I,L)] } +
      #                       J=1             I=1

      #                       K-1
      #                     { SUM [C(J,K)'*X(J,L)] } * D(L,L) +
      #                       J=1
      #                        K              L-1
      #                       SUM C(J,K)' * { SUM [X(J,I)*D(I,L)] }.
      #                       J=1             I=1
      # """
      j = 1
      for ll = 1:pb
          dl = bb[ll]
          dll = 1:dl
          il1 = 1:j-1
          j1 = j+dl-1
          l = j:j1
          i = 1
          for kk = 1:pa
              dk = ba[kk]
              dkk = 1:dk
              i1 = i+dk-1
              k = i:i1
              y = view(E,k,l)
              W1 = view(Xw,dkk,dll)
              if kk > 1
                 ir = 1:i-1
                 # W1 = A[ir,k]'*E[ir,l]
                 mul!(W1,transpose(view(A,ir,k)),view(E,ir,l))
                 #y -= W1*B[l,l]
                 mul!(y,W1,view(B,l,l),-ONE,ONE)
                 mul!(W1,transpose(view(C,ir,k)),view(E,ir,l))
                 #y -= W1*D[l,l]
                 mul!(y,W1,view(D,l,l),-SONE,ONE)
              end
              if ll > 1
                 ic = 1:i1
                 #WB[k,dll] = E[k,il1]*B[il1,l]
                 mul!(view(WB,k,dll),view(E,k,il1),view(B,il1,l))
                 #y -= A[ic,k]'*WB[ic,dll]
                 mul!(y,transpose(view(A,ic,k)),view(WB,ic,dll),-ONE,ONE)
                 #WD[k,dll] = E[k,il1]*D[il1,l]
                 mul!(view(WD,k,dll),view(E,k,il1),view(D,il1,l))
                 #y -= C[ic,k]'*WD[ic,dll]
                 mul!(y,transpose(view(C,ic,k)),view(WD,ic,dll),-SONE,ONE)
              end
              gsylv2!(adjAC,adjBD,y,dk,dl,view(A,k,k),view(B,l,l),view(C,k,k),view(D,l,l),Xw,Yw,isgn) 
              i += dk
          end
          j += dl
      end
   elseif adjAC && adjBD
      # """
      # The (K,L)th block of X is determined starting from
      # upper-right corner column by column by

      #            A(K,K)'*X(K,L)*B(L,L)' + C(K,K)'*X(K,L)*D(L,L)' = E(K,L) - R(K,L)

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L)' +
      #                       J=1
      #                        K               N
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(L,I)'] }+
      #                       J=1            I=L+1

      #                       K-1
      #                     { SUM [C(J,K)'*X(J,L)] } * D(L,L)' +
      #                       J=1
      #                        K               N
      #                       SUM C(J,K)' * { SUM [X(J,I)*D(L,I)'] }.
      #                       J=1            I=L+1
      # """
      j = n
      for ll = pb:-1:1
          dl = bb[ll]
          dll = 1:dl
          il1 = j+1:n
          l = j-dl+1:j
          i = 1
          for kk = 1:pa
              dk = ba[kk]
              dkk = 1:dk
              i1 = i+dk-1
              k = i:i1
              y = view(E,k,l)
              W1 = view(Xw,dkk,dll)
              if kk > 1
                 ir = 1:i-1
                 #W1 = A[ir,k]'*E[ir,l]
                 mul!(W1,transpose(view(A,ir,k)),view(E,ir,l))
                 #y -= W1*B[l,l]'
                 mul!(y,W1,transpose(view(B,l,l)),-ONE,ONE)
                 #   W2 = C[ir,k]'*E[ir,l]
               #   y -= W2*D[l,l]'
                 mul!(W1,transpose(view(C,ir,k)),view(E,ir,l))
                 #y -= W1*D[l,l]'
                 mul!(y,W1,transpose(view(D,l,l)),-SONE,ONE)
               end
              if ll < pb
                 ic = 1:i1
                 #WB[k,dll] = E[k,il1]*B[l,il1]'
                 mul!(view(WB,k,dll),view(E,k,il1),transpose(view(B,l,il1)))
                 #WD[k,dll] = E[k,il1]*D[l,il1]'
                 mul!(view(WD,k,dll),view(E,k,il1),transpose(view(D,l,il1)))
                 #y -= (A[ic,k]'*WB[ic,dll] + C[ic,k]'*WD[ic,dll])
                 mul!(y,transpose(view(A,ic,k)),view(WB,ic,dll),-ONE,ONE)
                 mul!(y,transpose(view(C,ic,k)),view(WD,ic,dll),-SONE,ONE)
              end
              gsylv2!(adjAC,adjBD,y,dk,dl,view(A,k,k),view(B,l,l),view(C,k,k),view(D,l,l),Xw,Yw,isgn) 
              i += dk
          end
          j -= dl
      end
   end
   return E
end
function sylvc2!(adjA::Bool,adjB::Bool,C::StridedMatrix{T},na::Int,nb::Int,A::AbstractMatrix{T},B::AbstractMatrix{T},isgn::Int, R::StridedMatrix{T}, Y::AbstractVector{T}) where T <:Real
   # speed and reduced allocation oriented implementation of a solver for 1x1 and 2x2 Sylvester equations: 
   #      A*X + isgn*X*B = C     if adjA = false and adjB = false -> R = kron(I,A)  + isgn*kron(B',I) 
   #      A'*X + isgn*X*B = C    if adjA = true and adjB = false  -> R = kron(I,A') + isgn*kron(B',I)
   #      A*X + isgn*X*B' = C    if adjA = false and adjB = true  -> R = kron(I,A)   + isgn*kron(B,I)
   #      A'*X + isgn*X*B' = C   if adjA = true and adjB = true   -> R = kron(I,A')  + isgn*kron(B,I)
   if na == 1 && nb == 1
      temp = A[1,1] + isgn*B[1,1]
      rmul!(C,inv(temp))
      any(!isfinite, C) &&  throw("ME:SingularException: `A` and `-B` have common eigenvalues")
      return C
   end
   if na == 1 && nb == 2
      @inbounds Y[1] = C[1,1] 
      @inbounds Y[2] = C[1,2] 
   elseif na == 2 && nb == 1
      @inbounds Y[1] = C[1,1] 
      @inbounds Y[2] = C[2,1]
   else # na == 2 && nb == 2
      @inbounds Y[1] = C[1,1] 
      @inbounds Y[2] = C[2,1] 
      @inbounds Y[3] = C[1,2]
      @inbounds Y[4] = C[2,2]
   end

   ZERO = zero(T)
   if !adjA && !adjB
      #R = kron(I,A) + kron(transpose(B),I)
      if na == 1
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = B[2,1]
            @inbounds  R[2,1] = B[1,2]
            @inbounds  R[2,2] = A[1,1]+B[2,2]
         else
            @inbounds  R[1,1] = A[1,1]-B[1,1]
            @inbounds  R[1,2] = -B[2,1]
            @inbounds  R[2,1] = -B[1,2]
            @inbounds  R[2,2] = A[1,1]-B[2,2]
         end
      else
         if nb == 1
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
            end
         else
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[1,3] = B[2,1]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = B[2,1]
               @inbounds  R[3,1] = B[1,2]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]+B[2,2]
               @inbounds  R[3,4] = A[1,2]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = B[1,2]
               @inbounds  R[4,3] = A[2,1]
               @inbounds  R[4,4] = A[2,2]+B[2,2]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[1,3] = -B[2,1]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = -B[2,1]
               @inbounds  R[3,1] = -B[1,2]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]-B[2,2]
               @inbounds  R[3,4] = A[1,2]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = -B[1,2]
               @inbounds  R[4,3] = A[2,1]
               @inbounds  R[4,4] = A[2,2]-B[2,2]
            end
         end
      end
   elseif adjA && !adjB
      #R = kron(I,transpose(A)) + kron(transpose(B),I)
      if na == 1
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = B[2,1]
            @inbounds  R[2,1] = B[1,2]
            @inbounds  R[2,2] = A[1,1]+B[2,2]
         else
            @inbounds  R[1,1] = A[1,1]-B[1,1]
            @inbounds  R[1,2] = -B[2,1]
            @inbounds  R[2,1] = -B[1,2]
            @inbounds  R[2,2] = A[1,1]-B[2,2]
         end
      else
         if nb == 1
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
            end
         else
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[1,3] = B[2,1]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = B[2,1]
               @inbounds  R[3,1] = B[1,2]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]+B[2,2]
               @inbounds  R[3,4] = A[2,1]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = B[1,2]
               @inbounds  R[4,3] = A[1,2]
               @inbounds  R[4,4] = A[2,2]+B[2,2]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[1,3] = -B[2,1]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = -B[2,1]
               @inbounds  R[3,1] = -B[1,2]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]-B[2,2]
               @inbounds  R[3,4] = A[2,1]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = -B[1,2]
               @inbounds  R[4,3] = A[1,2]
               @inbounds  R[4,4] = A[2,2]-B[2,2]
            end
         end
      end
   elseif !adjA && adjB
      #R = kron(I,A) + kron(B,I)
      if na == 1
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = B[1,2]
            @inbounds  R[2,1] = B[2,1]
            @inbounds  R[2,2] = A[1,1]+B[2,2]
         else
            @inbounds  R[1,1] = A[1,1]-B[1,1]
            @inbounds  R[1,2] = -B[1,2]
            @inbounds  R[2,1] = -B[2,1]
            @inbounds  R[2,2] = A[1,1]-B[2,2]
         end
      else
         if nb == 1
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
            end
         else
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[1,3] = B[1,2]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = B[1,2]
               @inbounds  R[3,1] = B[2,1]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]+B[2,2]
               @inbounds  R[3,4] = A[1,2]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = B[2,1]
               @inbounds  R[4,3] = A[2,1]
               @inbounds  R[4,4] = A[2,2]+B[2,2]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[1,2]
               @inbounds  R[1,3] = -B[1,2]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[2,1]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = -B[1,2]
               @inbounds  R[3,1] = -B[2,1]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]-B[2,2]
               @inbounds  R[3,4] = A[1,2]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = -B[2,1]
               @inbounds  R[4,3] = A[2,1]
               @inbounds  R[4,4] = A[2,2]-B[2,2]
            end
        end
      end
   else
      #R = kron(I,transpose(A)) + kron(B,I)
      if na == 1
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]+B[1,1]
            @inbounds  R[1,2] = B[1,2]
            @inbounds  R[2,1] = B[2,1]
            @inbounds  R[2,2] = A[1,1]+B[2,2]
         else
            @inbounds  R[1,1] = A[1,1]-B[1,1]
            @inbounds  R[1,2] = -B[1,2]
            @inbounds  R[2,1] = -B[2,1]
            @inbounds  R[2,2] = A[1,1]-B[2,2]
         end
     else
         if nb == 1
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
            end
         else
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]+B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[1,3] = B[1,2]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]+B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = B[1,2]
               @inbounds  R[3,1] = B[2,1]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]+B[2,2]
               @inbounds  R[3,4] = A[2,1]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = B[2,1]
               @inbounds  R[4,3] = A[1,2]
               @inbounds  R[4,4] = A[2,2]+B[2,2]
            else
               @inbounds  R[1,1] = A[1,1]-B[1,1]
               @inbounds  R[1,2] = A[2,1]
               @inbounds  R[1,3] = -B[1,2]
               @inbounds  R[1,4] = ZERO
               @inbounds  R[2,1] = A[1,2]
               @inbounds  R[2,2] = A[2,2]-B[1,1]
               @inbounds  R[2,3] = ZERO
               @inbounds  R[2,4] = -B[1,2]
               @inbounds  R[3,1] = -B[2,1]
               @inbounds  R[3,2] = ZERO
               @inbounds  R[3,3] = A[1,1]-B[2,2]
               @inbounds  R[3,4] = A[2,1]
               @inbounds  R[4,1] = ZERO
               @inbounds  R[4,2] = -B[2,1]
               @inbounds  R[4,3] = A[1,2]
               @inbounds  R[4,4] = A[2,2]-B[2,2]
            end
        end
      end
   end
   luslv!(R,Y,na*nb) && throw("ME:SingularException: A has eigenvalue(s) α and B has eingenvalu(s) β such that αβ = -1")
    if na == 1 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[1,2] = Y[2]
   elseif na == 2 && nb == 1
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
   else # na == 2 && nb == 2
      @inbounds C[1,1] = Y[1]
      @inbounds C[2,1] = Y[2]
      @inbounds C[1,2] = Y[3]
      @inbounds C[2,2] = Y[4]
   end
   return C
end

@inline function gsylv2!(adjAC::Bool,adjBD::Bool,E::StridedMatrix{T},na::Int,nb::Int,A::AbstractMatrix{T},B::AbstractMatrix{T},C::AbstractMatrix{T},D::AbstractMatrix{T},R::StridedMatrix{T}, Y::AbstractVector{T}, isgn::Int = 1) where T <:Real
   # speed and reduced allocation oriented implementation of a solver for 1x1 and 2x2 generalized Sylvester equations: 
   #      A*X*B + isgn*C*X*D = E     if adjAC = false and adjBD = false -> R = kron(B',A)  + isgn*kron(D',C) 
   #      A'*X*B + isgn*C'*X*D = E   if adjAC = true and adjBD = false  -> R = kron(B',A') + isgn*kron(D',C')
   #      A*X*B' + isgn*C*X*D' = E   if adjAC = false and adjBD = true  -> R = kron(B,A)   + isgn*kron(D,C)
   #      A'*X*B' + isgn*C'*X*D' = E if adjAC = true and adjBD = true   -> R = kron(B,A')  + isgn*kron(D,C')
   if na == 1 && nb == 1
      if isgn > 0
         temp = A[1,1]*B[1,1] + C[1,1]*D[1,1]
      else
         temp = A[1,1]*B[1,1] - C[1,1]*D[1,1]
      end
      rmul!(E,inv(temp))
      any(!isfinite, E) &&  throw("ME:SingularException: `A-λC` and `D+λB` have common eigenvalues")
      return E
   end
   if na == 1 && nb == 2
      @inbounds Y[1] = E[1,1] 
      @inbounds Y[2] = E[1,2] 
   elseif na == 2 && nb == 1
      @inbounds Y[1] = E[1,1] 
      @inbounds Y[2] = E[2,1]
   else # na == 2 && nb == 2
      @inbounds Y[1] = E[1,1] 
      @inbounds Y[2] = E[2,1] 
      @inbounds Y[3] = E[1,2]
      @inbounds Y[4] = E[2,2]
   end

   if !adjAC && !adjBD
      if na == 1
         # R12 =
         # [ a11*b11 + c11*d11, a11*b21 + c11*d21]
         # [ a11*b12 + c11*d12, a11*b22 + c11*d22]
         # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,1]*B[2,1]+C[1,1]*D[2,1];
         #                 A[1,1]*B[1,2]+C[1,1]*D[1,2]  A[1,1]*B[2,2]+C[1,1]*D[2,2]]
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
            @inbounds  R[2,1] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
            @inbounds  R[2,2] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
         else
            @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
            @inbounds  R[2,1] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
            @inbounds  R[2,2] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
         end
      else
         if nb == 1
            # R21 =
            # [ a11*b11 + c11*d11, a12*b11 + c12*d11]
            # [ a21*b11 + c21*d11, a22*b11 + c22*d11]
            # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,2]*B[1,1]+C[1,2]*D[1,1];
            #                 A[2,1]*B[1,1]+C[2,1]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1] ]
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[2,1] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[2,1] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
            end
         else
            # R =
            # [ a11*b11 + c11*d11, a12*b11 + c12*d11, a11*b21 + c11*d21, a12*b21 + c12*d21]
            # [ a21*b11 + c21*d11, a22*b11 + c22*d11, a21*b21 + c21*d21, a22*b21 + c22*d21]
            # [ a11*b12 + c11*d12, a12*b12 + c12*d12, a11*b22 + c11*d22, a12*b22 + c12*d22]
            # [ a21*b12 + c21*d12, a22*b12 + c22*d12, a21*b22 + c21*d22, a22*b22 + c22*d22]
            # (iszero(C[2,1]) && iszero(D[2,1]) && iszero(C[1,2]) && iszero(D[1,2])) ?
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,2]*B[1,1]      A[1,1]*B[2,1]      A[1,2]*B[2,1];
            # A[2,1]*B[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[2,1]*B[2,1]      A[2,2]*B[2,1];
            # A[1,1]*B[1,2]      A[1,2]*B[1,2]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[1,2]*B[2,2];
            # A[2,1]*B[1,2]      A[2,2]*B[1,2]      A[2,1]*B[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]]) :
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,2]*B[1,1]+C[1,2]*D[1,1]      A[1,1]*B[2,1]+C[1,1]*D[2,1]      A[1,2]*B[2,1]+C[1,2]*D[2,1];
            # A[2,1]*B[1,1]+C[2,1]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[2,1]*B[2,1]+C[2,1]*D[2,1]      A[2,2]*B[2,1]+C[2,2]*D[2,1];
            # A[1,1]*B[1,2]+C[1,1]*D[1,2]      A[1,2]*B[1,2]+C[1,2]*D[1,2]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[1,2]*B[2,2]+C[1,2]*D[2,2];
            # A[2,1]*B[1,2]+C[2,1]*D[1,2]      A[2,2]*B[1,2]+C[2,2]*D[1,2]      A[2,1]*B[2,2]+C[2,1]*D[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]])
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
               @inbounds  R[1,4] = A[1,2]*B[2,1]+C[1,2]*D[2,1]
               @inbounds  R[2,1] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[2,1]*B[2,1]+C[2,1]*D[2,1]
               @inbounds  R[2,4] = A[2,2]*B[2,1]+C[2,2]*D[2,1]
               @inbounds  R[3,1] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
               @inbounds  R[3,2] = A[1,2]*B[1,2]+C[1,2]*D[1,2]
               @inbounds  R[3,3] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[1,2]*B[2,2]+C[1,2]*D[2,2]
               @inbounds  R[4,1] = A[2,1]*B[1,2]+C[2,1]*D[1,2]
               @inbounds  R[4,2] = A[2,2]*B[1,2]+C[2,2]*D[1,2]
               @inbounds  R[4,3] = A[2,1]*B[2,2]+C[2,1]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]+C[2,2]*D[2,2]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
               @inbounds  R[1,4] = A[1,2]*B[2,1]-C[1,2]*D[2,1]
               @inbounds  R[2,1] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[2,1]*B[2,1]-C[2,1]*D[2,1]
               @inbounds  R[2,4] = A[2,2]*B[2,1]-C[2,2]*D[2,1]
               @inbounds  R[3,1] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
               @inbounds  R[3,2] = A[1,2]*B[1,2]-C[1,2]*D[1,2]
               @inbounds  R[3,3] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[1,2]*B[2,2]-C[1,2]*D[2,2]
               @inbounds  R[4,1] = A[2,1]*B[1,2]-C[2,1]*D[1,2]
               @inbounds  R[4,2] = A[2,2]*B[1,2]-C[2,2]*D[1,2]
               @inbounds  R[4,3] = A[2,1]*B[2,2]-C[2,1]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]-C[2,2]*D[2,2]
            end
         end
      end
      #R = kron(transpose(B),A) + kron(transpose(D),C)
   elseif adjAC && !adjBD
      if na == 1
         # R12 =
         # [ a11*b11 + c11*d11, a11*b21 + c11*d21]
         # [ a11*b12 + c11*d12, a11*b22 + c11*d22]
         # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,1]*B[2,1]+C[1,1]*D[2,1];
         #                 A[1,1]*B[1,2]+C[1,1]*D[1,2]  A[1,1]*B[2,2]+C[1,1]*D[2,2]]
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
            @inbounds  R[2,1] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
            @inbounds  R[2,2] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
         else
            @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
            @inbounds  R[2,1] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
            @inbounds  R[2,2] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
         end
      else
         if nb == 1
            # R21 =
            # [ a11*b11 + c11*d11, a21*b11 + c21*d11]
            # [ a12*b11 + c12*d11, a22*b11 + c22*d11]
            # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[2,1]*B[1,1]+C[2,1]*D[1,1];
            #                 A[1,2]*B[1,1]+C[1,2]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1] ]
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[2,1] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[2,1] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
            end
         else
            # R =
            # [ a11*b11 + c11*d11, a21*b11 + c21*d11, a11*b21 + c11*d21, a21*b21 + c21*d21]
            # [ a12*b11 + c12*d11, a22*b11 + c22*d11, a12*b21 + c12*d21, a22*b21 + c22*d21]
            # [ a11*b12 + c11*d12, a21*b12 + c21*d12, a11*b22 + c11*d22, a21*b22 + c21*d22]
            # [ a12*b12 + c12*d12, a22*b12 + c22*d12, a12*b22 + c12*d22, a22*b22 + c22*d22]
            # (iszero(C[2,1]) && iszero(D[2,1]) && iszero(C[1,2]) && iszero(D[1,2])) ?
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[2,1]*B[1,1]      A[1,1]*B[2,1]      A[2,1]*B[2,1];
            # A[1,2]*B[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[1,2]*B[2,1]      A[2,2]*B[2,1];
            # A[1,1]*B[1,2]      A[2,1]*B[1,2]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[2,1]*B[2,2];
            # A[1,2]*B[1,2]      A[2,2]*B[1,2]      A[1,2]*B[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]]) :
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[2,1]*B[1,1]+C[2,1]*D[1,1]      A[1,1]*B[2,1]+C[1,1]*D[2,1]      A[2,1]*B[2,1]+C[2,1]*D[2,1];
            # A[1,2]*B[1,1]+C[1,2]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[1,2]*B[2,1]+C[1,2]*D[2,1]      A[2,2]*B[2,1]+C[2,2]*D[2,1];
            # A[1,1]*B[1,2]+C[1,1]*D[1,2]      A[2,1]*B[1,2]+C[2,1]*D[1,2]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[2,1]*B[2,2]+C[2,1]*D[2,2];
            # A[1,2]*B[1,2]+C[1,2]*D[1,2]      A[2,2]*B[1,2]+C[2,2]*D[1,2]      A[1,2]*B[2,2]+C[1,2]*D[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]])
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
               @inbounds  R[1,4] = A[2,1]*B[2,1]+C[2,1]*D[2,1]
               @inbounds  R[2,1] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[1,2]*B[2,1]+C[1,2]*D[2,1]
               @inbounds  R[2,4] = A[2,2]*B[2,1]+C[2,2]*D[2,1]
               @inbounds  R[3,1] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
               @inbounds  R[3,2] = A[2,1]*B[1,2]+C[2,1]*D[1,2]
               @inbounds  R[3,3] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[2,1]*B[2,2]+C[2,1]*D[2,2]
               @inbounds  R[4,1] = A[1,2]*B[1,2]+C[1,2]*D[1,2]
               @inbounds  R[4,2] = A[2,2]*B[1,2]+C[2,2]*D[1,2]
               @inbounds  R[4,3] = A[1,2]*B[2,2]+C[1,2]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]+C[2,2]*D[2,2]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
               @inbounds  R[1,4] = A[2,1]*B[2,1]-C[2,1]*D[2,1]
               @inbounds  R[2,1] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[1,2]*B[2,1]-C[1,2]*D[2,1]
               @inbounds  R[2,4] = A[2,2]*B[2,1]-C[2,2]*D[2,1]
               @inbounds  R[3,1] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
               @inbounds  R[3,2] = A[2,1]*B[1,2]-C[2,1]*D[1,2]
               @inbounds  R[3,3] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[2,1]*B[2,2]-C[2,1]*D[2,2]
               @inbounds  R[4,1] = A[1,2]*B[1,2]-C[1,2]*D[1,2]
               @inbounds  R[4,2] = A[2,2]*B[1,2]-C[2,2]*D[1,2]
               @inbounds  R[4,3] = A[1,2]*B[2,2]-C[1,2]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]-C[2,2]*D[2,2]
            end
         end
      end
      #R = kron(transpose(B),transpose(A)) + kron(transpose(D),transpose(C))
   elseif !adjAC && adjBD
      if na == 1
         # R12 =
         # [ a11*b11 + c11*d11, a11*b12 + c11*d12]
         # [ a11*b21 + c11*d21, a11*b22 + c11*d22]
         # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,1]*B[1,2]+C[1,1]*D[1,2];
         #                 A[1,1]*B[2,1]+C[1,1]*D[2,1]  A[1,1]*B[2,2]+C[1,1]*D[2,2]]
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
            @inbounds  R[2,1] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
            @inbounds  R[2,2] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
         else
            @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
            @inbounds  R[2,1] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
            @inbounds  R[2,2] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
         end
      else
         if nb == 1
            # R21 =
            # [ a11*b11 + c11*d11, a12*b11 + c12*d11]
            # [ a21*b11 + c21*d11, a22*b11 + c22*d11]
            # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,2]*B[1,1]+C[1,2]*D[1,1];
            #                 A[2,1]*B[1,1]+C[2,1]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1] ]
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[2,1] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[2,1] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
            end
         else
            # R =
            # [ a11*b11 + c11*d11, a12*b11 + c12*d11, a11*b12 + c11*d12, a12*b12 + c12*d12]
            # [ a21*b11 + c21*d11, a22*b11 + c22*d11, a21*b12 + c21*d12, a22*b12 + c22*d12]
            # [ a11*b21 + c11*d21, a12*b21 + c12*d21, a11*b22 + c11*d22, a12*b22 + c12*d22]
            # [ a21*b21 + c21*d21, a22*b21 + c22*d21, a21*b22 + c21*d22, a22*b22 + c22*d22]
            # (iszero(C[2,1]) && iszero(D[2,1]) && iszero(C[1,2]) && iszero(D[1,2])) ?
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,2]*B[1,1]      A[1,1]*B[1,2]      A[1,2]*B[1,2];
            # A[2,1]*B[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[2,1]*B[1,2]      A[2,2]*B[1,2];
            # A[1,1]*B[2,1]      A[1,2]*B[2,1]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[1,2]*B[2,2]+C[1,2]*D[2,2];
            # A[2,1]*B[2,1]      A[2,2]*B[2,1]      A[2,1]*B[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]]) :
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,2]*B[1,1]+C[1,2]*D[1,1]      A[1,1]*B[1,2]+C[1,1]*D[1,2]      A[1,2]*B[1,2]+C[1,2]*D[1,2];
            # A[2,1]*B[1,1]+C[2,1]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[2,1]*B[1,2]+C[2,1]*D[1,2]      A[2,2]*B[1,2]+C[2,2]*D[1,2];
            # A[1,1]*B[2,1]+C[1,1]*D[2,1]      A[1,2]*B[2,1]+C[1,2]*D[2,1]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[1,2]*B[2,2]+C[1,2]*D[2,2];
            # A[2,1]*B[2,1]+C[2,1]*D[2,1]      A[2,2]*B[2,1]+C[2,2]*D[2,1]      A[2,1]*B[2,2]+C[2,1]*D[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]])
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
               @inbounds  R[1,4] = A[1,2]*B[1,2]+C[1,2]*D[1,2]
               @inbounds  R[2,1] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[2,1]*B[1,2]+C[2,1]*D[1,2]
               @inbounds  R[2,4] = A[2,2]*B[1,2]+C[2,2]*D[1,2]
               @inbounds  R[3,1] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
               @inbounds  R[3,2] = A[1,2]*B[2,1]+C[1,2]*D[2,1]
               @inbounds  R[3,3] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[1,2]*B[2,2]+C[1,2]*D[2,2]
               @inbounds  R[4,1] = A[2,1]*B[2,1]+C[2,1]*D[2,1]
               @inbounds  R[4,2] = A[2,2]*B[2,1]+C[2,2]*D[2,1]
               @inbounds  R[4,3] = A[2,1]*B[2,2]+C[2,1]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]+C[2,2]*D[2,2]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
               @inbounds  R[1,4] = A[1,2]*B[1,2]-C[1,2]*D[1,2]
               @inbounds  R[2,1] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[2,1]*B[1,2]-C[2,1]*D[1,2]
               @inbounds  R[2,4] = A[2,2]*B[1,2]-C[2,2]*D[1,2]
               @inbounds  R[3,1] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
               @inbounds  R[3,2] = A[1,2]*B[2,1]-C[1,2]*D[2,1]
               @inbounds  R[3,3] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[1,2]*B[2,2]-C[1,2]*D[2,2]
               @inbounds  R[4,1] = A[2,1]*B[2,1]-C[2,1]*D[2,1]
               @inbounds  R[4,2] = A[2,2]*B[2,1]-C[2,2]*D[2,1]
               @inbounds  R[4,3] = A[2,1]*B[2,2]-C[2,1]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]-C[2,2]*D[2,2]
            end
         end
      end
      #R = kron(B,A) + kron(D,C)
   else
      if na == 1
         # R12 =
         # [ a11*b11 + c11*d11, a11*b12 + c11*d12]
         # [ a11*b21 + c11*d21, a11*b22 + c11*d22]
         # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[1,1]*B[1,2]+C[1,1]*D[1,2];
         #                 A[1,1]*B[2,1]+C[1,1]*D[2,1]  A[1,1]*B[2,2]+C[1,1]*D[2,2]]
         if isgn > 0
            @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
            @inbounds  R[2,1] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
            @inbounds  R[2,2] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
         else
            @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
            @inbounds  R[1,2] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
            @inbounds  R[2,1] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
            @inbounds  R[2,2] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
         end
      else
         if nb == 1
            # R21 =
            # [ a11*b11 + c11*d11, a21*b11 + c21*d11]
            # [ a12*b11 + c12*d11, a22*b11 + c22*d11]
            # @inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[2,1]*B[1,1]+C[2,1]*D[1,1];
            #                 A[1,2]*B[1,1]+C[1,2]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1] ]
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[2,1] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[2,1] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
            end
         else
            # R =
            # [ a11*b11 + c11*d11, a21*b11 + c21*d11, a11*b12 + c11*d12, a21*b12 + c21*d12]
            # [ a12*b11 + c12*d11, a22*b11 + c22*d11, a12*b12 + c12*d12, a22*b12 + c22*d12]
            # [ a11*b21 + c11*d21, a21*b21 + c21*d21, a11*b22 + c11*d22, a21*b22 + c21*d22]
            # [ a12*b21 + c12*d21, a22*b21 + c22*d21, a12*b22 + c12*d22, a22*b22 + c22*d22]
            # (iszero(C[2,1]) && iszero(D[2,1]) && iszero(C[1,2]) && iszero(D[1,2])) ?
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[2,1]*B[1,1]      A[1,1]*B[1,2]      A[2,1]*B[1,2];
            # A[1,2]*B[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[1,2]*B[1,2]      A[2,2]*B[1,2];
            # A[1,1]*B[2,1]      A[2,1]*B[2,1]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[2,1]*B[2,2];
            # A[1,2]*B[2,1]      A[2,2]*B[2,1]      A[1,2]*B[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]]) :
            # (@inbounds R = [ A[1,1]*B[1,1]+C[1,1]*D[1,1]      A[2,1]*B[1,1]+C[2,1]*D[1,1]      A[1,1]*B[1,2]+C[1,1]*D[1,2]      A[2,1]*B[1,2]+C[2,1]*D[1,2];
            # A[1,2]*B[1,1]+C[1,2]*D[1,1]  A[2,2]*B[1,1]+C[2,2]*D[1,1]      A[1,2]*B[1,2]+C[1,2]*D[1,2]      A[2,2]*B[1,2]+C[2,2]*D[1,2];
            # A[1,1]*B[2,1]+C[1,1]*D[2,1]      A[2,1]*B[2,1]+C[2,1]*D[2,1]  A[1,1]*B[2,2]+C[1,1]*D[2,2]      A[2,1]*B[2,2]+C[2,1]*D[2,2];
            # A[1,2]*B[2,1]+C[1,2]*D[2,1]      A[2,2]*B[2,1]+C[2,2]*D[2,1]      A[1,2]*B[2,2]+C[1,2]*D[2,2]  A[2,2]*B[2,2]+C[2,2]*D[2,2]])
            if isgn > 0
               @inbounds  R[1,1] = A[1,1]*B[1,1]+C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]+C[2,1]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[1,2]+C[1,1]*D[1,2]
               @inbounds  R[1,4] = A[2,1]*B[1,2]+C[2,1]*D[1,2]
               @inbounds  R[2,1] = A[1,2]*B[1,1]+C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]+C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[1,2]*B[1,2]+C[1,2]*D[1,2]
               @inbounds  R[2,4] = A[2,2]*B[1,2]+C[2,2]*D[1,2]
               @inbounds  R[3,1] = A[1,1]*B[2,1]+C[1,1]*D[2,1]
               @inbounds  R[3,2] = A[2,1]*B[2,1]+C[2,1]*D[2,1]
               @inbounds  R[3,3] = A[1,1]*B[2,2]+C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[2,1]*B[2,2]+C[2,1]*D[2,2]
               @inbounds  R[4,1] = A[1,2]*B[2,1]+C[1,2]*D[2,1]
               @inbounds  R[4,2] = A[2,2]*B[2,1]+C[2,2]*D[2,1]
               @inbounds  R[4,3] = A[1,2]*B[2,2]+C[1,2]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]+C[2,2]*D[2,2]
            else
               @inbounds  R[1,1] = A[1,1]*B[1,1]-C[1,1]*D[1,1]
               @inbounds  R[1,2] = A[2,1]*B[1,1]-C[2,1]*D[1,1]
               @inbounds  R[1,3] = A[1,1]*B[1,2]-C[1,1]*D[1,2]
               @inbounds  R[1,4] = A[2,1]*B[1,2]-C[2,1]*D[1,2]
               @inbounds  R[2,1] = A[1,2]*B[1,1]-C[1,2]*D[1,1]
               @inbounds  R[2,2] = A[2,2]*B[1,1]-C[2,2]*D[1,1]
               @inbounds  R[2,3] = A[1,2]*B[1,2]-C[1,2]*D[1,2]
               @inbounds  R[2,4] = A[2,2]*B[1,2]-C[2,2]*D[1,2]
               @inbounds  R[3,1] = A[1,1]*B[2,1]-C[1,1]*D[2,1]
               @inbounds  R[3,2] = A[2,1]*B[2,1]-C[2,1]*D[2,1]
               @inbounds  R[3,3] = A[1,1]*B[2,2]-C[1,1]*D[2,2]
               @inbounds  R[3,4] = A[2,1]*B[2,2]-C[2,1]*D[2,2]
               @inbounds  R[4,1] = A[1,2]*B[2,1]-C[1,2]*D[2,1]
               @inbounds  R[4,2] = A[2,2]*B[2,1]-C[2,2]*D[2,1]
               @inbounds  R[4,3] = A[1,2]*B[2,2]-C[1,2]*D[2,2]
               @inbounds  R[4,4] = A[2,2]*B[2,2]-C[2,2]*D[2,2]
            end
         end
      end
      #R = kron(B,transpose(A)) + kron(D,transpose(C))
   end
   luslv!(R,Y,na*nb) && throw("ME:SingularException: A has eigenvalue(s) α and B has eingenvalu(s) β such that αβ = -1")
   if na == 1 && nb == 2
      @inbounds E[1,1] = Y[1]
      @inbounds E[1,2] = Y[2]
   elseif na == 2 && nb == 1
      @inbounds E[1,1] = Y[1]
      @inbounds E[2,1] = Y[2]
   else # na == 2 && nb == 2
      @inbounds E[1,1] = Y[1]
      @inbounds E[2,1] = Y[2]
      @inbounds E[1,2] = Y[3]
      @inbounds E[2,2] = Y[4]
   end
   return E
end

function gsylvs!(A::AbstractMatrix{T1}, B::AbstractMatrix{T1}, C::AbstractMatrix{T1}, D::AbstractMatrix{T1}, E::AbstractMatrix{T1}, 
                 WB::AbstractVector{T1} = similar(A,size(A,1)), WD::AbstractVector{T1} = similar(A,size(A,1)); 
                 adjAC::Bool = false, adjBD::Bool = false, isgn::Int = 1, CASchur::Bool = false, DBSchur::Bool = false) where T1<:Complex
   """
   An extension proposed in [1] of the Bartels-Stewart Schur form based approach [2] is employed.

   References:
   [1] K.-W. E. Chu. The solution of the matrix equation AXB – CXD = E and
       (YA – DZ, YC– BZ) = (E, F). Lin. Alg. Appl., 93:93-105, 1987.
   [2] R. H. Bartels and G. W. Stewart. Algorithm 432: Solution of the matrix equation AX+XB=C.
       Comm. ACM, 15:820–826, 1972.
   """
   m, n = size(E);
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,C,D) ||
      throw(DimensionMismatch("A, B, C, D and E have incompatible dimensions"))
   m == length(WB) || throw(DimensionMismatch("WB must be an $m - dimensional vector"))
   m == length(WD) || throw(DimensionMismatch("WD must be an $m - dimensional vector"))

   ZERO = zero(T1)
   SONE = isgn*one(T1)
   if !adjAC && !adjBD
      # """
      # The (K,L)th element of X is determined starting from
      # the bottom-left corner column by column by

      #       A(K,K)*X(K,L)*B(L,L) +C(K,K)*X(K,L)*D(L,L) = E(K,L) - R(K,L)

      # where
      #                        M
      #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L) +
      #                      J=K+1
      #                        M             L-1
      #                       SUM { A(K,J) * SUM [X(J,I)*B(I,L)] } +
      #                       J=K            I=1

      #                       M
      #                    { SUM [C(K,J)*X(J,L)] } * D(L,L) +
      #                     J=K+1
      #                       M             L-1
      #                      SUM { C(K,J) * SUM [X(J,I)*D(I,L)] } +
      #                      J=K            I=1
      # """
      for l = 1:n
          il1 = 1:l-1
          for k = m:-1:1
              y = E[k,l]
              if k < m
                 ta = ZERO
                 tc = ZERO
                 for ir = k+1:m
                     ta += A[k,ir]*E[ir,l]
                     tc += C[k,ir]*E[ir,l]
                 end
                 y -= (ta*B[l,l]+SONE*tc*D[l,l])
              end
              if l > 1
                 ta = ZERO
                 tc = ZERO
                 for ir = il1
                     ta += E[k,ir]*B[ir,l]
                     tc += E[k,ir]*D[ir,l]
                 end
                 WB[k] = ta
                 WD[k] = tc
                 for ic = k:m
                     y -= (A[k,ic]*WB[ic]+SONE*C[k,ic]*WD[ic])
                 end
              end
              E[k,l] = y/(B[l,l]*A[k,k]+SONE*D[l,l]*C[k,k])
              isfinite(E[k,l]) || throw("ME:SingularException: A-λC and D+λB have common or close eigenvalues")
          end
      end
   elseif !adjAC && adjBD
         # """
         #  The (K,L)th element of X is determined starting from
         #  the bottom-right corner column by column by

         #       A(K,K)*X(K,L)*B(L,L)' + C(K,K)*X(K,L)*D(L,L)' = E(K,L) - R(K,L)

         #  where
         #                        M
         #            R(K,L) = { SUM [A(K,J)*X(J,L)] } * B(L,L)' +
         #                      J=K+1
         #                        M              N
         #                       SUM { A(K,J) * SUM [X(J,I)*B(L,I)'] } +
         #                       J=K           I=L+1

         #                       M
         #                    { SUM [C(K,J)*X(J,L)] } * D(L,L)' +
         #                     J=K+1
         #                       M              N
         #                      SUM { C(K,J) * SUM [X(J,I)*D(L,I)'] }.
         #                      J=K           I=L+1
         # """
         for l = n:-1:1
             il1 = l+1:n
             for k = m:-1:1
                 y = E[k,l]
                 if k < m
                    ta = ZERO
                    tc = ZERO
                    for ir = k+1:m
                        ta += A[k,ir]*E[ir,l]
                        tc += C[k,ir]*E[ir,l]
                    end
                    y -= (ta*B[l,l]'+SONE*tc*D[l,l]')
                 end
                 if l < n
                    ta = ZERO
                    tc = ZERO
                    for ir = il1
                        ta += E[k,ir]*B[l,ir]'
                        tc += E[k,ir]*D[l,ir]'
                    end
                    WB[k] = ta
                    WD[k] = tc
                    for ic = k:m
                        y -= (A[k,ic]*WB[ic]+SONE*C[k,ic]*WD[ic])
                    end
                 end
                 E[k,l] = y/(B[l,l]'*A[k,k]+SONE*D[l,l]'*C[k,k])
                 isfinite(E[k,l]) || throw("ME:SingularException: A-λC and D'+λB' have common or close eigenvalues")
             end
         end
   elseif adjAC && !adjBD
      # """
      # The (K,L)th element of X is determined starting from the
      # upper-left corner column by column by

      # A(K,K)'*X(K,L)*B(L,L) + C(K,K)'*X(K,L)*D(L,L) = E(K,L) - R(K,L),

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L) +
      #                       J=1
      #                        K              L-1
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(I,L)] } +
      #                       J=1             I=1

      #                       K-1
      #                     { SUM [C(J,K)'*X(J,L)] } * D(L,L) +
      #                       J=1
      #                        K              L-1
      #                       SUM C(J,K)' * { SUM [X(J,I)*D(I,L)] }.
      #                       J=1             I=1
      # """
      for l = 1:n
          il1 = 1:l-1
          for k = 1:m
              y = E[k,l]
              if k > 1
                 ta = ZERO
                 tc = ZERO
                 for ir = 1:k-1
                     ta += A[ir,k]'*E[ir,l]
                     tc += C[ir,k]'*E[ir,l]
                 end
                 y -= (ta*B[l,l]+SONE*tc*D[l,l])
              end
              if l > 1
                 ta = ZERO
                 tc = ZERO
                 for ir = il1
                     ta += E[k,ir]*B[ir,l]
                     tc += E[k,ir]*D[ir,l]
                 end
                 WB[k] = ta
                 WD[k] = tc
                 for ic = 1:k
                     y -= (A[ic,k]'*WB[ic]+SONE*C[ic,k]'*WD[ic])
                 end
              end
              E[k,l] = y/(B[l,l]*A[k,k]'+SONE*D[l,l]*C[k,k]')
              isfinite(E[k,l]) || throw("ME:SingularException: A'-λC' and D+λB have common or close eigenvalues")
          end
      end
   elseif adjAC && adjBD
      # """
      # The (K,L)th element of X is determined starting from
      # the upper-right corner column by column by

      #       A(K,K)'*X(K,L)*B(L,L)' + C(K,K)'*X(K,L)*D(L,L)' = E(K,L) - R(K,L)

      # where
      #                       K-1
      #            R(K,L) = { SUM [A(J,K)'*X(J,L)] } * B(L,L)' +
      #                       J=1
      #                        K               N
      #                       SUM A(J,K)' * { SUM [X(J,I)*B(L,I)'] }+
      #                       J=1            I=L+1

      #                       K-1
      #                     { SUM [C(J,K)'*X(J,L)] } * D(L,L)' +
      #                       J=1
      #                        K               N
      #                       SUM C(J,K)' * { SUM [X(J,I)*D(L,I)'] }.
      #                       J=1            I=L+1
      # """
      for l = n:-1:1
          il1 = l+1:n
          for k = 1:m
              y = E[k,l]
              if k > 1
                 ta = ZERO
                 tc = ZERO
                 for ir = 1:k-1
                     ta += A[ir,k]'*E[ir,l]
                     tc += C[ir,k]'*E[ir,l]
                 end
                 y -= (ta*B[l,l]'+SONE*tc*D[l,l]')
               end
               if l < n
                  ta = ZERO
                  tc = ZERO
                  for ir = il1
                      ta += E[k,ir]*B[l,ir]'
                      tc += E[k,ir]*D[l,ir]'
                  end
                  WB[k] = ta
                  WD[k] = tc
                  for ic = 1:k
                      y -= (A[ic,k]'*WB[ic]+SONE*C[ic,k]'*WD[ic])
                  end
               end
              E[k,l] = y/(B[l,l]'*A[k,k]'+SONE*D[l,l]'*C[k,k]')
              isfinite(E[k,l]) || throw("ME:SingularException: A'-λC' and D'+λB' have common or close eigenvalues")
          end
      end
   end
   return E
end
"""
    (X,Y) = sylvsyss!(A,B,C,D,E,F)

Solve the Sylvester system of matrix equations

                AX + YB = C
                DX + YE = F,

where `(A,D)`, `(B,E)` are pairs of square matrices of the same size in generalized Schur forms.
The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues. The computed
solution `(X,Y)` is contained in `(C,F)`.

_Note:_ This is an enhanced interface to the `LAPACK.tgsyl!` function to also cover the case when
`A`, `B`, `D` and `E` are real matrices and `C` and `F` are complex matrices.
"""
function sylvsyss!(A::T1, B::T1, C::T1, D::T1, E::T1, F::T1) where {T<:BlasFloat,T1<:Matrix{T}}
   """
   This is a wrapper to the LAPACK.tgsyl! function with `trans = 'N'`.
   """
   C, F, scale =  tgsyl!('N',A,B,C,D,E,F)
   scale == one(T) || error("Singular Sylvester system")
   return rmul!(C,inv(scale)), rmul!(F,inv(-scale))
end
"""
    (X,Y) = dsylvsyss!(A,B,C,D,E,F)

Solve the dual Sylvester system of matrix equations

    A'X + D'Y = C
    XB' + YE' = F,

where `(A,D)`, `(B,E)` are pairs of square matrices of the same size in generalized Schur forms.
The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues. The computed
solution `(X,Y)` is contained in `(C,F)`.
"""
function dsylvsyss!(A::T1, B::T1, C::T1, D::T1, E::T1, F::T1) where {T<:BlasFloat,T1<:Matrix{T}}
   """
   This is an interface to the LAPACK.tgsyl! function with `trans = 'T' or `trans = 'C'`.
   """
   rmul!(F,-1)
   C, F, scale =  tgsyl!(T <: Complex ? 'C' : 'T', A, B, C, D, E, F)
   scale == one(T) || error("Singular Sylvester system")
   rmul!(view(C,:,:),inv(scale))
   rmul!(view(F,:,:),inv(scale))
   return C, F
end
function sylvcs2!(A::AbstractMatrix{T1},B::AbstractMatrix{T1},C::AbstractMatrix{T1}; adj = false) where {T1<:Real}
   n = LinearAlgebra.checksquare(A)
   m = LinearAlgebra.checksquare(B)
   m <= 2 || throw(DimensionMismatch("B must be a 1×1 or 2×2 matrix"))
   (n,m) == size(C) ||
      throw(DimensionMismatch("C must be a $n x $m matrix"))

   ONE = one(T1)

   # determine the structure of the real Schur form
   ba, p = sfstruct(A)

   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   
   if adj
      # """
      # The (K,1)th block of X is determined starting from
      # the upper-left corner column by column by

      # A(K,K)'*X(K,1) + X(K,1)*B(1,1) = -C(K,1) - R(K,1),

      # where
      #          K-1                    
      # R(K,1) = SUM [A(I,K)'*X(I,L)] 
      #          I=1                    
      # """

      l = 1:m
      i = 1
      for kk = 1:p
          dk = ba[kk]
          k = i:i+dk-1
          y = view(C,k,l)
          if kk > 1
             ir = 1:i-1
             # y += A[ia,k]'*C[ia,l]
             mul!(y,transpose(view(A,ir,k)),view(C,ir,l),ONE,ONE)
          end
          lyapcsylv2!(adj,y,dk,m,view(A,k,k),B,Xw,Yw)
          i += dk
      end
   else
      # """
      # The (K,1)th block of X is determined starting from
      # the bottom-right corner column by column by

      # A(K,K)*X(K,1) + X(K,1)*B(1,1)' = -C(K,1) - R(K,1),

      # where
      #           N                     
      # R(K,1) = SUM [A(K,I)*X(I,1)] 
      #         I=K+1                 
      # """
      l = 1:m
      i = n
      for kk = p:-1:1
          dk = ba[kk]
          i1 = i-dk+1
          k = i1:i
          y = view(C,k,l)
          if kk < p
             ia = i+1:n
             #  y += A[k,ia]*C[ia,l]
             mul!(y,view(A,k,ia),view(C,ia,l),ONE,ONE)
          end
          lyapcsylv2!(adj,y,dk,m,view(A,k,k),B,Xw,Yw)
          i -= dk
      end
   end
   C
end
function sylvcs1!(A::AbstractMatrix{T1},B::AbstractMatrix{T1},C::AbstractMatrix{T1}; adj = false) where {T1<:Complex}
   n = LinearAlgebra.checksquare(A)
   m = LinearAlgebra.checksquare(B)
   m == 1 || throw(DimensionMismatch("B must be an 1×1 matrix"))
   (n,m) == size(C) ||
      throw(DimensionMismatch("C must be a $n x $m matrix"))

   ONE = one(real(T1))


   Xw = Matrix{T1}(undef,4,4)
   Yw = Vector{T1}(undef,4)
   
   if adj
      # """
      # The (K,1)th block of X is determined starting from
      # the upper-left corner column by column by

      # A(K,K)'*X(K,1) + X(K,1)*B(1,1) = -C(K,1) - R(K,1),

      # where
      #          K-1                    
      # R(K,1) = SUM [A(I,K)'*X(I,L)] 
      #          I=1                    
      # """

      l = 1:1
      for i = 1:n
          k = i:i
          y = view(C,k,l)
          if i > 1
             ir = 1:i-1
             # y += A[ia,k]'*C[ia,l]
             mul!(y,adjoint(view(A,ir,k)),view(C,ir,l),ONE,ONE)
          end
          #lyapcsylv2!(adj,y,1,1,view(A,k,k),B,Xw,Yw)
          C[i,1] = -(A[i,i]'+B[1,1])\y[1]
          isfinite(C[i,1]) || error("Singular Lyapunov equation")
       end
   else
      # """
      # The (K,1)th block of X is determined starting from
      # the bottom-right corner column by column by

      # A(K,K)*X(K,1) + X(K,1)*B(1,1)' = -C(K,1) - R(K,1),

      # where
      #           N                     
      # R(K,1) = SUM [A(K,I)*X(I,1)] 
      #         I=K+1                 
      # """
      l = 1:1
      for i = n:-1:1
          k = i:i
          y = view(C,k,l)
          if i < n
             ia = i+1:n
             #  y += A[k,ia]*C[ia,l]
             mul!(y,view(A,k,ia),view(C,ia,l),ONE,ONE)
          end
          C[i,1] = -(A[i,i]+B[1,1]')\y[1]
          isfinite(C[i,1]) || error("Singular Lyapunov equation")
      end
   end
   C
end
function sylvsyss!(A::T1, B::T1, C::T1, D::T1, E::T1, F::T1) where {T<:Complex,T1<:AbstractMatrix{T}}
   """
   Solve the Sylvester system of matrix equations

   AX + YB = C
   DX + YE = F,

   where `(A,D)`, `(B,E)` are pairs of square matrices of the same size in generalized Schur forms.
   The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues. The computed
   solution `(X,Y)` is contained in `(C,F)`.

   References:
   [1] B. Kagstrom and L. Westin, Generalized Schur Methods with Condition Estimators for Solving 
       the Generalized Sylvester Equation, 
       IEEE Transactions on Automatic Control, Vol. 34, No. 7,  pp 745-751, 1989.
   """
   m, n = size(C);
   (m == size(F,1) && n == size(F,2)) ||
     throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,D,E) ||
      throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))
   Aw = Matrix{T}(undef,2,2)
   Bw = Vector{T}(undef,2)
   # """
   # The (K,L)th elements of X and Y are determined starting from
   # bottom-left corner column by column by

   #       A(K,K)*X(K,L) + Y(K,L)*B(L,L) = C(K,L) - P(K,L)
   #       C(K,K)*X(K,L) + Y(K,L)*E(L,L) = F(K,L) - R(K,L)

   # where
   #                        M                     L-1
   #            P(K,L) =   SUM [A(K,J)*X(J,L)]  + SUM [Y(K,I)*B(I,L)] 
   #                      J=K+1                   I=1
   #                        M                     L-1
   #            R(K,L) =   SUM [D(K,J)*X(J,L)]  + SUM [Y(K,I)*E(I,L)] 
   #                      J=K+1                   I=1
   #
   # """
   for l = 1:n
      il1 = 1:l-1
      for k = m:-1:1
          y = C[k,l]
          z = F[k,l]
          if k < m
             for ir = k+1:m
                 y -= A[k,ir]*C[ir,l]
                 z -= D[k,ir]*C[ir,l]
             end
          end
          if l > 1
             for ir = il1
                 y -= F[k,ir]*B[ir,l]
                 z -= F[k,ir]*E[ir,l]
             end
          end
          Aw = [A[k,k] B[l,l]; D[k,k] E[l,l]]
          Bw = [y; z]
          luslv!(Aw,Bw) && throw("ME:SingularException: Singular system of Sylvester equations")
          C[k,l] = Bw[1]
          F[k,l] = Bw[2]
      end
   end
   return C, F
end
function sylvsyss!(A::T1, B::T1, C::T1, D::T1, E::T1, F::T1) where {T<:Real,T1<:AbstractMatrix{T}}
   """
   Solve the Sylvester system of matrix equations

   AX + YB = C
   DX + YE = F,

   where `(A,D)`, `(B,E)` are pairs of square matrices of the same size in generalized Schur forms.
   The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues. The computed
   solution `(X,Y)` is contained in `(C,F)`.

   References:
   [1] B. Kagstrom and L. Westin, Generalized Schur Methods with Condition Estimators for Solving 
       the Generalized Sylvester Equation, 
       IEEE Transactions on Automatic Control, Vol. 34, No. 7,  pp 745-751, 1989.
   """
   m, n = size(C);
   (m == size(F,1) && n == size(F,2)) ||
     throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,D,E) ||
      throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))

   ONE = one(T)

   # determine the structure of the generalized real Schur forms of (A,D) and (B,E)
   (ba, pa) = sfstruct(A)
   (bb, pb) = sfstruct(B)

   # Xw = Matrix{T1}(undef,8,8)
   # Yw = Vector{T1}(undef,8)
   # """
   # The (K,L)th elements of X and Y are determined starting from
   # bottom-left corner column by column by

   #       A(K,K)*X(K,L) + Y(K,L)*B(L,L) = C(K,L) - P(K,L)
   #       C(K,K)*X(K,L) + Y(K,L)*E(L,L) = F(K,L) - R(K,L)

   # where
   #                        M                     L-1
   #            P(K,L) =   SUM [A(K,J)*X(J,L)]  + SUM [Y(K,I)*B(I,L)] 
   #                      J=K+1                   I=1
   #                        M                     L-1
   #            R(K,L) =   SUM [D(K,J)*X(J,L)]  + SUM [Y(K,I)*E(I,L)] 
   #                      J=K+1                   I=1
   #
   # """
   j = 1
   for ll = 1:pb
       dl = bb[ll]
       il1 = 1:j-1
       l = j:j+dl-1
       i = m
       for kk = pa:-1:1
           dk = ba[kk]
           k = i-dk+1:i
           y = view(C,k,l)
           z = view(F,k,l)
           if kk < pa
              ir = i+1:m
              mul!(y,view(A,k,ir),view(C,ir,l),-ONE,ONE)
              mul!(z,view(D,k,ir),view(C,ir,l),-ONE,ONE)
           end
           if ll > 1
              mul!(y,view(F,k,il1),view(B,il1,l),-ONE,ONE)
              mul!(z,view(F,k,il1),view(E,il1,l),-ONE,ONE)
           end
           C[k,l], F[k,l] = sylvsyskr(A[k,k], B[l,l], y, D[k,k], E[l,l], z)
           # sylvsys2!(dk,dl,view(A,k,k),view(B,l,l),y,view(D,k,k),view(E,l,l),z,Xw,Yw) 
           i -= dk
       end
       j += dl
   end
   return C, F
end
function dsylvsyss!(adj::Bool,A::T1, B::T1, C::T1, D::T1, E::T1, F::T1) where {T<:Complex,T1<:AbstractMatrix{T}}
   # """
   #     (X,Y) = dsylvsyss!(adj,A,B,C,D,E,F)

   # Solve the following dual Sylvester systems of matrix equations
   # for adj = false
   #     AX + DY = C
   #     XB + YE = F 
   #
   # for adj = true
   #     A'X + D'Y = C
   #     XB' + YE' = F,

   # where `(A,D)`, `(B,E)` are pairs of square matrices of the same size in generalized Schur forms.
   # The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues. The computed
   # solution `(X,Y)` is contained in `(C,F)`.
   # """
   adj && (T1 <: BlasComplex) && (return dsylvsyss!(A,B,C,D,E,F))

   m, n = size(C);
   (m == size(F,1) && n == size(F,2)) ||
   throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,D,E) ||
      throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))
   
   Aw = Matrix{T}(undef,2,2)
   Bw = Vector{T1}(undef,2)
   if adj
      # """
      # The (K,L)th elements of X and Y are determined starting from
      # the upper-right corner column by column by

      #       A(K,K)'*X(K,L) + D(K,K)'*Y(K,L) = C(K,L) - P(K,L)
      #       X(K,L)*B(L,L)' + Y(K,L)*E(L,L)' = F(K,L) - R(K,L)

      # where
      #                       K-1                       K-1                    
      #            P(K,L) =   SUM [A(J,K)'*X(J,L)]  +   SUM [D(J,K)'*Y(J,L)]    
      #                       J=1                       J=1                    
      #                        N                         N
      #            R(K,L) =   SUM [X(K,I)*B(L,I)']  +   SUM [Y(K,I)*E(L,I)'] 
      #                      I=L+1                     I=L+1
      # """
      for l = n:-1:1
          il1 = l+1:n
          for k = 1:m
              y = C[k,l]
              z = F[k,l]
              if k > 1
                 for ir = 1:k-1
                     y -= A[ir,k]'*C[ir,l]
                     y -= D[ir,k]'*F[ir,l]
                 end
              end
              if l < n
                 for ir = il1
                     z -= C[k,ir]*B[l,ir]'
                     z -= F[k,ir]*E[l,ir]'
                 end
              end
              Aw = [A[k,k]' D[k,k]'; B[l,l]' E[l,l]']
              Bw = [y; z]
              luslv!(Aw,Bw) && throw("ME:SingularException: Singular system of Sylvester equations")
              C[k,l] = Bw[1]
              F[k,l] = Bw[2]
          end
      end
   else
      # """
      # The (K,L)th elements of X and Y are determined starting from
      # the upper-right corner column by column by

      #       A(K,K)*X(K,L) + D(K,K)*Y(K,L) = C(K,L) - P(K,L)
      #       X(K,L)*B(L,L) + Y(K,L)*E(L,L) = F(K,L) - R(K,L)

      # where
      #                        M                      M                   
      #            P(K,L) =   SUM [A(K,J)*X(J,L)]  + SUM [D(K,J)*Y(J,L)]  
      #                      J=K+1                  J=K+1                 
      #                       L-1                    L-1
      #            R(K,L) =   SUM [X(K,I)*B(I,L)]  + SUM [Y(K,I)*E(I,L)] 
      #                       I=1                    I=1
      for l = 1:n
          il1 = 1:l-1
          for k = m:-1:1
              y = C[k,l]
              z = F[k,l]
              if k < m
                 for ir = k+1:m
                     y -= A[k,ir]*C[ir,l]
                     y -= D[k,ir]*F[ir,l]
                 end
              end
              if l > 1
                 for ir = il1
                     z -= C[k,ir]*B[ir,l]
                     z -= F[k,ir]*E[ir,l]
                 end
              end
              Aw = [A[k,k] D[k,k]; B[l,l] E[l,l]]
              Bw = [y; z]
              luslv!(Aw,Bw) && throw("ME:SingularException: Singular system of Sylvester equations")
              C[k,l] = Bw[1]
              F[k,l] = Bw[2]
          end
       end
  end
  return C, F
end
function dsylvsyss!(adj::Bool,A::T1, B::T1, C::T1, D::T1, E::T1, F::T1) where {T<:Real,T1<:AbstractMatrix{T}}
   # """
   #     (X,Y) = dsylvsyss!(A,B,C,D,E,F)

   # Solve the following dual Sylvester systems of matrix equations
   # for adj = false
   #     AX + DY = C
   #     XB + YE = F 
   #
   # for adj = true
   #     A'X + D'Y = C
   #     XB' + YE' = F,

   # where `(A,D)`, `(B,E)` are pairs of square matrices of the same size in generalized Schur forms.
   # The pencils `A-λD` and `-B+λE` must be regular and must not have common eigenvalues. The computed
   # solution `(X,Y)` is contained in `(C,F)`.
   # """
   adj && (T1 <: BlasReal) && (return dsylvsyss!(A,B,C,D,E,F))

   m, n = size(C);
   (m == size(F,1) && n == size(F,2)) ||
   throw(DimensionMismatch("C and F must have the same dimensions"))
   [m; n; m; n] == LinearAlgebra.checksquare(A,B,D,E) ||
      throw(DimensionMismatch("A, B, C, D, E and F have incompatible dimensions"))

   ONE = one(T)

   # determine the structure of the generalized real Schur forms of (A,D) and (B,E)
   (ba, pa) = sfstruct(A)
   (bb, pb) = sfstruct(B)

   # Xw = Matrix{T1}(undef,8,8)
   # Yw = Vector{T1}(undef,8)
   if adj
      # """
      # The (K,L)th elements of X and Y are determined starting from
      # the upper-right corner column by column by

      #       A(K,K)'*X(K,L) + D(K,K)'*Y(K,L) = C(K,L) - P(K,L)
      #       X(K,L)*B(L,L)' + Y(K,L)*E(L,L)' = F(K,L) - R(K,L)

      # where
      #                       K-1                       K-1                    
      #            P(K,L) =   SUM [A(J,K)'*X(J,L)]  +   SUM [D(J,K)'*Y(J,L)]    
      #                       J=1                       J=1                    
      #                        N                         N
      #            R(K,L) =   SUM [X(K,I)*B(L,I)']  +   SUM [Y(K,I)*E(L,I)'] 
      #                      I=L+1                     I=L+1
      # """
      j = n
      for ll = pb:-1:1
          dl = bb[ll]
          il1 = j+1:n
          l = j-dl+1:j
          i = 1
          for kk = 1:pa
              dk = ba[kk]
              k = i:i+dk-1
              y = view(C,k,l)
              z = view(F,k,l)
              if kk > 1
                 ir = 1:i-1
                 mul!(y,transpose(view(A,ir,k)),view(C,ir,l),-ONE,ONE)
                 mul!(y,transpose(view(D,ir,k)),view(F,ir,l),-ONE,ONE)
              end
              if ll < pb
                 mul!(z,view(C,k,il1),transpose(view(B,l,il1)),-ONE,ONE)
                 mul!(z,view(F,k,il1),transpose(view(E,l,il1)),-ONE,ONE)
              end
              C[k,l], F[k,l] = dsylvsyskr(A[k,k]', B[l,l]', y, D[k,k]', E[l,l]', z)
              # dsylvsys2!(adj,dk,dl,view(A,k,k),view(B,l,l),y,view(D,k,k),view(E,l,l),z,Xw,Yw) 
              i += dk
          end
          j -= dl
      end
   else 
      # """
      # The (K,L)th elements of X and Y are determined starting from
      # the upper-right corner column by column by

      #       A(K,K)*X(K,L) + D(K,K)*Y(K,L) = C(K,L) - P(K,L)
      #       X(K,L)*B(L,L) + Y(K,L)*E(L,L) = F(K,L) - R(K,L)

      # where
      #                        M                      M                   
      #            P(K,L) =   SUM [A(K,J)*X(J,L)]  + SUM [D(K,J)*Y(J,L)]  
      #                      J=K+1                  J=K+1                 
      #                       L-1                    L-1
      #            R(K,L) =   SUM [X(K,I)*B(I,L)]  + SUM [Y(K,I)*E(I,L)] 
      #                       I=1                    I=1
      j = 1
      for ll = 1:pb
          dl = bb[ll]
          il1 = 1:j-1
          l = j:j+dl-1
          i = m
          for kk = pa:-1:1
              dk = ba[kk]
              k = i-dk+1:i
              y = view(C,k,l)
              z = view(F,k,l)
              if kk < pa
                 ir = i+1:m
                 mul!(y,view(A,k,ir),view(C,ir,l),-ONE,ONE)
                 mul!(y,view(D,k,ir),view(F,ir,l),-ONE,ONE)
              end
              if ll > 1
                 mul!(z,view(C,k,il1),view(B,il1,l),-ONE,ONE)
                 mul!(z,view(F,k,il1),view(E,il1,l),-ONE,ONE)
              end
              C[k,l], F[k,l] = dsylvsyskr(A[k,k], B[l,l], y, D[k,k], E[l,l], z)
              # dsylvsys2!(adj,dk,dl,view(A,k,k),view(B,l,l),y,view(D,k,k),view(E,l,l),z,Xw,Yw) 
              i -= dk
          end
          j += dl
      end
   end
   return C, F   
end

module Test_MEcondest

using LinearAlgebra
using LinearMaps
using MatrixEquations
using Test

function check_ctranspose(op::LinearMaps.LinearMap{T}) where {T <: Union{AbstractFloat, Complex}}
   (m, n) = size(op)
   x = rand(T,n)
   y = rand(T,m)
   yAx = dot(y, op * x)
   xAty = dot(x, op' * y)
   ε = eps(real(eltype(op)))
   return abs(yAx - conj(xAty)) < (abs(yAx) + ε) * ε^(1 / 3)
end
   
    
println("Test_MEcondest")

#@testset "Testing Lyapunov and Sylvester operators" begin

n = 10; m = 5;
reltol = sqrt(eps(10.));
sc = 0.1;

@testset "Continuous Lyapunov operators" begin

#n = 3
ar = rand(n,n);
cr = rand(n,m);
cc = cr+im*rand(n,m);
cr = cr*cr';
as,  = schur(ar);
ac = ar+im*rand(n,n);
cc = cc*cc';
acs,  = schur(ac);
ur = triu(ar)
uc = triu(ac)

Tcr = lyapop(ar);
Tcrinv = invlyapop(ar);
Tcrs = lyapop(as);
Tcrsinv = invlyapop(as);
Tcrsym = lyapop(ar,her=true);
Tcrsyminv = invlyapop(ar,her=true);
Tcrssym = lyapop(as,her=true);
Tcrssyminv = invlyapop(as,her=true);

# define some T/H-Lyapunov operators for upper triangular arguments
Ttur = tulyaplikeop(ur,adj = true)
Ttaur = tulyaplikeop(ur,adj = false)
Ttuc = tulyaplikeop(uc,adj = true)
Ttauc = tulyaplikeop(uc,adj = false)
Thur = hulyaplikeop(ur,adj = true)
Thaur = hulyaplikeop(ur,adj = false)
Thuc = hulyaplikeop(uc,adj = true)
Thauc = hulyaplikeop(uc,adj = false)


Tcc = lyapop(ac);
Tccinv = invlyapop(ac);
Tccs = lyapop(acs);
Tccsinv = invlyapop(acs);
Tccsym = lyapop(ac,her=true);
Tccsyminv = invlyapop(ac,her=true);
Tccssym = lyapop(acs,her=true);
Tccssyminv = invlyapop(acs,her=true);
Π = trmatop(n); MPn = Matrix(Π)
@test issymmetric(Π) && ishermitian(Π)
@test size(Tcr) == size(Tcr') == size(Tcrinv)
Ln = eliminationop(n); MLn = Matrix(Ln)
Dn = duplicationop(n); MDn = Matrix(Dn)
@test MLn == Matrix(eliminationop(ar))
@test MDn == Matrix(duplicationop(ar))
@test MPn == MDn*MDn' + MLn'*MLn*MPn*MLn'*MLn - I
@test (Ln'*Ln*Π*Ln'*Ln)*vec(ar) == vec(Diagonal(ar))


@test check_ctranspose(Tcr) &&
      check_ctranspose(Tcrinv) &&
      check_ctranspose(Tcrs) &&
      check_ctranspose(Tcrsinv) &&
      check_ctranspose(Tcrsym) &&
      Matrix(Tcrsyminv') ≈  Matrix(Tcrsyminv)' &&
      Matrix(Tcrssyminv') ≈  Matrix(Tcrssyminv)' &&
      #check_ctranspose(Tcrsyminv) &&
      #check_ctranspose(Tcrssyminv) &&
      check_ctranspose(Tcc) &&
      check_ctranspose(Tccinv) &&
      check_ctranspose(Tccs) &&
      check_ctranspose(Tccsinv) &&
      Matrix(Tccsinv') ≈  Matrix(Tccsinv)'
      #check_ctranspose(Tccsym) &&
      #check_ctranspose(Tccsyminv) &&
      #check_ctranspose(Tccssyminv) &&
      #check_ctranspose(Tccssyminv) 

@test opnorm1(invlyapop([ 0 0;0 0])) == Inf

try
   T1 = invlyapop([1 0;0 1])
   T1 = invlyapop(convert(Matrix{Float32},as))
   T = invlyapop(as);
   T*rand(n*n);
   transpose(T)*rand(n*n);
   adjoint(T)*rand(n*n);
   T*rand(Float32,n*n);
   transpose(T)*rand(Float32,n*n);
   adjoint(T)*rand(Float32,n*n);
   T*ones(Int,n*n);
   transpose(T)*ones(Int,n*n);
   adjoint(T)*ones(Int,n*n);
   T*ones(Rational{Int},n*n);
   T1 = invlyapop(convert(Matrix{Complex{Float32}},acs));
   T = invlyapop(acs);
   T*rand(n*n);
   T*complex(rand(n*n));
   transpose(T)*rand(n*n);
   transpose(T)*complex(rand(n*n));
   adjoint(T)*rand(n*n);
   adjoint(T)*complex(rand(n*n));
   lyapop(schur(ar))
   lyapop(2)
   @test true
catch
   @test false
end 
 

@time x = Tcrinv*cr[:];
@test norm(Tcr*x-cr[:])/norm(x[:]) < reltol

@time x = Tcrinv*cc[:];
@test norm(Tcr*x-cc[:])/norm(x[:]) < reltol

@time x = Tcrsyminv*triu2vec(cr);
@test norm(Tcrsym*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = transpose(Tcrinv)*cr[:];
@test norm(transpose(Tcr)*x-cr[:])/norm(x[:]) < reltol

@time x = transpose(Tcrinv)*cc[:];
@test norm(transpose(Tcr)*x-cc[:])/norm(x[:]) < reltol

@time x = Tcrinv'*cc[:];
@test norm(Tcr'*x-cc[:])/norm(x[:]) < reltol

@time x = transpose(Tcrsyminv)*triu2vec(cr);
@test norm(transpose(Tcrsym)*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tcrsinv*cr[:];
@test norm(Tcrs*x-cr[:])/norm(x[:]) < reltol

@time x = Tcrsinv*cc[:];
@test norm(Tcrs*x-cc[:])/norm(x[:]) < reltol

@time x = transpose(Tcrsinv)*cr[:];
@test norm(transpose(Tcrs)*x-cr[:])/norm(x[:]) < reltol

@time x = transpose(Tcrsinv)*cc[:];
@test norm(transpose(Tcrs)*x-cc[:])/norm(x[:]) < reltol


@time x = Tcrsinv'*cr[:];
@test norm(Tcrs'*x-cr[:])/norm(x[:]) < reltol

@time x = Tcrsinv'*cc[:];
@test norm(Tcrs'*x-cc[:])/norm(x[:]) < reltol


@time x = Tcrssyminv*triu2vec(cr);
@test norm(Tcrssym*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = transpose(Tcrssyminv)*triu2vec(cr);
@test norm(transpose(Tcrssym)*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tccinv*cc[:];
@test norm(Tcc*x-cc[:])/norm(x[:]) < reltol

@time x = Tccsyminv*triu2vec(cr);
@test norm(Tccsym*x-triu2vec(cr))/norm(x[:]) < reltol

@time y = Tccinv'*cc[:];
@test norm(Tcc'*y-cc[:])/norm(y[:]) < reltol

# @time x = Tccsyminv'*triu2vec(cr);
# @test norm(Tccsym'*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tccsinv*cc[:];
@test norm(Tccs*x-cc[:])/norm(x[:]) < reltol

@time x = Tccssyminv*triu2vec(cr);
@test norm(Tccssym*x-triu2vec(cr))/norm(x[:]) < reltol

@time y = transpose(Tcrinv)*cr[:];
@test norm(transpose(Tcr)*y-cr[:])/norm(y[:]) < reltol

@time y = transpose(Tcrsinv)*cr[:];
@test norm(transpose(Tcrs)*y-cr[:])/norm(y[:]) < reltol

@test abs(norm(Matrix(Tcr)'-Matrix(transpose(Tcr)))) < reltol 
@test abs(norm(Matrix(Tcc)'-Matrix(Tcc'))) < reltol 
@test norm(Matrix(Tcrinv)*Matrix(Tcr)-I) < reltol 
@test norm(Matrix(Tcrsinv)*Matrix(Tcrs)-I) < reltol 
@test norm(Matrix(Tccinv)*Matrix(Tcc)-I) < reltol 
@test norm(Matrix(Tccsinv)*Matrix(Tccs)-I) < reltol  
@test opnorm1est(Π*Tcr-Tcr*Π) < reltol 
@test opnorm1est(Π*Tcrinv-Tcrinv*Π) < reltol 
@test opnorm1est(Π*Tcrsinv-Tcrsinv*Π) < reltol 
@test opnorm(Matrix(Tcr),1) ≈ opnorm1(Tcr) 
@test opnorm1(Tcrsinv-invlyapop(as')') == 0  
@test opnorm1(Tcrsinv-invlyapop(schur(ar))) == 0 

@test sc*opnorm1(Tcr) < opnorm1est(Tcr)  &&
      sc*opnorm1(Tcrinv) < opnorm1est(Tcrinv)  &&
      sc*opnorm1(Tcrs) < opnorm1est(Tcrs)  &&
      sc*opnorm1(Tcrsinv) < opnorm1est(Tcrsinv)  &&
      sc*opnorm1(Tcc) < opnorm1est(Tcc)  &&
      sc*opnorm1(Tccinv) < opnorm1est(Tccinv)  &&
      sc*opnorm1(Tccs) < opnorm1est(Tccs)  &&
      sc*opnorm1(Tccsinv) < opnorm1est(Tccsinv)


@test sc*oprcondest(Tcr,Tcrinv) < 1/opnorm1(Tcr)/opnorm1(Tcrinv)  &&
      sc*oprcondest(Tcrs,Tcrsinv) < 1/opnorm1(Tcrs)/opnorm1(Tcrsinv)  &&
      sc*oprcondest(Tcc,Tccinv) < 1/opnorm1(Tcc)/opnorm1(Tccinv)  &&
      sc*oprcondest(Tccs,Tccsinv) < 1/opnorm1(Tccs)/opnorm1(Tccsinv) &&
      oprcondest(Tcr) == oprcondest(Tcr,Tcrinv) == oprcondest(Tcrinv) 

@test opsepest(Tcrsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Tcrs)))  &&
      minimum(svdvals(Matrix(Tcrs))) <= sqrt(2)*n*opsepest(Tcrsinv)  &&
      opsepest(invlyapop([0. 1.; 0. 1.])) == 0. &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.]))) == 0. &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.]))) == 0.  &&
      opsepest(invlyapop([0. 1.; 0. 1.])) == 0.  &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.]))) == 0.  &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.]))) == 0.


# some tests for T/H-Lyapunov operators with upper triangular arguments
@test transpose(Matrix(Ttur)) == Matrix(transpose(Ttur)) &&
      transpose(Matrix(Ttaur)) == Matrix(transpose(Ttaur)) &&
      transpose(Matrix(Ttuc)) == Matrix(transpose(Ttuc)) &&
      transpose(Matrix(Ttauc)) == Matrix(transpose(Ttauc))
@test adjoint(Matrix(Ttur)) == Matrix(adjoint(Ttur)) &&
      adjoint(Matrix(Ttaur)) == Matrix(adjoint(Ttaur)) &&
      adjoint(Matrix(Ttuc)) == Matrix(adjoint(Ttuc)) &&
      adjoint(Matrix(Ttauc)) == Matrix(adjoint(Ttauc))


end

@testset "Continuous generalized Lyapunov operators" begin

ar = rand(n,n)
er = rand(n,n)
cr = rand(n,m)
cc = cr+im*rand(n,m)
cr = cr*cr'
as,es  = schur(ar,er)
ac = ar+im*rand(n,n)
ec = er+im*rand(n,n)
cc = cc*cc'
acs, ecs  = schur(ac,ec)

Tcr = lyapop(ar,er)
Tcrinv = invlyapop(ar,er)
Tcrs = lyapop(as,es)
Tcrsinv = invlyapop(as,es)
Tcrsym = lyapop(ar,er,her=true);
Tcrsyminv = invlyapop(ar,er,her=true);
Tcrssym = lyapop(as,es,her=true);
Tcrssyminv = invlyapop(as,es,her=true);


Tcc = lyapop(ac,ec)
Tccinv = invlyapop(ac,ec)
Tccs = lyapop(acs,ecs)
Tccsinv = invlyapop(acs,ecs)
Tccsym = lyapop(ac,ec,her=true);
Tccsyminv = invlyapop(ac,ec,her=true);
Tccssym = lyapop(acs,ecs,her=true);
Tccssyminv = invlyapop(acs,ecs,her=true);
Π = trmatop(size(ar))
@test size(Tcr) == size(Tcr') == size(Tcrinv)

@test opnorm1est(Π*Tcrinv-Tcrinv*Π) < reltol*norm(ar)*norm(er) 


@test check_ctranspose(Tcr) &&
      check_ctranspose(Tcrinv) &&
      check_ctranspose(Tcrs) &&
      check_ctranspose(Tcrsinv) &&
      check_ctranspose(Tcrsym) &&
      #check_ctranspose(Tcrsyminv) &&
      #check_ctranspose(Tcrssyminv) &&
      #check_ctranspose(Tcrssyminv) &&
      check_ctranspose(Tcc) &&
      check_ctranspose(Tccinv) &&
      check_ctranspose(Tccs) &&
      check_ctranspose(Tccsinv)  
      #check_ctranspose(Tccsym) &&
      #check_ctranspose(Tccsyminv) &&
      #check_ctranspose(Tccssyminv) &&
      #check_ctranspose(Tccssyminv) 


try
   T1 = invlyapop(convert(Matrix{Complex{Float32}},acs),ecs);
   T = invlyapop(acs,ecs);
   T*rand(n*n);
   transpose(T)*rand(n*n);
   adjoint(T)*rand(n*n);
   T*rand(Float32,n*n);
   transpose(T)*rand(Float32,n*n);
   adjoint(T)*rand(Float32,n*n);
   T*ones(Int,n*n);
   transpose(T)*ones(Int,n*n);
   adjoint(T)*ones(Int,n*n);
   T1 = invlyapop(convert(Matrix{Complex{Float32}},acs),convert(Matrix{Complex{Float32}},ecs));
   T = invlyapop(acs,ecs);
   T*rand(n*n);
   T*complex(rand(n*n));
   transpose(T)*rand(n*n);
   transpose(T)*complex(rand(n*n));
   T'*rand(n*n);
   T'*complex(rand(n*n));
   lyapop(schur(ar,er))
   lyapop(2,3)
   lyapop(rand(Int,2,2),rand(2,2))
   @test true
catch
   @test false
end 

@time x = Tcrinv*cr[:];
@test norm(Tcr*x-cr[:])/norm(x[:]) < reltol

@time x = Tcrinv*cc[:];
@test norm(Tcr*x-cc[:])/norm(x[:]) < reltol

@time x = Tcrsyminv*triu2vec(cr);
@test norm(Tcrsym*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tcrsyminv*triu2vec(cc);
@test norm(Tcrsym*x-triu2vec(cc))/norm(x[:]) < reltol

@time x = transpose(Tcrinv)*cr[:];
@test norm(transpose(Tcr)*x-cr[:])/norm(x[:]) < reltol

@time x = transpose(Tcrinv)*cc[:];
@test norm(transpose(Tcr)*x-cc[:])/norm(x[:]) < reltol

@time x = adjoint(Tcrinv)*cc[:];
@test norm(adjoint(Tcr)*x-cc[:])/norm(x[:]) < reltol

# @time x = transpose(Tcrsyminv)*triu2vec(cr);
# @test norm(transpose(Tcrsym)*x-triu2vec(cr))/norm(x[:]) < reltol

# @time x = transpose(Tcrsyminv)*triu2vec(cc); 
# @test norm(transpose(Tcrsym)*x-triu2vec(cc))/norm(x[:]) < reltol   

@time x = Tcrsinv*cr[:];
@test norm(Tcrs*x-cr[:])/norm(x[:]) < reltol

@time x = transpose(Tcrsinv)*cr[:];
@test norm(transpose(Tcrs)*x-cr[:])/norm(x[:]) < reltol

@time x = Tcrssyminv*triu2vec(cr);
@test norm(Tcrssym*x-triu2vec(cr))/norm(x[:]) < reltol

# @time x = transpose(Tcrssyminv)*triu2vec(cr);
# @test norm(transpose(Tcrssym)*x-triu2vec(cr))/norm(x[:]) < reltol

# @time x = adjoint(Tcrssyminv)*triu2vec(cr);
# @test norm(adjoint(Tcrssym)*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tccinv*cc[:];
@test norm(Tcc*x-cc[:])/norm(x[:]) < reltol

@time x = Tccsyminv*triu2vec(cr);
@test norm(Tccsym*x-triu2vec(cr))/norm(x[:]) < reltol  

@time y = Tccinv'*cc[:];
@test norm(Tcc'*y-cc[:])/norm(y[:]) < reltol

# @time x = Tccsyminv'*triu2vec(cr);
# @test norm(Tccsym'*x-triu2vec(cr))/norm(x[:]) < reltol 

@time x = Tccsinv*cc[:];
@test norm(Tccs*x-cc[:])/norm(x[:]) < reltol

@time x = Tccssyminv*triu2vec(cr);
@test norm(Tccssym*x-triu2vec(cr))/norm(x[:]) < reltol 

@time y = Tcrinv'*cr[:];
@test norm(Tcr'*y-cr[:])/norm(y[:]) < reltol

@time y = Tcrsinv'*cr[:];
@test norm(Tcrs'*y-cr[:])/norm(y[:]) < reltol

@test abs(norm(Matrix(Tcr)'-Matrix(transpose(Tcr)))) < reltol
@test abs(norm(Matrix(Tcc)'-Matrix(Tcc'))) < reltol  
@test norm(Matrix(Tcrinv)*Matrix(Tcr)-I) < reltol 
@test norm(Matrix(Tcrsinv)*Matrix(Tcrs)-I) < reltol 
@test norm(Matrix(Tccinv)*Matrix(Tcc)-I) < reltol 
@test norm(Matrix(Tccsinv)*Matrix(Tccs)-I) < reltol 
@test opnorm1est(Π*Tcr-Tcr*Π) < reltol 
@test opnorm1est(Π*Tcrinv-Tcrinv*Π) < reltol*norm(ar)*norm(er) 
@test opnorm1est(Π*Tcrsinv-Tcrsinv*Π) < reltol*norm(ar)*norm(er) 
@test opnorm(Matrix(Tcr),1) ≈ opnorm1(Tcr) 
@test opnorm1(Tcrsinv-invlyapop(as',es')') == 0 
@test opnorm1(Tcrsinv-invlyapop(schur(ar,er))) == 0

@test sc*opnorm1(Tcr) < opnorm1est(Tcr)  &&
      sc*opnorm1(Tcrinv) < opnorm1est(Tcrinv)  &&
      sc*opnorm1(Tcrs) < opnorm1est(Tcrs)  &&
      sc*opnorm1(Tcrsinv) < opnorm1est(Tcrsinv)  &&
      sc*opnorm1(Tcc) < opnorm1est(Tcc)  &&
      sc*opnorm1(Tccinv) < opnorm1est(Tccinv)  &&
      sc*opnorm1(Tccs) < opnorm1est(Tccs)  &&
      sc*opnorm1(Tccsinv) < opnorm1est(Tccsinv)


@test sc*oprcondest(Tcr,Tcrinv) < 1/opnorm1(Tcr)/opnorm1(Tcrinv)  &&
      sc*oprcondest(Tcrs,Tcrsinv) < 1/opnorm1(Tcrs)/opnorm1(Tcrsinv)  &&
      sc*oprcondest(Tcc,Tccinv) < 1/opnorm1(Tcc)/opnorm1(Tccinv)  &&
      sc*oprcondest(Tccs,Tccsinv) < 1/opnorm1(Tccs)/opnorm1(Tccsinv) &&
      oprcondest(Tcr) == oprcondest(Tcr,Tcrinv) == oprcondest(Tcrinv) 

@test opsepest(Tcrsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Tcrs)))  &&
      minimum(svdvals(Matrix(Tcrs))) <= sqrt(2)*n*opsepest(Tcrsinv)  &&
      opsepest(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.])) == 0. &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.]))) == 0. &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.]))) == 0.  &&
      opsepest(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.])) == 0.  &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.]))) == 0.  &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.]))) == 0.

end


@testset "Discrete Lyapunov operators" begin

ar = rand(n,n);
cr = rand(n,m);
cc = cr+im*rand(n,m);
cr = cr*cr';
as,  = schur(ar);
ac = ar+im*rand(n,n);
cc = cc*cc';
acs,  = schur(ac);

Tdr = lyapop(ar,disc=true);
Tdrinv = invlyapop(ar,disc=true);
Tdrs = lyapop(as,disc=true);
Tdrsinv = invlyapop(as,disc=true);
Tdrsym = lyapop(ar,disc=true,her=true);
Tdrsyminv = invlyapop(ar,disc=true,her=true);
Tdrssym = lyapop(as,disc=true,her=true);
Tdrssyminv = invlyapop(as,disc=true,her=true);


Tdc = lyapop(ac,disc=true);
Tdcinv = invlyapop(ac,disc=true);
Tdcs = lyapop(acs,disc=true);
Tdcsinv = invlyapop(acs,disc=true);
Tdcsym = lyapop(ac,disc=true,her=true);
Tdcsyminv = invlyapop(ac,disc=true,her=true);
Tdcssym = lyapop(acs,disc=true,her=true);
Tdcssyminv = invlyapop(acs,disc=true,her=true);
Π = trmatop(ar)

@test check_ctranspose(Tdr) &&
      check_ctranspose(Tdrinv) &&
      check_ctranspose(Tdrs) &&
      check_ctranspose(Tdrsinv) &&
      check_ctranspose(Tdc) &&
      check_ctranspose(Tdcinv) &&
      check_ctranspose(Tdcs) &&
      check_ctranspose(Tdcsinv) 

try
   T1 = invlyapop(convert(Matrix{Float32},as))
   T = invlyapop(as,disc=true);
   T*rand(n*n);
   transpose(T)*rand(n*n);
   adjoint(T)*rand(n*n);
   T*rand(Float32,n*n);
   transpose(T)*rand(Float32,n*n);
   adjoint(T)*rand(Float32,n*n);
   T*ones(Int,n*n);
   transpose(T)*ones(Int,n*n);
   adjoint(T)*ones(Int,n*n);
   T1 = invlyapop(convert(Matrix{Complex{Float32}},acs));
   T = invlyapop(acs,disc=true);
    T*rand(n*n);
    T*complex(rand(n*n));
    transpose(T)*rand(n*n);
    transpose(T)*complex(rand(n*n));
    adjoint(T)*rand(n*n);
    adjoint(T)*complex(rand(n*n));
    @test true
catch
    @test false
end 


@time x = Tdrinv*cr[:];
@test norm(Tdr*x-cr[:])/norm(x[:]) < reltol

@time x = Tdrinv*cc[:];
@test norm(Tdr*x-cc[:])/norm(x[:]) < reltol

@time x = Tdrsyminv*triu2vec(cr);
@test norm(Tdrsym*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = transpose(Tdrinv)*cr[:];
@test norm(transpose(Tdr)*x-cr[:])/norm(x[:]) < reltol

@time x = Tdrsyminv'*triu2vec(cr);
@test norm(Tdrsym'*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tdrsyminv'*triu2vec(cc);
@test norm(Tdrsym'*x-triu2vec(cc))/norm(x[:]) < reltol

@time x = Tdrsinv*cr[:]
@test norm(Tdrs*x-cr[:])/norm(x[:]) < reltol

@time x = transpose(Tdrsinv)*cr[:]
@test norm(transpose(Tdrs)*x-cr[:])/norm(x[:]) < reltol

@time x = Tdrssyminv*triu2vec(cr);
@test norm(Tdrssym*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = transpose(Tdrsyminv)*triu2vec(cr);
@test norm(transpose(Tdrsym)*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tdrssyminv'*triu2vec(cr);
@test norm(Tdrssym'*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tdcinv*cc[:]
@test norm(Tdc*x-cc[:])/norm(x[:]) < reltol

@time x = Tdcsyminv*triu2vec(cr);
@test norm(Tdcsym*x-triu2vec(cr))/norm(x[:]) < reltol

@time y = Tdcinv'*cc[:]
@test norm(Tdc'*y-cc[:])/norm(y[:]) < reltol

# @time x = Tdcsyminv'*triu2vec(cr);
# @test norm(Tdcsym'*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tdcsinv*cc[:]
@test norm(Tdcs*x-cc[:])/norm(x[:]) < reltol

@time x = Tdcssyminv*triu2vec(cr);
@test norm(Tdcssym*x-triu2vec(cr))/norm(x[:]) < reltol

@time y = transpose(Tdrinv)*cr[:]
@test norm(transpose(Tdr)*y-cr[:])/norm(y[:]) < reltol

@time y = transpose(Tdrsinv)*cr[:]
@test norm(transpose(Tdrs)*y-cr[:])/norm(y[:]) < reltol


@test abs(norm(Matrix(Tdr)'-Matrix(transpose(Tdr)))) < reltol
@test abs(norm(Matrix(Tdc)'-Matrix(Tdc'))) < reltol 
@test norm(Matrix(Tdrinv)*Matrix(Tdr)-I) < reltol 
@test norm(Matrix(Tdrsinv)*Matrix(Tdrs)-I) < reltol 
@test norm(Matrix(Tdcinv)*Matrix(Tdc)-I) < reltol 
@test norm(Matrix(Tdcsinv)*Matrix(Tdcs)-I) < reltol 
@test opnorm1est(Π*Tdr-Tdr*Π) < reltol 
@test opnorm1est(Π*Tdrinv-Tdrinv*Π) < reltol 
@test opnorm1est(Π*Tdrsinv-Tdrsinv*Π) < reltol


@test sc*opnorm1(Tdr) < opnorm1est(Tdr)  &&
      sc*opnorm1(Tdrinv) < opnorm1est(Tdrinv)  &&
      sc*opnorm1(Tdrs) < opnorm1est(Tdrs)  &&
      sc*opnorm1(Tdrsinv) < opnorm1est(Tdrsinv)  &&
      sc*opnorm1(Tdc) < opnorm1est(Tdc)  &&
      sc*opnorm1(Tdcinv) < opnorm1est(Tdcinv)  &&
      sc*opnorm1(Tdcs) < opnorm1est(Tdcs)  &&
      sc*opnorm1(Tdcsinv) < opnorm1est(Tdcsinv)


@test sc*oprcondest(Tdr,Tdrinv) < 1/opnorm1(Tdr)/opnorm1(Tdrinv)  &&
      sc*oprcondest(Tdrs,Tdrsinv) < 1/opnorm1(Tdrs)/opnorm1(Tdrsinv)  &&
      sc*oprcondest(Tdc,Tdcinv) < 1/opnorm1(Tdc)/opnorm1(Tdcinv)  &&
      sc*oprcondest(Tdcs,Tdcsinv) < 1/opnorm1(Tdcs)/opnorm1(Tdcsinv) &&
      oprcondest(Tdr) == oprcondest(Tdr,Tdrinv) == oprcondest(Tdrinv) 


@test opsepest(Tdrsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Tdrs)))  &&
      minimum(svdvals(Matrix(Tdrs))) <= sqrt(2)*n*opsepest(Tdrsinv)  &&
      opsepest(invlyapop([0. 1.; 0. 1.],disc=true)) == 0. &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.],disc=true))) == 0. &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.],disc=true))) == 0.  &&
      opsepest(invlyapop([0. 1.; 0. 1.],disc=true)) == 0.  &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.],disc=true))) == 0.  &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.],disc=true))) == 0.


end

@testset "Discrete generalized Lyapunov operators" begin

ar = rand(n,n)
er = rand(n,n)
cr = rand(n,m)
cc = cr+im*rand(n,m)
cr = cr*cr'
as,es  = schur(ar,er)
ac = ar+im*rand(n,n)
ec = er+im*rand(n,n)
cc = cc*cc'
acs, ecs  = schur(ac,ec)

Tdr = lyapop(ar,er,disc=true)
Tdrinv = invlyapop(ar,er,disc=true)
Tdrs = lyapop(as,es,disc=true)
Tdrsinv = invlyapop(as,es,disc=true)
Tdrsym = lyapop(ar,er,disc=true,her=true);
Tdrsyminv = invlyapop(ar,er,disc=true,her=true);
Tdrssym = lyapop(as,es,disc=true,her=true);
Tdrssyminv = invlyapop(as,es,disc=true,her=true);


Tdc = lyapop(ac,ec,disc=true)
Tdcinv = invlyapop(ac,ec,disc=true)
Tdcs = lyapop(acs,ecs,disc=true)
Tdcsinv = invlyapop(acs,ecs,disc=true)
Tdcsym = lyapop(ac,ec,disc=true,her=true);
Tdcsyminv = invlyapop(ac,ec,disc=true,her=true);
Tdcssym = lyapop(acs,ecs,disc=true,her=true);
Tdcssyminv = invlyapop(acs,ecs,disc=true,her=true);
Π = trmatop(n)

@test check_ctranspose(Tdr) &&
      check_ctranspose(Tdrinv) &&
      check_ctranspose(Tdrs) &&
      check_ctranspose(Tdrsinv) &&
      check_ctranspose(Tdc) &&
      check_ctranspose(Tdcinv) &&
      check_ctranspose(Tdcs) &&
      check_ctranspose(Tdcsinv) 

try
   #T1 = invlyapsop(convert(Matrix{Complex{Float32}},acs),ecs);
   T = invlyapop(acs,ecs,disc = true);
   T*rand(n*n);
   transpose(T)*rand(n*n);
   adjoint(T)*rand(n*n);
   T*rand(Float32,n*n);
   transpose(T)*rand(Float32,n*n);
   adjoint(T)*rand(Float32,n*n);
   T*ones(Int,n*n);
   transpose(T)*ones(Int,n*n);
   adjoint(T)*ones(Int,n*n);
   #T1 = invlyapsop(convert(Matrix{Complex{Float32}},acs),convert(Matrix{Complex{Float32}},ecs));
   T = invlyapop(acs,ecs,disc = true);
   T*rand(n*n);
   T*complex(rand(n*n));
   transpose(T)*rand(n*n);
   transpose(T)*complex(rand(n*n));
   T'*rand(n*n);
   T'*complex(rand(n*n));
   @test true
catch
   @test false
end 


@time x = Tdrinv*cr[:];
@test norm(Tdr*x-cr[:])/norm(x[:]) < reltol

@time x = Tdrsyminv*triu2vec(cr);
@test norm(Tdrsym*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = transpose(Tdrinv)*cr[:];
@test norm(transpose(Tdr)*x-cr[:])/norm(x[:]) < reltol

# @time x = Tdrsyminv'*triu2vec(cr);
# @test norm(Tdrsym'*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tdrsinv*cr[:];
@test norm(Tdrs*x-cr[:])/norm(x[:]) < reltol

@time x = transpose(Tdrsinv)*cr[:]
@test norm(transpose(Tdrs)*x-cr[:])/norm(x[:]) < reltol

@time x = Tdrssyminv*triu2vec(cr);
@test norm(Tdrssym*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tdrssyminv*triu2vec(cc);
@test norm(Tdrssym*x-triu2vec(cc))/norm(x[:]) < reltol

# @time x = transpose(Tdrsyminv)*triu2vec(cr);
# @test norm(transpose(Tdrsym)*x-triu2vec(cr))/norm(x[:]) < reltol

# @time x = Tdrssyminv'*triu2vec(cr);
# @test norm(Tdrssym'*x-triu2vec(cr))/norm(x[:]) < reltol

# @time x = Tdrssyminv'*triu2vec(cc);
# @test norm(Tdrssym'*x-triu2vec(cc))/norm(x[:]) < reltol

@time x = Tdcinv*cc[:];
@test norm(Tdc*x-cc[:])/norm(x[:]) < reltol

@time x = Tdcsyminv*triu2vec(cr);
@test norm(Tdcsym*x-triu2vec(cr))/norm(x[:]) < reltol

@time y = Tdcinv'*cc[:];
@test norm(Tdc'*y-cc[:])/norm(y[:]) < reltol

# @time x = Tdcsyminv'*triu2vec(cr);
# @test norm(Tdcsym'*x-triu2vec(cr))/norm(x[:]) < reltol

@time x = Tdcsinv*cc[:]
@test norm(Tdcs*x-cc[:])/norm(x[:]) < reltol

@time x = Tdcssyminv*triu2vec(cr);
@test norm(Tdcssym*x-triu2vec(cr))/norm(x[:]) < reltol

@time y = transpose(Tdrinv)*cr[:];
@test norm(transpose(Tdr)*y-cr[:])/norm(y[:]) < reltol

@time y = transpose(Tdrsinv)*cr[:];
@test norm(transpose(Tdrs)*y-cr[:])/norm(y[:]) < reltol

@test abs(norm(Matrix(Tdr)'-Matrix(transpose(Tdr)))) < reltol 
@test abs(norm(Matrix(Tdc)'-Matrix(Tdc'))) < reltol  
@test norm(Matrix(Tdrinv)*Matrix(Tdr)-I) < reltol 
@test norm(Matrix(Tdrsyminv)*Matrix(Tdrsym)-I) < reltol 
@test norm(Matrix(Tdrsinv)*Matrix(Tdrs)-I) < reltol 
@test norm(Matrix(Tdrssyminv)*Matrix(Tdrssym)-I) < reltol 
@test norm(Matrix(Tdcinv)*Matrix(Tdc)-I) < reltol 
@test norm(Matrix(Tdcsinv)*Matrix(Tdcs)-I) < reltol 
@test opnorm1est(Π*Tdr-Tdr*Π) < reltol 
@test opnorm1est(Π*Tdrinv-Tdrinv*Π) < reltol 
@test opnorm1est(Π*Tdrsinv-Tdrsinv*Π) < reltol


@test sc*opnorm1(Tdr) < opnorm1est(Tdr)  &&
      sc*opnorm1(Tdrinv) < opnorm1est(Tdrinv)  &&
      sc*opnorm1(Tdrs) < opnorm1est(Tdrs)  &&
      sc*opnorm1(Tdrsinv) < opnorm1est(Tdrsinv)  &&
      sc*opnorm1(Tdc) < opnorm1est(Tdc)  &&
      sc*opnorm1(Tdcinv) < opnorm1est(Tdcinv)  &&
      sc*opnorm1(Tdcs) < opnorm1est(Tdcs)  &&
      sc*opnorm1(Tdcsinv) < opnorm1est(Tdcsinv)


@test sc*oprcondest(Tdr,Tdrinv) < 1/opnorm1(Tdr)/opnorm1(Tdrinv)  &&
      sc*oprcondest(Tdrs,Tdrsinv) < 1/opnorm1(Tdrs)/opnorm1(Tdrsinv)  &&
      sc*oprcondest(Tdc,Tdcinv) < 1/opnorm1(Tdc)/opnorm1(Tdcinv)  &&
      sc*oprcondest(Tdcs,Tdcsinv) < 1/opnorm1(Tdcs)/opnorm1(Tdcsinv) &&
      oprcondest(Tdr) == oprcondest(Tdr,Tdrinv) == oprcondest(Tdrinv) 

@test opsepest(Tdrsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Tdrs)))  &&
      minimum(svdvals(Matrix(Tdrs))) <= sqrt(2)*n*opsepest(Tdrsinv)  &&
      opsepest(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.],disc=true)) == 0. &&
      opsepest(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.],disc=true)) == 0. &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.],disc=true))) == 0. &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.],disc=true))) == 0.  &&
      opsepest(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.],disc=true)) == 0.  &&
      opsepest(transpose(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.],disc=true))) == 0.  &&
      opsepest(adjoint(invlyapop([0. 1.; 0. 1.],[1. 1.;0. 1.],disc=true))) == 0.


end



#  continuous and discrete Sylvester equations
@testset "Continuous Sylvester operators" begin

# n = 3; m = 2; 
ar = rand(n,n)
br = rand(m,m)
cr = rand(n,m)
as,  = schur(ar)
bs,  = schur(br)
ac = ar+im*rand(n,n)
bc = br+im*rand(m,m)
cc = cr+im*rand(n,m)
acs,  = schur(ac)
bcs,  = schur(bc)

Tcr = sylvop(ar, br)
Tcrinv = invsylvop(ar,br)
Tcrs = sylvop(as, bs)
Tcrsinv = invsylvop(as,bs)


Tcc = sylvop(ac, bc)
Tccinv = invsylvop(ac,bc)
Tccs = sylvop(acs, bcs)
Tccsinv = invsylvop(acs,bcs)

@test size(Tcr) == size(Tcr')

@test check_ctranspose(Tcr) &&
      check_ctranspose(Tcrinv) &&
      check_ctranspose(Tcrs) &&
      check_ctranspose(Tcrsinv) && 
      check_ctranspose(Tcc) &&
      check_ctranspose(Tccinv) &&
      check_ctranspose(Tccs) &&
      check_ctranspose(Tccsinv) 


try
    T = invsylvop(as,bs);
    T*rand(n*m);
    transpose(T)*rand(n*m);
    adjoint(T)*rand(n*m);
    T*rand(Float32,n*m);
    transpose(T)*rand(Float32,n*m);
    adjoint(T)*rand(Float32,n*m);
    T*ones(Int,n*m);
    transpose(T)*ones(Int,n*m);
    adjoint(T)*ones(Int,n*m);
    T = invsylvop(acs,bcs);
    T*rand(n*m);
    T*complex(rand(n*m));
    transpose(T)*rand(n*m);
    transpose(T)*complex(rand(n*m));
    T'*rand(n*m);
    T'*complex(rand(n*m));
    sylvop(schur(rand(3,3)),schur(rand(3,3)))
    sylvop(1,im)
    invsylvop(1,im)
    sylvop(rand(Int,2,2),rand(2,2))
    invsylvop(rand(Int,2,2),rand(2,2))
    @test true
catch
    @test false
end 
 
@time x = Tcrinv*cr[:];
@test norm(Tcr*x[:]-cr[:])/norm(x[:]) < reltol

@time x = Tcrsinv*cr[:];
@test norm(Tcrs*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as,bs)*cr[:];
@test norm(sylvop(as, bs)*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as,bs')*cr[:];
@test norm(sylvop(as, bs')*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as',bs)*cr[:];
@test norm(sylvop(as', bs)*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as',bs')*cr[:];
@test norm(sylvop(as', bs')*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as,bs))*cr[:];
@test norm(transpose(sylvop(as, bs))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as,bs'))*cr[:];
@test norm(transpose(sylvop(as, bs'))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as',bs))*cr[:];
@test norm(transpose(sylvop(as', bs))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as',bs'))*cr[:];
@test norm(transpose(sylvop(as', bs'))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as,bs))*cr[:];
@test norm(adjoint(sylvop(as, bs))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as,bs'))*cr[:];
@test norm(adjoint(sylvop(as, bs'))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as',bs))*cr[:];
@test norm(adjoint(sylvop(as', bs))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as',bs'))*cr[:];
@test norm(adjoint(sylvop(as', bs'))*x[:]-cr[:])/norm(x[:]) < reltol


@time x = Tccinv*cc[:];
@test norm(Tcc*x[:]-cc[:])/norm(x[:]) < reltol

@time x = Tccsinv*cc[:];
@test norm(Tccs*x[:]-cc[:])/norm(x[:]) < reltol

@time y = transpose(Tcrinv)*cr[:];
@test norm(transpose(Tcr)*y[:]-cr[:])/norm(y[:]) < reltol

@time y = Tccinv'*cc[:];
@test norm(Tcc'*y[:]-cc[:])/norm(y[:]) < reltol

x = rand(n*m);
@test abs(norm(Matrix(Tcr)'-Matrix(transpose(Tcr)))) < reltol 
@test abs(norm(Matrix(Tcc)'-Matrix(Tcc'))) < reltol 
@test norm(Matrix(Tcrinv)*Matrix(Tcr)-I) < reltol 
@test norm(Matrix(Tcrsinv)*Matrix(Tcrs)-I) < reltol 
@test norm(Matrix(Tccinv)*Matrix(Tcc)-I) < reltol 
@test norm(Matrix(Tccsinv)*Matrix(Tccs)-I) < reltol 
@test norm(Tcrsinv'*x-invsylvop(as',bs')*x) == 0  
@test opnorm1(Tcrsinv-invsylvop(schur(ar),schur(br))) == 0 


@test sc*opnorm1(Tcr) < opnorm1est(Tcr)  &&
      sc*opnorm1(Tcrinv) < opnorm1est(Tcrinv)  &&
      sc*opnorm1(Tcrs) < opnorm1est(Tcrs)  &&
      sc*opnorm1(Tcrsinv) < opnorm1est(Tcrsinv)  &&
      sc*opnorm1(Tcc) < opnorm1est(Tcc)  &&
      sc*opnorm1(Tccinv) < opnorm1est(Tccinv)  &&
      sc*opnorm1(Tccs) < opnorm1est(Tccs)  &&
      sc*opnorm1(Tccsinv) < opnorm1est(Tccsinv)

@test sc*oprcondest(Tcr,Tcrinv) < 1/opnorm1(Tcr)/opnorm1(Tcrinv)  &&
      sc*oprcondest(Tcrs,Tcrsinv) < 1/opnorm1(Tcrs)/opnorm1(Tcrsinv)  &&
      sc*oprcondest(Tcc,Tccinv) < 1/opnorm1(Tcc)/opnorm1(Tccinv)  &&
      sc*oprcondest(Tccs,Tccsinv) < 1/opnorm1(Tccs)/opnorm1(Tccsinv) &&
      oprcondest(Tcr) == oprcondest(Tcr,Tcrinv) == oprcondest(Tcrinv) 

@test opsepest(Tcrsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Tcrs)))  &&
      minimum(svdvals(Matrix(Tcrs))) <= sqrt(2)*n*opsepest(Tcrsinv)  &&
      opsepest(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.])) == 0. &&
      opsepest(transpose(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.]))) == 0. &&
      opsepest(adjoint(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.]))) == 0. &&
      opsepest(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.])) == 0. &&
      opsepest(transpose(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.]))) == 0. &&
      opsepest(adjoint(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.]))) == 0.

end

# discrete Sylvester equations
@testset "Discrete Sylvester operators" begin

ar = rand(n,n)
br = rand(m,m)
cr = rand(n,m)
as,  = schur(ar)
bs,  = schur(br)
ac = ar+im*rand(n,n)
bc = br+im*rand(m,m)
cc = cr+im*rand(n,m)
acs,  = schur(ac)
bcs,  = schur(bc)

Tdr = sylvop(ar, br, disc = true)
Tdrinv = invsylvop(ar,br, disc = true)
Tdrs = sylvop(as, bs, disc = true)
Tdrsinv = invsylvop(as,bs, disc = true)

Tdc = sylvop(ac, bc, disc = true)
Tdcinv = invsylvop(ac,bc, disc = true)
Tdcs = sylvop(acs, bcs, disc = true)
Tdcsinv = invsylvop(acs,bcs, disc = true)

@test check_ctranspose(Tdr) &&
      check_ctranspose(Tdrinv) &&
      check_ctranspose(Tdrs) &&
      check_ctranspose(Tdrsinv) &&
      check_ctranspose(Tdc) &&
      check_ctranspose(Tdcinv) &&
      check_ctranspose(Tdcs) &&
      check_ctranspose(Tdcsinv) 

try
    T = invsylvop(as,bs,disc = true);
    T*rand(n*m);
    transpose(T)*rand(n*m);
    adjoint(T)*rand(n*m);
    T*rand(Float32,n*m);
    transpose(T)*rand(Float32,n*m);
    adjoint(T)*rand(Float32,n*m);
    T*ones(Int,n*m);
    transpose(T)*ones(Int,n*m);
    adjoint(T)*ones(Int,n*m);
    T = invsylvop(acs,bcs,disc = true);
    T*rand(n*m);
    T*complex(rand(n*m));
    transpose(T)*rand(n*m);
    transpose(T)*complex(rand(n*m));
    T'*rand(n*m);
    T'*complex(rand(n*m));
    @test true
catch
    @test false
end 

@time x = Tdrinv*cr[:]
@test norm(Tdr*x[:]-cr[:])/norm(x[:]) < reltol

@time x = Tdrsinv*cr[:]
@test norm(Tdrs*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as,bs, disc = true)*cr[:]
@test norm(sylvop(as, bs, disc = true)*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as,bs', disc = true)*cr[:]
@test norm(sylvop(as, bs', disc = true)*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as',bs, disc = true)*cr[:]
@test norm(sylvop(as', bs, disc = true)*x[:]-cr[:])/norm(x[:]) < reltol

@time x = invsylvop(as',bs', disc = true)*cr[:]
@test norm(sylvop(as', bs', disc = true)*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as,bs, disc = true))*cr[:]
@test norm(transpose(sylvop(as, bs, disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as,bs', disc = true))*cr[:]
@test norm(transpose(sylvop(as, bs', disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as',bs, disc = true))*cr[:]
@test norm(transpose(sylvop(as', bs, disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as',bs', disc = true))*cr[:]
@test norm(transpose(sylvop(as', bs', disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as,bs, disc = true))*cr[:]
@test norm(adjoint(sylvop(as, bs, disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as,bs', disc = true))*cr[:]
@test norm(adjoint(sylvop(as, bs', disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as',bs, disc = true))*cr[:]
@test norm(adjoint(sylvop(as', bs, disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as',bs', disc = true))*cr[:]
@test norm(adjoint(sylvop(as', bs', disc = true))*x[:]-cr[:])/norm(x[:]) < reltol

@time x = Tdcinv*cc[:]
@test norm(Tdc*x[:]-cc[:])/norm(x[:]) < reltol

@time x = Tdcsinv*cc[:]
@test norm(Tdcs*x[:]-cc[:])/norm(x[:]) < reltol

@time x = Tdcsinv'*cr[:]
@test norm(Tdcs'*x[:]-cr[:])/norm(x[:]) < reltol

@time y = transpose(Tdrinv)*cr[:]
@test norm(transpose(Tdr)*y[:]-cr[:])/norm(y[:]) < reltol

@time y = transpose(Tdrsinv)*cr[:]
@test norm(transpose(Tdrs)*y[:]-cr[:])/norm(y[:]) < reltol

@time x = transpose(Tdrsinv)*cr[:]
@test norm(transpose(Tdrs)*x[:]-cr[:])/norm(x[:]) < reltol

@time y = Tdcinv'*cc[:]
@test norm(Tdc'*y[:]-cc[:])/norm(y[:]) < reltol

@time y = Tdcsinv'*cc[:]
@test norm(Tdcs'*y[:]-cc[:])/norm(y[:]) < reltol


x = rand(n*m);
@test abs(norm(Matrix(Tdr)'-Matrix(transpose(Tdr)))) < reltol 
@test abs(norm(Matrix(Tdc)'-Matrix(Tdc'))) < reltol 
@test norm(Matrix(Tdrinv)*Matrix(Tdr)-I) < reltol 
@test norm(Matrix(Tdrsinv)*Matrix(Tdrs)-I) < reltol 
@test norm(Matrix(Tdcinv)*Matrix(Tdc)-I) < reltol 
@test norm(Matrix(Tdcsinv)*Matrix(Tdcs)-I) < reltol 
@test norm(Tdrsinv'*x-invsylvop(as',bs', disc = true)*x) == 0 
@test opnorm1(Tdrsinv-invsylvop(schur(ar),schur(br), disc = true)) == 0



@test sc*opnorm1(Tdr) < opnorm1est(Tdr)  &&
      sc*opnorm1(Tdrinv) < opnorm1est(Tdrinv)  &&
      sc*opnorm1(Tdrs) < opnorm1est(Tdrs)  &&
      sc*opnorm1(Tdrsinv) < opnorm1est(Tdrsinv)  &&
      sc*opnorm1(Tdc) < opnorm1est(Tdc)  &&
      sc*opnorm1(Tdcinv) < opnorm1est(Tdcinv)  &&
      sc*opnorm1(Tdcs) < opnorm1est(Tdcs)  &&
      sc*opnorm1(Tdcsinv) < opnorm1est(Tdcsinv)

@test sc*oprcondest(Tdr,Tdrinv) < 1/opnorm1(Tdr)/opnorm1(Tdrinv)  &&
      sc*oprcondest(Tdrs,Tdrsinv) < 1/opnorm1(Tdrs)/opnorm1(Tdrsinv)  &&
      sc*oprcondest(Tdc,Tdcinv) < 1/opnorm1(Tdc)/opnorm1(Tdcinv)  &&
      sc*oprcondest(Tdcs,Tdcsinv) < 1/opnorm1(Tdcs)/opnorm1(Tdcsinv) &&
      oprcondest(Tdr) == oprcondest(Tdr,Tdrinv) == oprcondest(Tdrinv) 



@test opsepest(Tdrsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Tdrs)))  &&
      minimum(svdvals(Matrix(Tdrs))) <= sqrt(2)*n*opsepest(Tdrsinv)  &&
      opsepest(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.],disc=true)) == 0. &&
      opsepest(invsylvop([0. 1.; 0. 1.],-[0. 1.; 0. 1.],disc=true)) == 0.

end


# generalized Sylvester equations
@testset "Generalized Sylvester operators" begin

ar = rand(n,n)
br = rand(m,m)
cr = rand(n,n)
dr = rand(m,m)
er = rand(n,m)
ac = ar+im*rand(n,n)
bc = br+im*rand(m,m)
cc = cr+im*rand(n,n)
dc = dr+im*rand(m,m)
ec = er+im*rand(n,m)
as, cs = schur(ar,cr)
bs, ds = schur(br,dr)
acs, ccs = schur(ac,cc)
bcs, dcs = schur(bc,dc)

Tr = sylvop(ar, br, cr, dr)
Trinv = invsylvop(ar, br, cr, dr)
Trs = sylvop(as, bs, cs, ds)
Trsinv = invsylvop(as, bs, cs, ds)
Trs1 = sylvop(as, ds, cs, bs)
Trs1inv = invsylvop(as, ds, cs, bs)

Tc = sylvop(ac, bc, cc, dc)
Tcinv = invsylvop(ac, bc, cc, dc)
Tcs = sylvop(acs, bcs, ccs, dcs)
Tcsinv = invsylvop(acs, bcs, ccs, dcs)
@test size(Tr) == size(Tr') == size(Trinv') 
   
@test check_ctranspose(Tr) &&   
      check_ctranspose(Trinv) &&  
      check_ctranspose(Trs) &&
      check_ctranspose(Trsinv) && 
      check_ctranspose(Tc) &&
      check_ctranspose(Tcinv) &&
      check_ctranspose(Tcs) &&
      check_ctranspose(Tcsinv) 


try
    T = invsylvop(as,bs,cs,ds);
    T*rand(n*m);
    transpose(T)*rand(n*m);
    adjoint(T)*rand(n*m);
    T*rand(Float32,n*m);
    transpose(T)*rand(Float32,n*m);
    adjoint(T)*rand(Float32,n*m);
    T*ones(Int,n*m);
    transpose(T)*ones(Int,n*m);
    adjoint(T)*ones(Int,n*m);
    T = invsylvop(acs,bcs,ccs,dcs);
    T*rand(n*m);
    T*complex(rand(n*m));
    transpose(T)*rand(n*m);
    transpose(T)*complex(rand(n*m));
    T'*rand(n*m);
    T'*complex(rand(n*m));
    sylvop(ar,complex(br),cr,dr);
    invsylvop(ar,complex(br),cr,dr);
    @test true
 catch
    @test false
 end 


@time x = Trinv*er[:];
@test norm(Tr*x-er[:])/norm(x[:]) < reltol 

@time x = Trsinv*er[:]
@test norm(Trs*x[:]-er[:])/norm(x[:]) < reltol

@time x = Trs1inv*er[:]
@test norm(Trs1*x[:]-er[:])/norm(x[:]) < reltol

@time x = invsylvop(as, bs, cs, ds)*er[:]
@test norm(sylvop(as, bs, cs, ds)*x[:]-er[:])/norm(x[:]) < reltol

@time x = invsylvop(as', bs, cs', ds)*er[:]
@test norm(sylvop(as', bs, cs', ds)*x[:]-er[:])/norm(x[:]) < reltol

@time x = invsylvop(as, bs', cs, ds')*er[:]
@test norm(sylvop(as, bs', cs, ds')*x[:]-er[:])/norm(x[:]) < reltol

@time x = invsylvop(as', bs', cs', ds')*er[:]
@test norm(sylvop(as', bs', cs', ds')*x[:]-er[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as, bs, cs, ds))*er[:]
@test norm(transpose(sylvop(as, bs, cs, ds))*x[:]-er[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as, bs, cs, ds))*er[:]
@test norm(transpose(sylvop(as, bs, cs, ds))*x[:]-er[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as', bs, cs', ds))*er[:]
@test norm(transpose(sylvop(as', bs, cs', ds))*x[:]-er[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as, bs', cs, ds'))*er[:]
@test norm(transpose(sylvop(as, bs', cs, ds'))*x[:]-er[:])/norm(x[:]) < reltol

@time x = transpose(invsylvop(as', bs', cs', ds'))*er[:]
@test norm(transpose(sylvop(as', bs', cs', ds'))*x[:]-er[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as, bs, cs, ds))*er[:]
@test norm(adjoint(sylvop(as, bs, cs, ds))*x[:]-er[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as', bs, cs', ds))*er[:]
@test norm(adjoint(sylvop(as', bs, cs', ds))*x[:]-er[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as, bs', cs, ds'))*er[:]
@test norm(adjoint(sylvop(as, bs', cs, ds'))*x[:]-er[:])/norm(x[:]) < reltol

@time x = adjoint(invsylvop(as', bs', cs', ds'))*er[:]
@test norm(adjoint(sylvop(as', bs', cs', ds'))*x[:]-er[:])/norm(x[:]) < reltol

@time x = Tcinv*ec[:]
@test norm(Tc*x[:]-ec[:])/norm(x[:]) < reltol

@time x = Tcsinv*ec[:]
@test norm(Tcs*x[:]-ec[:])/norm(x[:]) < reltol

@time x = Tcsinv'*er[:]
@test norm(Tcs'*x[:]-er[:])/norm(x[:]) < reltol

@time y = transpose(Trinv)*er[:]
@test norm(transpose(Tr)*y[:]-er[:])/norm(y[:]) < reltol

@time y = transpose(Trsinv)*er[:]
@test norm(transpose(Trs)*y[:]-er[:])/norm(y[:]) < reltol

@time x = transpose(Trsinv)*er[:]
@test norm(transpose(Trs)*x[:]-er[:])/norm(x[:]) < reltol

@time x = Trs1inv'*er[:]
@test norm(Trs1'*x[:]-er[:])/norm(x[:]) < reltol


@time y = Tcinv'*ec[:]
@test norm(Tc'*y[:]-ec[:])/norm(y[:]) < reltol

@time y = Tcsinv'*ec[:]
@test norm(Tcs'*y[:]-ec[:])/norm(y[:]) < reltol

x = rand(n*m);
@test abs(norm(Matrix(Tr)'-Matrix(transpose(Tr)))) < reltol  
@test abs(norm(Matrix(Tc)'-Matrix(Tc'))) < reltol 
@test norm(Matrix(Trinv)*Matrix(Tr)-I) < reltol 
@test norm(Matrix(Trsinv)*Matrix(Trs)-I) < reltol 
@test norm(Matrix(Tcinv)*Matrix(Tc)-I) < reltol 
@test norm(Matrix(Tcsinv)*Matrix(Tcs)-I) < reltol 
@test norm(Trsinv'*x-invsylvop(as',bs', cs',ds')*x) == 0 
@test opnorm1(Trsinv-invsylvop(schur(ar,cr),schur(br,dr))) == 0


@test sc*opnorm1(Tr) < opnorm1est(Tr)  &&
      sc*opnorm1(Trinv) < opnorm1est(Trinv)  &&
      sc*opnorm1(Trs) < opnorm1est(Trs)  &&
      sc*opnorm1(Trsinv) < opnorm1est(Trsinv)  &&
      sc*opnorm1(Tc) < opnorm1est(Tc)  &&
      sc*opnorm1(Tcinv) < opnorm1est(Tcinv)  &&
      sc*opnorm1(Tcs) < opnorm1est(Tcs)  &&
      sc*opnorm1(Tcsinv) < opnorm1est(Tcsinv)

@test sc*oprcondest(Tr,Trinv) < 1/opnorm1(Tr)/opnorm1(Trinv)  &&
      sc*oprcondest(Trs,Trsinv) < 1/opnorm1(Trs)/opnorm1(Trsinv)  &&
      sc*oprcondest(Tc,Tcinv) < 1/opnorm1(Tc)/opnorm1(Tcinv)  &&
      sc*oprcondest(Tcs,Tcsinv) < 1/opnorm1(Tcs)/opnorm1(Tcsinv) &&
      oprcondest(Tr) == oprcondest(Tr,Trinv) == oprcondest(Trinv) 

@test opsepest(Trsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Trs)))  &&
      minimum(svdvals(Matrix(Trs))) <= sqrt(2)*n*opsepest(Trsinv)  &&
      opsepest(invsylvop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.])) == 0. &&
      opsepest(transpose(invsylvop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0. &&
      opsepest(adjoint(invsylvop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0. &&
      opsepest(invsylvop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.])) == 0. &&
      opsepest(transpose(invsylvop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0. &&
      opsepest(adjoint(invsylvop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0. 

end

@testset "Sylvester system operators" begin

ar = rand(n,n)
br = rand(m,m)
cr = rand(n,n)
dr = rand(m,m)
er = rand(n,m)
fr = rand(n,m)
ac = ar+im*rand(n,n)
bc = br+im*rand(m,m)
cc = cr+im*rand(n,n)
dc = dr+im*rand(m,m)
ec = er+im*rand(n,m)
fc = fr+im*rand(n,m)
as, cs = schur(ar,cr)
bs, ds = schur(br,dr)
acs, ccs = schur(ac,cc)
bcs, dcs = schur(bc,dc)

Tr = sylvsysop(ar, br, cr, dr)
Trinv = invsylvsysop(ar, br, cr, dr)
Trs = sylvsysop(as, bs, cs, ds)
Trsinv = invsylvsysop(as, bs, cs, ds)

Tc = sylvsysop(ac, bc, cc, dc)
Tcinv = invsylvsysop(ac, bc, cc, dc)
Tcs = sylvsysop(acs, bcs, ccs, dcs)
Tcsinv = invsylvsysop(acs, bcs, ccs, dcs)
@test size(Tr) == size(Tr') == size(Trinv') 


@test check_ctranspose(Tr) &&
      check_ctranspose(Trinv) &&
      check_ctranspose(Trs) &&
      check_ctranspose(Trsinv) &&
      check_ctranspose(Tc) &&
      check_ctranspose(Tcinv) &&
      check_ctranspose(Tcs) &&
      check_ctranspose(Tcsinv) 


try
    T = invsylvsysop(as,bs,cs,ds);
    T*rand(2n*m);
    transpose(T)*rand(2n*m);
    adjoint(T)*rand(2n*m);
    T*rand(Float32,2n*m);
    transpose(T)*rand(Float32,2n*m);
    adjoint(T)*rand(Float32,2n*m);
    T*ones(Int,2n*m);
    transpose(T)*ones(Int,2n*m);
    adjoint(T)*ones(Int,2n*m);
    T = invsylvsysop(acs,bcs,ccs,dcs);
    T*rand(2n*m);
    T*complex(rand(2n*m));
    transpose(T)*rand(2n*m);
    transpose(T)*complex(rand(2n*m));
    T'*rand(2n*m);
    T'*complex(rand(2n*m));
    sylvsysop(ar,complex(br),cr,dr);
    invsylvsysop(ar,complex(br),cr,dr);
    @test true
 catch
    @test false
 end 




@time xy = Trinv*[er[:];fr[:]]
@test norm(Tr*xy-[er[:];fr[:]])/norm(xy[:]) < reltol
 
@time xy = Trinv*[ec[:];fc[:]]
@test norm(Tr*xy-[ec[:];fc[:]])/norm(xy[:]) < reltol

@time xy = transpose(Trinv)*[er[:];fr[:]]
@test norm(transpose(Tr)*xy-[er[:];fr[:]])/norm(xy[:]) < reltol

@time xy = transpose(Trinv)*[ec[:];fc[:]]
@test norm(transpose(Tr)*xy-[ec[:];fc[:]])/norm(xy[:]) < reltol

@time xy = Tcinv*[ec[:];fc[:]]
@test norm(Tc*xy-[ec[:];fc[:]])/norm(xy[:]) < reltol

@time xy = Tcinv'*[ec[:];fc[:]]
@test norm(Tc'*xy-[ec[:];fc[:]])/norm(xy[:]) < reltol

@time xy = Trsinv*[er[:];fr[:]]
@test norm(Trs*xy-[er[:];fr[:]])/norm(xy[:]) < reltol

@time xy = Tcsinv*[er[:];fr[:]]
@test norm(Tcs*xy-[er[:];fr[:]])/norm(xy[:]) < reltol

@time xy = transpose(Trsinv)*[er[:];fr[:]]
@test norm(transpose(Trs)*xy-[er[:];fr[:]])/norm(xy[:]) < reltol

@time xy = Tcsinv*[er[:];fr[:]]
@test norm(Tcs*xy-[er[:];fr[:]])/norm(xy[:]) < reltol

@time xy = Tcsinv'*[er[:];fr[:]]
@test norm(Tcs'*xy-[er[:];fr[:]])/norm(xy[:]) < reltol

@test abs(norm(Matrix(Tr)'-Matrix(transpose(Tr)))) < reltol 
@test abs(norm(Matrix(Tc)'-Matrix(Tc'))) < reltol 
@test norm(Matrix(Trinv)*Matrix(Tr)-I) < reltol 
@test norm(Matrix(Trsinv)*Matrix(Trs)-I) < reltol 
@test norm(Matrix(Tcinv)*Matrix(Tc)-I) < reltol 
@test norm(Matrix(Tcsinv)*Matrix(Tcs)-I) < reltol 
@test opnorm1(Trsinv-invsylvsysop(schur(ar,cr),schur(br,dr))) == 0


@test sc*opnorm1(Tr) < opnorm1est(Tr)  &&
      sc*opnorm1(Trinv) < opnorm1est(Trinv)  &&
      sc*opnorm1(Trs) < opnorm1est(Trs)  &&
      sc*opnorm1(Trsinv) < opnorm1est(Trsinv)  &&
      sc*opnorm1(Tc) < opnorm1est(Tc)  &&
      sc*opnorm1(Tcinv) < opnorm1est(Tcinv)  &&
      sc*opnorm1(Tcs) < opnorm1est(Tcs)  &&
      sc*opnorm1(Tcsinv) < opnorm1est(Tcsinv)

@test sc*oprcondest(Tr,Trinv) < 1/opnorm1(Tr)/opnorm1(Trinv)  &&
      sc*oprcondest(Trs,Trsinv) < 1/opnorm1(Trs)/opnorm1(Trsinv)  &&
      sc*oprcondest(Tc,Tcinv) < 1/opnorm1(Tc)/opnorm1(Tcinv)  &&
      sc*oprcondest(Tcs,Tcsinv) < 1/opnorm1(Tcs)/opnorm1(Tcsinv) &&
      oprcondest(Tr) == oprcondest(Tr,Trinv) == oprcondest(Trinv) 


@test opsepest(Trsinv)/n/sqrt(2) <= minimum(svdvals(Matrix(Trs)))  &&
      minimum(svdvals(Matrix(Trs))) <= sqrt(2)*n*opsepest(Trsinv)  &&
      opsepest(invsylvsysop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.])) == 0.   &&
      opsepest(transpose(invsylvsysop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0.  &&
      opsepest(adjoint(invsylvsysop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0.  &&
      opsepest(invsylvsysop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.])) == 0.  &&
      opsepest(transpose(invsylvsysop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0.  &&
      opsepest(adjoint(invsylvsysop([0. 1.; 0. 1.],[0. 1.; 0. 1.],-[0. 1.; 0. 1.],[0. 1.; 0. 1.]))) == 0. 


end

#end

end

module Test_dlyap

using LinearAlgebra
using MatrixEquations
using GenericSchur
using Test


println("Test_dlyap")
@testset "Testing discrete Lyapunov equation solvers" begin

n = 10
Ty = Float64

@testset "Discrete Lyapunov equations" begin

reltol = eps(float(1000))
a = -2+im; b = 2; @time x = lyapd(a,b)
@test abs(a*x*a'-x+b) < reltol

reltol = eps(float(1000f0))
a = 1f0-2f0im; b = 2f0; @time x = lyapd(a,b)
@test abs(a*x*a'-x+b)  < reltol

try
   x = lyapd(ones(1,1),ones(1,1))
   if norm(x,Inf) > 1.e10
      @test true
   else
      @test false
   end
 catch
   @test true
end  

try
   x = lyapd([0 1;  -1 0 ],ones(2,2))  
   if norm(x,Inf) > 1.e10
      @test true
   else
      @test false
   end
catch
   @test true
end  
 
try
   x = lyapd([0.5 1;  0 2],ones(2,2))
   if norm(x,Inf) > 1.e10
      @test true
   else
      @test false
   end
catch
   @test true
end  
 
try
   x = lyapd([1 1 1 1;  -1 1 0 1; 0 0 0.5 0.5; 0 0 -0.5 0.5],ones(4,4)) 
   if norm(x,Inf) > 1.e10
      @test true
   else
      @test false
   end
catch
   @test true
end  
 

for Ty in (Float64, Float32, BigFloat)
# for Ty in (Float64, Float32)

ar = rand(Ty,n,n); ars = Symmetric(ar);
ac = rand(Ty,n,n)+im*rand(Ty,n,n); ach = Hermitian(ac); acd = Diagonal(ac); 
c = rand(Ty,n,n)+im*rand(Ty,n,n)
#qc = c'*c
qc = Matrix(Hermitian(c'*c));
Qr = real(qc)
qnh = c;
Qnh = real(qnh);
Ty == Float64 ? reltol = eps(float(10000)) : reltol = eps(10000*n*one(Ty))

@time x = lyapd(ac,qc);
@test norm(ac*x*ac'-x+qc)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ac,qc,blocksize=5);
@test norm(ac*x*ac'-x+qc)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ac,qnh);
@test norm(ac*x*ac'-x+qnh)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ac,qnh,blocksize=5);
@test norm(ac*x*ac'-x+qnh)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ach,qc);
@test norm(ach*x*ach-x+qc)/norm(x)/max(1.,norm(ach)^2) < reltol

@time x = lyapd(ach,qc,blocksize=5);
@test norm(ach*x*ach-x+qc)/norm(x)/max(1.,norm(ach)^2) < reltol

@time x = lyapd(acd,qc);
@test norm(acd*x*acd'-x+qc)/norm(x)/max(1.,norm(acd)^2) < reltol

@time x = lyapd(acd',qc);
@test norm(acd'*x*acd-x+qc)/norm(x)/max(1.,norm(acd)^2) < reltol


α = 3+im; # α = 1; #SingularException
@time x = lyapd(α*I,qc);
@test norm(α*x*α'-x+qc)/norm(x) < reltol

try
   α = 1; #SingularException
   @time x = lyapd(α,qc);
catch
   @test true
end

α = 3. +im;
@time x = lyapd(α,qc);
@test norm(α*x*α'-x+qc)/norm(x) < reltol

@time x = lyapd(ac',qc);
@test norm(ac'*x*ac-x+qc)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ac',qc,blocksize=5);
@test norm(ac'*x*ac-x+qc)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ac',qnh);
@test norm(ac'*x*ac-x+qnh)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ac',qnh,blocksize=5);
@test norm(ac'*x*ac-x+qnh)/norm(x)/max(1.,norm(ac)^2) < reltol

@time x = lyapd(ar,Qr)
@test norm(ar*x*ar'-x+Qr)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar,Qr,blocksize=5)
@test norm(ar*x*ar'-x+Qr)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar,Qnh)
@test norm(ar*x*ar'-x+Qnh)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar,Qnh,blocksize=5)
@test norm(ar*x*ar'-x+Qnh)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar',Qr)
@test norm(ar'*x*ar-x+Qr)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar',Qr,blocksize=5)
@test norm(ar'*x*ar-x+Qr)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar',Qnh)
@test norm(ar'*x*ar-x+Qnh)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar',Qnh,blocksize=5)
@test norm(ar'*x*ar-x+Qnh)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ars,Qr)
@test norm(ars*x*ars'-x+Qr)/norm(x)/max(1.,norm(ars)^2) < reltol

@time x = lyapd(ars,Qr,blocksize=5)
@test norm(ars*x*ars'-x+Qr)/norm(x)/max(1.,norm(ars)^2) < reltol

@time x = lyapd(ars',Qr)
@test norm(ars'*x*ars-x+Qr)/norm(x)/max(1.,norm(ars)^2) < reltol

@time x = lyapd(ar',Qr,blocksize=5)
@test norm(ar'*x*ar-x+Qr)/norm(x)/max(1.,norm(ar)^2) < reltol


@time x = lyapd(ac,Qr);
@test norm(ac*x*ac'-x+Qr)/norm(x)/max(1.,norm(ac)^2)  < reltol

@time x = lyapd(ac',Qr);
@test norm(ac'*x*ac-x+Qr)/norm(x)/max(1.,norm(ac)^2)  < reltol

@time x = lyapd(ar,qc)
@test norm(ar*x*ar'-x+qc)/norm(x)/max(1.,norm(ar)^2) < reltol

@time x = lyapd(ar',qc)
@test norm(ar'*x*ar-x+qc)/norm(x)/max(1.,norm(ar)^2) < reltol
end
end

@testset "Discrete generalized Lyapunov equations" begin

reltol = eps(float(10000))
ac = -2+im; ec = 4+im; b = 2; @time x = lyapd(ac,ec,b)
@test abs(ac*x*ac'-ec*x*ec'+b) < reltol

try
   x = lyapd(ones(1,1),ones(1,1),ones(1,1))
   @test false
catch
   @test true
end  

try
   x = lyapd([0 2;  -2 0 ],[2 0; 0 2],ones(2,2))
   @test false
catch
   @test true
end  
 
try
   x = lyapd([2 1;  0 2],[2 0; 0 2],ones(2,2))
   @test false
catch
   @test true
end  
 
try
   x = lyapd(2*[1 1 1 1;  -1 1 0 1; 0 0 0.5 0.5; 0 0 -0.5 0.5],2*Matrix{Float64}(I,4,4),ones(4,4))
   @test false
catch
   @test true
end  

for Ty in (Float64, Float32, BigFloat)
# for Ty in (Float64, Float32)

ar = rand(Ty,n,n)
ac = rand(Ty,n,n)+im*rand(Ty,n,n)
er = rand(Ty,n,n)
ec = er+im*rand(Ty,n,n)

c = rand(Ty,n,n)+im*rand(Ty,n,n)
#qc = c'*c
qc = Matrix(Hermitian(c'*c));
Qr = real(qc)
qnh = c;
Qnh = real(qnh);
Ty == Float64 ? reltol = eps(float(1000)) : reltol = eps(1000*n*one(Ty))

@time x = lyapd(ac,ec,qc);
@test norm(ac*x*ac'-ec*x*ec'+qc)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac,ec,qc,blocksize = 5);
@test norm(ac*x*ac'-ec*x*ec'+qc)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac,ec,qnh);
@test norm(ac*x*ac'-ec*x*ec'+qnh)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac,ec,qnh,blocksize = 5);
@test norm(ac*x*ac'-ec*x*ec'+qnh)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

β = 3
@time x = lyapd(ac,β*I,qc);
@test norm(ac*x*ac'-β*x*β'+qc)/norm(x)/norm(ac) < reltol

β = (1+im);
@time x = lyapd(ac,β,qc);
@test norm(ac*x*ac'-β*x*β'+qc)/norm(x)/norm(ac) < reltol

α = 2+3im
@time x = lyapd(α*I,ec,qc);
@test norm(α*x*α'-ec*x*ec'+qc)/norm(x)/norm(ec) < reltol

α = 2+3im
@time x = lyapd(α,ec,qc);
@test norm(α*x*α'-ec*x*ec'+qc)/norm(x)/norm(ec) < reltol

try
   @time x = lyapd(0*ac,0*ec,qc);
   @test false
catch
   @test true
end

α = 2+3im; β = (1+im);
@time x = lyapd(α*I,β*I,qc);
@test norm(α*x*α'-β*x*β'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

try
   α = 1; β = 1; #SingularException
   @time x = lyapd(α,β,qc);
   @test false
catch
   @test true
end

α = 2+3im; β = (1+im);
@time x = lyapd(α,β,qc);
@test norm(α*x*α'-β*x*β'+qc)/norm(x)/norm(ac)/norm(ec) < reltol

@time x = lyapd(ac',ec',qc);
@test norm(ac'*x*ac-ec'*x*ec+qc)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac',ec',qc,blocksize=5);
@test norm(ac'*x*ac-ec'*x*ec+qc)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac',ec',qnh);
@test norm(ac'*x*ac-ec'*x*ec+qnh)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac',ec',qnh,blocksize=5);
@test norm(ac'*x*ac-ec'*x*ec+qnh)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

β = (1+im);
@time x = lyapd(ac',β*I,qc);
@test norm(ac'*x*ac-β*x*β'+qc)/norm(x)/norm(ac) < reltol

α = 2+3im
@time x = lyapd(α*I,ec',qc);
@test norm(α*x*α'-ec'*x*ec+qc)/norm(x)/norm(ec) < reltol

@time x = lyapd(ac',ec,qc);
@test norm(ac'*x*ac-ec*x*ec'+qc)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac,ec',qc);
@test norm(ac*x*ac'-ec'*x*ec+qc)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ar,er,Qr);
@test norm(ar*x*ar'-er*x*er'+Qr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar',er',Qr);
@test norm(ar'*x*ar-er'*x*er+Qr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar,er,Qr,blocksize=5);
@test norm(ar*x*ar'-er*x*er'+Qr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar',er',Qr,blocksize=5);
@test norm(ar'*x*ar-er'*x*er+Qr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar,er,Qnh);
@test norm(ar*x*ar'-er*x*er'+Qnh)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar',er',Qnh);
@test norm(ar'*x*ar-er'*x*er+Qnh)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar,er,Qnh,blocksize=5);
@test norm(ar*x*ar'-er*x*er'+Qnh)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar',er',Qnh,blocksize=5);
@test norm(ar'*x*ar-er'*x*er+Qnh)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar',er,Qr);
@test norm(ar'*x*ar-er*x*er'+Qr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar,er',Qr);
@test norm(ar*x*ar'-er'*x*er+Qr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ac,ec,Qr);
@test norm(ac*x*ac'-ec*x*ec'+Qr)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac',ec',Qr);
@test norm(ac'*x*ac-ec'*x*ec+Qr)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac',ec,Qr);
@test norm(ac'*x*ac-ec*x*ec'+Qr)/norm(x)/max(norm(ac)^2,norm(ec)^2) < reltol

@time x = lyapd(ac,ec',Qr);
@test norm(ac*x*ac'-ec'*x*ec+Qr)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar,er,qc);
@test norm(ar*x*ar'-er*x*er'+qc)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar',er',qc);
@test norm(ar'*x*ar-er'*x*er+qc)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar',er,qc);
@test norm(ar'*x*ar-er*x*er'+qc)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol

@time x = lyapd(ar,er',qc);
@test norm(ar*x*ar'-er'*x*er+qc)/norm(x)/max(norm(ar)^2,norm(er)^2) < reltol
end
end


@testset "Discrete Lyapunov equations - Schur form" begin

for Ty in (Float64, Float32, BigFloat)
# for Ty in (Float64, Float32)

ar = rand(Ty,n,n);ard = Diagonal(ar);
ac = rand(Ty,n,n)+im*rand(Ty,n,n); acd = Diagonal(ac);
er = rand(Ty,n,n);
ec = er+im*rand(Ty,n,n);
es = triu(er);
as = es*schur(ar).T;
#as, es = schur(ar,er);
acs, ecs = schur(ac,ec);

c = rand(Ty,n,n)+im*rand(Ty,n,n);
#qc = c'*c;
qc = Matrix(Hermitian(c'*c));
Qr = real(qc);
Ty == Float64 ? reltol = eps(float(1000)) : reltol = eps(1000*n*one(Ty))

x = copy(Qr)
@time lyapds!(as,x);
@test norm(as*x*as'+Qr-x)/norm(x)/max(norm(as)^2,1.) < reltol

x = copy(Qr)
@time lyapds!(ard,x);
@test norm(ard*x*ard+Qr-x)/norm(x)/max(norm(ard)^2,1.) < reltol

x = copy(Qr)
@time lyapds!(as,x,adj=true);
@test norm(as'*x*as+Qr-x)/norm(x)/max(norm(as)^2,1.) < reltol

x = copy(qc)
@time lyapds!(acs,ecs,x);
@test norm(acs*x*acs'+qc-ecs*x*ecs')/norm(x)/max(norm(acs)^2,norm(ecs)^2) < reltol

x = copy(qc)
@time lyapds!(acs,I,x);
@test norm(acs*x*acs'+qc-x)/norm(x)/norm(acs)^2  < reltol

x = copy(qc)
@time lyapds!(acd,x);
@test norm(acd*x*acd'+qc-x)/norm(x)/norm(acd)^2 < reltol

x = copy(qc)
@time lyapds!(acd,x,adj=true);
@test norm(acd'*x*acd+qc-x)/norm(x)/norm(acd)^2 < reltol


x = copy(qc)
@time lyapds!(acs,ecs,x,adj=true);
@test norm(acs'*x*acs+qc-ecs'*x*ecs)/norm(x)/max(norm(acs)^2,norm(ecs)^2) < reltol

x = copy(Qr)
@time lyapds!(as,es,x);
@test norm(as*x*as'+Qr-es*x*es')/norm(x)/max(norm(as)^2,norm(es)^2) < reltol

x = copy(Qr)
@time lyapds!(as,es,x,adj=true);
@test norm(as'*x*as+Qr-es'*x*es)/norm(x)/max(norm(as)^2,norm(es)^2) < reltol

end
end

end

end

using Documenter, MatrixEquations
DocMeta.setdocmeta!(MatrixEquations, :DocTestSetup, :(using MatrixEquations); recursive=true)

makedocs(warnonly = true, 
  modules  = [MatrixEquations],
  sitename = "MatrixEquations.jl",
  authors  = "Andreas Varga",
  format   = Documenter.HTML(prettyurls = false),
  pages    = [
     "Overview"   => "index.md",
     "Library" => [
        "lyapunov.md",
        "plyapunov.md",
        "riccati.md",
        "sylvester.md",
        "sylvkr.md",
        "condest.md",
        "meoperators.md",
        "iterative.md"
     ],
     "Internal" => [
        "lapackutil.md",
        "meutil.md"
     ],
     "Index" => "makeindex.md"
  ]
)

deploydocs(
  repo = "github.com/andreasvarga/MatrixEquations.jl.git",
  push_preview = true,
  target = "build",
  )

"""
    arec(A, G, Q = 0; scaling = 'B', pow2 = false, as = false, rtol::Real = nϵ, nrm = 1) -> (X, EVALS, Z, scalinfo)

Compute `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the continuous-time
algebraic Riccati equation

     A'X + XA - XGX + Q = 0,

where `G` and `Q` are hermitian/symmetric matrices or uniform scaling operators.
Scalar-valued `G` and `Q` are interpreted as appropriately sized uniform scaling operators `G*I` and `Q*I`.
The Schur method of [1] is used. 

To enhance the accuracy of computations, a block scaling of matrices `G` and `Q` is performed, if  
the default setting `scaling = 'B'` is used. This scaling is however performed only if `norm(Q) > norm(G)`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, experimental structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting. 
Scaling can be disabled with the choice `scaling = 'N'`.
If `pow2 = true`, the scaling elements are enforced to the nearest power of 2 (default: `pow2 = false`).

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable or anti-stable) eigenvalues of `A-GX`.

`Z = [U; V]` is an orthogonal basis for the stable/anti-stable deflating subspace such that `X = Sx*(V/U)*Sxi`, 
where `Sx` and `Sxi` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx` and `scalinfo.Sxi`, respectively.

_Note:_ To solve the continuous-time algebraic Riccati equation

     A'X + XA - XBR^(-1)B'X + Q = 0,

with `R` a hermitian/symmetric matrix and `B` a compatible size matrix, `G = BR^(-1)B'` must be provided. 
This approach is not numerically suited when `R` is ill-conditioned and/or `B` has large norm.  

`Reference:`

[1] Laub, A.J., A Schur Method for Solving Algebraic Riccati equations.
    IEEE Trans. Auto. Contr., AC-24, pp. 913-921, 1979.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> G = [1. 0. 0.; 0. 5. 0.; 0. 0. 10.]
3×3 Array{Float64,2}:
 1.0  0.0   0.0
 0.0  5.0   0.0
 0.0  0.0  10.0

julia> X, CLSEIG = arec(A,G,2I);

julia> X
3×3 Array{Float64,2}:
  0.459589   0.333603   -0.144406
  0.333603   0.65916    -0.0999216
 -0.144406  -0.0999216   0.340483

julia> A'*X+X*A-X*G*X+2I
3×3 Array{Float64,2}:
  2.22045e-16  4.44089e-16  -1.77636e-15
  4.44089e-16  6.66134e-16   1.11022e-16
 -1.77636e-15  1.11022e-16  -1.33227e-15

julia> CLSEIG
3-element Array{Complex{Float64},1}:
 -4.411547592296008 + 2.4222082620381102im
 -4.411547592296008 - 2.4222082620381102im
 -4.337128244724371 + 0.0im

julia> eigvals(A-G*X)
3-element Array{Complex{Float64},1}:
 -4.4115475922960075 - 2.4222082620381076im
 -4.4115475922960075 + 2.4222082620381076im
  -4.337128244724374 + 0.0im
```
"""
function arec(A::AbstractMatrix, G::Union{AbstractMatrix,UniformScaling,Real,Complex}, Q::Union{AbstractMatrix,UniformScaling,Real,Complex} = zero(eltype(A));
              scaling = 'B', pow2 = false, as = false, rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), nrm = 1)
    n = LinearAlgebra.checksquare(A)
    T = promote_type( eltype(A), eltype(G), eltype(Q) )
    if typeof(G) <: AbstractArray
       (LinearAlgebra.checksquare(G) == n && ishermitian(G)) ||
          throw(DimensionMismatch("G must be a symmetric/hermitian matrix of dimension $n"))
    else
       G = G*I
       iszero(imag(G.λ)) || throw("G must be a symmetric/hermitian matrix")
    end
    if typeof(Q) <: AbstractArray
       (LinearAlgebra.checksquare(Q) == n && ishermitian(Q)) ||
          throw(DimensionMismatch("Q must be a symmetric/hermitian matrix of dimension $n"))
    else
       Q = Q*I
       iszero(imag(Q.λ)) || throw("Q must be a symmetric/hermitian matrix")
    end
    T <: BlasFloat || (T = promote_type(Float64,T))
    TR = real(T)
    epsm = eps(TR)
    eltype(A) == T || (A = convert(Matrix{T},A))
    eltype(G) == T || (typeof(G) <: AbstractMatrix ? G = convert(Matrix{T},G) : G = convert(T,G.λ)*I)
    eltype(Q) == T || (typeof(Q) <: AbstractMatrix ? Q = convert(Matrix{T},Q) : Q = convert(T,Q.λ)*I)

    n == 0 && (return  zeros(T,0,0), zeros(T,0), zeros(T,m,0) )
    
    # perform scaling if appropriate
    H, Sx, Sxi = balham(A, G, Q; scaling, pow2, nrm)
    S = schur!(H)

    as ? select = real(S.values) .> 0 : select = real(S.values) .< 0
    n == count(select) || error("The Hamiltonian matrix is not dichotomic")
    ordschur!(S, select)

    n2 = n+n
    ix = 1:n
    F = _LUwithRicTest(S.Z[ix, ix],rtol)
    x = S.Z[n+1:n2, ix]/F
    lmul!(Sx,x); rmul!(x,Sxi)
    scalinfo = (Sx = Sx, Sxi = Sxi)
    return  LinearAlgebra._hermitianpart!(x), S.values[ix], S.Z[:,ix], scalinfo
end
function _LUwithRicTest(Z11::AbstractArray{T},rtol::Real) where {T <: BlasFloat}
   try
      F = LinearAlgebra.lu(Z11)
      Z11norm = opnorm(Z11,1)
      Z11norm > 2*rtol ? (rcond = LAPACK.gecon!('1',F.factors,Z11norm)) : (rcond = zero(eltype(Z11)))
      rcond <= rtol ? error("no finite solution exists for the Riccati equation") : (return  F)
    catch
      error("no finite solution exists for the Riccati equation")
   end
end
function _LUwithRicTest(Z11::AbstractArray,rtol::Real)
   try
      F = LinearAlgebra.lu(Z11)
      # Z11norm = opnorm(Z11,1)
      # Z11norm > 2*rtol ? (rcond = LAPACK.gecon!('1',F.factors,Z11norm)) : (rcond = zero(eltype(Z11)))
      # rcond <= rtol ? error("no finite solution exists for the Riccati equation") : (return  F)
    catch
      error("no finite solution exists for the Riccati equation")
   end
end
"""
    arec(A, B, R, Q, S; scaling = 'B', pow2 = false, as = false, rtol::Real = nϵ, orth = false, nrm = 1) -> (X, EVALS, F, Z, scalinfo)

Compute `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the continuous-time
algebraic Riccati equation

     A'X + XA - (XB+S)R^(-1)(B'X+S') + Q = 0,

where `R` and `Q` are hermitian/symmetric matrices or uniform scaling operators such that `R` is nonsingular.
Scalar-valued `R` and `Q` are interpreted as appropriately sized uniform scaling operators `R*I` and `Q*I`.
`S`, if not specified, is set to `S = zeros(size(B))`.
The Schur method of [1] is used. 

To enhance the accuracy of computations, a block scaling of matrices `R`, `Q`  and `S` is performed, if  
the default setting `scaling = 'B'` is used. This scaling is however performed only if `norm(Q) > norm(B)^2/norm(R)`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting.   
Experimental structure preserving scalings can be performed using the options `scaling = 'D'` 
or `scaling = 'T'`. Scaling can be disabled with the choice `scaling = 'N'`.
If `pow2 = true`, the scaling elements are enforced to the nearest power of 2 (default: `pow2 = false`).

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable or anti-stable) eigenvalues of `A-BF`.

`F` is the stabilizing or anti-stabilizing gain matrix `F = R^(-1)(B'X+S')`.

`Z = [U; V; W]` is a basis for the relevant stable/anti-stable deflating subspace 
such that `X = Sx*(V/U)*Sxi` and  `F = -Sr*(W/U)*Sxi`, 
where `Sx`, `Sxi` and `Sr` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx`, `scalinfo.Sxi` and `scalinfo.Sr`, respectively.
An orthogonal basis `Z` can be determined, with an increased computational cost, by setting `orth = true`.

`Reference:`

[1] Laub, A.J., A Schur Method for Solving Algebraic Riccati equations.
    IEEE Trans. Auto. Contr., AC-24, pp. 913-921, 1979.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> B = [1. 2.; 2. 0.; 0. 1.]
3×2 Array{Float64,2}:
 1.0  2.0
 2.0  0.0
 0.0  1.0

julia> R = [1. 0.; 0. 5.]
2×2 Array{Float64,2}:
 1.0  0.0
 0.0  5.0

julia> X, CLSEIG, F = arec(A,B,R,2I);

julia> X
3×3 Array{Float64,2}:
  0.522588   0.303007  -0.327227
  0.303007   0.650895  -0.132608
 -0.327227  -0.132608   0.629825

julia> A'*X+X*A-X*B*inv(R)*B'*X+2I
3×3 Array{Float64,2}:
 -2.66454e-15  -1.55431e-15   8.88178e-16
 -1.55431e-15   2.22045e-15  -2.9976e-15
  9.99201e-16  -2.9976e-15    4.44089e-16

julia> CLSEIG
3-element Array{Complex{Float64},1}:
   -4.37703628399912 + 2.8107164873731247im
   -4.37703628399912 - 2.8107164873731247im
 -1.8663764577096091 + 0.0im

julia> eigvals(A-B*F)
3-element Array{Complex{Float64},1}:
  -4.377036283999118 - 2.8107164873731234im
  -4.377036283999118 + 2.8107164873731234im
 -1.8663764577096063 + 0.0im
```
"""
function arec(A::AbstractMatrix, B::AbstractVecOrMat, R::Union{AbstractMatrix,UniformScaling,Real,Complex},
   Q::Union{AbstractMatrix,UniformScaling,Real,Complex}, S::AbstractVecOrMat = zeros(eltype(B),size(B));
   scaling = 'B', pow2 = false, as = false, rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), orth = false, nrm = 1)
   if orth
      return garec(A, I, B, 0, R, Q, S; scaling, pow2, as, rtol, nrm)
   else
      return arec(A, B, 0, R, Q, S; scaling, pow2, as, rtol, nrm)
   end
end
"""
    arec(A, B, G, R, Q, S; scaling = 'B', pow2 = false, as = false, rtol::Real = nϵ, orth = false, nrm = 1) -> (X, EVALS, F, Z, scalinfo)

Computes `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the continuous-time
algebraic Riccati equation

     A'X + XA - XGX - (XB+S)R^(-1)(B'X+S') + Q = 0,

where `G`, `R` and `Q` are hermitian/symmetric matrices or uniform scaling operators such that `R` is nonsingular.
Scalar-valued `G`, `R` and `Q` are interpreted as appropriately sized uniform scaling operators `G*I`, `R*I` and `Q*I`.
`S`, if not specified, is set to `S = zeros(size(B))`. 
For well conditioned `R`, the Schur method of [1] is used. For ill-conditioned `R` or if `orth = true`, 
the generalized Schur method of [2] is used. 

To enhance the accuracy of computations, a block oriented scaling of matrices `G`, `R`, `Q` and `S` is performed 
using the default setting `scaling = 'B'`. This scaling is performed only if `norm(Q) > max(norm(G), norm(B)^2/norm(R))`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting.   
If `orth = true`, two experimental scaling procedures 
can be activated using the options `scaling = 'D'` and `scaling = 'T'`. 
Scaling can be disabled with the choice `scaling = 'N'`.

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable or anti-stable) eigenvalues of `A-BF-GX`.

`F` is the stabilizing or anti-stabilizing gain matrix `F = R^(-1)(B'X+S')`.

`Z = [U; V; W]` is a basis for the relevant stable/anti-stable deflating subspace 
such that `X = Sx*(V/U)*Sxi` and  `F = -Sr*(W/U)*Sxi`, 
where `Sx`, `Sxi` and `Sr` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx`, `scalinfo.Sxi` and `scalinfo.Sr`, respectively.
An orthogonal basis `Z` can be determined, with an increased computational cost, by setting `orth = true`.

`Reference:`

[1] Laub, A.J., A Schur Method for Solving Algebraic Riccati equations.
    IEEE Trans. Auto. Contr., AC-24, pp. 913-921, 1979.

[2] W.F. Arnold, III and A.J. Laub,
    Generalized Eigenproblem Algorithms and Software for Algebraic Riccati Equations,
    Proc. IEEE, 72:1746-1754, 1984.
"""
function arec(A::AbstractMatrix, B::AbstractVecOrMat, G::Union{AbstractMatrix,UniformScaling,Real,Complex},
              R::Union{AbstractMatrix,UniformScaling,Real,Complex}, Q::Union{AbstractMatrix,UniformScaling,Real,Complex},
              S::AbstractVecOrMat; scaling = 'B', pow2 = false, as = false, rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), orth = false, nrm = 1)
   orth && (return garec(A, I, B, G, R, Q, S; scaling, pow2, as, rtol, nrm))

   T = promote_type( eltype(A), eltype(B), eltype(G), eltype(Q), eltype(R), eltype(S) )

   n = LinearAlgebra.checksquare(A)
   typeof(B) <: AbstractVector ? (nb, m) = (length(B), 1) : (nb, m) = size(B)
   n == nb || throw(DimensionMismatch("B must be a matrix with row dimension $n or a vector of length $n"))
   if typeof(G) <: AbstractArray
      (LinearAlgebra.checksquare(G) == n && ishermitian(G)) ||
          throw(DimensionMismatch("G must be a symmetric/hermitian matrix of dimension $n"))
   else
     G = G*I
     iszero(imag(G.λ)) || throw("G must be a symmetric/hermitian matrix")
   end
   if typeof(R) <: AbstractArray
      (LinearAlgebra.checksquare(R) == m && ishermitian(R)) ||
         throw(DimensionMismatch("R must be a symmetric/hermitian matrix of dimension $m"))
   else
      R = R*I
      iszero(imag(R.λ)) || throw("R must be a symmetric/hermitian matrix")
   end
   if typeof(Q) <: AbstractArray
     (LinearAlgebra.checksquare(Q) == n && ishermitian(Q)) ||
        throw(DimensionMismatch("Q must be a symmetric/hermitian matrix of dimension $n"))
   else
     Q = Q*I
     iszero(imag(Q.λ)) || throw("Q must be a symmetric/hermitian matrix")
   end
   typeof(S) <: AbstractVector ? (ns, ms) = (length(S), 1) : (ns, ms) = size(S)
   (n == ns && m == ms) ||
      throw(DimensionMismatch("S must be a $n x $m matrix or a vector of length $n"))
   T <: BlasFloat || (T = promote_type(Float64,T))
   TR = real(T)
   epsm = eps(TR)
   eltype(A) == T || (A = convert(Matrix{T},A))
   eltype(B) == T || (typeof(B) <: AbstractVector ? B = convert(Vector{T},B) : B = convert(Matrix{T},B))
   if typeof(G) <: AbstractArray
      (LinearAlgebra.checksquare(G) == n && ishermitian(G)) ||
          throw(DimensionMismatch("G must be a symmetric/hermitian matrix of dimension $n"))
      eltype(G) == T || (G = convert(Matrix{T},G))
   else
      G = G*I
      iszero(imag(G.λ)) || throw("G must be a symmetric/hermitian matrix")
   end
   if typeof(R) <: AbstractArray
      (LinearAlgebra.checksquare(R) == m && ishermitian(R)) ||
         throw(DimensionMismatch("R must be a symmetric/hermitian matrix of dimension $m"))
   else
      R = R*I
      iszero(imag(R.λ)) || throw("R must be a symmetric/hermitian matrix")
      R = Matrix{T}(R,m,m)
   end
   if typeof(Q) <: AbstractArray
      (LinearAlgebra.checksquare(Q) == n && ishermitian(Q)) ||
        throw(DimensionMismatch("Q must be a symmetric/hermitian matrix of dimension $n"))
      eltype(Q) == T || (Q = convert(Matrix{T},Q))
   else
      Q = Q*I
      iszero(imag(Q.λ)) || throw("Q must be a symmetric/hermitian matrix")
      Q = Matrix{T}(Q,n,n)
   end
   if eltype(S) != T
      if typeof(S) <: AbstractVector
         S = convert(Vector{T},S)
      else
         S = convert(Matrix{T},S)
      end
   end

   n == 0 && (return  zeros(T,0,0), zeros(T,0), zeros(T,m,0), zeros(T,m,0), (Sx = Diagonal(zeros(T,0)), Sxi = Diagonal(zeros(T,0)), Sr = Diagonal(zeros(T,m))) ) 

   S0flag = iszero(S)
   SR = schur(R)
   D = real(diag(SR.T))
   Da = abs.(D)
   minDa, = findmin(Da)
   maxDa, = findmax(Da)
   minDa <= epsm*maxDa && error("R must be non-singular")

   if minDa > sqrt(epsm)*maxDa && maxDa > 100*eps(max(opnorm(A,1),opnorm(G,1),opnorm(Q,1)))
      #Dinv = diagm(0 => 1 ./ D)
      Dinv = Diagonal(1 ./ D)
      Bu = B*SR.Z
      #G = G + Bu*Dinv*Bu'
      #G = utqu(Dinv,Bu')
      G += utqu(Dinv,Bu')
      if S0flag
         sol = arec(A, G, Q; scaling, nrm, pow2, as, rtol)
         w2 = SR.Z*Dinv*Bu'
         f = w2*sol[1]
         z = [sol[3]; w2*(sol[3])[n+1:end,:]]
      else
         Su = S*SR.Z
         #Q -= Su*Dinv*Su'
         Q -= utqu(Dinv,Su')
         sol = arec(A-Bu*Dinv*Su', G, Q; scaling, nrm, pow2, as, rtol)
         w1 = SR.Z*Dinv*Su'
         w2 = SR.Z*Dinv*Bu'
         f = w1+w2*sol[1]
         #f = SR.Z*Dinv*(Bu'*sol[1]+Su')
         z = [sol[3]; [w1 w2]*sol[3] ]
      end
      return sol[1], sol[2], f, z, sol[4]
   else
      # use implicit form
      @warn "R nearly singular: using the orthogonal reduction method"
      return garec(A, I, B, G, R, Q, S; scaling, nrm, pow2, as, rtol)
   end
end
tocomplex(A::LinearAlgebra.UniformScaling) = complex(A.λ)*I
tocomplex(A::AbstractArray) = complex(A)
tocomplex(A::Number) = complex(A)
"""
    garec(A, E, G, Q = 0; scaling = 'B', pow2 = false, as = false, rtol::Real = nϵ, nrm = 1) -> (X, EVALS, Z, scalinfo)

Compute `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the generalized continuous-time
algebraic Riccati equation

    A'XE + E'XA - E'XGXE + Q = 0,

where `G` and `Q` are hermitian/symmetric matrices or uniform scaling operators and `E` is a nonsingular matrix.
Scalar-valued `G` and `Q` are interpreted as appropriately sized uniform scaling operators `G*I` and `Q*I`.
The generalized Schur method of [1] is used. 

To enhance the accuracy of computations, a block scaling of matrices `G` and `Q` is performed, if  
the default setting `scaling = 'B'` is used. This scaling is however performed only if `norm(Q) > norm(G)`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting.   
Scaling can be disabled with the choice `scaling = 'N'`.
If `pow2 = true`, the scaling elements are enforced to the nearest power of 2 (default: `pow2 = false`).

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable or anti-stable) generalized eigenvalues of the pair `(A-GXE,E)`.

`Z = [U; V]` is an orthogonal basis for the stable/anti-stable deflating subspace such that `X = (Sx*(V/U)*Sxi)/E`, 
where `Sx` and `Sxi` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx` and `scalinfo.Sxi`, respectively.

_Note:_ To solve the continuous-time algebraic Riccati equation

     A'XE + E'XA - E'XBR^(-1)B'XE + Q = 0,

with `R` a hermitian/symmetric matrix and `B` a compatible size matrix, `G = BR^(-1)B'` must be provided. 
This approach is not numerically suited when `R` is ill-conditioned and/or `B` has large norm.  

`Reference:`

[1] W.F. Arnold, III and A.J. Laub,
    Generalized Eigenproblem Algorithms and Software for Algebraic Riccati Equations,
    Proc. IEEE, 72:1746-1754, 1984.
"""
function garec(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling}, G::Union{AbstractMatrix,UniformScaling,Real,Complex},
               Q::Union{AbstractMatrix,UniformScaling,Real,Complex} = zero(eltype(A));
               scaling = 'B', pow2 = false, as = false, rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), nrm = 1)
    T = promote_type( eltype(A), eltype(G), eltype(Q) )
    T <: BlasFloat  || (T = promote_type(Float64,T))

    # use complex version because the generalized Schur form decomposition available only for complex data 
    if !(T <: BlasFloat || T <: Complex) 
       sol = garec(tocomplex(A),tocomplex(E),tocomplex(G),tocomplex(Q); scaling, nrm, pow2, as, rtol)
       return real(sol[1]), sol[2], Matrix(qr([real(sol[3]) imag(sol[3])]).Q)[:,1:size(A,1)], sol[4]
    end

    n = LinearAlgebra.checksquare(A)
    eident = (E == I)
    if !eident
       LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
       eident = isequal(E,I)
       eident ? (E = I) : (T = promote_type(T,eltype(E)))
    end
    if typeof(G) <: AbstractArray
       (LinearAlgebra.checksquare(G) == n && ishermitian(G)) ||
          throw(DimensionMismatch("G must be a symmetric/hermitian matrix of dimension $n"))
    else
      G = G*I
      iszero(imag(G.λ)) || throw("G must be a symmetric/hermitian matrix")
    end
    if typeof(Q) <: AbstractArray
       (LinearAlgebra.checksquare(Q) == n && ishermitian(Q)) ||
          throw(DimensionMismatch("Q must be a symmetric/hermitian matrix of dimension $n"))
    else
       Q = Q*I
       iszero(imag(Q.λ)) || throw("Q must be a symmetric/hermitian matrix")
    end
    T <: BlasFloat || (T = promote_type(Float64,T))
    TR = real(T)
    epsm = eps(TR)
    eltype(A) == T || (A = convert(Matrix{T},A))
    eident || eltype(E) == T || (E = convert(Matrix{T},E))
    eltype(G) == T || (typeof(G) <: AbstractMatrix ? G = convert(Matrix{T},G) : G = convert(T,G.λ)*I)
    eltype(Q) == T || (typeof(Q) <: AbstractMatrix ? Q = convert(Matrix{T},Q) : Q = convert(T,Q.λ)*I)

    n == 0 && (return  zeros(T,0,0), zeros(T,0), zeros(T,m,0), (Sx = Diagonal(zeros(T,0)), Sxi = Diagonal(zeros(T,0))) ) 

    if !eident
      if T <: BlasFloat
         Et = LinearAlgebra.LAPACK.getrf!(copy(E))
         LinearAlgebra.LAPACK.gecon!('1',Et[1],opnorm(E,1))  < epsm && error("E must be non-singular")
      else
         cond(E)*epsm > 1 && error("E must be non-singular")
      end
    end
    #  Method:  A stable/anti-stable deflating subspace Z1 = [Z11; Z21] of the pencil
    #       L -s P := [  A  -G ]  - s [ E  0  ]
    #                 [ -Q  -A']      [ 0  E' ]
    #  is determined and the solution X is computed as X = Z21*inv(E*Z11).
    # use block scaling if appropriate
    L, P, Sx, Sxi = balham(A, E, G, Q; scaling, nrm)
    LPS = schur(L,P)
    as ? select = real.(LPS.α ./ LPS.β) .> 0 : select = real.(LPS.α ./ LPS.β) .< 0
    n == count(select) || error("The Hamiltonian/skew-Hamiltonian pencil is not dichotomic")
    ordschur!(LPS, select)
    i1 = 1:n
    i2 = n+1:2n
    F = _LUwithRicTest(LPS.Z[i1, i1],rtol)
    x = LPS.Z[i2,i1]/F
    lmul!(Sx,x); rmul!(x,Sxi)
    eident || (x = x/E)

    scalinfo = (Sx = Sx, Sxi = Sxi)
    return  LinearAlgebra._hermitianpart!(x), LPS.values[i1], LPS.Z[:,i1], scalinfo
end
"""
    garec(A, E, B, R, Q, S; scaling = 'B', pow2 = false, as = false, rtol::Real = nϵ, nrm = 1) -> (X, EVALS, F, Z, scalinfo)

Compute `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the generalized continuous-time
algebraic Riccati equation

    A'XE + E'XA - (E'XB+S)R^(-1)(B'XE+S') + Q = 0,

where `R` and `Q` are hermitian/symmetric matrices such that `R` is nonsingular, and
`E` is a nonsingular matrix.
Scalar-valued `R` and `Q` are interpreted as appropriately sized uniform scaling operators `R*I` and `Q*I`.
`S`, if not specified, is set to `S = zeros(size(B))`. 
The generalized Schur method of [1] is used. 

To enhance the accuracy of computations, a block oriented scaling of matrices `R,` `Q` and `S` is performed 
using the default setting `scaling = 'B'`. This scaling is performed only if `norm(Q) > norm(B)^2/norm(R)`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting.   
Experimental structure preserving scalings can be performed using the options `scaling = 'D'` 
or `scaling = 'T'`. Scaling can be disabled with the choice `scaling = 'N'`.
If `pow2 = true`, the scaling elements are enforced to the nearest power of 2 (default: `pow2 = false`).

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable or anti-stable) generalized eigenvalues of the pair `(A-BF,E)`.

`F` is the stabilizing/anti-stabilizing gain matrix `F = R^(-1)(B'XE+S')`.

`Z = [U; V; W]` is an orthogonal basis for the relevant stable/anti-stable deflating subspace 
such that `X = (Sx*(V/U)*Sxi)/E` and  `F = -Sr*(W/U)*Sxi`, 
where `Sx`, `Sxi` and `Sr` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx`, `scalinfo.Sxi` and `scalinfo.Sr`, respectively.

`Reference:`

[1] W.F. Arnold, III and A.J. Laub,
    Generalized Eigenproblem Algorithms and Software for Algebraic Riccati Equations,
    Proc. IEEE, 72:1746-1754, 1984.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> E = [10. 3. 0.; 0. 5. -1.; 0. 0. 10.]
3×3 Array{Float64,2}:
 10.0  3.0   0.0
  0.0  5.0  -1.0
  0.0  0.0  10.0

julia> B = [1. 2.; 2. 0.; 0. 1.]
3×2 Array{Float64,2}:
 1.0  2.0
 2.0  0.0
 0.0  1.0

julia> R = [1. 0.; 0. 5.]
2×2 Array{Float64,2}:
 1.0  0.0
 0.0  5.0

julia> X, CLSEIG, F = garec(A,E,B,R,2I);

julia> X
3×3 Array{Float64,2}:
  0.0502214   0.0284089   -0.0303703
  0.0284089   0.111219    -0.00259162
 -0.0303703  -0.00259162   0.0618395

julia> A'*X*E+E'*X*A-E'*X*B*inv(R)*B'*X*E+2I
3×3 Array{Float64,2}:
  1.55431e-15  -1.9984e-15   -3.33067e-15
 -1.77636e-15   1.33227e-15  -3.33067e-15
 -2.88658e-15  -3.21965e-15   1.11022e-15

julia> CLSEIG
3-element Array{Complex{Float64},1}:
  -0.6184265391601464 + 0.2913286844595737im
  -0.6184265391601464 - 0.2913286844595737im
 -0.21613059964451786 + 0.0im

julia> eigvals(A-B*F,E)
3-element Array{Complex{Float64},1}:
 -0.6184265391601462 - 0.29132868445957383im
 -0.6184265391601462 + 0.2913286844595739im
  -0.216130599644518 + 0.0im
```
"""
function garec(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling}, B::AbstractVecOrMat, R::Union{AbstractMatrix,UniformScaling,Real,Complex},
   Q::Union{AbstractMatrix,UniformScaling,Real,Complex}, S::AbstractVecOrMat = zeros(eltype(B),size(B));
   scaling = 'G', pow2 = false, as = false, rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), nrm = 1)
   garec(A, E, B, 0, R, Q, S; scaling, pow2, as, rtol, nrm)
end
"""
    garec(A, E, B, G, R, Q, S; scaling = 'B', pw2 = false, as = false, rtol::Real = nϵ, nrm = 1) -> (X, EVALS, F, Z, scalinfo)

Compute `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the generalized continuous-time
algebraic Riccati equation

    A'XE + E'XA - E'XGXE - (E'XB+S)R^(-1)(B'XE+S') + Q = 0,

where `G`, `Q` and `R` are hermitian/symmetric matrices such that `R` is nonsingular, and
`E` is a nonsingular matrix.
Scalar-valued `G`, `R` and `Q` are interpreted as appropriately sized uniform scaling operators `G*I`, `R*I` and `Q*I`.
The generalized Schur method of [1] is used. 

To enhance the accuracy of computations, a block oriented scaling of matrices `G,` `R,` `Q` and `S` is performed 
using the default setting `scaling = 'B'`. This scaling is performed only if `norm(Q) > max(norm(G), norm(B)^2/norm(R))`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting.   
Experimental structure preserving scalings can be performed using the options `scaling = 'D'` 
or `scaling = 'T'`. Scaling can be disabled with the choice `scaling = 'N'`.
If `pow2 = true`, the scaling elements are enforced to the nearest power of 2 (default: `pow2 = false`).

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable or anti-stable) generalized eigenvalues of the pair `(A-BF-GXE,E)`.

`F` is the stabilizing/anti-stabilizing gain matrix `F = R^(-1)(B'XE+S')`.

`Z = [U; V; W]` is an orthogonal basis for the relevant stable/anti-stable deflating subspace 
such that `X = (Sx*(V/U)*Sxi)/E` and  `F = -Sr*(W/U)*Sxi`, 
where `Sx`, `Sxi` and `Sr` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx`, `scalinfo.Sxi` and `scalinfo.Sr`, respectively.

`Reference:`

[1] W.F. Arnold, III and A.J. Laub,
    Generalized Eigenproblem Algorithms and Software for Algebraic Riccati Equations,
    Proc. IEEE, 72:1746-1754, 1984.
"""
function garec(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling}, B::AbstractVecOrMat,
               G::Union{AbstractMatrix,UniformScaling,Real,Complex}, R::Union{AbstractMatrix,UniformScaling,Real,Complex},
               Q::Union{AbstractMatrix,UniformScaling,Real,Complex}, S::AbstractVecOrMat;
               scaling = 'B', pow2 = false, as = false, rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), nrm = 1)
    T = promote_type( eltype(A), eltype(B), eltype(G), eltype(Q), eltype(R), eltype(S) )
    T <: BlasFloat  || (T = promote_type(Float64,T))
   
    # use complex version because the generalized Schur form decomposition available only for complex data 
    if !(T <: BlasFloat || T <: Complex) 
       sol = garec(tocomplex(A),tocomplex(E),tocomplex(B),tocomplex(G),tocomplex(R),tocomplex(Q),tocomplex(S); scaling, pow2, as, rtol, nrm)
       return real(sol[1]), isreal(sol[2]) ? real(sol[2]) : sol[2], real(sol[3]), Matrix(qr([real(sol[4]) imag(sol[4])]).Q)[:,1:size(A,1)], sol[5]
    end

    n = LinearAlgebra.checksquare(A)
    typeof(B) <: AbstractVector ? (nb, m) = (length(B), 1) : (nb, m) = size(B)
    n == nb || throw(DimensionMismatch("B must be a matrix with row dimension $n or a vector of length $n"))
    eident = (E == I)
    if !eident
       LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
       eident = isequal(E,I)
       eident ? (E = I) : (T = promote_type(T,eltype(E)))
    end
    if typeof(G) <: AbstractArray
       (LinearAlgebra.checksquare(G) == n && ishermitian(G)) ||
           throw(DimensionMismatch("G must be a symmetric/hermitian matrix of dimension $n"))
    else
      G = G*I
      iszero(imag(G.λ)) || throw("G must be a symmetric/hermitian matrix")
    end
    if typeof(R) <: AbstractArray
       (LinearAlgebra.checksquare(R) == m && ishermitian(R)) ||
          throw(DimensionMismatch("R must be a symmetric/hermitian matrix of dimension $m"))
    else
       R = R*I
       iszero(imag(R.λ)) || throw("R must be a symmetric/hermitian matrix")
    end
    if typeof(Q) <: AbstractArray
      (LinearAlgebra.checksquare(Q) == n && ishermitian(Q)) ||
         throw(DimensionMismatch("Q must be a symmetric/hermitian matrix of dimension $n"))
    else
      Q = Q*I
      iszero(imag(Q.λ)) || throw("Q must be a symmetric/hermitian matrix")
    end
    typeof(S) <: AbstractVector ? (ns, ms) = (length(S), 1) : (ns, ms) = size(S)
    (n == ns && m == ms) || throw(DimensionMismatch("S must be a $n x $m matrix or a vector of length $n"))
    T <: BlasFloat || (T = promote_type(Float64,T))
    TR = real(T)
    epsm = eps(TR)
    eltype(A) == T || (A = convert(Matrix{T},A))
    eident || eltype(E) == T || (E = convert(Matrix{T},E))
    eltype(B) == T || (typeof(B) <: AbstractVector ? B = convert(Vector{T},B) : B = convert(Matrix{T},B))
    eltype(G) == T || (typeof(G) <: AbstractMatrix ? G = convert(Matrix{T},G) : G = convert(T,G.λ)*I)
    eltype(Q) == T || (typeof(Q) <: AbstractMatrix ? Q = convert(Matrix{T},Q) : Q = convert(T,Q.λ)*I)
    eltype(R) == T || (typeof(R) <: AbstractMatrix ? R = convert(Matrix{T},R) : R = convert(T,R.λ)*I)
    eltype(S) == T || (typeof(S) <: AbstractVector ? S = convert(Vector{T},S) : S = convert(Matrix{T},S))

    n == 0 && (return  zeros(T,0,0), zeros(T,0), zeros(T,m,0), zeros(T,m,0), (Sx = Diagonal(zeros(T,0)), Sxi = Diagonal(zeros(T,0)), Sr = Diagonal(zeros(T,m))) )

    if !eident
      if T <: BlasFloat
         Et = LinearAlgebra.LAPACK.getrf!(copy(E))
         LinearAlgebra.LAPACK.gecon!('1',Et[1],opnorm(E,1))  < epsm && error("E must be non-singular")
      else
         cond(E)*epsm < 1 || error("E must be non-singular")
      end
    end
    cond(R)*epsm < 1 || error("R must be non-singular")

    #  Method:  A stable/ant-stable deflating subspace Z1 = [Z11; Z21; Z31] of the pencil
    #               [  A  -G    B ]      [ E  0  0 ]
    #      L -s P = [ -Q  -A'  -S ]  - s [ 0  E' 0 ]
    #               [  S'  B'   R ]      [ 0  0  0 ]
    # is determined and the solution X and feedback F are computed as
    #          X = Z21*inv(E*Z11),   F = -Z31*inv(Z11).
    H, J, Sx, Sxi, Sr = balham(A, E, B, G, R, Q, S; scaling, pow2, nrm)
    # deflate m simple infinite eigenvalues
    n2 = n+n;
    iric = 1:n2
    i1 = 1:n
    i2 = n+1:n2
    i3 = n2+1:n2+m
    #W = qr(Matrix([S; B; R]));
    W = qr!(copy(H[i3,:]'))
    cond(W.R) * epsm  < 1 || error("The extended Hamiltonian/skew-Hamiltonian pencil is not regular")

    #z = W.Q[:,m+1:m+n2]
    z = W.Q*[fill(false,m,n2); I ]

    #L11 = [ A -G B; -Q -A' -S]*z
    L11 = H[iric,:]*z
    #P11 = [ E*z[i1,:]; E'*z[i2,:] ]
    P11 = J[iric,:]*z
    LPS = schur(L11,P11)
    as ? select = real.(LPS.α ./ LPS.β) .> 0 : select = real.(LPS.α ./ LPS.β) .< 0
    n == count(select) ||
         error("The extended Hamiltonian/skew-Hamiltonian pencil is not dichotomic")
    ordschur!(LPS, select)

    z[:,i1] = z[:,iric]*LPS.Z[:,i1];

    F = _LUwithRicTest(z[i1,i1],rtol)
    if eident
       x = z[n+1:end,i1]/F
       f = -x[n+1:end,:]; lmul!(Sr,f); rmul!(f,Sxi)
       x = x[i1,:]; lmul!(Sx,x); rmul!(x,Sxi)
    else
       f = -z[i3,i1]/F; lmul!(Sr,f); rmul!(f,Sxi)
       #x = z[i2,i1]/(E*z[i1,i1])
       x = z[i2,i1]/F; lmul!(Sx,x); rmul!(x,Sxi); x = x/E
    end
    scalinfo = (Sx = Sx, Sxi = Sxi, Sr = Sr)
    return  LinearAlgebra._hermitianpart!(x), LPS.values[i1] , f, z[:,i1], scalinfo
end


"""
    ared(A, B, R, Q, S; scaling = 'B', pow2 = false, as = false, rtol::Real = nϵ, nrm = 1) -> (X, EVALS, F, Z, scalinfo)

Compute `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the discrete-time algebraic Riccati equation

    A'XA - X - (A'XB+S)(R+B'XB)^(-1)(B'XA+S') + Q = 0,

where `R` and `Q` are hermitian/symmetric matrices.
Scalar-valued `R` and `Q` are interpreted as appropriately sized uniform scaling operators `R*I` and `Q*I`.
`S`, if not specified, is set to `S = zeros(size(B))`.

To enhance the accuracy of computations, a block oriented scaling of matrices `R,` `Q` and `S` is performed 
using the default setting `scaling = 'B'`. This scaling is performed only if `norm(Q) > norm(B)^2/norm(R)`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting.   
Experimental structure preserving scalings can be performed using the options `scaling = 'D'`, `scaling = 'R'` and `scaling = 'T'`. 
Scaling can be disabled with the choice `scaling = 'N'`.
If `pow2 = true`, the scaling elements are enforced to the nearest power of 2 (default: `pow2 = false`).

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable) eigenvalues of `A-BF`.

`F` is the stabilizing gain matrix `F = (R+B'XB)^(-1)(B'XA+S')`.

`Z = [U; V; W]` is an orthogonal basis for the relevant stable/anti-stable deflating subspace 
such that `X = Sx*(V/U)*Sxi` and  `F = -Sr*(W/U)*Sxi`, 
where `Sx`, `Sxi` and `Sr` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx`, `scalinfo.Sxi` and `scalinfo.Sr`, respectively.

`Reference:`

[1] W.F. Arnold, III and A.J. Laub,
    Generalized Eigenproblem Algorithms and Software for Algebraic Riccati Equations,
    Proc. IEEE, 72:1746-1754, 1984.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [ 0. 1.; 0. 0. ]
2×2 Array{Float64,2}:
 0.0  1.0
 0.0  0.0

julia> B = [ 0.; sqrt(2.) ]
2-element Array{Float64,1}:
 0.0
 1.4142135623730951

julia> R = 1.
1.0

julia> Q = [ 1. -1.; -1. 1. ]
2×2 Array{Float64,2}:
  1.0  -1.0
 -1.0   1.0

julia> X, CLSEIG, F = ared(A,B,R,Q);

julia> X
2×2 Array{Float64,2}:
  1.0  -1.0
 -1.0   1.5

julia> A'*X*A-X-A'*X*B*inv(R+B'*X*B)*B'*X*A+Q
2×2 Array{Float64,2}:
  0.0          -3.33067e-16
 -3.33067e-16   8.88178e-16

julia> CLSEIG
2-element Array{Complex{Float64},1}:
 0.4999999999999998 - 0.0im
               -0.0 - 0.0im

julia> eigvals(A-B*F)
2-element Array{Float64,1}:
 -2.7755575615628914e-16
  0.5
```
"""
function ared(A::AbstractMatrix, B::AbstractVecOrMat, R::Union{AbstractMatrix,UniformScaling,Real,Complex},
              Q::Union{AbstractMatrix,UniformScaling,Real,Complex}, S::AbstractVecOrMat = zeros(eltype(B),size(B));
              scaling = 'B', pow2 = false, as = false, rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), nrm = 1)
    gared(A, I, B, R, Q, S; scaling, nrm, pow2, as, rtol)
end
"""
    gared(A, E, B, R, Q, S; scaling = 'B', pow2 = false, as = false, rtol::Real = nϵ, nrm = 1) -> (X, EVALS, F, Z, scalinfo)

Compute `X`, the hermitian/symmetric stabilizing solution (if `as = false`) or
anti-stabilizing solution (if `as = true`) of the generalized discrete-time
algebraic Riccati equation

    A'XA - E'XE - (A'XB+S)(R+B'XB)^(-1)(B'XA+S') + Q = 0,

where `R` and `Q` are hermitian/symmetric matrices, and `E` ist non-singular.
Scalar-valued `R` and `Q` are interpreted as appropriately sized uniform scaling operators `R*I` and `Q*I`.
`S`, if not specified, is set to `S = zeros(size(B))`.

To enhance the accuracy of computations, a block oriented scaling of matrices `R,` `Q` and `S` is performed 
using the default setting `scaling = 'B'`. This scaling is performed only if `norm(Q) > norm(B)^2/norm(R)`.
A general, eigenvalue computation oriented scaling combined with a block scaling is used if `scaling = 'G'` is selected. 
An alternative, structure preserving scaling can be performed using the option `scaling = 'S'`. 
A symmetric matrix equilibration based scaling is employed if `scaling = 'K'`, for which the underlying vector norm 
can be specified using the keyword argument `nrm = p`, where `p = 1` is the default setting.   
Experimental structure preserving scalings can be performed using the options `scaling = 'D'`, `scaling = 'R'` and `scaling = 'T'`. 
Scaling can be disabled with the choice `scaling = 'N'`.
If `pow2 = true`, the scaling elements are enforced to the nearest power of 2 (default: `pow2 = false`).

By default, the lower bound for the 1-norm reciprocal condition number `rtol` is `n*ϵ`, where `n` is the order of `A`
and `ϵ` is the _machine epsilon_ of the element type of `A`.

`EVALS` is a vector containing the (stable or anti-stable) generalized eigenvalues of the pair `(A-BF,E)`.

`F` is the stabilizing/anti-stabilizing gain matrix `F = (R+B'XB)^(-1)(B'XA+S')`.

`Z = [U; V; W]` is an orthogonal basis for the relevant stable/anti-stable deflating subspace 
such that `X = (Sx*(V/U)*Sxi)/E` and  `F = -Sr*(W/U)*Sxi`, 
where `Sx`, `Sxi` and `Sr` are diagonal scaling matrices contained in the named tuple `scalinfo` 
as `scalinfo.Sx`, `scalinfo.Sxi` and `scalinfo.Sr`, respectively.

`Reference:`

[1] W.F. Arnold, III and A.J. Laub,
    Generalized Eigenproblem Algorithms and Software for Algebraic Riccati Equations,
    Proc. IEEE, 72:1746-1754, 1984.

# Example
```jldoctest
julia> using LinearAlgebra

julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> E = [10. 3. 0.; 0. 5. -1.; 0. 0. 10.]
3×3 Array{Float64,2}:
 10.0  3.0   0.0
  0.0  5.0  -1.0
  0.0  0.0  10.0

julia> B = [1. 2.; 2. 0.; 0. 1.]
3×2 Array{Float64,2}:
 1.0  2.0
 2.0  0.0
 0.0  1.0

julia> R = [1. 0.; 0. 5.]
2×2 Array{Float64,2}:
 1.0  0.0
 0.0  5.0

julia> X, CLSEIG, F = gared(A,E,B,R,2I);

julia> X
3×3 Array{Float64,2}:
  0.065865   -0.0147205  -0.0100407
 -0.0147205   0.0885939   0.0101422
 -0.0100407   0.0101422   0.0234425

julia> A'*X*A-E'*X*E-A'*X*B*inv(R+B'*X*B)*B'*X*A+2I
3×3 Array{Float64,2}:
 -1.33227e-15  -2.48412e-15   1.38778e-16
 -2.498e-15    -4.44089e-16  -6.50521e-16
  1.80411e-16  -5.91541e-16  -1.33227e-15

julia> CLSEIG
3-element Array{Complex{Float64},1}:
  -0.084235615751339 - 0.0im
  -0.190533552034239 - 0.0im
 -0.5238922629921539 - 0.0im

julia> eigvals(A-B*F,E)
3-element Array{Float64,1}:
 -0.5238922629921539
 -0.19053355203423886
 -0.08423561575133902
```
"""
function gared(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling}, B::AbstractVecOrMat,
               R::Union{AbstractMatrix,UniformScaling,Real,Complex}, Q::Union{AbstractMatrix,UniformScaling,Real,Complex},
               S::AbstractVecOrMat = zeros(eltype(B),size(B)); scaling = 'B', pow2 = false, as = false, 
               rtol::Real = size(A,1)*eps(real(float(one(eltype(A))))), nrm = 1)
    T = promote_type( eltype(A), eltype(B), eltype(R), eltype(Q), eltype(S) )
    T <: BlasFloat  || (T = promote_type(Float64,T))
    # use complex version because the generalized Schur form decomposition available only for complex data 
    if !(T <: BlasFloat || T <: Complex) 
       sol = gared(tocomplex(A),tocomplex(E),tocomplex(B),tocomplex(R),tocomplex(Q),tocomplex(S); scaling, nrm, pow2, as, rtol)
       return real(sol[1]), sol[2], real(sol[3]), Matrix(qr([real(sol[4]) imag(sol[4])]).Q)[:,1:size(A,1)], sol[5]
    end

    n = LinearAlgebra.checksquare(A)
    typeof(B) <: AbstractVector ? (nb, m) = (length(B), 1) : (nb, m) = size(B)
    n == nb || throw(DimensionMismatch("B must be a matrix with row dimension $n or a vector of length $n"))
    eident = (E == I)
    if !eident
       LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
       eident = isequal(E,I)
       eident ? E = I : T = promote_type(T,eltype(E))
     end
    if typeof(R) <: AbstractArray
       (LinearAlgebra.checksquare(R) == m && ishermitian(R)) ||
         throw(DimensionMismatch("R must be a symmetric/hermitian matrix of dimension $m"))
    else
      R = R*I
      iszero(imag(R.λ)) || throw("R must be a symmetric/hermitian matrix")
    end
    if typeof(Q) <: AbstractArray
       (LinearAlgebra.checksquare(Q) == n && ishermitian(Q)) ||
          throw(DimensionMismatch("Q must be a symmetric/hermitian matrix of dimension $n"))
    else
       Q = Q*I
       iszero(imag(Q.λ)) || throw("Q must be a symmetric/hermitian matrix")
    end
    typeof(S) <: AbstractVector ? (ns, ms) = (length(S), 1) : (ns, ms) = size(S)
    (n == ns && m == ms) || throw(DimensionMismatch("S must be a $n x $m matrix or a vector of length $n"))
    TR = real(T)
    epsm = eps(TR)
    eltype(A) == T || (A = convert(Matrix{T},A))
    eident || eltype(E) == T || (E = convert(Matrix{T},E))
    eltype(B) == T || (typeof(B) <: AbstractVector ? B = convert(Vector{T},B) : B = convert(Matrix{T},B))
    eltype(Q) == T || (typeof(Q) <: AbstractMatrix ? Q = convert(Matrix{T},Q) : Q = convert(T,Q.λ)*I)
    eltype(R) == T || (typeof(R) <: AbstractMatrix ? R = convert(Matrix{T},R) : R = convert(T,R.λ)*I)
    eltype(S) == T || (typeof(S) <: AbstractVector ? S = convert(Vector{T},S) : S = convert(Matrix{T},S))

    n == 0 && (return  zeros(T,0,0), zeros(T,0), zeros(T,m,0), zeros(T,m,0) )

    if !eident
      if T <: BlasFloat
         Et = LinearAlgebra.LAPACK.getrf!(copy(E))
         LinearAlgebra.LAPACK.gecon!('1',Et[1],opnorm(E,1))  < epsm && error("E must be non-singular")
      else
         cond(E)*epsm < 1 || error("E must be non-singular")
      end
    end
    #  Method:  A stable deflating subspace Z1 = [Z11; Z21; Z31] of the pencil
    #                   [  A   0    B ]      [ E  0  0 ]
    #          H -z J = [ -Q   E'  -S ]  - z [ 0  A' 0 ]
    #                   [ S'   0    R ]      [ 0 -B' 0 ]
    #  is computed and the solution X and feedback F are computed as
    #          X = Z21*inv(E*Z11),   F = Z31*inv(Z11).
    H, J, Sx, Sxi, Sr = balsympl(A, E, B, R, Q, S; scaling, pow2, nrm)
    n2 = n+n;
    iric = 1:n2
    i1 = 1:n
    i2 = n+1:n2
    i2m = n+1:n2+m
    i3 = n2+1:n2+m
    #F = qr([A'; -B'])
    #F = qr(view(J,i2m,i2))
    F = qr(J[i2m,i2])
    #L2 = F.Q'*[-Q  E' -S; copy(S') zeros(T,m,n) R]
    #L2 = F.Q'*view(H,i2m,:)
    L2 = F.Q'*H[i2m,:]
    P2 = [zeros(T,n,n) F.R zeros(T,n,m)]

    G = qr(L2[n+1:n+m,:]')
    cond(G.R) * epsm  < 1 || error("The extended symplectic pencil is not regular")
    z = (G.Q*I)[:,[m+1:m+n2; 1:m]]

    # L1 = [ A zeros(T,n,n) B; L2[i1,:]]*z
    L1 = [ view(H,i1,:); L2[i1,:]]*z
    # P1 = [ E zeros(T,n,n+m); P2]*z
    P1 = [ view(J,i1,:); P2]*z

    as ? PLS = schur(L1[iric,iric],P1[iric,iric]) : PLS = schur(P1[iric,iric],L1[iric,iric])
    select = abs.(PLS.α) .> abs.(PLS.β)

    n == count(select) || error("The extended symplectic pencil is not dichotomic")

    ordschur!(PLS, select)
    z[:,i1]= z[:,iric]*PLS.Z[:,i1]

    F = _LUwithRicTest(z[i1,i1],rtol)
    if eident
       x = z[n+1:end,i1]/F; 
       f = -x[n+1:end,:]; lmul!(Sr,f); rmul!(f,Sxi)
       x = x[i1,:]; lmul!(Sx,x); rmul!(x,Sxi)
    else
       f = -z[i3,i1]/F; lmul!(Sr,f); rmul!(f,Sxi)
       x = z[i2,i1]/F; lmul!(Sx,x); rmul!(x,Sxi); x = x/E
    end

    as ? iev = i2 : iev = i1
    clseig = PLS.β[iev] ./ PLS.α[iev]
    if as && T <: Complex
      clseig =  conj(clseig)
    end
    scalinfo = (Sx = Sx, Sxi = Sxi, Sr = Sr)
    return  LinearAlgebra._hermitianpart!(x), clseig, f, z[:,i1], scalinfo
end
function balham(A, G, Q; scaling = 'B', pow2 = false, nrm = 1)
   # Scaling function to be used in conjunction with arec(A,G,Q)
   H = [A -G; -Q -A']
   scaling == 'N' && (return H, I, I)
   n = size(A,1)
   i1 = 1:n; i2 = n+1:2n
   At1 = view(H,i1,i1)
   Gt = view(H,i1,i2)
   Qt = view(H,i2,i1)
   At2 = view(H,i2,i2)
   T = eltype(H)
   TR = real(T)
   radix = TR(2.)
   if scaling == 'B'
      # block scaling using square-root norms
      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if (qs > gs) && (gs > 0)
         scal = qs/gs  
         scalsr = sqrt(scal)  
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         lmul!(scal,Gt); ldiv!(scal,Qt)  # Q -> Q/scal; G -> G * scal
         return H, scalsr*I, scalsr*I
      else    
         return H, I, I
      end
   elseif scaling == 'S'
      # structure preserving scaling enhanced with block scaling
      # unconstrained balancing with D = diag(D1,D2)
      Hd = Diagonal(H)
      if qS1(H) < 10*qS1(H-Hd) 
         d = lsbalance!(H-Hd).diag
      else
         d = lsbalance!(copy(H)).diag
      end
      s = log2.(d) 
      # impose that diagonal scaling has the form diag(Sx,1./Sx)  
      sx = round.(Int,(-s[i1]+s[i2])/2); # Sx = sqrt(D1/D2)
      Sx = Diagonal(radix.^(sx)) 
      lmul!(Sx,Gt); rmul!(Gt,Sx)  # Gt <- Sx*Gt*Sx
      ldiv!(Sx,Qt); rdiv!(Qt,Sx)  # Qt <- Sx\(Qt/Sx)
      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         lmul!(scalsr,Sx)
         lmul!(scal,Gt); ldiv!(scal,Qt)
      end      
      lmul!(Sx,At1); rdiv!(At1,Sx) 
      ldiv!(Sx,At2); rmul!(At2,Sx) 
      return H, Sx, Sx
   elseif scaling == 'K'
      # structure preserving scaling enhanced, if appropriate, with block scaling
      M = abs.(H)
      ind = [i2;i1]  
      dl, dr = symscal!(view(M,ind,:); nrm, maxiter = 1000)
      s = log2.(dr) 
      # impose that diagonal scaling has the form diag(Sx,1./Sx)  
      sx = round.(Int,(-s[i1]+s[i2])/2); # Sx = sqrt(D1/D2)
      Sx = Diagonal(radix.^(sx)) 
      lmul!(Sx,Gt); rmul!(Gt,Sx)  # Gt <- Sx*Gt*Sx
      ldiv!(Sx,Qt); rdiv!(Qt,Sx)  # Qt <- Sx\(Qt/Sx)

      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         lmul!(scalsr,Sx)
         lmul!(scal,Gt); ldiv!(scal,Qt)
      end      
      lmul!(Sx,At1); rdiv!(At1,Sx) 
      ldiv!(Sx,At2); rmul!(At2,Sx) 
      return H, Sx, Sx


      Dl = Diagonal(dl); Dr = Diagonal(dr)
      lmul!(Dl,view(H,ind,:)); rmul!(H,Dr)
      lmul!(Dl,view(J,ind,:)); rmul!(J,Dr)

      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         lmul!(scalsr,view(Dr.diag,i2)); ldiv!(scalsr,view(Dr.diag,i1))
      end

      return H, J, Diagonal(Dr.diag[i2]), inv(Diagonal(Dr.diag[i1])) 

   elseif scaling == 'G'
      # unconstrained balancing with D = diag(D1,D2)
      d = lsbalance!(H).diag
      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         lmul!(scal,Gt); ldiv!(scal,Qt)
         lmul!(scalsr,view(d,i2)); ldiv!(scalsr,view(d,i1))
      end
      # for convenience, return D2 and inv(D1)
      return H, Diagonal(d[i2]), inv(Diagonal(d[i1])) 
   else
      @warn "No such scaling option: no scaling is performed"
      return H, I, I
   end
end
function balham(A, E, G, Q; scaling = 'B', pow2 = false, nrm = 1) 
   # Scaling function to be used in conjunction with garec(A,E,G,Q)
   n = size(A,1); 
   T = eltype(A)
   H = [A -G; -Q -A']; J = [E zeros(T,n,n); zeros(T,n,n) E']
   scaling == 'N' && (return H, J, I, I)
   n2 = 2n; i1 = 1:n; i2 = n+1:n2
   Gt = view(H,i1,i2)
   Qt = view(H,i2,i1)
   TR = real(T)
   radix = TR(2.)
   if scaling == 'B'
      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if (qs > gs) && (gs > 0)
         scal = qs/gs  
         scalsr = sqrt(scal) 
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal 
         return H, J, scalsr*I, scalsr*I
      else    
         return H, J, I, I
      end
   elseif scaling == 'S'
      # structure preserving scaling enhanced, if appropriate, with block scaling
      nh = norm(view(H,i1,i1)-Diagonal(view(H,i1,i1)),1) + norm(view(H,i2,i2)-Diagonal(view(H,i2,i2)),1) 
      nj = norm(view(J,i1,i1)-Diagonal(view(J,i1,i1)),1) + norm(view(J,i2,i2)-Diagonal(view(J,i2,i2)),1) 
      if nh > 0 && nj > 0
         M = nj * abs.(H) + nh/nj * abs.(J);
      else
         M = abs.(H) + abs.(J);
      end     
      d = lsbalance!(M).diag
      s = log2.(d); # unconstrained balancing diag(D1,D2)
      sx = round.(Int,(-s[i1]+s[i2])/2);
      # impose that diagonal scaling has the form diag(Sx,1./Sx)  
      D = Diagonal(radix.^[sx ; -sx])
      lmul!(D,H); rdiv!(H,D)
      lmul!(D,J); rdiv!(J,D)
      Sx = Diagonal(D.diag[i1]) # Sx = sqrt(D2/D1)

      # check if block scaling is appropriate
      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         lmul!(scalsr,Sx) 
         lmul!(scal,Gt); ldiv!(scal,Qt)
      end         
      return H, J, Sx, Sx
   elseif scaling == 'K'
      # structure preserving scaling enhanced, if appropriate, with block scaling
      # nh = norm(view(H,i1,i1)-Diagonal(view(H,i1,i1)),1) + norm(view(H,i2,i2)-Diagonal(view(H,i2,i2)),1) 
      # nj = norm(view(J,i1,i1)-Diagonal(view(J,i1,i1)),1) + norm(view(J,i2,i2)-Diagonal(view(J,i2,i2)),1) 
      # if nh > 0 && nj > 0
      #    M = nj * abs.(H) + nh/nj * abs.(J);
      # else
      #    M = abs.(H) + abs.(J);
      # end   
      M = abs.(H) + abs.(J)
      ind = [i2;i1]  
      dl, dr = symscal!(view(M,ind,:); nrm, maxiter = 1000)
      pow2 && (dr .= radix .^(round.(Int,log2.(dr))); dl = dr) 
      Dl = Diagonal(dl); Dr = Diagonal(dr)
      lmul!(Dl,view(H,ind,:)); rmul!(H,Dr)
      lmul!(Dl,view(J,ind,:)); rmul!(J,Dr)

      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         lmul!(scalsr,view(Dr.diag,i2)); ldiv!(scalsr,view(Dr.diag,i1))
      end

      return H, J, Diagonal(Dr.diag[i2]), inv(Diagonal(Dr.diag[i1])) 
   elseif scaling == 'G'
      # general scaling enhanced, if appropriate, with a block scaling
      _, D2 = regbalance!(H, J; tol = 0.1)
      qs = sqrt(opnorm(Qt,1))
      gs = sqrt(opnorm(Gt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         lmul!(scalsr,view(D2.diag,i2)); ldiv!(scalsr,view(D2.diag,i1))
      end
      return H, J, Diagonal(D2.diag[i2]), inv(Diagonal(D2.diag[i1])) 
   else
      @warn "No such scaling option: no scaling is performed"
      return H, J, I, I
   end
end
function balham(A, E, B, G, R, Q, S; scaling = 'B', pow2 = false, nrm = 1) 
   # Scaling function to be used in conjunction with garec(A, E, B, G, R, Q, S)
   #                   [  A   -G    B ]      [ E  0  0 ]
   #          H -z J = [ -Q   -A'  -S ]  - z [ 0  E' 0 ]
   #                   [ S'    B'   R ]      [ 0  0  0 ]
   
   n, m = size(B,1), size(B,2); n2 = 2n
   T = eltype(A)
   H = [A -G B; -Q -A' -S; S' B' R] 
   J = [E zeros(T,n,n+m); zeros(T,n,n) E' zeros(T,n,m); zeros(T,m,n2+m)]
   scaling == 'N' && (return H, J, I, I, I)
   i1 = 1:n; i2 = n+1:n2; i3 = n2+1:n2+m; j2 = 1:n2
   At = view(H,i1,i1)
   Bt = view(H,i1,i3)
   Gt = view(H,i1,i2)
   Qt = view(H,i2,i1)
   St = view(H,i2,i3)
   St2 = view(H,i3,i1)
   Rt = view(H,i3,i3)
   Et = view(J,i1,i1)  
   T = eltype(H)
   TR = real(T)
   radix = TR(2.)
   if scaling == 'B'
      # block scaling using square-root norms
      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = sqrt(opnorm(Gt,1)) + norm(B,1)/sqrt(norm(Rt,1))
      if (qs > gs) && (gs > 0)
         scal = qs/gs  
         scalsr = sqrt(scal)  
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         return H, J, scalsr*I, scalsr*I, (1/scalsr)*I
      else    
         return H, J, I, I, I
      end
   elseif scaling == 'S'
      # structure preserving scaling enhanced, if appropriate, with block scaling
      nh = norm(At-Diagonal(At),1) 
      nj = norm(Et-Diagonal(Et),1) 
      if nh > 0 && nj > 0
         M = abs.(H) + nh/nj * abs.(J);
      else
         M = abs.(H) + abs.(J);
      end     
      # unconstrained balancing diag(D1,D2,Dr)
      d = lsbalance!(M).diag
      s = log2.(d) 
      sx = round.(Int,(-s[i1]+s[i2])/2); 
      sr = -s[i3]
      # impose that diagonal scaling has the form diag(Sx,1./Sx, Sr)  
      D = Diagonal(radix.^[sx ; -sx ; sr])
      lmul!(D,H); rdiv!(H,D)
      lmul!(D,J); rdiv!(J,D)
      Sx = Diagonal(radix.^sx) # Sx = sqrt(D2/D1)
      Sr = Diagonal(radix.^sr)

      # check if block scaling is appropriate
      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = sqrt(opnorm(Gt,1)) + norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         lmul!(scalsr,Sx); ldiv!(scalsr,Sr)
         lmul!(scal,Gt); ldiv!(scal,Qt); ldiv!(scal,Rt)
         ldiv!(scal,St); ldiv!(scal,St2)
      end      

      # adjust scaling of R 
      rs = sqrt(norm(Rt,1))/max(norm(Bt,1),norm(St,1)); 
      if 10*rs < 1 
         pow2 && (rs = radix^(round(Int,log2(rs)))) 
         lmul!(rs,view(H,i3,:)); rmul!(view(H,:,i3),rs); lmul!(rs,Sr)
      end
      return H, J, Sx, Sx, Sr
   elseif scaling == 'D'
      # descriptor system oriented general scaling enhanced, if appropriate, with block scaling
      sr = ones(T,m)
      _, D2  = lsbalance!(view(H,j2,j2),view(J,j2,j2),view(H,j2,i3),view(H,i3,j2); tol = 0.001)

      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = sqrt(opnorm(Gt,1)) + norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,view(D2.diag,i2)); ldiv!(scalsr,view(D2.diag,i1)); 
         ldiv!(scalsr,sr)
      end
      # adjust scaling of R 
      rs = sqrt(norm(Rt,1))/max(norm(Bt,1),norm(St,1)); 
      if 10*rs < 1 
         pow2 && (rs = radix^(round(Int,log2(rs)))) 
         lmul!(rs,view(H,i3,:)); rmul!(view(H,:,i3),rs); lmul!(rs,sr)
      end

      return H, J, Diagonal(D2.diag[i2]), inv(Diagonal(D2.diag[i1])), Diagonal(sr) 
   elseif scaling == 'T'
      # standard system oriented structure preserving scaling enhanced, if appropriate, with block scaling
      nh = norm(At-Diagonal(At),1) 
      nj = norm(Et-Diagonal(Et),1) 
      if nh > 0 && nj > 0
         M = abs.(H) + nh/nj * abs.(J);
      else
         M = abs.(H) + abs.(J);
      end     
      # unconstrained standard system balancing with diag(S1,S2,I)
      S = lsbalance!(view(M,j2,j2),view(M,j2,i3),view(M,i3,j2))
      sx = round.(Int,(log2.(S.diag[i2])-log2.(S.diag[i1]))/2); 
      sr = ones(T,m)     
      D = Diagonal(radix.^[sx ; -sx])
      lmul!(D,view(H,j2,:)); rdiv!(view(H,:,j2),D)
      lmul!(D,view(J,j2,j2)); rdiv!(view(J,j2,j2),D)
      Sx = Diagonal(radix.^sx) # Sx = sqrt(S2/S1)

      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = sqrt(opnorm(Gt,1)) + norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,Sx); ldiv!(scalsr,sr)
      end

      # adjust scaling of R 
      rs = sqrt(norm(Rt,1))/max(norm(Bt,1),norm(St,1)); 
      if 10*rs < 1 
         pow2 && (rs = radix^(round(Int,log2(rs)))) 
         lmul!(rs,view(H,i3,:)); rmul!(view(H,:,i3),rs); lmul!(rs,sr)
      end
      Sr = Diagonal(sr)
      return H, J, Sx, Sx, Sr
   elseif scaling == 'K'
      # symmetric scaling enhanced, if appropriate, with a block scaling
      nh = norm(At-Diagonal(At),1) 
      nj = norm(Et-Diagonal(Et),1) 
      if nh > 0 && nj > 0
         M = abs.(H) + (nh/nj) * abs.(J)
      else
         M = abs.(H) + abs.(J)
      end     
      ind = [i2;i1;i3]  
      dl, dr = symscal!(view(M,ind,:); nrm, maxiter = 1000)
      pow2 && (dr .= radix .^(round.(Int,log2.(dr))); dl = dr) 

      Dl = Diagonal(dl); Dr = Diagonal(dr)
      lmul!(Dl,view(H,ind,:)); rmul!(H,Dr)
      lmul!(Dl,view(J,ind,:)); rmul!(J,Dr)

      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = sqrt(opnorm(Gt,1)) + norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,view(Dr.diag,i2)); ldiv!(scalsr,view(Dr.diag,i1))
         ldiv!(scalsr,view(Dr.diag,i3))
      end
      return H, J, Diagonal(Dr.diag[i2]), inv(Diagonal(Dr.diag[i1])), Diagonal(Dr.diag[i3])   
   elseif scaling == 'G'
      # general scaling enhanced, if appropriate, with a block scaling
      _, D2 = regbalance!(H, J; tol = 0.001, maxiter = 1000, pow2)
      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = sqrt(opnorm(Gt,1)) + norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt); lmul!(scal,Gt)  # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,view(D2.diag,i2)); ldiv!(scalsr,view(D2.diag,i1)); 
         ldiv!(scalsr,view(D2.diag,i3))
      end
      return H, J, Diagonal(D2.diag[i2]), inv(Diagonal(D2.diag[i1])), Diagonal(D2.diag[i3]) 
   else
      @warn "No such scaling option: no scaling is performed"
      return H, J, I, I, I
   end
end
function balsympl(A, E, B, R, Q, S; scaling = 'B', pow2 = false, nrm = 1) 
   # Scaling function to be used in conjunction with gared(A, E, B, R, Q, S)
   n, m = size(B,1), size(B,2); n2 = 2n
   T = eltype(A)
    #                   [  A   0    B ]      [ E  0  0 ]
    #          H -z J = [ -Q   E'  -S ]  - z [ 0  A' 0 ]
    #                   [ S'   0    R ]      [ 0 -B' 0 ]
   H = [A zeros(T,n,n) B; -Q E' -S; S' zeros(T,m,n) R] 
   J = [E zeros(T,n,n+m); zeros(T,n,n) A' zeros(T,n,m); zeros(T,m,n) -B' zeros(T,m,m)]
   scaling == 'N' && (return H, J, I, I, I)
   i1 = 1:n; i2 = n+1:n2; i3 = n2+1:n2+m; j2 = 1:n2
   Qt = view(H,i2,i1)
   St = view(H,i2,i3)
   St2 = view(H,i3,i1)
   Rt = view(H,i3,i3)
   Bt = view(H,i1,i3)
   T = eltype(H)
   TR = real(T)
   radix = TR(2.)
   if scaling == 'B'
      i1 = 1:n; i2 = n+1:n2; i3 = n2+1:n2+m
      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = norm(B,1)/sqrt(norm(Rt,1))
      if (qs > gs) && (gs > 0)
         scal = qs/gs  
         scalsr = sqrt(scal)  
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt)                   # Q -> Q/scal; 
         ldiv!(scal,St); ldiv!(scal,St2)  # S -> S/scal 
         ldiv!(scal,Rt)                   # R -> R/scal
         return H, J, scalsr*I, scalsr*I, (1/scalsr)*I
      else    
         return H, J, I, I, I
      end
   elseif scaling == 'S'
      nh = norm(view(H,i1,i1)-Diagonal(view(H,i1,i1)),1) + norm(view(H,i2,i2)-Diagonal(view(H,i2,i2)),1) 
      nj = norm(view(J,i1,i1)-Diagonal(view(J,i1,i1)),1) + norm(view(J,i2,i2)-Diagonal(view(J,i2,i2)),1) 
      if nh > 0 && nj > 0
         M = abs.(H) + nh/nj * abs.(J);
      else
         M = abs.(H) + abs.(J);
      end  
      d = lsbalance!(M).diag
      s = log2.(d) 
      sx = round.(Int,(-s[i1]+s[i2])/2); 
      sr = -s[i3]
      # impose that diagonal scaling has the form diag(Sx,1./Sx, Sr)  
      D = Diagonal(radix.^[sx ; -sx ; sr])
      lmul!(D,H); rdiv!(H,D)
      lmul!(D,J); rdiv!(J,D)
      Sx = Diagonal(radix.^sx) # Sx = sqrt(D2/D1)
      Sr = Diagonal(radix.^sr)


      # check if block scaling is appropriate
      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         lmul!(scalsr,Sx); ldiv!(scalsr,Sr)
         ldiv!(scal,Qt); ldiv!(scal,Rt)
         ldiv!(scal,St); ldiv!(scal,St2)
      end      
      # adjust scaling of R 
      rs = sqrt(norm(Rt,1))/max(norm(Bt,1),norm(St,1)); 
      if 10*rs < 1 
         pow2 && (rs = radix^(round(Int,log2(rs)))) 
         lmul!(rs,view(H,i3,:)); rmul!(view(H,:,i3),rs); lmul!(rs,view(J,i3,:)); lmul!(rs,Sr)
      end
      return H, J, Sx, Sx, Sr
   elseif scaling == 'K'
      # symmetric scaling enhanced, if appropriate, with a block scaling
      M = abs.(H) + abs.(J)
      ind = [i2;i1;i3]  
      dl, dr, info = symscal!(view(M,ind,:); nrm, maxiter = 1000)
      pow2 && (dr .= radix .^(round.(Int,log2.(dr))); dl = dr) 

      Dl = Diagonal(dl); Dr = Diagonal(dr)
      lmul!(Dl,view(H,ind,:)); rmul!(H,Dr)
      lmul!(Dl,view(J,ind,:)); rmul!(J,Dr)

      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt);                 # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,view(Dr.diag,i2)); ldiv!(scalsr,view(Dr.diag,i1))
         ldiv!(scalsr,view(Dr.diag,i3))
      end
      return H, J, Diagonal(Dr.diag[i2]), inv(Diagonal(Dr.diag[i1])), Diagonal(Dr.diag[i3])   
   elseif scaling == 'D'
      # descriptor system oriented general scaling enhanced, if appropriate, with block scaling
      sr = ones(T,m)
      copyto!(view(H,i3,i2),view(J,i3,i2))
      _, D2  = lsbalance!(view(H,j2,j2),view(J,j2,j2),view(H,j2,i3),view(H,i3,j2); tol = 0.001)
      copyto!(view(J,i3,i2),view(H,i3,i2)); fill!(view(H,i3,i2),zero(T))

      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt);                 # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,view(D2.diag,i2)); ldiv!(scalsr,view(D2.diag,i1)); 
         ldiv!(scalsr,sr)
      end
      # adjust scaling of R 
      rs = sqrt(norm(Rt,1))/max(norm(Bt,1),norm(St,1)); 
      if 10*rs < 1 
         pow2 && (rs = radix^(round(Int,log2(rs)))) 
         lmul!(rs,view(H,i3,:)); rmul!(view(H,:,i3),rs); lmul!(rs,view(J,i3,:)); lmul!(rs,sr)
      end

      return H, J, Diagonal(D2.diag[i2]), inv(Diagonal(D2.diag[i1])), Diagonal(sr) 
   elseif scaling == 'R'
      sr = ones(T,m)
      Ht = [A zeros(T,n,n) B; -Q E' -S; S' -B' R] 
      Jt = [E zeros(T,n,n+m); zeros(T,n,n) A' zeros(T,n,m); zeros(T,m,n2+m)]
      S1,  = lsbalance!(view(Ht,j2,j2),view(Jt,j2,j2),view(Ht,j2,i3),view(Ht,i3,j2); tol = 0.001)

      sx = round.(Int,(log2.(S1.diag[i1])-log2.(S1.diag[i2]))/2); # D=sqrt(D1/D2)
      Sx = Diagonal(radix.^(sx)) 
      D = Diagonal(radix.^[sx ; -sx])
      lmul!(D,view(H,j2,:)); rdiv!(view(H,:,j2),D)
      lmul!(D,view(J,j2,j2)); rdiv!(view(J,:,j2),D)

      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt);                 # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,Sx); ldiv!(scalsr,sr)
      end

      # adjust scaling of R 
      # rs = sqrt(norm(Rt,1))/max(norm(Bt,1),norm(St,1)); 
      # if 10*rs < 1 
      #    pow2 && (rs = radix^(round(Int,log2(rs)))) 
      #    lmul!(rs,view(H,i3,:)); lmul!(rs,view(J,i3,:)); rmul!(view(H,:,i3),rs); lmul!(rs,sr)
      # end
      Sr = Diagonal(sr)
      return H, J, Sx, Sx, Sr
    elseif scaling == 'T'
      nh = norm(view(H,i1,i1)-Diagonal(view(H,i1,i1)),1) + norm(view(H,i2,i2)-Diagonal(view(H,i2,i2)),1) 
      nj = norm(view(J,i1,i1)-Diagonal(view(J,i1,i1)),1) + norm(view(J,i2,i2)-Diagonal(view(J,i2,i2)),1) 
      if nh > 0 && nj > 0
         M = abs.(H) + nh/nj * abs.(J);
      else
         M = abs.(H) + abs.(J);
      end     
      sr = ones(T,m)
      S1 = lsbalance!(view(M,j2,j2),view(M,j2,i3),view(M,i3,j2))
      sx = round.(Int,(log2.(S1.diag[i2])-log2.(S1.diag[i1]))/2); # D=sqrt(D1/D2)
      Sx = Diagonal(radix.^(sx)) 
      D = Diagonal(radix.^[sx ; -sx])
      lmul!(D,view(H,j2,:)); rdiv!(view(H,:,j2),D)
      lmul!(D,view(J,j2,j2)); rdiv!(view(J,:,j2),D)

      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt);                 # Q -> Q/scal; 
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,Sx); ldiv!(scalsr,sr)
      end
      # adjust scaling of R 
      rs = sqrt(norm(Rt,1))/max(norm(Bt,1),norm(St,1)); 
      if 10*rs < 1 
         pow2 && (rs = radix^(round(Int,log2(rs)))) 
         lmul!(rs,view(H,i3,:)); lmul!(rs,view(J,i3,:)); rmul!(view(H,:,i3),rs); lmul!(rs,sr)
      end

      Sr = Diagonal(sr)
      return H, J, Sx, Sx, Sr
   else
      _, D2 = regbalance!(H, J; tol = 0.001, maxiter = 1000, pow2 = false)
      qs = sqrt(opnorm(Qt,1)) + sqrt(opnorm(St,1))
      gs = norm(Bt,1)/sqrt(norm(Rt,1))
      if qs > 10*gs
         scal = qs/gs  
         scalsr = sqrt(scal)
         pow2 && (scalsr = radix^(round(Int,log2(scalsr))); scal = scalsr^2) 
         ldiv!(scal,Qt);                 # Q -> Q/scal; G -> G * scal
         ldiv!(scal,St); ldiv!(scal,St2) # S -> S/scal 
         ldiv!(scal,Rt)                  # R -> R/scal
         lmul!(scalsr,view(D2.diag,i2)); ldiv!(scalsr,view(D2.diag,i1)); 
         ldiv!(scalsr,view(D2.diag,i3))
      end

      return H, J, Diagonal(D2.diag[i2]), inv(Diagonal(D2.diag[i1])), Diagonal(D2.diag[i3]) 
   end
end

# qS1, lsbalance!, regbalance! from MatrixPencils.jl package 
function qS1(M)    
"""
    qs = qS1(M) 

Compute the 1-norm based scaling quality `qs = qS(abs(M))` of a matrix `M`, 
where `qS(⋅)` is the scaling quality measure defined in Definition 5.5 of [1] for 
nonnegative matrices. Nonzero rows and columns in `M` are allowed.   

[1] F.M.Dopico, M.C.Quintana and P. van Dooren, 
    "Diagonal scalings for the eigenstructure of arbitrary pencils", SIMAX, 43:1213-1237, 2022. 
"""
    (size(M,1) == 0 || size(M,2) == 0) && (return one(real(eltype(M))))
    temp = sum(abs,M,dims=1)
    tmax = maximum(temp)
    rmax = tmax == 0 ? one(real(eltype(M))) : tmax/minimum(temp[temp .!= 0])
    temp = sum(abs,M,dims=2)
    tmax = maximum(temp)
    cmax = tmax == 0 ? one(real(eltype(M))) : tmax/minimum(temp[temp .!= 0])
    return max(rmax,cmax)
end
qS1(M::UniformScaling) = 1
function lsbalance!(A::AbstractMatrix{T1}, B::AbstractVecOrMat{T1}, C::AbstractMatrix{T1}; 
                   withB = true, withC = true, maxred = 16) where {T1}
"""
     lsbalance!(A, B, C; withB = true, withC = true, maxred = 16) -> D

Reduce the 1-norm of a system matrix 

             S =  ( A  B )
                  ( C  0 )

corresponding to a standard system triple `(A,B,C)` by balancing. 
This involves a diagonal similarity transformation `inv(D)*A*D` 
to make the rows and columns of 

                  diag(inv(D),I) * S * diag(D,I)
     
as close in norm as possible.
     
The balancing can be optionally performed on the following 
particular system matrices:   

        S = A, if withB = false and withC = false ,
        S = ( A  B ), if withC = false,     or    
        S = ( A ), if withB = false .
            ( C )      

The keyword argument `maxred = s` specifies the maximum allowed reduction in the 1-norm of
`S` (in an iteration) if zero rows or columns are present. 
`s` must be a positive power of `2`, otherwise  `s` is rounded to the nearest power of 2.   

_Note:_ This function is a translation of the SLICOT routine `TB01ID.f`, which 
represents an extensiom of the LAPACK family `*GEBAL.f` and also includes  
the fix proposed in [1]. 

[1]  R.James, J.Langou and B.Lowery. "On matrix balancing and eigenvector computation."
     ArXiv, 2014, http://arxiv.org/abs/1401.5766
"""
    n = LinearAlgebra.checksquare(A)
    n1, m = size(B,1), size(B,2)
    n1 == n || throw(DimensionMismatch("A and B must have the same number of rows"))
    n == size(C,2) || throw(DimensionMismatch("A and C must have the same number of columns"))
    T = real(T1)
    ZERO = zero(T)
    ONE = one(T)
    SCLFAC = T(2.)
    FACTOR = T(0.95); 
    maxred > ONE || throw(ArgumentError("maxred must be greater than 1, got maxred = $maxred"))
    MAXR = T(maxred)
    MAXR = T(2.) ^round(Int,log2(MAXR))
    # Compute the 1-norm of the required part of matrix S and exit if it is zero.
    SNORM = ZERO
    for j = 1:n
        CO = sum(abs,view(A,:,j))
        withC && (CO += sum(abs,view(C,:,j)))
        SNORM = max( SNORM, CO )
    end
    if withB
       for j = 1:m 
           SNORM = max( SNORM, sum(abs,view(B,:,j)) )
       end
    end
    D = fill(ONE,n)
    SNORM == ZERO && (return D)

    SFMIN1 =  T <: BlasFloat ? safemin(T) / eps(T) : safemin(Float64) / eps(Float64)
    SFMAX1 = ONE / SFMIN1
    SFMIN2 = SFMIN1*SCLFAC
    SFMAX2 = ONE / SFMIN2

    SRED = maxred
    SRED <= ZERO && (SRED = MAXR)

    MAXNRM = max( SNORM/SRED, SFMIN1 )

    # Balance the system matrix.

    # Iterative loop for norm reduction.
    NOCONV = true
    while NOCONV
        NOCONV = false
        for i = 1:n
            Aci = view(A,:,i)
            Ari = view(A,i,:)
            Ci = view(C,:,i)
            Bi = view(B,i,:)

            CO = norm(Aci)
            RO = norm(Ari)
            CA = abs(argmax(abs,Aci))
            RA = abs(argmax(abs,Ari))

            if withC
               CO = hypot(CO, norm(Ci))
               CA = max(CA,abs(argmax(abs,Ci)))
            end
            if withB
                RO = hypot(RO, norm(Bi))
                RA = max( RA, abs(argmax(abs,Bi)))
            end
            #  Special case of zero CO and/or RO.
            CO == ZERO && RO == ZERO && continue
            if CO == ZERO 
               RO <= MAXNRM && continue
               CO = MAXNRM
            end
            if RO == ZERO
               CO <= MAXNRM && continue
               RO = MAXNRM
            end

            #  Guard against zero CO or RO due to underflow.
            G = RO / SCLFAC
            F = ONE
            S = CO + RO
            while ( CO < G && max( F, CO, CA ) < SFMAX2 && min( RO, G, RA ) > SFMIN2 ) 
                F  *= SCLFAC
                CO *= SCLFAC
                CA *= SCLFAC
                G  /= SCLFAC
                RO /= SCLFAC
                RA /= SCLFAC   
            end
            G = CO / SCLFAC

            while ( G >= RO && max( RO, RA ) < SFMAX2 && min( F, CO, G, CA ) > SFMIN2 )
                F  /= SCLFAC
                CO /= SCLFAC
                CA /= SCLFAC
                G  /= SCLFAC
                RO *= SCLFAC
                RA *= SCLFAC
            end

            # Now balance.
            CO+RO >= FACTOR*S && continue
            if F < ONE && D[i] < ONE 
               F*D[i] <= SFMIN1 && continue
            end
            if F > ONE && D[i] > ONE 
               D[i] >= SFMAX1 / F  && continue
            end
            G = ONE / F
            D[i] *= F
            NOCONV = true
       
            lmul!(G,Ari)
            rmul!(Aci,F)
            lmul!(G,Bi)
            rmul!(Ci,F)
        end
    end
    return Diagonal(D)
end   
lsbalance!(A::AbstractMatrix{T1}; maxred = 16) where {T1} = lsbalance!(A,zeros(T1,size(A,1),0),zeros(T1,0,size(A,2)); maxred, withB=false, withC=false)  
function lsbalance!(A::AbstractMatrix{T}, E::Union{AbstractMatrix{T},UniformScaling{Bool}}, B::AbstractVecOrMat{T}, C::AbstractMatrix{T}; 
                    withB = true, withC = true, maxred = 16, maxiter = 100, tol = 1, pow2 = true) where {T}
"""
     lsbalance!(A, E, B, C; withB = true, withC = true, pow2, maxiter = 100, tol = 1) -> (D1,D2)

Reduce the 1-norm of the matrix 

             S =  ( abs(A)+abs(E)  abs(B) )
                  (    abs(C)        0    )

corresponding to a descriptor system triple `(A-λE,B,C)` by row and column balancing. 
This involves diagonal similarity transformations `D1*(A-λE)*D2` applied
iteratively to `abs(A)+abs(E)` to make the rows and columns of 
                             
                  diag(D1,I)  * S * diag(D2,I)
     
as close in norm as possible.
     
The balancing can be performed optionally on the following 
particular system matrices:   

        S = abs(A)+abs(E), if withB = false and withC = false ,
        S = ( abs(A)+abs(E)  abs(B) ), if withC = false,     or    
        S = ( abs(A)+abs(E) ), if withB = false .
            (   abs(C)     )       

The keyword argument `maxiter = k` specifies the maximum number of iterations `k` 
allowed in the balancing algorithm. 

The keyword argument `tol = τ`, with `τ ≤ 1`,  specifies the tolerance used in the stopping criterion.   

If the keyword argument `pow2 = true` is specified, then the components of the resulting 
optimal `D1` and `D2` are replaced by their nearest integer powers of 2, in which case the 
scaling of matrices is done exactly in floating point arithmetic. 
If `pow2 = false`, the optimal values `D1` and `D2` are returned.

_Note:_ This function is an extension of the MATLAB function `rowcolsums.m` of [1]. 

[1] F.M.Dopico, M.C.Quintana and P. van Dooren, 
    "Diagonal scalings for the eigenstructure of arbitrary pencils", SIMAX, 43:1213-1237, 2022. 
"""
   radix = real(T)(2.)
   emat = (typeof(E) <: AbstractMatrix)
   eident = !emat || isequal(E,I) 
   n = LinearAlgebra.checksquare(A)
   emat && (n,n) != size(E) && throw(DimensionMismatch("A and E must have the same dimensions"))
   n == size(B,1) || throw(DimensionMismatch("A and B must have compatible dimensions"))
   n == size(C,2) || throw(DimensionMismatch("A and C must have compatible dimensions"))

   n == 0 && (return Diagonal(T[]), Diagonal(T[]))
 
   if eident 
      D = lsbalance!(A, B, C; withB, withC, maxred)
      return inv(D), D
   else
      MA = abs.(A)+abs.(E)   
      MB = abs.(B)   
      MC = abs.(C)   
      r = fill(real(T)(n),n); c = copy(r)
      # Scale the matrix to have total sum(sum(M))=sum(c)=sum(r);
      sumcr = sum(c) 
      sumM = sum(MA) 
      withB && (sumM += sum(MB))
      withC && (sumM += sum(MC))
      sc = sumcr/sumM
      lmul!(1/sc,c); lmul!(1/sc,r)
      t = sqrt(sumcr/sumM); Dl = Diagonal(fill(t,n)); Dr = Diagonal(fill(t,n))
      # Scale left and right to make row and column sums equal to r and c
      conv = false
      for i = 1:maxiter
          conv = true
          cr = sum(MA,dims=1)
          withC && (cr .+= sum(MC,dims=1))
          dr = Diagonal(reshape(cr,n)./c)
          rdiv!(MA,dr); rdiv!(MC,dr) 
          er = minimum(dr.diag)/maximum(dr) 
          rdiv!(Dr,dr)
          cl = sum(MA,dims=2)
          withB && (cl .+= sum(MB,dims=2))
          dl = Diagonal(reshape(cl,n)./r)
          ldiv!(dl,MA); ldiv!(dl,MB)
          el = minimum(dl.diag)/maximum(dl) 
          rdiv!(Dl,dl)
         #  @show i, er, el
          max(1-er,1-el) < tol/2 && break
          conv = false
      end
      conv || (@warn "the iterative algorithm did not converge in $maxiter iterations")
      # Finally scale the two scalings to have equal maxima
      scaled = sqrt(maximum(Dr)/maximum(Dl))
      rmul!(Dl,scaled); rmul!(Dr,1/scaled)
      if pow2
         Dl = Diagonal(radix .^(round.(Int,log2.(Dl.diag))))
         Dr = Diagonal(radix .^(round.(Int,log2.(Dr.diag))))
      end
      lmul!(Dl,A); rmul!(A,Dr)
      lmul!(Dl,E); rmul!(E,Dr)
      lmul!(Dl,B)
      rmul!(C,Dr)
      return Dl, Dr  
   end
end
function regbalance!(A::AbstractMatrix{T}, E::AbstractMatrix{T}; maxiter = 100, tol = 1, pow2 = true) where {T}
"""
     regbalance!(A, E; maxiter = 100, tol = 1, pow2 = true) -> (Dl,Dr)

Balance the regular pair `(A,E)` by reducing the 1-norm of the matrix `M := abs(A)+abs(E)`
by row and column balancing. 
This involves diagonal similarity transformations `Dl*(A-λE)*Dr` applied
iteratively to `M` to make the rows and columns of `Dl*M*Dr` as close in norm as possible.
The [Sinkhorn–Knopp algorithm](https://en.wikipedia.org/wiki/Sinkhorn%27s_theorem) is used 
to reduce `M` to a doubly stochastic matrix. 

The resulting `Dl` and `Dr` are diagonal scaling matrices.  
If the keyword argument `pow2 = true` is specified, then the components of the resulting 
optimal `Dl` and `Dr` are replaced by their nearest integer powers of 2. 
If `pow2 = false`, the optimal values `Dl` and `Dr` are returned.
The resulting `Dl*A*Dr` and `Dl*E*Dr` overwrite `A` and `E`, respectively
    
The keyword argument `tol = τ`, with `τ ≤ 1`,  specifies the tolerance used in the stopping criterion. 
The iterative process is stopped as soon as the incremental scalings are `tol`-close to the identity. 

The keyword argument `maxiter = k` specifies the maximum number of iterations `k` 
allowed in the balancing algorithm. 

_Note:_ This function is based on the MATLAB function `rowcolsums.m` of [1], modified such that
the scaling operations are directly applied to `A` and `E`.  

[1] F.M.Dopico, M.C.Quintana and P. van Dooren, 
    "Diagonal scalings for the eigenstructure of arbitrary pencils", SIMAX, 43:1213-1237, 2022. 
"""
   n = LinearAlgebra.checksquare(A)
   (n,n) != size(E) && throw(DimensionMismatch("A and E must have the same dimensions"))

   n <= 1 && (return Diagonal(ones(T,n)), Diagonal(ones(T,n)))
   TR = real(T)
   radix = TR(2.)
   t = TR(n)
   pow2 && (t = radix^(round(Int,log2(t)))) 
   c = fill(t,n); 
   # Scale the matrix M = abs(A)+abs(E) to have total sum(sum(M)) = sum(c)
   sumcr = sum(c) 
   sumM = sum(abs,A) + sum(abs,E)
   sc = sumcr/sumM
   pow2 && (sc = radix^(round(Int,log2(sc)))) 
   t = sqrt(sc) 
   ispow2(t) || (sc *= 2; t = sqrt(sc))
   lmul!(sc,A); lmul!(sc,E)
   Dl = Diagonal(fill(t,n)); Dr = Diagonal(fill(t,n))

   # Scale left and right to make row and column sums equal to r and c
   conv = false
   for i = 1:maxiter
       conv = true
       cr = sum(abs,A,dims=1) + sum(abs,E,dims=1) 
       dr = pow2 ? Diagonal(radix .^(round.(Int,log2.(reshape(cr,n)./c)))) : Diagonal(reshape(cr,n)./c)
       rdiv!(A,dr); rdiv!(E,dr) 
       er = minimum(dr.diag)/maximum(dr) 
       rdiv!(Dr,dr)
       cl = sum(abs,A,dims=2) + sum(abs,E,dims=2)
       dl = pow2 ? Diagonal(radix .^(round.(Int,log2.(reshape(cl,n)./c)))) : Diagonal(reshape(cl,n)./c)
       ldiv!(dl,A); ldiv!(dl,E)
       el = minimum(dl.diag)/maximum(dl) 
       rdiv!(Dl,dl)
       max(1-er,1-el) < tol/2 && break
       conv = false
   end
   conv || (@warn "the iterative algorithm did not converge in $maxiter iterations")
   # Finally scale the two scalings to have equal maxima
   scaled = sqrt(maximum(Dr)/maximum(Dl))
   pow2 && (scaled = radix^(round(Int,log2(scaled)))) 
   rmul!(Dl,scaled); rmul!(Dr,1/scaled)
   return Dl, Dr  
end
"""
    symscal!(M; maxiter = 100, tol = 1.e-3, nrm = 1) -> (dleft,dright)

Perform the symmetry preserving algorithm to scale 
a non-negative `m×n` matrix `M` such that
 
     Md := diag(dleft)*M*diag(dright)

has all row and column norms equal to one. The employed norms can be selected 
via the keyword argument `nrm`. Presently only `nrm = 1` (default) and `nrm = Inf` are supported.
The iterative process is stopped as soon as the incremental
scalings are tol-close to the identity. The keyword argument `tol` is the
tolerance for the transformation updates. 

The resulting `Md` overwrites the input matrix `M`, and `dleft` and `dright` are 
the diagonals of the left and right scalings. 
`Md` results symmetric provided `M` is a symmetric matrix, and in this case `dleft = dright`.

The scaling algorithm has been proposed in [1]. 

[1] Authors: P. A. Knight, D. Ruiz and B. Uçar.
    A Symmetry Preserving Algorithm for Matrix Scaling. 
    SIAM Journal on Matrix Analysis and Applications, 35:931-955, 2014. 
"""
function symscal!(M::AbstractMatrix{T}; maxiter = 100, tol = 1.e-3, nrm = 1) where {T}
    m, n = size(M) 
    dl = ones(T,m); dr = ones(T,n)
    for i = 1:maxiter
        r = [sqrt(norm(view(M,j,:),nrm)) for j in 1:m]
        c = [sqrt(norm(view(M,:,j),nrm)) for j in 1:n]
        if norm(1 .- r,Inf) < tol && norm(1 .- c,Inf) < tol 
           info = (flag = 1, iter = i)
           return dl, dr, info
        end
        ldiv!(Diagonal(r),M); rdiv!(M,Diagonal(c))
        dl ./= r; dr ./= c
    end
    info = (flag = 2, iter = maxiter)
    return dl, dr, info
end

"""
    γ = opnorm1(op)

Compute `γ`, the induced `1`-norm of the linear operator `op`, as the maximum of `1`-norm of the
columns of the associated `m x n` matrix ``M`` `= Matrix(op)`:
```math
\\gamma = \\|op\\|_1 := \\max_{1 ≤ j ≤ n} \\|M_j\\|_1
```
with ``M_j`` the `j`-th column of ``M``. This function is not recommended to be used for large order operators.


# Examples
```jldoctest
julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> opnorm1(lyapop(A))
30.0

julia> opnorm1(invlyapop(A))
3.7666666666666706
```
"""
function opnorm1(op::LinearMaps.LinearMap{T}) where T
   m, n = size(op)
   TR = real(T)
   ej = zeros(TR, n)
   ej[1] = 1
   y = similar(ej, T, m)
   nrm = zero(typeof(norm(zero(T))))
   for j = 1:n
      ej[j] = 1
      try
         mul!(y, op, ej)
         nrm = max(nrm, norm(y, 1))
      catch err
         # if isnothing(findfirst("SingularException",string(err))) &&
         #    isnothing(findfirst("LAPACKException",string(err)))
         findfirst("SingularException", string(err)) === nothing &&
         findfirst("LAPACKException", string(err)) === nothing ? rethrow() : (return TR(Inf))
      end
      ej[j] = 0
   end
   return nrm
end

"""
    γ = opnorm1est(op)

Compute `γ`, a lower bound of the `1`-norm of the square linear operator `op`, using
reverse communication based computations to evaluate `op * x` and `op' * x`.
It is expected that in most cases ``\\gamma > \\|op\\|_1/10``, which is usually
acceptable for estimating the condition numbers of linear operators.

# Examples
```jldoctest
julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> opnorm1est(lyapop(A))
18.0

julia> opnorm1est(invlyapop(A))
3.76666666666667
```
"""
function opnorm1est(op::LinearMaps.LinearMap)
   m, n = size(op)
   m == n || throw(DimensionMismatch("The operator op must be square"))
   T = promote_type(Float64,eltype(op))
   TR = real(T)
   TR == Float64 ? SMLNUM = reinterpret(Float64, 0x2000000000000000) : SMLNUM = reinterpret(Float32, 0x20000000)
   BIGNUM = 2*eps(TR) / SMLNUM
   cmplx = T<:Complex
   V = Array{T,1}(undef,n)
   X = Array{T,1}(undef,n)
   cmplx ? ISGN = Array{Int,1}(undef,1) : ISGN = Array{Int,1}(undef,n)
   ISAVE = Array{Int,1}(undef,3)
   ANORM = zero(TR)
   KASE = 0
   finish = false
   while !finish
      if cmplx
         ANORM, KASE = LapackUtil.lacn2!(V, X, ANORM, KASE, ISAVE )
      else
         ANORM, KASE = LapackUtil.lacn2!(V, X, ISGN, ANORM, KASE, ISAVE )
      end
      (isfinite(ANORM) && ANORM < BIGNUM) || (return Inf)
      if KASE != 0
         try
            KASE == 1 ? X = op*X : X = op'*X
         catch err
         #   if isnothing(findfirst("SingularException",string(err))) &&
         #      isnothing(findfirst("LAPACKException",string(err)))
            findfirst("SingularException",string(err)) === nothing &&
            findfirst("LAPACKException",string(err)) === nothing ? rethrow() : (return TR(Inf))
         end
      else
         finish = true
      end
   end
   return ANORM
end

"""
    sep = opsepest(opinv; exact = false)

Compute `sep`, an estimation of the `1`-norm separation of a linear operator
`op`, where `opinv` is the inverse operator `inv(op)`. The estimate is computed as
``\\text{sep}  = 1 / \\|opinv\\|_1`` , using an estimate of the `1`-norm, if `exact = false`, or
the computed exact value of the `1`-norm, if `exact = true`.
The `exact = true` option is not recommended for large order operators.

The separation of the operator `op` is defined as
```math
\\text{sep} = \\displaystyle\\min_{X\\neq 0} \\frac{\\|op*X\\|}{\\|X\\|}.
```

An estimate of the reciprocal condition number of `op` can be computed as ``\\text{sep}/\\|op\\|_1``.

# Example
```jldoctest
julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> opsepest(invlyapop(A))
0.26548672566371656

julia> 1/opnorm1est(invlyapop(A))
0.26548672566371656

julia> opsepest(invlyapop(A),exact = true)
0.26548672566371656

julia> 1/opnorm1(invlyapop(A))
0.26548672566371656
```
"""
function opsepest(opinv::LinearMaps.LinearMap; exact = false)
   T = promote_type(Float64,eltype(opinv))
   TR = real(T)
   TR == Float64 ? SMLNUM = reinterpret(Float64, 0x2000000000000000) : SMLNUM = reinterpret(Float32, 0x20000000)
   BIGNUM = 2*eps(TR) / SMLNUM
   ZERO = zero(TR)
   opinvnrm1 = exact ? opnorm1(opinv) : opnorm1est(opinv)
   if opinvnrm1 >= BIGNUM
      return ZERO
   end
   return one(TR)/opinvnrm1
end

"""
    rcond = oprcondest(op, opinv; exact = false)

Compute `rcond`, an estimation of the `1`-norm reciprocal condition number
of a linear operator `op`, where `opinv` is the inverse operator `inv(op)`. The estimate is computed as
``\\text{rcond} = 1 / (\\|op\\|_1\\|opinv\\|_1)``, using estimates of the `1`-norm, if `exact = false`, or
computed exact values of the `1`-norm, if `exact = true`.
The `exact = true` option is not recommended for large order operators.

_Note:_ No check is performed to verify that `opinv = inv(op)`.

# Examples
```jldoctest
julia> A = [-6. -2. 1.; 5. 1. -1; -4. -2. -1.]
3×3 Array{Float64,2}:
 -6.0  -2.0   1.0
  5.0   1.0  -1.0
 -4.0  -2.0  -1.0

julia> oprcondest(lyapop(A),invlyapop(A))
0.014749262536873142

julia> 1/opnorm1est(lyapop(A))/opnorm1est(invlyapop(A))
0.014749262536873142

julia> oprcondest(lyapop(A),invlyapop(A),exact = true)
0.008849557522123885

julia> 1/opnorm1(lyapop(A))/opnorm1(invlyapop(A))
0.008849557522123885
```
"""
function oprcondest(op::LinearMaps.LinearMap, opinv::LinearMaps.LinearMap; exact = false)
   return opsepest(op, exact = exact)*opsepest(opinv, exact = exact)
end
"""
    rcond = oprcondest(op; exact = false)

Compute `rcond`, an estimation of the `1`-norm reciprocal condition number
of a linear operator `op`, where `op` is one of the defined Lyapunov or Sylvester operators.
The estimate is computed as
``\\text{rcond} = 1 / (\\|op\\|_1\\|inv(op)\\|_1)``, using estimates of the `1`-norm, if `exact = false`, or
computed exact values of the `1`-norm, if `exact = true`.
The `exact = true` option is not recommended for large order operators.
"""
function oprcondest(op::MatrixEquationsMaps{T}; kwargs...) where T
   oprcondest(op, inv(op); kwargs...)
end

module Test_cplyap

using LinearAlgebra
using MatrixEquations
using GenericSchur
using Test
using LinearAlgebra: BlasFloat


println("Test_cplyap")
@testset "Testing positive continuous Lyapunov equation solvers" begin

n = 30
m = 5
p = 3
Ty = Float64

@testset "Positive continuous Lyapunov equations" begin

reltol = eps(float(100))
a = -1; b = 2im; @time u = plyapc(a,b)
@test abs(a*u*u'+u*u'*a'+b*b') < reltol

reltol = eps(float(100f0))
a = -1f0; b = 2f0im; @time u = plyapc(a,b)
@test abs(a*u*u'+u*u'*a'+b*b') < reltol


for Ty in (Float64, Float32, BigFloat)

ar = rand(Ty,n,n);
ar = ar-2*norm(ar)*Matrix(I,n,n);
br = rand(Ty,n,m);
ac = rand(Ty,n,n)+im*rand(Ty,n,n);
ac = ac-2*norm(ac)*Matrix(I,n,n);
bc = br+im*rand(Ty,n,m);

brw = rand(Ty,n,n+m)
bcw = brw+im*rand(Ty,n,n+m)
cr = rand(Ty,p,n)
crt = rand(Ty,n+p,n)
cc = cr+im*rand(Ty,p,n)
cct = crt+im*rand(Ty,n+p,n)
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))

@time u = plyapc(ar,br);
x = u*u'; @test norm(ar*x+x*ar'+br*br')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar,0*br);
x = u*u'; @test norm(ar*x+x*ar') < reltol

@time u = plyapc(ar,brw);
x = u*u'; @test norm(ar*x+x*ar'+brw*brw')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar,I,br);
x = u*u'; @test norm(ar*x+x*ar'+br*br')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar',cr');
x = u'*u; @test norm(ar'*x+x*ar+cr'*cr)/norm(x)/norm(ar) < reltol

@time u = plyapc(ar',crt');
x = u'*u; @test norm(ar'*x+x*ar+crt'*crt)/norm(x)/norm(ar) < reltol

@time u = plyapc(ac,bc);
x = u*u'; @test norm(ac*x+x*ac'+bc*bc')/norm(x)/norm(ac) < reltol

@time u = plyapc(ac,0*bc);
x = u*u'; @test norm(ac*x+x*ac') < reltol

@time u = plyapc(ac,bcw);
x = u*u'; @test norm(ac*x+x*ac'+bcw*bcw')/norm(x)/norm(ac) < reltol

@time u = plyapc(ac',cc');
x = u'*u; @test norm(ac'*x+x*ac+cc'*cc)/norm(x)/norm(ac) < reltol  

@time u = plyapc(ac',cct');
x = u'*u; @test norm(ac'*x+x*ac+cct'*cct)/norm(x)/norm(ac) < reltol

@time u = plyapc(ac',I,cc');
x = u'*u; @test norm(ac'*x+x*ac+cc'*cc)/norm(x)/norm(ac) < reltol

@time u = plyapc(ac,br);
x = u*u'; @test norm(ac*x+x*ac'+br*br')/norm(x)/norm(ac) < reltol

@time u = plyapc(ac',cr');
x = u'*u; @test norm(ac'*x+x*ac+cr'*cr)/norm(x)/norm(ac) < reltol

@time u = plyapc(ar,bc);
x = u*u'; @test norm(ar*x+x*ar'+bc*bc')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar',cc');
x = u'*u; @test norm(ar'*x+x*ar+cc'*cc)/norm(x)/norm(ar)  < reltol

if Ty <: BlasFloat
@time u = plyapc(ar,br; blocksize = 10);
x = u*u'; @test norm(ar*x+x*ar'+br*br')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar',cr'; blocksize = 10);
x = u'*u; @test norm(ar'*x+x*ar+cr'*cr)/norm(x)/norm(ar) < reltol

@time u = plyapc(ac,bc; blocksize = 10);
x = u*u'; @test norm(ac*x+x*ac'+bc*bc')/norm(x)/norm(ac) < reltol

@time u = plyapc(ac',cc'; blocksize = 10);
x = u'*u; @test norm(ac'*x+x*ac+cc'*cc)/norm(x)/norm(ac) < reltol  
end
end
end


@testset "Positive continuous generalized Lyapunov equations" begin

reltol = eps(float(100))
a = -1; ee = 4; b = 2im; @time u = plyapc(a,ee,b)
@test abs(a*u*u'*ee'+ee*u*u'*a'+b*b') < reltol

reltol = eps(float(100f0))
a = -1f0; ee = 4f0; b = 2f0im; @time u = plyapc(a,ee,b)
@test abs(a*u*u'*ee'+ee*u*u'*a'+b*b')  < reltol

# # scaling related tests
# a = [   -1.3429   -0.4189   -0.3001
#    -1.0322   -0.1403    1.0294
#     1.3312    0.8998   -0.3451];
# e = [
#     1.0128   -0.8657   -0.4381
#     0.6293   -1.0431   -0.4087
#    -0.2130   -0.2701    0.9835];
# b = [
#    -0.2977    0.9726
#     1.1437   -0.5223
#    -0.5316    0.1766];
# b = copy(b');

# U = plyapc(a',e',b'); 
# X = U'*U; 
# @test norm(a'*X*e + e'*X*a + b'*b,Inf) < 1.e-7

# t = 1e150; U = plyapc(a',e',(t*b)')/t; X = U'*U; 
# @test norm(a'*X*e + e'*X*a + b'*b,Inf) < 1.e-7

# t = 1.e150; U = plyapc((t*a)',(t*e)',(t*b)'); X = U'*U; 
# @test norm(a'*X*e + e'*X*a + b'*b,Inf) < 1.e-7


for Ty in (Float64, Float32, BigFloat)

ar = rand(Ty,n,n)
ar = ar-2*norm(ar)*Matrix(I,n,n)
er = rand(n,n)
ar = er*ar
ac = rand(Ty,n,n)+im*rand(Ty,n,n)
ac = ac-2*norm(ac)*Matrix(I,n,n)
ec = er+im*rand(Ty,n,n)
ac = ec*ac
br = rand(Ty,n,m)
brw = rand(Ty,n,n+m)
bc = br+im*rand(Ty,n,m)
bcw = brw+im*rand(Ty,n,n+m)
cr = rand(Ty,p,n)
crt = rand(Ty,n+p,n)
cc = cr+im*rand(Ty,p,n)
cct = crt+im*rand(Ty,n+p,n)
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))


@time u = plyapc(ar,er,br);
x = u*u'; @test norm(ar*x*er'+er*x*ar'+br*br')/norm(x)/norm(ar) < reltol

@time u = real(plyapc(complex(ar),complex(er),complex(br)));
x = u*u'; @test norm(ar*x*er'+er*x*ar'+br*br')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar,er,0*br);
x = u*u'; @test norm(ar*x*er'+er*x*ar') < reltol

@time u = plyapc(ar,er,brw);
x = u*u'; @test norm(ar*x*er'+er*x*ar'+brw*brw')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar',er',cr');
x = u'*u; @test norm(ar'*x*er+er'*x*ar+cr'*cr)/norm(x)/norm(ar) < reltol  

@time u = plyapc(ar',er',crt');
x = u'*u; @test norm(ar'*x*er+er'*x*ar+crt'*crt)/norm(x)/norm(ar) < reltol

@time u = plyapc(ac,ec,bc);
x = u*u'; @test norm(ac*x*ec'+ec*x*ac'+bc*bc')/norm(x)/norm(ac)/norm(ec) < reltol

@time u = plyapc(ac,ec,0*bc);
x = u*u'; @test norm(ac*x*ec'+ec*x*ac') < reltol

@time u = plyapc(ac,ec,bcw);
x = u*u'; @test norm(ac*x*ec'+ec*x*ac'+bcw*bcw')/norm(x)/norm(ac)/norm(ec) < reltol

@time u = plyapc(ac',ec',cc');
x = u'*u; @test norm(ac'*x*ec+ec'*x*ac+cc'*cc)/norm(x)/norm(ac) < reltol

@time u = plyapc(ac',ec',cct');
x = u'*u; @test norm(ac'*x*ec+ec'*x*ac+cct'*cct)/norm(x)/norm(ac) < reltol

@time u = plyapc(ar,er,bc);
x = u*u'; @test norm(ar*x*er'+er*x*ar'+bc*bc')/norm(x)/norm(ar) < reltol

@time u = plyapc(ar',er',cc');
x = u'*u; @test norm(ar'*x*er+er'*x*ar+cc'*cc)/norm(x)/norm(ar) < reltol

@time u = plyapc(ac,ec,br);
x = u*u'; @test norm(ac*x*ec'+ec*x*ac'+br*br')/norm(x)/norm(ac)/norm(ec) < reltol

@time u = plyapc(ac',ec',cr');
x = u'*u; @test norm(ac'*x*ec+ec'*x*ac+cr'*cr)/norm(x)/norm(ac) < reltol

end
end

@testset "Positive 2x2 continuous Lyapunov equations" begin

A = [-1.1 1.; -1. -1.]
E = [1. 1.; 0. 1.]
R = UpperTriangular([1. 1.; 0. 1.])
reltol = eps(float(100))
β = rand(2,2); α = rand(2,2);

U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = true, disc = false)
X = U'*U; @test norm(A'*X+X*A+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U - R)/max(1,norm(R)) < reltol

U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = false, disc = false)
X = U*U'; @test norm(A*X+X*A'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(U*β-A*U)/max(1,norm(U))/norm(A) < reltol &&
                norm(U*α - R)/max(1,norm(R)) < reltol

U = copy(R)                
β, α = MatrixEquations.pglyap2!(A, E, U, adj = true, disc = false)
X = U'*U; @test norm(A'*X*E+E'*X*A+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U*E-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U*E - R)/max(1,norm(R)) < reltol

U = copy(R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = false, disc = false)
X = U*U'; @test norm(A*X*E'+E*X*A'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(A*U-E*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E*U*α - R)/max(1,norm(R)) < reltol

U = copy(R)
Q = qr(rand(2,2)).Q; A1 = Q*A; E1 = Q*E;
β, α = MatrixEquations.pglyap2!(A1, E1, U, adj = false, disc = false)
X = U*U'; @test norm(A1*X*E1'+E1*X*A1'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(A1*U-E1*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E1*U*α - R)/max(1,norm(R)) < reltol


U = copy(0*R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = false, disc = false)
X = U*U'; @test norm(A*X*E'+E*X*A')/max(1,norm(X))/norm(A) < reltol &&
                norm(A*U-E*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E*U*α - 0*R)/max(1,norm(R)) < reltol


A = [-1.1 1.; -1. -1.]/10; A = convert(Matrix{Float32},A)
E = [1. 1.; 0. 1.]; E = convert(Matrix{Float32},E)
R = [1. 1.; 0. 1.]; R = UpperTriangular(convert(Matrix{Float32},R))
reltol = eps(100f0)
β = rand(Float32,2,2); α = rand(Float32,2,2);

U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = true, disc = false)
X = U'*U; @test norm(A'*X+X*A+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U - R)/max(1,norm(R)) < reltol

U = copy(R)
MatrixEquations.plyap2!(A, U, β, α, adj = false, disc = false)
X = U*U'; @test norm(A*X+X*A'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(U*β-A*U)/max(1,norm(U))/norm(A) < reltol &&
                norm(U*α - R)/max(1,norm(R)) < reltol

U = copy(R)                
β, α = MatrixEquations.pglyap2!(A, E, U, adj = true, disc = false)
X = U'*U; @test norm(A'*X*E+E'*X*A+R'*R)/max(1,norm(X))/norm(A) < reltol &&
                norm(β*U*E-U*A)/max(1,norm(U))/norm(A) < reltol &&
                norm(α*U*E - R)/max(1,norm(R)) < reltol

U = copy(R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = false, disc = false)
X = U*U'; @test norm(A*X*E'+E*X*A'+R*R')/max(1,norm(X))/norm(A) < reltol &&
                norm(A*U-E*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E*U*α - R)/max(1,norm(R)) < reltol

U = copy(0*R)
β, α = MatrixEquations.pglyap2!(A, E, U, adj = false, disc = false)
X = U*U'; @test norm(A*X*E'+E*X*A')/max(1,norm(X))/norm(A) < reltol &&
                norm(A*U-E*U*β)/max(1,norm(U))/norm(A) < reltol &&
                norm(E*U*α)/max(1,norm(R)) < reltol

end

@testset "Continuous positive Lyapunov equations - Schur form" begin

for Ty in (Float64, Float32, BigFloat)

ar = rand(Ty,n,n)
ar = ar-2*norm(ar)*Matrix(I,n,n)
as,  = schur(ar)
ac = rand(Ty,n,n)+im*rand(Ty,n,n)
ac = ac-2*norm(ac)*Matrix(I,n,n)
acs,  = schur(ac)
br = rand(Ty,n,m)
brw = rand(Ty,n,n+m)
bc = br+im*rand(Ty,n,m)
cr = rand(Ty,p,n)
crt = rand(Ty,n+p,n)
cc = cr+im*rand(Ty,p,n)
Ty == Float64 ? reltol = eps(float(100)) : reltol = eps(100*n*one(Ty))

@time u = plyaps(as,br);
x = u*u'; @test norm(as*x+x*as'+br*br')/norm(x)/norm(as) < reltol

@time u = plyaps(as,brw);
x = u*u'; @test norm(as*x+x*as'+brw*brw')/norm(x)/norm(as) < reltol

@time u = plyaps(as,I,br);
x = u*u'; @test norm(as*x+x*as'+br*br')/norm(x)/norm(as) < reltol

@time u = plyaps(as',cr');
x = u'*u; @test norm(as'*x+x*as+cr'*cr)/norm(x)/norm(as) < reltol

@time u = plyaps(as',crt');
x = u'*u; @test norm(as'*x+x*as+crt'*crt)/norm(x)/norm(as) < reltol

@time u = plyaps(acs,bc);
x = u*u'; @test norm(acs*x+x*acs'+bc*bc')/norm(x)/norm(as) < reltol

@time u = plyaps(acs',cc');
x = u'*u; @test norm(acs'*x+x*acs+cc'*cc)/norm(x)/norm(as) < reltol

@time u = plyaps(acs',I,cc');
x = u'*u; @test norm(acs'*x+x*acs+cc'*cc)/norm(x)/norm(as) < reltol

if Ty <: BlasFloat
@time u = plyaps(as,br,blocksize = 10);
x = u*u'; @test norm(as*x+x*as'+br*br')/norm(x)/norm(as) < reltol

@time u = plyaps(as',cr',blocksize = 10);
x = u'*u; @test norm(as'*x+x*as+cr'*cr)/norm(x)/norm(as) < reltol

@time u = plyaps(acs,bc,blocksize = 10);
x = u*u'; @test norm(acs*x+x*acs'+bc*bc')/norm(x)/norm(as) < reltol

@time u = plyaps(acs',cc',blocksize = 10);
x = u'*u; @test norm(acs'*x+x*acs+cc'*cc)/norm(x)/norm(as) < reltol
end


F = UpperTriangular(rand(Ty,n,n))
R = copy(F)
@time plyapcs!(as,R,adj = true);
x = R'*R; @test norm(as'*x+x*as+F'*F)/norm(x)/norm(as) < reltol

F = UpperTriangular(rand(Ty,n,n))
R = copy(F)
@time plyapcs!(as,I,R,adj = true);
x = R'*R; @test norm(as'*x+x*as+F'*F)/norm(x)/norm(as) < reltol

F = UpperTriangular(rand(Ty,n,n))
R = copy(F)
@time plyapcs!(as,R,adj = false);
x = R*R'; @test norm(as*x+x*as'+F*F')/norm(x)/norm(as) < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(F)
@time plyapcs!(acs,R,adj = true);
x = R'*R; @test norm(acs'*x+x*acs+F'*F)/norm(x)/norm(acs) < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(F)
@time plyapcs!(acs,R,adj = false);
x = R*R'; @test norm(acs*x+x*acs'+F*F')/norm(x)/norm(acs) < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(F)
@time plyapcs!(acs,I,R,adj = true);
x = R'*R; @test norm(acs'*x+x*acs+F'*F)/norm(x)/norm(acs) < reltol

if Ty <: BlasFloat

F = UpperTriangular(rand(Ty,n,n))
R = copy(F)
@time plyapcs!(as,R,adj = false,blocksize = 10);
x = R*R'; @test norm(as*x+x*as'+F*F')/norm(x)/norm(as) < reltol

F = UpperTriangular(rand(Ty,n,n))
R = copy(F)
@time plyapcs!(as,R,adj = true,blocksize = 10);
x = R'*R; @test norm(as'*x+x*as+F'*F)/norm(x)/norm(as) < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(F)
@time plyapcs!(acs,R,adj = false,blocksize = 10);
x = R*R'; @test norm(acs*x+x*acs'+F*F')/norm(x)/norm(acs) < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(F)
@time plyapcs!(acs,R,adj = false,blocksize = 10);
x = R*R'; @test norm(acs*x+x*acs'+F*F')/norm(x)/norm(acs) < reltol
end

as = schur(ar).T
er = rand(Ty,n,n)
ar = er*ar
es = triu(er)
as = es*as
#as, es = schur(ar,er)
ec = er+im*rand(Ty,n,n)
ac = ec*ac
acs, ecs = schur(ac,ec)

@time u = plyaps(as,es,br);
x = u*u'; @test norm(as*x*es'+es*x*as'+br*br')/norm(x)/norm(as) < reltol

@time u = plyaps(as,es,brw);
x = u*u'; @test norm(as*x*es'+es*x*as'+brw*brw')/norm(x)/norm(as) < reltol

@time u = plyaps(as',es',cr');
x = u'*u; @test norm(as'*x*es+es'*x*as+cr'*cr)/norm(x)/norm(as) < reltol  

@time u = plyaps(as',es',crt');
x = u'*u; @test norm(as'*x*es+es'*x*as+crt'*crt)/norm(x)/norm(as) < reltol

@time u = plyaps(acs,ecs,bc);
x = u*u'; @test norm(acs*x*ecs'+ecs*x*acs'+bc*bc')/norm(x)/norm(as) < reltol

@time u = plyaps(acs',ecs',cc');
x = u'*u; @test norm(acs'*x*ecs+ecs'*x*acs+cc'*cc)/norm(x)/norm(as) < reltol

F = UpperTriangular(rand(Ty,n,n))
R = copy(F)
@time plyapcs!(as,es,R,adj = true);
x = R'*R; @test norm(as'*x*es+es'*x*as+F'*F)/norm(x)/norm(as) < reltol  #fails

F = UpperTriangular(rand(Ty,n,n))
R = copy(0*F)
@time plyapcs!(as,es,R,adj = true);
x = R'*R; @test norm(as'*x*es+es'*x*as) < reltol


F = UpperTriangular(rand(Ty,n,n))
R = copy(F)
@time plyapcs!(as,es,R,adj = false);
x = R*R'; @test norm(as*x*es'+es*x*as'+F*F')/norm(x)/norm(as) < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(F)
@time plyapcs!(acs,ecs,R,adj = false);
x = R*R'; @test norm(acs*x*ecs'+ecs*x*acs'+F*F')/norm(x)/norm(acs) < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(0*F)
@time plyapcs!(acs,ecs,R,adj = false);
x = R*R'; @test norm(acs*x*ecs'+ecs*x*acs') < reltol

F = UpperTriangular(rand(Ty,n,n)+im*rand(Ty,n,n))
R = copy(F)
@time plyapcs!(acs,ecs,R,adj = true);
x = R'*R; @test norm(acs'*x*ecs+ecs'*x*acs+F'*F)/norm(x)/norm(acs) < reltol

end

end
end

end

"""
    lyapci(A, C; abstol, reltol, maxiter) -> (X,info)

Compute for a square `A` and a hermitian/symmetric `C` a solution `X` of the continuous Lyapunov matrix equation

                A*X + X*A' + C = 0.

A least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function lyapci(A::AbstractMatrix, C::AbstractMatrix; abstol = zero(float(real(eltype(A)))), reltol = sqrt(eps(float(real(eltype(A))))), maxiter = 1000) 
    n = LinearAlgebra.checksquare(A)
    LinearAlgebra.checksquare(C) == n ||
        throw(DimensionMismatch("C must be a square matrix of dimension $n"))
    sym = isreal(A) && isreal(C) && issymmetric(C) 
    her = ishermitian(C) 
    LT = lyapop(A; her = sym)

    if sym 
       xt, info = cgls(LT,-triu2vec(C); abstol, reltol, maxiter)
    else
       xt, info = cgls(LT,-vec(C); abstol, reltol, maxiter)
    end
    info.flag == 1 || @warn "convergence issues: info = $info"
    if sym
       return vec2triu(xt,her = true), info
    else
       Xt = reshape(xt,n,n); 
       return her ? (Xt+Xt')/2 : Xt, info
    end
end
"""
    lyapci(A, E, C; abstol, reltol, maxiter) -> (X,info)

Compute `X`, the solution of the generalized continuous Lyapunov equation

    AXE' + EXA' + C = 0,

where `A` and `E` are square real or complex matrices and `C` is a square matrix.
A least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function lyapci(A::AbstractMatrix, E::AbstractMatrix, C::AbstractMatrix; abstol = zero(float(real(eltype(A)))), reltol = sqrt(eps(float(real(eltype(A))))), maxiter = 1000) 
    n = LinearAlgebra.checksquare(A)
    LinearAlgebra.checksquare(C) == n ||
       throw(DimensionMismatch("C must be a square matrix of dimension $n"))
    LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a square matrix of dimension $n"))
    sym = isreal(A) && isreal(E) && isreal(C) && issymmetric(C) 
    her = ishermitian(C)
    LT = lyapop(A, E; her = sym)
    
    if sym 
       xt, info = cgls(LT,-triu2vec(C); abstol, reltol, maxiter)
    else
       xt, info = cgls(LT,-vec(C); abstol, reltol, maxiter)
    end
    info.flag == 1 || @warn "convergence issues: info = $info"
    if sym
       return vec2triu(xt,her = true), info
    else
       Xt = reshape(xt,n,n); 
       return her ? (Xt+Xt')/2 : Xt, info
    end
end
"""
    plyapci(A, E, B; cyclic, abstol, reltol, maxiter, nshifts, shifts, loginf) -> (U, info)
    plyapci(A, B; cyclic, abstol, reltol, maxiter, nshifts, shifts, loginf) -> (U, info)

Compute a low-rank factor `U` of the solution `X = UU'` of the
generalized continuous Lyapunov equation

      AXE' + EXA' + BB' = 0,

where `A` and `E` are square real matrices and `B` is a real matrix
with the same number of rows as `A`. The pencil `A - λE` must have only
eigenvalues with negative real parts. `E = I` is assumed in the second call. 


The named tuple `info` contains information related to the execution of the LR-ADI algorithm as follows:
`info.niter` contains the number of performed iterations; 
`info.res_fact` contains the norm of the residual factor; 
`info.res` contains, if `loginf = true`, the vector of normalized residual norms (normalized with respect to the norm of the initial approximation);
`info.rc` contains, if `loginf = true`, the vector of norms of relative changes in building the solution;
`info.used_shift` contains the vector of used shifts.

The keyword argument `abstol` (default: `abstol = 1e-12`) is the tolerance used for convergence test
on the normalized residuals, while the keyword argument
`reltol` (default: `reltol = 0`) is the tolerance for the relative changes of the solution. 
The keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 100`).
The keyword argument `nshifts` specifies the desired number of shifts to be used in an iteration cycle (default: `nshifts = 6`). 
The keyword argument `shifts` can be used to provide a pre-calculated set of complex conjugated shifts to be used
to start the iterations (default: `shifts = missing`).
With the keyword argument `loginf = true`, the normalized residual values and the norms of increments of the solution
can be saved as outputs in the resulting info structure (default: `loginf = false`). 

The low-rank ADI (LR-ADI) method with enhancements proposed in [1] is implemented, based on MATLAB 
codes of the free software described in [2]. If `cyclic = true`, the cyclic low-rank method of [3] is used, with the
pre-calculated shifts provided in the keyword argument `shifts`. 

_References_

[1] P. Kürschner. Efficient Low-Rank Solution of Large-Scale Matrix Equations. 
    Dissertation, Otto-von-Guericke-Universität, Magdeburg, Germany, 2016. Shaker Verlag,

[2] P. Benner, M. Köhler, and J. Saak. “Matrix Equations, Sparse Solvers: M-M.E.S.S.-2.0.1—
    Philosophy, Features, and Application for (Parametric) Model Order Reduction.” 
    In Model Reduction of Complex Dynamical Systems, Eds. P. Benner et.al., 171:369–92, Springer, 2021.

[3] T. Penzl, A cyclic low-rank Smith method for large sparse Lyapunov equations, 
    SIAM J. Sci. Comput. 21 (4) (1999) 1401–1418.
"""
function plyapci(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling{Bool}}, B::AbstractMatrix; cyclic = false,
                 abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6, loginf = false)    
    n = LinearAlgebra.checksquare(A)
    withE = !(E == I)
    if E == I 
       EE = I
       withE = false
    else
       LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
       EE = E
       withE = true
    end
       
    T2 = promote_type(eltype(A), eltype(EE), eltype(B))
    T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
 
    adjA = isa(A,Adjoint)
    adjE = withE ? isa(E,Adjoint) : false
    adjB= isa(B,Adjoint)

    AA = A; BB = B
 
    nb, mb = size(B)
    nb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))

    eltype(AA) == T2 || (adjA ? AA = convert(Matrix{T2},AA.parent)' : AA = convert(Matrix{T2},AA))
    withE && (eltype(EE) == T2 || (adjE ? EE = convert(Matrix{T2},EE.parent)' : EE = convert(Matrix{T2},EE)))
    eltype(BB) == T2 || (adjB ? BB = convert(Matrix{T2},BB.parent)' : BB = convert(Matrix{T2},BB))
 
    if cyclic 
       ismissing(shifts) && (cyclic = false; @warn "missing cyclic shifts: option cyclic reset to false")
    end
    # Start LR-ADI procedure
 
    used_shifts = zeros(T2,0)
    if iszero(B) 
       info = (niter = 0, res_fact = zero(T2), res = zeros(T2,0), rc = zeros(T2,0), 
               used_shifts = used_shifts)   
       return zeros(T2,n,0), info
    end

    W = Matrix(BB)   
    ncolZ = maxiter * mb
    Z = zeros(T2, n, ncolZ)
    res0 = norm(W' * W)
    res1 = 1
    U = copy(W)
    nrmZ = 0
    
    if ismissing(shifts) 
       p = zeros(0)
       i = 1
       while isempty(p)
             p = projection_shifts(AA, EE, U, AA*U, zeros(T2,0); nshifts)   
             if isempty(p)
                 if i < 5
                    @warn "Could not compute initial projection shifts. Going to retry with random right hand side"
                    U = rand(size(U)...)
                 else
                    error("Could not compute initial projection shifts")
                 end
             end      
             i = i + 1
       end
    else
        p = shifts
        illegal_shifts = false
        # Check if all shifts are in the open left half plane
        # and if complex pairs of shifts are properly ordered.
        kk = 1
        while kk <= length(p)
            if isreal(p[kk]) 
                illegal_shifts = real(p[kk]) >= 0 
            else
                illegal_shifts = p[kk + 1] != conj(p[kk]) || real(p[kk]) >= 0
                kk = kk + 1
            end
            illegal_shifts && error("Improper shift vector detected")
            kk = kk + 1
        end
    end
    lp = length(p)

    if loginf 
       res = zeros(maxiter)  
       rc = zeros(maxiter)
    else
       res = zeros(T2,0) 
       rc = zeros(T2,0)
    end
    psave = complex(zeros(maxiter))
    
    # start iteration
    jZ = 0
    k = 1
    k_shift = 1
    mb2 = 2*mb
    while k < maxiter + 1 
        if k_shift > lp
           # update shifts
           k_shift = 1
           if !cyclic 
              used_shifts = [used_shifts; p]
              first_dropped = length(used_shifts) - nshifts + 1
              last_kept = first_dropped - 1
              if length(used_shifts) > nshifts && 
                 imag(used_shifts[first_dropped]) > 0 && 
                 (abs(used_shifts[first_dropped] - conj(used_shifts[last_kept])) < eps())
                 # don't cut between pair of complex shifts
                 used_shifts = used_shifts[end - nshifts:end]
              elseif length(used_shifts) > nshifts
                 used_shifts = used_shifts[end - nshifts + 1:end]
              end
              len = size(used_shifts, 1) * mb - 1        
              p = projection_shifts(AA, EE, view(Z,:, jZ-len:jZ), W, used_shifts; nshifts)
              lp = length(p)
           end
        end
        isempty(p) && error("empty shift vector computed; the pair (A,E) is possibly unstable")
        # get current shift
        pc = p[k_shift]
        if isreal(pc) 
            pc = real(pc)
        else
            jZ+1 >= ncolZ && break   
        end
        # perform the actual step computations, i. e. shifted solve
        #V = adj ? (A.parent + pc'*(withE ? E.parent : I))'\W : (A + pc*E)\W
        if adjA && adjE
            V = (AA.parent + pc'*EE.parent)'\W 
        else
            V = (AA + pc*EE)\W 
        end

        if isreal(pc) 
            pc2 = 2*pc
            # update the factor
            #Z[:, (m - 1) * k + 1:m * k] = sqrt(-2.0 * pc) * V     
            Z[:, jZ+1:jZ+mb] .= sqrt(-pc2) .* V     
            jZ += mb
            # update low-rank residual
            if withE
                #EV = E*V
                #W = W - 2.0 * pc * EV
                mul!(W,EE,V,-pc2,1)
            else
                #W = W - 2.0 * pc * V
                W .-= pc2 .* V
            end
            psave[k] = pc
        else
            # perform a double step with the known solution for the conjugate shift
            a = 2.0 * sqrt(-real(pc))
            b = real(pc) / imag(pc)
            #V1 = a * (real(V) + b * imag(V))
            Z1 = view(Z,:,jZ+1:jZ+mb)
            Z2 = view(Z,:,jZ+mb+1:jZ+mb2)
            Z1 .= a .* (real.(V) .+ b .* imag.(V))
            g = (a * sqrt(b * b + 1))
            Z2 .=  g .* imag.(V)
            jZ +=mb2
    
            # update low-rank residual for double step
            if withE
                #EV = E*V1
                #W = W + a * EV
                mul!(W,EE,Z1,a,1)
            else
                W .+= a .* Z1
            end
            psave[k] = pc
            psave[k+1] = conj(pc)
    
            k += 1
            k_shift += 1
    
        end
        # evaluate normalized residual
        resm = norm(W' * W) / res0

        # evaluate norm of correction of solution  
        if isreal(pc) 
            k == 1 && (res1 = resm)
            nrmV = 2.0 * abs(pc) * norm(V)^2
        else # complex double step means 2 blocks added
            k < 2 && (res1 = resm)
            nrmV = norm(Z1)^2+norm(Z2)^2
        end
    
        nrmZ = nrmZ + nrmV
        rcm = sqrt(nrmV / nrmZ)
        if loginf 
           if isreal(pc) 
              res[k] = resm; rc[k] = rcm
           else
              res[k] = resm; res[k-1] = resm
              rc[k] = rcm; rc[k-1] = rcm
           end 
        end

        # check convegence conditions
        if (abstol > 0 && resm < abstol) || (reltol > 0 && rcm < reltol) 
           break
        end 
        # checck for possible divergence
        k > 2 && resm > 100*res1 && error("residual is growing: eigenvalues are probably unstable")
        
        k += 1
        k_shift += 1
    end
    
    niter = k - (k > maxiter)
    info = (niter = niter, res_fact = norm(W), 
            res = loginf ? res[1:niter] : zeros(T2,0), 
            rc = loginf ? rc[1:niter] : zeros(T2,0), 
            used_shifts = isreal(psave) ? real(psave[1:niter]) : psave[1:niter])   
    
    if niter >= maxiter
        @warn "LR-ADI reached maximum iteration number. Results may be inaccurate!"
    end
    return Z[:, 1:niter*mb], info
end
function plyapci(A::AbstractMatrix, B::AbstractMatrix; kwargs...)
    plyapci(A::AbstractMatrix, I, B::AbstractMatrix; kwargs...)
end 

function projection_shifts(A, E, V, W, p_old; nshifts = 6)
    # function p = projection_shifts(A, E, V, W, nshifts, p_old) 
    #
    # Computes new shifts by implicitly or explicitly
    # projecting the E and A matrices to the span of V. Note that the
    # width of V must be a multiple of that of of the residual W, V is the newest part
    # of the ADI solution factor Z and the old shift
    # vector p_old passed in must have this multiple as its length.
    #
    # The projection is computed implicitly from the contents of V. 
    #
    # This function is based on the MATLAB function mess_projection_shifts.m, which is
    # part of the M - M.E.S.S. project  (http://www.mpi-magdeburg.mpg.de/projects/mess).
    # Authors: Jens Saak, Martin Koehler, Peter Benner and others.
        
    withE = (E != I)
          
    L = length(p_old)
    cols_V = size(V, 2)
    cols_W = size(W, 2)
    
    if L > 0 && !iszero(p_old)  
        cols_V == L*cols_W || error("V and W have inconsistent no. of columns")
    end
    
    # initialize data
    T1 = eltype(A) 
    if L > 0 && !iszero(p_old)
        T = zeros(T1,L, L)
        K = zeros(T1,1, L)
        D = zeros(T1,0,0)
        Ir = Matrix{T1}(I(cols_W))
        iC = findall(!iszero,imag(p_old))
        iCh = iC[1:2:end]
        iR = findall(iszero,imag(p_old))
        isubdiag = [iR; iCh]
        # process previous shifts
        h = 1   
        while h <= L
            is = isubdiag[isubdiag .< h]
            K[1, h] = 1
            if isreal(p_old[h])  # real shift 
                rpc = real(p_old[h])
                T[h, h] = rpc
                if !isempty(is)
                    T[h, is] = 2 * rpc * ones(1, length(is))
                end
                D = cat(D, sqrt(-2 * rpc), dims=Val((1,2)))
                h = h + 1;
            else # complex conjugated pair of shifts
                rpc = real(p_old[h])
                ipc = imag(p_old[h])
                β = rpc / ipc
                T[h:h + 1, h:h + 1] = [3*rpc -ipc
                                       ipc*(1 + 4 * β^2) -rpc]
                if !isempty(is)
                    T[h:h +  1, is] = [4*rpc; 4*rpc*β] * ones(1, length(is))
                end
                D = cat(D, 2*sqrt(-rpc)*[1  0; β sqrt(1 + β^2)], dims=Val((1,2)))
                h = h + 2;
            end
        end
        S = kron(D \ (T * D), Ir)
        K = kron(K * D, Ir)
    else  # explicit AV 
        S = 0
        K = 1
        !iszero(p_old) && (W = A*V)
    end
    
    # compute projection matrices
    F = eigen(V'*V)
    s = real(F.values)
    v = F.vectors
    r = (s .> eps() * s[end] * cols_V)
    st = v[:,r]*Diagonal(1 ./ s[r].^.5)
    U = V * st
  
    ## Project V and compute Ritz values
    if withE
        E_V = E*V
        G = U' * E_V;
        H = U' * W * K * st + G * (S * st);
        G = G * st;
        p = eigvals(H, G)
    else
        H = U' * (W * K) * st + U' * (V * (S * st))
        p = eigvals(H)
    end
    # permute complex shifts if necessary
    kk = 1
    while kk < length(p)
        if isreal(p[kk]) 
           kk += 1
        else
           if imag(p[kk]) < 0
              p[kk] = conj(p[kk])
              p[kk+1] = conj(p[kk])
           end
           kk += 2
        end
    end
  
    # postprocess new shifts
    
    # remove infinite values
    p = p[isfinite.(p)]
    
    # remove zeros
    p = p[abs.(p) .> 10*eps()]
     
    # make all shifts stable
    p[real.(p) .> 0] = -p[real.(p) .> 0]

    if !isempty(p) 
        # remove small imaginary perturbations
        small_imag = findall(abs.(imag.(p)) ./ abs.(p) .< 1e-12)
        p[small_imag] = real(p[small_imag])
        # sort (s.t. compl. pairs are together)
        #sort!(p; by = v -> (real(v), abs(imag(v))))
        isreal(p) ? sort!(p; by = real) : sort!(p; by = abs)
        # select nshifts 
        length(p) > nshifts && (p = subopt_select(p, nshifts))
    end

    return p
end
function subopt_select(RV, nshifts=length(RV))
    #  Determine for the vector RV of Ritz values and desired number of shifts nshifts, 
    #  nshifts (or occasionally nshifts+1) shift parameters P by selecting suboptimal values of 
    #  the min-max ADI shift parameter problem. 
    # 
    #  This is the function heuristic, borrowed from the DifferentialRiccatiEquations.jl package.
    s(t, P) = prod(abs(t - p) / abs(t + p) for p in P)
    length(RV) >= nshifts || throw(ArgumentError("length(RV) must be at least nshifts = $nshifts "))
    p0 = argmin(RV) do p
        maximum(s(t, (p,)) for t in RV)
    end
    P = isreal(p0) ? [p0] : [p0, conj(p0)]
    while length(P) < nshifts
        p = argmax(RV) do t
            s(t, P)
        end
        if isreal(p)
            push!(P, p)
        else
            append!(P, (p, conj(p)))
        end
    end

    return P
end
"""
    plyapdi(A, E, B; cyclic, abstol, reltol, maxiter, nshifts, shifts, loginf) -> (U, info)
    plyapdi(A, B; cyclic, abstol, reltol, maxiter, nshifts, shifts, loginf) -> (U, info)

Compute a low-rank factor `U` of the solution `X = UU'` of the
generalized discrete Lyapunov equation

      AXA' - EXE' + BB' = 0,

where `A` and `E` are square real matrices and `B` is a real matrix
with the same number of rows as `A`. The pencil `A - λE` must have only
eigenvalues with moduli less than one. `E = I` is assumed in the second call. 


The named tuple `info` contains information related to the execution of the LR-ADI algorithm as follows:
`info.niter` contains the number of performed iterations; 
`info.res_fact` contains the norm of the residual factor; 
`info.res` contains, if `loginf = true`, the vector of normalized residual norms (normalized with respect to the norm of the initial approximation);
`info.rc` contains, if `loginf = true`, the vector of norms of relative changes in building the solution;
`info.used_shift` contains the vector of used shifts.

The keyword argument `abstol` (default: `abstol = 1e-12`) is the tolerance used for convergence test
on the normalized residuals, while the keyword argument
`reltol` (default: `reltol = 0`) is the tolerance for the relative changes of the solution. 
The keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 100`).
The keyword argument `nshifts` specifies the desired number of shifts to be used in an iteration cycle (default: `nshifts = 6`). 
The keyword argument `shifts` can be used to provide a pre-calculated set of complex conjugated shifts to be used
to start the iterations (default: `shifts = missing`).
With the keyword argument `loginf = true`, the normalized residual values and the norms of increments of the solution
can be saved as outputs in the resulting info structure (default: `loginf = false`). 

The low-rank ADI (LR-ADI) method with enhancements proposed in [1] is adapted to the discrete case, 
inspired by the MATLAB codes of the free software described in [2]. If `cyclic = true`, the cyclic low-rank method of [3] is adapted, with the
pre-calculated shifts provided in the keyword argument `shifts`. 

_References_

[1] P. Kürschner. Efficient Low-Rank Solution of Large-Scale Matrix Equations. 
    Dissertation, Otto-von-Guericke-Universität, Magdeburg, Germany, 2016. Shaker Verlag,

[2] P. Benner, M. Köhler, and J. Saak. “Matrix Equations, Sparse Solvers: M-M.E.S.S.-2.0.1—
    Philosophy, Features, and Application for (Parametric) Model Order Reduction.” 
    In Model Reduction of Complex Dynamical Systems, Eds. P. Benner et.al., 171:369–92, Springer, 2021.

[3] T. Penzl, A cyclic low-rank Smith method for large sparse Lyapunov equations, 
    SIAM J. Sci. Comput. 21 (4) (1999) 1401–1418.
"""
function plyapdi(A::AbstractMatrix, E::Union{AbstractMatrix,UniformScaling{Bool}}, B::AbstractMatrix; cyclic = false,
                 abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6, loginf = false)    
    n = LinearAlgebra.checksquare(A)
    withE = !(E == I)
    if E == I 
       EE = I
       withE = false
    else
       LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a $n x $n matrix or I"))
       EE = E
       withE = true
    end
       
    T2 = promote_type(eltype(A), eltype(EE), eltype(B))
    T2 <: BlasFloat  || (T2 = promote_type(Float64,T2))
 
    adjA = isa(A,Adjoint)
    adjE = withE ? isa(E,Adjoint) : false
    adjB= isa(B,Adjoint)

    AA = A; BB = B
 
    nb, mb = size(B)
    nb == n || throw(DimensionMismatch("B must be a matrix of row dimension $n"))

    eltype(AA) == T2 || (adjA ? AA = convert(Matrix{T2},AA.parent)' : AA = convert(Matrix{T2},AA))
    withE && (eltype(EE) == T2 || (adjE ? EE = convert(Matrix{T2},EE.parent)' : EE = convert(Matrix{T2},EE)))
    eltype(BB) == T2 || (adjB ? BB = convert(Matrix{T2},BB.parent)' : BB = convert(Matrix{T2},BB))
 
    if cyclic 
       ismissing(shifts) && (cyclic = false; @warn "missing cyclic shifts: cyclic reset to false")
    end
    # Start LR-ADI procedure
 
    used_shifts = zeros(T2,0)
    if iszero(B) 
       info = (niter = 0, res_fact = zero(T2), res = zeros(T2,0), rc = zeros(T2,0), 
               used_shifts = used_shifts)   
       return zeros(T2,n,0), info
    end

    W = Matrix(BB)   
    ncolZ = maxiter * mb
    Z = zeros(T2, n, ncolZ)
    res0 = norm(W' * W)
    res1 = 1
    U = copy(W)
    nrmZ = 0
    withE && (temp = similar(W))
    
    if ismissing(shifts) 
       p = zeros(0)
       i = 1
       while isempty(p)
             p = projection_shiftsd(AA, EE, U; nshifts)   
             if isempty(p)
                 if i < 5
                    @warn "Could not compute initial projection shifts. Going to retry with random right hand side"
                    U = rand(size(U)...)
                 else
                    error("Could not compute initial projection shifts")
                 end
             end      
             i = i + 1
       end
    else
        p = shifts
        illegal_shifts = false
        # Check if all shifts are in the open left half plane
        # and if complex pairs of shifts are properly ordered.
        kk = 1
        while kk <= length(p)
            if isreal(p[kk]) 
                illegal_shifts = abs(p[kk]) >= 1 
            else
                illegal_shifts = p[kk + 1] != conj(p[kk]) || abs(p[kk]) >= 1
                kk = kk + 1
            end
            illegal_shifts && error("Improper shift vector detected")
            kk = kk + 1
        end
    end
    lp = length(p)

    if loginf 
       res = zeros(maxiter)  
       rc = zeros(maxiter)
    else
       res = zeros(T2,0) 
       rc = zeros(T2,0)
    end
    psave = complex(zeros(maxiter))
    
    # start iteration
    jZ = 0
    k = 1
    k_shift = 1
    mb2 = 2*mb
    while k < maxiter + 1 
        if k_shift > lp
           # update shifts
           k_shift = 1
           if !cyclic 
              used_shifts = [used_shifts; p]
              first_dropped = length(used_shifts) - nshifts + 1
              last_kept = first_dropped - 1
              if length(used_shifts) > nshifts && 
                 imag(used_shifts[first_dropped]) > 0 && 
                 (abs(used_shifts[first_dropped] - conj(used_shifts[last_kept])) < eps())
                 # don't cut between pair of complex shifts
                 used_shifts = used_shifts[end - nshifts:end]
              elseif length(used_shifts) > nshifts
                 used_shifts = used_shifts[end - nshifts + 1:end]
              end
              len = size(used_shifts, 1) * mb - 1        
              p = projection_shiftsd(AA, EE, view(Z,:, jZ-len:jZ); nshifts)
              lp = length(p)
           end
        end
        isempty(p) && error("empty shift vector computed; the pair (A,E) is possibly unstable")
        # get current shift
        pc = p[k_shift]
        if isreal(pc) 
            pc = real(pc)
        else
            jZ+1 >= ncolZ && break   
        end
        # perform the actual step computations, i. e. shifted solve
        #V = adj ? ((withE ? E.parent : I) - conj(pc)*A.parent)'\W : (E -conj(ps)*A)\W
        if adjA && adjE
            V = (EE.parent - pc*AA.parent)'\W 
        else
            V = (EE-conj(pc)*AA)\W 
        end

        α = real(pc); β = imag(pc)  
        if isreal(pc) 
            τ = 1-α^2
            # update the factor
            #Z[:, (m - 1) * k + 1:m * k] = sqrt(τ) * V     
            Z[:, jZ+1:jZ+mb] .= sqrt(τ) .* V     
            jZ += mb
            # update low-rank residual
            if withE
               mul!(W,EE,V,τ/α,-1/α)
            else
               W .= (τ/α) .* V .- (1/α) .* W
            end
            psave[k] = pc
        else
            as2 = α^2+β^2;   τ = 1-as2  
            # perform a double step with the known solution for the conjugate shift
            θ = α/β
            mu = sqrt(τ/(1+as2))  
            Z1 = view(Z,:,jZ+1:jZ+mb)
            Z2 = view(Z,:,jZ+mb+1:jZ+mb2)
            Z1 .= sqrt(1-as2^2) .* real.(V) .+ (θ*mu*(1-as2)) .* imag.(V)
            Z2 .=  (mu*abs(pc^2-1)/β) .* imag.(V)
            jZ +=mb2
    
            # update low-rank residual for double step
            if withE
               temp .= (as2-1/as2).*real.(V) .- (θ*τ^2/as2) .* imag.(V)
               mul!(W,EE,temp,1,1/as2)
            else
                W .= (1/as2) .* W .+ (as2-1/as2).*real.(V) .- (θ*τ^2/as2) .* imag.(V)
            end
            psave[k] = pc
            psave[k+1] = conj(pc)
    
            k += 1
            k_shift += 1
    
        end
        # evaluate normalized residual
        resm = norm(W' * W) / res0

        # evaluate norm of correction of solution  
        if isreal(pc) 
            k == 1 && (res1 = resm)
            nrmV = 2.0 * abs(pc) * norm(V)^2
        else # complex double step means 2 blocks added
            k < 2 && (res1 = resm)
            nrmV = norm(Z1)^2+norm(Z2)^2
        end
    
        nrmZ = nrmZ + nrmV
        rcm = sqrt(nrmV / nrmZ)
        if loginf 
           if isreal(pc) 
              res[k] = resm; rc[k] = rcm
           else
              res[k] = resm; res[k-1] = resm
              rc[k] = rcm; rc[k-1] = rcm
           end 
        end

        # check convegence conditions
        if (abstol > 0 && resm < abstol) || (reltol > 0 && rcm < reltol) 
           break
        end 
        # checck for possible divergence
        k > 2 && resm > 100*res1 && error("residual is growing: eigenvalues are probably unstable")
        
        k += 1
        k_shift += 1
    end
    
    niter = k - (k > maxiter)
    info = (niter = niter, res_fact = norm(W), 
            res = loginf ? res[1:niter] : zeros(T2,0), 
            rc = loginf ? rc[1:niter] : zeros(T2,0), 
            used_shifts = isreal(psave) ? real(psave[1:niter]) : psave[1:niter])   
    
    if niter >= maxiter
        @warn "LR-ADI reached maximum iteration number. Results may be inaccurate!"
    end
    return Z[:, 1:niter*mb], info
end
function plyapdi(A::AbstractMatrix, B::AbstractMatrix; kwargs...)
    plyapdi(A::AbstractMatrix, I, B::AbstractMatrix; kwargs...)
end 

function projection_shiftsd(A, E, V; nshifts = 6)
    # p = projection_shiftsd(A, E, V; nshifts = 6) 
    #
    # Compute up to nshifts new shifts as Ritz values of of the pair (A,E), 
    # by explicitly projecting the E and A matrices to the span of V, where 
    # is the newest part of the ADI solution factor Z.
        
    withE = (E != I)
             
    # compute projection matrices
    F = eigen(V'*V)
    s = real(F.values)
    v = F.vectors
    r = (s .> eps() * s[end] * size(V,2))
    st = v[:,r]*Diagonal(1 ./ s[r].^.5)
    U = V * st
  
    ## Project V and compute Ritz values
    if withE
        p = eigvals(U'*(A*U), U'*(E*U))
    else
        p = eigvals(U'*(A*U))
    end
    # permute complex shifts if necessary
    kk = 1
    while kk < length(p)
        if isreal(p[kk]) 
           kk += 1
        else
           if imag(p[kk]) < 0
              p[kk] = conj(p[kk])
              p[kk+1] = conj(p[kk])
           end
           kk += 2
        end
    end
  
    # postprocess new shifts
    
    # remove infinite values
    p = p[isfinite.(p)]
    
    # remove zeros
    p = p[abs.(p) .> 10*eps()]
     
    # make all shifts stable
    p[abs.(p) .> 1] = 1 ./ p[abs.(p) .> 1]

    if !isempty(p) 
        # remove small imaginary perturbations
        small_imag = findall(abs.(imag.(p)) ./ abs.(p) .< 1e-12)
        p[small_imag] = real(p[small_imag])
        # sort (s.t. compl. pairs are together)
        #sort!(p; by = v -> (real(v), abs(imag(v))))
        isreal(p) ? sort!(p; by = real) : sort!(p; by = abs)
        # select nshifts 
        length(p) > nshifts && (p = subopt_select(p, nshifts))
    end

    return p
end

"""
    lyapdi(A, C; abstol, reltol, maxiter) -> (X,info)

Compute for a square `A` and a hermitian/symmetric `C` a solution `X` of the discrete Lyapunov matrix equation

                AXA' - X + C = 0.

A least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function lyapdi(A::AbstractMatrix, C::AbstractMatrix; abstol = zero(float(real(eltype(A)))), reltol = sqrt(eps(float(real(eltype(A))))), maxiter = 1000) 
    n = LinearAlgebra.checksquare(A)
    LinearAlgebra.checksquare(C) == n ||
        throw(DimensionMismatch("C must be a square matrix of dimension $n"))
    sym = isreal(A) && isreal(C) && issymmetric(C) 
    her = ishermitian(C)
    LT = lyapop(A; disc = true, her = sym)
    if sym 
       xt, info = cgls(LT,-triu2vec(C); abstol, reltol, maxiter)
    else
       xt, info = cgls(LT,-vec(C); abstol, reltol, maxiter)
    end
    info.flag == 1 || @warn "convergence issues: info = $info"
    if sym
       return vec2triu(xt,her = true), info
    else
       Xt = reshape(xt,n,n); 
       return her ? (Xt+Xt')/2 : Xt, info
    end
end
"""
    lyapdi(A, E, C; abstol, reltol, maxiter) -> (X,info)

Compute `X`, the solution of the generalized discrete Lyapunov equation

    AXA' - EXE' + C = 0,

where `A` and `E` are square real or complex matrices and `C` is a square matrix.
A least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function lyapdi(A::AbstractMatrix, E::AbstractMatrix, C::AbstractMatrix; abstol = zero(float(real(eltype(A)))), reltol = sqrt(eps(float(real(eltype(A))))), maxiter = 1000) 
    n = LinearAlgebra.checksquare(A)
    LinearAlgebra.checksquare(C) == n ||
       throw(DimensionMismatch("C must be a square matrix of dimension $n"))
    LinearAlgebra.checksquare(E) == n || throw(DimensionMismatch("E must be a square matrix of dimension $n"))
    sym = isreal(A) && isreal(E) && isreal(C) && issymmetric(C) 
    her = ishermitian(C)
    LT = lyapop(A, E; disc = true, her = sym)
    
    if sym 
       xt, info = cgls(LT,-triu2vec(C); abstol, reltol, maxiter)
    else
       xt, info = cgls(LT,-vec(C); abstol, reltol, maxiter)
    end
    info.flag == 1 || @warn "convergence issues: info = $info"
    if sym
       return vec2triu(xt,her = true), info
    else
       Xt = reshape(xt,n,n); 
       return her ? (Xt+Xt')/2 : Xt, info
    end
end
lyapci(A::AbstractMatrix, E::UniformScaling{Bool}, C::AbstractMatrix; kwargs...) = lyapci(A, C; kwargs...)
lyapdi(A::AbstractMatrix, E::UniformScaling{Bool}, C::AbstractMatrix; kwargs...) = lyapdi(A, C; kwargs...)

"""
    X = sylvci(A,B,C)

Solve the continuous Sylvester matrix equation

                AX + XB = C ,

where `A` and `B` are square matrices. 

A least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function sylvci(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix; abstol = zero(float(real(eltype(A)))), reltol = sqrt(eps(float(real(eltype(A))))), maxiter = 1000) 
    m, n = size(C);
    [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    LT = sylvop(A, B)   
    xt, info = cgls(LT,vec(C); abstol, reltol, maxiter)
    return reshape(xt,m,n), info
end
"""
    X = sylvdi(A,B,C)

Solve the discrete Sylvester matrix equation

                AXB + X = C ,

where `A` and `B` are square matrices. 

A least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 

"""
function sylvdi(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix; abstol = zero(float(real(eltype(A)))), reltol = sqrt(eps(float(real(eltype(A))))), maxiter = 1000) 
    m, n = size(C);
    [m; n] == LinearAlgebra.checksquare(A,B) || throw(DimensionMismatch("A, B and C have incompatible dimensions"))
    LT = sylvop(A, B; disc = true)   
    xt, info = cgls(LT,vec(C); abstol, reltol, maxiter)
    return reshape(xt,m,n), info
end
"""
    X = gsylvi(A,B,C,D,E)

Solve the generalized Sylvester matrix equation

    AXB + CXD = E ,

where `A`, `B`, `C` and `D` are square matrices. 

A least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function gsylvi(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix, E::AbstractMatrix; abstol = zero(float(real(eltype(A)))), reltol = sqrt(eps(float(real(eltype(A))))), maxiter = 1000) 
    m, n = size(E);
    [m; n; m; n] == LinearAlgebra.checksquare(A,B,C,D) ||
        throw(DimensionMismatch("A, B, C, D and E have incompatible dimensions"))
    LT = sylvop(A,B,C,D)
    xt, info = cgls(LT,vec(E); abstol, reltol, maxiter)
    info.flag == 1 || @warn "convergence issues: info = $info"
    return reshape(xt,m,n), info
end


"""
     gtsylvi(A, B, C, D, E; mx, nx, abstol, reltol, maxiter) -> (X,info)

Compute a solution `X` of the generalized T-Sylvester matrix equation

      ∑ A_i*X*B_i + ∑ C_j*transpose(X)*D_j = E, 
      
where `A_i` and `C_j` are matrices having the same row dimension equal to the row dimension of `E` and 
`B_i` and `D_j` are matrices having the same column dimension equal to the column dimension of `E`. 
`A_i` and `B_i` are contained in the `k`-vectors of matrices `A` and `B`, respectively, and 
`C_j` and `D_j` are contained in the `l`-vectors of matrices `C` and `D`, respectively. 
Any of the component matrices can be given as an `UniformScaling`. 
The keyword parameters `mx` and `nx` can be used to specify the row and column dimensions of `X`, 
if they cannot be inferred from the data.

A least-squares solution `X` is determined using a conjugate-gradient based iterative method applied 
to a suitably defined T-Sylvester linear operator `L:X -> Y` such that `L(X) = E` or `norm(L(X) - E)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 

_Note:_ For the derivation of the adjoint equation see reference [1], which also served as motivation to implement a general linear matrix equation solver in Julia.  

[1] Uhlig, F., Xu, A.B. Iterative optimal solutions of linear matrix equations for hyperspectral and multispectral image fusing. Calcolo 60, 26 (2023). 
    [https://doi.org/10.1007/s10092-023-00514-8](https://doi.org/10.1007/s10092-023-00514-8)
"""
function gtsylvi(A::Vector{TA}, B::Vector{TB}, C::Vector{TC}, D::Vector{TD}, E::AbstractArray{T}; mx = -1, nx = -1, abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T,TA,TB,TC,TD}
    LT = gsylvop(A,B,C,D; mx, nx)
    xt, info = cgls(LT,vec(E); abstol, reltol, maxiter)
    info.flag == 1 || @warn "convergence issues: info = $info"
    return reshape(xt,LT.mx,LT.nx), info
end
"""
     ghsylvi(A, B, C, D, E; mx, nx, abstol, reltol, maxiter) -> (X,info)

Compute a solution `X` of the generalized H-Sylvester matrix equation

      ∑ A_i*X*B_i + ∑ C_j*X'*D_j = E, 
      
where `A_i` and `C_j` are matrices having the same row dimension equal to the row dimension of `E` and 
`B_i` and `D_j` are matrices having the same column dimension equal to the column dimension of `E`. 
`A_i` and `B_i` are contained in the `k`-vectors of matrices `A` and `B`, respectively, and 
`C_j` and `D_j` are contained in the `l`-vectors of matrices `C` and `D`, respectively. 
Any of the component matrices can be given as an `UniformScaling`. 
The keyword parameters `mx` and `nx` can be used to specify the row and column dimensions of `X`, 
if they cannot be inferred from the data.

A least-squares solution `X` is determined using a conjugate-gradient based iterative method applied 
to a suitably defined T-Sylvester linear operator `L:X -> Y` such that `L(X) = E` or `norm(L(X) - E)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 

_Note:_ For the derivation of the adjoint equation see reference [1], which also served as motivation to implement a general linear matrix equation solver in Julia.  

[1] Uhlig, F., Xu, A.B. Iterative optimal solutions of linear matrix equations for hyperspectral and multispectral image fusing. Calcolo 60, 26 (2023). 
    [https://doi.org/10.1007/s10092-023-00514-8](https://doi.org/10.1007/s10092-023-00514-8)
"""
function ghsylvi(A::Vector{TA}, B::Vector{TB}, C::Vector{TC}, D::Vector{TD}, E::AbstractArray{T}; mx = -1, nx = -1, abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T,TA,TB,TC,TD}
    LT = gsylvop(A,B,C,D; mx, nx, htype = true)
    xt, info = cgls(LT,vec(E); abstol, reltol, maxiter)
    info.flag == 1 || @warn "convergence issues: info = $info"
    return reshape(xt,LT.mx,LT.nx), info
end
"""
    tlyapci(A, C, isig = +1; adj = false, abstol, reltol, maxiter) -> (X,info)

Compute a solution `X` of the continuous T-Lyapunov matrix equation

                A*X +isig*transpose(X)*transpose(A) = C   if adj = false, 

or

                A*transpose(X) + isig*X*transpose(A) = C   if adj = true,

where for `isig = 1`, `C` is a symmetric matrix and for `isig = -1`, `C` is a skew-symmetric matrix.                     

For a matrix `A`, a least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined T-Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution and 
the keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function tlyapci(A::AbstractMatrix{T}, C::AbstractMatrix{T}, isig::Int = 1; adj = false,  abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T}
    m = LinearAlgebra.checksquare(C)
    ma, n = size(A)
    ma == m || throw(DimensionMismatch("A and C have incompatible dimensions"))
    abs(isig) == 1 || error(" isig must be either 1 or -1")
    if isig == 1
       issymmetric(C) || error("C must be symmetric for isig = 1")
       # temporary fix to avoid false results for DoubleFloats 
       # C == transpose(C) || error("C must be symmetric for isig = 1")
    else
       iszero(C+transpose(C)) || error("C must be skew-symmetric for isig = -1")
    end
    LT = lyaplikeop(A; adj, isig, htype = false)
    xt, info = cgls(LT, vec(C); abstol, reltol, maxiter)
    info.flag == 1 || @warn "convergence issues: info = $info"
    return adj ? reshape(xt,m,n) : reshape(xt,n,m), info
end
"""
    hlyapci(A, C, isig = +1; adj = false, abstol, reltol, maxiter) -> (X,info)


Compute a solution `X` of the continuous H-Lyapunov matrix equation

                A*X + isig*X'*A' = C   if adj = false, 

or

                A*X' + isig*X*A' = C   if adj = true,

where for `isig = 1`, `C` is a hermitian matrix and for `isig = -1`, `C` is a skew-hermitian matrix.                     

For a matrix `A`, a least-squares solution `X` is determined using a conjugate gradient based iterative method applied 
to a suitably defined T-Lyapunov linear operator `L:X -> Y` such that `L(X) = C` or `norm(L(X) - C)` is minimized. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution. 
The keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function hlyapci(A::AbstractMatrix{T}, C::AbstractMatrix{T}, isig::Int = 1; adj = false,  abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T}
    m = LinearAlgebra.checksquare(C)
    ma, n = size(A)
    ma == m || throw(DimensionMismatch("A and C have incompatible dimensions"))
    abs(isig) == 1 || error(" isig must be either 1 or -1")
    if isig == 1
        ishermitian(C) || error("C must be hermitian for isig = 1")
       # temporary fix to avoid false results for DoubleFloats 
       # C == C' || error("C must be hermitian for isig = 1")
    else
       iszero(C+C') || error("C must be skew-hermitian for isig = -1")
    end
    LT = lyaplikeop(A; adj, isig, htype = true)
    xt, info = cgls(LT,vec(C); abstol, reltol, maxiter)
    info.flag == 1 || @warn "convergence issues: info = $info"
    return adj ? reshape(xt,m,n) : reshape(xt,n,m), info
end

"""
    tulyapci(U, Q; adj = false, abstol, reltol, maxiter) -> (X,info)

Compute for an upper triangular `U` and a symmetric `Q` an upper triangular solution `X` of the continuous T-Lyapunov matrix equation

      transpose(U)*X + transpose(X)*U = Q   if adj = false,

or 

      U*transpose(X) + X*transpose(U) = Q   if adj = true. 


For a `n×n` upper triangular matrix `U`, a least-squares upper-triangular solution `X` is determined using a conjugate-gradient based iterative method applied 
to a suitably defined T-Lyapunov linear operator `L:X -> Y`, which maps upper triangular matrices `X`
into upper triangular matrices `Y`, and the associated matrix `M = Matrix(L)` is ``n(n+1)/2 \\times n(n+1)/2``. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution. 
The keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`). 
"""
function tulyapci(U::AbstractMatrix{T}, Q::AbstractMatrix{T}; adj = false,  abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T}
    n = LinearAlgebra.checksquare(U)
    n == LinearAlgebra.checksquare(Q) || throw(DimensionMismatch("U and Q have incompatible dimensions"))
    istriu(U) || throw(ArgumentError("U must be upper triangular"))
    issymmetric(Q) || throw(ArgumentError("Q must be symmetric"))
    LT = tulyaplikeop(U; adj)
    xt, info = cgls(LT,triu2vec(Q); abstol, reltol, maxiter)
    info.flag == 1 || @warn "convergence issues: info = $info"
    return vec2triu(xt), info
end
"""
    hulyapci(U, Q; adj = false, abstol, reltol, maxiter) -> (X,info)

Compute for an upper triangular `U` and a hermitian `Q` an upper triangular solution `X` of the continuous H-Lyapunov matrix equation

                U'*X + X'*U = Q   if adj = false, 

or

                U*X' + X*U' = Q    if adj = true.

For a `n×n` upper triangular matrix `U`, a least-squares upper-triangular solution `X` is determined using a conjugate-gradient based iterative method applied 
to a suitably defined T-Lyapunov linear operator `L:X -> Y`, which maps upper triangular matrices `X`
into upper triangular matrices `Y`, and the associated matrix `M = Matrix(L)` is ``n(n+1)/2 \\times n(n+1)/2``. 
The keyword arguments `abstol` (default: `abstol = 0`) and `reltol` (default: `reltol = sqrt(eps())`) can be used to provide the desired tolerance for the accuracy of the computed solution. 
The keyword argument `maxiter` can be used to set the maximum number of iterations (default: `maxiter = 1000`).  
"""
function hulyapci(U::AbstractMatrix{T}, Q::AbstractMatrix{T}; adj = false,  abstol = zero(float(real(T))), reltol = sqrt(eps(float(real(T)))), maxiter = 1000) where {T}
    n = LinearAlgebra.checksquare(U)
    n == LinearAlgebra.checksquare(Q) || throw(DimensionMismatch("U and Q have incompatible dimensions"))
    istriu(U) || throw(ArgumentError("U must be upper triangular"))
    ishermitian(Q) || throw(ArgumentError("Q must be hermitian"))
    LT = hulyaplikeop(U; adj)
    xt, info = cgls(LT,triu2vec(Q); abstol, reltol, maxiter)
    info.flag == 1 || @warn "convergence issues: info = $info"
    return vec2triu(xt), info
end

"""
     cgls(A, b; shift, abstol, reltol, maxiter, x0) -> (x, info)

Solve `Ax = b` or minimize `norm(Ax-b)` using `CGLS`, the conjugate gradient method for unsymmetric linear equations and least squares problems. 
`A` can be specified either as a rectangular matrix or as a linear operator, as defined in the `LinearMaps` package.  
It is desirable that `eltype(A) == eltype(b)`, otherwise errors may result or additional allocations may occur in operator-vector products. 

The keyword argument `shift` specifies a regularization parameter as `shift = s`. If
`s = 0` (default), then `CGLS` is Hestenes and Stiefel's specialized form of the
conjugate-gradient method for least-squares problems. If `s ≠ 0`, the system `(A'*A + s*I)*b = A'*b` is solved. 

An absolute tolerance `abstol` and a relative tolerance `reltol` can be specified for stopping the iterative process (default: `abstol = 0`, `reltol = 1.e-6`).

The maximum number of iterations can be specified using `maxiter` (default: `maxiter = max(size(A),20)`).

An initial guess for the solution can be specified using the keyword argument vector `x0` (default: `x0 = missing`). 

The resulting named tuple `info` contains `(flag, resNE, iter) `, with convergence related information, as follows: 

     `info.flag`  - convergence flag with values:  
                    1, if convergence occured; 
                    2, if the maximum number of iterations has been reached without convergence;
                    3, if the matrix `A'*A + s*I` seems to be singular or indefinite;
                    4, if instability seems likely meaning `(A'*A + s*I)` indefinite and `norm(x)` decreased;  

     `info.resNE` - the relative residual for the normal equations `norm(A'*b - (A'*A + s*I)*x)/norm(A'*b)`;  
 
     `info.iter`  - the iteration number at which `x` was computed.        

This function is a translation of the MATLAB implementation of `CGLS`, the conjugate gradient method for nonsymmetric linear equations and least squares problems
[`https://web.stanford.edu/group/SOL/software/cgls/`](https://web.stanford.edu/group/SOL/software/cgls/). 
The author of the code is Michael Saunders, with contributions from Per Christian Hansen, Folkert Bleichrodt and Christopher Fougner.    

_Note:_  Two alternative solvers `lsqr` and `lsmr`, available in the [`IterativeSolvers`](https://github.com/JuliaLinearAlgebra/IterativeSolvers.jl) package, can also be employed. 
For example, the following call to `lsqr` can be alternatively used:
        
      using IterativeSolvers
      lsqr(A, b; kwargs...) -> x[, history]

where `kwargs` contains solver-specific keyword arguments. A similar call to  `lsmr` can be used.    
"""
function cgls(A, b; shift = 0, abstol = 0, reltol = 1e-6, maxiter = max(size(A,1),size(A,2),20), x0 = missing ) 
   
    m, n = size(A) 
    length(b) == m || error("Inconsistent problem size")
    T = eltype(A)
    T == eltype(b) || @warn "eltype(A) ≠ eltype(b). This could lead to errors or additional allocations in operator-vector products."
    ismissing(x0) || T == eltype(x0) || @warn "eltype(A) ≠ eltype(x0). This could lead to errors or additional allocations in operator-vector products."
   
 
    if iszero(b)
       return zeros(T,n), (flag = 1, resNE = zero(T), iter = 1)
    end
    T1 = typeof(one(eltype(b))/one(T))
    # allocate vectors 
    x = Vector{T1}(undef,n)
    WS = (Vector{T1}(undef,n),Vector{T1}(undef,n),Vector{T1}(undef,m),Vector{T1}(undef,m))
 
    # the following may fail if eltype(x0) is not a subtype of eltype(x)
    ismissing(x0) ? x .= zero(T1) : x .= x0
    return cgls!(x, WS, A, b; shift, abstol, reltol, maxiter) 
end 
function cgls!(x, WS, A, b; shift = 0, abstol = 0, reltol = 1e-6, maxiter = max(size(A,1),size(A,2),20) ) 
    """
       cgls!(x, WS, A, b; shift, abstol, reltol, maxiter) -> (x, info)

    Solve `Ax = b` or minimize `norm(Ax-b)` using `CGLS`, the conjugate gradient method for unsymmetric linear equations and least squares problems. 
    The initial guess `x`, will be updated in-place. For an `m×n` operator `A`, `WS` is a prealocated working space provided as a tuple of vectors `(p,s,r,q)` of 
    dimensions `(n,n,m,m)`, respectively. See [`cgls`](@ref) for the description of the keyword parameters.  
    """
    T1 = eltype(x)
    # recover allocated vectors 
    (p, s, r, q) = WS 
    adjointA = adjoint(A)
    
    r .= b
    #r = b - A*x
    mul!(r,A,x,-1,1)
 
    #s = A'*r-shift*x
    mul!(s,adjointA,r)
   shift == 0 || axpy!(-shift, x, s)
        
    # Initialize
    p      .= s
    norms0 = norm(s)
    gamma  = norms0^2
    normx  = norm(x)
    xmax   = normx
    k      = 0
    flag   = 0
    
    indefinite = 0
    resNE = 0
    ONE = one(T1)
    
    #--------------------------------------------------------------------------
    # Main loop
    #--------------------------------------------------------------------------
    while (k < maxiter) && (flag == 0)
        k += 1
        
        #q = A*p;
        mul!(q, A, p)
           
        delta = norm(q)^2  +  shift*norm(p)^2
        delta < 0 && (indefinite = 1)
        delta == 0 && (delta = eps(real(float(T1))))
        α = gamma / delta
        
        #x     = x + α*p
        axpy!(α,p,x)
        #r     = r - α*q
        axpy!(-α,q,r)
           
        #s = A'*r - shift*x
        mul!(s,adjointA,r)
        shift == 0 || axpy!(-shift, x, s)
           
        norms  = norm(s)
        gamma1 = gamma
        gamma  = norms^2
        β   = gamma / gamma1
        #p      = s + β*p
        axpby!(ONE,s,β,p)
 
        # Convergence
        normx = norm(x)
        xmax  = max(xmax, normx)
        #flag  = Int((norms <= norms0 * tol) || (normx * tol >= 1))
        flag  = Int((norms <= max(norms0 * reltol, abstol)) || (normx * reltol >= 1))
        
        # Output
        resNE = norms / norms0; 
        #@show k, resNE
        isnan(resNE) && (resNE = zero(norms))
 
    end # while
    
    iter = k;
    
    shrink = normx/xmax;
    if k == maxiter;        flag = 2; end
    if indefinite > 0;      flag = 3; end
    if shrink <= sqrt(reltol); flag = 4; end
    return x, (flag = flag, resNE = resNE, iter = iter)
end
# function cgls(A, b; shift = 0, abstol = 0, reltol = 1e-6, maxiter = max(size(A,1),size(A,2),20), x0 = missing ) 
#     """
#        cgls(A, b; shift, abstol, reltol, maxiter, x0) -> (x, info)

#     Solve `Ax = b` or minimize `norm(Ax-b)` using `CGLS`, the conjugate gradient method for unsymmetric linear equations and least squares problems. 
#     Comment out to obtain the original translation of the MATLAB implementation of `CGLS`.
#     """
   
#     m, n = size(A) 
#     length(b) == m || error("Inconsistent problem size")
#     T = eltype(A)
#     T == eltype(b) || @warn "eltype(A) ≠ eltype(b). This could lead to errors or additional allocations in operator-vector products."
#     ismissing(x0) || T == eltype(x0) || @warn "eltype(A) ≠ eltype(x0). This could lead to errors or additional allocations in operator-vector products."
   
 
#     if iszero(b)
#        return zeros(T,n), (flag = 1, resNE = zero(T), iter = 1)
#     end
#     T1 = typeof(one(eltype(b))/one(T))
#     # allocate vectors 
#     x = Vector{T1}(undef,n)
#     p = Vector{T1}(undef,n)
#     s = Vector{T1}(undef,n)
#     r = Vector{T1}(undef,m)
#     q = Vector{T1}(undef,m)
 
#     # the following may fail if eltype(x0) is not a subtype of eltype(x)
#     ismissing(x0) ? x .= zero(T1) : x .= x0
    
#     r .= b
#     #r = b - A*x
#     mul!(r,A,x,-1,1)
 
#     #s = A'*r-shift*x
#     mul!(s,A',r)
#     shift == 0 || axpy!(-shift, x, s)
        
#     # Initialize
#     p      .= s
#     norms0 = norm(s)
#     gamma  = norms0^2
#     normx  = norm(x)
#     xmax   = normx
#     k      = 0
#     flag   = 0
    
#     indefinite = 0
#     resNE = 0
#     ONE = one(T1)
    
#     #--------------------------------------------------------------------------
#     # Main loop
#     #--------------------------------------------------------------------------
#     while (k < maxiter) && (flag == 0)
        
#         k += 1
        
#         #q = A*p;
#         mul!(q, A, p)
           
#         delta = norm(q)^2  +  shift*norm(p)^2
#         delta < 0 && (indefinite = 1)
#         delta == 0 && (delta = eps(real(float(T1))))
#         alpha = gamma / delta
        
#         #x     = x + alpha*p
#         axpy!(alpha,p,x)
#         #r     = r - alpha*q
#         axpy!(-alpha,q,r)
           
#         #s = A'*r - shift*x
#         mul!(s,A',r)
#         shift == 0 || axpy!(-shift, x, s)
           
#         norms  = norm(s)
#         gamma1 = gamma
#         gamma  = norms^2
#         beta   = gamma / gamma1
#         #p      = s + beta*p
#         axpby!(ONE,s,beta,p)
 
#         # Convergence
#         normx = norm(x)
#         xmax  = max(xmax, normx)
#         #flag  = Int((norms <= norms0 * tol) || (normx * tol >= 1))
#         flag  = Int((norms <= max(norms0 * reltol, abstol)) || (normx * reltol >= 1))
        
#         # Output
#         resNE = norms / norms0; 
#         isnan(resNE) && (resNE = zero(norms))
 
#     end # while
    
#     iter = k;
    
#     shrink = normx/xmax;
#     if k == maxiter;        flag = 2; end
#     if indefinite > 0;      flag = 3; end
#     if shrink <= sqrt(reltol); flag = 4; end
#     return x, (flag = flag, resNE = resNE, iter = iter)
# end

module Test_iterative

using LinearAlgebra
using MatrixEquations
using GenericSchur
using GenericLinearAlgebra
using Test
using SparseArrays
using IterativeSolvers
using BandedMatrices
using LinearMaps
using JLD2
using KrylovKit



@testset "LR-ADI iterative solvers" begin

# discrete case    
n = 300; r = 5; B = [rand(r,2);zeros(n-r,2)]; C = [zeros(3,n-r) rand(3,r)];
A = triu(rand(n,n)); E = triu(rand(n,n));
while maximum(abs.(eigvals(A,E))) >= 1   
    AA = triu(rand(n,n)); E = triu(rand(n,n)); A = AA/n 
end  

@time Z, info = plyapdi(A, E, B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A*Z*Z'*A'-E*Z*Z'*E'+B*B') < 1.e-7 && rank(Z) == r
@time Z, info = plyapdi(A', E', C'; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A'*Z*Z'*A-E'*Z*Z'*E+C'*C) < 1.e-7 && rank(Z) == r

A1 = [-0.01 -200; 200 0.001]
A2 = [-0.2 -300; 300 -0.1]
A3 = [-0.02 -500; 500 0]
A4 = [-0.01 -520; 520 -0.01]
A = cat(A1, A2, A3, A4, Diagonal(-1:-1:-400), dims=Val((1,2)))/600;
B = ones(408,1); C = ones(1,408);

@time Z, info = plyapdi(A, B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = [-0.0016; -0.0033], cyclic = true, nshifts = 6)    
@test norm(A*Z*Z'*A'-Z*Z'+B*B') < 1.e-7 
@time Y, info = plyapdi(A', C'; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = info.used_shifts, nshifts = 6)    
@test norm(A'*Y*Y'*A-Y*Y'+C'*C) < 1.e-7 

# using automatic shift generation
@time Z, info = plyapdi(A, B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A*Z*Z'*A'-Z*Z'+B*B') < 1.e-7 
@time Z, info = plyapdi(A', C'; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A'*Z*Z'*A-Z*Z'+C'*C) < 1.e-7 

Ts = 100;
A1 = exp([-0.01 -200; 200 0.001]*Ts)
A2 = exp([-0.2 -300; 300 -0.1]*Ts)
A3 = exp([-0.02 -500; 500 0]*Ts)
A4 = exp([-0.01 -520; 520 -0.01]*Ts)
A = cat(A1, A2, A3, A4, Diagonal(exp.((-1:-1:-400).*Ts)), dims=Val((1,2)));
B = ones(408,1); C = ones(1,408);

@time Z, info = plyapdi(A, B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A*Z*Z'*A'-Z*Z'+B*B') < 1.e-7 
@time Y, info = plyapdi(A', C'; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A'*Y*Y'*A-Y*Y'+C'*C) < 1.e-7 


cd(joinpath(pkgdir(MatrixEquations),"test"))
A, E, B, C, D = load("mirror315.jld2","A","E","B","C","D");
@time Z, info = MatrixEquations.plyapdi(A, E, B; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = missing, nshifts = 6); 
@time Y, info = MatrixEquations.plyapdi(A', E', C'; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = info.used_shifts, nshifts = 6); 
@test norm(A*Z*Z'*A'-E*Z*Z'*E'+B*B') < 1.e-7 && norm(A'*Y*Y'*A-E'*Y*Y'*E+C'*C) < 1.e-7
nr = rank(Y'*Z);
println("Reduced model order = $nr")

n = 50000; A = BandedMatrix(1 => 0.49*ones(n-1),-1 => -0.49*ones(n-1)); B = [I;zeros(n-2,2)];
@time Z, info = plyapdi(A, B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6);
@test info.res_fact < 1.e-6 

# continuous case    
n = 30; r = 5; B = [rand(r,2);zeros(n-r,2)]; C = [zeros(3,n-r) rand(3,r)];
A = triu(rand(n,n)); E = triu(rand(n,n));
while maximum(real(eigvals(A,E))) >= 0   
    AA = triu(rand(n,n)); E = triu(rand(n,n)); A = E*AA-n*E; 
end  

@time Z, info = plyapci(A, E, B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A*Z*Z'*E'+E*Z*Z'*A'+B*B') < 1.e-7
@time Z, info = plyapci(A', E', C'; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A'*Z*Z'*E+E'*Z*Z'*A+C'*C) < 1.e-7

@time Z, info = plyapci(UpperTriangular(A), UpperTriangular(E), B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A*Z*Z'*E'+E*Z*Z'*A'+B*B') < 1.e-7
@time Z, info = plyapci(UpperTriangular(A)', UpperTriangular(E)', C'; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(A'*Z*Z'*E+E'*Z*Z'*A+C'*C) < 1.e-7

Ad = Diagonal(A); Ed = Diagonal(E);
@time Z, info = plyapci(Ad, Ed, B; abstol = 1e-12, reltol = 0, maxiter = 100, shifts = missing, nshifts = 6)    
@test norm(Ad*Z*Z'*Ed'+Ed*Z*Z'*Ad'+B*B') < 1.e-7

@time Z, info = plyapci(Ad, Ed, B; cyclic = true, abstol = 1e-12, reltol = 0, maxiter = 100, shifts = info.used_shifts[1])    
@test norm(Ad*Z*Z'*Ed'+Ed*Z*Z'*Ad'+B*B') < 1.e-7

A1 = [-0.01 -200; 200 0.001]
A2 = [-0.2 -300; 300 -0.1]
A3 = [-0.02 -500; 500 0]
A4 = [-0.01 -520; 520 -0.01]
A = cat(A1, A2, A3, A4, Diagonal(-1:-1:-400), dims=Val((1,2)));
B = ones(408,1); C = ones(1,408);
@time Z, info = MatrixEquations.plyapci(A, B; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = missing, nshifts = 6); 
@time Y, info = MatrixEquations.plyapci(A', C'; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = info.used_shifts, nshifts = 6); 
@test norm(A*Z*Z'+Z*Z'*A'+B*B') < 1.e-7 && norm(A'*Y*Y'+Y*Y'*A+C'*C) < 1.e-7
nr = rank(Y'*Z);
println("Reduced model order = $nr")

As = sparse(A);
@time Zs, infos = MatrixEquations.plyapci(As, B; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = missing, nshifts = 6); 
@time Ys, infos = MatrixEquations.plyapci(As', C'; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = info.used_shifts, nshifts = 6); 
@test norm(As*Zs*Zs'+Zs*Zs'*As'+B*B') < 1.e-7 && norm(As'*Ys*Ys'+Ys*Ys'*As+C'*C) < 1.e-7
nrs = rank(Ys'*Zs);
println("Reduced model order = $nrs")

@test norm(Z*Z'-Zs*Zs') < 1.e-10 && nr == nrs

Ab = BandedMatrix(As)
@time Zb, infob = MatrixEquations.plyapci(Ab, B; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = missing, nshifts = 6); 
@time Yb, infob = MatrixEquations.plyapci(Ab', C'; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = info.used_shifts, nshifts = 6); 

@test norm(Ab*Zb*Zb'+Zb*Zb'*Ab'+B*B') < 1.e-7 && norm(Ab'*Yb*Yb'+Yb*Yb'*Ab+C'*C) < 1.e-7
nrb = rank(Yb'*Zb);
println("Reduced model order = $nrb")

@test norm(Z*Z'-Zb*Zb') < 1.e-10 && nr == nrb


A, E, B, C, D = load("mirror315.jld2","A","E","B","C","D");
A1 = A-0.0001*E; 
@time Z, info = MatrixEquations.plyapci(A1, E, B; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = missing, nshifts = 6); 
@time Y, info = MatrixEquations.plyapci(A1', E', C'; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = info.used_shifts, nshifts = 6); 
@test norm(A1*Z*Z'*E'+E*Z*Z'*A1'+B*B') < 1.e-7 && norm(A1'*Y*Y'*E+E'*Y*Y'*A1+C'*C) < 1.e-7
nr = rank(Y'*Z);
println("Reduced model order = $nr")

As = sparse(A1); Es  = sparse(E); 
@time Zs, infos = MatrixEquations.plyapci(As, Es, B; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = missing, nshifts = 6); 
@time Ys, infos = MatrixEquations.plyapci(As', Es', C'; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = infos.used_shifts, nshifts = 6); 
@test norm(As*Zs*Zs'*Es'+Es*Zs*Zs'*As'+B*B') < 1.e-7 && norm(As'*Ys*Ys'*Es+Es'*Ys*Ys'*As+C'*C) < 1.e-7
nrs = rank(Ys'*Zs);
println("Reduced model order = $nrs")

@test norm(Z*Z'-Zs*Zs') < 1.e-10 && nr == nrs

Ab = BandedMatrix(As); Eb = BandedMatrix(Es);
@time Zb, infos = MatrixEquations.plyapci(Ab, Eb, B; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = missing, nshifts = 6); 
@time Yb, infos = MatrixEquations.plyapci(Ab', Eb', C'; abstol = 1e-12, reltol = 0.e-5, 
          maxiter = 100, shifts = infos.used_shifts, nshifts = 6); 
@test norm(Ab*Zb*Zb'*Eb'+Eb*Zb*Zb'*Ab'+B*B') < 1.e-7 && norm(Ab'*Yb*Yb'*Eb+Eb'*Yb*Yb'*Ab+C'*C) < 1.e-7
nrb = rank(Yb'*Zb);
println("Reduced model order = $nrb")
@test norm(Z*Z'-Zb*Zb') < 1.e-10 && nr == nrb

end

@testset "General iterative solvers" begin
    n = 10
    T = ComplexF32
    @testset "Matrix{$T}" for T in (Float64, ComplexF64, BigFloat)
        A = rand(T, n, n)
        #A = A' * A + I
        b = rand(T, n)
        reltol = √eps(real(T))/10

        @time x, info = cgls(A, b; reltol=reltol, maxiter=2n);
        @test norm(A*x - b) / norm(b) ≤ 10*reltol
        @test info.flag == 1

        # If you start from the exact solution, you should converge immediately
        x, info = cgls(A, b; x0 = A \ b, abstol=n*n*eps(real(T)), reltol)
        (info.flag == 1 && info.iter <= 2) || (@show info)
        @test info.flag == 1 # && info.iter <= 2

        # All-zeros rhs should give all-zeros lhs
        x0 = cgls(A, zeros(T, n))[1]
        @test x0 == zeros(T, n)
    end

    @testset "T/H-Lyapunov with upper triangular singular U"  begin   
        n = 5
        Ty = Float64
        reltol = 1.e-7
        # real case
        U = triu(rand(Ty,n,n)); U[1,1] = 0; U[n,n] = 0; #U[7,7] = 0
        X0 = triu(rand(Ty,n,n)); X0[1,1] = 0; X0[n,n] = 0
        Q = Matrix(Symmetric(transpose(U)*X0 + transpose(X0)*U))
      
        X, info = tulyapci(U, Q, adj = false, reltol=1.e-14, maxiter=1000); 
        @test norm(transpose(U)*X + transpose(X)*U - Q)/norm(X) < reltol 

           
        Q = Matrix(Symmetric(U*transpose(X0) + X0*transpose(U)))
     
        X, info = tulyapci(U,Q,adj = true, reltol=1.e-14,maxiter=1000); 
        @test norm(U*transpose(X) + X*transpose(U)- Q)/norm(X) < reltol 
    

        # complex case
        U = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); U[1,1] = 0; U[n,n] = 0; 
        X0 = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); X0[1,1] = 0; X0[n,n] = 0
        Q = Matrix(Symmetric(transpose(U)*X0 + transpose(X0)*U))
        X, info = tulyapci(U, Q, adj = false, reltol=1.e-14, maxiter=1000); 
        @test norm(transpose(U)*X + transpose(X)*U - Q)/norm(X) < reltol 
    
        Q = Matrix(Symmetric(U*transpose(X0) + X0*transpose(U)))
     
        X, info = tulyapci(U,Q,adj = true, reltol=1.e-14,maxiter=1000); 
        @test norm(U*transpose(X) + X*transpose(U)- Q)/norm(X) < reltol 
    
    
        # complex hermitian case
        U = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); U[1,1] = 0; U[n,n] = 0; 
        X0 = triu(rand(Ty,n,n)+im*rand(Ty,n,n)); X0[1,1] = 0; X0[n,n] = 0
        Q = Matrix(Hermitian(U'*X0 + X0'*U))
        @time X, info = hulyapci(U, Q; adj = false)  
        @test norm(U'*X + X'*U - Q)/norm(X) < 10*reltol 
    
        Q = Matrix(Hermitian(U*X0' + X0*U'))
        @time X, info = hulyapci(U, Q; adj = true, reltol = 1.e-14)  
        @test norm(U*X' + X*U'- Q)/norm(X) < reltol 
    end

    @testset "T/H-Lyapunov"  begin   
        m = 3; n = 5
        Ty = Float64
        reltol = 1.e-7
        @testset "Matrix{$T}" for T in (Float64, BigFloat)
            # T-Lyapunov
            # real case
            A = rand(Ty,m,n);
            X0 = rand(Ty,n,m);
            C = Matrix(Symmetric(A*X0 + transpose(X0)*transpose(A)))
            @time X, info = tlyapci(A, C, adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X + transpose(X)*transpose(A) - C)/norm(X) < reltol 

            Y = A*X0; C = Y - transpose(Y);
            @time X, info = tlyapci(A, C, -1; adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X - transpose(X)*transpose(A) - C)/norm(X) < reltol 


            X0 = rand(Ty,m,n);
            C = Matrix(Symmetric(A*transpose(X0)+X0*transpose(A)))
            @time X, info = tlyapci(A, C, adj = true, reltol=1.e-14, maxiter=1000); 
            @test norm(A*transpose(X)+X*transpose(A) - C)/norm(X) < reltol 

            Y = A*transpose(X0); C = Y - transpose(Y);
            @time X, info = tlyapci(A, C, -1; adj = true, reltol=1.e-14, maxiter=1000); 
            @test norm(A*transpose(X)-X*transpose(A) - C)/norm(X) < reltol 


            # complex case
            A = rand(Ty,m,n)+im*rand(Ty,m,n); 
            X0 =rand(Ty,n,m)+im*rand(Ty,n,m); 
            C = Matrix(Symmetric(A*X0 + transpose(X0)*transpose(A)))
            @time X, info = tlyapci(A, C, adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X + transpose(X)*transpose(A) - C)/norm(X) < reltol 

            Y = A*X0; C = Y - transpose(Y);
            @time X, info = tlyapci(A, C, -1; adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X - transpose(X)*transpose(A) - C)/norm(X) < reltol 


            X0 =rand(Ty,m,n)+im*rand(Ty,m,n); 
            C = Matrix(Symmetric(A*transpose(X0)+X0*transpose(A)))
            @time X, info = tlyapci(A, C, adj = true, reltol=1.e-14, maxiter=1000); 
            @test norm(A*transpose(X)+X*transpose(A) - C)/norm(X) < reltol 

            Y = A*transpose(X0); C = Y - transpose(Y);
            @time X, info = tlyapci(A, C, -1; adj = true, reltol=1.e-14, maxiter=1000); 
            @test norm(A*transpose(X)-X*transpose(A) - C)/norm(X) < reltol 


            # H-Lyapunov
            # real case
            A = rand(Ty,m,n);
            X0 = rand(Ty,n,m);
            C = Matrix(Hermitian(A*X0 + X0'*A'))
            @time X, info = hlyapci(A, C, adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X +X'*A' - C)/norm(X) < reltol 

            Y = A*X0; C = Y - Y';
            @time X, info = hlyapci(A, C, -1; adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X - X'*A' - C)/norm(X) < reltol 

            X0 = rand(Ty,m,n);
            C = Matrix(Hermitian(A*X0'+X0*A'))
            @time X, info = hlyapci(A, C, adj = true, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X'+X*A' - C)/norm(X) < reltol 

            Y = A*X0';  C = Y - Y';
            @time X, info = hlyapci(A, C, -1; adj = true, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X'-X*A' - C)/norm(X) < reltol 


            # complex case
            A = rand(Ty,m,n)+im*rand(Ty,m,n); 
            X0 =rand(Ty,n,m)+im*rand(Ty,n,m); 
            C = Matrix(Hermitian(A*X0 + X0'*A'))
            @time X, info = hlyapci(A, C, adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X +X'*A' - C)/norm(X) < reltol 

            Y = A*X0; C = Y - Y';
            @time X, info = hlyapci(A, C, -1; adj = false, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X - X'*A' - C)/norm(X) < reltol 


            X0 = rand(Ty,m,n)+im*rand(Ty,m,n); 
            C = Matrix(Hermitian(A*X0'+X0*A'))
            @time X, info = hlyapci(A, C, adj = true, reltol=1.e-14, maxiter=1000); 
            @test  norm(A*X'+X*A' - C)/norm(X) < reltol 

            Y = A*X0';  C = Y - Y';
            @time X, info = hlyapci(A, C, -1; adj = true, reltol=1.e-14, maxiter=1000); 
            @test norm(A*X'-X*A' - C)/norm(X) < reltol 

        end
    end

    @testset "Generalized T/H-Sylvester"  begin   
        a = [rand(2,3)]; b = [I];  c = [I]; d = [a[1]'];
        L = gsylvop(a,b,c,d;nx=2)
        L1 = lyaplikeop(a[1])
        @test Matrix(L) == Matrix(L1)
        @test Matrix(L') == Matrix(L1')

        m = 3; n = 5; mx = 2; nx = 4; la = 2; lc = 1
        Ty = Float64
        reltol = 1.e-6
        A = [rand(Ty,m,mx) for i in 1:la]
        B = [rand(Ty,nx,n) for i in 1:la]
        C = [rand(Ty,m,nx) for i in 1:la]
        D = [rand(Ty,mx,n) for i in 1:la]
        L = gsylvop(A,B,C,D)
        X0 = rand(Ty,mx,nx);
        # solve with cgls for an exact solution
        e = L*vec(X0);
        @time x, info = cgls(L, e; reltol = 1.e-7);
        @test info.flag == 1 && norm(L*x-e)/norm(x) < reltol
        # solve with cgls for a least-squares solution
        b = rand(m*n); 
        @time x, info = cgls(L, b; reltol = 1.e-7);
        @test info.flag == 1
        # solve with cgls for an underdetermine solution
        b = rand(mx*nx); 
        @time x, info = cgls(L', b; reltol = 1.e-7);
        @test info.flag == 1 && norm(L'*x-b)/norm(x) < reltol

        # solve with lsqr from IterativeSolvers.jl
        @time x1 = lsqr(L, e);
        @test norm(L*x1-e)/norm(x1) < reltol
        # solve with lsmr from IterativeSolvers.jl
        @time x2 = lsmr(L, e);
        @test norm(L*x2-e)/norm(x2) < reltol

        m = 3; n = 5; mx = 2; nx = 4; la = 2; lc = 1
        Ty = Float64
        reltol = 1.e-7
        @testset "Matrix{$Ty}" for Ty in (Float64, BigFloat)
            reltol = √eps(real(Ty))
            # real data
            A = [rand(Ty,m,mx) for i in 1:la]
            B = [rand(Ty,nx,n) for i in 1:la]
            C = [rand(Ty,m,nx) for i in 1:la]
            D = [rand(Ty,mx,n) for i in 1:la]
            L = gsylvop(A,B,C,D)
            X0 = rand(Ty,mx,nx);
            # solve with cgls for an exact solution
            E = reshape(L*vec(X0),m,n);
            X, info = gtsylvi(A,B,C,D,E; reltol = reltol/10)
            @test norm(L*vec(X)-vec(E))/norm(X) < 10*reltol        
   
            # complex data
            A = [rand(Ty,m,mx)+im*rand(Ty,m,mx) for i in 1:la]
            B = [rand(Ty,nx,n)+im*rand(Ty,nx,n) for i in 1:la]
            C = [rand(Ty,m,nx)+im*rand(Ty,m,nx) for i in 1:la]
            D = [rand(Ty,mx,n)+im*rand(Ty,mx,n) for i in 1:la]
            X0 = rand(Ty,mx,nx)+im*rand(Ty,mx,nx);
            # solve for Ttype with cgls for an exact solution
            L = gsylvop(A,B,C,D)
            E = reshape(L*vec(X0),m,n);
            X, info = gtsylvi(A,B,C,D,E; reltol = reltol/10)
            @test norm(L*vec(X)-vec(E))/norm(X) < 10*reltol       
            # solve for Htype with cgls for an exact solution
            LH = gsylvop(A,B,C,D; htype = true) 
            E = reshape(LH*vec(X0),m,n);
            X, info = ghsylvi(A,B,C,D,E; reltol = reltol/10)
            @test norm(LH*vec(X)-vec(E))/norm(X) < 10*reltol       
        end
    end

    # Example from https://discourse.julialang.org/t/solve-linear-system-under-hermitian-constraint/130158/9
    m, n = 1000, 123 
    A = randn(ComplexF64, m,n); B = hermitianpart!(randn(ComplexF64,m,m)) * A;
    @time X, info = ghsylvi([I],[A'*A],[A],[A],B,reltol=1.e-14);
    @test norm(X*A'*A+A*X'*A-B) < 1.e-7

    # the same with KrylovKit
    @time λ, = linsolve(y -> let Y = reshape(y,m,n); vec(A*(Y'*A)+Y*(A'*A)); end, vec(B));
    X1 = reshape(λ, m, n)
    @test norm(X-X1) < 1.e-7

    # the same with lyapc
    @time X2 = lyapc(A*A', hermitianpart!(-(A*B'+B*A')));
    @test norm(X2*A-B)/norm(X2) < 1.e-7

    # the same with lyapci
    @time X3, = lyapci(A*A', hermitianpart!(-(A*B'+B*A')),reltol=1.e-10);
    @test norm(X3*A-B)/norm(X3) < 1.e-7

    m, n = 1000, 123 
    A = randn(m,n); B = hermitianpart!(randn(m,m)) * A;
    @time X, info = gtsylvi([I],[A'*A],[A],[A],B,reltol=1.e-14);
    @test norm(X*A'*A+A*X'*A-B) < 1.e-7

    # the same with KrylovKit
    @time λ, = linsolve(y -> let Y = reshape(y,m,n); vec(A*(Y'*A)+Y*(A'*A)); end, vec(B));
    X1 = reshape(λ, m, n)
    @test norm(X-X1) < 1.e-7

    try
       @time X2 = lyapc(A*A', hermitianpart!(-(A*B'+B*A')));
       @test norm(X2*A-B)/norm(X2) < 1.e-7
    catch
       @test true
    end

    # the same with lyapci
    @time X3, = lyapci(A*A', hermitianpart!(-(A*B'+B*A')),reltol=1.e-10);
    @test norm(X3*A-B)/norm(X3) < 1.e-7

    A1 = A*A'; C = Matrix(hermitianpart!(-(A*B'+B*A')))
    @time λ, = linsolve(y -> let Y = reshape(y,m,m); vec(A1*Y+Y*A1'); end, -vec(C));
    X1 = reshape(λ, m, m);
    @test norm(X1*A-B)/norm(X1) < 1.e-7



    A = [I,Matrix(rand(4,4))]
    B = [I, Matrix(rand(4,4))]
    C = [I,Matrix(rand(4,4))] 
    D = [I,Matrix(rand(4,4))] 
    E = rand(4,4); 
    L = gsylvop(A,B,C,D)
    @time X, info = gtsylvi(A,B,C,D,E; reltol = 1.e-8);
    @test norm(L*vec(X)-vec(E))/norm(X)  < 1.e-4     


    m = 3; n = 5; mx = 2; nx = 4; la = 2; lc = 1
    Ty = Float64
    reltol = √eps(real(Ty))
    # sparse real data
    A = [sprand(Ty,m,mx,0.5) for i in 1:la]
    B = [sprand(Ty,nx,n,0.5) for i in 1:la]
    C = [sprand(Ty,m,nx,0.5) for i in 1:la]
    D = [sprand(Ty,mx,n,0.5) for i in 1:la]
    L = gsylvop(A,B,C,D)
    X0 = sprand(Ty,mx,nx,0.4);
    iszero(X0) && (X0[1,1] = one(Ty))
    # solve with cgls for an exact solution
    E = reshape(L*vec(X0),m,n);
    X, info = gtsylvi(A,B,C,D,E; reltol = reltol/10)
    @test norm(L*vec(X)-vec(E))/norm(X) < 10*reltol        

    # solve AX+XD = E for sparse matrices
    mx = 4; nx = 400;
    As = [sprand(Ty,mx,mx,0.9),I]; Bs = [I,sprand(Ty,nx,nx,0.05)];
    Cs = []; Ds = [];
    Ls = gsylvop(As,Bs,Cs,Ds)
    X0 = sprand(Ty,mx,nx,0.4);
    iszero(X0) && (X0[1,1] = one(Ty))
    Es = reshape(Ls*vec(X0),mx,nx);
    @time Xs, infos = gtsylvi(As,Bs,Cs,Ds,Es; reltol = 1.e-8, maxiter = 2000);
    @test norm(Ls*vec(Xs)-vec(Es))/norm(Xs) < 1.e-3 

    A = [Matrix(As[1]),I]
    B = [I, Matrix(Bs[2])]
    C = Cs; D = Ds; E = Matrix(Es); 
    L = gsylvop(A,B,C,D)
    @time X, info = gtsylvi(A,B,C,D,E; reltol = 1.e-8, maxiter = 5000);
    @test norm(L*vec(X)-vec(E))/norm(X)  < 1.e-3   
      
    
    n = 5; m = 4;
    Ty = Float64
    Ty = ComplexF64
    Ty = BigFloat
    @testset "Matrix{$Ty}" for Ty in (Float64, ComplexF64, BigFloat, Complex{BigFloat})
        reltol = √eps(real(Ty))
        A = rand(Ty,n,n); E = rand(Ty,n,n);  
        Q = rand(Ty,n,n); C = Hermitian(Q);           
        # Lyapunov equation, Hermitian case
        @time X, info = lyapci(A, C)
        @test norm(A*X+X*A'+C)/norm(X)  < 1.e-4   && ishermitian(X)
        @time X1 = reshape(linsolve(y -> let Y = reshape(y,n,n); vec(A*Y+Y*A'); end, -vec(C))[1],n,n);
        @test norm(A*X1+X1*A'+C)/norm(X1)  < 1.e-4   
        @time X, info = lyapdi(A, C) 
        @test norm(A*X*A' -X+C)/norm(X)  < 1.e-4   && ishermitian(X)
       
        # Lyapunov equation, non-Hermitian case
        @time X, info = lyapci(A, Q)
        @test norm(A*X+X*A'+Q)/norm(X)  < 1.e-4   
        @time X, info = lyapdi(A, Q)
        @test norm(A*X*A' -X+Q)/norm(X)  < 1.e-4   

        # generalized Lyapunov equation, Hermitian case
        @time X, info = lyapci(A, E, C)
        @test norm(A*X*E'+E*X*A'+C)/norm(X)  < 1.e-4   && ishermitian(X)
        @time X, info = lyapdi(A, E, C) 
        @test norm(A*X*A' -E*X*E'+C)/norm(X)  < 1.e-4   && ishermitian(X)
       
         # generalized Lyapunov equation, non-Hermitian case
        @time X, info = lyapci(A, E, Q)
        @test norm(A*X*E'+E*X*A'+Q)/norm(X)  < 1.e-4   
        @time X, info = lyapdi(A, E, Q)
        @test norm(A*X*A' - E*X*E'+Q)/norm(X)  < 1.e-4   

        #  Sylvester equation
        B = rand(Ty,m,m); W = rand(Ty,n,m)
        @time X, info = sylvci(A, B, W)
        @test norm(A*X+X*B-W)/norm(X)  < 1.e-4   
        @time X, info = sylvdi(A, B, W)
        @test norm(A*X*B+X-W)/norm(X)  < 1.e-4   
    
        #  generalized Sylvester equation
        C = rand(Ty,n,n); D = rand(Ty,m,m)
        @time X, info = gsylvi(A, B, C, D, W)
        @test norm(A*X*B+C*X*D-W)/norm(X)  < 1.e-4   
        @time X, info = gsylvi(A, B', C', D, W)
        @test norm(A*X*B'+C'*X*D-W)/norm(X)  < 1.e-4   
    end
 
end


end

module Test_sylvkr

using LinearAlgebra
using MatrixEquations
using GenericLinearAlgebra
using Test

println("Test_sylvkr")


@testset "Testing Sylvester equation solvers based on Kronecker expansions" begin

n = 5; m = 3;

for Ty in (Float64, BigFloat)

ar = rand(Ty,n,n)
br = rand(Ty,m,m)
cr = rand(Ty,n,m)
art = rand(Ty,m,n)
brt = rand(Ty,n,m)
crt = rand(Ty,m,m)
crt1 = rand(Ty,m,n)
dr = rand(Ty,n,n)
er = rand(Ty,m,m)
fr = rand(Ty,n,m)
ac = ar+im*rand(Ty,n,n)
bc = br+im*rand(Ty,m,m)
cc = cr+im*rand(Ty,n,m)
act = art+im*rand(Ty,m,n)
bct = brt+im*rand(Ty,n,m)
cct = crt+im*rand(Ty,m,m)
cct1 = crt1+im*rand(Ty,m,n)
dc = dr+im*rand(Ty,n,n)
ec = er+im*rand(Ty,m,m)
fc = fr+im*rand(Ty,n,m)
Qr = cr*cr'
Qr = (Qr+transpose(Qr))/2
Qrss = (Qr-transpose(Qr))/2
Qc = cc*cc'
Qc = (Qc+Qc')/2
Qrt1 = crt1*crt1'
Qrt1 = (Qrt1+transpose(Qrt1))/2
Qcs = (Qc+transpose(Qc))/2
Qcss = (Qc-transpose(Qc))/2
reltol = sqrt(eps(one(Ty)))

# solving Sylvester equations
@time x = sylvckr(ar,br,cr)
@test norm(ar*x+x*br-cr)/norm(x) < reltol

@time x = sylvckr(ac,bc,cc)
@test norm(ac*x+x*bc-cc)/norm(x) < reltol

@time x = sylvdkr(ar,br,cr)
@test norm(ar*x*br+x-cr)/norm(x) < reltol

@time x = sylvdkr(ac,bc,cc)
@test norm(ac*x*bc+x-cc)/norm(x) < reltol

# solving Sylvester-like equations
@time x = tsylvckr(art,brt,crt)
@test norm(art*x+transpose(x)*brt-crt)/norm(x) < reltol

@time x = tsylvckr(act,bct,cct)
@test norm(act*x+transpose(x)*bct-cct)/norm(x) < reltol

@time x = hsylvckr(act,bct,cct)
@test norm(act*x+adjoint(x)*bct-cct)/norm(x) < reltol

@time x = csylvckr(ac,bc,cc)
@test norm(ac*x+conj(x)*bc-cc)/norm(x) < reltol

@time x = tsylvdkr(art,brt',crt1)
@test norm(art*transpose(x)*brt'+x-crt1)/norm(x) < reltol

@time x = tsylvdkr(act,bct',cct1)
@test norm(act*transpose(x)*bct'+x-cct1)/norm(x) < reltol

@time x = hsylvdkr(act,bct',cct1)
@test norm(act*adjoint(x)*bct'+x-cct1)/norm(x) < reltol

@time x = csylvdkr(ac,bc,cc)
@test norm(ac*conj(x)*bc+x-cc)/norm(x) < reltol

# solving Lyapunov equations
@time x = sylvckr(ar,ar',-Qr)
@test norm(ar*x+x*ar'+Qr)/norm(x) < reltol

@time x = sylvckr(ac',ac,-Qc)
@test norm(ac'*x+x*ac+Qc)/norm(x) < reltol

@time x = sylvdkr(-ar,ar',Qr)
@test norm(ar*x*ar'-x+Qr)/norm(x) < reltol

@time x = sylvdkr(-ac',ac,Qc)
@test norm(ac'*x*ac-x+Qc)/norm(x) < reltol

# solving Lyapunov-like equations
@time x = tsylvckr(ar,ar',-Qr)
@test norm(ar*x+transpose(x)*ar'+Qr)/norm(x) < reltol

@time x1 = tlyapckr(ar,-Qr)
@test norm(ar*x1+transpose(x1)*ar'+Qr)/norm(x1) < reltol && x ≈ x1

@time x = tsylvckr(art,art',-Qrt1)
@test norm(art*x+transpose(x)*art'+Qrt1)/norm(x) < reltol

@time x1 = tlyapckr(art,-Qrt1)
@test norm(art*x1+transpose(x1)*art'+Qrt1)/norm(x1) < reltol && x ≈ x1

@time x = tsylvckr(ac,transpose(ac),-Qcs)
@test norm(ac*x+transpose(x)*transpose(ac)+Qcs)/norm(x) < reltol

@time x1 = tlyapckr(ac,-Qcs)
@test norm(ac*x1+transpose(x1)*transpose(ac)+Qcs)/norm(x1) < reltol && x ≈ x1

@time x = tsylvckr(ar,-ar',-ar+ar')
@test norm(ar*x-transpose(x)*ar'+ar-ar')/norm(x) < reltol

@time x1 = tlyapckr(ar,-ar+ar',-1)
@test norm(ar*x1-transpose(x1)*ar'+ar-ar')/norm(x1) < reltol && x ≈ x1

@time x = tsylvckr(art,-art',-er+er')
@test norm(art*x-transpose(x)*art'+er-er')/norm(x) < reltol

@time x1 = tlyapckr(art,-er+er',-1)
@test norm(art*x1-transpose(x1)*art'+er-er')/norm(x1) < reltol && x ≈ x1

@time x = tsylvckr(transpose(ac),-ac,-ac+transpose(ac))
@test norm(transpose(ac)*x-transpose(x)*ac+ac-transpose(ac))/norm(x) < reltol

@time x1 = tlyapckr(transpose(ac),-ac+transpose(ac),-1)
@test norm(transpose(ac)*x1-transpose(x1)*ac+ac-transpose(ac))/norm(x1) < reltol && x ≈ x1

@time x = hsylvckr(ac',ac,-Qc)  
@test norm(ac'*x+adjoint(x)*ac+Qc)/norm(x) < reltol

@time x1 = hlyapckr(ac',-Qc)  
@test norm(ac'*x1+adjoint(x1)*ac+Qc)/norm(x1) < reltol && x ≈ x1

@time x = hsylvckr(ac',-ac,-ac+ac')  
@test norm(ac'*x-adjoint(x)*ac+ac-ac')/norm(x) < reltol

@time x1 = hlyapckr(ac',-ac+ac',-1)  
@test norm(ac'*x1-adjoint(x1)*ac+ac-ac')/norm(x1) < reltol && x ≈ x1

@time x = tsylvdkr(-ar,ar',Qr)
@test norm(ar*transpose(x)*ar'-x+Qr)/norm(x) < reltol

@time x = hsylvdkr(-ac',ac,Qc)
@test norm(ac'*adjoint(x)*ac-x+Qc)/norm(x) < reltol

@time x = csylvdkr(-ac',ac,Qc)
@test norm(ac'*conj(x)*ac-x+Qc)/norm(x) < reltol


# solving generalized Sylvester equations
@time x = gsylvkr(ar,br,dr,er,cr)
@test norm(ar*x*br+dr*x*er-cr)/norm(x) < reltol

@time x = gsylvkr(ac,bc,dc,ec,cc)
@test norm(ac*x*bc+dc*x*ec-cc)/norm(x) < reltol

@time x = gsylvkr(ar,br',-dr,er',cr)
@test norm(ar*x*br'-dr*x*er'-cr)/norm(x) < reltol

@time x = gsylvkr(ac',bc,-dc,ec',cc)
@test norm(ac'*x*bc-dc*x*ec'-cc)/norm(x) < reltol

# solving generalized Lyapunov equations
@time x = gsylvkr(ar,dr',dr,ar',-Qr)
@test norm(ar*x*dr'+dr*x*ar'+Qr)/norm(x) < reltol

@time x = gsylvkr(ac',dc,dc',ac,-Qc)
@test norm(ac'*x*dc+dc'*x*ac+Qc)/norm(x) < reltol

@time x = gsylvkr(ar,ar',-dr,dr',-Qr)
@test norm(ar*x*ar'-dr*x*dr'+Qr)/norm(x) < reltol

@time x = gsylvkr(ac',ac,-dc',dc,-Qc)
@test norm(ac'*x*ac-dc'*x*dc+Qc)/norm(x) < reltol

# solving Sylvester systems
@time x, y = sylvsyskr(ar,br,cr,dr,er,fr)
@test norm(ar*x+y*br-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr*x+y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsyskr(ar,-br,cr,dr,-er,fr)
@test norm(ar*x-y*br-cr)/max(norm(x),norm(y)) < reltol &&
      norm(dr*x-y*er-fr)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsyskr(ac,bc,cc,dc,ec,fc)
@test norm(ac*x+y*bc-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dc*x+y*ec-fc)/max(norm(x),norm(y)) < reltol

@time x, y = sylvsyskr(ac,-bc,cc,dc,-ec,fc)
@test norm(ac*x-y*bc-cc)/max(norm(x),norm(y)) < reltol &&
      norm(dc*x-y*ec-fc)/max(norm(x),norm(y)) < reltol

@time x, y = dsylvsyskr(ar',br',cr,-dr',er',-fr)
@test norm(ar'*x-dr'*y-cr)/max(norm(x),norm(y)) < reltol &&
      norm(x*br'+y*er'+fr)/max(norm(x),norm(y)) < reltol

end
end

end

# TODO: These types aren't used anywhere for multiple dispatch, so why have them?
abstract type LyapunovMatrixEquationsMaps{T} <: LinearMaps.LinearMap{T} end
abstract type SylvesterMatrixEquationsMaps{T} <: LinearMaps.LinearMap{T} end
const MatrixEquationsMaps{T} = Union{LyapunovMatrixEquationsMaps{T},SylvesterMatrixEquationsMaps{T}}

abstract type ContinuousOrDiscrete end
struct Continuous <: ContinuousOrDiscrete end
struct Discrete <: ContinuousOrDiscrete end
abstract type TtypeOrHtype end
struct Ttype <: TtypeOrHtype end
struct Htype <: TtypeOrHtype end


struct trmatop{T} <: LinearMaps.LinearMap{T}
   size::Dims{2}
   function trmatop{T}(dims::Dims{2}) where {T}
      all(≥(0), dims) || throw(ArgumentError("dims must be non-negative"))
      return new{T}(dims)
   end
   function trmatop(m::Int, n::Int)
      (m ≥ (0) & n ≥ (0))  || throw(ArgumentError("dimensions must be non-negative"))
      return new{Bool}((m, n))
   end
end
trmatop(dims::Dims{2}) = trmatop{Bool}(dims)
trmatop(n::Int) = trmatop(n, n)
Base.size(A::trmatop) = (N = prod(A.size); return (N,N))
LinearAlgebra.issymmetric(A::trmatop) = true
LinearAlgebra.ishermitian(A::trmatop) = true
function LinearMaps._unsafe_mul!(y::AbstractVector, A::trmatop, x::AbstractVector)
   (m, n) = A.size
   k = 1
   for j = 1:n
      for i = 1:m
          y[(i-1)*n+j] = x[k]
          k += 1
      end
   end
   return y
end

"""
    M = trmatop(n, m)
    M = trmatop(A)

Define the transposition operator `M: X -> X'` for all `n x m` matrices or for all matrices of size of `A`. 
The corresponding commutation matrix (see [here](https://en.wikipedia.org/wiki/Commutation_matrix)) 
can be generated as `Matrix(M)`.
"""
function trmatop(A)
    trmatop{eltype(A)}(size(A))
end
"""
    M = eliminationop(n)
    M = eliminationop(A)

Define the elimination operator of all `n×n` matrices to select their upper triangular parts or of all square matrices of size of `A`.  
See [here](https://en.wikipedia.org/wiki/Duplication_and_elimination_matrices) for the 
definition of an elimination matrix for the selection of lower triangular parts.
"""
struct eliminationop{T} <: LinearMaps.LinearMap{T}
   dim::Int
   function eliminationop{T}(dim::Int) where {T}
      dim >= 0 || throw(ArgumentError("dimension must be non-negative"))
      return new{T}(dim)
   end
   function eliminationop(n::Int)
      (n ≥ (0))  || throw(ArgumentError("dimension must be non-negative"))
      return new{Bool}(n)
   end
end
Base.size(A::eliminationop) = (n = A.dim; return (div(n*(n+1),2), n*n))
LinearAlgebra.adjoint(A::eliminationop{T}) where {T} = LinearAlgebra.transpose(A)


function LinearMaps._unsafe_mul!(y::AbstractVector, A::eliminationop, x::AbstractVector)
   # X = reshape(x, A.dim, A.dim)
   # y[:] = triu2vec(X)
   n = A.dim
   k = 1
   for j = 1:n
      for i = 1:j
          y[k] = x[(i-1)*n + j]
          k += 1
      end
   end
   return y
end
function LinearMaps._unsafe_mul!(x::AbstractVector, AT::LinearMaps.TransposeMap{T,<:eliminationop{T}}, y::AbstractVector) where {T}
   # X = vec2triu(y)
   n = AT.lmap.dim
   ZERO = zero(eltype(y))
   @inbounds begin
      k = 1
      for j = 1:n
          for i = 1:j
              x[(i-1)*n + j] = y[k]
              k += 1
          end
          for i = j+1:n
              x[(i-1)*n + j] = ZERO
          end
      end
    end
   return x
end
eliminationop(A) = eliminationop{eltype(A)}(LinearAlgebra.checksquare(A))

"""
    M = duplicationop(n)
    M = duplicationop(A)

Define the duplication operator of all `n×n` matrices to reconstruct a hermitian matrix from its upper triangular elements 
or of all square matrices of size of `A`.
See [here](https://en.wikipedia.org/wiki/Duplication_and_elimination_matrices) for the 
definition of a duplication matrix from the lower triangular parts.

"""
struct duplicationop{T} <: LinearMaps.LinearMap{T}
   dim::Int
   function duplicationop{T}(dim::Int) where {T}
      dim >= 0 || throw(ArgumentError("dimension must be non-negative"))
      return new{T}(dim)
   end
   function duplicationop(n::Int)
      (n ≥ (0))  || throw(ArgumentError("dimension must be non-negative"))
      return new{Bool}(n)
   end
end
Base.size(A::duplicationop) = (n = A.dim; return (n*n, div(n*(n+1),2)))
LinearAlgebra.adjoint(A::duplicationop{T}) where {T} = LinearAlgebra.transpose(A)


function LinearMaps._unsafe_mul!(y::AbstractVector, A::duplicationop, x::AbstractVector)
   # y[:] = vec2triu(x, her = true)
   n = A.dim
   @inbounds begin
      k = 1
      for j = 1:n
          for i = 1:j
              y[(i-1)*n + j] = x[k]
              k += 1
          end
          for i = 1:j-1
              y[(j-1)*n + i] = conj(y[(i-1)*n + j])
          end
      end
    end
    return y
end

function LinearMaps._unsafe_mul!(x::AbstractVector, AT::LinearMaps.TransposeMap{T,<:duplicationop{T}}, y::AbstractVector) where {T}
   n = AT.lmap.dim
   # Y = reshape(y, n, n)
   # x[:] = triu2vec(Y+transpose(Y)-Diagonal(Y))
   @inbounds begin
      k = 1
      for j = 1:n
         for i = 1:j
            #x[k] = i == j ? Y[j,j] : Y[i,j] + Y[j,i]
            x[k] = i == j ? y[(j-1)*n + j] : y[(i-1)*n + j] + y[(j-1)*n + i]
            k += 1
         end
      end
   end
   return x
end
duplicationop(A) = duplicationop{eltype(A)}(LinearAlgebra.checksquare(A))



struct LyapLikeMap{T,TA <: AbstractMatrix,CD <: ContinuousOrDiscrete,TH<:TtypeOrHtype} <: LyapunovMatrixEquationsMaps{T}
   A::TA
   adj::Bool
   isig::Int
   function LyapLikeMap{T,TA,CD,TH}(A::TA; isig = 1, adj=false) where {T,TA<:AbstractMatrix{T},CD,TH}
      abs(isig) == 1 || throw(ArgumentError("only 1 or -1 values allowed for isig; got isig = $isig"))
      return new{T,TA,CD,TH}(A, adj, isig)
   end
end
LyapLikeMap(A::TA, ::CD = Continuous(), ::TH = Ttype(); adj::Bool = false, isig::Int = 1) where {T,TA<:AbstractMatrix{T},CD<:ContinuousOrDiscrete,TH<:TtypeOrHtype} =
   LyapLikeMap{T,TA,CD,TH}(A; adj, isig)

function Base.size(L::LyapLikeMap)
   m, n = size(L.A)
   return (m*m, m*n)
end

"""
    L = lyaplikeop(A; isig = 1, adj = false, htype = false)

For a matrix `A`, define for `adj = false` the continuous T-Lyapunov operator `L:X -> A*X+isig*transpose(X)*transpose(A)` if `htype = false`
or the continuous H-Lyapunov operator `L:X -> A*X+isig*X'*A'` if `htype = true`, or 
define for `adj = true` the continuous T-Lyapunov operator `L:X -> A*transpose(X)+X*transpose(A)` if `htype = false`,
or the continuous H-Lyapunov operator  `L:X -> A*X'+isig*X*A'` if `htype = true`. 
"""
function lyaplikeop(A::AbstractMatrix; disc=false, adj=false, isig = 1, htype = false)
    LyapLikeMap(A, ifelse(disc, Discrete(), Continuous()), ifelse(htype, Htype(), Ttype()); adj, isig)
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::LyapLikeMap{T,TA,Continuous,Ttype}, x::AbstractVector) where {T,TA}
   m, n = size(L.A)
   T1 = promote_type(T, eltype(x))
   X = L.adj ? reshape(convert(AbstractVector{T1}, x), m, n) : reshape(convert(AbstractVector{T1}, x), n, m)
   Y = L.adj ? L.A*transpose(X) : L.A*X
   y[:] .= L.isig == 1 ? (Y+transpose(Y))[:] : (Y-transpose(Y))[:]
   return y
end

function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.TransposeMap{T,<:LyapLikeMap{T,<:Any,Continuous,Ttype}}, y::AbstractVector) where {T}
   m = size(LT.lmap.A,1)
   T1 = promote_type(T, eltype(y))
   Y = reshape(convert(AbstractVector{T1}, y), m, m)
   temp = LT.lmap.isig ==1 ? Y+transpose(Y) : (LT.lmap.adj ? transpose(Y)-Y : Y-transpose(Y))
   x[:] = LT.lmap.adj ? (temp*LT.lmap.A)[:] : (transpose(LT.lmap.A)*temp)[:]
   return x
end

function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.AdjointMap{T,<:LyapLikeMap{T,<:Any,Continuous,Ttype}}, y::AbstractVector) where {T}
   m = size(LT.lmap.A,1)
   T1 = promote_type(T, eltype(y))
   Y = reshape(convert(AbstractVector{T1}, y), m, m)
   temp = LT.lmap.isig ==1 ? Y+transpose(Y) : (LT.lmap.adj ? transpose(Y)-Y : Y-transpose(Y))
   x[:] = LT.lmap.adj ? (temp*conj(LT.lmap.A))[:] : (LT.lmap.A'*temp)[:]
   return x
end

function LinearMaps._unsafe_mul!(y::AbstractVector, L::LyapLikeMap{T,TA,Continuous,Htype}, x::AbstractVector) where {T,TA}
   m, n = size(L.A)
   T1 = promote_type(T, eltype(x))
   X = L.adj ? reshape(convert(AbstractVector{T1}, x), m, n) : reshape(convert(AbstractVector{T1}, x), n, m)
   Y = L.adj ? L.A*X' : L.A*X
   y[:] .= L.isig == 1 ? (Y+Y')[:] : (Y-Y')[:]
   return y
end

function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.TransposeMap{T,<:LyapLikeMap{T,<:Any,Continuous,Htype}}, y::AbstractVector) where {T}
   m = size(LT.lmap.A,1)
   T1 = promote_type(T, eltype(y))
   Y = reshape(convert(AbstractVector{T1}, y), m, m)
   temp = LT.lmap.isig ==1 ? Y+transpose(Y) : (LT.lmap.adj ? transpose(Y)-Y : Y-transpose(Y))
   x[:] = LT.lmap.adj ? (temp*LT.lmap.A)[:] : (transpose(LT.lmap.A)*temp)[:]
   return x
end

function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.AdjointMap{T,<:LyapLikeMap{T,<:Any,Continuous,Htype}}, y::AbstractVector) where {T}
   m = size(LT.lmap.A,1)
   T1 = promote_type(T, eltype(y))
   Y = reshape(convert(AbstractVector{T1}, y), m, m)
   temp = LT.lmap.isig ==1 ? Y+Y' : (LT.lmap.adj ? Y'-Y : Y-Y')
   x[:] = LT.lmap.adj ? (temp*LT.lmap.A)[:] : (LT.lmap.A'*temp)[:]
   return x
end


struct UTLyapLikeMap{T,TU <: AbstractMatrix,CD <: ContinuousOrDiscrete,TH<:TtypeOrHtype} <: LyapunovMatrixEquationsMaps{T}
   U::TU
   adj::Bool
   function UTLyapLikeMap{T,TU,CD,TH}(U::TU, adj=false) where {T,TU<:AbstractMatrix{T},CD,TH}
      LinearAlgebra.checksquare(U)
      istriu(U) || error("U must be upper triangular")
      #(!adj && istriu(U.parent)) || (adj && istriu(U)) || error("U must be upper triangular")
      return new{T,TU,CD,TH}(U, adj)
   end
end

UTLyapLikeMap(U::TU, ::CD = Continuous(), ::TH = Ttype(); adj::Bool = false) where {T,TU<:AbstractMatrix{T},CD<:ContinuousOrDiscrete,TH<:TtypeOrHtype} =
   UTLyapLikeMap{T,TU,CD,TH}(U, adj)

function Base.size(L::UTLyapLikeMap)
   n = size(L.U, 1)
   N = Int(n * (n + 1) / 2)
   return (N, N)
end

"""
    L = tulyaplikeop(U; adj = false)

Define, for an upper triangular matrix `U`, the continuous T-Lyapunov operator `L:X -> transpose(U)*X+transpose(X)*U`, if `adj = false`,
or `L:X -> U*transpose(X)+X*transpose(U)` if `adj = true`.
"""
function tulyaplikeop(U::AbstractMatrix; disc=false, adj = false)
   UTLyapLikeMap(U, ifelse(disc, Discrete(), Continuous()), Ttype(); adj )
end
"""
    L = hulyaplikeop(U; adj = false)

Define, for an upper triangular matrix `U`, the continuous H-Lyapunov operator `L:X -> U'*X+X'*U`, if `adj = false`,
`L:X -> U*X'+X*U'` if `adj = true`. 
"""
function hulyaplikeop(U::AbstractMatrix; disc=false, adj = false)
   UTLyapLikeMap(U, ifelse(disc, Discrete(), Continuous()), Htype(); adj)
end

function LinearMaps._unsafe_mul!(y::AbstractVector, L::UTLyapLikeMap{T,TU,Continuous,Ttype}, x::AbstractVector) where {T,TU}
   T1 = promote_type(T, eltype(x))
   X = vec2triu(convert(AbstractVector{T1}, x), her=false)
   Y = L.adj ? L.U*transpose(X) : transpose(L.U)*X
   y[:] .= triu2vec(Y+transpose(Y))
   return y
end

#LinearAlgebra.adjoint(L::UTLyapLikeMap{T,TU,Continuous,Ttype}) where {T,TU}= LinearAlgebra.transpose(L)
#LinearAlgebra.transpose(L::UTLyapLikeMap{T,TU,Continuous,Ttype}) where {T,TU}= LinearAlgebra.adjoint(L)

function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.TransposeMap{T,<:UTLyapLikeMap{T,<:Any,Continuous,Ttype}}, y::AbstractVector) where {T}
   n = size(LT.lmap.U,2)
   T1 = promote_type(T, eltype(y))
   Y = vec2triu(convert(AbstractVector{T1}, y), her=false)
   x[:] = LT.lmap.adj ? triu2vec((Y+transpose(Y))*LT.lmap.U) : triu2vec(LT.lmap.U*(Y+transpose(Y)))
   #x[:] = LT.lmap.adj ? triu2vec(Y*LT.lmap.U+Y'*conj(LT.lmap.U)) : triu2vec(LT.lmap.U*Y+conj(LT.lmap.U)*Y')
   return x
end
function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.AdjointMap{T,<:UTLyapLikeMap{T,<:Any,Continuous,Ttype}}, y::AbstractVector) where {T}
   n = size(LT.lmap.U,2)
   T1 = promote_type(T, eltype(y))
   Y = vec2triu(convert(AbstractVector{T1}, y), her=false)
   #x[:] = LT.lmap.adj ? triu2vec((Y+Y')*conj(LT.lmap.U)) : triu2vec(conj(LT.lmap.U)*(Y+Y'))
   x[:] = LT.lmap.adj ? triu2vec((Y+transpose(Y))*conj(LT.lmap.U)) : triu2vec(conj(LT.lmap.U)*(Y+transpose(Y)))
   return x
end

function LinearMaps._unsafe_mul!(y::AbstractVector, L::UTLyapLikeMap{T,TU,Continuous,Htype}, x::AbstractVector) where {T,TU}
   T1 = promote_type(T, eltype(x))
   X = vec2triu(convert(AbstractVector{T1}, x), her=false)
   Y = L.adj ? L.U*X' : L.U'*X
   y[:] .= triu2vec(Y+Y')
   return y
end

# function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.TransposeMap{T,<:UTLyapLikeMap{T,TU,Continuous,Htype}}, y::AbstractVector) where {T,TU}
#    n = size(LT.lmap.U,2)
#    T1 = promote_type(T, eltype(y))
#    Y = vec2triu(convert(AbstractVector{T1}, y), her=false)
#    x[:] = LT.lmap.adj ? triu2vec(Y*LT.lmap.U+Y'*conj(LT.lmap.U)) : triu2vec(LT.lmap.U*Y+conj(LT.lmap.U)*Y')
#    return x
# end

function LinearMaps._unsafe_mul!(x::AbstractVector, LT::LinearMaps.AdjointMap{T,<:UTLyapLikeMap{T,TU,Continuous,Htype}}, y::AbstractVector) where {T,TU}
   n = size(LT.lmap.U,2)
   T1 = promote_type(T, eltype(y))
   Y = vec2triu(convert(AbstractVector{T1}, y), her=false)
  # the following ensures Matrix(L') == Matrix(L)' 
   #x[:] = LT.lmap.adj ? triu2vec(Y*LT.lmap.U+Y'*conj(LT.lmap.U)) : triu2vec(LT.lmap.U*Y+conj(LT.lmap.U)*Y')
   x[:] = LT.lmap.adj ? triu2vec((Y+Y')*LT.lmap.U) : triu2vec(LT.lmap.U*(Y+Y'))
   return x
end
# function LinearMaps._unsafe_mul!(y::AbstractVector, LT::LinearMaps.AdjointMap{T,<:UTHLyapunovMap{T}}, x::AbstractVector) where {T}
#    n = size(LT.lmap.U,2)
#    T1 = promote_type(T, eltype(x))
#    X = vec2triu(convert(AbstractVector{T1}, x), her=false)
#    y[:] = LT.lmap.adj ? triu2vec((X+X')*LT.lmap.U) : triu2vec(LT.lmap.U'*(X+X'))
#    return y
# end



# struct UTLyapLikeMap{T,TU <: AbstractMatrix,CD <: ContinuousOrDiscrete} <: LyapunovMatrixEquationsMaps{T}
#    U::TU
#    adj::Bool
#    function UTLyapLikeMap{T,TU,CD}(U::TU, adj=false) where {T,TU<:AbstractMatrix{T},CD}
#       LinearAlgebra.checksquare(U)
#       (!adj && istriu(U.parent)) || (adj && istriu(U)) || error("U must be upper triangular")
#       return new{T,TU,CD}(U, adj)
#    end
# end

# UTLyapLikeMap(U::TU, ::CD = Continuous(), adj::Bool = false) where {T,TU<:AbstractMatrix{T},CD<:ContinuousOrDiscrete} =
#    UTLyapLikeMap{T,TU,CD}(U, adj)

# #LinearAlgebra.transpose(L::UTLyapLikeMap{<:Any,<:Any,CD}) where {CD} = LinearAlgebra.adjoint(L)

# function Base.size(L::UTLyapLikeMap)
#    n = size(L.U, 1)
#    N = Int(n * (n + 1) / 2)
#    return (N, N)
# end

# function LinearMaps._unsafe_mul!(y::AbstractVector, L::UTLyapLikeMap{T,<:Any,Continuous,Htype}, x::AbstractVector) where {T,TU}
#    T1 = promote_type(T, eltype(x))
#    X = vec2triu(convert(AbstractVector{T1}, x), her=false)
#    Y = L.adj ? L.U*X' : L.U*X
#    y[:] .= triu2vec(Y+Y')
#    return y
# end

# function LinearMaps._unsafe_mul!(y::AbstractVector, LT::LinearMaps.AdjointMap{T,<:UTLyapLikeMap{T}}, x::AbstractVector) where {T}
#    n = size(LT.lmap.U,2)
#    T1 = promote_type(T, eltype(x))
#    X = vec2triu(convert(AbstractVector{T1}, x), her=false)
#    y[:] = LT.lmap.adj ? triu2vec((X+X')*LT.lmap.U) : triu2vec(LT.lmap.U'*(X+X'))
#    return y
# end

struct LyapunovMap{T,TA <: AbstractMatrix,CD <: ContinuousOrDiscrete} <: LyapunovMatrixEquationsMaps{T}
   A::TA
   her::Bool
   function LyapunovMap{T,TA,CD}(A::TA, her=false) where {T,TA<:AbstractMatrix{T},CD}
      LinearAlgebra.checksquare(A)
      return new{T,TA,CD}(A, her)
   end
end

LyapunovMap(A::TA, ::CD = Continuous(), her::Bool = false) where {T,TA<:AbstractMatrix{T},CD<:ContinuousOrDiscrete} =
   LyapunovMap{T,TA,CD}(A, her)

# LinearAlgebra.adjoint(L::LyapunovMap{<:Any,<:Any,CD}) where {CD}   = LyapunovMap(L.A', CD(), L.her)
# LinearAlgebra.transpose(L::LyapunovMap{<:Any,<:Any,CD}) where {CD} = LyapunovMap(L.A', CD(), L.her)
# LinearAlgebra.transpose(L::LyapunovMap{<:Any,<:Any,CD}) where {CD} = LyapunovMap(L.A', CD(), L.her)

"""
    L = lyapop(A; disc = false, her = false)

Define, for an `n x n` matrix `A`, the continuous Lyapunov operator `L:X -> AX+XA'`
if `disc = false` or the discrete Lyapunov operator `L:X -> AXA'-X` if `disc = true`.
If `her = false` the Lyapunov operator `L:X -> Y` maps general square matrices `X`
into general square matrices `Y`, and the associated matrix `M = Matrix(L)` is
``n^2 \\times n^2``.
If `her = true` the Lyapunov operator `L:X -> Y` maps symmetric/Hermitian matrices `X`
into symmetric/Hermitian matrices `Y`, and the associated matrix `M = Matrix(L)` is
``n(n+1)/2 \\times n(n+1)/2``.
For the definitions of the Lyapunov operators see:

M. Konstantinov, V. Mehrmann, P. Petkov. On properties of Sylvester and Lyapunov
operators. Linear Algebra and its Applications 312:35–71, 2000.
"""
lyapop(A::AbstractMatrix; disc=false, her=false) =
   LyapunovMap(A, ifelse(disc, Discrete(), Continuous()), her)
lyapop(A::Schur; disc=false, her=false) =
   LyapunovMap(A.T, ifelse(disc, Discrete(), Continuous()), her)
lyapop(A::Number; disc=false, her=false) =
   LyapunovMap(fill(A, 1, 1), ifelse(disc, Discrete(), Continuous()), her)
function Base.size(L::LyapunovMap)
   n = size(L.A, 1)
   N = L.her ? Int(n * (n + 1) / 2) : n * n
   return (N, N)
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::LyapunovMap{T,TA,Discrete}, x::AbstractVector) where {T,TA}
   require_one_based_indexing(y, x)
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   if L.her
      X = vec2triu(convert(AbstractVector{T1}, x), her=true)
      # (y .= triu2vec(utqu(X,L.A') - X))
      muldsym!(y, L.A, X)
   else
      X = reshape(convert(AbstractVector{T1}, x), n, n)
      # (y .= (L.A*X*L.A' - X)[:])
      mul!(y, -1, x)
      Y = reshape(y, n, n)
      mul!(Y, L.A, X * L.A', true, true)
   end
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(x::AbstractVector, L::$ttype{T,LyapunovMap{T,TA,Discrete}}, y::AbstractVector) where  {T,TA}
      require_one_based_indexing(y, x)
      n = size(L.lmap.A, 1)
      T1 = promote_type(T, eltype(y))
      if L.lmap.her
         Y = vec2triu(convert(AbstractVector{T1}, y), her=false)
         # x[:] = triu2vec(L.lmap.A'*Y*L.lmap.A - Y)
         muldsym!(x, L.lmap.A', Y, dual = true)
      else
         # (x .= (L.A'*Y*L.A - Y)[:])
         mul!(x, -1, y)
         Y = reshape(convert(AbstractVector{T1}, y), n, n)
         X = reshape(x, n, n)
         mul!(X, L.lmap.A'*Y, L.lmap.A, true, true)
      end
      return x
   end
end
   
function LinearMaps._unsafe_mul!(y::AbstractVector, L::LyapunovMap{T,TA,Continuous}, x::AbstractVector) where {T,TA}
   require_one_based_indexing(y, x)
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   if L.her
      X = vec2triu(convert(AbstractVector{T1}, x), her=true)
      mulcsym!(y, L.A, X)
   else
      X = reshape(convert(AbstractVector{T1}, x), n, n)
      # (y[:] = (L.A*X + X*L.A')[:])
      Y = reshape(y, n, n)
      mul!(Y, X, L.A')
      mul!(Y, L.A, X, true, true)
   end
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(x::AbstractVector, L::$ttype{T,LyapunovMap{T,TA,Continuous}}, y::AbstractVector) where  {T,TA}
      require_one_based_indexing(y, x)
      n = size(L.lmap.A, 1)
      T1 = promote_type(T, eltype(y))
      if L.lmap.her
         Y = vec2triu(convert(AbstractVector{T1}, y), her=false)
         mulcsym!(x, L.lmap.A, Y, dual = true)
      else
         Y = reshape(convert(AbstractVector{T1}, y), n, n)
         # (x[:] = (L.A'*Y + Y*L.A)[:])
         X = reshape(x, n, n)
         mul!(X, Y, L.lmap.A)
         mul!(X, L.lmap.A', Y, true, true)
      end
      return x
   end
end
function mulcsym!(y::AbstractVector, A::AbstractMatrix, X::AbstractMatrix; dual = false) 
   require_one_based_indexing(y, A, X)
   # A*X + X*A'
   n = size(A, 1)
   Y = similar(X, n, n)
   if dual
      #Y = A'*X+X*A
      Y = similar(X, n, n)
      mul!(Y, X, A)
      mul!(Y, A', X, true, true)
      # y[:] = triu2vec(Y+transpose(Y)-Diagonal(Y))
      @inbounds begin
         k = 1
         for j = 1:n
            for i = 1:j
               y[k] = i == j ? Y[j,j] : Y[i,j] + conj(Y[j,i])
               k += 1
            end
         end
      end
   else
      mul!(Y, A, X)
      @inbounds begin
         k = 1
         for j = 1:n
             for i = 1:j
                 y[k] = Y[i,j] + conj(Y[j,i])
                 k += 1
             end
        end
      end
   end
   return y
end
function muldsym!(y::AbstractVector, A::AbstractMatrix, X::AbstractMatrix; dual = false)
   require_one_based_indexing(y, X)
   # A*X*A' - X
   n = size(A, 1)
   if dual 
      #Y = A*X*A' - X
      Y = similar(X, n, n)
      mul!(Y, -1, X)
      mul!(Y, A*X, A', true, true)
      # y[:] = triu2vec(Y+transpose(Y)-Diagonal(Y))
      @inbounds begin
         k = 1
         for j = 1:n
            for i = 1:j
               y[k] = i == j ? Y[j,j] : Y[i,j] + Y[j,i]
               k += 1
            end
         end
      end
      return y
   end
   # t = triu(X)-diag(X)/2
   t = UpperTriangular(X) - Diagonal(X[diagind(X)] ./ 2)
   Y = similar(t, n, n)
   # Y = A*t*A'
   mul!(Y, A * t, A')
   # Y + Y' - X
   @inbounds begin
      k = 1
      for j = 1:n
         for i = 1:j
            y[k] = Y[i,j] + conj(Y[j,i]) - X[i,j]
            k += 1
         end
      end
   end
   return y
end

struct GeneralizedLyapunovMap{T,TA <: AbstractMatrix{T},TE <: AbstractMatrix{T},CD<:ContinuousOrDiscrete} <: LyapunovMatrixEquationsMaps{T}
   A::TA
   E::TE
   her::Bool
   function GeneralizedLyapunovMap{T,TA,TE,CD}(A::TA, E::TE, her=false) where {T,TA<:AbstractMatrix{T},TE<:AbstractMatrix{T},CD}
      n = LinearAlgebra.checksquare(A)
      n == LinearAlgebra.checksquare(E) ||
               throw(DimensionMismatch("E must be a square matrix of dimension $n"))
      return new{T,TA,TE,CD}(A, E, her)
   end
end
function GeneralizedLyapunovMap(A::AbstractMatrix, E::AbstractMatrix, ::CD = Continuous(), her::Bool = false) where {CD<:ContinuousOrDiscrete}
   n = LinearAlgebra.checksquare(A)
   n == LinearAlgebra.checksquare(E) ||
            throw(DimensionMismatch("E must be a square matrix of dimension $n"))
   T = promote_type(eltype(A), eltype(E))
   A = convert(AbstractMatrix{T}, A)
   E = convert(AbstractMatrix{T}, E)
   return GeneralizedLyapunovMap{T,typeof(A),typeof(E),CD}(A, E, her)
end

# LinearAlgebra.adjoint(L::GeneralizedLyapunovMap{<:Any,<:Any,<:Any,CD}) where {CD} =
#    GeneralizedLyapunovMap(L.A', L.E', CD(), L.her)
# LinearAlgebra.transpose(L::GeneralizedLyapunovMap{<:Any,<:Any,<:Any,CD}) where {CD} =
#    GeneralizedLyapunovMap(L.A', L.E', CD(), L.her)

"""
    L = lyapop(A, E; disc = false, her = false)

Define, for a pair `(A,E)` of `n x n` matrices, the continuous Lyapunov operator `L:X -> AXE'+EXA'`
if `disc = false` or the discrete Lyapunov operator `L:X -> AXA'-EXE'` if `disc = true`.
If `her = false` the Lyapunov operator `L:X -> Y` maps general square matrices `X`
into general square matrices `Y`, and the associated matrix `M = Matrix(L)` is
``n^2 \\times n^2``.
If `her = true` the Lyapunov operator `L:X -> Y` maps symmetric/Hermitian matrices `X`
into symmetric/Hermitian matrices `Y`, and the associated `M = Matrix(L)` is a
``n(n+1)/2 \\times n(n+1)/2``.
For the definitions of the Lyapunov operators see:

M. Konstantinov, V. Mehrmann, P. Petkov. On properties of Sylvester and Lyapunov
operators. Linear Algebra and its Applications 312:35–71, 2000.
"""
lyapop(A::AbstractMatrix, E::AbstractMatrix; disc=false, her=false) =
   GeneralizedLyapunovMap(A, E, ifelse(disc, Discrete(), Continuous()), her)
lyapop(F::GeneralizedSchur; disc=false, her=false) =
   GeneralizedLyapunovMap(F.S, F.T, ifelse(disc, Discrete(), Continuous()), her)
function lyapop(A::Number, E::Number; disc=false, her=false)
   A, E = promote(A, E)
   GeneralizedLyapunovMap(fill(A, 1, 1), fill(E, 1, 1), ifelse(disc, Discrete(), Continuous()), her)
end
function Base.size(L::GeneralizedLyapunovMap)
   n = size(L.A, 1)
   N = L.her ? Int(n * (n + 1) / 2) : n * n
   return (N, N)
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::GeneralizedLyapunovMap{T,<:Any,<:Any,Discrete}, x::AbstractVector) where {T}
   require_one_based_indexing(y, x)
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   if L.her
      X = vec2triu(convert(AbstractVector{T1}, x), her=true)
      # (y .= triu2vec(utqu(X,L.A') - utqu(X,L.E')))
      muldsym!(y, L.A, L.E, X)
   else
      X = reshape(convert(AbstractVector{T1}, x), n, n)
      Y = reshape(y, n, n)
      temp = similar(Y, (n, n))
      # (y .= (L.A*X*L.A' - L.E*X*L.E')[:])
      # Y .= X
      mul!(temp, X, L.A')
      mul!(Y, L.A, temp)
      mul!(temp, X, L.E')
      mul!(Y, L.E, temp, -1, 1)
   end
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(x::AbstractVector, L::$ttype{T,GeneralizedLyapunovMap{T,TA,TE,Discrete}}, y::AbstractVector) where  {T,TA,TE}
      require_one_based_indexing(y, x)
      n = size(L.lmap.A, 1)
      T1 = promote_type(T, eltype(y))
      if L.lmap.her
         Y = vec2triu(convert(AbstractVector{T1}, y), her=false)
         # x[:] = triu2vec(L.lmap.A'*Y*L.lmap.A - Y)
         muldsym!(x, L.lmap.A', L.lmap.E', Y, dual = true)
      else
         # (x .= (L.A'*Y*L.A - L.E'*X*L.E)[:])
         X = reshape(x, n, n)
         Y = reshape(convert(AbstractVector{T1}, y), n, n)
         temp = similar(Y, (n, n))
         mul!(temp, Y, L.lmap.A)
         mul!(X, L.lmap.A', temp)
         mul!(temp, Y, L.lmap.E)
         mul!(X, L.lmap.E', temp, -1, 1)
      end
      return x
   end
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::GeneralizedLyapunovMap{T,<:Any,<:Any,Continuous}, x::AbstractVector) where {T}
   require_one_based_indexing(y, x)
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   if L.her
      X = vec2triu(convert(AbstractVector{T1}, x), her=true)
      mulcsym!(y, L.A, L.E, X)
   else
      X = reshape(convert(AbstractVector{T1}, x), n, n)
      Y = reshape(y, n, n)
      temp = similar(Y, (n, n))
      # (y[:] = (L.A*X*L.E' + L.E*X*L.A')[:])
      mul!(temp, L.E, X)
      mul!(Y, temp, L.A')
      mul!(temp, X, L.E')
      mul!(Y, L.A, temp, 1, 1)
   end
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(x::AbstractVector, L::$ttype{T,GeneralizedLyapunovMap{T,TA,TE,Continuous}}, y::AbstractVector) where  {T,TA,TE}
      require_one_based_indexing(y, x)
      n = size(L.lmap.A, 1)
      T1 = promote_type(T, eltype(y))
      if L.lmap.her
         Y = UpperTriangular(vec2triu(convert(AbstractVector{T1}, y), her=false))
         #x[:] = triu2vec(L.lmap.A'*Y + Y*L.lmap.A)
         #mulcsym!(x, L.lmap.A', L.lmap.E',  Y, dual = true)
         mulcsym!(x, L.lmap.A, L.lmap.E,  Y, dual = true)
      else
         X = reshape(x, n, n)
         Y = reshape(convert(AbstractVector{T1}, y), n, n)
         temp = similar(Y, (n, n))
         # (x[:] = (L.A'*Y*L.E + L.E'*Y*L.A)[:])
         mul!(temp, L.lmap.E', Y)
         mul!(X, temp, L.lmap.A)
         mul!(temp, Y, L.lmap.E)
         mul!(X, L.lmap.A', temp, 1, 1)
      end
      return x
   end
end
function mulcsym!(y::AbstractVector, A::AbstractMatrix, E::AbstractMatrix, X::AbstractMatrix; dual = false) 
   require_one_based_indexing(y, A)
   n = size(A, 1)
   if dual 
      # A'XE + E'XA with X upper triangular
      Y = E'*(X*A) + A'*(X*E)
      # y[:] = triu2vec(Y+transpose(Y)-Diagonal(Y))
      @inbounds begin
         k = 1
         for j = 1:n
            for i = 1:j
               y[k] = i == j ? Y[j,j] : Y[i,j] + conj(Y[j,i])
               k += 1
            end
         end
      end
   else
      # AXE' + EXA' with X symmetric
      Y = (A*X)*E'
      @inbounds begin
         k = 1
         for j = 1:n
             for i = 1:j
                 y[k] = Y[i,j] + conj(Y[j,i])
                 k += 1
             end
        end
      end
   end
   return y
end
function muldsym!(y::AbstractVector, A::AbstractMatrix, E::AbstractMatrix, X::AbstractMatrix; dual = false)
   require_one_based_indexing(y)
   # AXA' - EXE'
   n = size(A, 1)
   Y = similar(X, n, n)
   if dual 
      #Y = AXA' - EXE'
      temp = similar(Y, (n, n))
      mul!(temp, A, X)
      mul!(Y, temp, A')
      mul!(temp, X, E')
      mul!(Y, E, temp, -1, 1)
      # y[:] = triu2vec(Y+transpose(Y)-Diagonal(Y))
      @inbounds begin
         k = 1
         for j = 1:n
            for i = 1:j
               y[k] = i == j ? Y[j,j] : Y[i,j] + Y[j,i]
               k += 1
            end
         end
      end
   else
      # t = triu(X)-diag(X)/2
      t = UpperTriangular(X) - Diagonal(X[diagind(X)] ./ 2)
      # Y = A*t*A' - E*t*E'
      mul!(Y, A * t, A')
      mul!(Y, E * t, E', -1, 1)
      # Y + Y'
      @inbounds  begin
         k = 1
         for j = 1:n
            for i = 1:j
               y[k] = Y[i,j] + conj(Y[j,i])
               k += 1
            end
         end
      end
   end
   return y
end

struct InverseLyapunovMap{T,TA <: AbstractMatrix,adj,CD} <: LyapunovMatrixEquationsMaps{T}
   A::TA
   her::Bool
   sf::Bool
   function InverseLyapunovMap{T,TA,adj,CD}(A::TA, her::Bool, sf::Bool) where {T <: BlasFloat, TA <: AbstractMatrix{T}, adj, CD}
      LinearAlgebra.checksquare(A)
      return new{T,TA,adj,CD}(A, her, sf)
   end
end
function InverseLyapunovMap(A::AbstractMatrix{T}, ::CD = Continuous(), her::Bool = false) where {T <: BlasFloat,CD <: ContinuousOrDiscrete}
   schur_flag = isschur(A)
   return InverseLyapunovMap{T,typeof(A),false,CD}(A, her, schur_flag)
end
function InverseLyapunovMap(A::Adjoint{T,<:AbstractMatrix{T}}, ::CD = Continuous(), her::Bool = false) where {T <: BlasFloat,CD <: ContinuousOrDiscrete}
   Ap = A.parent
   schur_flag = isschur(Ap)
   return InverseLyapunovMap{T,typeof(Ap),true,CD}(Ap, her, schur_flag)
end

LinearAlgebra.adjoint(L::InverseLyapunovMap{<:Any,<:Any,adj,CD}) where {adj,CD} = 
   eltype(L) <: Complex ? InverseLyapunovMap(adj ? L.A : L.A', CD(), L.her) : LinearAlgebra.transpose(L)
# LinearAlgebra.adjoint(L::InverseLyapunovMap{<:Any,<:Any,adj,CD}) where {adj,CD} =
#    InverseLyapunovMap(adj ? L.A : L.A', CD(), L.her)
# LinearAlgebra.transpose(L::InverseLyapunovMap{<:Any,<:Any,adj,CD}) where {adj,CD} =
#    InverseLyapunovMap(adj ? L.A : L.A', CD(), L.her)
LinearAlgebra.inv(L::LyapunovMap{T,TA,CD}) where {T,TA,CD} =
   InverseLyapunovMap(L.A, CD(), L.her)
LinearAlgebra.inv(L::InverseLyapunovMap{<:Any,<:Any,adj,CD}) where {adj,CD} =
   LyapunovMap(adj ? L.A' : L.A, CD(), L.her)

"""
    LINV = invlyapop(A; disc = false, her = false)

Define `LINV`, the inverse of the continuous Lyapunov operator `L:X -> AX+XA'` for `disc = false`
or the inverse of the discrete Lyapunov operator `L:X -> AXA'-X` for `disc = true`, where
`A` is an `n x n` matrix.
If `her = false` the inverse Lyapunov operator `LINV:Y -> X` maps general square matrices `Y`
into general square matrices `X`, and the associated matrix `M = Matrix(LINV)` is
``n^2 \\times n^2``.
If `her = true` the inverse Lyapunov operator `LINV:Y -> X` maps symmetric/Hermitian matrices `Y`
into symmetric/Hermitian matrices `X`, and the associated matrix `M = Matrix(LINV)` is
``n(n+1)/2 \\times n(n+1)/2``.
For the definitions of the Lyapunov operators see:

M. Konstantinov, V. Mehrmann, P. Petkov. On properties of Sylvester and Lyapunov
operators. Linear Algebra and its Applications 312:35–71, 2000.
"""
invlyapop(A::AbstractMatrix{<:BlasFloat}; disc=false, her=false) =
   InverseLyapunovMap(A, ifelse(disc, Discrete(), Continuous()), her)
function invlyapop(A::AbstractMatrix; disc=false, her=false)
   A = convert(AbstractMatrix{promote_type(eltype(A), Float64)}, A)
   InverseLyapunovMap(A, ifelse(disc, Discrete(), Continuous()), her)
end
invlyapop(A::Schur{<:BlasFloat}; disc=false, her=false) =
   InverseLyapunovMap(A.T, ifelse(disc, Discrete(), Continuous()), her)
function Base.size(L::InverseLyapunovMap)
   n = size(L.A, 1)
   N = L.her ? Int(n * (n + 1) / 2) : n * n
   return (N, N)
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseLyapunovMap{T,<:Any,adj,Discrete}, x::AbstractVector) where {T <: BlasFloat,adj}
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.sf && !(T <: Real && T1 <: Complex) 
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            lyapds!(L.A, Y, adj=adj)
            copyto!(y, triu2vec(Y))
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            adj ? sylvds!(-L.A, L.A, Y, adjA=true) : sylvds!(-L.A, L.A, Y, adjB=true)
            copyto!(y, Y)
         end
      else
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            y .= triu2vec(lyapd(adj ? L.A' : L.A, Y))
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            copyto!(y, lyapd(adj ? L.A' : L.A, Y))
         end
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::LinearMaps.TransposeMap{<:Any,<:InverseLyapunovMap{T,<:Any,adj,Discrete}}, x::AbstractVector) where {T <: BlasFloat,adj}
   n = size(L.lmap.A, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.lmap.sf && !(T <: Real && T1 <: Complex) 
         if L.lmap.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=false)
            adj ? sylvds!(-L.lmap.A, L.lmap.A, Y, adjB=true) : sylvds!(-L.lmap.A, L.lmap.A, Y, adjA=true)
            # lyapds!(L.A, Y, adj=adj)
            # copyto!(y, triu2vec(Y))
            @inbounds begin
               k = 1
               for j = 1:n
                  for i = 1:j
                     y[k] = i == j ? Y[j,j] : Y[i,j] + Y[j,i]
                     k += 1
                  end
               end
            end
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            adj ? sylvds!(-L.lmap.A, L.lmap.A, Y, adjB=true) : sylvds!(-L.lmap.A, L.lmap.A, Y, adjA=true)
            copyto!(y, Y)
         end
      else
         if L.lmap.her
            Y1 = vec2triu(-convert(AbstractVector{T1}, x), her=false)
            #y .= triu2vec(lyapd(adj ? L.A' : L.A, Y))
            adj ? (Y = sylvd(-L.lmap.A, L.lmap.A', Y1)) : (Y = sylvd(-L.lmap.A', L.lmap.A, Y1))
            @inbounds begin
               k = 1
               for j = 1:n
                  for i = 1:j
                     y[k] = i == j ? Y[j,j] : Y[i,j] + Y[j,i]
                     k += 1
                  end
               end
            end
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            copyto!(y, lyapd(adj ? L.lmap.A : L.lmap.A', Y))
         end
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end

function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseLyapunovMap{T,<:Any,adj,Continuous}, x::AbstractVector) where {T <: BlasFloat,adj}
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.sf && !(T <: Real && T1 <: Complex) 
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            lyapcs!(L.A, Y; adj=adj)
            copyto!(y, triu2vec(Y))
         else
            Y = copy(reshape(convert(AbstractVector{T1}, x), n, n))
            adj ? (sylvcs!(L.A, L.A, Y, adjA=true)) : (sylvcs!(L.A, L.A, Y, adjB=true))
            copyto!(y, Y)
         end
      else
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            y .= triu2vec(lyapc(adj ? L.A' : L.A, Y))
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            copyto!(y, lyapc(adj ? L.A' : L.A, Y))
         end
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::LinearMaps.TransposeMap{<:Any,<:InverseLyapunovMap{T,<:Any,adj,Continuous}}, x::AbstractVector) where {T <: BlasFloat,adj}
   n = size(L.lmap.A, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.lmap.sf && !(T <: Real && T1 <: Complex) 
         if L.lmap.her
            Y = vec2triu(convert(AbstractVector{T1}, x), her=false)
            adj ? (sylvcs!(L.lmap.A, L.lmap.A, Y, adjB=true)) : (sylvcs!(L.lmap.A, L.lmap.A, Y, adjA=true))
            @inbounds begin
               k = 1
               for j = 1:n
                  for i = 1:j
                     y[k] = i == j ? Y[j,j] : Y[i,j] + Y[j,i]
                     k += 1
                  end
               end
            end
         else
            Y = copy(reshape(convert(AbstractVector{T1}, x), n, n))
            adj ? (sylvcs!(L.lmap.A, L.lmap.A, Y, adjB=true)) : (sylvcs!(L.lmap.A, L.lmap.A, Y, adjA=true))
            copyto!(y, Y)
         end
      else
         if L.lmap.her
            Y1 = vec2triu(convert(AbstractVector{T1}, x), her=false)
            #y .= triu2vec(lyapc(adj ? L.A' : L.A, Y))
            adj ? (Y = sylvc(L.lmap.A, L.lmap.A', Y1)) : (Y = sylvc(L.lmap.A', L.lmap.A, Y1))
            @inbounds begin
               k = 1
               for j = 1:n
                  for i = 1:j
                     y[k] = i == j ? Y[j,j] : Y[i,j] + Y[j,i]
                     k += 1
                  end
               end
            end
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            copyto!(y, lyapc(adj ? L.lmap.A : L.lmap.A', Y))
         end
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end


struct InverseGeneralizedLyapunovMap{T,TA <: AbstractMatrix,TE <: AbstractMatrix,adj,CD <: ContinuousOrDiscrete} <: LyapunovMatrixEquationsMaps{T}
  A::TA
  E::TE
  her::Bool
  sf::Bool
  function InverseGeneralizedLyapunovMap{T,TA,TE,adj,CD}(A::TA, E::TE, her::Bool, schur_flag::Bool) where {T<:BlasFloat,TA<:AbstractMatrix{T},TE<:AbstractMatrix{T},adj,CD}
      LinearAlgebra.checksquare(A)
      return new{T,TA,TE,adj,CD}(A, E, her, schur_flag)
   end
end

function InverseGeneralizedLyapunovMap(A::AbstractMatrix, E::AbstractMatrix, ::CD = Continuous(), her::Bool = false) where {CD <: ContinuousOrDiscrete}
   T = promote_type(eltype(A), eltype(E), Float64)
   A = convert(AbstractMatrix{T}, A)
   E = convert(AbstractMatrix{T}, E)
   schur_flag = isschur(A, E)
   return InverseGeneralizedLyapunovMap{T,typeof(A),typeof(E),false,CD}(A, E, her, schur_flag)
end
function InverseGeneralizedLyapunovMap(A::Adjoint{<:Any,<:AbstractMatrix}, E::Adjoint{<:Any,<:AbstractMatrix}, ::CD = Continuous(), her::Bool = false) where {CD <: ContinuousOrDiscrete}
   A = A.parent
   E = E.parent
   T = promote_type(eltype(A), eltype(E), Float64)
   A = convert(AbstractMatrix{T}, A)
   E = convert(AbstractMatrix{T}, E)
   schur_flag = isschur(A, E)
   return InverseGeneralizedLyapunovMap{T,typeof(A),typeof(E),true,CD}(A, E, her, schur_flag)
end

LinearAlgebra.adjoint(L::InverseGeneralizedLyapunovMap{<:Any,<:Any,<:Any,adj,CD}) where {adj,CD} =
   InverseGeneralizedLyapunovMap(adj ? L.A : L.A', adj ? L.E : L.E', CD(), L.her)
LinearAlgebra.transpose(L::InverseGeneralizedLyapunovMap{<:Any,<:Any,<:Any,adj,CD}) where {adj,CD} =
   InverseGeneralizedLyapunovMap(adj ? L.A : L.A', adj ? L.E : L.E', CD(), L.her)
LinearAlgebra.inv(L::GeneralizedLyapunovMap{<:Any,<:Any,<:Any,CD}) where {CD} =
   InverseGeneralizedLyapunovMap(L.A, L.E, CD(), L.her)
LinearAlgebra.inv(L::InverseGeneralizedLyapunovMap{<:Any,<:Any,<:Any,adj,CD}) where {adj,CD} =
   GeneralizedLyapunovMap(adj ? L.A' : L.A, adj ? L.E' : L.E, CD(), L.her)

"""
    LINV = invlyapop(A, E; disc = false, her = false)

Define `LINV`, the inverse of the continuous Lyapunov operator `L:X -> AXE'+EXA'` for `disc = false`
or the inverse of the discrete Lyapunov operator `L:X -> AXA'-EXE'` for `disc = true`, where
`(A,E)` is a pair of `n x n` matrices.
If `her = false` the inverse Lyapunov operator `LINV:Y -> X` maps general square matrices `Y`
into general square matrices `X`, and the associated matrix `M = Matrix(LINV)` is
``n^2 \\times n^2``.
If `her = true` the inverse Lyapunov operator `LINV:Y -> X` maps symmetric/Hermitian matrices `Y`
into symmetric/Hermitian matrices `X`, and the associated matrix `M = Matrix(LINV)` is
``n(n+1)/2 \\times n(n+1)/2``.
For the definitions of the Lyapunov operators see:

M. Konstantinov, V. Mehrmann, P. Petkov. On properties of Sylvester and Lyapunov
operators. Linear Algebra and its Applications 312:35–71, 2000.
"""
invlyapop(A::AbstractMatrix, E::AbstractMatrix; disc=false, her=false) =
   InverseGeneralizedLyapunovMap(A, E, ifelse(disc, Discrete(), Continuous()), her)
invlyapop(F::GeneralizedSchur; disc=false, her=false) =
   InverseGeneralizedLyapunovMap(F.S, F.T, ifelse(disc, Discrete(), Continuous()), her)
function Base.size(L::InverseGeneralizedLyapunovMap)
   n = size(L.A, 1)
   N = L.her ? Int(n * (n + 1) / 2) : n * n
   return (N, N)
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseGeneralizedLyapunovMap{T,<:Any,<:Any,adj,Discrete}, x::AbstractVector) where {T,adj}
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.sf && !(T <: Real && T1 <: Complex) 
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            lyapds!(L.A, L.E, Y; adj=adj)
            y .= triu2vec(Y)
         else
            copyto!(y, x)
            Y = reshape(y, (n, n))
            adj ? gsylvs!(L.A, L.A, -L.E, L.E, Y, adjAC=true) : gsylvs!(L.A, L.A, -L.E, L.E, Y, adjBD=true)
         end
      else
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            y .= triu2vec(lyapd(adj ? L.A' : L.A, adj ? L.E' : L.E, Y))
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            # adj ? (y .= gsylv(-L.A',L.A,L.E',L.E,Y)[:]) : (y .= gsylv(-L.A,L.A',L.E,L.E',Y)[:])
            copyto!(y, lyapd(adj ? L.A' : L.A, adj ? L.E' : L.E, Y))
         end
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseGeneralizedLyapunovMap{T,<:Any,<:Any,adj,Continuous}, x::AbstractVector) where {T,adj}
   n = size(L.A, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.sf && !(T <: Real && T1 <: Complex) 
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            lyapcs!(L.A, L.E, Y; adj=adj)
            y .= triu2vec(Y)
         else
            copyto!(y, x)
            Y = reshape(y, (n, n))
            adj ? (gsylvs!(L.A, L.E, L.E, L.A, Y, adjAC=true, DBSchur=true)) : (gsylvs!(L.A, L.E, L.E, L.A, Y, adjBD=true, DBSchur=true))
         end
      else
         if L.her
            Y = vec2triu(-convert(AbstractVector{T1}, x), her=true)
            y .= triu2vec(lyapc(adj ? L.A' : L.A, adj ? L.E' : L.E, Y))
         else
            Y = reshape(-convert(AbstractVector{T1}, x), n, n)
            # adj ? (y .= gsylv(L.A',L.E,L.E',L.A,Y)[:]) : (y .= gsylv(L.A,L.E',L.E,L.A',Y)[:])
            copyto!(y, lyapc(adj ? L.A' : L.A, adj ? L.E' : L.E, Y))
         end
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end

struct SylvesterMap{T,TA <: AbstractMatrix,TB <: AbstractMatrix,CD <: ContinuousOrDiscrete} <: SylvesterMatrixEquationsMaps{T}
   A::TA
   B::TB
   function SylvesterMap{T,TA,TB,CD}(A::TA, B::TB) where {T,TA<:AbstractMatrix{T},TB<:AbstractMatrix{T},CD}
      LinearAlgebra.checksquare(A, B)
      return new{T,TA,TB,CD}(A, B)
   end
end
function SylvesterMap(A::AbstractMatrix, B::AbstractMatrix, ::CD = Continuous()) where {CD}
   T = promote_type(eltype(A), eltype(B))
   A = convert(AbstractMatrix{T}, A)
   B = convert(AbstractMatrix{T}, B)
   return SylvesterMap{T,typeof(A),typeof(B),CD}(A, B)
end

# LinearAlgebra.adjoint(L::SylvesterMap{<:Any,<:Any,<:Any,CD}) where {CD} =
#    SylvesterMap(L.A', L.B', CD())
# LinearAlgebra.transpose(L::SylvesterMap{<:Any,<:Any,<:Any,CD}) where {CD} =
#    SylvesterMap(L.A', L.B', CD())

"""
    M = sylvop(A, B; disc = false)

Define the continuous Sylvester operator `M: X -> AX+XB` if `disc = false`
or the discrete Sylvester operator `M: X -> AXB+X` if `disc = true`, where `A` and `B` are square matrices.
"""
sylvop(A::AbstractMatrix, B::AbstractMatrix; disc=false) =
   SylvesterMap(A, B, ifelse(disc, Discrete(), Continuous()))
sylvop(A::Schur, B::Schur; disc=false) = SylvesterMap(A.T, B.T, ifelse(disc, Discrete(), Continuous()))
function sylvop(A::Number, B::Number; disc=false)
   A, B = promote(A, B)
   SylvesterMap(fill(A, 1, 1), fill(B, 1, 1), ifelse(disc, Discrete(), Continuous()))
end
Base.size(L::SylvesterMap) = (N = size(L.A, 1) * size(L.B, 1); return (N, N))
function LinearMaps._unsafe_mul!(y::AbstractVector, L::SylvesterMap{T,<:Any,<:Any,Discrete}, x::AbstractVector) where T
   require_one_based_indexing(y, x)
   m = size(L.A, 1)
   n = size(L.B, 1)
   T1 = promote_type(T, eltype(x))
   X = reshape(convert(AbstractVector{T1}, x), (m, n))
   Y = reshape(y, (m, n))
   # Y = A * X * B + X
   copyto!(y, x)
   mul!(Y, L.A * X, L.B, true, true)
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(x::AbstractVector, LT::$ttype{T,SylvesterMap{T,TA,TB,Discrete}}, y::AbstractVector) where {T,TA,TB}
      require_one_based_indexing(y, x)
      m = size(LT.lmap.A, 1)
      n = size(LT.lmap.B, 1)
      T1 = promote_type(T, eltype(y))
      Y = reshape(convert(AbstractVector{T1}, y), (m, n))
      X = reshape(x, (m, n))
      # X = A' * Y * B' + X
      copyto!(x, y)
      mul!(X, LT.lmap.A' * Y, LT.lmap.B', true, true)
      return x
   end
end

function LinearMaps._unsafe_mul!(y::AbstractVector, L::SylvesterMap{T,<:Any,<:Any,Continuous}, x::AbstractVector) where T
   require_one_based_indexing(y, x)
   m = size(L.A, 1)
   n = size(L.B, 1)
   T1 = promote_type(T, eltype(x))
   X = reshape(convert(AbstractVector{T1}, x), (m, n))
   Y = reshape(y, (m, n))
   # Y = A * X + X * B
   mul!(Y, L.A, X)
   mul!(Y, X, L.B, true, true)
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(x::AbstractVector, LT::$ttype{T,SylvesterMap{T,TA,TB,Continuous}}, y::AbstractVector) where {T,TA,TB}
      require_one_based_indexing(y, x)
      m = size(LT.lmap.A, 1)
      n = size(LT.lmap.B, 1)
      T1 = promote_type(T, eltype(y))
      Y = reshape(convert(AbstractVector{T1}, y), (m, n))
      X = reshape(x, (m, n))
      # X = A' * Y + Y * B'
      mul!(X, LT.lmap.A', Y)
      mul!(X, Y, LT.lmap.B', true, true)
      return x
   end
end

struct InverseSylvesterMap{T,TA <: AbstractMatrix,TB <: AbstractMatrix,CD} <: SylvesterMatrixEquationsMaps{T}
   A::TA
   B::TB
   adjA::Bool
   adjB::Bool
   sf::Bool
   function InverseSylvesterMap{T,TA,TB,CD}(A::AbstractMatrix{T}, B::AbstractMatrix{T}) where {T,TA,TB,CD}
      LinearAlgebra.checksquare(A, B)
      adjA = isa(A, Adjoint)
      adjB = isa(B, Adjoint)
      A = adjA ? A.parent : A
      B = adjB ? B.parent : B
      schur_flag = isschur(A) && isschur(B)
      return new{T,typeof(A),typeof(B),CD}(A, B, adjA, adjB, schur_flag)
   end
end
function InverseSylvesterMap(A::AbstractMatrix, B::AbstractMatrix, ::CD = Continuous) where {CD}
   T = promote_type(eltype(A), eltype(B))
   A = convert(AbstractMatrix{T}, A)
   B = convert(AbstractMatrix{T}, B)
   return InverseSylvesterMap{T,typeof(A),typeof(B),CD}(A, B)
end

LinearAlgebra.adjoint(L::InverseSylvesterMap{<:Any,<:Any,<:Any,CD}) where {CD} =
   InverseSylvesterMap(L.adjA ? L.A : L.A', L.adjB ? L.B : L.B', CD())
LinearAlgebra.transpose(L::InverseSylvesterMap{<:Any,<:Any,<:Any,CD}) where {CD} =
   InverseSylvesterMap(L.adjA ? L.A : L.A', L.adjB ? L.B : L.B', CD())
LinearAlgebra.inv(L::SylvesterMap{<:Any,<:Any,<:Any,CD}) where {CD} =
   InverseSylvesterMap(L.A, L.B, CD())
LinearAlgebra.inv(L::InverseSylvesterMap{<:Any,<:Any,<:Any,CD}) where {CD} =
   SylvesterMap(L.adjA ? L.A' : L.A, L.adjB ? L.B' : L.B, CD())

"""
    MINV = invsylvop(A, B; disc = false)

Define `MINV`, the inverse of the continuous Sylvester operator  `M: X -> AX+XB` if `disc = false`
or of the discrete Sylvester operator `M: X -> AXB+X` if `disc = true`, where `A` and `B` are square matrices.
"""
function invsylvop(A::AbstractMatrix, B::AbstractMatrix; disc=false)
   InverseSylvesterMap(A, B, ifelse(disc, Discrete(), Continuous()))
end
invsylvop(A::Schur, B::Schur; disc=false) =
   InverseSylvesterMap(A.T, B.T, ifelse(disc, Discrete(), Continuous()))
function invsylvop(A::Number, B::Number; disc=false)
   A, B = promote(A, B)
   InverseSylvesterMap(fill(A, 1, 1), fill(B, 1, 1), ifelse(disc, Discrete(), Continuous()))
end
Base.size(L::InverseSylvesterMap) = (N = size(L.A, 1) * size(L.B, 1); return (N, N))
function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseSylvesterMap{T,<:Any,<:Any,Discrete}, x::AbstractVector) where {T}
   m = size(L.A, 1)
   n = size(L.B, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.sf
         copyto!(y, x)
         Y = reshape(y, (m, n))
         sylvds!(L.A, L.B, Y, adjA=L.adjA, adjB=L.adjB)
      else
         Y = reshape(convert(AbstractVector{T1}, x), m, n)
         copyto!(y, sylvd(L.adjA ? L.A' : L.A, L.adjB ? L.B' : L.B, Y))
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseSylvesterMap{T,<:Any,<:Any,Continuous}, x::AbstractVector) where T
   m = size(L.A, 1)
   n = size(L.B, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.sf
         copyto!(y, x)
         Y = reshape(y, (m, n))
         sylvcs!(L.A, L.B, Y, adjA=L.adjA, adjB=L.adjB)
      else
         Y = reshape(convert(AbstractVector{T1}, x), m, n)
         copyto!(y, sylvc(L.adjA ? L.A' : L.A, L.adjB ? L.B' : L.B, Y))
      end
      return y
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
end

struct GeneralizedSylvesterMap{T,TA <: AbstractMatrix,TB <: AbstractMatrix,TC <: AbstractMatrix,TD <: AbstractMatrix} <: SylvesterMatrixEquationsMaps{T}
   A::TA
   B::TB
   C::TC
   D::TD
   function GeneralizedSylvesterMap(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix)
      m, n = LinearAlgebra.checksquare(A, B)
      [m, n] == LinearAlgebra.checksquare(C, D) ||
               throw(DimensionMismatch("A, B, C and D have incompatible dimensions"))
      T = promote_type(map(eltype, (A, B, C, D))...)
      A = convert(AbstractMatrix{T}, A)
      B = convert(AbstractMatrix{T}, B)
      C = convert(AbstractMatrix{T}, C)
      D = convert(AbstractMatrix{T}, D)
      return new{T,typeof(A),typeof(B),typeof(C),typeof(D)}(A, B, C, D)
   end
end

"""
    M = sylvop(A, B, C, D)

Define the generalized Sylvester operator `M: X -> AXB+CXD`, where `(A,C)` and `(B,D)` are pairs of square matrices.
"""
sylvop(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix) =
   GeneralizedSylvesterMap(A, B, C, D)
Base.size(L::GeneralizedSylvesterMap) = (N = size(L.A, 1) * size(L.B, 1); return (N, N))
function LinearMaps._unsafe_mul!(y::AbstractVector, L::GeneralizedSylvesterMap{T}, x::AbstractVector) where T
   require_one_based_indexing(y, x)
   m = size(L.A, 1)
   n = size(L.B, 1)
   T1 = promote_type(T, eltype(x))
   X = reshape(convert(AbstractVector{T1}, x), (m, n))
   Y = reshape(y, (m, n))
   # Y = A * X * B + C * X * D
   temp = similar(Y, (m, n))
   mul!(temp, L.A, X)
   mul!(Y, temp, L.B, 1, 0)
   mul!(temp, L.C, X)
   mul!(Y, temp, L.D, 1, 1)
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(x::AbstractVector, LT::$ttype{T,GeneralizedSylvesterMap{T,TA,TB,TC,TD}}, y::AbstractVector) where {T,TA,TB,TC,TD}
      require_one_based_indexing(y, x)
      m = size(LT.lmap.A, 1)
      n = size(LT.lmap.B, 1)
      T1 = promote_type(T, eltype(y))
      Y = reshape(convert(AbstractVector{T1}, y), (m, n))
      X = reshape(x, (m, n))
      temp = similar(Y, (m, n))
      # X = A' * Y * B' + C' * Y * D'
      mul!(temp, LT.lmap.A', Y)
      mul!(X, temp, LT.lmap.B', true, false)
      mul!(temp, LT.lmap.C', Y)
      mul!(X, temp, LT.lmap.D', true, true)
      return x
   end
end

struct InverseGeneralizedSylvesterMap{T,TA <: AbstractMatrix,TB <: AbstractMatrix,TC <: AbstractMatrix,TD <: AbstractMatrix} <: SylvesterMatrixEquationsMaps{T}
   A::TA
   B::TB
   C::TC
   D::TD
   adjAC::Bool
   adjBD::Bool
   sf::Bool
   BDSchur::Bool
   DBSchur::Bool
   function InverseGeneralizedSylvesterMap(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix)
      m, n = LinearAlgebra.checksquare(A, B)
      [m, n] == LinearAlgebra.checksquare(C, D) ||
               throw(DimensionMismatch("A, B, C and D have incompatible dimensions"))
      adjAC = isa(A, Adjoint) && isa(C, Adjoint)
      adjBD = isa(B, Adjoint) && isa(D, Adjoint)
      ACSchur = (adjAC ? isschur(A.parent, C.parent) : isschur(A, C))
      BDSchur = (adjBD ? isschur(B.parent, D.parent) : isschur(B, D))
      DBSchur = (adjBD ? isschur(D.parent, B.parent) : isschur(D, B))
      schur_flag = ACSchur && (BDSchur || DBSchur)
      A = adjAC ? A.parent : A
      B = adjBD ? B.parent : B
      C = adjAC ? C.parent : C
      D = adjBD ? D.parent : D
      T = promote_type(map(eltype, (A, B, C, D))...)
      A = convert(AbstractMatrix{T}, A)
      B = convert(AbstractMatrix{T}, B)
      C = convert(AbstractMatrix{T}, C)
      D = convert(AbstractMatrix{T}, D)
    return new{T,typeof(A),typeof(B),typeof(C),typeof(D)}(A, B, C, D, adjAC, adjBD, schur_flag, BDSchur, DBSchur)
   end
end

LinearAlgebra.adjoint(L::InverseGeneralizedSylvesterMap) =
   InverseGeneralizedSylvesterMap(L.adjAC ? L.A : L.A', L.adjBD ? L.B : L.B',
                                    L.adjAC ? L.C : L.C', L.adjBD ? L.D : L.D')
LinearAlgebra.transpose(L::InverseGeneralizedSylvesterMap) =
   InverseGeneralizedSylvesterMap(L.adjAC ? L.A : L.A', L.adjBD ? L.B : L.B',
                                    L.adjAC ? L.C : L.C', L.adjBD ? L.D : L.D')
LinearAlgebra.inv(L::GeneralizedSylvesterMap) =
   InverseGeneralizedSylvesterMap(L.A, L.B, L.C, L.D)
LinearAlgebra.inv(L::InverseGeneralizedSylvesterMap) =
   GeneralizedSylvesterMap(L.adjAC ? L.A' : L.A, L.adjBD ? L.B' : L.B,
                           L.adjAC ? L.C' : L.C, L.adjBD ? L.D' : L.D)

"""
    MINV = invsylvop(A, B, C, D)

Define `MINV`, the inverse of the generalized Sylvester operator `M: X -> AXB+CXD`,
where (A,C) and (B,D) are pairs of square matrices.
"""
invsylvop(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix) =
   InverseGeneralizedSylvesterMap(A, B, C, D)
invsylvop(F::GeneralizedSchur, G::GeneralizedSchur) = invsylvop(F.S, G.S, F.T, G.T)
Base.size(L::InverseGeneralizedSylvesterMap) = (N = size(L.A, 1) * size(L.B, 1); return (N, N))
function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseGeneralizedSylvesterMap{T}, x::AbstractVector) where T
   m = size(L.A, 1)
   n = size(L.B, 1)
   T1 = promote_type(T, eltype(x))
   try
      if L.sf
         copyto!(y, x)
         Y = reshape(y, m, n)
         gsylvs!(L.A, L.B, L.C, L.D, Y, adjAC=L.adjAC, adjBD=L.adjBD, DBSchur=L.DBSchur && !L.BDSchur)
      else
         X = reshape(convert(AbstractVector{T1}, x), m, n)
         copyto!(y, gsylv(L.adjAC ? L.A' : L.A, L.adjBD ? L.B' : L.B,
                           L.adjAC ? L.C' : L.C, L.adjBD ? L.D' : L.D, X))
      end
   catch err
      findfirst("SingularException", string(err)) === nothing &&
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
   return y
end

struct SylvesterSystemMap{T,TA <: AbstractMatrix,TB <: AbstractMatrix,TC <: AbstractMatrix,TD <: AbstractMatrix} <: SylvesterMatrixEquationsMaps{T}
   A::TA
   B::TB
   C::TC
   D::TD
   function SylvesterSystemMap(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix)
      m, n = LinearAlgebra.checksquare(A, B)
      [m, n] == LinearAlgebra.checksquare(C, D) ||
         throw(DimensionMismatch("A, B, C and D have incompatible dimensions"))
      T = promote_type(map(eltype, (A, B, C, D))...)
      A = convert(AbstractMatrix{T}, A)
      B = convert(AbstractMatrix{T}, B)
      C = convert(AbstractMatrix{T}, C)
      D = convert(AbstractMatrix{T}, D)
      return new{T,typeof(A),typeof(B),typeof(C),typeof(D)}(A, B, C, D)
   end
end

"""
    M = sylvsysop(A, B, C, D)

Define the operator `M: (X,Y) -> (AX+YB, CX+YD)`, where `(A,C)` and `(B,D)` are pairs of
square matrices.
"""
sylvsysop(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix) =
   SylvesterSystemMap(A, B, C, D)
Base.size(L::SylvesterSystemMap) = (N = size(L.A, 1) * size(L.B, 1) * 2; return (N, N))
function LinearMaps._unsafe_mul!(y::AbstractVector, L::SylvesterSystemMap{T}, x::AbstractVector) where T
   require_one_based_indexing(y, x)
   m = size(L.A, 1)
   n = size(L.B, 1)
   mn = m * n
   T1 = promote_type(T, eltype(x))
   X1 = reshape(convert(AbstractVector{T1}, view(x, 1:mn)), m, n)
   X2 = reshape(convert(AbstractVector{T1}, view(x, mn + 1:2 * mn)), m, n)
   U = reshape(view(y, 1:m * n), (m, n))
   V = reshape(view(y, mn + 1:2 * mn), (m, n))
   # U = A * X + Y * B
   # V = C * X + Y * D
   mul!(U, L.A, X1)
   mul!(U, X2, L.B, 1, 1)
   mul!(V, L.C, X1)
   mul!(V, X2, L.D, 1, 1)
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(y::AbstractVector, LT::$ttype{T,<:SylvesterSystemMap{T}}, x::AbstractVector) where T
      require_one_based_indexing(y, x)
      m = size(LT.lmap.A, 1)
      n = size(LT.lmap.B, 1)
      mn = m * n
      T1 = promote_type(T, eltype(x))
      X1 = reshape(convert(AbstractVector{T1}, view(x, 1:mn)), m, n)
      X2 = reshape(convert(AbstractVector{T1}, view(x, mn + 1:2 * mn)), m, n)
      U = reshape(view(y, 1:m * n), (m, n))
      V = reshape(view(y, mn + 1:2 * mn), (m, n))
      # U = A' * X + C' * Y
      # V = X * B' + Y * D'
      mul!(U, LT.lmap.A', X1)
      mul!(U, LT.lmap.C', X2, 1, 1)
      mul!(V, X1, LT.lmap.B')
      mul!(V, X2, LT.lmap.D', 1, 1)
      return y
   end
end

struct InverseSylvesterSystemMap{T,TA <: AbstractMatrix,TB <: AbstractMatrix,TC <: AbstractMatrix,TD <: AbstractMatrix} <: SylvesterMatrixEquationsMaps{T}
   A::TA
   B::TB
   C::TC
   D::TD
   sf::Bool
   function InverseSylvesterSystemMap(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix)
      m, n = LinearAlgebra.checksquare(A, B)
      [m, n] == LinearAlgebra.checksquare(C, D) ||
               throw(DimensionMismatch("A, B, C and D have incompatible dimensions"))
      T = promote_type(map(eltype, (A, B, C, D))...)
      A = convert(AbstractMatrix{T}, A)
      B = convert(AbstractMatrix{T}, B)
      C = convert(AbstractMatrix{T}, C)
      D = convert(AbstractMatrix{T}, D)
      schur_flag = isschur(A, C) && isschur(B, D)
      return new{T,typeof(A),typeof(B),typeof(C),typeof(D)}(A, B, C, D, schur_flag)
   end
end

LinearAlgebra.inv(L::SylvesterSystemMap) = InverseSylvesterSystemMap(L.A, L.B, L.C, L.D)
LinearAlgebra.inv(L::InverseSylvesterSystemMap) = SylvesterSystemMap(L.A, L.B, L.C, L.D)

"""
    MINV = invsylvsysop(A, B, C, D)

Define `MINV`, the inverse of the linear operator `M: (X,Y) -> (AX+YB, CX+YD )`,
where `(A,C)` and `(B,D)` a pairs of square matrices.
"""
invsylvsysop(A::AbstractMatrix, B::AbstractMatrix, C::AbstractMatrix, D::AbstractMatrix) =
   InverseSylvesterSystemMap(A, B, C, D)
invsylvsysop(AC::GeneralizedSchur, BD::GeneralizedSchur) =
   InverseSylvesterSystemMap(AC.S, BD.S, AC.T, BD.T)
Base.size(L::InverseSylvesterSystemMap) = (N = size(L.A, 1) * size(L.B, 1) * 2; return (N, N))
function LinearMaps._unsafe_mul!(y::AbstractVector, L::InverseSylvesterSystemMap{T}, x::AbstractVector) where T
   require_one_based_indexing(y, x)
   m = size(L.A, 1)
   n = size(L.B, 1)
   T1 = promote_type(T, eltype(x))
   mn = m * n
   E = reshape(eltype(x) == T1 ? x[1:mn] : convert(Vector{T1}, view(x, 1:m * n)), m, n)
   F = reshape(eltype(x) == T1 ? x[mn + 1:2 * mn] : convert(Vector{T1}, view(x, mn + 1:2 * mn)), m, n)
   Y1 = view(y, 1:mn)
   Y2 = view(y, mn + 1:2mn)
   try
      if L.sf
         X1, X2 = sylvsyss!(L.A, L.B, E, L.C, L.D, F)
         copyto!(Y1, X1)
         copyto!(Y2, X2)
      else
         X1, X2  = sylvsys(L.A, L.B, E, L.C, L.D, F)
         copyto!(Y1, X1)
         copyto!(Y2, X2)
      end
   catch err
      findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
   end
   return y
end
for ttype in (LinearMaps.TransposeMap, LinearMaps.AdjointMap)
   @eval function LinearMaps._unsafe_mul!(y::AbstractVector, L::$ttype{T,<:InverseSylvesterSystemMap}, x::AbstractVector) where T
      require_one_based_indexing(y, x)
      m = size(L.lmap.A, 1)
      n = size(L.lmap.B, 1)
      mn = m * n
      T1 = promote_type(T, eltype(x))
      E = reshape(eltype(x) == T1 ? x[1:mn] : convert(Vector{T1}, view(x, 1:mn)), m, n)
      F = reshape(eltype(x) == T1 ? x[mn + 1:2 * mn] : convert(Vector{T1}, view(x, mn + 1:2 * mn)), m, n)
      Y1 = view(y, 1:mn)
      Y2 = view(y, mn + 1:2mn)
      try
         if L.lmap.sf
            X1, X2 = dsylvsyss!(true,L.lmap.A, L.lmap.B, E, L.lmap.C, L.lmap.D, F)
            copyto!(Y1, X1)
            copyto!(Y2, X2)
         else
            X1, X2 = dsylvsys(L.lmap.A', L.lmap.B', E, L.lmap.C', L.lmap.D', F)
            copyto!(Y1, X1)
            copyto!(Y2, X2)
         end
      catch err
         findfirst("LAPACKException", string(err)) === nothing ? rethrow() : throw("ME:SingularException: Singular operator")
      end
      return y
   end
end
struct GeneralizedTSylvesterMap{T,TA,TB,TC,TD,TH<:TtypeOrHtype} <: SylvesterMatrixEquationsMaps{T}
   A::TA
   B::TB
   C::TC
   D::TD
   m::Int
   n::Int
   mx::Int
   nx::Int
   function GeneralizedTSylvesterMap{T,TA,TB,TC,TD,TH}(A, B, C, D; mx = -1, nx = -1) where {T,TA,TB,TC,TD,TH}
      la = length(A)
      la == length(B) ||  throw(DimensionMismatch("A and B must have the same lengths"))
      lc = length(C)
      lc == length(D) ||  throw(DimensionMismatch("C and D must have the same lengths"))
      la+lc > 0 || throw(DimensionMismatch("either A or C must be non-empty"))
      m = mx; n = nx; 
      squareA = any(isa.(A,UniformScaling)) 
      squareC = any(isa.(C,UniformScaling))
      squareB = any(isa.(B,UniformScaling)) 
      squareD = any(isa.(D,UniformScaling))
      for i = 1:la
          isa(A[i],UniformScaling) && continue
          if m < 0 
             m = size(A[i],1)
             mx < 0 ? mx = size(A[i],2) : (mx == size(A[i],2) || throw(DimensionMismatch("all matrices in vector A must have column dimension $mx but A[$i] has column dimension $(size(A[i],2))")) )
             (squareA && m != mx) && throw(DimensionMismatch("all matrices in vector A must be square")) 
             continue
          else
             mx < 0 && (mx = size(A[i],2))
          end
          (m == size(A[i],1) && mx == size(A[i],2)) || throw(DimensionMismatch("all matrices in vector A must have the same dimensions"))
      end
      for i = 1:la
         isa(B[i],UniformScaling) && continue
         if n < 0 
            n = size(B[i],2)
            nx < 0 ? nx = size(B[i],1) : (nx == size(B[i],1) || throw(DimensionMismatch("all matrices in vector B must have row dimension $nx but B[$i] has row dimension $(size(B[i],1))")) )
            (squareB && n != nx) && throw(DimensionMismatch("all matrices in vector B must be square")) 
            continue
         else
            nx < 0 && (nx = size(B[i],1)) 
         end
         (n == size(B[i],2) && nx == size(B[i],1)) || throw(DimensionMismatch("all matrices in vector B must have the same dimensions"))
      end
      for i = 1:lc
          isa(C[i],UniformScaling) && continue
          if m < 0 
             m = size(C[i],1)
             nx < 0 ? nx = size(C[i],2) : (nx == size(C[i],2) || throw(DimensionMismatch("all matrices in vector C must have column dimension $nx but C[$i] has column dimension $(size(C[i],2))")) )
             (squareC && m != nx) && throw(DimensionMismatch("all matrices in vector C must be square")) 
             continue
          else
             nx < 0 && (nx = size(C[i],2))
          end
          (m == size(C[i],1) && nx == size(C[i],2)) || throw(DimensionMismatch("all matrices in vector C must have the same dimensions"))
      end
      for i = 1:lc
          isa(D[i],UniformScaling) && continue
          if n < 0 
             n = size(D[i],2)
             mx < 0 ? mx = size(D[i],1) : (mx == size(D[i],1) || throw(DimensionMismatch("all matrices in vector D must have row dimension $mx but D[$i] has row dimension $(size(D[i],1))")) )
             (squareD && n != mx) && throw(DimensionMismatch("all matrices in vector D must be square")) 
             continue
          else 
             mx < 0 && (mx = size(D[i],1))             
          end
          (n == size(D[i],2) && mx == size(D[i],1)) || throw(DimensionMismatch("all matrices in vector D must have the same dimensions"))
      end
      (m >= 0 && mx >= 0) || throw(DimensionMismatch("at least one of elements of A or D must be a matrix; use mx to specify the row dimension of X"))
      (n >= 0 && nx >= 0) || throw(DimensionMismatch("at least one of elements of B or C must be a matrix; use nx to specify the column dimension of X"))
          
      T1 = promote_type(eltype.(A)...)       
      T1 = promote_type(T1, eltype.(B)...)       
      T1 = promote_type(T1, eltype.(C)...)       
      T1 = promote_type(T1, eltype.(D)...)      
      T1 == Bool && (T1 = Float64) 
      A1 = [ isa(A[i],UniformScaling) ? convert(UniformScaling{T}, A[i]) : convert(AbstractMatrix{T}, A[i]) for i in 1:la ]
      B1 = [ isa(B[i],UniformScaling) ? convert(UniformScaling{T}, B[i]) : convert(AbstractMatrix{T}, B[i]) for i in 1:la ]
      C1 = [ isa(C[i],UniformScaling) ? convert(UniformScaling{T}, C[i]) : convert(AbstractMatrix{T}, C[i]) for i in 1:lc ]
      D1 = [ isa(D[i],UniformScaling) ? convert(UniformScaling{T}, D[i]) : convert(AbstractMatrix{T}, D[i]) for i in 1:lc ]
      return new{T1,typeof(A1),typeof(B1),typeof(C1),typeof(D1),TH}(A1, B1, C1, D1, m, n, mx, nx)
   end
end
function GeneralizedTSylvesterMap(A, B, C, D, ::TH = Ttype(); mx = -1, nx = -1) where {TH}
   la = length(A)
   la == length(B) ||  throw(DimensionMismatch("A and B must have the same lengths"))
   lc = length(C)
   lc == length(D) ||  throw(DimensionMismatch("C and D must have the same lengths"))
   la+lc > 0 || throw(DimensionMismatch("either A or C must be non-empty"))
   T = promote_type(eltype.(A)...)       
   T = promote_type(T, eltype.(B)...)       
   T = promote_type(T, eltype.(C)...)       
   T = promote_type(T, eltype.(D)...)      
   T == Bool && (T = Float64) 
   A1 = [ isa(A[i],UniformScaling) ? convert(UniformScaling{T}, A[i]) : convert(AbstractMatrix{T}, A[i]) for i in 1:la ]
   B1 = [ isa(B[i],UniformScaling) ? convert(UniformScaling{T}, B[i]) : convert(AbstractMatrix{T}, B[i]) for i in 1:la ]
   C1 = [ isa(C[i],UniformScaling) ? convert(UniformScaling{T}, C[i]) : convert(AbstractMatrix{T}, C[i]) for i in 1:lc ]
   D1 = [ isa(D[i],UniformScaling) ? convert(UniformScaling{T}, D[i]) : convert(AbstractMatrix{T}, D[i]) for i in 1:lc ]
   return GeneralizedTSylvesterMap{T,typeof(A1),typeof(B1),typeof(C1),typeof(D1),TH}(A1, B1, C1, D1; mx, nx)
end
"""
    M = gsylvop(A, B, C, D; mx, nx, htype = false)

Define the generalized T-Sylvester operator `M: X -> ∑ A_i*X*B_i + ∑ C_j'*transpose(X)*D_j`, if `htype = false` or
the generalized H-Sylvester operator `M: X -> ∑ A_i*X*B_i + ∑ C_j'*X'*D_j`, if `htype = true`.
`A_i` and `C_j` are matrices having the same row dimension and `B_i` and `D_j` are matrices having the same column dimension. 
`A_i` and `B_i` are contained in the `k`-vectors of matrices `A` and `B`, respectively, and 
`C_j` and `D_j` are contained in the `l`-vectors of matrices `C` and `D`, respectively. Any of the component matrices can be given as an `UniformScaling`. 
The keyword parameters `mx` and `nx` can be used to specify the row and column dimensions of `X`, if they cannot be inferred from the data.   
"""
function gsylvop(A, B, C, D; mx = -1, nx = -1, htype = false)
    GeneralizedTSylvesterMap(A, B, C, D, ifelse(htype, Htype(), Ttype()); mx, nx)
end
Base.size(L::GeneralizedTSylvesterMap) = (M = L.m*L.n; N = L.mx * L.nx; return (M, N))
function LinearMaps._unsafe_mul!(y::AbstractVector, L::GeneralizedTSylvesterMap{T,<:Any,<:Any,<:Any,<:Any,Ttype}, x::AbstractVector) where T
   T1 = promote_type(T, eltype(x))
   X = reshape(convert(AbstractVector{T1}, x), (L.mx, L.nx))
   Y = reshape(y, (L.m, L.n))
   # Y = ∑ A_i * X * B_i + ∑ C_j * transpose(X) * D_j
   la = length(L.A)
   lc = length(L.C)
   temp = similar(Y, (L.m, L.nx))
   if la > 0
      mul!(temp, L.A[1], X)
      mul!(Y, temp, L.B[1], 1, 0)
      for i = 2:la
          mul!(temp, L.A[i], X)
          mul!(Y, temp, L.B[i], 1, 1)
      end
   end
   temp = similar(Y, (L.m, L.mx))
   if lc > 0
      mul!(temp, L.C[1], transpose(X))
      mul!(Y, temp, L.D[1], 1, la> 0 ? 1 : 0)
      for i = 2:lc
          mul!(temp, L.C[i], transpose(X))
          mul!(Y, temp, L.D[i], 1, 1)
      end
   end
   return y
end
function LinearMaps._unsafe_mul!(x::AbstractVector, L::LinearMaps.TransposeMap{T,<:GeneralizedTSylvesterMap{T,<:Any,<:Any,<:Any,<:Any,Ttype}}, y::AbstractVector) where T
   T1 = promote_type(T, eltype(y))
   Y = reshape(convert(AbstractVector{T1}, y), (L.lmap.m, L.lmap.n))
   X = reshape(x, (L.lmap.mx, L.lmap.nx))
   # X = ∑ transpose(A_i) * Y * transpose(B_i) + ∑ D_j * transpose(Y) * C_j
   la = length(L.lmap.A)
   lc = length(L.lmap.C)
   temp = similar(Y, (L.lmap.mx, L.lmap.n))
   if la > 0
      mul!(temp, transpose(L.lmap.A[1]), Y)
      mul!(X, temp, transpose(L.lmap.B[1]), 1, 0)
      for i = 2:la
          mul!(temp, transpose(L.lmap.A[i]), Y)
          mul!(X, temp, transpose(L.lmap.B[i]), 1, 1)
      end
   end
   temp = similar(Y, (L.lmap.mx, L.lmap.m))
   if lc > 0
      mul!(temp, L.lmap.D[1], transpose(Y))
      mul!(X, temp, L.lmap.C[1], 1, la> 0 ? 1 : 0)
      for i = 2:lc
          mul!(temp, L.lmap.D[i], transpose(Y))
          mul!(X, temp, L.lmap.C[i], 1, 1)
      end
   end
   return x
end
function LinearMaps._unsafe_mul!(x::AbstractVector, L::LinearMaps.AdjointMap{T,<:GeneralizedTSylvesterMap{T,<:Any,<:Any,<:Any,<:Any,Ttype}}, y::AbstractVector) where T
   T1 = promote_type(T, eltype(y))
   Y = reshape(convert(AbstractVector{T1}, y), (L.lmap.m, L.lmap.n))
   X = reshape(x, (L.lmap.mx, L.lmap.nx))
   # X = ∑ transpose(A_i) * Y * transpose(B_i) + ∑ D_j * transpose(Y) * C_j
   la = length(L.lmap.A)
   lc = length(L.lmap.C)
   temp = similar(Y, (L.lmap.mx, L.lmap.n))
   if la > 0
      mul!(temp, L.lmap.A[1]', Y)
      mul!(X, temp, L.lmap.B[1]', 1, 0)
      for i = 2:la
          mul!(temp, L.lmap.A[i]', Y)
          mul!(X, temp, L.lmap.B[i]', 1, 1)
      end
   end
   temp = similar(Y, (L.lmap.mx, L.lmap.m))
   if lc > 0
      mul!(temp, conj(L.lmap.D[1]), transpose(Y))
      mul!(X, temp, conj(L.lmap.C[1]), 1, la> 0 ? 1 : 0)
      for i = 2:lc
          mul!(temp, conj(L.lmap.D[i]), transpose(Y))
          mul!(X, temp, conj(L.lmap.C[i]), 1, 1)
      end
   end
   return x
end
function LinearMaps._unsafe_mul!(y::AbstractVector, L::GeneralizedTSylvesterMap{T,<:Any,<:Any,<:Any,<:Any,Htype}, x::AbstractVector) where T
   T1 = promote_type(T, eltype(x))
   X = reshape(convert(AbstractVector{T1}, x), (L.mx, L.nx))
   Y = reshape(y, (L.m, L.n))
   # Y = ∑ A_i * X * B_i + ∑ C_j * X' * D_j
   la = length(L.A)
   lc = length(L.C)
   temp = similar(Y, (L.m, L.nx))
   if la > 0
      mul!(temp, L.A[1], X)
      mul!(Y, temp, L.B[1], 1, 0)
      for i = 2:la
          mul!(temp, L.A[i], X)
          mul!(Y, temp, L.B[i], 1, 1)
      end
   end
   temp = similar(Y, (L.m, L.mx))
   if lc > 0
      mul!(temp, L.C[1], X')
      mul!(Y, temp, L.D[1], 1, la> 0 ? 1 : 0)
      for i = 2:lc
          mul!(temp, L.C[i], X')
          mul!(Y, temp, L.D[i], 1, 1)
      end
   end
   return y
end
# function LinearMaps._unsafe_mul!(x::AbstractVector, L::LinearMaps.TransposeMap{T,<:GeneralizedTSylvesterMap{T,<:Any,<:Any,<:Any,<:Any,Htype}}, y::AbstractVector) where T
#    T1 = promote_type(T, eltype(y))
#    Y = reshape(convert(AbstractVector{T1}, y), (L.lmap.m, L.lmap.n))
#    X = reshape(x, (L.lmap.mx, L.lmap.nx))
#    # X = ∑ transpose(A_i) * Y * transpose(B_i) + ∑ D_j * transpose(Y) * C_j
#    la = length(L.lmap.A)
#    lc = length(L.lmap.C)
#    temp = similar(Y, (L.lmap.mx, L.lmap.n))
#    if la > 0
#       mul!(temp, transpose(L.lmap.A[1]), Y)
#       mul!(X, temp, transpose(L.lmap.B[1]), 1, 0)
#       for i = 2:la
#           mul!(temp, transpose(L.lmap.A[i]), Y)
#           mul!(X, temp, transpose(L.lmap.B[i]), 1, 1)
#       end
#    end
#    temp = similar(Y, (L.lmap.mx, L.lmap.m))
#    if lc > 0
#       mul!(temp, L.lmap.D[1], transpose(Y))
#       mul!(X, temp, L.lmap.C[1], 1, la> 0 ? 1 : 0)
#       for i = 2:lc
#           mul!(temp, L.lmap.D[i], transpose(Y))
#           mul!(X, temp, L.lmap.C[i], 1, 1)
#       end
#    end
#    return x
# end
function LinearMaps._unsafe_mul!(x::AbstractVector, L::LinearMaps.AdjointMap{T,<:GeneralizedTSylvesterMap{T,<:Any,<:Any,<:Any,<:Any,Htype}}, y::AbstractVector) where T
   T1 = promote_type(T, eltype(y))
   Y = reshape(convert(AbstractVector{T1}, y), (L.lmap.m, L.lmap.n))
   X = reshape(x, (L.lmap.mx, L.lmap.nx))
   # X = ∑ A_i' * Y * B_i' + ∑ D_j * Y' * C_j
   la = length(L.lmap.A)
   lc = length(L.lmap.C)
   temp = similar(Y, (L.lmap.mx, L.lmap.n))
   if la > 0
      mul!(temp, L.lmap.A[1]', Y)
      mul!(X, temp, L.lmap.B[1]', 1, 0)
      for i = 2:la
          mul!(temp, L.lmap.A[i]', Y)
          mul!(X, temp, L.lmap.B[i]', 1, 1)
      end
   end
   temp = similar(Y, (L.lmap.mx, L.lmap.m))
   if lc > 0
      mul!(temp, L.lmap.D[1], Y')
      mul!(X, temp, L.lmap.C[1], 1, la> 0 ? 1 : 0)
      for i = 2:lc
          mul!(temp, L.lmap.D[i], Y')
          mul!(X, temp, L.lmap.C[i], 1, 1)
      end
   end
   return x
end

# Lyapunov Matrix Equation Solvers

## Continuous-time Lyapunov Matrix Equations

```@docs
lyapc
lyapcs!
tlyapc
hlyapc
tulyapc!
hulyapc!
```

## Discrete-time Lyapunov (Stein) Matrix Equations

```@docs
lyapd
lyapds!
```

# Iterative Solvers

## Conjugate Gradient based Solution of Linear Equations

```@docs
cgls
```

## Continuous-time Lyapunov and Lyapunov-like Matrix Equations

```@docs
lyapci
plyapci
lyapdi
plyapdi
tlyapci
hlyapci
tulyapci
hulyapci
```

## Sylvester and Sylvester-like Matrix Equations

```@docs
sylvci
sylvdi
gsylvi
gtsylvi
ghsylvi
```

# Sylvester Matrix Equation Solvers

## Standard Sylvester Matrix Equations

```@docs
sylvc
sylvcs!
sylvd
sylvds!
```

## Generalized Sylvester Matrix Equations

```@docs
gsylv
gsylvs!
```

## Sylvester Systems of Matrix Equation

```@docs
sylvsys
sylvsyss!
dsylvsys
dsylvsyss!
```

# Positive-definite Lyapunov Matrix Equation Solvers

## Continuous-time Lyapunov Matrix Equations

```@docs
plyapc
plyapcs!
```

## Discrete-time Lyapunov (Stein) Matrix Equations

```@docs
plyapd
plyapds!
```

## Schur Form Based Solvers

```@docs
plyaps
```

# Linear Operators Related to Matrix Equation Solvers

## Lyapunov and Lyapunov-like Operators

```@docs
lyapop
invlyapop
lyaplikeop
tulyaplikeop
hulyaplikeop
```

## Sylvester and Sylvester-like Operators

```@docs
sylvop
invsylvop
gsylvop
```

## Sylvester System Operators

```@docs
sylvsysop
invsylvsysop
```

## Elementary Matrix Operators

```@docs
trmatop
eliminationop
duplicationop
```

# Index

```@index
Pages = ["lyapunov.md", "plyapunov.md", "riccati.md", "sylvester.md", "sylvkr.md", "iterative.md", "condest.md","meoperators.md", "lapackutil.md" ]
Module = ["MatrixEquations"]
Order = [:type, :function]
```

```@meta
CurrentModule = MatrixEquations
DocTestSetup = quote
    using MatrixEquations
end
```

# MatrixEquations.jl

[![DocBuild](https://github.com/andreasvarga/MatrixEquations.jl/workflows/CI/badge.svg)](https://github.com/andreasvarga/MatrixEquations.jl/actions)
[![Code on Github.](https://img.shields.io/badge/code%20on-github-blue.svg)](https://github.com/andreasvarga/MatrixEquations.jl)

This collection of Julia functions is an attemp to implement high performance
numerical software to solve classes of Lyapunov, Sylvester and Riccati matrix equations
at a performance level comparable with efficient structure exploiting Fortran implementations, as those available in the Systems and Control Library [SLICOT](https://github.com/SLICOT).
This goal has been fully achieved for Lyapunov and Sylvester equation solvers, for which the
codes for both real and complex data perform at practically same performance level as similar functions available in
the MATLAB Control System Toolbox (which rely on SLICOT).

The available functions in the `MatrixEquations.jl` package cover both standard
and generalized continuous and discrete Lyapunov, Sylvester and Riccati equations for both real and complex data. The functions for the solution of Lyapunov and Sylvester equations rely on efficient structure exploiting solvers for which the input data are in Schur or generalized Schur forms. A comprehensive set of Lyapunov and Sylvester operators has been implemented, which allow the estimation of condition numbers of these operators and the iterative solution of various Lyapunov and Sylvester matrix equations using the conjugate gradient method. The implementation of Riccati equation solvers employ orthogonal Schur vectors
based methods and their extensions to linear matrix pencil based reduction approaches. The calls of all functions with adjoint (in complex case) or transposed (in real case) arguments are fully supported by appropriate computational algorithms, thus the matrix copying operations are mostly avoided.

The current version of the package includes the following functions:

**Solution of Lyapunov equations**

| Function | Description |
| :--- | :--- |
| **[`lyapc`](@ref)**  | Solution of the continuous Lyapunov equations |
| **[`lyapd`](@ref)**  | Solution of the discrete Lyapunov equations |
| **[`tlyapc`](@ref)** | Solution of the continuous T-Lyapunov equations |
| **[`hlyapc`](@ref)** | Solution of the continuous H-Lyapunov equations |
| **[`tulyapc!`](@ref)** | Computation of the upper triangular solution of the continuous T-Lyapunov equation |
| **[`hulyapc!`](@ref)** | Computation of the upper triangular solution of the continuous H-Lyapunov equation |
| **[`plyapc`](@ref)** | Solution of the positive continuous Lyapunov equations|
| **[`plyapd`](@ref)** | Solution of the positive discrete Lyapunov equations|

 **Solution of algebraic  Riccati equations**

| Function | Description |
| :--- | :--- |
| **[`arec`](@ref)**  |  Solution of the continuous Riccati equations|
| **[`garec`](@ref)** |  Solution of the generalized continuous Riccati equation|
| **[`ared`](@ref)**  |  Solution of the discrete Riccati equation|
| **[`gared`](@ref)** |  Solution of the generalized discrete Riccati equation|

 **Solution of Sylvester equations and systems**

| Function | Description |
| :--- | :--- |
| **[`sylvc`](@ref)** | Solution of the (continuous) Sylvester equations|
| **[`sylvd`](@ref)** | Solution of the (discrete) Sylvester equations |
| **[`gsylv`](@ref)** | Solution of the generalized Sylvester equations |
| **[`sylvsys`](@ref)** | Solution of the Sylvester system of matrix equations |
| **[`dsylvsys`](@ref)** | Solution of the dual Sylvester system of matrix equations |


**Iterative solution of linear matrix equations**

| Function | Description |
| :--- | :--- |
| **[`lyapci`](@ref)** |Iterative solution of continuous Lyapunov equations|
| **[`plyapci`](@ref)** |Iterative solution of low-rank non-negative continuous Lyapunov equations|
| **[`lyapdi`](@ref)** |Iterative solution of discrete Lyapunov equations|
| **[`plyapdi`](@ref)** |Iterative solution of low-rank non-negative discrete Lyapunov equations|
| **[`tlyapci`](@ref)** |Iterative solution of the continuous T-Lyapunov equations|
| **[`hlyapci`](@ref)** |Iterative solution of the continuous H-Lyapunov equations|
| **[`tulyapci`](@ref)** |Iterative solution of the continuous T-Lyapunov equations with upper triangular solutions|
| **[`hulyapci`](@ref)** |Iterative solution of the continuous H-Lyapunov equations with upper triangular solutions|
| **[`sylvci`](@ref)** |Iterative solution of the (continuous) Sylvester equations|
| **[`sylvdi`](@ref)** |Iterative solution of the (discrete) Sylvester equations |
| **[`gsylvi`](@ref)** |Iterative solution of the generalized Sylvester equations|
| **[`gtsylvi`](@ref)** |Iterative solution of the generalized T-Sylvester equations|
| **[`ghsylvi`](@ref)** |Iterative solution of the generalized H-Sylvester equations|
| **[`cgls`](@ref)** |The conjugate gradient method for nonsymmetric linear equations and least squares problems|


**Norm, condition and separation estimation of linear operators**

| Function | Description |
| :--- | :--- |
| **[`opnorm1`](@ref)** | Computation of the 1-norm of a linear operator|
| **[`opnorm1est`](@ref)** | Estimation of the 1-norm of a linear operator|
| **[`oprcondest`](@ref)** | Estimation of the reciprocal 1-norm condition number of an operator|
| **[`opsepest`](@ref)** | Estimation of the separation of a linear operator|

The general solvers of Lyapunov and Sylvester equations rely on a set of specialized solvers for real or complex matrices in appropriate Schur forms. For testing purposes, a set of solvers for Sylvester equations has been implemented, which employ the Kronecker-product expansion of the equations. These solvers are not recommended for large order matrices. Based on the conjugate gradient method to solve linear systems or least-squares problems, several iterative solvers have been implemented, which are potentially applicable to solve linear matrix equations with large order dense and sparse matrices. The norms, reciprocal condition numbers and separations can be estimated for a comprehensive set of predefined Lyapunov and Sylvester operators. A complete list of implemented functions is available [here](https://sites.google.com/view/andreasvarga/home/software/matrix-equations-in-julia).

## Future plans

The collection of tools can be extended by adding new functionality, such as expert solvers, which additionally compute error bounds and condition estimates, or solvers for new classes of Sylvester-like equations or Riccati equations (as those arising in game-theoretic optimization problems). Further performance improvements are still possible by employing blocking based variants of solvers for Lyapunov and Sylvester equations.

## [Release Notes](https://github.com/andreasvarga/MatrixEquations.jl/blob/master/ReleaseNotes.md)

## Main developer

[Andreas Varga](https://sites.google.com/view/andreasvarga/home)

License: MIT (expat)
